﻿// Generated by Construct 2, the HTML5 game and app creator :: http://www.scirra.com
//////////////////////////////////////
// COCOONJS.JS                      //
//////////////////////////////////////

(function()
{
	// There should not be a CocoonJS object when this code is executed.
	// if (typeof window.CocoonJS !== 'undefined') throw("This is strange, a CocoonJS object already exists when trying to create it.");

    /**
    * The basic object for all the CocoonJS related specific APIs === extensions.
    * @namespace
    */
    CocoonJS = window.CocoonJS ? window.CocoonJS : {};

	CocoonJS.nativeExtensionObjectAvailable = typeof window.ext !== 'undefined';

	/**
	* This type represents a 2D size structure with horizontal and vertical values.
	* @namespace
	*/
	CocoonJS.Size = {
		/**
		* The horizontal size value.
		*/
		width : 0,

		/**
		* The vertical size value.
		*/
		height : 0
	};

	/**
	* This utility function allows to create an object oriented like hierarchy between two functions using their prototypes.
	* This function adds a "superclass" and a "__super" attributes to the subclass and it's functions to reference the super class.
	* @param {function} subc The subclass function.
	* @param {function} superc The superclass function.
	*/
	CocoonJS.extend = function(subc, superc) {
	    var subcp = subc.prototype;

	    // Class pattern.
	    var CocoonJSExtendHierarchyChainClass = function() {};
	    CocoonJSExtendHierarchyChainClass.prototype = superc.prototype;

	    subc.prototype = new CocoonJSExtendHierarchyChainClass();       // chain prototypes.
	    subc.superclass = superc.prototype;
	    subc.prototype.constructor = subc;

	    // Reset constructor. See Object Oriented Javascript for an in-depth explanation of this.
	    if (superc.prototype.constructor === Object.prototype.constructor) {
	        superc.prototype.constructor = superc;
	    }

	    // Check all the elements in the subclass prototype and add them to the chain object's prototype.
	    for (var method in subcp) {
	        if (subcp.hasOwnProperty(method)) {
	            subc.prototype[method] = subcp[method];

	            // // tenemos en super un metodo con igual nombre.
	            // if ( superc.prototype[method]) 
	            // {
	            //     subc.prototype[method]= (function(fn, fnsuper) 
	            //     {
	            //         return function() 
	            //         {
	            //             var prevMethod= this.__super;

	            //             this.__super= fnsuper;

	            //             var retValue= fn.apply(
	            //                     this,
	            //                     Array.prototype.slice.call(arguments) );

	            //             this.__super= prevMethod;

	            //             return retValue;
	            //         };
	            //     })(subc.prototype[method], superc.prototype[method]);
	            // }
	        }
	    }
	}

	/**
	* IMPORTANT: This function should only be used by Ludei.
	* This function allows a call to the native extension object function reusing the same arguments object.
	* Why is interesting to use this function instead of calling the native object's function directly?
	* As the CocoonJS object functions expicitly receive parameters, if they are not present and the native call is direcly mapped,
	* undefined arguments are passed to the native side. Some native functions do not check the parameters validation
	* correctly (just check the number of parameters passed).
	* Another solution instead of using this function call is to correctly check if the parameters are valid (not undefined) to make the
	* call, but it takes more work than using this approach.
	* @static
	* @param {string} nativeExtensionObjectName The name of the native extension object name. The object that is a member of the 'ext' object.
	* @param {string} nativeFunctionName The name of the function to be called inside the native extension object.
	* @param {object} arguments The arguments object of the CocoonJS extension object function. It contains all the arguments passed to the CocoonJS extension object function and these are the ones that will be passed to the native call too.
	* @param {boolean} [async] A flag to indicate if the makeCall (false or undefined) or the makeCallAsync function should be used to perform the native call.
	* @returns Whatever the native function call returns.
	*/
	CocoonJS.makeNativeExtensionObjectFunctionCall = function(nativeExtensionObjectName, nativeFunctionName, args, async) {
		if (CocoonJS.nativeExtensionObjectAvailable) {
			var argumentsArray = Array.prototype.slice.call(args);
			argumentsArray.unshift(nativeFunctionName);
			var nativeExtensionObject = ext[nativeExtensionObjectName];
			var makeCallFunction = async ? nativeExtensionObject.makeCallAsync : nativeExtensionObject.makeCall;
			var ret = makeCallFunction.apply(nativeExtensionObject, argumentsArray);
			var finalRet = ret;
			if (typeof ret === "string") {
				try	{
					finalRet = JSON.parse(ret);
				}
				catch(error) {
				}
			}
			return finalRet;
		}
	};

	/**
	* Returns an object retrieved from a path specified by a dot specified text path starting from a given base object.
	* It could be useful to find the reference of an object from a defined base object. For example the base object could be window and the
	* path could be "CocoonJS.App" or "document.body".
	* @param {Object} baseObject The object to start from to find the object using the given text path.
	* @param {string} objectPath The path in the form of a text using the dot notation. i.e. "document.body"
	* For example:
	* var body = getObjectFromPath(window, "document.body");
	*/
	CocoonJS.getObjectFromPath = function(baseObject, objectPath) {
    	var parts = objectPath.split('.');
    	var obj = baseObject;
        for (var i = 0, len = parts.length; i < len; ++i) 
        {
            obj[parts[i]] = obj[parts[i]] || undefined;
    		obj = obj[parts[i]];
    	}
    	return obj;
 	};

 	/**
 	* Returns the key for a value in a dictionary. It looks for an specific value inside a dictionary and returns the corresponding key.
 	* @param {Object} dictionary The dictionary to look for the value in and get the corresponding key.
 	* @param {Object} value The value to look for inside the dictionary and return it's corresponding key.
 	* @return The key that corresponds to the given value it is has been found or null.
 	*/
 	CocoonJS.getKeyForValueInDictionary = function(dictionary, value) {
        var finalKey = null;
        for (var key in dictionary) {
            if (dictionary[key] === value)            {
                finalKey = key;
                break;
            }
        }
        return finalKey;
 	}

 	/**
 	* Finds a string inside a given array of strings by looking for a given substring. It can also
 	* specify if the search must be performed taking care or not of the case sensitivity.
 	* @param {Array} stringArray The array of strings in which to to look for the string.
 	* @param {string} subString The substring to look for inside all the strings of the array.
 	* @param {boolean} caseSensitive A flag to indicate if the search must be performed taking case of the 
 	* case sensitiveness (true) or not (false).
 	* @return {string} The string that has been found or null if the substring is not inside any of the string of the array.
 	*/
 	CocoonJS.findStringInStringArrayThatIsIndexOf = function(stringArray, subString, caseSensitive) {
 		var foundString = null;
 		subString = caseSensitive ? subString : subString.toUpperCase();
 		for (var i = 0; foundString == null && i < stringArray.length; i++)	{
 			foundString = caseSensitive ? stringArray[i] : stringArray[i].toUpperCase();
 			foundString = foundString.indexOf(subString) >= 0 ? stringArray[i] : null; 
 		}
 		return foundString;
 	};

	/**
	* A class that represents objects to handle events. Event handlers have always the same structure:
	* Mainly they provide the addEventListener and removeEventListener functions.
	* Both functions receive a callback function that will be added or removed. All the added callback
	* functions will be called when the event takes place.
	* Additionally they also allow the addEventListenerOnce and notifyEventListeners functions.
	* @constructor
	* @param {string} nativeExtensionObjectName The name of the native extension object (inside the ext object) to be used.
	* @param {string} cocoonJSExtensionObjectName The name of the sugarized extension object.
	* @param {string} nativeEventName The name of the native event inside the ext object.
	* @param {number} [chainFunction] An optional function used to preprocess the listener callbacks. This function, if provided,
	* will be called before any of the other listeners.
	*/
	CocoonJS.EventHandler = function(nativeExtensionObjectName, cocoonJSExtensionObjectName, nativeEventName, chainFunction) {
		this.listeners = [];
		this.listenersOnce = [];
		this.chainFunction = chainFunction;

		/**
		* Adds a callback function so it can be called when the event takes place.
		* @param {function} listener The callback function to be added to the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
		*/
		this.addEventListener = function(listener) {
			if (chainFunction) {
				var f = function() {
					chainFunction.call(this, arguments.callee.sourceListener, Array.prototype.slice.call(arguments)); 
				};
				listener.CocoonJSEventHandlerChainFunction = f;
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0) {
                	this.listeners.push(listener);
                }
            }
		};

        this.addEventListenerOnce = function(listener)
		{
			if (chainFunction) {
				var f = function() { chainFunction(arguments.callee.sourceListener,Array.prototype.slice.call(arguments)); };
				f.sourceListener = listener;
				listener = f;
			}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].addEventListenerOnce(nativeEventName, listener);
            }
            else
            {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener < 0)
                {
                	this.listenersOnce.push(listener);
                }
            }
		};

        /**
         * Removes a callback function that was added to the event handler so it won't be called when the event takes place.
         * @param {function} listener The callback function to be removed from the event handler object. See the referenced Listener function documentation for more detail in each event handler object's documentation.
         */
        this.removeEventListener = function (listener) {

        	if (chainFunction) {
        		listener = listener.CocoonJSEventHandlerChainFunction;
        		delete listener.CocoonJSEventHandlerChainFunction;
        	}

			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].removeEventListener(nativeEventName, listener);
            }
            else {
                var indexOfListener = this.listeners.indexOf(listener);
                if (indexOfListener >= 0) {
                    this.listeners.splice(indexOfListener, 1);
                }
            }
        };

		this.notifyEventListeners = function() {
			var cocoonJSExtensionObject = CocoonJS.getObjectFromPath(CocoonJS, cocoonJSExtensionObjectName);
            if (cocoonJSExtensionObject && cocoonJSExtensionObject.nativeExtensionObjectAvailable) {
                ext[nativeExtensionObjectName].notifyEventListeners(nativeEventName);
            } else {

                var argumentsArray= Array.prototype.slice.call(arguments);
                var listeners =     Array.prototype.slice.call(this.listeners);
                var listenersOnce = Array.prototype.slice.call(this.listenersOnce);
                var _this = this;
                // Notify listeners after a while ;) === do not block this thread.
                setTimeout(function() {
                    for (var i = 0; i < listeners.length; i++) {
                        listeners[i].apply(_this, argumentsArray);
                    }
                    for (var i = 0; i < listenersOnce.length; i++) {
                        listenersOnce[i].apply(_this, argumentsArray);
                    }
                }, 0);

                _this.listenersOnce= [];
            }
		};
		return this;
	};

	/**
	* A simple timer class. Update it every loop iteration and get values from accumulated time to elapsed time in seconds or milliseconds.
	*/
	CocoonJS.Timer = function() {
		this.reset();
		return this;
	};

	CocoonJS.Timer.prototype = {
		currentTimeInMillis : 0,
		lastTimeInMillis : 0,
		elapsedTimeInMillis : 0,
		elapsedTimeInSeconds : 0,
		accumTimeInMillis : 0,

		/**
		Resets the timer to 0.
		*/
		reset : function() {
			this.currentTimeInMillis = this.lastTimeInMillis = new Date().getTime();
			this.accumTimeInMillis = this.elapsedTimeInMillis = this.elapsedTimeInSeconds = 0;
		},

		/**
		Updates the timer calculating the elapsed time between update calls.
		*/
		update : function() {
			this.currentTimeInMillis = new Date().getTime();
			this.elapsedTimeInMillis = this.currentTimeInMillis - this.lastTimeInMillis;
			this.elapsedTimeInSeconds = this.elapsedTimeInMillis / 1000.0;
			this.lastTimeInMillis = this.currentTimeInMillis;
			this.accumTimeInMillis += this.elapsedTimeInMillis;
		}
	};

	// CocoonJS.FindAllNativeBindingsInCocoonJSExtensionObject = function(cocoonJSExtensionObject, nativeFunctionBindingCallback, nativeEventBindingCallback)
	// {
	// 	for (var cocoonJSExtensionObjectAttributeName in cocoonJSExtensionObject)
	// 	{
	// 		var cocoonJSExtensionObjectAttribute = cocoonJSExtensionObject[cocoonJSExtensionObjectAttributeName];

	// 		// Function
	// 		if (typeof cocoonJSExtensionObjectAttribute === 'function' && typeof cocoonJSExtensionObjectAttribute.nativeFunctionName !== 'undefined')
	// 		{
	// 			var nativeFunctionName = cocoonJSExtensionObjectAttribute.nativeFunctionName;
	// 			nativeFunctionBindingCallback(cocoonJSExtensionObjectAttributeName, nativeFunctionName);
	// 		}
	// 		// Event object
	// 		else if (typeof cocoonJSExtensionObjectAttribute === 'object' && cocoonJSExtensionObjectAttribute !== null && typeof cocoonJSExtensionObjectAttribute.nativeEventName !== 'undefined')
	// 		{
	// 			var nativeEventName = cocoonJSExtensionObjectAttribute.nativeEventName;
	// 			nativeEventBindingCallback(cocoonJSExtensionObjectAttributeName, nativeEventName);
	// 		}
	// 	}
	// }

	/**
	This function looks for a CocoonJS extension object that is bound to the given native ext object name.
	@returns The CocoonJS extension object that corresponds to the give native extension object name or null if it cannot be found.
	*/
	// CocoonJS.GetCocoonJSExtensionObjectForNativeExtensionObjectName = function(nativeExtensionObjectName)
	// {
	// 	var cocoonJSExtensionObject = null;
	// 	// Look in the CocoonJS object and for every object that is a CocoonJS.Extension check if it's nativeExtensionObjectName matches to the one passed as argument. If so, create an object that will represent it's documentation for the native ext object.
	// 	for (var cocoonJSAttributeName in CocoonJS)
	// 	{
	// 		var cocoonJSAttribute = CocoonJS[cocoonJSAttributeName];
	// 		if (typeof cocoonJSAttribute === 'object' && cocoonJSAttribute instanceof CocoonJS.Extension && cocoonJSAttribute.nativeExtensionObjectName === nativeExtensionObjectName)
	// 		{
	// 			// We have found the CocoonJS object that represents the native ext extension object name. 
	// 			cocoonJSExtensionObject = cocoonJSAttribute;
	// 			break;
	// 		}
	// 	}
	// 	return cocoonJSExtensionObject;
	// };

	/**
	This function adds functions to a CocoonJS extension object in order to bind them to the native makeCall function calls of the ext object.

	@param extensionObject The reference to the CocoonJS extension object where to add the new functions bound to the ext object makeCall functions calls.

	@param nativeFunctionsConfiguration An array of objects with the following structure:

		{ nativeFunctionName : "" [, functionName : "", isAsync : true/false] }

		- nativeFunctionName: Specifies the name of the function inside the ext object makeCall function call that will be bound.
		- functionName: An optional attribute that allows to specify the name of the function to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeFunctionName.
		- isAsync: An optional attribute that allows to specify if the call should be performed using makeCall (false or missing) or makeCallAsync (true).
		- alternativeFunction: An optional attribute that allows to specify an alternative function that will be called internally when this function is called. This attribute
		allows for adding new functionalities like for example adding methods 

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeFunctionBindingsToExtensionObject = function(extensionObject, nativeFunctionsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeFunctionsConfiguration === 'undefined' || nativeFunctionsConfiguration === null) throw("The passed native functions configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeFunctionsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeFunctionsConfiguration[i].nativeFunctionName === 'undefined') throw("The 'nativeFunctionName' attribute in the native function configuration object at index '" + i + "' in the native function configuration array cannot be undefined.");
	// 		var nativeFunctionName = nativeFunctionsConfiguration[i].nativeFunctionName;
	// 		var functionName = typeof nativeFunctionsConfiguration[i].functionName !== 'undefined' ? nativeFunctionsConfiguration[i].functionName : nativeFunctionName;
	// 		var makeCallFunction = null;
	// 		makeCallFunction = typeof nativeFunctionsConfiguration[i].isAsync !== 'undefined' && nativeFunctionsConfiguration[i].isAsync ? extensionObject.nativeExtensionObject.makeCallAsync : extensionObject.nativeExtensionObject.makeCall;
	// 		// Add the new function to the CocoonJS extension object
	// 		extensionObject[functionName] = function()
	// 		{
	// 			// Convert the arguments object to an array
	// 			var arguments = Array.prototype.slice.call(arguments);
	// 			// Add the native function name as the first parameter
	// 			arguments.unshift(nativeFunctionName);
	// 			// Make the native ext object call
	// 			var result = makeCallFunction.apply(extensionObject.nativeExtensionObject, arguments);
	// 			return result;
	// 		}
	// 		// Add a property to the newly added function to store the name of the original function.
	// 		extensionObject[functionName].nativeFunctionName = nativeFunctionName;
	// 	}
	// 	return extensionObject;
	// };

	/**
	This function adds objects to a CocoonJS extension object to allow event listener handling (add and remove) bound to the native ext object event listener handling.

	@param extensionObject The reference to the CocoonJS extension object where to add the new objects bound to the ext object event listener handling.

	@param nativeEventsConfiguration An array of objects with the following structure:

		{ nativeEventName : "" [, eventObjectName : ""] }

		- nativeEventName: Specifies the event in the native ext object to be bound.
		- eventObjectName: An optional attribute that allows to specify the name of the object to be added to the CocoonJS extension object. If is not present, the name of the function will be the same
		as the nativeEventName.
		- alternativeAddEventListenerFunction:
		- alternativeRemoveEventListenerFunction:

	@returns The CocoonJS extension object.
	*/
	// CocoonJS.AddNativeEventBindingsToExtensionObject = function(extensionObject, nativeEventsConfiguration)
	// {
	// 	if (typeof extensionObject === 'undefined' || extensionObject === null) throw("The passed extension object be a valid object.");
	// 	if (typeof nativeEventsConfiguration === 'undefined' || nativeEventsConfiguration === null) throw("The passed native events configuration array must be a valid object.");

	// 	for (var i = 0; i < nativeEventsConfiguration.length; i++)
	// 	{
	// 		if (typeof nativeEventsConfiguration[i].nativeEventName === 'undefined') throw("The 'nativeEventName' attribute in the native event configuration object at index '" + i + "' in the native event configuration array cannot be undefined.");
	// 		var nativeEventName = nativeEventsConfiguration[i].nativeEventName;
	// 		var eventObjectName = typeof nativeEventsConfiguration[i].eventObjectName !== 'undefined' ? nativeEventsConfiguration[i].eventObjectName : nativeEventName;
	// 		// Anonymous function call so each variable in the loop is used in the event listener handling function bindings.
	// 		(function(nativeEventName, eventObjectName)
	// 		{
	//     		extensionObject[eventObjectName] =
	//     		{
	//     			// Store the native event name
	//     			nativeEventName : nativeEventName,
	//     			// Create the event listener management functions bound to the native counterparts
	//     			addEventListener : function(callback)
	// 	    		{
	// 	    			extensionObject.nativeExtensionObject.addEventListener(nativeEventName, callback);
	//     			},
	//     			removeEventListener : function(callback)
	//     			{
	// 	    			extensionObject.nativeExtensionObject.removeEventListener(nativeEventName, callback);
	//     			}
	//     			// ,
	//     			// removeAllEventListeners : function()
	//     			// {

	//     			// }
	//     		};
	// 		})(nativeEventName, eventObjectName);
	// 	}
	// 	return extensionObject;
	// };

	/**
	The function object constructor function all the CocoonJS extensions can use to instantiate the CocoonJS extension object and add all the functionality needed bound to the native ext object.

	@param nativeExtensionObject The reference to the ext object extension object.

	@param nativeFunctionsConfiguration See CocoonJS.AddNativeFunctionBindingsToExtensionObject function's documentation for more details.

	@param nativeEventsConfiguration See CocoonJS.AddNativeEventBindingsToExtensionObject function's documentation for more details.

	@returns The new CocoonJS extension object.
	*/
	// CocoonJS.Extension = function(nativeExtensionObjectName, nativeFunctionsConfiguration, nativeEventsConfiguration)
	// {
	// 	if (typeof nativeExtensionObjectName === 'undefined' || nativeExtensionObjectName === null) throw("The native extension object name cannot be null");

	// 	if (window.ext[nativeExtensionObjectName] === 'undefined') throw("The given native extension object name '" + nativeExtensionObjectName + "' is incorrect or the native extension object is undefined.");

	// 	var nativeExtensionObject = window.ext[nativeExtensionObjectName];

	// 	// Store a reference to the native extension object and to it's name
	// 	this.nativeExtensionObject = nativeExtensionObject;
	// 	this.nativeExtensionObjectName = nativeExtensionObjectName;

	// 	// If native function configuration is passed, use it to add some functions to the new extension object.
	// 	if (typeof nativeFunctionsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeFunctionBindingsToExtensionObject(this, nativeFunctionsConfiguration);
	// 	}

	// 	// If native event configuration is passed, use it to add some event objects to the new extension object.
	// 	if (typeof nativeEventsConfiguration !== 'undefined')
	// 	{
	// 		CocoonJS.AddNativeEventBindingsToExtensionObject(this, nativeEventsConfiguration);
	// 	}

	// 	return this;
	// };   

})();

//////////////////////////////////////
// COCOONJS_APP.JS                  //
//////////////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents all the basic functionalities available in the CocoonJS extension API.
     * @namespace
     */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    CocoonJS.App.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_APP !== 'undefined';

    /**
     * The predefined possible layouts for the FPS overlay.
     * @namespace
     */
    CocoonJS.App.FPSLayout = {
        TOP_LEFT:'top-left',
        TOP_RIGHT:'top-right',
        BOTTOM_LEFT:'bottom-left',
        BOTTOM_RIGHT:'bottom-right'
    };

    /**
     * Contains all the possible values to specify the input keyboard type to be used when introducing text.
     * @namespace
     */
    CocoonJS.App.KeyboardType = {
        /**
         * Represents a generic text input keyboard.
         */
        TEXT:"text",

        /**
         * Represents a number like input keyboard.
         */
        NUMBER:"num",

        /**
         * Represents a phone like input keyboard.
         */
        PHONE:"phone",

        /**
         * Represents an email like input keyboard.
         */
        EMAIL:"email",

        /**
         * Represents an URL like input keyboard.
         */
        URL:"url"
    };

    /**
     * The storage types to be used with file system related operations.
     * @namespace
     */
    CocoonJS.App.StorageType = {
        /**
         * Represents the application storage. The application storage is the place where all the resources that come with the application are stored.
         */
        APP_STORAGE:"APP_STORAGE",

        /**
         * Represents the internal storage. The internal storage is a different storage space that the application storage and only the data that the application has stored
         * in it will be in this storage. It is internal to the platform/device.
         */
        INTERNAL_STORAGE:"INTERNAL_STORAGE",

        /**
         * Represents an external storage. The external storage is similar to the internal storage in the sense that it only contains information that the application has written
         * in it but it represents an external storage device like a SD-CARD. If there is no exrernal storage, it will represent the same as the internal storage.
         */
        EXTERNAL_STORAGE:"EXTERNAL_STORAGE",

        /**
         * Represents the temporal storage. Same as the internal and external storage spaces in the sense that it only contains information that the application has written
         * in it but the main difference is that the information in this storage may dissapear without notice.
         */
        TEMPORARY_STORAGE:"TEMPORARY_STORAGE"
    };

    /**
     * The capture types to capture screenshots using CocoonJS native capabilities.
     * @namespace
     */
    CocoonJS.App.CaptureType = {
        /**
         Captures everything, both the CocoonJS GL hardware accelerated surface and the system views (like the WebView).
         */
        EVERYTHING:0,

        /**
         * Captures just the CocoonJS GL hardware accelerated surface.
         */
        JUST_COCOONJS_GL_SURFACE:1,

        /**
         * Captures just the sustem views (like the webview)
         */
        JUST_SYSTEM_VIEWS:2
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It waits until the code is executed and the result of it is returned === synchronous.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @return {string} The result of the execution of the passed JavaScript code in the different JavaScript environment.
     */
    CocoonJS.App.forward = function (javaScriptCode) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forward", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                //return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                return window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Makes a forward call of some javascript code to be executed in a different environment (i.e. from CocoonJS to the WebView and viceversa).
     * It is asyncrhonous so it does not wait until the code is executed and the result of it is returned. Instead, it calls a callback function when the execution has finished to pass the result.
     * @function
     * @param {string} javaScriptCode Some JavaScript code in a string to be forwarded and executed in a different JavaScript environment (i.e. from CocoonJS to the WebView and viceversa).
     * @param {function} [returnCallback] A function callback that will be called when the passed JavaScript code is executed in a different thread to pass the result of the execution in the different JavaScript environment.
     */
    CocoonJS.App.forwardAsync = function (javaScriptCode, returnCallback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            if (typeof returnCallback !== 'undefined') {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode, returnCallback);
            }
            else {
                return ext.IDTK_APP.makeCallAsync("forward", javaScriptCode);
            }
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.eval(javaScriptCode);
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
                // window.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.eval(javaScriptCode);
            }
        }
    };

    /**
     * Pops up a text dialog so the user can introduce some text and the application can get it back. It is the first approach CocoonJS has taken to be able to introduce
     * text input in a easy way. The dialog execution events are passed to the application through the {@link CocoonJS.App.onTextDialogFinished} and the {@link CocoonJS.App.onTextDialogCancelled} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [text] Default value is "". The initial text to be introduced in the text input field.
     * @param {CocoonJS.App.KeyboardType} [keyboardType] Default value is {@link CocoonJS.App.KeyboardType.TEXT}. The keyboard type to be used when the text has to be introduced.
     * @param {string} [cancelButtonText] Default value is "". The text to be displayed in the cancel button of the dialog.
     * @param {string} [okButtonText] Default value is "". The text to be displayed in the ok button of the dialog.
     * @see CocoonJS.App.onTextDialogFinished
     * @see CocoonJS.App.onTextDialogCancelled
     */
    CocoonJS.App.showTextDialog = function (title, message, text, keyboardType, cancelButtonText, okButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showTextDialog", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            if (!text) {
                text = "";
            }
            var result = prompt(message, text);
            var eventObject = result ? CocoonJS.App.onTextDialogFinished : CocoonJS.App.onTextDialogCancelled;
            eventObject.notifyEventListeners(result);
        }
    };

    /**
     * Pops up a message dialog so the user can decide between a yes or no like confirmation. The message box execution events are passed to the application through the {@link CocoonJS.App.onMessageBoxConfirmed} and the {@link CocoonJS.App.onMessageBoxDenied} event objects.
     * @function
     * @param {string} [title] Default value is "". The title to be displayed in the dialog.
     * @param {string} [message] Default value is "". The message to be displayed in the dialog, next to the text input field.
     * @param {string} [confirmButtonText] Default value is "Yes". The text to be displayed for the confirm button.
     * @param {string} [denyButtonText] Default value is "No". The text to be displayed for the deny button.
     * @see CocoonJS.App.onMessageBoxConfirmed
     * @see CocoonJS.App.onMessageBoxDenied
     */
    CocoonJS.App.showMessageBox = function (title, message, confirmButtonText, denyButtonText) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "showMessageBox", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            if (!message) {
                message = "";
            }
            var result = confirm(message);
            var eventObject = result ? CocoonJS.App.onMessageBoxConfirmed : CocoonJS.App.onMessageBoxDenied;
            eventObject.notifyEventListeners();
        }
    };

    /**
     * It allows to load a new JavaScript/HTML5 resource that can be loaded either locally (inside the platform/device storage) or using a remote URL.
     * @function
     * @param {string} path A path to a resource stored in the platform or in a URL to a remote resource.
     * @param {CocoonJS.App.StorageType} [storageType] If the path argument represents a locally stored resource, the developer can specify the storage where it is stored. If no value is passes, the {@link CocoonJS.App.StorageType.APP_STORAGE} value is used by default.
     */
    CocoonJS.App.load = function (path, storageType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "loadPath", arguments);
        }
        else if (!navigator.isCocoonJS) {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function (event) {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        // TODO: As window load event is not being called (WHY???), I have decided to call the listeners directly
                        // var callback= function(event){
                        //     window.removeEventListener("load", callback);
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "window.CocoonJS && window.CocoonJS.App.onLoadInCocoonJSSucceed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                        // };
                        // window.addEventListener("load", callback);
                        window.location.href = path;
                    }
                    else if (xhr.status === 404) {
                        this.onreadystatechange = null;
                        var jsCode;
                        // If there is no webview, it means we are in the webview, so notify the CocoonJS environment
                        if (!CocoonJS.App.EmulatedWebViewIFrame) {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners('" + path + "');";
                        }
                        // If there is a webview, it means we are in CocoonJS, so notify the webview environment
                        else {
                            jsCode = "CocoonJS && CocoonJS.App.onLoadInCocoonJSFailed.notifyEventListeners('" + path + "');";
                        }
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the current context.
     * @function
     */
    CocoonJS.App.reload = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "reload", arguments);
        }
        else if (!navigator.isCocoonJS) {
            if (window.name == 'CocoonJS_App_ForCocoonJS_WebViewIFrame') {
                return window.parent.location.reload();
            }
            else {
                return window.parent.frames['CocoonJS_App_ForCocoonJS_WebViewIFrame'].window.location.reload();
            }
        }
    };

    /**
     * Opens a given URL using a system service that is able to open it. For example, open a HTTP URL using the system WebBrowser.+
     * @function
     * @param {string} url The URL to be opened by a system service.
     */
    CocoonJS.App.openURL = function (url) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "openURL", arguments, true);
        }
        else if (!navigator.isCocoonJS) {
            window.open(url, '_blank');
        }
    }

    /**
     * Forces the app to be finished.
     * @function
     */
    CocoonJS.App.forceToFinish = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "forceToFinish", arguments);
        }
        else if (!navigator.isCocoonJS) {
            window.close();
        }
    }

    /**
     * Enables or disables the auto lock to control if the screen keeps on after an inactivity period.
     * When the auto lock is enabled and the application has no user input for a short period, the system puts the device into a "sleepâ€ state where the screen dims or turns off.
     * When the auto lock is disabled the screen keeps on even when there is no user input for long times.
     * @param enabled A boolean value that controls whether to enable or disable the auto lock.
     */
    CocoonJS.App.setAutoLockEnabled = function (enabled) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setAutoLockEnabled", arguments);
        }
    }

    /**
     * Creates a canvas element that is automatically resized to the screen size. When the app is being executed
     * inside CocoonJS. This canvas is optimized for rendering so it is higly recommended to use it if it fits
     * your app needs. If your app uses one canvas as the main canvas where all other canvases and images are displayed, Ludei recommends to
     * call this function in order to create this main canvas. A usual 2x performance gain is achieved by doing so
     * depending on the device and the graphics card driver.
     * @function
     * @return {object} The canvas object that should be used as the main canvas and that is resized to the screen resolution.
     */
    CocoonJS.App.createScreenCanvas = function () {
        var screenCanvas;
        if (navigator.isCocoonJS) {
            screenCanvas = document.createElement("screencanvas");
        }
        else if (!navigator.isCocoonJS) {
            screenCanvas = document.createElement("canvas");
            screenCanvas.width = window.innerWidth;
            screenCanvas.height = window.innerHeight;
        }
        return screenCanvas;
    };

    /**
     * Disables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.disableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Enables the touch events in the CocoonJS environment.
     * @function
     */
    CocoonJS.App.enableTouchInCocoonJS = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "CocoonJSView");
        }
    };

    /**
     * Disables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.disableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("disableTouchLayer", "WebView");
        }
    };

    /**
     * Enables the touch events in the WebView environment.
     * @function
     */
    CocoonJS.App.enableTouchInTheWebView = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("enableTouchLayer", "WebView");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the accelerometer updates.
     * It defines the rate at which the devicemotion events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setAccelerometerUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setAccelerometerUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for accelerometer related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for accelerometer related events.
     */
    CocoonJS.App.getAccelerometerUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getAccelerometerUpdateIntervalInSeconds");
        }
    };

    /**
     * Setups the update interval in seconds (1 second / X frames) to receive the gyroscope updates.
     * It defines the rate at which the devicemotion and deviceorientation events are updated.
     * @function
     * @param {number} updateIntervalInSeconds The update interval in seconds to be set.
     */
    CocoonJS.App.setGyroscopeUpdateIntervalInSeconds = function (updateIntervalInSeconds) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("setGyroscopeUpdateIntervalInSeconds", updateIntervalInSeconds);
        }
    };

    /**
     * Returns the update interval in seconds that is currently set for gyroscope related events.
     * @function
     * @return {number} The update interval in seconds that is currently set for gyroscope related events.
     */
    CocoonJS.App.getGyroscopeUpdateIntervalInSeconds = function () {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCall("getGyroscopeUpdateIntervalInSeconds");
        }
    };


    /**
     * Setups a origin proxy for a given typeName. What this means is that after calling this function the environment that makes this call will suddenly
     * have a way of creating instances of the given typeName and those instances will act as a transparent proxy to counterpart instances in the destination environment.
     * Manipulating attributes, calling funcitions or handling events will all be performed in the destination environment but the developer will think they will be
     * happening in the origin environment.
     * IMPORTANT NOTE: These proxies only work with types that use attributes and function parameters and return types that are primitive like numbers, strings or arrays.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} [attributeNames] A list of the names of the attributes to be proxified.
     * @param {array} [functionNames] A list of the names of the functions to be proxified.
     * @param {array} [eventHandlerNames] A list of the names of the event handlers to be proxified (onXXXX like attributes that represent callbacks).
     * A valid typeName and at least one valid array for attribute, function or event handler names is mandatory.
     */
    CocoonJS.App.setupOriginProxyType = function (typeName, attributeNames, functionNames, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            // Control the parameters.
            if (!typeName) throw "The given typeName must be valid.";
            if (!attributeNames && !functionNames && !eventHandlerNames) throw "There is no point on setting up a proxy for no attributes, functions nor eventHandlers.";
            attributeNames = attributeNames ? attributeNames : [];
            functionNames = functionNames ? functionNames : [];
            eventHandlerNames = eventHandlerNames ? eventHandlerNames : [];

            // The parent object will be the window. It could be another object but careful, the destination side should know about this.
            // TODO: Specify the parentObject as a parameter, obtain it's path from the window object and pass it to the destination environment so it knows about it.
            var parentObject = window;

            // Setup the destination side too.
            var jsCode = "CocoonJS.App.setupDestinationProxyType(" + JSON.stringify(typeName) + ", " + JSON.stringify(eventHandlerNames) + ");";
            CocoonJS.App.forward(jsCode);

            var originalType = parentObject[typeName];

            // Constructor. This will be the new proxified type in the origin environment. Instances of this type will be created by the developer without knowing that they are
            // internally calling to their counterparts in the destination environment.
            parentObject[typeName] = function () {
                var _this = this;

                // Each proxy object will have a origin object inside with all the necessary information to be a proxy to the destination.
                this._cocoonjs_proxy_object_data = {};
                // The id is obtained calling to the destination side to create an instance of the type.
                var jsCode = "CocoonJS.App.newDestinationProxyObject(" + JSON.stringify(typeName) + ");";
                this._cocoonjs_proxy_object_data.id = CocoonJS.App.forward(jsCode);
                // The eventHandlers dictionary contains objects of the type { eventHandlerName : string, eventHandler : function } to be able to make the callbacks when the 
                // webview makes the corresponding calls.
                this._cocoonjs_proxy_object_data.eventHandlers = {};
                // Also store the typename inside each instance.
                this._cocoonjs_proxy_object_data.typeName = typeName;
                // A dictionary to store the event handlers
                this._cocoonjs_proxy_object_data.eventListeners = {};

                // TODO: eventHandlers and eventListeners should be in the same list ;)

                // Store all the proxy instances in a list that belongs to the type itself.
                parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[this._cocoonjs_proxy_object_data.id] = this;

                // Create a setter and a getter for all the attribute names that have been specified. When the attributes are accessed (set or get) a call to the destination counterpart will be performed.
                for (var i = 0; i < attributeNames.length; i++) {
                    (function (attributeName) {
                        _this.__defineSetter__(attributeName, function (value) {
                            var jsCode = "CocoonJS.App.setDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ", " + JSON.stringify(value) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                        _this.__defineGetter__(attributeName, function () {
                            var jsCode = "CocoonJS.App.getDestinationProxyObjectAttribute(" + JSON.stringify(typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(attributeName) + ");";
                            return CocoonJS.App.forwardAsync(jsCode);
                        });
                    })(attributeNames[i]);
                }

                // Create a function that performs a call to the destination environment counterpart for all the function names that have been specified.
                for (var i = 0; i < functionNames.length; i++) {
                    (function (functionName) {
                        _this[functionName] = function () {
                            // Get the arguments as an array and add the typeName, the proxy id and the functionName before all the other arguments before making the call to the destination counterpart.
                            var argumentsArray = Array.prototype.slice.call(arguments);
                            argumentsArray.unshift(functionName);
                            argumentsArray.unshift(this._cocoonjs_proxy_object_data.id);
                            argumentsArray.unshift(typeName);
                            // Use the array to create the correct function call.
                            var jsCode = "CocoonJS.App.callDestinationProxyObjectFunction(";
                            for (var i = 0; i < argumentsArray.length; i++) {
                                // The second argument (the id) should not be stringified
                                jsCode += (i !== 1 ? JSON.stringify(argumentsArray[i]) : argumentsArray[i]) + (i < argumentsArray.length - 1 ? ", " : "");
                            }
                            jsCode += ");";
                            // TODO: This next call should be synchronous but it seems that some customers are experiencing some crash issues. Making it async solves these crashes.
                            // Another possible solution could be to be able to specify which calls could be async and which sync in the proxification array.
                            var ret = CocoonJS.App.forwardAsync(jsCode);
                            return ret;
                        };
                    })(functionNames[i]);
                }

                // Create a setter and getter for all the event handler names that have been specified. When the event handlers are accessed, store them inside the corresponding position on the eventHandlers
                // array so they can be called when the destination environment makes the corresponding callback call.
                for (var i = 0; i < eventHandlerNames.length; i++) {
                    (function (eventHandlerName) {
                        _this.__defineSetter__(eventHandlerName, function (value) {
                            _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName] = value;
                        });
                        _this.__defineGetter__(eventHandlerName, function () {
                            return _this._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                        });
                    })(eventHandlerNames[i]);
                }

                // Setup the add and remove event listeners in the proxy object
                _this.addEventListener = function (eventTypeName, eventCallback) {
                    var addEventCallback = true;
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        // As the eventListeners were already added, check that the same callback has not been added.
                        addEventCallback = eventListeners.indexOf(eventCallback) < 0;
                    }
                    else {
                        // There are no event listeners, so add the one and add the listeners array for the specific event type name
                        eventListeners = [];
                        _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = eventListeners;

                        // Forward the call so the other end registers a event listener (only one is needed).
                        var jsCode = "CocoonJS.App.addDestinationProxyObjectEventListener(" + JSON.stringify(_this._cocoonjs_proxy_object_data.typeName) + ", " + _this._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    }
                    // Only if the alforithm above specify so, add the eventcallback and notify the destination environment to do the same
                    if (addEventCallback) {
                        eventListeners.push(eventCallback);
                    }
                };

                _this.removeEventListener = function (eventTypeName, eventCallback) {
                    // Check for the eventListeners
                    var eventListeners = _this._cocoonjs_proxy_object_data.eventListeners[eventTypeName];
                    if (eventListeners) {
                        var eventCallbackIndex = eventListeners.indexOf(eventCallback);
                        if (eventCallbackIndex >= 0) {
                            eventListeners.splice(eventCallbackIndex, 1);
                        }
                    }
                };

                // Return the proxy instance.
                return this;
            };

            // The type will contain a proxy data structure to store all the instances that are created so they are available when the destination environment calls back. 
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                originalType:originalType,
                proxyObjects:[]
            };

            /**
             * Deletes a proxy instance from both the CocoonJS environment structures and also deleting it's webview environment counterpart.
             * This function should be manually called whenever a proxy instance won't be accessed anymore.
             * @param {object} object The proxy object to be deleted.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.deleteProxyObject = function (object) {
                var proxyObjectKey = CocoonJS.getKeyForValueInDictionary(this.proxyObjects, object);
                if (proxyObjectKey) {
                    var jsCode = "CocoonJS.App.deleteDestinationProxyObject(" + JSON.stringify(typeName) + ", " + object._cocoonjs_proxy_object_data.id + ");";
                    CocoonJS.App.forwardAsync(jsCode);
                    object._cocoonjs_proxy_object_data = null;
                    delete this.proxyObjects[proxyObjectKey];
                }
            };

            /**
             * Calls a event handler for the given proxy object id and eventHandlerName.
             * @param {number} id The id to be used to look for the proxy object for which to make the call to it's event handler.
             * @param {string} eventHandlerName The name of the handler to be called.
             * NOTE: Events are a complex thing in the HTML specification. This function just performs a call but at least provides a
             * structure to the event passing the target (the proxy object).
             * TODO: The destination should serialize the event object as far as it can so many parameters can be passed to the origin
             * side. Using JSON.stringify in the destination side and parse in origin side maybe? Still must add the target to the event structure though.
             */
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler = function (id, eventHandlerName) {
                var object = this.proxyObjects[id];
                var eventHandler = object._cocoonjs_proxy_object_data.eventHandlers[eventHandlerName];
                if (eventHandler) {
                    eventHandler({ target:object });
                }
            };

            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners = function (id, eventTypeName) {
                var object = this.proxyObjects[id];
                var eventListeners = object._cocoonjs_proxy_object_data.eventListeners[eventTypeName].slice();
                for (var i = 0; i < eventListeners.length; i++) {
                    eventListeners[i]({ target:object });
                }
            };
        }
    };

    /**
     * Takes down the proxification of a type and restores it to it's original type. Do not worry if you pass a type name that is not proxified yet. The
     * function will handle it correctly for compativility reasons.
     * @param {string} typeName The name of the type to be deproxified (take down the proxification and restore the type to it's original state)
     */
    CocoonJS.App.takedownOriginProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parentObject[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                parentObject[typeName] = parentObject[typeName]._cocoonjs_proxy_type_data.originalType;
            }
        }
    };

    /**
     * Deletes everything related to a proxy object in both environments. Do not worry of you do not pass a proxified object to the
     * function. For compatibility reasons, you can still have calls to this function even when no poxification of a type has been done.
     * @param {object} object The proxified object to be deleted.
     */
    CocoonJS.App.deleteOriginProxyObject = function (object) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (object && object._cocoonjs_proxy_object_data) {
                parentObject[object._cocoonjs_proxy_object_data.typeName]._cocoonjs_proxy_type_data.deleteProxyObject(object);
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when an event handler need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventHandlerName The name of the event handler to be called.
     */
    CocoonJS.App.callOriginProxyObjectEventHandler = function (typeName, id, eventHandlerName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventHandler(id, eventHandlerName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the destination environment whenever it is needed to work with proxy objects.
     * It calls the origin proxy object when all the event listeners related to a specific event need to be updated/called from the destination environment.
     * @param {string} typeName The type name of the proxified type.
     * @param {number} id The id of the proxy object.
     * @param {string} eventTypeName The name of the event type to call the listeners related to it.
     */
    CocoonJS.App.callOriginProxyObjectEventListeners = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            parentObject[typeName]._cocoonjs_proxy_type_data.callProxyObjectEventListeners(id, eventTypeName);
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Setups all the structures that are needed to proxify a destination type to an origin type.
     * @param {string} typeName The name of the type to be proxified.
     * @param {array} eventHandlerNames An array with al the event handlers to be proxified. Needed in order to be able to create callbacks for all the event handlers
     * and call to the CocoonJS counterparts accordingly.
     */
    CocoonJS.App.setupDestinationProxyType = function (typeName, eventHandlerNames) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            // Add a cocoonjs structure to the destination proxified type to store some useful information like all the proxy instances that are created, plus the id counter 
            // and the names of all the event handlers and some utility functions.
            parentObject[typeName]._cocoonjs_proxy_type_data =
            {
                nextId:0,
                proxyObjects:{},
                eventHandlerNames:eventHandlerNames
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environment whenever it is needed to work with proxy objects.
     * Takes down the proxy type at the destination environment. Just removes the data structure related to proxies that was added to the type when proxification tool place.
     * @param {string} typeName The name of the type to take the proxification down.
     */
    CocoonJS.App.takedownDestinationProxyType = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            if (parent[typeName] && parentObject[typeName]._cocoonjs_proxy_type_data) {
                delete parentObject[typeName]._cocoonjs_proxy_type_data;
            }
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Creates a new destination object instance and generates a id to reference it from the original environment.
     * @param {string} typeName The name of the type to be proxified and to generate an instance.
     * @return The id to be used from the original environment to identify the corresponding destination object instance.
     */
    CocoonJS.App.newDestinationProxyObject = function (typeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;

            var proxyObject = new parentObject[typeName]();
            // Also store some additional information in the proxy object
            proxyObject._cocoonjs_proxy_object_data = {};
            // Like the type name, that could be useful late ;)
            proxyObject._cocoonjs_proxy_object_data.typeName = typeName;
            // Caculate the id for the object. It will be returned to the origin environment so this object can be referenced later
            var proxyObjectId = parentObject[typeName]._cocoonjs_proxy_type_data.nextId;
            // Store the created object in the structure defined in the setup of proxification with an id associated to it
            parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[proxyObjectId] = proxyObject;
            // Also store the id inside the proxy object itself
            proxyObject._cocoonjs_proxy_object_data.id = proxyObjectId;
            // Calculate a new id for the next object.
            parentObject[typeName]._cocoonjs_proxy_type_data.nextId++;

            // Setup all the event handlers.
            for (var i = 0; i < parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames.length; i++) {
                (function (eventHandlerName) {
                    proxyObject[eventHandlerName] = function (event) {
                        var proxyObject = this; // event.target;
                        // var eventHandlerName = CocoonJS.getKeyForValueInDictionary(proxyObject, this); // Avoid closures ;)
                        var jsCode = "CocoonJS.App.callOriginProxyObjectEventHandler(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventHandlerName) + ");";
                        CocoonJS.App.forwardAsync(jsCode);
                    };
                })(parentObject[typeName]._cocoonjs_proxy_type_data.eventHandlerNames[i]);
            }

            // Add the dictionary where the event listeners (callbacks) will be added.
            proxyObject._cocoonjs_proxy_object_data.eventListeners = {};

            return proxyObjectId;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the origin environement whenever it is needed to work with proxy objects.
     * Calls a function of a destination object idetified by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} functionName The name of the function to be called.
     * @return Whatever the function call returns.
     */
    CocoonJS.App.callDestinationProxyObjectFunction = function (typeName, id, functionName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var argumentsArray = Array.prototype.slice.call(arguments);
            argumentsArray.splice(0, 3);
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            var result = proxyObject[functionName].apply(proxyObject, argumentsArray);
            return result;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Sets a value to the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be set.
     * @param {unknown} attributeValue The value to be set to the attribute.
     */
    CocoonJS.App.setDestinationProxyObjectAttribute = function (typeName, id, attributeName, attributeValue) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            proxyObject[attributeName] = attributeValue;
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Retrieves the value of the corresponding attributeName of a proxy object represented by it's typeName and id.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     * @param {string} attributeName The name of the attribute to be retrieved.
     */
    CocoonJS.App.getDestinationProxyObjectAttribute = function (typeName, id, attributeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
            return proxyObject[attributeName];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     * Deletes a proxy object identifying it using it's typeName and id. Deleting a proxy object mainly means to remove the instance from the global structure
     * that hold all the instances.
     * @param {string} typeName The name of the type of the proxy.
     * @param {number} id The id of the proxy object.
     */
    CocoonJS.App.deleteDestinationProxyObject = function (typeName, id) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            delete parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];
        }
    };

    /**
     * NOTE: This function should never be directly called. It will be called from the original environment whenever it is needed to work with proxy objects.
     */
    CocoonJS.App.addDestinationProxyObjectEventListener = function (typeName, id, eventTypeName) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            var parentObject = window;
            // Look for the proxy object
            var proxyObject = parentObject[typeName]._cocoonjs_proxy_type_data.proxyObjects[id];

            var callback = function (event) {
                var proxyObject = this; // event.target;
                // var eventTypeName = CocoonJS.getKeyForValueInDictionary(proxyObject._cocoonjs_proxy_object_data.eventListeners, this); // Avoid closures ;)
                // TODO: Is there a way to retrieve the callbackId without a closure?
                var jsCode = "CocoonJS.App.callOriginProxyObjectEventListeners(" + JSON.stringify(proxyObject._cocoonjs_proxy_object_data.typeName) + ", " + proxyObject._cocoonjs_proxy_object_data.id + ", " + JSON.stringify(eventTypeName) + ");";
                CocoonJS.App.forwardAsync(jsCode);
            };

            proxyObject._cocoonjs_proxy_object_data.eventListeners[eventTypeName] = callback;

            // Finally add the event listener callback to the proxy object
            proxyObject.addEventListener(eventTypeName, callback);
        }
    };

    // TODO: We could add a removeDestinationProxyObjectEventListener although it seems that is not completely necessary.

    /**
     * Proxifies the XMLHttpRequest type for the environment where this call is made. After calling this function, all the new objects
     * of XMLHttpRequest that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyXHR = function () {
        var ATTRIBUTE_NAMES =
            [
                "timeout",
                "withCredentials",
                "upload",
                "status",
                "statusText",
                "responseType",
                "response",
                "responseText",
                "responseXML",
                "readyState"
            ];
        var FUNCTION_NAMES =
            [
                "open",
                "setRequestHeader",
                "send",
                "abort",
                "getResponseHeader",
                "getAllResponseHeaders",
                "overrideMimeType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onloadstart",
                "onprogress",
                "onabort",
                "onerror",
                "onload",
                "ontimeout",
                "onloadend",
                "onreadystatechange"
            ];
        CocoonJS.App.setupOriginProxyType("XMLHttpRequest", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Proxifies the Audio type for the environment where this call is made. After calling this function, all the new objects
     * of Audio that are instantiated, will be proxified objects that will make calls to the counterparts in the other environment (CocoonJS <-> WebView viceversa).
     * IMPORTANT NOTE: Remember to take down the proxification once you are done or to delete proxy objects whenever they are not needed anymore or memory leaks may occur.
     */
    CocoonJS.App.proxifyAudio = function () {
        var ATTRIBUTE_NAMES =
            [
                "src",
                "loop",
                "volume",
                "preload"
            ];
        var FUNCTION_NAMES =
            [
                "play",
                "pause",
                "load",
                "canPlayType"
            ];
        var EVENT_HANDLER_NAMES =
            [
                "onended",
                "oncanplay",
                "oncanplaythrough",
                "onerror"
            ];
        CocoonJS.App.setupOriginProxyType("Audio", ATTRIBUTE_NAMES, FUNCTION_NAMES, EVENT_HANDLER_NAMES);
    };

    /**
     * Captures a image of the screen synchronously and saves it to a file. Sync mode allows to capture the screen in the middle of a frame rendering.
     * @param {string} fileName Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} storageType The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @return The URL of the saved file.
     * @throws exception if the image fails to be stored or there is another error.
     * @see CocoonJS.App.onCaptureScreenSucceeded
     * @see CocoonJS.App.onCaptureScreenFailed
     */
    CocoonJS.App.captureScreen = function (fileName, storageType, captureType) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("captureScreen", fileName, storageType, captureType);
        }
    };

    /**
     * Captures a image of the screen asynchronously and saves it to a file.
     * Async mode captures a final frame as soon as possible.
     * @param {string} Desired file name and format (png or jpg). If no value is passed, "capture.png" value is used by default
     * @param {CocoonJS.App.StorageType} [storageType] The developer can specify the storage where it is stored. If no value is passed, the {@link CocoonJS.App.StorageType.TMP_STORAGE} value is used by default.
     * @param {CocoonJS.App.CaptureType} captureType. Optional value to choose capture type. [0: captures everything, 1: only captures cocoonjs surface, 2: only captures system views]. @see CocoonJS.App.CaptureType
     * @param {function} callback. Response callback, check the error property to monitor errors. Check the 'url' property to get the URL of the saved Image
     */
    CocoonJS.App.captureScreenAsync = function (fileName, storageType, captureType, callback) {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            window.ext.IDTK_APP.makeCallAsync("captureScreen", fileName, storageType, captureType, callback);
        }
    };

    /**
     * Returns the device UUID
     * @return {string} The device UUID
     */
    CocoonJS.App.getDeviceId = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceId");
        }
    };

    /**
     * Structure that defines the getDeviceInfo returned information
     */
    CocoonJS.App.DeviceInfo = {

        /**
        * The operating system name (ios, android,...)
        * @type string
        */
        os: null,

        /**
        * The operating system version (4.2.2, 5.0,...)
        * @type string
        */
        version: null,

        /**
        * The operating system screen density in dpi
        * @type string
        */
        dpi: null,

        /**
        * The device manufacturer (apple, samsung, lg,...)
        * @type string
        */
        brand: null,

        /**
        * The device model (iPhone 4S, SAMSUNG-SGH-I997, SAMSUNG-SGH-I997R, etc)
        * @type string
        */
        model: null,

        /**
        * The phone IMEI
        * Android: The phone IMEI is returned or null if the device has not telepohny
        * iOS: null is returned as we cannot get the IMEI in iOS, no public API available for that yet.
        * @type string
        */
        imei: null,

        /**
        * The platform Id
        * Android: The ANDROID_ID is used.
        * iOS: The OpenUDID is used as there is no Android ANDROID_ID equivalent in iOS
        * @type string
        */
        platformId: null,

        /**
        * The Odin generated id https://code.google.com/p/odinmobile/
        * @type string
        */
        odin: null,

        /**
        * The OpenUDID generated Id https://github.com/ylechelle/OpenUDID
        * @type string
        */
        openudid: null
    };

    /**
     * Returns the device Info
     * @return {CocoonJS.App.DeviceInfo} The device Info
     */
    CocoonJS.App.getDeviceInfo = function() {
        if (CocoonJS.App.nativeExtensionObjectAvailable) {
            return window.ext.IDTK_APP.makeCall("getDeviceInfo");
        }
    };    

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onTextDialogFinished} event calls.
     * @name OnTextDialogFinishedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} text The text that was introduced in the text dialog when it was finished.
     */
    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function's documentation is represented by {@link CocoonJS.App.OnTextDialogFinishedListener}
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogFinished = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogfinish");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onTextDialogCancelled = new CocoonJS.EventHandler("IDTK_APP", "App", "ontextdialogcancel");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by accepting it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxConfirmed = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxconfirmed");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the text dialog is finished by dismissing it's content.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onMessageBoxDenied = new CocoonJS.EventHandler("IDTK_APP", "App", "onmessageboxdenied");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is suspended.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onSuspended = new CocoonJS.EventHandler("IDTK_APP", "App", "onsuspended");

    /**
     * This {@link CocoonJS.EventHandler} object allows listening to events called when the application is activated.
     * The callback function does not receive any parameter.
     * @event
     * @static
     * @memberOf CocoonJS.App
     */
    CocoonJS.App.onActivated = new CocoonJS.EventHandler("IDTK_APP", "App", "onactivated");

})();

//////////////////////////////////////
// COCOONJS_APP_FORCOCOONJS.JS		//
//////////////////////////////////////

(function()
{
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before adding more functionalities to an extension.");
    if (typeof window.CocoonJS.App === 'undefined' || window.CocoonJS.App === null) throw("The CocoonJS.App object must exist and be valid before adding more functionalities to it.");

    /**
    * This namespace represents all the basic functionalities available in the CocoonJS extension API.
    * @namespace
    */
    CocoonJS.App = CocoonJS.App ? CocoonJS.App : {};

    if (!CocoonJS.App.nativeExtensionObjectAvailable)
    {
        (function createWebView() { 
            CocoonJS.App.EmulatedWebView = document.createElement('div'); 
            CocoonJS.App.EmulatedWebView.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewDiv'); 
            CocoonJS.App.EmulatedWebView.style.width = 0; 
            CocoonJS.App.EmulatedWebView.style.height = 0; 
            CocoonJS.App.EmulatedWebView.style.position = "absolute"; 
            CocoonJS.App.EmulatedWebView.style.left = 0; 
            CocoonJS.App.EmulatedWebView.style.top = 0;
            CocoonJS.App.EmulatedWebView.style.backgroundColor = 'transparent';
            CocoonJS.App.EmulatedWebView.style.border = "0px solid #000"; 
            CocoonJS.App.EmulatedWebViewIFrame = document.createElement("IFRAME"); 
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('id', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.setAttribute('name', 'CocoonJS_App_ForCocoonJS_WebViewIFrame');
            CocoonJS.App.EmulatedWebViewIFrame.style.width = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.style.height = 0; 
            CocoonJS.App.EmulatedWebViewIFrame.frameBorder = 0;
            CocoonJS.App.EmulatedWebViewIFrame.allowtransparency = true;
            CocoonJS.App.EmulatedWebView.appendChild(CocoonJS.App.EmulatedWebViewIFrame);
            if(!document.body)
            document.body = document.createElement("body");
            document.body.appendChild(CocoonJS.App.EmulatedWebView);
        })(); 
    }

    /**
    * Pauses the CocoonJS JavaScript execution loop.
    * @function
    * @augments CocoonJS.App
    */
    CocoonJS.App.pause = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "pause", arguments);
        }
    };

    /**
    * Resumes the CocoonJS JavaScript execution loop.
    * @static
    * @function
    */
    CocoonJS.App.resume = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "resume", arguments);
        }
    };

    /**
    * Loads a resource in the WebView environment from the CocoonJS environment.
    * @function
    * @param {string} path The path to the resource. It can be a remote URL or a path to a local file.
    * @param {CocoonJS.App.StorageType} [storageType] An optional parameter to specify at which storage in the device the file path is stored. By default, APP_STORAGE is used.
    * @see CocoonJS.App.load
    * @see CocoonJS.App.onLoadInTheWebViewSucceed
    * @see CocoonJS.App.onLoadInTheWebViewFailed
    */
    CocoonJS.App.loadInTheWebView = function(path, storageType)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            // TODO: All this code should be changed to a simple call makeNativeExtensionObjectFunctionCall when the native argument control is improved.
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('loadPath'";
            if (typeof path !== 'undefined')
            {
                javaScriptCodeToForward += ", '" + path + "'";
                if (typeof storageType !== 'undefined')
                {
                    javaScriptCodeToForward += ", '" + storageType + "'";
                }
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            var xhr = new XMLHttpRequest();

            xhr.onreadystatechange = function(event) {
                if (xhr.readyState === 4)
                {
                    if (xhr.status === 200)
                    {
                        var callback= function(event){
                            CocoonJS.App.onLoadInTheWebViewSucceed.notifyEventListeners(path);
                            CocoonJS.App.EmulatedWebViewIFrame.removeEventListener("load", callback);
                        };

                        CocoonJS.App.EmulatedWebViewIFrame.addEventListener(
                            "load", 
                            callback
                        );
                        CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.href= path;
                    }
                    else if (xhr.status === 404)
                    {
                        this.onreadystatechange = null;
                        CocoonJS.App.onLoadInTheWebViewFailed.notifyEventListeners(path);
                    }
                }
            };
            xhr.open("GET", path, true);
            xhr.send();
        }
    };

    /**
     * Reloads the last loaded path in the WebView context.
     * @function
     */
    CocoonJS.App.reloadWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.App.forwardAsync("ext.IDTK_APP.makeCall('reload');");
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.contentWindow.location.reload();
        }
    };

    /**
    * Shows the webview.
    * @function
    * @param {int} x The top lef x coordinate of the rectangle where the webview will be shown.
    * @param {int} y The top lef y coordinate of the rectangle where the webview will be shown.
    * @param {width} y The width of the rectangle where the webview will be shown.
    * @param {height} y The height of the rectangle where the webview will be shown.
    */
    CocoonJS.App.showTheWebView = function(x, y, width, height)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('show'";
            if (typeof x !== 'undefined' && typeof y !== 'undefined' && typeof width !== 'undefined' && typeof height !== 'undefined')
            {
                javaScriptCodeToForward += ", " + x + ", " + y + ", " + width + ", " + height;
            }
            javaScriptCodeToForward += ");";

            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebViewIFrame.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebViewIFrame.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.left = (x ? x : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.top = (y ? y : 0)+'px';
            CocoonJS.App.EmulatedWebView.style.width = (width ? width : window.innerWidth)+'px';
            CocoonJS.App.EmulatedWebView.style.height = (height ? height : window.innerHeight)+'px';
            CocoonJS.App.EmulatedWebView.style.display = "block";
        }
    };

    /**
    * Hides the webview.
    * @function
    */
    CocoonJS.App.hideTheWebView = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            var javaScriptCodeToForward = "ext.IDTK_APP.makeCall('hide');";
            return CocoonJS.App.forwardAsync(javaScriptCodeToForward);
        }
        else if (!navigator.isCocoonJS)
        {
            CocoonJS.App.EmulatedWebView.style.display = "none";
        }
    };

    /**
    * Marks a audio file to be used as music by the system. CocoonJS, internally, differentiates among music files and sound files.
    * Music files are usually bigger in size and longer in duration that sound files. There can only be just one music file 
    * playing at a specific given time. The developer can mark as many files as he/she wants to be treated as music. When the corresponding
    * HTML5 audio object is used, the system will automatically know how to treat the audio resource as music or as sound.
    * Note that it is not mandatory to use this function. The system automatically tries to identify if a file is suitable to be treated as music
    * or as sound by checking file size and duration thresholds. It is recommended, though, that the developer specifies him/herself what he/she considers
    * to be music.
    * @function
    * @param {string} audioFilePath The same audio file path that will be used to create HTML5 audio objects.
    */
    CocoonJS.App.markAsMusic = function(audioFilePath)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "addForceMusic", arguments);
        }
    };

    /**
    * Activates or deactivates the antialas functionality from the CocoonJS rendering.
    * @function
    * @param {boolean} enable A flag that indicates if the antialas should be activated (true) or deactivated (false).
    */
    CocoonJS.App.setAntialias = function(enable)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
           return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultAntialias", arguments);
        }
    };

    /**
    * Sets a callback function that will be called whenever the system tries to finish the app.
    * The developer can specify how the system will react to the finish of the app by returning a
    * boolean value in the callback function: true means, close the app, false means that the developer
    * will handle the app close.
    * A common example of this is the back button in Android devices. When the back button is pressed, this
    * callback will be called and the system will react depending on the developers choice finishing, or not,
    * the application.
    * @function
    * @param {function} appShouldFinishCallback A function object that will be called when the system
    * determines that the app should be finished. This function must return a true or a false value
    * depending on what the developer wants: true === finish the app, false === do not close the app.
    */
    CocoonJS.App.setAppShouldFinishCallback = function(appShouldFinishCallback)
    {
        if (navigator.isCocoonJS)
        {
            window.onidtkappfinish = appShouldFinishCallback;
        }
    }

    /**
    * Sets the texture reduction options. The texture reduction is a process that allows big images to be reduced/scaled down when they are loaded.
    * Although the quality of the images may decrease, it can be very useful in low end devices or those with limited amount of memory.
    * The function sets the threshold on image size (width or height) that will be used in order to know if an image should be reduced or not.
    * It also allows to specify a list of strings to identify in which images file paths should be applied (when they meet the size threshold requirement) 
    * The developer will still think that the image is of the original size. CocoonJS handles all of the internals to be able to show the image correctly.
    * IMPORTANT NOTE: This function should be called when the application is initialized before any image is set to be loaded for obvious reasons ;).
    * and in which sould be forbid (even if they meet the threshold requirement).
    * @function
    * @param {number} sizeThreshold This parameter specifies the minimun size (either width or height) that an image should have in order to be reduced.
    * @param {string or array} [applyTo] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it will be reduced. This parameter can also be null.
    * @param {string or array} [forbidFor] This parameter can either be a string or an array of strings. It's purpose is to specify one (the string) or more (the array) substring(s) 
    * that will be compared against the file path of an image to be loaded in order to know if the reduction should be applied or not. If the image meets the
    * threshold size requirement and it's file path contains this string (or strings), it won't be reduced. This parameter should be used in order to mantain the 
    * quality of some images even they meet the size threshold requirement.
    */
    CocoonJS.App.setTextureReduction = function(sizeThreshold, applyTo, forbidFor)
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "setDefaultTextureReducerThreshold", arguments);
        }
    };


    /**
    * Prints to the console the memory usage of the currently alive textures
    * @function
    */
    CocoonJS.App.logMemoryInfo = function()
    {
        if (CocoonJS.App.nativeExtensionObjectAvailable)
        {
            return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_APP", "logMemoryInfo", arguments);
        }
    };

    /**
    * Enable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.enableFPSInTheWebView = function(fpsLayout, textColor)
    {
        if (!CocoonJS.App.fpsInTheWebViewEnabled)
        {
            fpsLayout = fpsLayout ? fpsLayout : CocoonJS.App.FPSLayout.TOP_RIGHT;
            textColor = textColor ? textColor : "white";
            var jsCode = "" +
                "(function()" +
                "{" +
                    "var COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES = ['js/CocoonJSExtensions/CocoonJS.js', 'js/CocoonJSExtensions/CocoonJS_App.js', 'js/CocoonJSExtensions/CocoonJS_App_ForWebView.js'];" +
                    "var loadedScriptCounter = 0;" + 
                    "var loadedScriptFunction = function() " +
                    "{ " +
                        "loadedScriptCounter++;"+
                        "if (loadedScriptCounter >= COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length)"+
                        "{"+
                            "CocoonJS.App.enableFPS(" + JSON.stringify(fpsLayout) + ", " + JSON.stringify(textColor) + ");"+
                        "}"+
                    "};"+
                    "for (var i = 0; i < COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES.length; i++)"+
                    "{"+
                        "var s = document.createElement('script');"+
                        "s.onload = loadedScriptFunction;"+
                        "s.src = COCOONJS_WEBVIEW_EXTENSION_SCRIPT_FILES[i];"+
                        "document.body.appendChild(s);"+
                    "}" +
                "})();";
            setTimeout(function()
            {
                CocoonJS.App.forward(jsCode);
            }, 3000);
            CocoonJS.App.fpsInTheWebViewEnabled = true;
        }
    };

    /**
    * Disable CocoonJS Webview FPS overlay.
    * @function
    */
    CocoonJS.App.disableFPSInTheWebView = function()
    {
        // TODO: Implement this function.
    };

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewSucceed} event calls.
     * @name OnLoadInTheWebViewSucceedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load has completed successfully.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewSucceedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    * @param {string} pageURL A string that represents the page URL loaded.
    */
    CocoonJS.App.onLoadInTheWebViewSucceed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpageload");

    /**
     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.App.onLoadInTheWebViewFailed} event calls.
     * @name OnLoadInTheWebViewFailedListener
     * @function
     * @static
     * @memberOf CocoonJS.App
     * @param {string} pageURL The URL of the page that had been loaded in the webview.
     */
    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the WebView load fails.
    * The callback function's documentation is represented by {@link CocoonJS.App.OnLoadInTheWebViewFailedListener}
    * @event
    * @static
    * @memberOf CocoonJS.App
    */
    CocoonJS.App.onLoadInTheWebViewFailed = new CocoonJS.EventHandler("IDTK_APP", "App", "forwardpagefail");
    
})();

//////////////////////////////////////
// COCOONJS_AD.JS                   //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Advertisement extension API.
    * @namespace
    */
    CocoonJS.Ad = {};

    CocoonJS.Ad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_AD !== 'undefined';

    /**
    * The predefined possible layouts for a banner ad.
    * @namespace 
    */
	CocoonJS.Ad.BannerLayout = 
	{
		/**
		* Specifies that the banner must be shown in the top of the screen and vertically centered.
		*/
	    TOP_CENTER      : "TOP_CENTER",

		/**
		* Specifies that the banner must be shown in the bottom of the screen and vertically centered.
		*/
	    BOTTOM_CENTER   : "BOTTOM_CENTER"
	};

	/**
    * A rectangle object that contains the banner dimensions
    * @namespace 
    * @constructor
    * @param {int} x The top lef x coordinate of the rectangle.
    * @param {int} y The top lef y coordinate of the rectangle.
    * @param {width} y The rectangle width.
    * @param {height} y The rectangle height.
    */
	CocoonJS.Ad.Rectangle = function(x, y, width, height) 
	{
		/**
		* The top lef x coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.x = x;

		/**
		* The top lef y coordinate of the rectangle 
		* @field 
		* @type {int}
		*/
	    this.y = y;

	    /**
		* The rectangle width
		* @field 
		* @type {int}
		*/
	    this.width = width;

	    /**
		* The rectangle height
		* @field 
		* @type {int}
		*/
	    this.height = height;
	};

	CocoonJS.Ad.Banner = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    	* The callback function does not receive any parameter.
    	* @static
    	* @event
    	*/
		this.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener();
    		}
    	});

    	/**
    	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
    	* The callback function does not receive any parameter.
    	* @param {number} width The banner width
    	* @param {number} height The banner height
    	* @static
    	* @event
    	*/
		this.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) 
    		{
    			sourceListener(args[1], args[2]);
    		}
    	});
	};

	CocoonJS.Ad.Banner.prototype = {

		/**
		* Shows a banner ad if available.
		* @function
		*/
		showBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", [this.id], true);
			}
		},

		/**
		* Hides the banner ad if it was being shown.
		* @function
		*/
		hideBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", [this.id], true);
			}
		},

		/**
		* Refreshes the banner.
		* @function
		*/
		refreshBanner : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", [this.id], true);
			}
		},

		/**
		* Gets the rectangle representing the banner screen position.
		* @function
		* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
		*/
		getRectangle : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", [this.id]);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* @function
		* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
		*/
		setRectangle : function(rect)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", [this.id, rect],true);
			}
		},

		/**
		* Sets the rectangle where the banner ad is going to be shown.
		* You can use this method if you want to have better control of the banner screen positioning.
		* @function
		* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
		*/
		setBannerLayout : function(bannerLayout)
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", [this.id, bannerLayout],true);
			}
		}
	};

	CocoonJS.Ad.Fullscreen = function(id)
	{
		if (typeof id !== 'number') throw "The given ad ID is not a number.";

		this.id = id;
		var me = this;

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
		this.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});

    	/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    */
    	this.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready", function(sourceListener, args)
    	{
    		if (me.id === args[0]) {
    			sourceListener();
    		}
    	});
	};

	CocoonJS.Ad.Fullscreen.prototype = {

		/**
		* Shows a full screen ad if available.
		* @function
		* @see CocoonJS.Ad.onFullScreenShown
		* @see CocoonJS.Ad.onFullScreenHidden
		*/
		showFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", [this.id], true);
			}
		},

		/**
		* Refreshes the fullscreen.
		* @function
		*/
		refreshFullScreen : function()
		{
			if (CocoonJS.Ad.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", [this.id], true);
			}
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Ad.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "requestInitialization", arguments, true);
		}
	};

	/**
	* Creates a new banner ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createBanner = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createBanner", [parameters]);
			var banner = new CocoonJS.Ad.Banner(adId);

			return banner;
		}
	};

	/**
	* Releases a banner.
	* @function
	* @param {object} The banner ad object to be released.
	*/
	CocoonJS.Ad.releaseBanner = function(banner)
	{
		if (typeof banner === "undefined") {
            throw "The banner ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseBanner", [banner.id]);
		}
	};

	/**
	* Creates a new fullscreen ad.
	* @function
	* @param {object} An object containing the properties the ad will need for its initialization.
	*/
	CocoonJS.Ad.createFullscreen = function(parameters)
	{
		if (typeof parameters === "undefined") {
            parameters = {};
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			var adId = CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "createFullscreen", [parameters]);
			var fullscreen = new CocoonJS.Ad.Fullscreen(adId);

			return fullscreen;
		}
	};

	/**
	* Releases a fullscreen ad.
	* @function
	* @param {object} The fullscreen ad object to be released.
	*/
	CocoonJS.Ad.releaseFullscreen = function(fullscreen)
	{
		if (typeof fullscreen === "undefined") {
            throw "The fullscreen ad object to be released is undefined"
        }

		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "releaseFullscreen", [fullscreen.id]);
		}
	};

	/**
	* Shows a banner ad if available.
	* @function
	* @see CocoonJS.Ad.setBannerLayout
	* @see CocoonJS.Ad.onBannerShown
	*/
	CocoonJS.Ad.showBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showBanner", arguments, true);
		}
	};

	/**
	* Hides the banner ad if it was being shown.
	* @function
	*/
	CocoonJS.Ad.hideBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "hideBanner", arguments, true);
		}
	};

	/**
	* Refreshes the banner.
	* @function
	*/
	CocoonJS.Ad.refreshBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshBanner", arguments, true);
		}
	};

	/**
	* Shows a full screen ad if available.
	* @function
	* @see CocoonJS.Ad.onFullScreenShown
	* @see CocoonJS.Ad.onFullScreenHidden
	*/
	CocoonJS.Ad.showFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "showFullScreen", arguments, true);
		}
	};

	/**
	* Refreshes the fullscreen.
	* @function
	*/
	CocoonJS.Ad.refreshFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "refreshFullScreen", arguments, true);
		}
	};

	/**
	* Makes a request to preload a banner ad.
	* @function
	*/
	CocoonJS.Ad.preloadBanner = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadBanner", arguments, true);
		}
	};

	/**
	* Makes a request to preload a full screen ad.
	* @function
	*/
	CocoonJS.Ad.preloadFullScreen = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "preloadFullScreen", arguments, true);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* @function
	* @param {CocoonJS.Ad.Rectangle} rect The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.setRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setRectangle", arguments, true);
		}
	};

	/**
	* Gets the rectangle representing the banner screen position.
	* @function
	* @return {CocoonJS.Ad.Rectangle} rectangle The rectangle representing the banner position and domensions.
	*/
	CocoonJS.Ad.getRectangle = function()
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "getRectangle", arguments);
		}
	};

	/**
	* Sets the rectangle where the banner ad is going to be shown.
	* You can use this method if you want to have better control of the banner screen positioning.
	* @function
	* @param {CocoonJS.Ad.BannerLayout} bannerLayout The layout where the bannerwill be placed.
	*/
	CocoonJS.Ad.setBannerLayout = function(bannerLayout)
	{
		if (CocoonJS.Ad.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_AD", "setBannerLayout", arguments, true);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannershow");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onBannerHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerhide"); 

	/**
	* This {@link CocoonJS.EventHandler} object allows listening to events called when a banner is ready (cached).
	* The callback function does not receive any parameter.
	* @param {number} width The banner width
	* @param {number} height The banner height
	* @static
	* @event
	*/
	CocoonJS.Ad.onBannerReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onbannerready"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is shown.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenShown = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenshow"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is hidden.
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenHidden = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenhide");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a full screen ad is ready (cached).
    * The callback function does not receive any parameter.
    * @static
    * @event
    */
	CocoonJS.Ad.onFullScreenReady = new CocoonJS.EventHandler("IDTK_SRV_AD", "Ad", "onfullscreenready"); 

})();

//////////////////////////////////////
// COCOONJS_STORE.JS                //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS In-App Purchase extension.
    * @namespace
    */
    CocoonJS.Store = {};

    CocoonJS.Store.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_STORE !== 'undefined';

	/**
	* The data structure that represents the information of a product in the store.
	* @namespace
	* @constructor
	* @param {string} The id of the product.
	* @param {string} The alias of the product.
	* @param {CocoonJS.Store.ProductType} The product type @see CocoonJS.Store.ProductType.
	* @param {string} The title of the product.
	* @param {string} The description of the product.
	* @param {string} The localized price of the product.
	* @param {string} The URL of the asset to be downloaded for this purchase.
	*/
	CocoonJS.Store.ProductInfo = function(productAlias, productId, productType, title, description, price, localizedPrice, downloadURL)
	{
		/**
		* The id of the product.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The alias of the product.
		* @field
		* @type string
		*/
		this.productAlias = productAlias;

		/**
		* The product type @see CocoonJS.Store.ProductType
		* @field
		* @type CocoonJS.Store.ProductType
		*/
		this.productType = productType;

		/**
		* The title of the product.
		* @field
		* @type string
		*/
		this.title = title;

		/**
		* The description of the product.
		* @field
		* @type string
		*/
		this.description = description;

		/**
		* The price of the product.
		* @field
		* @type string
		*/
		this.price = price;

		/**
		* The localized price of the product.
		* @field
		* @type string
		*/
		this.localizedPrice = localizedPrice;

		/**
		* The URL of the asset to be downloaded for this purchase.
		* @field
		* @type string
		*/
		this.downloadURL = downloadURL;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.ProductType = 
	{
		/**
		* A consumable product. See platform documentation for further information.
		*/
	    CONSUMABLE : 0,

		/**
		* A non-cunsumable product. . See platform documentation for further information.
		*/
	    NON_CONSUMABLE : 1,

	    /**
		* An auto-renewable subscription. See platform documentation for further information.
		*/
	    AUTO_RENEWABLE_SUBSCRIPTION : 2,

	    /**
		* A free subscription. See platform documentation for further information.
		*/
	    FREE_SUBSCRIPTION : 3,

	    /**
		* A non-renewable subscription. See platform documentation for further information.
		*/
	    NON_RENEWABLE_SUBSCRIPTION : 4
	};

	/**
    * The predefined possible store types.
    * @namespace 
    */
	CocoonJS.Store.StoreType = 
	{
		/**
		* Apple AppStore
		*/
	    APP_STORE : 0,

	    /**
	    * Android Play Store
	    */
	    PLAY_STORE : 1,

		/**
		* Mock Store
		*/
		MOCK_STORE : 2,

		/**
	    * Amazon AppStore
	    */
	    CHROME_STORE : 3,

	    /**
	    * Amazon AppStore
	    */
	    AMAZON_STORE : 4,

	    /**
	    * Nook Store
	    */
	    NOOK_STORE : 5
	};

	/**
	* The data structure that represents the information of a purchase.
	* @namespace
	* @constructor
	* @param {string} The transaction id of a purchase.
	* @param {string} The time when the purchase was done in seconds since 1970.
	* @param {CocoonJS.Store.PurchaseState} The state of the purchase. @see CocoonJS.Store.PurchaseState
	* @param {string} The product id related to this purchase.
	* @param {number} The number of products of the productId kind purchased in this transaction.
	*/
	CocoonJS.Store.PurchaseInfo = function(transactionId, purchaseTime, purchaseState, productId, quantity)
	{
		/**
		* The transaction id of a purchase.
		* @field
		* @type string
		*/
		this.transactionId = transactionId;

		/**
		* The time when the purchase was done in seconds since 1970.
		* @field
		* @type string
		*/
		this.purchaseTime = purchaseTime;

		/**
		* The state of the purchase. @see CocoonJS.Store.PurchaseState
		* @field
		* @type CocoonJS.Store.PurchaseState
		*/
		this.purchaseState = purchaseState;

		/**
		* The product id related to this purchase.
		* @field
		* @type string
		*/
		this.productId = productId;

		/**
		* The number of products of the productId kind purchased in this transaction.
		* @field
		* @type number
		*/
		this.quantity = quantity;

		return this;
	};

	/**
    * The predefined possible states of a purchase.
    * @namespace 
    */
	CocoonJS.Store.PurchaseState = 
	{
		/**
		* The product has been successfully purchased. The transaction has ended successfully.
		*/
	    PURCHASED : 0,

		/**
		* The purchase has been canceled.
		*/
	    CANCELED : 1,

	    /**
		* The purchase has been refunded.
		*/
	    REFUNDED : 2,

	    /**
		* The purchase (subscriptions only) has expired and is no longer valid.
		*/
	    EXPIRED : 3
	};

	/**
	* Gets the name of the native store implementation. 
	* @return {CocoonJS.Store.StoreType} The store type
	* @function
	*/ 
	CocoonJS.Store.getStoreType = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getStoreType", arguments);
		}
	};

	/**
	* Initialize the service with service level initialization parameters.
	* @function
	* @param {object} An object with the required initialization parameters for the service.
	*/
	CocoonJS.Store.requestInitialization = function(parameters)
	{
        if (typeof parameters === "undefined") 
        {
            parameters = {};
        }
        else
        {
        	if (parameters['managed'] !== undefined) parameters['remote'] = parameters['managed'];
        	if (parameters['sandbox'] !== undefined) parameters['debug'] = parameters['sandbox'];
        }

		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "requestInitialization", arguments, true);
		}
	};

	/**
	* Starts the Store Service. 
	* This will make the system to initialize the Store Service and probably Store callbacks will start to be received after calling this method so you should have set your event handler before calling this method so don't lose any callback.
	* @function
	*/ 
	CocoonJS.Store.start = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "start", arguments);
		}
	};

	/**
	* This method allows you to check is the  Store service is available in this platform. 
	* Not all iOS and Android devices will have the Store service available so you should check if it is before calling any other method.
	* @function
	* @return {boolean} True if the service is available and false otherwise.
	*/ 
	CocoonJS.Store.canPurchase = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "canPurchase", arguments);
		}
	};

	/**
	* Fetches the products from the CocoonJS Cloud Compiling service store configuration. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @deprecated You should now use fetchProductsFromStore. We don't support cloud products now.
	* @function
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromServer = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromServer", arguments, true);
		}
	};

	/**
	* Fetches the products information from the Store. 
	* The request is monitored using the {@link CocoonJS.Store.onProductsFetchStarted}, {@link CocoonJS.Store.onProductsFetchCompleted} and {@link CocoonJS.Store.onProductsFetchFailed} event handlers.
	* @function
	* @param {array} productIds An array with the ids of the products to retrieve information from.
	* @see CocoonJS.Store.onProductsFetchStarted
	* @see CocoonJS.Store.onProductsFetchCompleted
	* @see CocoonJS.Store.onProductsFetchFailed
	*/ 
	CocoonJS.Store.fetchProductsFromStore = function(productIds)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "fetchProductsFromStore", arguments, true);
		}
	};

	/**
	* Finish a purchase transaction and removes the transaction from the transaction queue. 
	* This method must be called after a purchase finishes successfully and the  {@link CocoonJS.Store.onProductPurchaseCompleted} callback has been received. 
	* If the purchase includes some asset to download from an external server this method must be called after the asset has been successfully downloaded. 
	* If you do not finish the transaction because the asset has not been correctly downloaded the {@link CocoonJS.Store.onProductPurchaseStarted} method will be called again later on.
	* @function
	* @param {string} transactionId The transactionId of the purchase to finish.
	*/ 
	CocoonJS.Store.finishPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "finishPurchase", arguments, true);
		}
	};

	/**
	* Consumes a purchase. This makes that product to be purchasable again. 
	* @function
	* @param {string} transactionId The transaction Id of the purchase to consume.
	* @param {string} productId The product Id of the product to be consumed.
	*/ 
	CocoonJS.Store.consumePurchase = function(transactionId, productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "consumePurchase", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeature", arguments, true);
		}
	};

	/**
	* Request a product purchase given it's product id showing a modal progress dialog. 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.puchaseProductModal = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModal", arguments, true);
		}
	};

	/**
	* Request the purchase of a product given it's product id showing a dialog with a preview of the product (title and description). 
	* The request is monitored using the {@link CocoonJS.Store.onProductPurchaseStarted}, {@link CocoonJS.Store.onProductPurchaseCompleted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} productId The id or alias of the product to be purchased.
	* @see CocoonJS.Store.onProductPurchaseStarted
	* @see CocoonJS.Store.onProductPurchaseCompleted
	* @see CocoonJS.Store.onProductPurchaseFailed
	*/ 
	CocoonJS.Store.purchaseProductModalWithPreview = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "purchaseFeatureModalWithPreview", arguments, true);
		}
	};

	/**
	* Returns if a product has been already purchased or not. 
	* @function
	* @param {string} productId The product id or alias of the product to be checked.
	* @returns {boolean} A flag that indicates whether the product has been already purchased (true) or not (false).
	*/
	CocoonJS.Store.isProductPurchased = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "isFeaturePurchased", arguments);
		}
	};

	/**
	* Restores all the purchases from the platform's market. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchases", arguments, true);
		}
	};

	/**
	* Restores all the purchases from the platform's market showing a modal progress dialog. 
	* For each already purchased product {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onPurchaseProductCompleted} and {@link CocoonJS.Store.onPurchaseProductFailed} event handlers are called again
	* @function
	* @see CocoonJS.Store.onRestorePurchasesStarted
	* @see CocoonJS.Store.onRestorePurchasesCompleted
	* @see CocoonJS.Store.onRestorePurchasesFailed
	*/
	CocoonJS.Store.restorePurchasesModal = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "restorePurchasesModal", arguments, true);
		}
	};

	/**
	* Returns all the products available to be purchased.
	* @function
	* @returns {array} An array with  all the {@link CocoonJS.Store.ProductInfo} objects available for purchase.
	*/
	CocoonJS.Store.getProducts = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getProducts", arguments);
		}
	};

	/**
	* Adds a product to the products local DB. 
	* @function
	* @param {CocoonJS.Store.ProductInfo} product The product to be added to the local products DB.
	*/
	CocoonJS.Store.addProduct = function(product)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addProduct", arguments);
		}
	};

	/**
	* Removes a product from the products local DB given its productId. 
	* @function
	* @param {string} productId The product or alias of the product to be removed from the local products DB.
	*/
	CocoonJS.Store.removeProduct = function(productId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removeProduct", arguments);
		}
	};

	/**
	* Returns all the locally stored purchases.
	* @function
	* @returns {array} An array with all the {@link CocoonJS.Store.PurchaseInfo} completed purchases.
	*/
	CocoonJS.Store.getPurchases = function()
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "getPurchases", arguments);
		}
	};

	/**
	* Adds a purchase to the local purchases DB. 
	* @function
	* @param {CocoonJS.Store.StorePurchase} purchase The purchase to be added.
	*/ 
	CocoonJS.Store.addPurchase = function(purchase)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "addPurchase", arguments);
		}
	};

	/**
	* Removes a purchase from the local purchases DB given it's transaction id. 
	* @function
	* @param {string} transactionId The id of the transaction to be removed.
	*/ 
	CocoonJS.Store.removePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "removePurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase cancel. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be canceled.
	*/
	CocoonJS.Store.cancelPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "cancelPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase refundment. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be refunded.
	*/
	CocoonJS.Store.refundPurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "refundPurchase", arguments);
		}
	};

	/**
	* (TESTING ONLY) Simulate a purchase expiration. 
	* This method is not allowed in production services and will only work in Mocks. 
	* The request is monitored using the {@link CocoonJS.Store.onPurchaseProductStarted}, {@link CocoonJS.Store.onProductPurchaseStarted} and {@link CocoonJS.Store.onProductPurchaseFailed} event handlers.
	* @function
	* @param {string} transactionId The transactionId of the purchase to be expired.
	*/
	CocoonJS.Store.expirePurchase = function(transactionId)
	{
		if (CocoonJS.Store.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_STORE", "expirePurchase", arguments);
		}
	};

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onProductsFetchStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchStarted");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has completed.
    * The callback function receives a parameter with an the valid products array.
    * @static
    * @event
    * @param {array} validProducts An array of {@link CocoonJS.Store.ProductInfo} objects representing all the valid fetched products.
    */
	CocoonJS.Store.onProductsFetchCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the products fetch has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onProductsFetchFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductsFetchFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product starts.
    * The callback function receives a parameters with the information of the purchased product @see CocoonJS.Store.ProductInfo.
    * @static
	* @event
    * @param {string} productId The product id of the product being purchased.
    */
	CocoonJS.Store.onProductPurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseStarted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a request for purchase verification has been received from the Store.
    * The callback function receives two parameters, one with the productId of the purchased product and another one with a JSON object containing the data to be verified.
    * In Andorid this JSON object will containt two keys: signedData and signature. You will need that information to verify the purchase against the backend server.
    * @static
    * @event
    * @param {string} productId The product id of the product to be verified.
    * @param {string} data The string with the data to be verified.
    */
	CocoonJS.Store.onProductPurchaseVerificationRequestReceived = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseVerificationRequestReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product succeeds.
    * The callback function receives as parameter the information of the purchase {@see CocoonJS.Store.PurchaseInfo}.
    * @static
    * @event
    * @param {CocoonJS.Store.PurchaseInfo} purchaseInfo The purchase info.
    */
	CocoonJS.Store.onProductPurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseCompleted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the purchase of a product fails.
    * The callback function receives a parameters with the product id and an error message.
    * @static
    * @event
    * @param {string} productId The product id.
    * @param {string} msg The error message.
    */
	CocoonJS.Store.onProductPurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onProductPurchaseFailed"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has started.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has completed.
    * The callback function receives no parameters.
    * @static
    * @event
    */
	CocoonJS.Store.onRestorePurchasesCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the restore purchases operation has failed.
    * The callback function receives an error message as a parameter.
    * @static
    * @event
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onRestorePurchasesFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onRestorePurchasesFailed");

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has started.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase being consumed.
    */
	CocoonJS.Store.onConsumePurchaseStarted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseStarted"); 

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has completed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the consumed purchase.
    */
	CocoonJS.Store.onConsumePurchaseCompleted = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseCompleted"); 

	/**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the consume purchase operation has failed.
    * @static
    * @event
    * @param {string} transactionId The transaction id of the purchase that couldn't be consumed.
    * @param {string} errorMessage The error message.
    */
	CocoonJS.Store.onConsumePurchaseFailed = new CocoonJS.EventHandler("IDTK_SRV_STORE", "Store", "onConsumePurchaseFailed");

})();

//////////////////////////////////////
// COCOONJS_SOCIAL.JS               //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.Social = function(nativeExtensionName, extensionName)
	{
		if (typeof nativeExtensionName !== 'string') throw "The given native extension name '" + nativeExtensionName + "' is not a string.";
		if (typeof extensionName !== 'string') throw "The given extension name '" + extensionName + "' is not a string.";

		this.nativeExtensionName = nativeExtensionName;
		this.extensionName = extensionName;
	    this.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext[nativeExtensionName] !== 'undefined';

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationSucceed} event calls.
	     * @name OnRequestInitializationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when requestInitialization was called.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestInitializationFailed} event calls.
	     * @name OnRequestInitializationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {object} initializationData The data structure passed when the requestInitialization function was called.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestInitializationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
	    this.onRequestInitializationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestInitializationFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginSucceed} event calls.
	     * @name OnRequestLoginSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the user that logged in.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestLoginFailed} event calls.
	     * @name OnRequestLoginFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user login request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestLoginFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestLoginFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestLoginFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user logs out.
	    * The callback function does not receive any parameter.
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onLogout = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLogout");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoSucceed} event calls.
	     * @name OnRequestUserInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.UserInfo} userInfo The structure that describes the information of the request user id.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserInfoFailed} event calls.
	     * @name OnRequestUserInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnUserInfoRequestFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLSucceed} event calls.
	     * @name OnRequestUserImageURLSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id used in the request.
	     * @param {string} imageURL The URL of the image of the requested user. 
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserImageURLFailed} event calls.
	     * @name OnRequestUserImageURLFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user the request was placed for.
	     * @param {string} errorMessage The message that describes why the request did fail.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user image URL request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserImageURLFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserImageURLFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserImageURLFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosSucceed} event calls.
	     * @name OnRequestUserFriendsUserInfosSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {string} userID The id of the user for whom the friend user infos where requested.
	     * @param {array} friendsInfo An array of {@link CocoonJS.Social.UserInfo} objects representing the information of the friends of the user.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info is successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestUserFriendsUserInfosFailed} event calls.
	     * @name OnRequestUserFriendsUserInfosFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param 
	     * @param {string} userID The id of the user fro whom the friends infos were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's friends info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestUserFriendsUserInfosFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestUserFriendsUserInfosFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserFriendsUserInfosFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationSucceed} event calls.
	     * @name OnRequestMessagePublicationSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
 	     * @param {CocoonJS.Social.Message} message The message that has been published.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationSucceedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    * @param {CocoonJS.Social.Message} message The message that has been published.
	    */
		this.onRequestMessagePublicationSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.Social.onRequestMessagePublicationFailed} event calls.
	     * @name OnRequestMessagePublicationFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.Social
	     * @param {CocoonJS.Social.Message} message The message that was supposed to be published.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user message publication request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.Social.OnRequestMessagePublicationFailedListener}
	    * @static
	    * @event
	    * @memberOf CocoonJS.Social
	    */
		this.onRequestMessagePublicationFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestMessagePublicationFailed");

		/**
        * @ignore
        */
        this.on= function(event, callback) {
            event= "on"+event[0].toUpperCase()+event.substr(1);
            var signal= this[event];
            if (signal) {
                signal.addEventListener(callback);
            } else {
                console.error("SocialGaming service: '"+this.extensionName+"' does not understand '"+event+' signal.');
            }

            return this;
        };

	    return this;
	};

	CocoonJS.Social.prototype = {
        userInfo : null,
        userInfoCocoonJS : null,

        /**
        * @ignore
        */
        getUserInfo : function() {
            return this.userInfo;
        },

        /**
        * Returns the information of the currently logged in user.
        * @return {@link CocoonJS.Social.UserInfo}
        */
        getLoggedInUserInfo : function() {
            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getLoggedInUserInfo", arguments);
            }
            else {
                return this.userInfoCocoonJS;
            }
        },

        /**
        * @ignore
        */
        setUserInfo : function( userInfo) {
            this.userInfo= userInfo;
        },

        /**
        * @ignore
        */
        setUserInfoCocoonJS : function( userInfoCocoonJS ) {
            this.userInfoCocoonJS = userInfoCocoonJS;
        },

		/**
        * Request initialization of the underlying social service.
        * @param {object} paramsObject A data structure to initialize the service. It will be dependable of the underlying service.
        * @see CocoonJS.Social.onRequestInitializationSucceed
        * @see CocoonJS.Social.onRequestInitializationFailed
        */
		requestInitialization : function(paramsObject) 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestInitialization", arguments, true);
			}
		},

		/**
        * Returns a flag to indicate if the underlying service has been initialized or not.
        * @return {boolean} If the underlying service had been initialized using the requestInitialization function call.
        */
		isInitialized : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isInitialized", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to log in the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Socual.onRequestLoginFailed
		*/
		requestLogin : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogin", arguments, true);
			}
		},

		/**
		* Request to log out of the social gaming application.
		* @see CocoonJS.Social.onRequestLoginSucceed
		* @see CocoonJS.Social.onRequestLoginFailed
		* @see CocoonJS.Social.onLogout
		*/
		requestLogout : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestLogout", arguments, true);
			}
		},

		/**
		* Check if the user is logged in.
		* @return {boolean} true if the user is still logged in, false otherwise.
		*/
		isLoggedIn : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "isLoggedIn", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Returns all the granted permissions for the current session.
		* @return {Array} An array containin the user granted permissions.
		*/
		getPermissions : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "getPermissions", arguments);
			}
			else
			{
				return new Array();
			}
		},

		/**
		* Check if the user has granted the publish permission for the current session.
		* @return {boolean} true if the user has granted the publish permission for the current session, false otherwise.
		*/
		hasPublishPermission : function() 
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "hasPublishPermission", arguments);
			}
			else
			{
				return false;
			}
		},

		/**
		* Request to retrieve the current or a specific user's id. The request can be monitored using the {@link CocoonJS.Social.onUserInfoRequestSucceed} and {@link CocoonJS.Social.onUserInfoRequestFailed} event handlers.
		* @param {string} [userId] The id of the user to retireve the information from. If no userID is specified, the currently logged in user is assumed.
		* @see CocoonJS.Social.onRequestUserInfoSucceed
		* @see CocoonJS.Social.onRequestUserInfoFailed
		*/
		requestUserInfo : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserInfo", arguments, true);
			}
		},

		/**
		* Request to retrieve the Image of a user
		* @param {string} [userID] The id of the user to get the image for. If no userID is specified, the currently logged user is used.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}. If no value is specified, SMALL is used.
		* @see CocoonJS.Social.onRequestUserImageURLSucceed;
		* @see CocoonJS.Social.onRequestUserImageURLFailed;
		*/
		requestUserImageURL : function( imageSizeType, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserImageURL", arguments, true);
			}
		},

		/**
		* Request for the information of all the friends of the currently logged user.
		* @param {string} [userID] The id of the user to get the friends infos for. If no userID is specified, the currently logged user is used.
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosSucceed;
		* @see CocoonJS.Social.onRequestUserFriendsUserInfosFailed;
		*/
		requestUserFriendsUserInfos : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserFriendsUserInfos", arguments, true);
			}
		},

		/**
		* Request the publication of a message using a dialog.
		* @param {CocoonJS.Social.Message} message A object representing the information to be published.
		* @see CocoonJS.Social.onRequestMessagePublicationSucceed
		* @see CocoonJS.Social.onRequestMessagePublicationFailed
		*/
		requestMessagePublicationWithDialog : function(message)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestMessagePublicationWithDialog", arguments, true);
			}
		}
	};

	/**
	* This structure represents the possible images to be obtained for a user in the social gaming extension.
	* @namespace
	*/
	CocoonJS.Social.ImageSizeType = 
	{
		/**
		* Represent a thumbnail like image size.
		*/
	    THUMB : "thumb",

		/**
		* Represents the small image size.
		*/
	    SMALL : "small",

		/**
		* Represents the medium image size.
		*/
	    MEDIUM : "medium",

		/**
		* Represents the large image size.
		*/
	    LARGE : "large"
	};

	/**
	* The data structure that represents the information of a user inside the social gaming extension.
	* @namespace
	* @constructor
	* @param {string} userID The id of the user.
	* @param {string} userName The user name of the user.
	*/
	CocoonJS.Social.UserInfo = function(userID, userName)
	{
		/**
		* The id of the user.
		* @field
		* @type string
		*/
		this.userID = userID;

		/**
		* The user name of the user.
		* @field
		* @type string
		*/
		this.userName = userName;
	};

	/**
	* This type represents a message to be published.
	* @namespace
	* @constructor
	* @param {string} message The message to be published.
	* @param {string} mediaURL An URL to a media (image, video, ...)
	* @param {string} linkURL An URL to add to the message so the user can click on that link to get more information.
	* @param {string} linkText The text that will appear in the message link.
	* @param {string} linkCaption The text caption that will appear in the message link.
	*/
	CocoonJS.Social.Message = function(message, mediaURL, linkURL, linkText, linkCaption)
	{
		/**
		* The message to be published.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* An URL to a media (image, video, ...)
		* @field
		* @type string
		*/
		this.mediaURL = mediaURL;

		/**
		* An URL to add to the message so the user can click on that link to get more information.
		* @field
		* @type string
		*/
		this.linkURL = linkURL;

		/**
		* The text that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkText = linkText;

		/**
		* The text caption that will appear in the message link.
		* @field
		* @type string
		*/
		this.linkCaption = linkCaption;

		return this;
	};

})();

//////////////////////////////////////
// COCOONJS_SOCIALGAMING.JS         //
//////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    if (!CocoonJS.Social)
		throw("The CocoonJS.Social object must exist and be valid before creating any extension object.");

	/**
	* This type represents the access to a native Social Gamming extension API. As there can be more than
	* one service of this type, more than one instance can be created.
	* @namespace
	* @constructor
	* @param {string} nativeExtensionName The name of the native ext object extension property name.
	* @param {string} extensionName The name of the CocoonJS object extension property name.
	*/
	CocoonJS.SocialGaming = function(nativeExtensionName, extensionName)
	{
		CocoonJS.SocialGaming.superclass.constructor.call(this, nativeExtensionName, extensionName);

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed} event calls.
	     * @name OnRequestUserAndFriendsScoresSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} userAndFriendsScoreInfos An array of {@link CocoonJS.SocialGaming.UserScoreInfo} objects representing the information of the user's and friends' scores.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and friends scores request succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed} event calls.
	     * @name OnRequestUserAndFriendsScoresFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score and friends scores were requested.
	     * @param {string} leadeboardID The id of the leaderboard for whom the score and friends scores were requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user and his/her friends scores request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAndFriendsScoresFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAndFriendsScoresFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAndFriendsScoresFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreSucceed} event calls.
	     * @name OnRequestUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.UserScoreInfo} userScoreInfo The info of the user's score.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserScoreFailed} event calls.
	     * @name OnRequestUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score was requested.
	     * @param {string} leaderboardID The id of the leaderboard for whom the score was requested.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score information request fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreSucceed} event calls.
	     * @name OnSubmitUserScoreSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score has been submitted.
	     * @param {string} leaderboardID The id of the leaderboard for which the score has been submitted.
	     * @param {number} score The score that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit suceeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserScoreFailed} event calls.
	     * @name OnSubmitUserScoreFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the score submition was requested.
	     * @param {string} leaderboadID The id of the leaderboard for which the score submition was requested.
	     * @param {number} score The score that was submitted and failed.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's score submit fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserScoreFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserScoreFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserScoreFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} event calls.
	     * @name OnRequestUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where requested.
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of the user's achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestUserAchievementsFailed} event calls.
	     * @name OnRequestUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were requested.
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestUserAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} event calls.
	     * @name OnRequestAllAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {array} achievementsInfos An array of {@link CocoonJS.SocialGaming.AchievementInfo} objects representing the information of all the achievements.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievements info are successfully retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAllAchievementsFailed} event calls.
	     * @name OnRequestAllAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	   	 * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the user's achievmeents info fails to be retrieved.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAllAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAllAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAllAchievementsFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoSucceed} event calls.
	     * @name OnRequestAchievementInfoSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {CocoonJS.SocialGaming.AchievementInfo} achievementInfo A {@link CocoonJS.SocialGaming.AchievementInfo} object representing the information of the achievement.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onRequestAchievementInfoFailed} event calls.
	     * @name OnRequestAchievementInfoFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} achievementID The id of the achievement for which the information retrieval was requested.
	     * @param {string} errorMessage The error message.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the request to retrieve the information of an achievement fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnRequestAchievementInfoFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onRequestAchievementInfoFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onRequestAchievementInfoFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementSucceed} event calls.
	     * @name OnSubmitUserAchievementSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievement has been submitted.
	     * @param {string} achievementID The id of the achievement that has been submitted.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onSubmitUserAchievementFailed} event calls.
	     * @name OnSubmitUserAchievementFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievment was submitted.
	     * @param {string} achievementID The id of the achievement that was submitted.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement submition fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnSubmitUserAchievementFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onSubmitUserAchievementFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onSubmitUserAchievementFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsSucceed} event calls.
	     * @name OnResetUserAchievementsSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements were reset.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset succeeds.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onResetUserAchievementsFailed} event calls.
	     * @name OnResetUserAchievementsFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} userID The id of the user for whom the achievements where tried to be reset.
	     * @param {string} msg The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnResetUserAchievementsFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onResetUserAchievementsFailed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onResetUserAchievementsFailed");

	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the users closes the achievements view.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onAchievementsViewFailed} event calls.
	     * @name OnAchievementsViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} errorMessage The message that describes why the call failed.
	     */
		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when the achievements view failed to show.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnAchievementsViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewFailed");

		/**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when achievements view shows successfully.
	    * The callback function does not receive any parameter.
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
		this.onAchievementsViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onAchievementsViewSucceed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewClosed} event calls.
	     * @name OnLeaderboardViewClosedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewClosedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewClosed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewClosed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewFailed} event calls.
	     * @name OnLeaderboardViewFailedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     * @param {string} errorMessage The error message.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewFailedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewFailed  = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewFailed");

	    /**
	     * FOR DOCUMENTATION PURPOSE ONLY! The documentation of the function callback for the {@link CocoonJS.SocialGaming.onLeaderboardViewSucceed} event calls.
	     * @name OnLeaderboardViewSucceedListener
	     * @function
	     * @static
	     * @memberOf CocoonJS.SocialGaming
	     * @param {string} leaderboardID The id of the leaderboard for which it's vew was requested to be shown.
	     */
	    /**
	    * This {@link CocoonJS.EventHandler} object allows listening to events called when a user's achievement reset fails.
	    * The callback function's documentation is represented by {@link CocoonJS.SocialGaming.OnLeaderboardViewSucceedListener}
	    * @event
	    * @static
	    * @memberOf CocoonJS.SocialGaming
	    */
   		this.onLeaderboardViewSucceed = new CocoonJS.EventHandler(this.nativeExtensionName, this.extensionName, "onLeaderboardViewSucceed");

		return this;
	};

	CocoonJS.SocialGaming.prototype = 
	{
        abstractToSocialGamingAchievementMap : null,
        abstractToSocialGamingAchievementMapInverse : null,

        /**
        * @ignore
        */
        setAbstractToSocialGamingAchievementMap : function( map ) {
            this.abstractToSocialGamingAchievementMap= map;

            // build a reciprocal map.
            this.abstractToSocialGamingAchievementMapInverse= {};
            for( var id in map ) {
                if ( map.hasOwnProperty(id) ) {
                    this.abstractToSocialGamingAchievementMapInverse[ map[id] ]= id;
                }
            }
            return this;
        },

        /**
        * @ignore
        */
        getAbstractToSocialGamingAchievementTranslation : function( achievementID ) {
            /**
             * If a translation map for abstract in-game achievements has been set, translate achievementID from
             * abstract to SocialGamingService.
             */
            if (this.abstractToSocialGamingAchievementMap) {
                var socialGamingAchievementID = this.abstractToSocialGamingAchievementMap[achievementID];
                if (socialGamingAchievementID) {
                    console.log("Abstract achieventID='" + achievementID + "' turned to '" + socialGamingAchievementID + "'");
                    achievementID = socialGamingAchievementID;
                } else {
                    console.log("Something may be wrong: abstract achievementID: '" + achievementID + "' w/o translation.")
                }
            }

            return achievementID;
        },

		/**
		* Request to retrieve the scores of all friends of a given user.
		* @param {string} [leaderboardID] The id of the leaderboard to request the scores for.
		* @param {string} [userID] The id of the user. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAndFriendsScoresFailed
		*/
		requestUserAndFriendsScores : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAndFriendsScores", arguments, true);
			}
		},

		/**
		* Request to retrieve the score of a user.
		* @param {string} [leaderboardID] The id of the scores leaderboard to retireve the score from. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to retireve the score from. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onRequestUserScoreSucceed
		* @see CocoonJS.SocualGaming.onRequestUserScoreFailed
		*/
		requestUserScore : function(leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserScore", arguments, true);
			}
		},

		/**
		* Request to the server the score of a user.
		* @param {number} [score] the score to submit
		* @param {string} [leaderboardID] The id of the scores leaderboard to submit the score to. If null or underfined is passed, the "leadeboard" id will be used.
		* @param {string} [userID] The id of the user to submit the score for. If null or undefined is passed, the currently logged in user id is used.
		* @see CocoonJS.SocialGaming.onSubmitUserScoreSucceed
		* @see CocoonJS.SocualGaming.onSubmitUserScoreFailed
		*/
		submitUserScore : function(score, leaderboardID, userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserScore", arguments, true);
			}
		},
		/**
		* Shows the leaderboard using a platform dependant view.
		* @param {string} [leaderboardID] The id of the scores leaderboard to show the view for. If null or underfined is passed, the "leadeboard" id will be used.
		* @see CocoonJS.SocialGaming.onLeaderboardViewClosed
		*/
		showLeaderboardView : function(leaderboardID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showLeaderboardView", arguments, true);
			}
		},

		/**
		* Request to retrieve the user achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestUserAchievementsSucceed} and {@link CocoonJS.Social.onRequestUserAchievementsFailed} event handlers.
		* @param {string} [userID] The id of the user to retireve the achievements from. if null/undefined/"" is specified, the currently logged in user is assumed.
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestUserAchievementsFailed
		*/
		requestUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestUserAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve all the achievements. The request can be monitored using the {@link CocoonJS.SocialGaming.onRequestAllAchievementsSucceed} and {@link CocoonJS.Social.onRequestAllAchievementsFailed} event handlers.
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsSucceed
		* @see CocoonJS.SocialGaming.onRequestAllAchievementsFailed
		*/
		requestAllAchievements : function()
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAllAchievements", arguments, true);
			}
		},

		/**
		* Request to retrieve the information about an achievement. 
		* @param {string} achievementID The id of the achievement to get the information for.
		* @param {CocoonJS.Social.ImageSizeType} [imageSizeType] The size of the image. One of the possible values among the ones in the {@link CocoonJS.Social.ImageSizeType}
		*/
		requestAchievementInfo : function(achievementID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "requestAchievementInfo", arguments, true);
			}
		},

		/**
		* Submits an achievement to the server. If the process fails, the achievement is stored to submit it later.
		* @param {string} [achievementID] the achievement identifier
		* @param {number} [percentComplete] an optional number between 0 and 100 that indicates a completion percentage.
		* @see CocoonJS.SocialGaming.onSubmitAchievementSucceed
		* @see CocoonJS.SocualGaming.onSubmitAchievementFailed
		*/
        submitUserAchievement:function (achievementID, userID) {
            achievementID = this.getAbstractToSocialGamingAchievementTranslation(achievementID);

            if (this.nativeExtensionObjectAvailable) {
                return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "submitUserAchievement", arguments, true);
            }
        },

		/**
		* Shows the achievements using a platform dependant view.
		* @see CocoonJS.SocialGaming.onAchievementsViewClosed
		*/
		showUserAchievementsView : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "showUserAchievementsView", arguments, true);
			}
		},

		/**
		* Resets all the achievements of the current user
		* @param {string} [userID] The id of the user to reset the achievements for. If null/undefined/"", the logged in user is assumed.
		* @see CocoonJS.SocialGaming.onResetAchievementsSucceed
		* @see CocoonJS.SocualGaming.onResetAchievementsFailed
		*/
		resetUserAchievements : function(userID)
		{
			if (this.nativeExtensionObjectAvailable)
			{
				return CocoonJS.makeNativeExtensionObjectFunctionCall(this.nativeExtensionName, "resetUserAchievements", arguments, true);
			}
		}
	};

	/**
    * @ignore
    */
	CocoonJS.extend(CocoonJS.SocialGaming, CocoonJS.Social);

	/**
	* The data structure that represents the information of the user score in the application.
	* @namespace
	* @constructor
	* @param {string} userID The user id.
	* @param {number} score The score of the user.
	* @param {string} userName The name of the user.
	* @param {string} imageURL The url of the user image.
	* @param {number} leaderboardID The id of the leaderboard the score belongs to.
	*/
	CocoonJS.SocialGaming.UserScoreInfo = function(userID, score, userName, imageURL, leaderboardID)
	{
		/**
		* The user id. 
		* @type string
		*/
		this.userID = userID;

		/**
		* The score of the user.
		* @type number
		*/
		this.score = score ? score : 0;

		/**
		* The name of the user.
		* @type string
		*/
        this.userName = userName;

		/**
		* The url of the user image.
		* @type string
		*/
        this.imageURL = imageURL;

        /**
		* The id of the leaderboard the score belongs to.
		* @type number
		*/
        this.leaderboardID = leaderboardID;
	};

	/**
	* The data structure that represents the information of an achievement in the application.
	* @namespace
	* @constructor
	* @param {string} achievementID The id of the achievement info.
	* @param {string} title The title of the achievement.
	* @param {string} description The description of the achievement.
	* @param {string} imageURL The url to the image representing the achievement.
	* @param {number} points The points value of the achievement
	*/
	CocoonJS.SocialGaming.AchievementInfo = function(achievementID, title, description, imageURL, points)
	{
		/**
		* The id of the achievement info.
		* @type string
		*/
		this.achievementID = achievementID;

		/**
		* The title of the achievement.
		* @type string
		*/
		this.title = title;

		/**
		* The description of the achievement.
		* @type string
		*/
		this.description = description;

		/**
		* The url to the image representing the achievement.
		* @type string
		*/
		this.imageURL = imageURL;

		/**
		* The points value of the achievement
		* @type number
		*/
		this.points = points ? points : 0;
	};

})();

/////////////////////////////////////////
// COCOONJS_SOCIALGAMING_GAMECENTER.JS //
/////////////////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");
    if (typeof window.CocoonJS.SocialGaming === 'undefined' || window.CocoonJS === null) throw("The CocoonJS.SocialGaming object must exist and be valid before creating a Game Center extension object.");

	/**
	* This instance represents the extension object to access GameCenter related native functionalities.
	* The data structure for initialization: None.
	* @see CocoonJS.Social
	*/
	CocoonJS.SocialGaming.GameCenter = new CocoonJS.SocialGaming("IDTK_SRV_SOCIAL_GAMECENTER", "SocialGaming.GameCenter");
})();

//////////////////////////////
// COCOONJS_GAMEPAD.JS 		//
//////////////////////////////

(function () {
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
     * This namespace represents the functionalities related to OUYA android gaming control.
     * @namespace
     */
    CocoonJS.Gamepad = {};

    CocoonJS.Gamepad.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.Gamepad !== 'undefined';

    CocoonJS.Gamepad.Indices = {
        BUTTON_0                : 0, 
        BUTTON_1                : 1,
        BUTTON_2                : 2,
        BUTTON_3                : 3,
        BUTTON_LEFT_BUMPER      : 4,
        BUTTON_RIGHT_BUMPER     : 5,
        
        BUTTON_LEFT_TRIGGER     : 6,
        BUTTON_RIGHT_TRIGGER    : 7,
        
        BUTTON_LEFT_JOYSTICK    : 10,
        BUTTON_RIGHT_JOYSTICK   : 11,
        BUTTON_DPAD_UP          : 12,
        BUTTON_DPAD_DOWN        : 13,
        BUTTON_DPAD_LEFT        : 14,
        BUTTON_DPAD_RIGHT       : 15,
        BUTTON_MENU             : 16,
        
        AXE_LEFT_JOYSTICK_X     : 0,
        AXE_LEFT_JOYSTICK_Y     : 1,
        AXE_RIGHT_JOYSTICK_X    : 2,
        AXE_RIGHT_JOYSTICK_Y    : 3
    };

    // If the extension is present and the navigator does not provide the gamepad API:
    // 1.- Add the getGamepads function to the navigator object.
    // 2.- Replace the window add and remove event listener functions to call to the extension for the gamepad related events.
    var systemSupportsGamepads = navigator["getGamepads"] || navigator["webkitGetGamepads"];
    if (CocoonJS.Gamepad.nativeExtensionObjectAvailable && !systemSupportsGamepads)
    {
        navigator.getGamepads = function()
        {
            return window.ext.Gamepad.makeCall("getGamepads");
        };

        CocoonJS.Gamepad.originalWindowAddEventListener = window.addEventListener;
        CocoonJS.Gamepad.originalWindowRemoveEventListener = window.removeEventListener;

        window.addEventListener = function(eventName, callback)
        {
            console.log("The new window.addEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.addEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowAddEventListener.apply(window, argumentsArray);
            }
        };
        window.removeEventListener = function(eventName, callback)
        {
            console.log("The new window.removeEventListener has been called.");
            if (eventName === "gamepadconnected" || eventName === "gamepaddisconnected")
            {
                window.ext.Gamepad.removeEventListener(eventName, callback);
            }
            else
            {
                var argumentsArray = Array.prototype.slice.call(arguments);
                CocoonJS.Gamepad.originalWindowRemoveEventListener.apply(window, argumentsArray);
            }
        };
    } 
    else if (systemSupportsGamepads) 
    {
        if (!navigator.getGamepads)
        {
            console.log("navigator.getGamepads does not exist.");
            if (navigator.webkitGetGamepads)
            {
                console.log("navigator.webkitGamepads exists, adding navigator.getGamepads to point to it.");
                navigator.getGamepads = navigator.webkitGetGamepads;
            }
            else
            {
                console.log("navigator.webkitGetGamepads does not exist either.");
            }
        }
    }
})();

//////////////////////////////
// COCOONJS_NOTIFICATION.JS //
//////////////////////////////

(function()
{
    // The CocoonJS must exist before creating the extension.
    if (typeof window.CocoonJS === 'undefined' || window.CocoonJS === null) throw("The CocoonJS object must exist and be valid before creating any extension object.");

    /**
    * This namespace represents the CocoonJS Notification extension.
    * @namespace
    */
    CocoonJS.Notification = {};

    CocoonJS.Notification.nativeExtensionObjectAvailable = CocoonJS.nativeExtensionObjectAvailable && typeof window.ext.IDTK_SRV_NOTIFICATION !== 'undefined';

	/**
	* The data structure that represents the information of a local notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {string} contentBody The body content to be showed in the expanded notification information.
	* @param {string} contentTitle The title to be showed in the expanded notification information.
	* @param {number} date Time in millisecs from 1970 when the notification will be fired.
	*/
	CocoonJS.Notification.LocalNotification = function(message, soundEnabled, badgeNumber, userData, contentBody, contentTitle, scheduleTime)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* (iOS only) The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData;

		/**
		* (Android only) The body content to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentBody !== undefined)
			this.contentBody = contentBody;
		else
			this.contentBody = "";

		/**
		* (Android only) The title to be showed in the expanded notification information.
		* @field
		* @type string
		*/
		if (contentTitle !== undefined)
			this.contentTitle = contentTitle;
		else
			this.contentTitle = "";

		/**
		* Time in millisecs from 1970 when the local notification will be fired
		* @field
		* @type number
		*/
		var currentTime = new Date().getTime();
		if (scheduleTime !== undefined){
			this.scheduleTime = scheduleTime;
		}else{
			this.scheduleTime = currentTime;
		}
	};

	/**
	* The data structure that represents the information of a push notification.
	* @namespace
	* @constructor
	* @param {string} message The notification message.
	* @param {boolean} soundEnabled A flag that indicates if the sound should be enabled for the notification.
	* @param {number} badgeNumber The number that will appear in the badge of the application icon in the home screen.
	* @param {object} userData The JSON data to attached to the notification.
	* @param {array} channels An array containing the channels names this notification will be delivered to.
	* @param {number} expirationTime A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	* @param {number} expirationTimeInterval An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
	*/
	CocoonJS.Notification.PushNotification = function(message, soundEnabled, badgeNumber, userData, channels, expirationTime, expirationTimeInterval)
	{
		/**
		* The notification message.
		* @field
		* @type string
		*/
		this.message = message;

		/**
		* A flag that indicates if the sound should be enabled for the notification.
		* @field
		* @type boolean
		*/
		this.soundEnabled = soundEnabled;

		/**
		* The number that will appear in the badge of the application icon in the home screen.
		* @field
		* @type number
		*/
		this.badgeNumber = badgeNumber;

		/**
		* The JSON data to attached to the notification.
		* @field
		* @type object
		*/
		this.userData = userData

		/**
		* An array containing the channels names this notification will be delivered to.
		* @field
		* @type array
		*/
		this.channels = channels;

		/**
		* A time in seconds from 1970 when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTime !== undefined)
			this.expirationTime = expirationTime;
		else
			this.expirationTime = 0;

		/**
		* An incremental ammount of time in from now when the notification is no longer valid and will not be delivered in case it has not already been delivered.
		* @field
		* @type number
		*/
		if (expirationTimeInterval !== undefined)
			this.expirationTimeInterval = expirationTimeInterval;
		else
			this.expirationTimeInterval = 0;
	};

	/**
	* Start processing received notifications. The user must call this method when the game is ready to process notifications. Notifications received before being prepared are stored and processed later.
	*/
	CocoonJS.Notification.start = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "start", arguments, true);
		}
	};


	/**
	* Register to be able to receive push notifications.
	* The registration process is controlled using the {@link CocoonJS.Notification.onRegisterForPushNotificationsSucceed} and {@link CocoonJS.Notification.onRegisterForPushNotificationsFailed} event handlers.
	* @function
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsSucceed}
	* @see {CocoonJS.Notification.onRegisterForPushNotificationsFailed}
	*/
	CocoonJS.Notification.registerForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "registerForPushNotifications", arguments, true);
		}
	};

	/**
	* Unregister from receiving push notifications.
	* The unregistration process is controlled using the {@link CocoonJS.Notification.onUnregisterForPushNotificationsSucceed} event handler.
	* @function
	* @see CocoonJS.Notification.onUnregisterForPushNotificationsSucceed
	*/
	CocoonJS.Notification.unregisterForPushNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unregisterForPushNotifications", arguments, true);
		}
	};

	/**
	* Cancel the last sent local notification.
	* The last sent local notification will be remove from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelLastSentLocalNotificiation = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelLocalNotification", arguments, true);
		}
	};

	/**
	* Cancel all sent local notifications.
	* All the notifications will ve removed from the notifications bar.
	* @function
	*/
	CocoonJS.Notification.cancelAllLocalNotifications = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "cancelAllLocalNotifications", arguments, true);
		}
	};

	/**
	* Send a local notification.
	* @function
	* @param {CocoonJS.Notification.LocalNotification} localNotification The local notification to be sent.
	*/
	CocoonJS.Notification.sendLocalNotification = function(localNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendLocalNotification", arguments, true);
		}
	};

	/**
	* Subscribe to a channel in order to receive notifications targeted to that channel.
	* @function
	* @param {string} channel The channel id to subscribe to.
	*/
	CocoonJS.Notification.subscribeToChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "subscribe", arguments, true);
		}
	};

	/**
	* Unsubscribe from a channel in order to stop receiving notifications targeted to it.
	* @function
	* @param {string} channel The channel id to unsubscribe from.
	*/
	CocoonJS.Notification.unsubscribeFromChannel = function(channel)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "unsubscribe", arguments, true);
		}
	};

	/**
	* Send a push notification.
	* @function
	* @param {CocoonJS.Notification.PushNotification} pushNotification The push notification object to be sent.
	* @see CocoonJS.Notification.onPushNotificationDeliverySucceed
	* @see CocoonJS.Notification.onPushNotificationDeliveryFailed
	*/
	CocoonJS.Notification.sendPushNotification = function(pushNotification)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "sendPushNotification", arguments, true);
		}
	};

	/**
	* (iOS only) Set the badge number for this application.
	* This is useful if you want to modify the badge number set by a notification.
	* @function
	* @param {number} badgeNumber The number of the badge.
	*/
	CocoonJS.Notification.setBadgeNumber = function(badgeNumber)
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "setBadgeNumber", arguments);
		}
	};

	/**
	* (iOS only) Returns the current badge number.
	* @function
	* @returns {number} The badge number.
	*/
	CocoonJS.Notification.getBadgeNumber = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getBadgeNumber", arguments);
		}
	};

	/**
	* Returns the last received user data from a Local notification.
	* @function
	* @returns {object} The last received user data from a Local notification.
	*/
	CocoonJS.Notification.getLastReceivedLocalNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedLocalNotificationData", arguments);
		}
	};

	/**
	* Returns the last received user data from a Push notification.
	* @function
	* @returns {object} The last received user data from a Push notification.
	*/
	CocoonJS.Notification.getLastReceivedPushNotificationData = function()
	{
		if (CocoonJS.Notification.nativeExtensionObjectAvailable)
		{
			return CocoonJS.makeNativeExtensionObjectFunctionCall("IDTK_SRV_NOTIFICATION", "getLastReceivedPushNotificationData", arguments);
		}
	};

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notification succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @param {string} token The token (apid or device token) received at registration time.
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onRegisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceRegistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the unregistration for push notifications succeeds.
    * The callback function does not receive any parameter.
    * @static
    * @event
    * @memberOf CocoonJS.Notification
    */
	CocoonJS.Notification.onUnregisterForPushNotificationsSucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceUnregistered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the registration for push notifications fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onRegisterForPushNotificationsFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationServiceFailedToRegister");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a push notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a local notification is received.
    * The callback function receives a parameter with the userData of the received notification.
    * @static
    * @event
    * @param {object} userData An object with the notification userData information.
    */
	CocoonJS.Notification.onLocalNotificationReceived = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "localNotificationReceived");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when a notification is successfully delivered.
    * The callback function receives a parameter with the notificationId of the delivered notification.
    * @static
    * @event
    * @param {string} userData A string with the notification userData information.
    */
	CocoonJS.Notification.onPushNotificationDeliverySucceed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationSuccessfullyDelivered");

    /**
    * This {@link CocoonJS.EventHandler} object allows listening to events called when the delivery of push a notification fails.
    * The callback function receives a parameter with error information.
    * @static
    * @event
    * @param {string} msg The error message.
    */
	CocoonJS.Notification.onPushNotificationDeliveryFailed = new CocoonJS.EventHandler("IDTK_SRV_NOTIFICATION", "Notification", "pushNotificationDeliveryError");

})();

/////////////////
// PATHFIND.JS //
/////////////////

// Pathfind.js
// Written by Ashley Gullen
// Copyright (c) 2013 Scirra Ltd.

// A* pathfinding javascript implementation

(function() {
	
	var PF_CLEAR = 0;
	var PF_OBSTACLE = 32767;
	
	function node()
	{
		this.parent = null;
		
		this.x = 0;
		this.y = 0;

		this.f = 0;
		this.g = 0;
		this.h = 0;
	};
	
	var nodeCache = [];			// for recycling nodes
	
	function allocNode()
	{
		var ret;
		
		if (nodeCache.length)
			ret = nodeCache.pop();
		else
			ret = new node();
			
		ret.parent = null;
		ret.x = 0;
		ret.y = 0;
		ret.f = 0;
		ret.g = 0;
		ret.h = 0;
		return ret;
	};
	
	function freeNode(n)
	{
		if (nodeCache.length < 64000)
			nodeCache.push(n);
	};
	
	function resultNode(x_, y_)
	{
		this.x = x_ || 0;
		this.y = y_ || 0;
	};
	
	var resultNodeCache = [];			// for recycling resultNodes
	
	function allocResultNode()
	{
		if (resultNodeCache.length)
			return resultNodeCache.pop();
		else
			return new resultNode(0, 0);
	};
	
	function freeResultNode(n)
	{
		if (resultNodeCache.length < 10000)
			resultNodeCache.push(n);
	};
	
	var workersSupported = (typeof Worker !== "undefined");
	var isInWebWorker = (typeof document === "undefined");		// no DOM in a worker
	var myInstance = null;										// single pathfinder instance for worker
	
	if (isInWebWorker)
	{
		self.addEventListener("message", function (e)
		{
			var d = e.data;
			
			if (!d)
				return;		// could be empty postMessage() to start worker
			
			if (d.cmd === "init")
			{
				if (!myInstance)
					myInstance = new pathfinder();
					
				myInstance.init(d.hcells, d.vcells, d.data, d.diagonals);
			}
			else if (d.cmd === "find")
			{
				// receive a pathfind job, process it them dispatch result
				myInstance.pathEnd.parent = null;
				myInstance.targetX = d.endX;
				myInstance.targetY = d.endY;
				
				if (myInstance.doLongFindPath(d.startX, d.startY))
				{
					self.postMessage({ cmd: "result", pathList: myInstance.pathList });
				}
				else
				{
					self.postMessage({ cmd: "result", pathList: null });
				}
			}
			else if (d.cmd === "setdiag")
			{
				// update diagonalsEnabled flag
				myInstance.diagonalsEnabled = d.diagonals;
			}
			
		}, false);
	}
	
	function pathfinder()
	{
		this.hcells = 0;
		this.vcells = 0;
		
		this.pathEnd = allocNode();
		
		this.cells = null;
		this.openList = [];
		this.closedList = [];
		this.closedCache = {};
		this.pathList = [];
		
		this.currentNode = null;
		this.targetX = 0;
		this.targetY = 0;
		this.diagonalsEnabled = true;
		
		this.worker = null;
		this.workerQueue = [];		// jobs awaiting completion from worker in order of requests made
		this.workerRecycle = [];
		
		var self = this;
		var i, len;
		
		if (workersSupported && !isInWebWorker)
		{
			// Create worker and receive results of pathfind jobs from it
			this.worker = new Worker("pathfind.js");
			
			this.worker.addEventListener("message", function (e) {
			
				if (!e || !e.data)
					return;
				
				if (e.data.cmd === "result")
				{
					if (e.data.pathList)
					{
						for (i = 0, len = self.pathList.length; i < len; i++)
							freeResultNode(self.pathList[i]);
						
						self.pathList = e.data.pathList;
						self.workerQueue[0].success();
					}
					else
						self.workerQueue[0].fail();
						
					self.workerRecycle.push(self.workerQueue.shift());
				}
			}, false);
			
			this.worker.addEventListener("error", function (e) {
				console.error(e);
			}, false);
			
			this.worker.postMessage(null);
		}
	};
	
	pathfinder.prototype.init = function (hcells_, vcells_, data_, diagonals_)
	{
		this.hcells = hcells_;
		this.vcells = vcells_;
		this.cells = data_;
		this.diagonalsEnabled = diagonals_;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "init",
				hcells: hcells_,
				vcells: vcells_,
				diagonals: diagonals_,
				data: data_
			});
		}
	};
	
	pathfinder.prototype.isReady = function ()
	{
		return !!this.cells;
	};
	
	pathfinder.prototype.setDiagonals = function (d)
	{
		if (this.diagonalsEnabled === d)
			return;
		
		this.diagonalsEnabled = d;
		
		if (workersSupported && !isInWebWorker)
		{
			this.worker.postMessage({
				cmd: "setdiag",
				diagonals: d,
			});
		}
	};
	
	pathfinder.prototype.at = function (x_, y_)
	{
		if (x_ < 0 || y_ < 0 || x_ >= this.hcells || y_ >= this.vcells)
			return PF_OBSTACLE;
			
		return this.cells[x_][y_];
	};
	
	pathfinder.prototype.findPath = function (startX, startY, endX, endY, successCallback, failCallback)
	{
		if (!this.cells)
		{
			// not yet initialised
			failCallback();
			return;
		}
		
		startX = Math.floor(startX);
		startY = Math.floor(startY);
		endX = Math.floor(endX);
		endY = Math.floor(endY);
		
		this.targetX = endX;
		this.targetY = endY;
		this.pathEnd.parent = null;
		
		// Check the box made by the start and dest cells.
		// If the complete box is empty, allow a direct move to target.
		var minX = Math.min(startX, endX);
		var maxX = Math.max(startX, endX);
		var minY = Math.min(startY, endY);
		var maxY = Math.max(startY, endY);
		
		// Path goes out of bounds: no calculable path
		if (minX < 0 || minY < 0 || maxX >= this.hcells || maxY >= this.vcells)
		{
			failCallback();
			return;
		}
		
		var x, y, i, len, c, h, n;

		if (this.diagonalsEnabled)
		{
			var canMoveDirect = true;
			
			for (x = minX; x <= maxX; x++)
			{
				for (y = minY; y <= maxY; y++)
				{
					if (this.cells[x][y] !== 0)
					{
						canMoveDirect = false;
						
						// Break both loops
						x = maxX + 1;
						break;
					}
				}
			}

			// A "direct" path is available (box is empty)
			if (canMoveDirect)
			{
				for (i = 0, len = this.pathList.length; i < len; i++)
					freeResultNode(this.pathList[i]);
				this.pathList.length = 0;
			
				this.pathEnd.x = endX;
				this.pathEnd.y = endY;
				this.pathEnd.parent = null;
				n = allocResultNode();
				n.x = endX;
				n.y = endY;
				this.pathList.push(n);
				successCallback();
				return;
			}
		}
		
		if (workersSupported)
		{
			// recycle objects in the worker queue
			if (this.workerRecycle.length)
				h = this.workerRecycle.pop();
			else
				h = {};
			
			h.success = successCallback;
			h.fail = failCallback;
			
			// dispatch the heavy lifting to the worker thread
			this.workerQueue.push(h);

			this.worker.postMessage({
				cmd: "find",
				startX: startX,
				startY: startY,
				endX: endX,
				endY: endY
			});
		}
		else
		{
			// no web worker support, just run on main thread
			if (this.doLongFindPath(startX, startY))
				successCallback();
			else
				failCallback();
		}
	};
		
	pathfinder.prototype.doLongFindPath = function (startX, startY)
	{
		var i, len, c, n, p, lastDir = 8, curDir = -1, addNode;
		for (i = 0, len = this.openList.length; i < len; i++)
			freeNode(this.openList[i]);
		for (i = 0, len = this.closedList.length; i < len; i++)
			freeNode(this.closedList[i]);
		for (i = 0, len = this.pathList.length; i < len; i++)
			freeResultNode(this.pathList[i]);
		this.openList.length = 0;
		this.closedList.length = 0;
		this.closedCache = {};
		this.pathList.length = 0;

		// Add the start node to the open list
		var startNode = allocNode();
		startNode.x = startX;
		startNode.y = startY;

		this.openList.push(startNode);
		var obsLeft = false, obsTop = false, obsRight = false, obsBottom = false;
		var diagonals = this.diagonalsEnabled;
		
		// While there are nodes on the open list
		while (this.openList.length)
		{
			// Move the best F value to closed list
			c = this.openList.shift();
			this.closedList.unshift(c);
			this.closedCache[((c.x << 16) + c.y).toString()] = true;

			// Are we there yet?
			if (c.x === this.targetX && c.y === this.targetY)
			{
				this.pathEnd.parent = c.parent;
				this.pathEnd.x = c.x;
				this.pathEnd.y = c.y;
				
				// Link up the whole path to an indexable array
				p = this.pathEnd;
				
				while (p)
				{
					// filter redundant nodes in straight lines
					if (this.pathList.length === 0)
					{
						addNode = true;
						
						if (p.parent)
						{
							lastDir = this.nodeDirection(p, p.parent);
							curDir = lastDir;
						}
					}
					else if (!p.parent)
						addNode = false;
					else 
					{
						curDir = this.nodeDirection(p, p.parent);
						addNode = (curDir !== lastDir);
					}
					
					if (addNode)
					{
						n = allocResultNode();
						n.x = p.x;
						n.y = p.y;
						this.pathList.unshift(n);
						lastDir = curDir;
					}
					
					p = p.parent;
				}
				
				return true;
			}

			// Get current node
			this.currentNode = c;
			var x = c.x;
			var y = c.y;
			
			var obsLeft = (this.at(x - 1, y) === PF_OBSTACLE);
			var obsTop = (this.at(x, y - 1) === PF_OBSTACLE);
			var obsRight = (this.at(x + 1, y) === PF_OBSTACLE);
			var obsBottom = (this.at(x, y + 1) === PF_OBSTACLE);

			// Check adjacent 8 nodes.  No diagonals allowed if either cell being crossed is obstacle.
			if (!obsLeft)
				this.addCellToOpenList(x - 1, y, 10);

			if (diagonals && !obsLeft && !obsTop)
				this.addCellToOpenList(x - 1, y - 1, 14);

			if (!obsTop)
				this.addCellToOpenList(x, y - 1, 10);

			if (diagonals && !obsTop && !obsRight)
				this.addCellToOpenList(x + 1, y - 1, 14);

			if (!obsRight)
				this.addCellToOpenList(x + 1, y, 10);

			if (diagonals && !obsRight && !obsBottom)
				this.addCellToOpenList(x + 1, y + 1, 14);

			if (!obsBottom)
				this.addCellToOpenList(x, y + 1, 10);

			if (diagonals && !obsBottom && !obsLeft)
				this.addCellToOpenList(x - 1, y + 1, 14);
		}
		
		return false;
	};
	
	pathfinder.prototype.insertToOpenList = function (c)
	{
		var i, len;
		
		// Needs to go at end
		if (c.f >= this.openList[this.openList.length - 1].f)
		{
			this.openList.push(c);
		}
		else
		{
			for (i = 0, len = this.openList.length; i < len; i++)
			{
				if (c.f < this.openList[i].f)
				{
					this.openList.splice(i, 0, c);
					break;
				}
			}
		}
	};
	
	pathfinder.prototype.addCellToOpenList = function (x_, y_, g_)
	{
		// Ignore if cell on closed list
		if (this.closedCache.hasOwnProperty(((x_ << 16) + y_).toString()))
			return;
		
		var i, len, c;
		
		// Cell costs can be increased by changing the number in the map
		var curCellCost = this.at(x_, y_);

		// Is this cell already on the open list?
		for (i = 0, len = this.openList.length; i < len; i++)
		{
			c = this.openList[i];
			
			if (x_ === c.x && y_ === c.y)
			{
				// Is this a better path?
				if (this.currentNode.g + g_ + curCellCost < c.g)
				{
					// Update F, G and H and update parent
					c.parent = this.currentNode;
					c.g = this.currentNode.g + g_ + curCellCost;
					c.h = this.estimateH(c.x, c.y);
					c.f = c.g + c.h;

					// This node's F has changed:  Delete it then re-insert it in the right place

					if (this.openList.length === 1)
					{
						// no need to remove then re-insert same node, just leave it there
						return;
					}
					
					this.openList.splice(i, 1);
					this.insertToOpenList(c);
				}

				return;
			}
		}

		// Not on the open list; add it in the right place
		c = allocNode();
		c.x = x_;
		c.y = y_;
		c.h = this.estimateH(x_, y_);
		c.g = this.currentNode.g + g_ + curCellCost;
		c.f = c.h + c.g;
		c.parent = this.currentNode;

		// Insert this node sorted in the open list
		// The loop below won't add new largest F values
		if (!this.openList.length)
		{
			this.openList.push(c);
			return;
		}
		
		this.insertToOpenList(c);
	};
	
	function quickAbs(x)
	{
		return x < 0 ? -x : x;
	};
	
	pathfinder.prototype.estimateH = function (x_, y_)
	{
		var dx = quickAbs(x_ - this.targetX);
		var dy = quickAbs(y_ - this.targetY);

		return dx * 10 + dy * 10;
	};
	
	pathfinder.prototype.nodeDirection = function (a, b)
	{
		var ax = a.x;
		var ay = a.y;
		var bx = b.x;
		var by = b.y;

		if (ax === bx)
		{
			if (by > ay) return 6;
			if (by < ay) return 2;
			if (ay == by) return 8;
		}
		else if (ay === by)
		{
			if (bx > ax) return 4;
			if (by < ax) return 0;
		}
		else
		{
			if (bx < ax && by < ay) return 1;
			if (bx > ax && by < ay) return 3;
			if (bx < ax && by > ay) return 7;
			if (bx > ax && by > ay) return 5;
		}
		return 8;
	};
	
	if (!isInWebWorker)
	{
		window.PF_CLEAR = PF_CLEAR;
		window.PF_OBSTACLE = PF_OBSTACLE;
		window.Pathfinder = pathfinder;
		
		window.ResultNode = resultNode;
		window.allocResultNode = allocResultNode;
		window.freeResultNode = freeResultNode;
	}

})();
(function() {
var cr = {};
cr.plugins_ = {};
cr.behaviors = {};
if (typeof Object.getPrototypeOf !== "function")
{
	if (typeof "test".__proto__ === "object")
	{
		Object.getPrototypeOf = function(object) {
			return object.__proto__;
		};
	}
	else
	{
		Object.getPrototypeOf = function(object) {
			return object.constructor.prototype;
		};
	}
}
(function(){
	cr.logexport = function (msg)
	{
		if (window.console && window.console.log)
			window.console.log(msg);
	};
	cr.seal = function(x)
	{
		return x;
	};
	cr.freeze = function(x)
	{
		return x;
	};
	cr.is_undefined = function (x)
	{
		return typeof x === "undefined";
	};
	cr.is_number = function (x)
	{
		return typeof x === "number";
	};
	cr.is_string = function (x)
	{
		return typeof x === "string";
	};
	cr.isPOT = function (x)
	{
		return x > 0 && ((x - 1) & x) === 0;
	};
	cr.nextHighestPowerOfTwo = function(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	cr.abs = function (x)
	{
		return (x < 0 ? -x : x);
	};
	cr.max = function (a, b)
	{
		return (a > b ? a : b);
	};
	cr.min = function (a, b)
	{
		return (a < b ? a : b);
	};
	cr.PI = Math.PI;
	cr.round = function (x)
	{
		return (x + 0.5) | 0;
	};
	cr.floor = function (x)
	{
		if (x >= 0)
			return x | 0;
		else
			return (x | 0) - 1;		// correctly round down when negative
	};
	cr.ceil = function (x)
	{
		var f = x | 0;
		return (f === x ? f : f + 1);
	};
	function Vector2(x, y)
	{
		this.x = x;
		this.y = y;
		cr.seal(this);
	};
	Vector2.prototype.offset = function (px, py)
	{
		this.x += px;
		this.y += py;
		return this;
	};
	Vector2.prototype.mul = function (px, py)
	{
		this.x *= px;
		this.y *= py;
		return this;
	};
	cr.vector2 = Vector2;
	cr.segments_intersect = function(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y)
	{
		var max_ax, min_ax, max_ay, min_ay, max_bx, min_bx, max_by, min_by;
		if (a1x < a2x)
		{
			min_ax = a1x;
			max_ax = a2x;
		}
		else
		{
			min_ax = a2x;
			max_ax = a1x;
		}
		if (b1x < b2x)
		{
			min_bx = b1x;
			max_bx = b2x;
		}
		else
		{
			min_bx = b2x;
			max_bx = b1x;
		}
		if (max_ax < min_bx || min_ax > max_bx)
			return false;
		if (a1y < a2y)
		{
			min_ay = a1y;
			max_ay = a2y;
		}
		else
		{
			min_ay = a2y;
			max_ay = a1y;
		}
		if (b1y < b2y)
		{
			min_by = b1y;
			max_by = b2y;
		}
		else
		{
			min_by = b2y;
			max_by = b1y;
		}
		if (max_ay < min_by || min_ay > max_by)
			return false;
		var dpx = b1x - a1x + b2x - a2x;
		var dpy = b1y - a1y + b2y - a2y;
		var qax = a2x - a1x;
		var qay = a2y - a1y;
		var qbx = b2x - b1x;
		var qby = b2y - b1y;
		var d = cr.abs(qay * qbx - qby * qax);
		var la = qbx * dpy - qby * dpx;
		if (cr.abs(la) > d)
			return false;
		var lb = qax * dpy - qay * dpx;
		return cr.abs(lb) <= d;
	};
	function Rect(left, top, right, bottom)
	{
		this.set(left, top, right, bottom);
		cr.seal(this);
	};
	Rect.prototype.set = function (left, top, right, bottom)
	{
		this.left = left;
		this.top = top;
		this.right = right;
		this.bottom = bottom;
	};
	Rect.prototype.copy = function (r)
	{
		this.left = r.left;
		this.top = r.top;
		this.right = r.right;
		this.bottom = r.bottom;
	};
	Rect.prototype.width = function ()
	{
		return this.right - this.left;
	};
	Rect.prototype.height = function ()
	{
		return this.bottom - this.top;
	};
	Rect.prototype.offset = function (px, py)
	{
		this.left += px;
		this.top += py;
		this.right += px;
		this.bottom += py;
		return this;
	};
	Rect.prototype.normalize = function ()
	{
		var temp = 0;
		if (this.left > this.right)
		{
			temp = this.left;
			this.left = this.right;
			this.right = temp;
		}
		if (this.top > this.bottom)
		{
			temp = this.top;
			this.top = this.bottom;
			this.bottom = temp;
		}
	};
	Rect.prototype.intersects_rect = function (rc)
	{
		return !(rc.right < this.left || rc.bottom < this.top || rc.left > this.right || rc.top > this.bottom);
	};
	Rect.prototype.intersects_rect_off = function (rc, ox, oy)
	{
		return !(rc.right + ox < this.left || rc.bottom + oy < this.top || rc.left + ox > this.right || rc.top + oy > this.bottom);
	};
	Rect.prototype.contains_pt = function (x, y)
	{
		return (x >= this.left && x <= this.right) && (y >= this.top && y <= this.bottom);
	};
	Rect.prototype.equals = function (r)
	{
		return this.left === r.left && this.top === r.top && this.right === r.right && this.bottom === r.bottom;
	};
	cr.rect = Rect;
	function Quad()
	{
		this.tlx = 0;
		this.tly = 0;
		this.trx = 0;
		this.try_ = 0;	// is a keyword otherwise!
		this.brx = 0;
		this.bry = 0;
		this.blx = 0;
		this.bly = 0;
		cr.seal(this);
	};
	Quad.prototype.set_from_rect = function (rc)
	{
		this.tlx = rc.left;
		this.tly = rc.top;
		this.trx = rc.right;
		this.try_ = rc.top;
		this.brx = rc.right;
		this.bry = rc.bottom;
		this.blx = rc.left;
		this.bly = rc.bottom;
	};
	Quad.prototype.set_from_rotated_rect = function (rc, a)
	{
		if (a === 0)
		{
			this.set_from_rect(rc);
		}
		else
		{
			var sin_a = Math.sin(a);
			var cos_a = Math.cos(a);
			var left_sin_a = rc.left * sin_a;
			var top_sin_a = rc.top * sin_a;
			var right_sin_a = rc.right * sin_a;
			var bottom_sin_a = rc.bottom * sin_a;
			var left_cos_a = rc.left * cos_a;
			var top_cos_a = rc.top * cos_a;
			var right_cos_a = rc.right * cos_a;
			var bottom_cos_a = rc.bottom * cos_a;
			this.tlx = left_cos_a - top_sin_a;
			this.tly = top_cos_a + left_sin_a;
			this.trx = right_cos_a - top_sin_a;
			this.try_ = top_cos_a + right_sin_a;
			this.brx = right_cos_a - bottom_sin_a;
			this.bry = bottom_cos_a + right_sin_a;
			this.blx = left_cos_a - bottom_sin_a;
			this.bly = bottom_cos_a + left_sin_a;
		}
	};
	Quad.prototype.offset = function (px, py)
	{
		this.tlx += px;
		this.tly += py;
		this.trx += px;
		this.try_ += py;
		this.brx += px;
		this.bry += py;
		this.blx += px;
		this.bly += py;
		return this;
	};
	var minresult = 0;
	var maxresult = 0;
	function minmax4(a, b, c, d)
	{
		if (a < b)
		{
			if (c < d)
			{
				if (a < c)
					minresult = a;
				else
					minresult = c;
				if (b > d)
					maxresult = b;
				else
					maxresult = d;
			}
			else
			{
				if (a < d)
					minresult = a;
				else
					minresult = d;
				if (b > c)
					maxresult = b;
				else
					maxresult = c;
			}
		}
		else
		{
			if (c < d)
			{
				if (b < c)
					minresult = b;
				else
					minresult = c;
				if (a > d)
					maxresult = a;
				else
					maxresult = d;
			}
			else
			{
				if (b < d)
					minresult = b;
				else
					minresult = d;
				if (a > c)
					maxresult = a;
				else
					maxresult = c;
			}
		}
	};
	Quad.prototype.bounding_box = function (rc)
	{
		minmax4(this.tlx, this.trx, this.brx, this.blx);
		rc.left = minresult;
		rc.right = maxresult;
		minmax4(this.tly, this.try_, this.bry, this.bly);
		rc.top = minresult;
		rc.bottom = maxresult;
	};
	Quad.prototype.contains_pt = function (x, y)
	{
		var v0x = this.trx - this.tlx;
		var v0y = this.try_ - this.tly;
		var v1x = this.brx - this.tlx;
		var v1y = this.bry - this.tly;
		var v2x = x - this.tlx;
		var v2y = y - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		var dot11 = v1x * v1x + v1y * v1y
		var dot12 = v1x * v2x + v1y * v2y
		var invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		var u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		var v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		if ((u >= 0.0) && (v > 0.0) && (u + v < 1))
			return true;
		v0x = this.blx - this.tlx;
		v0y = this.bly - this.tly;
		var dot00 = v0x * v0x + v0y * v0y
		var dot01 = v0x * v1x + v0y * v1y
		var dot02 = v0x * v2x + v0y * v2y
		invDenom = 1.0 / (dot00 * dot11 - dot01 * dot01);
		u = (dot11 * dot02 - dot01 * dot12) * invDenom;
		v = (dot00 * dot12 - dot01 * dot02) * invDenom;
		return (u >= 0.0) && (v > 0.0) && (u + v < 1);
	};
	Quad.prototype.at = function (i, xory)
	{
		if (xory)
		{
			switch (i)
			{
				case 0: return this.tlx;
				case 1: return this.trx;
				case 2: return this.brx;
				case 3: return this.blx;
				case 4: return this.tlx;
				default: return this.tlx;
			}
		}
		else
		{
			switch (i)
			{
				case 0: return this.tly;
				case 1: return this.try_;
				case 2: return this.bry;
				case 3: return this.bly;
				case 4: return this.tly;
				default: return this.tly;
			}
		}
	};
	Quad.prototype.midX = function ()
	{
		return (this.tlx + this.trx  + this.brx + this.blx) / 4;
	};
	Quad.prototype.midY = function ()
	{
		return (this.tly + this.try_ + this.bry + this.bly) / 4;
	};
	Quad.prototype.intersects_segment = function (x1, y1, x2, y2)
	{
		if (this.contains_pt(x1, y1) || this.contains_pt(x2, y2))
			return true;
		var a1x, a1y, a2x, a2y;
		var i;
		for (i = 0; i < 4; i++)
		{
			a1x = this.at(i, true);
			a1y = this.at(i, false);
			a2x = this.at(i + 1, true);
			a2y = this.at(i + 1, false);
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	Quad.prototype.intersects_quad = function (rhs)
	{
		var midx = rhs.midX();
		var midy = rhs.midY();
		if (this.contains_pt(midx, midy))
			return true;
		midx = this.midX();
		midy = this.midY();
		if (rhs.contains_pt(midx, midy))
			return true;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		var i, j;
		for (i = 0; i < 4; i++)
		{
			for (j = 0; j < 4; j++)
			{
				a1x = this.at(i, true);
				a1y = this.at(i, false);
				a2x = this.at(i + 1, true);
				a2y = this.at(i + 1, false);
				b1x = rhs.at(j, true);
				b1y = rhs.at(j, false);
				b2x = rhs.at(j + 1, true);
				b2y = rhs.at(j + 1, false);
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	cr.quad = Quad;
	cr.RGB = function (red, green, blue)
	{
		return Math.max(Math.min(red, 255), 0)
			 | (Math.max(Math.min(green, 255), 0) << 8)
			 | (Math.max(Math.min(blue, 255), 0) << 16);
	};
	cr.GetRValue = function (rgb)
	{
		return rgb & 0xFF;
	};
	cr.GetGValue = function (rgb)
	{
		return (rgb & 0xFF00) >> 8;
	};
	cr.GetBValue = function (rgb)
	{
		return (rgb & 0xFF0000) >> 16;
	};
	cr.shallowCopy = function (a, b, allowOverwrite)
	{
		var attr;
		for (attr in b)
		{
			if (b.hasOwnProperty(attr))
			{
;
				a[attr] = b[attr];
			}
		}
		return a;
	};
	cr.arrayRemove = function (arr, index)
	{
		var i, len;
		index = cr.floor(index);
		if (index < 0 || index >= arr.length)
			return;							// index out of bounds
		if (index === 0)					// removing first item
			arr.shift();
		else if (index === arr.length - 1)	// removing last item
			arr.pop();
		else
		{
			for (i = index, len = arr.length - 1; i < len; i++)
				arr[i] = arr[i + 1];
			arr.length = len;
		}
	};
	cr.shallowAssignArray = function (dest, src)
	{
		dest.length = src.length;
		var i, len;
		for (i = 0, len = src.length; i < len; i++)
			dest[i] = src[i];
	};
	cr.appendArray = function (a, b)
	{
		a.push.apply(a, b);
	};
	cr.arrayFindRemove = function (arr, item)
	{
		var index = arr.indexOf(item);
		if (index !== -1)
			cr.arrayRemove(arr, index);
	};
	cr.clamp = function(x, a, b)
	{
		if (x < a)
			return a;
		else if (x > b)
			return b;
		else
			return x;
	};
	cr.to_radians = function(x)
	{
		return x / (180.0 / cr.PI);
	};
	cr.to_degrees = function(x)
	{
		return x * (180.0 / cr.PI);
	};
	cr.clamp_angle_degrees = function (a)
	{
		a %= 360;       // now in (-360, 360) range
		if (a < 0)
			a += 360;   // now in [0, 360) range
		return a;
	};
	cr.clamp_angle = function (a)
	{
		a %= 2 * cr.PI;       // now in (-2pi, 2pi) range
		if (a < 0)
			a += 2 * cr.PI;   // now in [0, 2pi) range
		return a;
	};
	cr.to_clamped_degrees = function (x)
	{
		return cr.clamp_angle_degrees(cr.to_degrees(x));
	};
	cr.to_clamped_radians = function (x)
	{
		return cr.clamp_angle(cr.to_radians(x));
	};
	cr.angleTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.atan2(dy, dx);
	};
	cr.angleDiff = function (a1, a2)
	{
		if (a1 === a2)
			return 0;
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		var n = s1 * s2 + c1 * c2;
		if (n >= 1)
			return 0;
		if (n <= -1)
			return cr.PI;
		return Math.acos(n);
	};
	cr.angleRotate = function (start, end, step)
	{
		var ss = Math.sin(start);
		var cs = Math.cos(start);
		var se = Math.sin(end);
		var ce = Math.cos(end);
		if (Math.acos(ss * se + cs * ce) > step)
		{
			if (cs * se - ss * ce > 0)
				return cr.clamp_angle(start + step);
			else
				return cr.clamp_angle(start - step);
		}
		else
			return cr.clamp_angle(end);
	};
	cr.angleClockwise = function (a1, a2)
	{
		var s1 = Math.sin(a1);
		var c1 = Math.cos(a1);
		var s2 = Math.sin(a2);
		var c2 = Math.cos(a2);
		return c1 * s2 - s1 * c2 <= 0;
	};
	cr.rotatePtAround = function (px, py, a, ox, oy, getx)
	{
		if (a === 0)
			return getx ? px : py;
		var sin_a = Math.sin(a);
		var cos_a = Math.cos(a);
		px -= ox;
		py -= oy;
		var left_sin_a = px * sin_a;
		var top_sin_a = py * sin_a;
		var left_cos_a = px * cos_a;
		var top_cos_a = py * cos_a;
		px = left_cos_a - top_sin_a;
		py = top_cos_a + left_sin_a;
		px += ox;
		py += oy;
		return getx ? px : py;
	}
	cr.distanceTo = function(x1, y1, x2, y2)
	{
		var dx = x2 - x1;
        var dy = y2 - y1;
		return Math.sqrt(dx*dx + dy*dy);
	};
	cr.xor = function (x, y)
	{
		return !x !== !y;
	};
	cr.lerp = function (a, b, x)
	{
		return a + (b - a) * x;
	};
	cr.unlerp = function (a, b, c)
	{
		if (a === b)
			return 0;		// avoid divide by 0
		return (c - a) / (b - a);
	};
	cr.anglelerp = function (a, b, x)
	{
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			return a + diff * x;
		}
		else
		{
			return a - diff * x;
		}
	};
	cr.hasAnyOwnProperty = function (o)
	{
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
				return true;
		}
		return false;
	};
	cr.wipe = function (obj)
	{
		var p;
		for (p in obj)
		{
			if (obj.hasOwnProperty(p))
				delete obj[p];
		}
	};
	var startup_time = +(new Date());
	cr.performance_now = function()
	{
		if (typeof window["performance"] !== "undefined")
		{
			var winperf = window["performance"];
			if (typeof winperf.now !== "undefined")
				return winperf.now();
			else if (typeof winperf["webkitNow"] !== "undefined")
				return winperf["webkitNow"]();
			else if (typeof winperf["mozNow"] !== "undefined")
				return winperf["mozNow"]();
			else if (typeof winperf["msNow"] !== "undefined")
				return winperf["msNow"]();
		}
		return Date.now() - startup_time;
	};
	var supports_set = ((typeof window === "undefined" || !window["c2ejecta"]) && (typeof Set !== "undefined" && typeof Set.prototype["forEach"] !== "undefined"));
	function ObjectSet_()
	{
		this.s = null;
		this.items = null;			// lazy allocated (hopefully results in better GC performance)
		this.item_count = 0;
		if (supports_set)
		{
			this.s = new Set();
		}
		this.values_cache = [];
		this.cache_valid = true;
		cr.seal(this);
	};
	ObjectSet_.prototype.contains = function (x)
	{
		if (this.isEmpty())
			return false;
		if (supports_set)
			return this.s["has"](x);
		else
			return (this.items && this.items.hasOwnProperty(x));
	};
	ObjectSet_.prototype.add = function (x)
	{
		if (supports_set)
		{
			if (!this.s["has"](x))
			{
				this.s["add"](x);
				this.cache_valid = false;
			}
		}
		else
		{
			var str = x.toString();
			var items = this.items;
			if (!items)
			{
				this.items = {};
				this.items[str] = x;
				this.item_count = 1;
				this.cache_valid = false;
			}
			else if (!items.hasOwnProperty(str))
			{
				items[str] = x;
				this.item_count++;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.remove = function (x)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			if (this.s["has"](x))
			{
				this.s["delete"](x);
				this.cache_valid = false;
			}
		}
		else if (this.items)
		{
			var str = x.toString();
			var items = this.items;
			if (items.hasOwnProperty(str))
			{
				delete items[str];
				this.item_count--;
				this.cache_valid = false;
			}
		}
	};
	ObjectSet_.prototype.clear = function (/*wipe_*/)
	{
		if (this.isEmpty())
			return;
		if (supports_set)
		{
			this.s["clear"]();			// best!
		}
		else
		{
				this.items = null;		// creates garbage; will lazy allocate on next add()
			this.item_count = 0;
		}
		this.values_cache.length = 0;
		this.cache_valid = true;
	};
	ObjectSet_.prototype.isEmpty = function ()
	{
		return this.count() === 0;
	};
	ObjectSet_.prototype.count = function ()
	{
		if (supports_set)
			return this.s["size"];
		else
			return this.item_count;
	};
	var current_arr = null;
	var current_index = 0;
	function set_append_to_arr(x)
	{
		current_arr[current_index++] = x;
	};
	ObjectSet_.prototype.update_cache = function ()
	{
		if (this.cache_valid)
			return;
		if (supports_set)
		{
			this.values_cache.length = this.s["size"];
			current_arr = this.values_cache;
			current_index = 0;
			this.s["forEach"](set_append_to_arr);
;
			current_arr = null;
			current_index = 0;
		}
		else
		{
			var values_cache = this.values_cache;
			values_cache.length = this.item_count;
			var p, n = 0, items = this.items;
			if (items)
			{
				for (p in items)
				{
					if (items.hasOwnProperty(p))
						values_cache[n++] = items[p];
				}
			}
;
		}
		this.cache_valid = true;
	};
	ObjectSet_.prototype.valuesRef = function ()
	{
		this.update_cache();
		return this.values_cache;
	};
	cr.ObjectSet = ObjectSet_;
	function KahanAdder_()
	{
		this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
		cr.seal(this);
	};
	KahanAdder_.prototype.add = function (v)
	{
		this.y = v - this.c;
	    this.t = this.sum + this.y;
	    this.c = (this.t - this.sum) - this.y;
	    this.sum = this.t;
	};
    KahanAdder_.prototype.reset = function ()
    {
        this.c = 0;
        this.y = 0;
        this.t = 0;
        this.sum = 0;
    };
	cr.KahanAdder = KahanAdder_;
	cr.regexp_escape = function(text)
	{
		return text.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
	};
	function CollisionPoly_(pts_array_)
	{
		this.pts_cache = [];
		this.bboxLeft = 0;
		this.bboxTop = 0;
		this.bboxRight = 0;
		this.bboxBottom = 0;
		this.convexpolys = null;		// for physics behavior to cache separated polys
		this.set_pts(pts_array_);
		cr.seal(this);
	};
	CollisionPoly_.prototype.set_pts = function(pts_array_)
	{
		this.pts_array = pts_array_;
		this.pts_count = pts_array_.length / 2;			// x, y, x, y... in array
		this.pts_cache.length = pts_array_.length;
		this.cache_width = -1;
		this.cache_height = -1;
		this.cache_angle = 0;
	};
	CollisionPoly_.prototype.is_empty = function()
	{
		return !this.pts_array.length;
	};
	CollisionPoly_.prototype.update_bbox = function ()
	{
		var myptscache = this.pts_cache;
		var bboxLeft_ = myptscache[0];
		var bboxRight_ = bboxLeft_;
		var bboxTop_ = myptscache[1];
		var bboxBottom_ = bboxTop_;
		var x, y, i = 1, i2, len = this.pts_count;
		for ( ; i < len; ++i)
		{
			i2 = i*2;
			x = myptscache[i2];
			y = myptscache[i2+1];
			if (x < bboxLeft_)
				bboxLeft_ = x;
			if (x > bboxRight_)
				bboxRight_ = x;
			if (y < bboxTop_)
				bboxTop_ = y;
			if (y > bboxBottom_)
				bboxBottom_ = y;
		}
		this.bboxLeft = bboxLeft_;
		this.bboxRight = bboxRight_;
		this.bboxTop = bboxTop_;
		this.bboxBottom = bboxBottom_;
	};
	CollisionPoly_.prototype.set_from_rect = function(rc, offx, offy)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = rc.left - offx;
		myptscache[1] = rc.top - offy;
		myptscache[2] = rc.right - offx;
		myptscache[3] = rc.top - offy;
		myptscache[4] = rc.right - offx;
		myptscache[5] = rc.bottom - offy;
		myptscache[6] = rc.left - offx;
		myptscache[7] = rc.bottom - offy;
		this.cache_width = rc.right - rc.left;
		this.cache_height = rc.bottom - rc.top;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_quad = function(q, offx, offy, w, h)
	{
		this.pts_cache.length = 8;
		this.pts_count = 4;
		var myptscache = this.pts_cache;
		myptscache[0] = q.tlx - offx;
		myptscache[1] = q.tly - offy;
		myptscache[2] = q.trx - offx;
		myptscache[3] = q.try_ - offy;
		myptscache[4] = q.brx - offx;
		myptscache[5] = q.bry - offy;
		myptscache[6] = q.blx - offx;
		myptscache[7] = q.bly - offy;
		this.cache_width = w;
		this.cache_height = h;
		this.update_bbox();
	};
	CollisionPoly_.prototype.set_from_poly = function (r)
	{
		this.pts_count = r.pts_count;
		cr.shallowAssignArray(this.pts_cache, r.pts_cache);
		this.bboxLeft = r.bboxLeft;
		this.bboxTop - r.bboxTop;
		this.bboxRight = r.bboxRight;
		this.bboxBottom = r.bboxBottom;
	};
	CollisionPoly_.prototype.cache_poly = function(w, h, a)
	{
		if (this.cache_width === w && this.cache_height === h && this.cache_angle === a)
			return;		// cache up-to-date
		this.cache_width = w;
		this.cache_height = h;
		this.cache_angle = a;
		var i, i2, i21, len, x, y;
		var sina = 0;
		var cosa = 1;
		var myptsarray = this.pts_array;
		var myptscache = this.pts_cache;
		if (a !== 0)
		{
			sina = Math.sin(a);
			cosa = Math.cos(a);
		}
		for (i = 0, len = this.pts_count; i < len; i++)
		{
			i2 = i*2;
			i21 = i2+1;
			x = myptsarray[i2] * w;
			y = myptsarray[i21] * h;
			myptscache[i2] = (x * cosa) - (y * sina);
			myptscache[i21] = (y * cosa) + (x * sina);
		}
		this.update_bbox();
	};
	CollisionPoly_.prototype.contains_pt = function (a2x, a2y)
	{
		var myptscache = this.pts_cache;
		if (a2x === myptscache[0] && a2y === myptscache[1])
			return true;
		var i, i2, imod, len = this.pts_count;
		var a1x = this.bboxLeft - 110;
		var a1y = this.bboxTop - 101;
		var a3x = this.bboxRight + 131
		var a3y = this.bboxBottom + 120;
		var b1x, b1y, b2x, b2y;
		var count1 = 0, count2 = 0;
		for (i = 0; i < len; i++)
		{
			i2 = i*2;
			imod = ((i+1)%len)*2;
			b1x = myptscache[i2];
			b1y = myptscache[i2+1];
			b2x = myptscache[imod];
			b2y = myptscache[imod+1];
			if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
				count1++;
			if (cr.segments_intersect(a3x, a3y, a2x, a2y, b1x, b1y, b2x, b2y))
				count2++;
		}
		return (count1 % 2 === 1) || (count2 % 2 === 1);
	};
	CollisionPoly_.prototype.intersects_poly = function (rhs, offx, offy)
	{
		var rhspts = rhs.pts_cache;
		var mypts = this.pts_cache;
		if (this.contains_pt(rhspts[0] + offx, rhspts[1] + offy))
			return true;
		if (rhs.contains_pt(mypts[0] - offx, mypts[1] - offy))
			return true;
		var i, i2, imod, leni, j, j2, jmod, lenj;
		var a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2];
			a1y = mypts[i2+1];
			a2x = mypts[imod];
			a2y = mypts[imod+1];
			for (j = 0, lenj = rhs.pts_count; j < lenj; j++)
			{
				j2 = j*2;
				jmod = ((j+1)%lenj)*2;
				b1x = rhspts[j2] + offx;
				b1y = rhspts[j2+1] + offy;
				b2x = rhspts[jmod] + offx;
				b2y = rhspts[jmod+1] + offy;
				if (cr.segments_intersect(a1x, a1y, a2x, a2y, b1x, b1y, b2x, b2y))
					return true;
			}
		}
		return false;
	};
	CollisionPoly_.prototype.intersects_segment = function (offx, offy, x1, y1, x2, y2)
	{
		var mypts = this.pts_cache;
		if (this.contains_pt(x1 - offx, y1 - offy))
			return true;
		var i, leni, i2, imod;
		var a1x, a1y, a2x, a2y;
		for (i = 0, leni = this.pts_count; i < leni; i++)
		{
			i2 = i*2;
			imod = ((i+1)%leni)*2;
			a1x = mypts[i2] + offx;
			a1y = mypts[i2+1] + offy;
			a2x = mypts[imod] + offx;
			a2y = mypts[imod+1] + offy;
			if (cr.segments_intersect(x1, y1, x2, y2, a1x, a1y, a2x, a2y))
				return true;
		}
		return false;
	};
	CollisionPoly_.prototype.mirror = function (px)
	{
		var i, leni, i2;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			this.pts_cache[i2] = px * 2 - this.pts_cache[i2];
		}
	};
	CollisionPoly_.prototype.flip = function (py)
	{
		var i, leni, i21;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i21 = i*2+1;
			this.pts_cache[i21] = py * 2 - this.pts_cache[i21];
		}
	};
	CollisionPoly_.prototype.diag = function ()
	{
		var i, leni, i2, i21, temp;
		for (i = 0, leni = this.pts_count; i < leni; ++i)
		{
			i2 = i*2;
			i21 = i2+1;
			temp = this.pts_cache[i2];
			this.pts_cache[i2] = this.pts_cache[i21];
			this.pts_cache[i21] = temp;
		}
	};
	cr.CollisionPoly = CollisionPoly_;
	function SparseGrid_(cellwidth_, cellheight_)
	{
		this.cellwidth = cellwidth_;
		this.cellheight = cellheight_;
		this.cells = {};
	};
	SparseGrid_.prototype.totalCellCount = 0;
	SparseGrid_.prototype.getCell = function (x_, y_, create_if_missing)
	{
		var ret;
		var col = this.cells[x_];
		if (!col)
		{
			if (create_if_missing)
			{
				ret = allocGridCell(this, x_, y_);
				this.cells[x_] = {};
				this.cells[x_][y_] = ret;
				return ret;
			}
			else
				return null;
		}
		ret = col[y_];
		if (ret)
			return ret;
		else if (create_if_missing)
		{
			ret = allocGridCell(this, x_, y_);
			this.cells[x_][y_] = ret;
			return ret;
		}
		else
			return null;
	};
	SparseGrid_.prototype.XToCell = function (x_)
	{
		return cr.floor(x_ / this.cellwidth);
	};
	SparseGrid_.prototype.YToCell = function (y_)
	{
		return cr.floor(y_ / this.cellheight);
	};
	SparseGrid_.prototype.update = function (inst, oldrange, newrange)
	{
		var x, lenx, y, leny, cell;
		if (oldrange)
		{
			for (x = oldrange.left, lenx = oldrange.right; x <= lenx; ++x)
			{
				for (y = oldrange.top, leny = oldrange.bottom; y <= leny; ++y)
				{
					if (newrange && newrange.contains_pt(x, y))
						continue;	// is still in this cell
					cell = this.getCell(x, y, false);	// don't create if missing
					if (!cell)
						continue;	// cell does not exist yet
					cell.remove(inst);
					if (cell.isEmpty())
					{
						freeGridCell(cell);
						this.cells[x][y] = null;
					}
				}
			}
		}
		if (newrange)
		{
			for (x = newrange.left, lenx = newrange.right; x <= lenx; ++x)
			{
				for (y = newrange.top, leny = newrange.bottom; y <= leny; ++y)
				{
					if (oldrange && oldrange.contains_pt(x, y))
						continue;	// is still in this cell
					this.getCell(x, y, true).insert(inst);
				}
			}
		}
	};
	SparseGrid_.prototype.queryRange = function (rc, result)
	{
		var x, lenx, ystart, y, leny, cell;
		x = this.XToCell(rc.left);
		ystart = this.YToCell(rc.top);
		lenx = this.XToCell(rc.right);
		leny = this.YToCell(rc.bottom);
		for ( ; x <= lenx; ++x)
		{
			for (y = ystart; y <= leny; ++y)
			{
				cell = this.getCell(x, y, false);
				if (!cell)
					continue;
				cell.dump(result);
			}
		}
	};
	cr.SparseGrid = SparseGrid_;
	var gridcellcache = [];
	function allocGridCell(grid_, x_, y_)
	{
		var ret;
		SparseGrid_.prototype.totalCellCount++;
		if (gridcellcache.length)
		{
			ret = gridcellcache.pop();
			ret.grid = grid_;
			ret.x = x_;
			ret.y = y_;
			return ret;
		}
		else
			return new cr.GridCell(grid_, x_, y_);
	};
	function freeGridCell(c)
	{
		SparseGrid_.prototype.totalCellCount--;
		c.objects.clear();
		if (gridcellcache.length < 1000)
			gridcellcache.push(c);
	};
	function GridCell_(grid_, x_, y_)
	{
		this.grid = grid_;
		this.x = x_;
		this.y = y_;
		this.objects = new cr.ObjectSet();
	};
	GridCell_.prototype.isEmpty = function ()
	{
		return this.objects.isEmpty();
	};
	GridCell_.prototype.insert = function (inst)
	{
		this.objects.add(inst);
	};
	GridCell_.prototype.remove = function (inst)
	{
		this.objects.remove(inst);
	};
	GridCell_.prototype.dump = function (result)
	{
		cr.appendArray(result, this.objects.valuesRef());
	};
	cr.GridCell = GridCell_;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	cr.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	cr.setGLBlend = function(this_, effect, gl)
	{
		if (!gl)
			return;
		this_.srcBlend = gl.ONE;
		this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this_.srcBlend = gl.ONE;
			this_.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this_.srcBlend = gl.ZERO;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this_.srcBlend = gl.DST_ALPHA;
			this_.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this_.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this_.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	cr.round6dp = function (x)
	{
		return cr.round(x * 1000000) / 1000000;
	};
	/*
	var localeCompare_options = {
		"usage": "search",
		"sensitivity": "accent"
	};
	var has_localeCompare = !!"a".localeCompare;
	var localeCompare_works1 = (has_localeCompare && "a".localeCompare("A", undefined, localeCompare_options) === 0);
	var localeCompare_works2 = (has_localeCompare && "a".localeCompare("á", undefined, localeCompare_options) !== 0);
	var supports_localeCompare = (has_localeCompare && localeCompare_works1 && localeCompare_works2);
	*/
	cr.equals_nocase = function (a, b)
	{
		if (typeof a !== "string" || typeof b !== "string")
			return false;
		if (a.length !== b.length)
			return false;
		if (a === b)
			return true;
		/*
		if (supports_localeCompare)
		{
			return (a.localeCompare(b, undefined, localeCompare_options) === 0);
		}
		else
		{
		*/
			return a.toLowerCase() === b.toLowerCase();
	};
}());
var MatrixArray=typeof Float32Array!=="undefined"?Float32Array:Array,glMatrixArrayType=MatrixArray,vec3={},mat3={},mat4={},quat4={};vec3.create=function(a){var b=new MatrixArray(3);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2]);return b};vec3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];return b};vec3.add=function(a,b,c){if(!c||a===c)return a[0]+=b[0],a[1]+=b[1],a[2]+=b[2],a;c[0]=a[0]+b[0];c[1]=a[1]+b[1];c[2]=a[2]+b[2];return c};
vec3.subtract=function(a,b,c){if(!c||a===c)return a[0]-=b[0],a[1]-=b[1],a[2]-=b[2],a;c[0]=a[0]-b[0];c[1]=a[1]-b[1];c[2]=a[2]-b[2];return c};vec3.negate=function(a,b){b||(b=a);b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];return b};vec3.scale=function(a,b,c){if(!c||a===c)return a[0]*=b,a[1]*=b,a[2]*=b,a;c[0]=a[0]*b;c[1]=a[1]*b;c[2]=a[2]*b;return c};
vec3.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=Math.sqrt(c*c+d*d+e*e);if(g){if(g===1)return b[0]=c,b[1]=d,b[2]=e,b}else return b[0]=0,b[1]=0,b[2]=0,b;g=1/g;b[0]=c*g;b[1]=d*g;b[2]=e*g;return b};vec3.cross=function(a,b,c){c||(c=a);var d=a[0],e=a[1],a=a[2],g=b[0],f=b[1],b=b[2];c[0]=e*b-a*f;c[1]=a*g-d*b;c[2]=d*f-e*g;return c};vec3.length=function(a){var b=a[0],c=a[1],a=a[2];return Math.sqrt(b*b+c*c+a*a)};vec3.dot=function(a,b){return a[0]*b[0]+a[1]*b[1]+a[2]*b[2]};
vec3.direction=function(a,b,c){c||(c=a);var d=a[0]-b[0],e=a[1]-b[1],a=a[2]-b[2],b=Math.sqrt(d*d+e*e+a*a);if(!b)return c[0]=0,c[1]=0,c[2]=0,c;b=1/b;c[0]=d*b;c[1]=e*b;c[2]=a*b;return c};vec3.lerp=function(a,b,c,d){d||(d=a);d[0]=a[0]+c*(b[0]-a[0]);d[1]=a[1]+c*(b[1]-a[1]);d[2]=a[2]+c*(b[2]-a[2]);return d};vec3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+"]"};
mat3.create=function(a){var b=new MatrixArray(9);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8]);return b};mat3.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];return b};mat3.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=1;a[5]=0;a[6]=0;a[7]=0;a[8]=1;return a};
mat3.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[5];a[1]=a[3];a[2]=a[6];a[3]=c;a[5]=a[7];a[6]=d;a[7]=e;return a}b[0]=a[0];b[1]=a[3];b[2]=a[6];b[3]=a[1];b[4]=a[4];b[5]=a[7];b[6]=a[2];b[7]=a[5];b[8]=a[8];return b};mat3.toMat4=function(a,b){b||(b=mat4.create());b[15]=1;b[14]=0;b[13]=0;b[12]=0;b[11]=0;b[10]=a[8];b[9]=a[7];b[8]=a[6];b[7]=0;b[6]=a[5];b[5]=a[4];b[4]=a[3];b[3]=0;b[2]=a[2];b[1]=a[1];b[0]=a[0];return b};
mat3.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+"]"};mat4.create=function(a){var b=new MatrixArray(16);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3],b[4]=a[4],b[5]=a[5],b[6]=a[6],b[7]=a[7],b[8]=a[8],b[9]=a[9],b[10]=a[10],b[11]=a[11],b[12]=a[12],b[13]=a[13],b[14]=a[14],b[15]=a[15]);return b};
mat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=a[12];b[13]=a[13];b[14]=a[14];b[15]=a[15];return b};mat4.identity=function(a){a[0]=1;a[1]=0;a[2]=0;a[3]=0;a[4]=0;a[5]=1;a[6]=0;a[7]=0;a[8]=0;a[9]=0;a[10]=1;a[11]=0;a[12]=0;a[13]=0;a[14]=0;a[15]=1;return a};
mat4.transpose=function(a,b){if(!b||a===b){var c=a[1],d=a[2],e=a[3],g=a[6],f=a[7],h=a[11];a[1]=a[4];a[2]=a[8];a[3]=a[12];a[4]=c;a[6]=a[9];a[7]=a[13];a[8]=d;a[9]=g;a[11]=a[14];a[12]=e;a[13]=f;a[14]=h;return a}b[0]=a[0];b[1]=a[4];b[2]=a[8];b[3]=a[12];b[4]=a[1];b[5]=a[5];b[6]=a[9];b[7]=a[13];b[8]=a[2];b[9]=a[6];b[10]=a[10];b[11]=a[14];b[12]=a[3];b[13]=a[7];b[14]=a[11];b[15]=a[15];return b};
mat4.determinant=function(a){var b=a[0],c=a[1],d=a[2],e=a[3],g=a[4],f=a[5],h=a[6],i=a[7],j=a[8],k=a[9],l=a[10],n=a[11],o=a[12],m=a[13],p=a[14],a=a[15];return o*k*h*e-j*m*h*e-o*f*l*e+g*m*l*e+j*f*p*e-g*k*p*e-o*k*d*i+j*m*d*i+o*c*l*i-b*m*l*i-j*c*p*i+b*k*p*i+o*f*d*n-g*m*d*n-o*c*h*n+b*m*h*n+g*c*p*n-b*f*p*n-j*f*d*a+g*k*d*a+j*c*h*a-b*k*h*a-g*c*l*a+b*f*l*a};
mat4.inverse=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=a[4],h=a[5],i=a[6],j=a[7],k=a[8],l=a[9],n=a[10],o=a[11],m=a[12],p=a[13],r=a[14],s=a[15],A=c*h-d*f,B=c*i-e*f,t=c*j-g*f,u=d*i-e*h,v=d*j-g*h,w=e*j-g*i,x=k*p-l*m,y=k*r-n*m,z=k*s-o*m,C=l*r-n*p,D=l*s-o*p,E=n*s-o*r,q=1/(A*E-B*D+t*C+u*z-v*y+w*x);b[0]=(h*E-i*D+j*C)*q;b[1]=(-d*E+e*D-g*C)*q;b[2]=(p*w-r*v+s*u)*q;b[3]=(-l*w+n*v-o*u)*q;b[4]=(-f*E+i*z-j*y)*q;b[5]=(c*E-e*z+g*y)*q;b[6]=(-m*w+r*t-s*B)*q;b[7]=(k*w-n*t+o*B)*q;b[8]=(f*D-h*z+j*x)*q;
b[9]=(-c*D+d*z-g*x)*q;b[10]=(m*v-p*t+s*A)*q;b[11]=(-k*v+l*t-o*A)*q;b[12]=(-f*C+h*y-i*x)*q;b[13]=(c*C-d*y+e*x)*q;b[14]=(-m*u+p*B-r*A)*q;b[15]=(k*u-l*B+n*A)*q;return b};mat4.toRotationMat=function(a,b){b||(b=mat4.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];b[4]=a[4];b[5]=a[5];b[6]=a[6];b[7]=a[7];b[8]=a[8];b[9]=a[9];b[10]=a[10];b[11]=a[11];b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
mat4.toMat3=function(a,b){b||(b=mat3.create());b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[4];b[4]=a[5];b[5]=a[6];b[6]=a[8];b[7]=a[9];b[8]=a[10];return b};mat4.toInverseMat3=function(a,b){var c=a[0],d=a[1],e=a[2],g=a[4],f=a[5],h=a[6],i=a[8],j=a[9],k=a[10],l=k*f-h*j,n=-k*g+h*i,o=j*g-f*i,m=c*l+d*n+e*o;if(!m)return null;m=1/m;b||(b=mat3.create());b[0]=l*m;b[1]=(-k*d+e*j)*m;b[2]=(h*d-e*f)*m;b[3]=n*m;b[4]=(k*c-e*i)*m;b[5]=(-h*c+e*g)*m;b[6]=o*m;b[7]=(-j*c+d*i)*m;b[8]=(f*c-d*g)*m;return b};
mat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],f=a[3],h=a[4],i=a[5],j=a[6],k=a[7],l=a[8],n=a[9],o=a[10],m=a[11],p=a[12],r=a[13],s=a[14],a=a[15],A=b[0],B=b[1],t=b[2],u=b[3],v=b[4],w=b[5],x=b[6],y=b[7],z=b[8],C=b[9],D=b[10],E=b[11],q=b[12],F=b[13],G=b[14],b=b[15];c[0]=A*d+B*h+t*l+u*p;c[1]=A*e+B*i+t*n+u*r;c[2]=A*g+B*j+t*o+u*s;c[3]=A*f+B*k+t*m+u*a;c[4]=v*d+w*h+x*l+y*p;c[5]=v*e+w*i+x*n+y*r;c[6]=v*g+w*j+x*o+y*s;c[7]=v*f+w*k+x*m+y*a;c[8]=z*d+C*h+D*l+E*p;c[9]=z*e+C*i+D*n+E*r;c[10]=z*g+C*
j+D*o+E*s;c[11]=z*f+C*k+D*m+E*a;c[12]=q*d+F*h+G*l+b*p;c[13]=q*e+F*i+G*n+b*r;c[14]=q*g+F*j+G*o+b*s;c[15]=q*f+F*k+G*m+b*a;return c};mat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],b=b[2];c[0]=a[0]*d+a[4]*e+a[8]*b+a[12];c[1]=a[1]*d+a[5]*e+a[9]*b+a[13];c[2]=a[2]*d+a[6]*e+a[10]*b+a[14];return c};
mat4.multiplyVec4=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=b[3];c[0]=a[0]*d+a[4]*e+a[8]*g+a[12]*b;c[1]=a[1]*d+a[5]*e+a[9]*g+a[13]*b;c[2]=a[2]*d+a[6]*e+a[10]*g+a[14]*b;c[3]=a[3]*d+a[7]*e+a[11]*g+a[15]*b;return c};
mat4.translate=function(a,b,c){var d=b[0],e=b[1],b=b[2],g,f,h,i,j,k,l,n,o,m,p,r;if(!c||a===c)return a[12]=a[0]*d+a[4]*e+a[8]*b+a[12],a[13]=a[1]*d+a[5]*e+a[9]*b+a[13],a[14]=a[2]*d+a[6]*e+a[10]*b+a[14],a[15]=a[3]*d+a[7]*e+a[11]*b+a[15],a;g=a[0];f=a[1];h=a[2];i=a[3];j=a[4];k=a[5];l=a[6];n=a[7];o=a[8];m=a[9];p=a[10];r=a[11];c[0]=g;c[1]=f;c[2]=h;c[3]=i;c[4]=j;c[5]=k;c[6]=l;c[7]=n;c[8]=o;c[9]=m;c[10]=p;c[11]=r;c[12]=g*d+j*e+o*b+a[12];c[13]=f*d+k*e+m*b+a[13];c[14]=h*d+l*e+p*b+a[14];c[15]=i*d+n*e+r*b+a[15];
return c};mat4.scale=function(a,b,c){var d=b[0],e=b[1],b=b[2];if(!c||a===c)return a[0]*=d,a[1]*=d,a[2]*=d,a[3]*=d,a[4]*=e,a[5]*=e,a[6]*=e,a[7]*=e,a[8]*=b,a[9]*=b,a[10]*=b,a[11]*=b,a;c[0]=a[0]*d;c[1]=a[1]*d;c[2]=a[2]*d;c[3]=a[3]*d;c[4]=a[4]*e;c[5]=a[5]*e;c[6]=a[6]*e;c[7]=a[7]*e;c[8]=a[8]*b;c[9]=a[9]*b;c[10]=a[10]*b;c[11]=a[11]*b;c[12]=a[12];c[13]=a[13];c[14]=a[14];c[15]=a[15];return c};
mat4.rotate=function(a,b,c,d){var e=c[0],g=c[1],c=c[2],f=Math.sqrt(e*e+g*g+c*c),h,i,j,k,l,n,o,m,p,r,s,A,B,t,u,v,w,x,y,z;if(!f)return null;f!==1&&(f=1/f,e*=f,g*=f,c*=f);h=Math.sin(b);i=Math.cos(b);j=1-i;b=a[0];f=a[1];k=a[2];l=a[3];n=a[4];o=a[5];m=a[6];p=a[7];r=a[8];s=a[9];A=a[10];B=a[11];t=e*e*j+i;u=g*e*j+c*h;v=c*e*j-g*h;w=e*g*j-c*h;x=g*g*j+i;y=c*g*j+e*h;z=e*c*j+g*h;e=g*c*j-e*h;g=c*c*j+i;d?a!==d&&(d[12]=a[12],d[13]=a[13],d[14]=a[14],d[15]=a[15]):d=a;d[0]=b*t+n*u+r*v;d[1]=f*t+o*u+s*v;d[2]=k*t+m*u+A*
v;d[3]=l*t+p*u+B*v;d[4]=b*w+n*x+r*y;d[5]=f*w+o*x+s*y;d[6]=k*w+m*x+A*y;d[7]=l*w+p*x+B*y;d[8]=b*z+n*e+r*g;d[9]=f*z+o*e+s*g;d[10]=k*z+m*e+A*g;d[11]=l*z+p*e+B*g;return d};mat4.rotateX=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[4],g=a[5],f=a[6],h=a[7],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[0]=a[0],c[1]=a[1],c[2]=a[2],c[3]=a[3],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[4]=e*b+i*d;c[5]=g*b+j*d;c[6]=f*b+k*d;c[7]=h*b+l*d;c[8]=e*-d+i*b;c[9]=g*-d+j*b;c[10]=f*-d+k*b;c[11]=h*-d+l*b;return c};
mat4.rotateY=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[8],j=a[9],k=a[10],l=a[11];c?a!==c&&(c[4]=a[4],c[5]=a[5],c[6]=a[6],c[7]=a[7],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*-d;c[1]=g*b+j*-d;c[2]=f*b+k*-d;c[3]=h*b+l*-d;c[8]=e*d+i*b;c[9]=g*d+j*b;c[10]=f*d+k*b;c[11]=h*d+l*b;return c};
mat4.rotateZ=function(a,b,c){var d=Math.sin(b),b=Math.cos(b),e=a[0],g=a[1],f=a[2],h=a[3],i=a[4],j=a[5],k=a[6],l=a[7];c?a!==c&&(c[8]=a[8],c[9]=a[9],c[10]=a[10],c[11]=a[11],c[12]=a[12],c[13]=a[13],c[14]=a[14],c[15]=a[15]):c=a;c[0]=e*b+i*d;c[1]=g*b+j*d;c[2]=f*b+k*d;c[3]=h*b+l*d;c[4]=e*-d+i*b;c[5]=g*-d+j*b;c[6]=f*-d+k*b;c[7]=h*-d+l*b;return c};
mat4.frustum=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=e*2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=e*2/i;f[6]=0;f[7]=0;f[8]=(b+a)/h;f[9]=(d+c)/i;f[10]=-(g+e)/j;f[11]=-1;f[12]=0;f[13]=0;f[14]=-(g*e*2)/j;f[15]=0;return f};mat4.perspective=function(a,b,c,d,e){a=c*Math.tan(a*Math.PI/360);b*=a;return mat4.frustum(-b,b,-a,a,c,d,e)};
mat4.ortho=function(a,b,c,d,e,g,f){f||(f=mat4.create());var h=b-a,i=d-c,j=g-e;f[0]=2/h;f[1]=0;f[2]=0;f[3]=0;f[4]=0;f[5]=2/i;f[6]=0;f[7]=0;f[8]=0;f[9]=0;f[10]=-2/j;f[11]=0;f[12]=-(a+b)/h;f[13]=-(d+c)/i;f[14]=-(g+e)/j;f[15]=1;return f};
mat4.lookAt=function(a,b,c,d){d||(d=mat4.create());var e,g,f,h,i,j,k,l,n=a[0],o=a[1],a=a[2];g=c[0];f=c[1];e=c[2];c=b[1];j=b[2];if(n===b[0]&&o===c&&a===j)return mat4.identity(d);c=n-b[0];j=o-b[1];k=a-b[2];l=1/Math.sqrt(c*c+j*j+k*k);c*=l;j*=l;k*=l;b=f*k-e*j;e=e*c-g*k;g=g*j-f*c;(l=Math.sqrt(b*b+e*e+g*g))?(l=1/l,b*=l,e*=l,g*=l):g=e=b=0;f=j*g-k*e;h=k*b-c*g;i=c*e-j*b;(l=Math.sqrt(f*f+h*h+i*i))?(l=1/l,f*=l,h*=l,i*=l):i=h=f=0;d[0]=b;d[1]=f;d[2]=c;d[3]=0;d[4]=e;d[5]=h;d[6]=j;d[7]=0;d[8]=g;d[9]=i;d[10]=k;d[11]=
0;d[12]=-(b*n+e*o+g*a);d[13]=-(f*n+h*o+i*a);d[14]=-(c*n+j*o+k*a);d[15]=1;return d};mat4.fromRotationTranslation=function(a,b,c){c||(c=mat4.create());var d=a[0],e=a[1],g=a[2],f=a[3],h=d+d,i=e+e,j=g+g,a=d*h,k=d*i;d*=j;var l=e*i;e*=j;g*=j;h*=f;i*=f;f*=j;c[0]=1-(l+g);c[1]=k+f;c[2]=d-i;c[3]=0;c[4]=k-f;c[5]=1-(a+g);c[6]=e+h;c[7]=0;c[8]=d+i;c[9]=e-h;c[10]=1-(a+l);c[11]=0;c[12]=b[0];c[13]=b[1];c[14]=b[2];c[15]=1;return c};
mat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+", "+a[4]+", "+a[5]+", "+a[6]+", "+a[7]+", "+a[8]+", "+a[9]+", "+a[10]+", "+a[11]+", "+a[12]+", "+a[13]+", "+a[14]+", "+a[15]+"]"};quat4.create=function(a){var b=new MatrixArray(4);a&&(b[0]=a[0],b[1]=a[1],b[2]=a[2],b[3]=a[3]);return b};quat4.set=function(a,b){b[0]=a[0];b[1]=a[1];b[2]=a[2];b[3]=a[3];return b};
quat4.calculateW=function(a,b){var c=a[0],d=a[1],e=a[2];if(!b||a===b)return a[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e)),a;b[0]=c;b[1]=d;b[2]=e;b[3]=-Math.sqrt(Math.abs(1-c*c-d*d-e*e));return b};quat4.inverse=function(a,b){if(!b||a===b)return a[0]*=-1,a[1]*=-1,a[2]*=-1,a;b[0]=-a[0];b[1]=-a[1];b[2]=-a[2];b[3]=a[3];return b};quat4.length=function(a){var b=a[0],c=a[1],d=a[2],a=a[3];return Math.sqrt(b*b+c*c+d*d+a*a)};
quat4.normalize=function(a,b){b||(b=a);var c=a[0],d=a[1],e=a[2],g=a[3],f=Math.sqrt(c*c+d*d+e*e+g*g);if(f===0)return b[0]=0,b[1]=0,b[2]=0,b[3]=0,b;f=1/f;b[0]=c*f;b[1]=d*f;b[2]=e*f;b[3]=g*f;return b};quat4.multiply=function(a,b,c){c||(c=a);var d=a[0],e=a[1],g=a[2],a=a[3],f=b[0],h=b[1],i=b[2],b=b[3];c[0]=d*b+a*f+e*i-g*h;c[1]=e*b+a*h+g*f-d*i;c[2]=g*b+a*i+d*h-e*f;c[3]=a*b-d*f-e*h-g*i;return c};
quat4.multiplyVec3=function(a,b,c){c||(c=b);var d=b[0],e=b[1],g=b[2],b=a[0],f=a[1],h=a[2],a=a[3],i=a*d+f*g-h*e,j=a*e+h*d-b*g,k=a*g+b*e-f*d,d=-b*d-f*e-h*g;c[0]=i*a+d*-b+j*-h-k*-f;c[1]=j*a+d*-f+k*-b-i*-h;c[2]=k*a+d*-h+i*-f-j*-b;return c};quat4.toMat3=function(a,b){b||(b=mat3.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=k-g;b[4]=1-(j+e);b[5]=d+f;b[6]=c+h;b[7]=d-f;b[8]=1-(j+l);return b};
quat4.toMat4=function(a,b){b||(b=mat4.create());var c=a[0],d=a[1],e=a[2],g=a[3],f=c+c,h=d+d,i=e+e,j=c*f,k=c*h;c*=i;var l=d*h;d*=i;e*=i;f*=g;h*=g;g*=i;b[0]=1-(l+e);b[1]=k+g;b[2]=c-h;b[3]=0;b[4]=k-g;b[5]=1-(j+e);b[6]=d+f;b[7]=0;b[8]=c+h;b[9]=d-f;b[10]=1-(j+l);b[11]=0;b[12]=0;b[13]=0;b[14]=0;b[15]=1;return b};
quat4.slerp=function(a,b,c,d){d||(d=a);var e=a[0]*b[0]+a[1]*b[1]+a[2]*b[2]+a[3]*b[3],g,f;if(Math.abs(e)>=1)return d!==a&&(d[0]=a[0],d[1]=a[1],d[2]=a[2],d[3]=a[3]),d;g=Math.acos(e);f=Math.sqrt(1-e*e);if(Math.abs(f)<0.001)return d[0]=a[0]*0.5+b[0]*0.5,d[1]=a[1]*0.5+b[1]*0.5,d[2]=a[2]*0.5+b[2]*0.5,d[3]=a[3]*0.5+b[3]*0.5,d;e=Math.sin((1-c)*g)/f;c=Math.sin(c*g)/f;d[0]=a[0]*e+b[0]*c;d[1]=a[1]*e+b[1]*c;d[2]=a[2]*e+b[2]*c;d[3]=a[3]*e+b[3]*c;return d};
quat4.str=function(a){return"["+a[0]+", "+a[1]+", "+a[2]+", "+a[3]+"]"};
(function()
{
	var MAX_VERTICES = 8000;						// equates to 2500 objects being drawn
	var MAX_INDICES = (MAX_VERTICES / 2) * 3;		// 6 indices for every 4 vertices
	var MAX_POINTS = 8000;
	var MULTI_BUFFERS = 4;							// cycle 4 buffers to try and avoid blocking
	var BATCH_NULL = 0;
	var BATCH_QUAD = 1;
	var BATCH_SETTEXTURE = 2;
	var BATCH_SETOPACITY = 3;
	var BATCH_SETBLEND = 4;
	var BATCH_UPDATEMODELVIEW = 5;
	var BATCH_RENDERTOTEXTURE = 6;
	var BATCH_CLEAR = 7;
	var BATCH_POINTS = 8;
	var BATCH_SETPROGRAM = 9;
	var BATCH_SETPROGRAMPARAMETERS = 10;
	var BATCH_SETTEXTURE1 = 11;
	function GLWrap_(gl, isMobile)
	{
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.width = 0;		// not yet known, wait for call to setSize()
		this.height = 0;
		this.cam = vec3.create([0, 0, 100]);			// camera position
		this.look = vec3.create([0, 0, 0]);				// lookat position
		this.up = vec3.create([0, 1, 0]);				// up vector
		this.worldScale = vec3.create([1, 1, 1]);		// world scaling factor
		this.enable_mipmaps = true;
		this.matP = mat4.create();						// perspective matrix
		this.matMV = mat4.create();						// model view matrix
		this.lastMV = mat4.create();
		this.currentMV = mat4.create();
		this.gl = gl;
		this.initState();
	};
	GLWrap_.prototype.initState = function ()
	{
		var gl = this.gl;
		var i, len;
		this.lastOpacity = 1;
		this.lastTexture0 = null;			// last bound to TEXTURE0
		this.lastTexture1 = null;			// last bound to TEXTURE1
		this.currentOpacity = 1;
		gl.clearColor(0, 0, 0, 0);
		gl.clear(gl.COLOR_BUFFER_BIT);
		gl.enable(gl.BLEND);
        gl.blendFunc(gl.ONE, gl.ONE_MINUS_SRC_ALPHA);
		gl.disable(gl.CULL_FACE);
		gl.disable(gl.DEPTH_TEST);
		this.maxTextureSize = gl.getParameter(gl.MAX_TEXTURE_SIZE);
		this.lastSrcBlend = gl.ONE;
		this.lastDestBlend = gl.ONE_MINUS_SRC_ALPHA;
		this.pointBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
		this.vertexBuffers = new Array(MULTI_BUFFERS);
		this.texcoordBuffers = new Array(MULTI_BUFFERS);
		for (i = 0; i < MULTI_BUFFERS; i++)
		{
			this.vertexBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[i]);
			this.texcoordBuffers[i] = gl.createBuffer();
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[i]);
		}
		this.curBuffer = 0;
		this.indexBuffer = gl.createBuffer();
		gl.bindBuffer(gl.ELEMENT_ARRAY_BUFFER, this.indexBuffer);
		this.vertexData = new Float32Array(MAX_VERTICES * 2);
		this.texcoordData = new Float32Array(MAX_VERTICES * 2);
		this.pointData = new Float32Array(MAX_POINTS * 4);
		var indexData = new Uint16Array(MAX_INDICES);
		i = 0, len = MAX_INDICES;
		var fv = 0;
		while (i < len)
		{
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 1;	// top right
			indexData[i++] = fv + 2;	// bottom right (first tri)
			indexData[i++] = fv;		// top left
			indexData[i++] = fv + 2;	// bottom right
			indexData[i++] = fv + 3;	// bottom left
			fv += 4;
		}
		gl.bufferData(gl.ELEMENT_ARRAY_BUFFER, indexData, gl.STATIC_DRAW);
		this.vertexPtr = 0;
		this.pointPtr = 0;
		var fsSource, vsSource;
		this.shaderPrograms = [];
		fsSource = [
			"varying mediump vec2 vTex;",
			"uniform lowp float opacity;",
			"uniform lowp sampler2D samplerFront;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, vTex);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		vsSource = [
			"attribute highp vec2 aPos;",
			"attribute mediump vec2 aTex;",
			"varying mediump vec2 vTex;",
			"uniform highp mat4 matP;",
			"uniform highp mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	vTex = aTex;",
			"}"
		].join("\n");
		var shaderProg = this.createShaderProgram({src: fsSource}, vsSource, "<default>");
;
		this.shaderPrograms.push(shaderProg);		// Default shader is always shader 0
		fsSource = [
			"uniform mediump sampler2D samplerFront;",
			"varying lowp float opacity;",
			"void main(void) {",
			"	gl_FragColor = texture2D(samplerFront, gl_PointCoord);",
			"	gl_FragColor *= opacity;",
			"}"
		].join("\n");
		var pointVsSource = [
			"attribute vec4 aPos;",
			"varying float opacity;",
			"uniform mat4 matP;",
			"uniform mat4 matMV;",
			"void main(void) {",
			"	gl_Position = matP * matMV * vec4(aPos.x, aPos.y, 0.0, 1.0);",
			"	gl_PointSize = aPos.z;",
			"	opacity = aPos.w;",
			"}"
		].join("\n");
		shaderProg = this.createShaderProgram({src: fsSource}, pointVsSource, "<point>");
;
		this.shaderPrograms.push(shaderProg);		// Point shader is always shader 1
		for (var shader_name in cr.shaders)
		{
			if (cr.shaders.hasOwnProperty(shader_name))
				this.shaderPrograms.push(this.createShaderProgram(cr.shaders[shader_name], vsSource, shader_name));
		}
		gl.activeTexture(gl.TEXTURE0);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.batch = [];
		this.batchPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.lastProgram = -1;				// start -1 so first switchProgram can do work
		this.currentProgram = -1;			// current program during batch execution
		this.currentShader = null;
		this.fbo = gl.createFramebuffer();
		this.renderToTex = null;
		this.tmpVec3 = vec3.create([0, 0, 0]);
;
;
		var pointsizes = gl.getParameter(gl.ALIASED_POINT_SIZE_RANGE);
		this.minPointSize = pointsizes[0];
		this.maxPointSize = pointsizes[1];
		if (this.maxPointSize > 2048)
			this.maxPointSize = 2048;
;
		this.switchProgram(0);
		cr.seal(this);
	};
	function GLShaderProgram(gl, shaderProgram, name)
	{
		this.gl = gl;
		this.shaderProgram = shaderProgram;
		this.name = name;
		this.locAPos = gl.getAttribLocation(shaderProgram, "aPos");
		this.locATex = gl.getAttribLocation(shaderProgram, "aTex");
		this.locMatP = gl.getUniformLocation(shaderProgram, "matP");
		this.locMatMV = gl.getUniformLocation(shaderProgram, "matMV");
		this.locOpacity = gl.getUniformLocation(shaderProgram, "opacity");
		this.locSamplerFront = gl.getUniformLocation(shaderProgram, "samplerFront");
		this.locSamplerBack = gl.getUniformLocation(shaderProgram, "samplerBack");
		this.locDestStart = gl.getUniformLocation(shaderProgram, "destStart");
		this.locDestEnd = gl.getUniformLocation(shaderProgram, "destEnd");
		this.locSeconds = gl.getUniformLocation(shaderProgram, "seconds");
		this.locPixelWidth = gl.getUniformLocation(shaderProgram, "pixelWidth");
		this.locPixelHeight = gl.getUniformLocation(shaderProgram, "pixelHeight");
		this.locLayerScale = gl.getUniformLocation(shaderProgram, "layerScale");
		this.locLayerAngle = gl.getUniformLocation(shaderProgram, "layerAngle");
		this.locViewOrigin = gl.getUniformLocation(shaderProgram, "viewOrigin");
		this.hasAnyOptionalUniforms = !!(this.locPixelWidth || this.locPixelHeight || this.locSeconds || this.locSamplerBack || this.locDestStart || this.locDestEnd || this.locLayerScale || this.locLayerAngle || this.locViewOrigin);
		if (this.locOpacity)
			gl.uniform1f(this.locOpacity, 1);
		if (this.locSamplerFront)
			gl.uniform1i(this.locSamplerFront, 0);
		if (this.locSamplerBack)
			gl.uniform1i(this.locSamplerBack, 1);
		if (this.locDestStart)
			gl.uniform2f(this.locDestStart, 0.0, 0.0);
		if (this.locDestEnd)
			gl.uniform2f(this.locDestEnd, 1.0, 1.0);
		if (this.locLayerScale)
			gl.uniform1f(this.locLayerScale, 1.0);
		if (this.locLayerAngle)
			gl.uniform1f(this.locLayerAngle, 0.0);
		if (this.locViewOrigin)
			gl.uniform2f(this.locViewOrigin, 0.0, 0.0);
		this.hasCurrentMatMV = false;		// matMV needs updating
	};
	GLWrap_.prototype.createShaderProgram = function(shaderEntry, vsSource, name)
	{
		var gl = this.gl;
		var fragmentShader = gl.createShader(gl.FRAGMENT_SHADER);
		gl.shaderSource(fragmentShader, shaderEntry.src);
		gl.compileShader(fragmentShader);
		if (!gl.getShaderParameter(fragmentShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			return null;
		}
		var vertexShader = gl.createShader(gl.VERTEX_SHADER);
		gl.shaderSource(vertexShader, vsSource);
		gl.compileShader(vertexShader);
		if (!gl.getShaderParameter(vertexShader, gl.COMPILE_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			return null;
		}
		var shaderProgram = gl.createProgram();
		gl.attachShader(shaderProgram, fragmentShader);
		gl.attachShader(shaderProgram, vertexShader);
		gl.linkProgram(shaderProgram);
		if (!gl.getProgramParameter(shaderProgram, gl.LINK_STATUS))
		{
;
			gl.deleteShader(fragmentShader);
			gl.deleteShader(vertexShader);
			gl.deleteProgram(shaderProgram);
			return null;
		}
		gl.useProgram(shaderProgram);
;
		gl.deleteShader(fragmentShader);
		gl.deleteShader(vertexShader);
		var ret = new GLShaderProgram(gl, shaderProgram, name);
		ret.extendBoxHorizontal = shaderEntry.extendBoxHorizontal || 0;
		ret.extendBoxVertical = shaderEntry.extendBoxVertical || 0;
		ret.crossSampling = !!shaderEntry.crossSampling;
		ret.animated = !!shaderEntry.animated;
		ret.parameters = shaderEntry.parameters || [];
		var i, len;
		for (i = 0, len = ret.parameters.length; i < len; i++)
		{
			ret.parameters[i][1] = gl.getUniformLocation(shaderProgram, ret.parameters[i][0]);
			gl.uniform1f(ret.parameters[i][1], 0);
		}
		cr.seal(ret);
		return ret;
	};
	GLWrap_.prototype.getShaderIndex = function(name_)
	{
		var i, len;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			if (this.shaderPrograms[i].name === name_)
				return i;
		}
		return -1;
	};
	GLWrap_.prototype.project = function (x, y, out)
	{
		var mv = this.matMV;
		var proj = this.matP;
		var fTempo = [0, 0, 0, 0, 0, 0, 0, 0];
		fTempo[0] = mv[0]*x+mv[4]*y+mv[12];
		fTempo[1] = mv[1]*x+mv[5]*y+mv[13];
		fTempo[2] = mv[2]*x+mv[6]*y+mv[14];
		fTempo[3] = mv[3]*x+mv[7]*y+mv[15];
		fTempo[4] = proj[0]*fTempo[0]+proj[4]*fTempo[1]+proj[8]*fTempo[2]+proj[12]*fTempo[3];
		fTempo[5] = proj[1]*fTempo[0]+proj[5]*fTempo[1]+proj[9]*fTempo[2]+proj[13]*fTempo[3];
		fTempo[6] = proj[2]*fTempo[0]+proj[6]*fTempo[1]+proj[10]*fTempo[2]+proj[14]*fTempo[3];
		fTempo[7] = -fTempo[2];
		if(fTempo[7]===0.0)	//The w value
			return;
		fTempo[7]=1.0/fTempo[7];
		fTempo[4]*=fTempo[7];
		fTempo[5]*=fTempo[7];
		fTempo[6]*=fTempo[7];
		out[0]=(fTempo[4]*0.5+0.5)*this.width;
		out[1]=(fTempo[5]*0.5+0.5)*this.height;
	};
	GLWrap_.prototype.setSize = function(w, h, force)
	{
		if (this.width === w && this.height === h && !force)
			return;
		this.endBatch();
		this.width = w;
		this.height = h;
		this.gl.viewport(0, 0, w, h);
		mat4.perspective(45, w / h, 1, 1000, this.matP);
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		var tl = [0, 0];
		var br = [0, 0];
		this.project(0, 0, tl);
		this.project(1, 1, br);
		this.worldScale[0] = 1 / (br[0] - tl[0]);
		this.worldScale[1] = -1 / (br[1] - tl[1]);
		var i, len, s;
		for (i = 0, len = this.shaderPrograms.length; i < len; i++)
		{
			s = this.shaderPrograms[i];
			s.hasCurrentMatMV = false;
			if (s.locMatP)
			{
				this.gl.useProgram(s.shaderProgram);
				this.gl.uniformMatrix4fv(s.locMatP, false, this.matP);
			}
		}
		this.gl.useProgram(this.shaderPrograms[this.lastProgram].shaderProgram);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE1);
		this.gl.bindTexture(this.gl.TEXTURE_2D, null);
		this.gl.activeTexture(this.gl.TEXTURE0);
		this.lastTexture0 = null;
		this.lastTexture1 = null;
	};
	GLWrap_.prototype.resetModelView = function ()
	{
		mat4.lookAt(this.cam, this.look, this.up, this.matMV);
		mat4.scale(this.matMV, this.worldScale);
	};
	GLWrap_.prototype.translate = function (x, y)
	{
		if (x === 0 && y === 0)
			return;
		this.tmpVec3[0] = x;// * this.worldScale[0];
		this.tmpVec3[1] = y;// * this.worldScale[1];
		this.tmpVec3[2] = 0;
		mat4.translate(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.scale = function (x, y)
	{
		if (x === 1 && y === 1)
			return;
		this.tmpVec3[0] = x;
		this.tmpVec3[1] = y;
		this.tmpVec3[2] = 1;
		mat4.scale(this.matMV, this.tmpVec3);
	};
	GLWrap_.prototype.rotateZ = function (a)
	{
		if (a === 0)
			return;
		mat4.rotateZ(this.matMV, a);
	};
	GLWrap_.prototype.updateModelView = function()
	{
		var anydiff = false;
		for (var i = 0; i < 16; i++)
		{
			if (this.lastMV[i] !== this.matMV[i])
			{
				anydiff = true;
				break;
			}
		}
		if (!anydiff)
			return;
		var b = this.pushBatch();
		b.type = BATCH_UPDATEMODELVIEW;
		if (b.mat4param)
			mat4.set(this.matMV, b.mat4param);
		else
			b.mat4param = mat4.create(this.matMV);
		mat4.set(this.matMV, this.lastMV);
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	/*
	var debugBatch = false;
	jQuery(document).mousedown(
		function(info) {
			if (info.which === 2)
				debugBatch = true;
		}
	);
	*/
	function GLBatchJob(type_, glwrap_)
	{
		this.type = type_;
		this.glwrap = glwrap_;
		this.gl = glwrap_.gl;
		this.opacityParam = 0;		// for setOpacity()
		this.startIndex = 0;		// for quad()
		this.indexCount = 0;		// "
		this.texParam = null;		// for setTexture()
		this.mat4param = null;		// for updateModelView()
		this.shaderParams = [];		// for user parameters
		cr.seal(this);
	};
	GLBatchJob.prototype.doSetTexture = function ()
	{
		this.gl.bindTexture(this.gl.TEXTURE_2D, this.texParam);
	};
	GLBatchJob.prototype.doSetTexture1 = function ()
	{
		var gl = this.gl;
		gl.activeTexture(gl.TEXTURE1);
		gl.bindTexture(gl.TEXTURE_2D, this.texParam);
		gl.activeTexture(gl.TEXTURE0);
	};
	GLBatchJob.prototype.doSetOpacity = function ()
	{
		var o = this.opacityParam;
		var glwrap = this.glwrap;
		glwrap.currentOpacity = o;
		var curProg = glwrap.currentShader;
		if (curProg.locOpacity)
			this.gl.uniform1f(curProg.locOpacity, o);
	};
	GLBatchJob.prototype.doQuad = function ()
	{
		this.gl.drawElements(this.gl.TRIANGLES, this.indexCount, this.gl.UNSIGNED_SHORT, this.startIndex * 2);
	};
	GLBatchJob.prototype.doSetBlend = function ()
	{
		this.gl.blendFunc(this.startIndex, this.indexCount);
	};
	GLBatchJob.prototype.doUpdateModelView = function ()
	{
		var i, len, s, shaderPrograms = this.glwrap.shaderPrograms, currentProgram = this.glwrap.currentProgram;
		for (i = 0, len = shaderPrograms.length; i < len; i++)
		{
			s = shaderPrograms[i];
			if (i === currentProgram && s.locMatMV)
			{
				this.gl.uniformMatrix4fv(s.locMatMV, false, this.mat4param);
				s.hasCurrentMatMV = true;
			}
			else
				s.hasCurrentMatMV = false;
		}
		mat4.set(this.mat4param, this.glwrap.currentMV);
	};
	GLBatchJob.prototype.doRenderToTexture = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		if (this.texParam)
		{
			if (glwrap.lastTexture1 === this.texParam)
			{
				gl.activeTexture(gl.TEXTURE1);
				gl.bindTexture(gl.TEXTURE_2D, null);
				glwrap.lastTexture1 = null;
				gl.activeTexture(gl.TEXTURE0);
			}
			gl.bindFramebuffer(gl.FRAMEBUFFER, glwrap.fbo);
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, this.texParam, 0);
		}
		else
		{
			gl.framebufferTexture2D(gl.FRAMEBUFFER, gl.COLOR_ATTACHMENT0, gl.TEXTURE_2D, null, 0);
			gl.bindFramebuffer(gl.FRAMEBUFFER, null);
		}
	};
	GLBatchJob.prototype.doClear = function ()
	{
		var gl = this.gl;
		if (this.startIndex === 0)		// clear whole surface
		{
			gl.clearColor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clear(gl.COLOR_BUFFER_BIT);
		}
		else							// clear rectangle
		{
			gl.enable(gl.SCISSOR_TEST);
			gl.scissor(this.mat4param[0], this.mat4param[1], this.mat4param[2], this.mat4param[3]);
			gl.clearColor(0, 0, 0, 0);
			gl.clear(this.gl.COLOR_BUFFER_BIT);
			gl.disable(gl.SCISSOR_TEST);
		}
	};
	GLBatchJob.prototype.doPoints = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[1];
		gl.useProgram(s.shaderProgram);
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		gl.enableVertexAttribArray(s.locAPos);
		gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.pointBuffer);
		gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		gl.drawArrays(gl.POINTS, this.startIndex / 4, this.indexCount);
		s = glwrap.currentShader;
		gl.useProgram(s.shaderProgram);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	};
	GLBatchJob.prototype.doSetProgram = function ()
	{
		var gl = this.gl;
		var glwrap = this.glwrap;
		var s = glwrap.shaderPrograms[this.startIndex];		// recycled param to save memory
		glwrap.currentProgram = this.startIndex;			// current batch program
		glwrap.currentShader = s;
		gl.useProgram(s.shaderProgram);						// switch to
		if (!s.hasCurrentMatMV && s.locMatMV)
		{
			gl.uniformMatrix4fv(s.locMatMV, false, glwrap.currentMV);
			s.hasCurrentMatMV = true;
		}
		if (s.locOpacity)
			gl.uniform1f(s.locOpacity, glwrap.currentOpacity);
		if (s.locAPos >= 0)
		{
			gl.enableVertexAttribArray(s.locAPos);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.vertexBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
		}
		if (s.locATex >= 0)
		{
			gl.enableVertexAttribArray(s.locATex);
			gl.bindBuffer(gl.ARRAY_BUFFER, glwrap.texcoordBuffers[glwrap.curBuffer]);
			gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
	}
	GLBatchJob.prototype.doSetProgramParameters = function ()
	{
		var i, len, s = this.glwrap.currentShader;
		var gl = this.gl;
		var mat4param = this.mat4param;
		if (s.locSamplerBack && this.glwrap.lastTexture1 !== this.texParam)
		{
			gl.activeTexture(gl.TEXTURE1);
			gl.bindTexture(gl.TEXTURE_2D, this.texParam);
			this.glwrap.lastTexture1 = this.texParam;
			gl.activeTexture(gl.TEXTURE0);
		}
		if (s.locPixelWidth)
			gl.uniform1f(s.locPixelWidth, mat4param[0]);
		if (s.locPixelHeight)
			gl.uniform1f(s.locPixelHeight, mat4param[1]);
		if (s.locDestStart)
			gl.uniform2f(s.locDestStart, mat4param[2], mat4param[3]);
		if (s.locDestEnd)
			gl.uniform2f(s.locDestEnd, mat4param[4], mat4param[5]);
		if (s.locLayerScale)
			gl.uniform1f(s.locLayerScale, mat4param[6]);
		if (s.locLayerAngle)
			gl.uniform1f(s.locLayerAngle, mat4param[7]);
		if (s.locViewOrigin)
			gl.uniform2f(s.locViewOrigin, mat4param[8], mat4param[9]);
		if (s.locSeconds)
			gl.uniform1f(s.locSeconds, cr.performance_now() / 1000.0);
		if (s.parameters.length)
		{
			for (i = 0, len = s.parameters.length; i < len; i++)
			{
				gl.uniform1f(s.parameters[i][1], this.shaderParams[i]);
			}
		}
	};
	GLWrap_.prototype.pushBatch = function ()
	{
		if (this.batchPtr === this.batch.length)
			this.batch.push(new GLBatchJob(BATCH_NULL, this));
		return this.batch[this.batchPtr++];
	};
	GLWrap_.prototype.endBatch = function ()
	{
		if (this.batchPtr === 0)
			return;
		if (this.gl.isContextLost())
			return;
		var gl = this.gl;
		if (this.pointPtr > 0)
		{
			gl.bindBuffer(gl.ARRAY_BUFFER, this.pointBuffer);
			gl.bufferData(gl.ARRAY_BUFFER, this.pointData.subarray(0, this.pointPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name === "<point>")
				gl.vertexAttribPointer(s.locAPos, 4, gl.FLOAT, false, 0, 0);
		}
		if (this.vertexPtr > 0)
		{
			var s = this.currentShader;
			gl.bindBuffer(gl.ARRAY_BUFFER, this.vertexBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.vertexData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locAPos >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locAPos, 2, gl.FLOAT, false, 0, 0);
			gl.bindBuffer(gl.ARRAY_BUFFER, this.texcoordBuffers[this.curBuffer]);
			gl.bufferData(gl.ARRAY_BUFFER, this.texcoordData.subarray(0, this.vertexPtr), gl.STREAM_DRAW);
			if (s && s.locATex >= 0 && s.name !== "<point>")
				gl.vertexAttribPointer(s.locATex, 2, gl.FLOAT, false, 0, 0);
		}
		var i, len, b;
		for (i = 0, len = this.batchPtr; i < len; i++)
		{
			b = this.batch[i];
			switch (b.type) {
			case 1:
				b.doQuad();
				break;
			case 2:
				b.doSetTexture();
				break;
			case 3:
				b.doSetOpacity();
				break;
			case 4:
				b.doSetBlend();
				break;
			case 5:
				b.doUpdateModelView();
				break;
			case 6:
				b.doRenderToTexture();
				break;
			case 7:
				b.doClear();
				break;
			case 8:
				b.doPoints();
				break;
			case 9:
				b.doSetProgram();
				break;
			case 10:
				b.doSetProgramParameters();
				break;
			case 11:
				b.doSetTexture1();
				break;
			}
		}
		this.batchPtr = 0;
		this.vertexPtr = 0;
		this.pointPtr = 0;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
		this.curBuffer++;
		if (this.curBuffer >= MULTI_BUFFERS)
			this.curBuffer = 0;
	};
	GLWrap_.prototype.setOpacity = function (op)
	{
		if (op === this.lastOpacity)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETOPACITY;
		b.opacityParam = op;
		this.lastOpacity = op;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setTexture = function (tex)
	{
		if (tex === this.lastTexture0)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_SETTEXTURE;
		b.texParam = tex;
		this.lastTexture0 = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.setBlend = function (s, d)
	{
		if (s === this.lastSrcBlend && d === this.lastDestBlend)
			return;
		var b = this.pushBatch();
		b.type = BATCH_SETBLEND;
		b.startIndex = s;		// recycle params to save memory
		b.indexCount = d;
		this.lastSrcBlend = s;
		this.lastDestBlend = d;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.isPremultipliedAlphaBlend = function ()
	{
		return (this.lastSrcBlend === this.gl.ONE && this.lastDestBlend === this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setAlphaBlend = function ()
	{
		this.setBlend(this.gl.ONE, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	GLWrap_.prototype.setNoPremultiplyAlphaBlend = function ()
	{
		this.setBlend(this.gl.SRC_ALPHA, this.gl.ONE_MINUS_SRC_ALPHA);
	};
	var LAST_VERTEX = MAX_VERTICES * 2 - 8;
	GLWrap_.prototype.quad = function(tlx, tly, trx, try_, brx, bry, blx, bly)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = 0;
		vd[v] = tly;
		td[v++] = 0;
		vd[v] = trx;
		td[v++] = 1;
		vd[v] = try_;
		td[v++] = 0;
		vd[v] = brx;
		td[v++] = 1;
		vd[v] = bry;
		td[v++] = 1;
		vd[v] = blx;
		td[v++] = 0;
		vd[v] = bly;
		td[v++] = 1;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTex = function(tlx, tly, trx, try_, brx, bry, blx, bly, rcTex)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		var rc_left = rcTex.left;
		var rc_top = rcTex.top;
		var rc_right = rcTex.right;
		var rc_bottom = rcTex.bottom;
		vd[v] = tlx;
		td[v++] = rc_left;
		vd[v] = tly;
		td[v++] = rc_top;
		vd[v] = trx;
		td[v++] = rc_right;
		vd[v] = try_;
		td[v++] = rc_top;
		vd[v] = brx;
		td[v++] = rc_right;
		vd[v] = bry;
		td[v++] = rc_bottom;
		vd[v] = blx;
		td[v++] = rc_left;
		vd[v] = bly;
		td[v++] = rc_bottom;
		this.vertexPtr = v;
	};
	GLWrap_.prototype.quadTexUV = function(tlx, tly, trx, try_, brx, bry, blx, bly, tlu, tlv, tru, trv, bru, brv, blu, blv)
	{
		if (this.vertexPtr >= LAST_VERTEX)
			this.endBatch();
		var v = this.vertexPtr;			// vertex cursor
		var vd = this.vertexData;		// vertex data array
		var td = this.texcoordData;		// texture coord data array
		if (this.hasQuadBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount += 6;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_QUAD;
			b.startIndex = (v / 4) * 3;
			b.indexCount = 6;
			this.hasQuadBatchTop = true;
			this.hasPointBatchTop = false;
		}
		vd[v] = tlx;
		td[v++] = tlu;
		vd[v] = tly;
		td[v++] = tlv;
		vd[v] = trx;
		td[v++] = tru;
		vd[v] = try_;
		td[v++] = trv;
		vd[v] = brx;
		td[v++] = bru;
		vd[v] = bry;
		td[v++] = brv;
		vd[v] = blx;
		td[v++] = blu;
		vd[v] = bly;
		td[v++] = blv;
		this.vertexPtr = v;
	};
	var LAST_POINT = MAX_POINTS - 4;
	GLWrap_.prototype.point = function(x_, y_, size_, opacity_)
	{
		if (this.pointPtr >= LAST_POINT)
			this.endBatch();
		var p = this.pointPtr;			// point cursor
		var pd = this.pointData;		// point data array
		if (this.hasPointBatchTop)
		{
			this.batch[this.batchPtr - 1].indexCount++;
		}
		else
		{
			var b = this.pushBatch();
			b.type = BATCH_POINTS;
			b.startIndex = p;
			b.indexCount = 1;
			this.hasPointBatchTop = true;
			this.hasQuadBatchTop = false;
		}
		pd[p++] = x_;
		pd[p++] = y_;
		pd[p++] = size_;
		pd[p++] = opacity_;
		this.pointPtr = p;
	};
	GLWrap_.prototype.switchProgram = function (progIndex)
	{
		if (this.lastProgram === progIndex)
			return;			// no change
		var shaderProg = this.shaderPrograms[progIndex];
		if (!shaderProg)
		{
			if (this.lastProgram === 0)
				return;								// already on default shader
			progIndex = 0;
			shaderProg = this.shaderPrograms[0];
		}
		var b = this.pushBatch();
		b.type = BATCH_SETPROGRAM;
		b.startIndex = progIndex;
		this.lastProgram = progIndex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.programUsesDest = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd);
	};
	GLWrap_.prototype.programUsesCrossSampling = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return !!(s.locDestStart || s.locDestEnd || s.crossSampling);
	};
	GLWrap_.prototype.programExtendsBox = function (progIndex)
	{
		var s = this.shaderPrograms[progIndex];
		return s.extendBoxHorizontal !== 0 || s.extendBoxVertical !== 0;
	};
	GLWrap_.prototype.getProgramBoxExtendHorizontal = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxHorizontal;
	};
	GLWrap_.prototype.getProgramBoxExtendVertical = function (progIndex)
	{
		return this.shaderPrograms[progIndex].extendBoxVertical;
	};
	GLWrap_.prototype.getProgramParameterType = function (progIndex, paramIndex)
	{
		return this.shaderPrograms[progIndex].parameters[paramIndex][2];
	};
	GLWrap_.prototype.programIsAnimated = function (progIndex)
	{
		return this.shaderPrograms[progIndex].animated;
	};
	GLWrap_.prototype.setProgramParameters = function (backTex, pixelWidth, pixelHeight, destStartX, destStartY, destEndX, destEndY, layerScale, layerAngle, viewOriginLeft, viewOriginTop, params)
	{
		var i, len;
		var s = this.shaderPrograms[this.lastProgram];
		var b, mat4param, shaderParams;
		if (s.hasAnyOptionalUniforms || params.length)
		{
			b = this.pushBatch();
			b.type = BATCH_SETPROGRAMPARAMETERS;
			if (b.mat4param)
				mat4.set(this.matMV, b.mat4param);
			else
				b.mat4param = mat4.create();
			mat4param = b.mat4param;
			mat4param[0] = pixelWidth;
			mat4param[1] = pixelHeight;
			mat4param[2] = destStartX;
			mat4param[3] = destStartY;
			mat4param[4] = destEndX;
			mat4param[5] = destEndY;
			mat4param[6] = layerScale;
			mat4param[7] = layerAngle;
			mat4param[8] = viewOriginLeft;
			mat4param[9] = viewOriginTop;
			if (s.locSamplerBack)
			{
;
				b.texParam = backTex;
			}
			else
				b.texParam = null;
			if (params.length)
			{
				shaderParams = b.shaderParams;
				shaderParams.length = params.length;
				for (i = 0, len = params.length; i < len; i++)
					shaderParams[i] = params[i];
			}
			this.hasQuadBatchTop = false;
			this.hasPointBatchTop = false;
		}
	};
	GLWrap_.prototype.clear = function (r, g, b_, a)
	{
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 0;					// clear all mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = r;
		b.mat4param[1] = g;
		b.mat4param[2] = b_;
		b.mat4param[3] = a;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.clearRect = function (x, y, w, h)
	{
		if (w < 0 || h < 0)
			return;							// invalid clear area
		var b = this.pushBatch();
		b.type = BATCH_CLEAR;
		b.startIndex = 1;					// clear rect mode
		if (!b.mat4param)
			b.mat4param = mat4.create();
		b.mat4param[0] = x;
		b.mat4param[1] = y;
		b.mat4param[2] = w;
		b.mat4param[3] = h;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	GLWrap_.prototype.present = function ()
	{
		this.endBatch();
		this.gl.flush();
		/*
		if (debugBatch)
		{
;
			debugBatch = false;
		}
		*/
	};
	function nextHighestPowerOfTwo(x) {
		--x;
		for (var i = 1; i < 32; i <<= 1) {
			x = x | x >> i;
		}
		return x + 1;
	}
	var all_textures = [];
	var textures_by_src = {};
	var BF_RGBA8 = 0;
	var BF_RGB8 = 1;
	var BF_RGBA4 = 2;
	var BF_RGB5_A1 = 3;
	var BF_RGB565 = 4;
	GLWrap_.prototype.loadTexture = function (img, tiling, linearsampling, pixelformat, tiletype)
	{
		tiling = !!tiling;
		linearsampling = !!linearsampling;
		var tex_key = img.src + "," + tiling + "," + linearsampling + (tiling ? ("," + tiletype) : "");
		var webGL_texture = null;
		if (typeof img.src !== "undefined" && textures_by_src.hasOwnProperty(tex_key))
		{
			webGL_texture = textures_by_src[tex_key];
			webGL_texture.c2refcount++;
			return webGL_texture;
		}
		this.endBatch();
;
		var gl = this.gl;
		var isPOT = (cr.isPOT(img.width) && cr.isPOT(img.height));
		webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		var internalformat = gl.RGBA;
		var format = gl.RGBA;
		var type = gl.UNSIGNED_BYTE;
		if (pixelformat && !this.isIE)
		{
			switch (pixelformat) {
			case BF_RGB8:
				internalformat = gl.RGB;
				format = gl.RGB;
				break;
			case BF_RGBA4:
				type = gl.UNSIGNED_SHORT_4_4_4_4;
				break;
			case BF_RGB5_A1:
				type = gl.UNSIGNED_SHORT_5_5_5_1;
				break;
			case BF_RGB565:
				internalformat = gl.RGB;
				format = gl.RGB;
				type = gl.UNSIGNED_SHORT_5_6_5;
				break;
			}
		}
		if (!isPOT && tiling)
		{
			var canvas = document.createElement("canvas");
			canvas.width = cr.nextHighestPowerOfTwo(img.width);
			canvas.height = cr.nextHighestPowerOfTwo(img.height);
			var ctx = canvas.getContext("2d");
			ctx["webkitImageSmoothingEnabled"] = linearsampling;
			ctx["mozImageSmoothingEnabled"] = linearsampling;
			ctx["msImageSmoothingEnabled"] = linearsampling;
			ctx["imageSmoothingEnabled"] = linearsampling;
			ctx.drawImage(img,
						  0, 0, img.width, img.height,
						  0, 0, canvas.width, canvas.height);
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, canvas);
		}
		else
			gl.texImage2D(gl.TEXTURE_2D, 0, internalformat, format, type, img);
		if (tiling)
		{
			if (tiletype === "repeat-x")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
			}
			else if (tiletype === "repeat-y")
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
			else
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
			}
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		if (linearsampling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.LINEAR);
			if (isPOT && this.enable_mipmaps)
			{
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR_MIPMAP_LINEAR);
				gl.generateMipmap(gl.TEXTURE_2D);
			}
			else
				gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.LINEAR);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, gl.NEAREST);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, gl.NEAREST);
		}
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = img.width;
		webGL_texture.c2height = img.height;
		webGL_texture.c2refcount = 1;
		webGL_texture.c2texkey = tex_key;
		all_textures.push(webGL_texture);
		textures_by_src[tex_key] = webGL_texture;
		return webGL_texture;
	};
	GLWrap_.prototype.createEmptyTexture = function (w, h, linearsampling, _16bit, tiling)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		var webGL_texture = gl.createTexture();
		gl.bindTexture(gl.TEXTURE_2D, webGL_texture);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, w, h, 0, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, null);
		if (tiling)
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.REPEAT);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.REPEAT);
		}
		else
		{
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_S, gl.CLAMP_TO_EDGE);
			gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_WRAP_T, gl.CLAMP_TO_EDGE);
		}
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MAG_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.texParameteri(gl.TEXTURE_2D, gl.TEXTURE_MIN_FILTER, linearsampling ? gl.LINEAR : gl.NEAREST);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
		webGL_texture.c2width = w;
		webGL_texture.c2height = h;
		all_textures.push(webGL_texture);
		return webGL_texture;
	};
	GLWrap_.prototype.videoToTexture = function (video_, texture_, _16bit)
	{
		this.endBatch();
		var gl = this.gl;
		if (this.isIE)
			_16bit = false;
		gl.bindTexture(gl.TEXTURE_2D, texture_);
		gl.pixelStorei(gl["UNPACK_PREMULTIPLY_ALPHA_WEBGL"], true);
		gl.texImage2D(gl.TEXTURE_2D, 0, gl.RGBA, gl.RGBA, _16bit ? gl.UNSIGNED_SHORT_4_4_4_4 : gl.UNSIGNED_BYTE, video_);
		gl.bindTexture(gl.TEXTURE_2D, null);
		this.lastTexture0 = null;
	};
	GLWrap_.prototype.deleteTexture = function (tex)
	{
		if (!tex)
			return;
		if (typeof tex.c2refcount !== "undefined" && tex.c2refcount > 1)
		{
			tex.c2refcount--;
			return;
		}
		this.endBatch();
		if (tex === this.lastTexture0)
		{
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.lastTexture0 = null;
		}
		if (tex === this.lastTexture1)
		{
			this.gl.activeTexture(this.gl.TEXTURE1);
			this.gl.bindTexture(this.gl.TEXTURE_2D, null);
			this.gl.activeTexture(this.gl.TEXTURE0);
			this.lastTexture1 = null;
		}
		cr.arrayFindRemove(all_textures, tex);
		if (typeof tex.c2texkey !== "undefined")
			delete textures_by_src[tex.c2texkey];
		this.gl.deleteTexture(tex);
	};
	GLWrap_.prototype.estimateVRAM = function ()
	{
		var total = this.width * this.height * 4 * 2;
		var i, len, t;
		for (i = 0, len = all_textures.length; i < len; i++)
		{
			t = all_textures[i];
			total += (t.c2width * t.c2height * 4);
		}
		return total;
	};
	GLWrap_.prototype.textureCount = function ()
	{
		return all_textures.length;
	};
	GLWrap_.prototype.setRenderingToTexture = function (tex)
	{
		if (tex === this.renderToTex)
			return;
;
		var b = this.pushBatch();
		b.type = BATCH_RENDERTOTEXTURE;
		b.texParam = tex;
		this.renderToTex = tex;
		this.hasQuadBatchTop = false;
		this.hasPointBatchTop = false;
	};
	cr.GLWrap = GLWrap_;
}());
;
(function()
{
	function Runtime(canvas)
	{
		if (!canvas || (!canvas.getContext && !canvas["dc"]))
			return;
		if (canvas["c2runtime"])
			return;
		else
			canvas["c2runtime"] = this;
		var self = this;
		this.isCrosswalk = /crosswalk/i.test(navigator.userAgent) || /xwalk/i.test(navigator.userAgent) || !!(typeof window["c2isCrosswalk"] !== "undefined" && window["c2isCrosswalk"]);
		this.isPhoneGap = (!this.isCrosswalk && (typeof window["device"] !== "undefined" && (typeof window["device"]["cordova"] !== "undefined" || typeof window["device"]["phonegap"] !== "undefined")));
		this.isDirectCanvas = !!canvas["dc"];
		this.isAppMobi = (typeof window["AppMobi"] !== "undefined" || this.isDirectCanvas);
		this.isCocoonJs = !!window["c2cocoonjs"];
		this.isEjecta = !!window["c2ejecta"];
		if (this.isCocoonJs)
		{
			CocoonJS["App"]["onSuspended"].addEventListener(function() {
				self["setSuspended"](true);
			});
			CocoonJS["App"]["onActivated"].addEventListener(function () {
				self["setSuspended"](false);
			});
		}
		if (this.isEjecta)
		{
			document.addEventListener("pagehide", function() {
				self["setSuspended"](true);
			});
			document.addEventListener("pageshow", function() {
				self["setSuspended"](false);
			});
			document.addEventListener("resize", function () {
				self["setSize"](window.innerWidth, window.innerHeight);
			});
		}
		this.isDomFree = (this.isDirectCanvas || this.isCocoonJs || this.isEjecta);
		this.isTizen = /tizen/i.test(navigator.userAgent);
		this.isAndroid = /android/i.test(navigator.userAgent) && !this.isTizen;		// tizen says "like Android"
		this.isIE = /msie/i.test(navigator.userAgent) || /trident/i.test(navigator.userAgent);
		this.isiPhone = /iphone/i.test(navigator.userAgent) || /ipod/i.test(navigator.userAgent);	// treat ipod as an iphone
		this.isiPad = /ipad/i.test(navigator.userAgent);
		this.isiOS = this.isiPhone || this.isiPad || this.isEjecta;
		this.isiPhoneiOS6 = (this.isiPhone && /os\s6/i.test(navigator.userAgent));
		this.isChrome = /chrome/i.test(navigator.userAgent) || /chromium/i.test(navigator.userAgent);
		this.isAmazonWebApp = /amazonwebappplatform/i.test(navigator.userAgent);
		this.isFirefox = /firefox/i.test(navigator.userAgent);
		this.isSafari = !this.isChrome && /safari/i.test(navigator.userAgent);		// Chrome includes Safari in UA
		this.isWindows = /windows/i.test(navigator.userAgent);
		this.isNodeWebkit = (typeof window["c2nodewebkit"] !== "undefined" || /nodewebkit/i.test(navigator.userAgent));
		this.isArcade = (typeof window["is_scirra_arcade"] !== "undefined");
		this.isWindows8App = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.isWindows8Capable = !!(typeof window["c2isWindows8Capable"] !== "undefined" && window["c2isWindows8Capable"]);
		this.isWindowsPhone8 = !!(typeof window["c2isWindowsPhone8"] !== "undefined" && window["c2isWindowsPhone8"]);
		this.isWindowsPhone81 = !!(typeof window["c2isWindowsPhone81"] !== "undefined" && window["c2isWindowsPhone81"]);
		this.isWinJS = (this.isWindows8App || this.isWindows8Capable || this.isWindowsPhone81);	// note not WP8.0
		this.isBlackberry10 = !!(typeof window["c2isBlackberry10"] !== "undefined" && window["c2isBlackberry10"]);
		this.isAndroidStockBrowser = (this.isAndroid && !this.isChrome && !this.isFirefox && !this.isAmazonWebApp && !this.isDomFree);
		this.devicePixelRatio = 1;
		this.isMobile = (this.isPhoneGap || this.isCrosswalk || this.isAppMobi || this.isCocoonJs || this.isAndroid || this.isiOS || this.isWindowsPhone8 || this.isWindowsPhone81 || this.isBlackberry10 || this.isTizen || this.isEjecta);
		if (!this.isMobile)
		{
			this.isMobile = /(blackberry|bb10|playbook|palm|symbian|nokia|windows\s+ce|phone|mobile|tablet|kindle|silk)/i.test(navigator.userAgent);
		}
		if (typeof cr_is_preview !== "undefined" && !this.isNodeWebkit && (window.location.search === "?nw" || /nodewebkit/i.test(navigator.userAgent)))
		{
			this.isNodeWebkit = true;
		}
		this.isDebug = (typeof cr_is_preview !== "undefined" && window.location.search.indexOf("debug") > -1)
		this.canvas = canvas;
		this.canvasdiv = document.getElementById("c2canvasdiv");
		this.gl = null;
		this.glwrap = null;
		this.ctx = null;
		this.fullscreenOldMarginCss = "";
		this.firstInFullscreen = false;
		this.oldWidth = 0;		// for restoring non-fullscreen canvas after fullscreen
		this.oldHeight = 0;
		this.canvas.oncontextmenu = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		this.canvas.onselectstart = function (e) { if (e.preventDefault) e.preventDefault(); return false; };
		if (this.isDirectCanvas)
			window["c2runtime"] = this;
		if (this.isNodeWebkit)
		{
			window.ondragover = function(e) { e.preventDefault(); return false; };
			window.ondrop = function(e) { e.preventDefault(); return false; };
			require("nw.gui")["App"]["clearCache"]();
		}
		this.width = canvas.width;
		this.height = canvas.height;
		this.draw_width = this.width;
		this.draw_height = this.height;
		this.cssWidth = this.width;
		this.cssHeight = this.height;
		this.lastWindowWidth = window.innerWidth;
		this.lastWindowHeight = window.innerHeight;
		this.redraw = true;
		this.isSuspended = false;
		if (!Date.now) {
		  Date.now = function now() {
			return +new Date();
		  };
		}
		this.plugins = [];
		this.types = {};
		this.types_by_index = [];
		this.behaviors = [];
		this.layouts = {};
		this.layouts_by_index = [];
		this.eventsheets = {};
		this.eventsheets_by_index = [];
		this.wait_for_textures = [];        // for blocking until textures loaded
		this.triggers_to_postinit = [];
		this.all_global_vars = [];
		this.all_local_vars = [];
		this.solidBehavior = null;
		this.jumpthruBehavior = null;
		this.deathRow = new cr.ObjectSet();
		this.isInClearDeathRow = false;
		this.isInOnDestroy = 0;					// needs to support recursion so increments and decrements and is true if > 0
		this.isRunningEvents = false;
		this.createRow = [];
		this.isLoadingState = false;
		this.saveToSlot = "";
		this.loadFromSlot = "";
		this.loadFromJson = "";
		this.lastSaveJson = "";
		this.signalledContinuousPreview = false;
		this.suspendDrawing = false;		// for hiding display until continuous preview loads
		this.dt = 0;
        this.dt1 = 0;
		this.logictime = 0;			// used to calculate CPUUtilisation
		this.cpuutilisation = 0;
		this.zeroDtCount = 0;
        this.timescale = 1.0;
        this.kahanTime = new cr.KahanAdder();
		this.last_tick_time = 0;
		this.measuring_dt = true;
		this.fps = 0;
		this.last_fps_time = 0;
		this.tickcount = 0;
		this.execcount = 0;
		this.framecount = 0;        // for fps
		this.objectcount = 0;
		this.changelayout = null;
		this.destroycallbacks = [];
		this.event_stack = [];
		this.event_stack_index = -1;
		this.localvar_stack = [[]];
		this.localvar_stack_index = 0;
		this.trigger_depth = 0;		// recursion depth for triggers
		this.pushEventStack(null);
		this.loop_stack = [];
		this.loop_stack_index = -1;
		this.next_uid = 0;
		this.next_puid = 0;		// permanent unique ids
		this.layout_first_tick = true;
		this.family_count = 0;
		this.suspend_events = [];
		this.raf_id = -1;
		this.timeout_id = -1;
		this.isloading = true;
		this.loadingprogress = 0;
		this.isNodeFullscreen = false;
		this.stackLocalCount = 0;	// number of stack-based local vars for recursion
		this.halfFramerateMode = false;
		this.lastRafTime = 0;		// time of last requestAnimationFrame call
		this.ranLastRaf = false;	// false if last requestAnimationFrame was skipped for half framerate mode
		this.had_a_click = false;
		this.isInUserInputEvent = false;
        this.objects_to_tick = new cr.ObjectSet();
		this.objects_to_tick2 = new cr.ObjectSet();
		this.registered_collisions = [];
		this.temp_poly = new cr.CollisionPoly([]);
		this.temp_poly2 = new cr.CollisionPoly([]);
		this.allGroups = [];				// array of all event groups
        this.groups_by_name = {};
		this.cndsBySid = {};
		this.actsBySid = {};
		this.varsBySid = {};
		this.blocksBySid = {};
		this.running_layout = null;			// currently running layout
		this.layer_canvas = null;			// for layers "render-to-texture"
		this.layer_ctx = null;
		this.layer_tex = null;
		this.layout_tex = null;
		this.layout_canvas = null;
		this.layout_ctx = null;
		this.is_WebGL_context_lost = false;
		this.uses_background_blending = false;	// if any shader uses background blending, so entire layout renders to texture
		this.fx_tex = [null, null];
		this.fullscreen_scaling = 0;
		this.files_subfolder = "";			// path with project files
		this.objectsByUid = {};				// maps every in-use UID (as a string) to its instance
		this.loaderlogo = null;
		this.snapshotCanvas = null;
		this.snapshotData = "";
		this.load();
		this.isRetina = ((!this.isDomFree || this.isEjecta) && this.useHighDpi && !this.isAndroidStockBrowser);
		this.devicePixelRatio = (this.isRetina ? (window["devicePixelRatio"] || window["webkitDevicePixelRatio"] || window["mozDevicePixelRatio"] || window["msDevicePixelRatio"] || 1) : 1);
		this.ClearDeathRow();
		var attribs;
		var alpha_canvas = this.alphaBackground && !(this.isNodeWebkit || this.isWinJS || this.isWindowsPhone8 || this.isCrosswalk);
		if (this.fullscreen_mode > 0)
			this["setSize"](window.innerWidth, window.innerHeight, true);
		try {
			if (this.enableWebGL && (this.isCocoonJs || this.isEjecta || !this.isDomFree))
			{
				attribs = {
					"alpha": alpha_canvas,
					"depth": false,
					"antialias": false,
					"failIfMajorPerformanceCaveat": true
				};
				this.gl = (canvas.getContext("webgl", attribs) || canvas.getContext("experimental-webgl", attribs));
			}
		}
		catch (e) {
		}
		if (this.gl)
		{
;
			if (!this.isDomFree)
			{
				this.overlay_canvas = document.createElement("canvas");
				jQuery(this.overlay_canvas).appendTo(this.canvas.parentNode);
				this.overlay_canvas.oncontextmenu = function (e) { return false; };
				this.overlay_canvas.onselectstart = function (e) { return false; };
				this.overlay_canvas.width = this.cssWidth;
				this.overlay_canvas.height = this.cssHeight;
				jQuery(this.overlay_canvas).css({"width": this.cssWidth + "px",
												"height": this.cssHeight + "px"});
				this.positionOverlayCanvas();
				this.overlay_ctx = this.overlay_canvas.getContext("2d");
			}
			this.glwrap = new cr.GLWrap(this.gl, this.isMobile);
			this.glwrap.setSize(canvas.width, canvas.height);
			this.glwrap.enable_mipmaps = (this.downscalingQuality !== 0);
			this.ctx = null;
			this.canvas.addEventListener("webglcontextlost", function (ev) {
				ev.preventDefault();
				self.onContextLost();
				console.log("[Construct 2] WebGL context lost");
				window["cr_setSuspended"](true);		// stop rendering
			}, false);
			this.canvas.addEventListener("webglcontextrestored", function (ev) {
				self.glwrap.initState();
				self.glwrap.setSize(self.glwrap.width, self.glwrap.height, true);
				self.layer_tex = null;
				self.layout_tex = null;
				self.fx_tex[0] = null;
				self.fx_tex[1] = null;
				self.onContextRestored();
				self.redraw = true;
				console.log("[Construct 2] WebGL context restored");
				window["cr_setSuspended"](false);		// resume rendering
			}, false);
			var i, len, j, lenj, k, lenk, t, s, l, y;
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
				{
					s = t.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
					this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
				}
			}
			for (i = 0, len = this.layouts_by_index.length; i < len; i++)
			{
				l = this.layouts_by_index[i];
				for (j = 0, lenj = l.effect_types.length; j < lenj; j++)
				{
					s = l.effect_types[j];
					s.shaderindex = this.glwrap.getShaderIndex(s.id);
				}
				for (j = 0, lenj = l.layers.length; j < lenj; j++)
				{
					y = l.layers[j];
					for (k = 0, lenk = y.effect_types.length; k < lenk; k++)
					{
						s = y.effect_types[k];
						s.shaderindex = this.glwrap.getShaderIndex(s.id);
						this.uses_background_blending = this.uses_background_blending || this.glwrap.programUsesDest(s.shaderindex);
					}
				}
			}
		}
		else
		{
			if (this.fullscreen_mode > 0 && this.isDirectCanvas)
			{
;
				this.canvas = null;
				document.oncontextmenu = function (e) { return false; };
				document.onselectstart = function (e) { return false; };
				this.ctx = AppMobi["canvas"]["getContext"]("2d");
				try {
					this.ctx["samplingMode"] = this.linearSampling ? "smooth" : "sharp";
					this.ctx["globalScale"] = 1;
					this.ctx["HTML5CompatibilityMode"] = true;
					this.ctx["imageSmoothingEnabled"] = this.linearSampling;
				} catch(e){}
				if (this.width !== 0 && this.height !== 0)
				{
					this.ctx.width = this.width;
					this.ctx.height = this.height;
				}
			}
			if (!this.ctx)
			{
;
				if (this.isCocoonJs)
				{
					attribs = {
						"antialias": !!this.linearSampling,
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				else
				{
					attribs = {
						"alpha": alpha_canvas
					};
					this.ctx = canvas.getContext("2d", attribs);
				}
				this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
				this.ctx["imageSmoothingEnabled"] = this.linearSampling;
			}
			this.overlay_canvas = null;
			this.overlay_ctx = null;
		}
		this.tickFunc = function () { self.tick(false); };
		if (window != window.top && !this.isDomFree && !this.isWinJS && !this.isWindowsPhone8)
		{
			document.addEventListener("mousedown", function () {
				window.focus();
			}, true);
			document.addEventListener("touchstart", function () {
				window.focus();
			}, true);
		}
		if (typeof cr_is_preview !== "undefined")
		{
			if (this.isCocoonJs)
				console.log("[Construct 2] In preview-over-wifi via CocoonJS mode");
			if (window.location.search.indexOf("continuous") > -1)
			{
				cr.logexport("Reloading for continuous preview");
				this.loadFromSlot = "__c2_continuouspreview";
				this.suspendDrawing = true;
			}
			if (this.pauseOnBlur && !this.isMobile)
			{
				jQuery(window).focus(function ()
				{
					self["setSuspended"](false);
				});
				jQuery(window).blur(function ()
				{
					self["setSuspended"](true);
				});
			}
		}
		if (this.fullscreen_mode === 0 && this.isRetina && this.devicePixelRatio > 1)
		{
			this["setSize"](this.original_width, this.original_height, true);
		}
		this.tryLockOrientation();
		this.go();			// run loading screen
		this.extra = {};
		cr.seal(this);
	};
	var webkitRepaintFlag = false;
	Runtime.prototype["setSize"] = function (w, h, force)
	{
		var offx = 0, offy = 0;
		var neww = 0, newh = 0, intscale = 0;
		var tryHideAddressBar = (this.isiPhoneiOS6 && this.isSafari && !navigator["standalone"] && !this.isDomFree && !this.isPhoneGap);
		if (tryHideAddressBar)
			h += 60;		// height of Safari iPhone iOS 6 address bar
		if (this.lastWindowWidth === w && this.lastWindowHeight === h && !force)
			return;
		this.lastWindowWidth = w;
		this.lastWindowHeight = h;
		var mode = this.fullscreen_mode;
		var orig_aspect, cur_aspect;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.fullscreen_mode === 0 && !force)
			return;			// ignore size events when not fullscreen and not using a fullscreen-in-browser mode
		if (isfullscreen && this.fullscreen_scaling > 0)
			mode = this.fullscreen_scaling;
		if (mode >= 4)
		{
			orig_aspect = this.original_width / this.original_height;
			cur_aspect = w / h;
			if (cur_aspect > orig_aspect)
			{
				neww = h * orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = neww / this.original_width;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offx = (w - neww) / 2;
					w = neww;
				}
			}
			else
			{
				newh = w / orig_aspect;
				if (mode === 5)	// integer scaling
				{
					intscale = newh / this.original_height;
					if (intscale > 1)
						intscale = Math.floor(intscale);
					else if (intscale < 1)
						intscale = 1 / Math.ceil(1 / intscale);
					neww = this.original_width * intscale;
					newh = this.original_height * intscale;
					offx = (w - neww) / 2;
					offy = (h - newh) / 2;
					w = neww;
					h = newh;
				}
				else
				{
					offy = (h - newh) / 2;
					h = newh;
				}
			}
			if (isfullscreen && !this.isNodeWebkit)
			{
				offx = 0;
				offy = 0;
			}
			offx = Math.floor(offx);
			offy = Math.floor(offy);
			w = Math.floor(w);
			h = Math.floor(h);
		}
		else if (this.isNodeWebkit && this.isNodeFullscreen && this.fullscreen_mode_set === 0)
		{
			offx = Math.floor((w - this.original_width) / 2);
			offy = Math.floor((h - this.original_height) / 2);
			w = this.original_width;
			h = this.original_height;
		}
		if (mode < 2)
			this.aspect_scale = this.devicePixelRatio;
		if (this.isRetina && this.isiPad && this.devicePixelRatio > 1)	// don't apply to iPad 1-2
		{
			if (w >= 1024)
				w = 1023;		// 2046 retina pixels
			if (h >= 1024)
				h = 1023;
		}
		var multiplier = this.devicePixelRatio;
		this.cssWidth = w;
		this.cssHeight = h;
		this.width = Math.round(w * multiplier);
		this.height = Math.round(h * multiplier);
		this.redraw = true;
		if (this.wantFullscreenScalingQuality)
		{
			this.draw_width = this.width;
			this.draw_height = this.height;
			this.fullscreenScalingQuality = true;
		}
		else
		{
			if ((this.width < this.original_width && this.height < this.original_height) || mode === 1)
			{
				this.draw_width = this.width;
				this.draw_height = this.height;
				this.fullscreenScalingQuality = true;
			}
			else
			{
				this.draw_width = this.original_width;
				this.draw_height = this.original_height;
				this.fullscreenScalingQuality = false;
				/*var orig_aspect = this.original_width / this.original_height;
				var cur_aspect = this.width / this.height;
				if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
					this.aspect_scale = this.height / this.original_height;
				else
					this.aspect_scale = this.width / this.original_width;*/
				if (mode === 2)		// scale inner
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect < orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect > orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
				else if (mode === 3)
				{
					orig_aspect = this.original_width / this.original_height;
					cur_aspect = this.lastWindowWidth / this.lastWindowHeight;
					if (cur_aspect > orig_aspect)
						this.draw_width = this.draw_height * cur_aspect;
					else if (cur_aspect < orig_aspect)
						this.draw_height = this.draw_width / cur_aspect;
				}
			}
		}
		if (this.canvasdiv && !this.isDomFree)
		{
			jQuery(this.canvasdiv).css({"width": w + "px",
										"height": h + "px",
										"margin-left": offx,
										"margin-top": offy});
			if (typeof cr_is_preview !== "undefined")
			{
				jQuery("#borderwrap").css({"width": w + "px",
											"height": h + "px"});
			}
		}
		if (this.canvas)
		{
			this.canvas.width = Math.round(w * multiplier);
			this.canvas.height = Math.round(h * multiplier);
			if (this.isEjecta)
			{
				this.canvas.style.left = offx + "px";
				this.canvas.style.top = offy + "px";
				this.canvas.style.width = w + "px";
				this.canvas.style.height = h + "px";
			}
			else if (this.isRetina && !this.isDomFree)
			{
				jQuery(this.canvas).css({"width": w + "px",
										"height": h + "px"});
			}
		}
		if (this.overlay_canvas)
		{
			this.overlay_canvas.width = w;
			this.overlay_canvas.height = h;
			jQuery(this.overlay_canvas).css({"width": w + "px",
											"height": h + "px"});
		}
		if (this.glwrap)
		{
			this.glwrap.setSize(Math.round(w * multiplier), Math.round(h * multiplier));
		}
		if (this.isDirectCanvas && this.ctx)
		{
			this.ctx.width = w;
			this.ctx.height = h;
		}
		if (this.ctx)
		{
			this.ctx["webkitImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["mozImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["msImageSmoothingEnabled"] = this.linearSampling;
			this.ctx["imageSmoothingEnabled"] = this.linearSampling;
		}
		this.tryLockOrientation();
		if (!this.isDomFree && (tryHideAddressBar || this.isiPhone))
		{
			window.setTimeout(function () {
				window.scrollTo(0, 1);
			}, 100);
		}
	};
	Runtime.prototype.tryLockOrientation = function ()
	{
		if (!this.autoLockOrientation || this.orientations === 0)
			return;
		var orientation = "portrait";
		if (this.orientations === 2)
			orientation = "landscape";
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Runtime.prototype.onContextLost = function ()
	{
		this.is_WebGL_context_lost = true;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onLostWebGLContext)
				t.onLostWebGLContext();
		}
	};
	Runtime.prototype.onContextRestored = function ()
	{
		this.is_WebGL_context_lost = false;
		var i, len, t;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onRestoreWebGLContext)
				t.onRestoreWebGLContext();
		}
	};
	Runtime.prototype.positionOverlayCanvas = function()
	{
		if (this.isDomFree)
			return;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		var overlay_position = isfullscreen ? jQuery(this.canvas).offset() : jQuery(this.canvas).position();
		overlay_position.position = "absolute";
		jQuery(this.overlay_canvas).css(overlay_position);
	};
	var caf = window["cancelAnimationFrame"] ||
	  window["mozCancelAnimationFrame"]    ||
	  window["webkitCancelAnimationFrame"] ||
	  window["msCancelAnimationFrame"]     ||
	  window["oCancelAnimationFrame"];
	Runtime.prototype["setSuspended"] = function (s)
	{
		var i, len;
		if (s && !this.isSuspended)
		{
			cr.logexport("[Construct 2] Suspending");
			this.isSuspended = true;			// next tick will be last
			if (this.raf_id !== -1 && caf)		// note: CocoonJS does not implement cancelAnimationFrame
				caf(this.raf_id);
			if (this.timeout_id !== -1)
				clearTimeout(this.timeout_id);
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](true);
		}
		else if (!s && this.isSuspended)
		{
			cr.logexport("[Construct 2] Resuming");
			this.isSuspended = false;
			this.last_tick_time = cr.performance_now();	// ensure first tick is a zero-dt one
			this.last_fps_time = cr.performance_now();	// reset FPS counter
			this.framecount = 0;
			this.logictime = 0;
			for (i = 0, len = this.suspend_events.length; i < len; i++)
				this.suspend_events[i](false);
			this.tick(false);						// kick off runtime again
		}
	};
	Runtime.prototype.addSuspendCallback = function (f)
	{
		this.suspend_events.push(f);
	};
	Runtime.prototype.load = function ()
	{
;
		var pm = cr.getProjectModel();
		this.name = pm[0];
		this.first_layout = pm[1];
		this.fullscreen_mode = pm[11];	// 0 = off, 1 = crop, 2 = scale inner, 3 = scale outer, 4 = letterbox scale, 5 = integer letterbox scale
		this.fullscreen_mode_set = pm[11];
		this.original_width = pm[9];
		this.original_height = pm[10];
		this.parallax_x_origin = this.original_width / 2;
		this.parallax_y_origin = this.original_height / 2;
		if (this.isDomFree && !this.isEjecta && (pm[11] >= 4 || pm[11] === 0))
		{
			cr.logexport("[Construct 2] Letterbox scale fullscreen modes are not supported on this platform - falling back to 'Scale outer'");
			this.fullscreen_mode = 3;
			this.fullscreen_mode_set = 3;
		}
		this.uses_loader_layout = pm[17];
		this.loaderstyle = pm[18];
		if (this.loaderstyle === 0)
		{
			this.loaderlogo = new Image();
			this.loaderlogo.src = "loading-logo.png";
		}
		this.next_uid = pm[20];
		this.system = new cr.system_object(this);
		var i, len, j, lenj, k, lenk, idstr, m, b, t, f;
		var plugin, plugin_ctor;
		for (i = 0, len = pm[2].length; i < len; i++)
		{
			m = pm[2][i];
;
			cr.add_common_aces(m);
			plugin = new m[0](this);
			plugin.singleglobal = m[1];
			plugin.is_world = m[2];
			plugin.must_predraw = m[9];
			if (plugin.onCreate)
				plugin.onCreate();  // opportunity to override default ACEs
			cr.seal(plugin);
			this.plugins.push(plugin);
		}
		pm = cr.getProjectModel();
		for (i = 0, len = pm[3].length; i < len; i++)
		{
			m = pm[3][i];
			plugin_ctor = m[1];
;
			plugin = null;
			for (j = 0, lenj = this.plugins.length; j < lenj; j++)
			{
				if (this.plugins[j] instanceof plugin_ctor)
				{
					plugin = this.plugins[j];
					break;
				}
			}
;
;
			var type_inst = new plugin.Type(plugin);
;
			type_inst.name = m[0];
			type_inst.is_family = m[2];
			type_inst.instvar_sids = m[3].slice(0);
			type_inst.vars_count = m[3].length;
			type_inst.behs_count = m[4];
			type_inst.fx_count = m[5];
			type_inst.sid = m[11];
			if (type_inst.is_family)
			{
				type_inst.members = [];				// types in this family
				type_inst.family_index = this.family_count++;
				type_inst.families = null;
			}
			else
			{
				type_inst.members = null;
				type_inst.family_index = -1;
				type_inst.families = [];			// families this type belongs to
			}
			type_inst.family_var_map = null;
			type_inst.family_beh_map = null;
			type_inst.family_fx_map = null;
			type_inst.is_contained = false;
			type_inst.container = null;
			if (m[6])
			{
				type_inst.texture_file = m[6][0];
				type_inst.texture_filesize = m[6][1];
				type_inst.texture_pixelformat = m[6][2];
			}
			else
			{
				type_inst.texture_file = null;
				type_inst.texture_filesize = 0;
				type_inst.texture_pixelformat = 0;		// rgba8
			}
			if (m[7])
			{
				type_inst.animations = m[7];
			}
			else
			{
				type_inst.animations = null;
			}
			type_inst.index = i;                                // save index in to types array in type
			type_inst.instances = [];                           // all instances of this type
			type_inst.deadCache = [];							// destroyed instances to recycle next create
			type_inst.solstack = [new cr.selection(type_inst)]; // initialise SOL stack with one empty SOL
			type_inst.cur_sol = 0;
			type_inst.default_instance = null;
			type_inst.default_layerindex = 0;
			type_inst.stale_iids = true;
			type_inst.updateIIDs = cr.type_updateIIDs;
			type_inst.getFirstPicked = cr.type_getFirstPicked;
			type_inst.getPairedInstance = cr.type_getPairedInstance;
			type_inst.getCurrentSol = cr.type_getCurrentSol;
			type_inst.pushCleanSol = cr.type_pushCleanSol;
			type_inst.pushCopySol = cr.type_pushCopySol;
			type_inst.popSol = cr.type_popSol;
			type_inst.getBehaviorByName = cr.type_getBehaviorByName;
			type_inst.getBehaviorIndexByName = cr.type_getBehaviorIndexByName;
			type_inst.getEffectIndexByName = cr.type_getEffectIndexByName;
			type_inst.applySolToContainer = cr.type_applySolToContainer;
			type_inst.getInstanceByIID = cr.type_getInstanceByIID;
			type_inst.collision_grid = new cr.SparseGrid(this.original_width, this.original_height);
			type_inst.any_cell_changed = true;
			type_inst.any_instance_parallaxed = false;
			type_inst.extra = {};
			type_inst.toString = cr.type_toString;
			type_inst.behaviors = [];
			for (j = 0, lenj = m[8].length; j < lenj; j++)
			{
				b = m[8][j];
				var behavior_ctor = b[1];
				var behavior_plugin = null;
				for (k = 0, lenk = this.behaviors.length; k < lenk; k++)
				{
					if (this.behaviors[k] instanceof behavior_ctor)
					{
						behavior_plugin = this.behaviors[k];
						break;
					}
				}
				if (!behavior_plugin)
				{
					behavior_plugin = new behavior_ctor(this);
					behavior_plugin.my_types = [];						// types using this behavior
					behavior_plugin.my_instances = new cr.ObjectSet(); 	// instances of this behavior
					if (behavior_plugin.onCreate)
						behavior_plugin.onCreate();
					cr.seal(behavior_plugin);
					this.behaviors.push(behavior_plugin);
					if (cr.behaviors.solid && behavior_plugin instanceof cr.behaviors.solid)
						this.solidBehavior = behavior_plugin;
					if (cr.behaviors.jumpthru && behavior_plugin instanceof cr.behaviors.jumpthru)
						this.jumpthruBehavior = behavior_plugin;
				}
				if (behavior_plugin.my_types.indexOf(type_inst) === -1)
					behavior_plugin.my_types.push(type_inst);
				var behavior_type = new behavior_plugin.Type(behavior_plugin, type_inst);
				behavior_type.name = b[0];
				behavior_type.sid = b[2];
				behavior_type.onCreate();
				cr.seal(behavior_type);
				type_inst.behaviors.push(behavior_type);
			}
			type_inst.global = m[9];
			type_inst.isOnLoaderLayout = m[10];
			type_inst.effect_types = [];
			for (j = 0, lenj = m[12].length; j < lenj; j++)
			{
				type_inst.effect_types.push({
					id: m[12][j][0],
					name: m[12][j][1],
					shaderindex: -1,
					active: true,
					index: j
				});
			}
			type_inst.tile_poly_data = m[13];
			if (!this.uses_loader_layout || type_inst.is_family || type_inst.isOnLoaderLayout || !plugin.is_world)
			{
				type_inst.onCreate();
				cr.seal(type_inst);
			}
			if (type_inst.name)
				this.types[type_inst.name] = type_inst;
			this.types_by_index.push(type_inst);
			if (plugin.singleglobal)
			{
				var instance = new plugin.Instance(type_inst);
				instance.uid = this.next_uid++;
				instance.puid = this.next_puid++;
				instance.iid = 0;
				instance.get_iid = cr.inst_get_iid;
				instance.toString = cr.inst_toString;
				instance.properties = m[14];
				instance.onCreate();
				cr.seal(instance);
				type_inst.instances.push(instance);
				this.objectsByUid[instance.uid.toString()] = instance;
			}
		}
		for (i = 0, len = pm[4].length; i < len; i++)
		{
			var familydata = pm[4][i];
			var familytype = this.types_by_index[familydata[0]];
			var familymember;
			for (j = 1, lenj = familydata.length; j < lenj; j++)
			{
				familymember = this.types_by_index[familydata[j]];
				familymember.families.push(familytype);
				familytype.members.push(familymember);
			}
		}
		for (i = 0, len = pm[24].length; i < len; i++)
		{
			var containerdata = pm[24][i];
			var containertypes = [];
			for (j = 0, lenj = containerdata.length; j < lenj; j++)
				containertypes.push(this.types_by_index[containerdata[j]]);
			for (j = 0, lenj = containertypes.length; j < lenj; j++)
			{
				containertypes[j].is_contained = true;
				containertypes[j].container = containertypes;
			}
		}
		if (this.family_count > 0)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (t.is_family || !t.families.length)
					continue;
				t.family_var_map = new Array(this.family_count);
				t.family_beh_map = new Array(this.family_count);
				t.family_fx_map = new Array(this.family_count);
				var all_fx = [];
				var varsum = 0;
				var behsum = 0;
				var fxsum = 0;
				for (j = 0, lenj = t.families.length; j < lenj; j++)
				{
					f = t.families[j];
					t.family_var_map[f.family_index] = varsum;
					varsum += f.vars_count;
					t.family_beh_map[f.family_index] = behsum;
					behsum += f.behs_count;
					t.family_fx_map[f.family_index] = fxsum;
					fxsum += f.fx_count;
					for (k = 0, lenk = f.effect_types.length; k < lenk; k++)
						all_fx.push(cr.shallowCopy({}, f.effect_types[k]));
				}
				t.effect_types = all_fx.concat(t.effect_types);
				for (j = 0, lenj = t.effect_types.length; j < lenj; j++)
					t.effect_types[j].index = j;
			}
		}
		for (i = 0, len = pm[5].length; i < len; i++)
		{
			m = pm[5][i];
			var layout = new cr.layout(this, m);
			cr.seal(layout);
			this.layouts[layout.name] = layout;
			this.layouts_by_index.push(layout);
		}
		for (i = 0, len = pm[6].length; i < len; i++)
		{
			m = pm[6][i];
			var sheet = new cr.eventsheet(this, m);
			cr.seal(sheet);
			this.eventsheets[sheet.name] = sheet;
			this.eventsheets_by_index.push(sheet);
		}
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].postInit();
		for (i = 0, len = this.eventsheets_by_index.length; i < len; i++)
			this.eventsheets_by_index[i].updateDeepIncludes();
		for (i = 0, len = this.triggers_to_postinit.length; i < len; i++)
			this.triggers_to_postinit[i].postInit();
		this.triggers_to_postinit.length = 0;
		this.files_subfolder = pm[7];
		this.pixel_rounding = pm[8];
		this.aspect_scale = 1.0;
		this.enableWebGL = pm[12];
		this.linearSampling = pm[13];
		this.alphaBackground = pm[14];
		this.versionstr = pm[15];
		this.useHighDpi = pm[16];
		this.orientations = pm[19];		// 0 = any, 1 = portrait, 2 = landscape
		this.autoLockOrientation = (this.orientations > 0);
		this.pauseOnBlur = pm[21];
		this.wantFullscreenScalingQuality = pm[22];		// false = low quality, true = high quality
		this.fullscreenScalingQuality = this.wantFullscreenScalingQuality;
		this.downscalingQuality = pm[23];	// 0 = low (mips off), 1 = medium (mips on, dense spritesheet), 2 = high (mips on, sparse spritesheet)
		this.start_time = Date.now();
	};
	var anyImageHadError = false;
	Runtime.prototype.waitForImageLoad = function (img_)
	{
		img_.onerror = function (e)
		{
			img_.c2error = true;
			anyImageHadError = true;
			if (console && console.error)
				console.error("Error loading image '" + img_.src + "': ", e);
		};
		this.wait_for_textures.push(img_);
	};
	Runtime.prototype.findWaitingTexture = function (src_)
	{
		var i, len;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			if (this.wait_for_textures[i].cr_src === src_)
				return this.wait_for_textures[i];
		}
		return null;
	};
	Runtime.prototype.areAllTexturesLoaded = function ()
	{
		var totalsize = 0;
		var completedsize = 0;
		var ret = true;
		var i, len, img;
		for (i = 0, len = this.wait_for_textures.length; i < len; i++)
		{
			img = this.wait_for_textures[i];
			var filesize = img.cr_filesize;
			if (!filesize || filesize <= 0)
				filesize = 50000;
			totalsize += filesize;
			if ((img.complete || img["loaded"]) && !img.c2error)
				completedsize += filesize;
			else
				ret = false;    // not all textures loaded
		}
		if (totalsize == 0)
			this.progress = 0;
		else
			this.progress = (completedsize / totalsize);
		return ret;
	};
	Runtime.prototype.go = function ()
	{
		if (!this.ctx && !this.glwrap)
			return;
		var ctx = this.ctx || this.overlay_ctx;
		if (this.overlay_canvas)
			this.positionOverlayCanvas();
		this.progress = 0;
		this.last_progress = -1;
		if (this.areAllTexturesLoaded())
			this.go_textures_done();
		else
		{
			var ms_elapsed = Date.now() - this.start_time;
			if (ctx)
			{
				var overlay_width = this.width;
				var overlay_height = this.height;
				var multiplier = this.devicePixelRatio;
				if (this.overlay_canvas)
				{
					overlay_width = this.cssWidth;
					overlay_height = this.cssHeight;
					multiplier = 1;
				}
				if (this.loaderstyle !== 3 && (this.isCocoonJs || (ms_elapsed >= 500 && this.last_progress != this.progress)))
				{
					ctx.clearRect(0, 0, overlay_width, overlay_height);
					var mx = overlay_width / 2;
					var my = overlay_height / 2;
					var haslogo = (this.loaderstyle === 0 && this.loaderlogo.complete);
					var hlw = 40 * multiplier;
					var hlh = 0;
					var logowidth = 80 * multiplier;
					var logoheight;
					if (haslogo)
					{
						logowidth = this.loaderlogo.width * multiplier;
						logoheight = this.loaderlogo.height * multiplier;
						hlw = logowidth / 2;
						hlh = logoheight / 2;
						ctx.drawImage(this.loaderlogo, cr.floor(mx - hlw), cr.floor(my - hlh), logowidth, logoheight);
					}
					if (this.loaderstyle <= 1)
					{
						my += hlh + (haslogo ? 12 * multiplier : 0);
						mx -= hlw;
						mx = cr.floor(mx) + 0.5;
						my = cr.floor(my) + 0.5;
						ctx.fillStyle = anyImageHadError ? "red" : "DodgerBlue";
						ctx.fillRect(mx, my, Math.floor(logowidth * this.progress), 6 * multiplier);
						ctx.strokeStyle = "black";
						ctx.strokeRect(mx, my, logowidth, 6 * multiplier);
						ctx.strokeStyle = "white";
						ctx.strokeRect(mx - 1 * multiplier, my - 1 * multiplier, logowidth + 2 * multiplier, 8 * multiplier);
					}
					else if (this.loaderstyle === 2)
					{
						ctx.font = (this.isEjecta ? "12pt ArialMT" : "12pt Arial");
						ctx.fillStyle = anyImageHadError ? "#f00" : "#999";
						ctx.textBaseLine = "middle";
						var percent_text = Math.round(this.progress * 100) + "%";
						var text_dim = ctx.measureText ? ctx.measureText(percent_text) : null;
						var text_width = text_dim ? text_dim.width : 0;
						ctx.fillText(percent_text, mx - (text_width / 2), my);
					}
				}
				this.last_progress = this.progress;
			}
			setTimeout((function (self) { return function () { self.go(); }; })(this), (this.isCocoonJs ? 10 : 100));
		}
	};
	Runtime.prototype.go_textures_done = function ()
	{
		if (this.overlay_canvas)
		{
			this.canvas.parentNode.removeChild(this.overlay_canvas);
			this.overlay_ctx = null;
			this.overlay_canvas = null;
		}
		this.start_time = Date.now();
		this.last_fps_time = cr.performance_now();       // for counting framerate
		var i, len, t;
		if (this.uses_loader_layout)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				t = this.types_by_index[i];
				if (!t.is_family && !t.isOnLoaderLayout && t.plugin.is_world)
				{
					t.onCreate();
					cr.seal(t);
				}
			}
		}
		else
			this.isloading = false;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			this.layouts_by_index[i].createGlobalNonWorlds();
		}
		if (this.fullscreen_mode >= 2)
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			if ((this.fullscreen_mode !== 2 && cur_aspect > orig_aspect) || (this.fullscreen_mode === 2 && cur_aspect < orig_aspect))
				this.aspect_scale = this.height / this.original_height;
			else
				this.aspect_scale = this.width / this.original_width;
		}
		if (this.first_layout)
			this.layouts[this.first_layout].startRunning();
		else
			this.layouts_by_index[0].startRunning();
;
		if (!this.uses_loader_layout)
		{
			this.loadingprogress = 1;
			this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
		}
		if (navigator["splashscreen"] && navigator["splashscreen"]["hide"])
			navigator["splashscreen"]["hide"]();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			t = this.types_by_index[i];
			if (t.onAppBegin)
				t.onAppBegin();
		}
		this.tick(false);
		if (this.isDirectCanvas)
			AppMobi["webview"]["execute"]("onGameReady();");
	};
	var raf = window["requestAnimationFrame"] ||
	  window["mozRequestAnimationFrame"]    ||
	  window["webkitRequestAnimationFrame"] ||
	  window["msRequestAnimationFrame"]     ||
	  window["oRequestAnimationFrame"];
	Runtime.prototype.tick = function (background_wake)
	{
		if (!this.running_layout)
			return;
		var logic_start = cr.performance_now();
		if (this.halfFramerateMode && this.ranLastRaf)
		{
			if (logic_start - this.lastRafTime < 29)
			{
				this.ranLastRaf = false;
				this.lastRafTime = logic_start;
				if (raf)
					this.raf_id = raf(this.tickFunc, this.canvas);
				else	// no idea if this works without raf/hi res timers but let's hope for the best
					this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
				return;		// skipped this frame
			}
		}
		this.ranLastRaf = true;
		this.lastRafTime = logic_start;
		var fsmode = this.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"]);
		if ((isfullscreen || this.isNodeFullscreen) && this.fullscreen_scaling > 0)
			fsmode = this.fullscreen_scaling;
		if (fsmode > 0 && (!this.isiOS || window.self !== window.top))
		{
			var curwidth = window.innerWidth;
			var curheight = window.innerHeight;
			if (this.lastWindowWidth !== curwidth || this.lastWindowHeight !== curheight)
			{
					this["setSize"](curwidth, curheight);
			}
		}
		if (!this.isDomFree)
		{
			if (isfullscreen)
			{
				if (!this.firstInFullscreen)
				{
					this.fullscreenOldMarginCss = jQuery(this.canvas).css("margin") || "0";
					this.firstInFullscreen = true;
				}
				if (!this.isChrome && !this.isNodeWebkit)
				{
					jQuery(this.canvas).css({
						"margin-left": "" + Math.floor((screen.width - (this.width / this.devicePixelRatio)) / 2) + "px",
						"margin-top": "" + Math.floor((screen.height - (this.height / this.devicePixelRatio)) / 2) + "px"
					});
				}
			}
			else
			{
				if (this.firstInFullscreen)
				{
					if (!this.isChrome && !this.isNodeWebkit)
					{
						jQuery(this.canvas).css("margin", this.fullscreenOldMarginCss);
					}
					this.fullscreenOldMarginCss = "";
					this.firstInFullscreen = false;
					if (this.fullscreen_mode === 0)
					{
						this["setSize"](Math.round(this.oldWidth / this.devicePixelRatio), Math.round(this.oldHeight / this.devicePixelRatio), true);
					}
				}
				else
				{
					this.oldWidth = this.width;
					this.oldHeight = this.height;
				}
			}
		}
		if (this.isloading)
		{
			var done = this.areAllTexturesLoaded();		// updates this.progress
			this.loadingprogress = this.progress;
			if (done)
			{
				this.isloading = false;
				this.progress = 1;
				this.trigger(cr.system_object.prototype.cnds.OnLoadFinished, null);
			}
		}
		this.logic();
		if ((this.redraw || this.isCocoonJs) && !this.is_WebGL_context_lost && !this.suspendDrawing && !background_wake)
		{
			this.redraw = false;
			if (this.glwrap)
				this.drawGL();
			else
				this.draw();
			if (this.snapshotCanvas)
			{
				if (this.canvas && this.canvas.toDataURL)
				{
					this.snapshotData = this.canvas.toDataURL(this.snapshotCanvas[0], this.snapshotCanvas[1]);
					this.trigger(cr.system_object.prototype.cnds.OnCanvasSnapshot, null);
				}
				this.snapshotCanvas = null;
			}
		}
		if (!this.hit_breakpoint)
		{
			this.tickcount++;
			this.execcount++;
			this.framecount++;
		}
		this.logictime += cr.performance_now() - logic_start;
		if (this.isSuspended || background_wake)
			return;
		if (raf)
			this.raf_id = raf(this.tickFunc, this.canvas);
		else
		{
			this.timeout_id = setTimeout(this.tickFunc, this.isMobile ? 1 : 16);
		}
	};
	Runtime.prototype.logic = function ()
	{
		var i, leni, j, lenj, k, lenk, type, inst, binst;
		var cur_time = cr.performance_now();
		if (cur_time - this.last_fps_time >= 1000)  // every 1 second
		{
			this.last_fps_time += 1000;
			this.fps = this.framecount;
			this.framecount = 0;
			this.cpuutilisation = this.logictime;
			this.logictime = 0;
		}
		if (this.measuring_dt)
		{
			if (this.last_tick_time !== 0)
			{
				var ms_diff = cur_time - this.last_tick_time;
				if (ms_diff === 0 && !this.isDebug)
				{
					this.zeroDtCount++;
					if (this.zeroDtCout >= 10)
						this.measuring_dt = false;
					this.dt1 = 1.0 / 60.0;            // 60fps assumed (0.01666...)
				}
				else
				{
					this.dt1 = ms_diff / 1000.0; // dt measured in seconds
					if (this.dt1 > 0.5)
						this.dt1 = 0;
					else if (this.dt1 > 0.1)
						this.dt1 = 0.1;
				}
			}
			this.last_tick_time = cur_time;
		}
        this.dt = this.dt1 * this.timescale;
        this.kahanTime.add(this.dt);
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || !!document["msFullscreenElement"] || this.isNodeFullscreen);
		if (this.fullscreen_mode >= 2 /* scale */ || (isfullscreen && this.fullscreen_scaling > 0))
		{
			var orig_aspect = this.original_width / this.original_height;
			var cur_aspect = this.width / this.height;
			var mode = this.fullscreen_mode;
			if (isfullscreen && this.fullscreen_scaling > 0)
				mode = this.fullscreen_scaling;
			if ((mode !== 2 && cur_aspect > orig_aspect) || (mode === 2 && cur_aspect < orig_aspect))
			{
				this.aspect_scale = this.height / this.original_height;
			}
			else
			{
				this.aspect_scale = this.width / this.original_width;
			}
			if (this.running_layout)
			{
				this.running_layout.scrollToX(this.running_layout.scrollX);
				this.running_layout.scrollToY(this.running_layout.scrollY);
			}
		}
		else
			this.aspect_scale = (this.isRetina ? this.devicePixelRatio : 1);
		this.ClearDeathRow();
		this.isInOnDestroy++;
		this.system.runWaits();		// prevent instance list changing
		this.isInOnDestroy--;
		this.ClearDeathRow();		// allow instance list changing
		this.isInOnDestroy++;
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					inst.behavior_insts[k].tick();
				}
			}
		}
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.posttick)
						binst.posttick();
				}
			}
		}
        var tickarr = this.objects_to_tick.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
		this.handleSaveLoad();		// save/load now if queued
		i = 0;
		while (this.changelayout && i++ < 10)
		{
			this.doChangeLayout(this.changelayout);
		}
        for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
            this.eventsheets_by_index[i].hasRun = false;
		if (this.running_layout.event_sheet)
			this.running_layout.event_sheet.run();
		this.registered_collisions.length = 0;
		this.layout_first_tick = false;
		this.isInOnDestroy++;		// prevent instance lists from being changed
		for (i = 0, leni = this.types_by_index.length; i < leni; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || (!type.behaviors.length && !type.families.length))
				continue;	// type doesn't have any behaviors
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				var inst = type.instances[j];
				for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
				{
					binst = inst.behavior_insts[k];
					if (binst.tick2)
						binst.tick2();
				}
			}
		}
        tickarr = this.objects_to_tick2.valuesRef();
        for (i = 0, leni = tickarr.length; i < leni; i++)
            tickarr[i].tick2();
		this.isInOnDestroy--;		// end preventing instance lists from being changed
	};
	Runtime.prototype.doChangeLayout = function (changeToLayout)
	{
;
		var prev_layout = this.running_layout;
		this.running_layout.stopRunning();
		var i, len, j, lenj, k, lenk, type, inst, binst;
		if (this.glwrap)
		{
			for (i = 0, len = this.types_by_index.length; i < len; i++)
			{
				type = this.types_by_index[i];
				if (type.is_family)
					continue;
				if (type.unloadTextures && (!type.global || type.instances.length === 0) && changeToLayout.initial_types.indexOf(type) === -1)
				{
					type.unloadTextures();
				}
			}
		}
		if (prev_layout == changeToLayout)
			this.system.waits.length = 0;
		changeToLayout.startRunning();
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (!type.global && !type.plugin.singleglobal)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (inst.onLayoutChange)
					inst.onLayoutChange();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.onLayoutChange)
							binst.onLayoutChange();
					}
				}
			}
		}
		this.redraw = true;
		this.layout_first_tick = true;
		this.ClearDeathRow();
	};
    Runtime.prototype.tickMe = function (inst)
    {
        this.objects_to_tick.add(inst);
    };
	Runtime.prototype.untickMe = function (inst)
	{
		this.objects_to_tick.remove(inst);
	};
	Runtime.prototype.tick2Me = function (inst)
    {
        this.objects_to_tick2.add(inst);
    };
	Runtime.prototype.untick2Me = function (inst)
	{
		this.objects_to_tick2.remove(inst);
	};
    Runtime.prototype.getDt = function (inst)
    {
        if (!inst || inst.my_timescale === -1.0)
            return this.dt;
        return this.dt1 * inst.my_timescale;
    };
	Runtime.prototype.draw = function ()
	{
		this.running_layout.draw(this.ctx);
		if (this.isDirectCanvas)
			this.ctx["present"]();
	};
	Runtime.prototype.drawGL = function ()
	{
		this.running_layout.drawGL(this.glwrap);
		this.glwrap.present();
	};
	Runtime.prototype.addDestroyCallback = function (f)
	{
		if (f)
			this.destroycallbacks.push(f);
	};
	Runtime.prototype.removeDestroyCallback = function (f)
	{
		cr.arrayFindRemove(this.destroycallbacks, f);
	};
	Runtime.prototype.getObjectByUID = function (uid_)
	{
;
		var uidstr = uid_.toString();
		if (this.objectsByUid.hasOwnProperty(uidstr))
			return this.objectsByUid[uidstr];
		else
			return null;
	};
	Runtime.prototype.DestroyInstance = function (inst)
	{
		var i, len;
		if (!this.deathRow.contains(inst))
		{
			this.deathRow.add(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					this.DestroyInstance(inst.siblings[i]);
				}
			}
			if (this.isInClearDeathRow)
				this.deathRow.values_cache.push(inst);
			this.isInOnDestroy++;		// support recursion
			this.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnDestroyed, inst);
			this.isInOnDestroy--;
		}
	};
	Runtime.prototype.ClearDeathRow = function ()
	{
		var inst, index, type, instances, binst;
		var i, j, k, leni, lenj, lenk;
		var w, f;
		this.isInClearDeathRow = true;
		for (i = 0, leni = this.createRow.length; i < leni; i++)
		{
			inst = this.createRow[i];
			type = inst.type;
			type.instances.push(inst);
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				type.families[j].instances.push(inst);
				type.families[j].stale_iids = true;
			}
		}
		this.createRow.length = 0;
		var arr = this.deathRow.valuesRef();	// get array of items from set
		for (i = 0; i < arr.length; i++)		// check array length every time in case it changes
		{
			inst = arr[i];
			type = inst.type;
			instances = type.instances;
			for (j = 0, lenj = this.destroycallbacks.length; j < lenj; j++)
				this.destroycallbacks[j](inst);
			cr.arrayFindRemove(instances, inst);
			if (instances.length === 0)
				type.any_instance_parallaxed = false;
			if (inst.collcells)
			{
				type.collision_grid.update(inst, inst.collcells, null);
			}
			if (inst.layer)
			{
				cr.arrayRemove(inst.layer.instances, inst.get_zindex());
				inst.layer.zindices_stale = true;
			}
			for (j = 0, lenj = type.families.length; j < lenj; j++)
			{
				cr.arrayFindRemove(type.families[j].instances, inst);
				type.families[j].stale_iids = true;
			}
			if (inst.behavior_insts)
			{
				for (j = 0, lenj = inst.behavior_insts.length; j < lenj; j++)
				{
					binst = inst.behavior_insts[j];
					if (binst.onDestroy)
						binst.onDestroy();
					binst.behavior.my_instances.remove(inst);
				}
			}
            this.objects_to_tick.remove(inst);
			this.objects_to_tick2.remove(inst);
			for (j = 0, lenj = this.system.waits.length; j < lenj; j++)
			{
				w = this.system.waits[j];
				if (w.sols.hasOwnProperty(type.index))
					cr.arrayFindRemove(w.sols[type.index].insts, inst);
				if (!type.is_family)
				{
					for (k = 0, lenk = type.families.length; k < lenk; k++)
					{
						f = type.families[k];
						if (w.sols.hasOwnProperty(f.index))
							cr.arrayFindRemove(w.sols[f.index].insts, inst);
					}
				}
			}
			if (inst.onDestroy)
				inst.onDestroy();
			if (this.objectsByUid.hasOwnProperty(inst.uid.toString()))
				delete this.objectsByUid[inst.uid.toString()];
			this.objectcount--;
			if (type.deadCache.length < 64)
				type.deadCache.push(inst);
			type.stale_iids = true;
		}
		if (!this.deathRow.isEmpty())
			this.redraw = true;
		this.deathRow.clear();
		this.isInClearDeathRow = false;
	};
	Runtime.prototype.createInstance = function (type, layer, sx, sy)
	{
		if (type.is_family)
		{
			var i = cr.floor(Math.random() * type.members.length);
			return this.createInstance(type.members[i], layer, sx, sy);
		}
		if (!type.default_instance)
		{
			return null;
		}
		return this.createInstanceFromInit(type.default_instance, layer, false, sx, sy, false);
	};
	var all_behaviors = [];
	Runtime.prototype.createInstanceFromInit = function (initial_inst, layer, is_startup_instance, sx, sy, skip_siblings)
	{
		var i, len, j, lenj, p, effect_fallback, x, y;
		if (!initial_inst)
			return null;
		var type = this.types_by_index[initial_inst[1]];
;
;
		var is_world = type.plugin.is_world;
;
		if (this.isloading && is_world && !type.isOnLoaderLayout)
			return null;
		if (is_world && !this.glwrap && initial_inst[0][11] === 11)
			return null;
		var original_layer = layer;
		if (!is_world)
			layer = null;
		var inst;
		if (type.deadCache.length)
		{
			inst = type.deadCache.pop();
			inst.recycled = true;
			type.plugin.Instance.call(inst, type);
		}
		else
		{
			inst = new type.plugin.Instance(type);
			inst.recycled = false;
		}
		if (is_startup_instance && !skip_siblings)
			inst.uid = initial_inst[2];
		else
			inst.uid = this.next_uid++;
		this.objectsByUid[inst.uid.toString()] = inst;
		inst.puid = this.next_puid++;
		inst.iid = type.instances.length;
		for (i = 0, len = this.createRow.length; i < len; ++i)
		{
			if (this.createRow[i].type === type)
				inst.iid++;
		}
		inst.get_iid = cr.inst_get_iid;
		var initial_vars = initial_inst[3];
		if (inst.recycled)
		{
			cr.wipe(inst.extra);
		}
		else
		{
			inst.extra = {};
			if (typeof cr_is_preview !== "undefined")
			{
				inst.instance_var_names = [];
				inst.instance_var_names.length = initial_vars.length;
				for (i = 0, len = initial_vars.length; i < len; i++)
					inst.instance_var_names[i] = initial_vars[i][1];
			}
			inst.instance_vars = [];
			inst.instance_vars.length = initial_vars.length;
		}
		for (i = 0, len = initial_vars.length; i < len; i++)
			inst.instance_vars[i] = initial_vars[i][0];
		if (is_world)
		{
			var wm = initial_inst[0];
;
			inst.x = cr.is_undefined(sx) ? wm[0] : sx;
			inst.y = cr.is_undefined(sy) ? wm[1] : sy;
			inst.z = wm[2];
			inst.width = wm[3];
			inst.height = wm[4];
			inst.depth = wm[5];
			inst.angle = wm[6];
			inst.opacity = wm[7];
			inst.hotspotX = wm[8];
			inst.hotspotY = wm[9];
			inst.blend_mode = wm[10];
			effect_fallback = wm[11];
			if (!this.glwrap && type.effect_types.length)	// no WebGL renderer and shaders used
				inst.blend_mode = effect_fallback;			// use fallback blend mode - destroy mode was handled above
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			if (inst.recycled)
			{
				for (i = 0, len = wm[12].length; i < len; i++)
				{
					for (j = 0, lenj = wm[12][i].length; j < lenj; j++)
						inst.effect_params[i][j] = wm[12][i][j];
				}
				inst.bbox.set(0, 0, 0, 0);
				inst.collcells.set(0, 0, -1, -1);
				inst.bquad.set_from_rect(inst.bbox);
				inst.bbox_changed_callbacks.length = 0;
			}
			else
			{
				inst.effect_params = wm[12].slice(0);
				for (i = 0, len = inst.effect_params.length; i < len; i++)
					inst.effect_params[i] = wm[12][i].slice(0);
				inst.active_effect_types = [];
				inst.active_effect_flags = [];
				inst.active_effect_flags.length = type.effect_types.length;
				inst.bbox = new cr.rect(0, 0, 0, 0);
				inst.collcells = new cr.rect(0, 0, -1, -1);
				inst.bquad = new cr.quad();
				inst.bbox_changed_callbacks = [];
				inst.set_bbox_changed = cr.set_bbox_changed;
				inst.add_bbox_changed_callback = cr.add_bbox_changed_callback;
				inst.contains_pt = cr.inst_contains_pt;
				inst.update_bbox = cr.update_bbox;
				inst.update_collision_cell = cr.update_collision_cell;
				inst.get_zindex = cr.inst_get_zindex;
			}
			inst.tilemap_exists = false;
			inst.tilemap_width = 0;
			inst.tilemap_height = 0;
			inst.tilemap_data = null;
			if (wm.length === 14)
			{
				inst.tilemap_exists = true;
				inst.tilemap_width = wm[13][0];
				inst.tilemap_height = wm[13][1];
				inst.tilemap_data = wm[13][2];
			}
			for (i = 0, len = type.effect_types.length; i < len; i++)
				inst.active_effect_flags[i] = true;
			inst.updateActiveEffects = cr.inst_updateActiveEffects;
			inst.updateActiveEffects();
			inst.uses_shaders = !!inst.active_effect_types.length;
			inst.bbox_changed = true;
			inst.cell_changed = true;
			type.any_cell_changed = true;
			inst.visible = true;
            inst.my_timescale = -1.0;
			inst.layer = layer;
			inst.zindex = layer.instances.length;	// will be placed at top of current layer
			if (typeof inst.collision_poly === "undefined")
				inst.collision_poly = null;
			inst.collisionsEnabled = true;
			this.redraw = true;
		}
		inst.toString = cr.inst_toString;
		var initial_props, binst;
		all_behaviors.length = 0;
		for (i = 0, len = type.families.length; i < len; i++)
		{
			all_behaviors.push.apply(all_behaviors, type.families[i].behaviors);
		}
		all_behaviors.push.apply(all_behaviors, type.behaviors);
		if (inst.recycled)
		{
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				binst = inst.behavior_insts[i];
				binst.recycled = true;
				btype.behavior.Instance.call(binst, btype, inst);
				initial_props = initial_inst[4][i];
				for (j = 0, lenj = initial_props.length; j < lenj; j++)
					binst.properties[j] = initial_props[j];
				binst.onCreate();
				btype.behavior.my_instances.add(inst);
			}
		}
		else
		{
			inst.behavior_insts = [];
			for (i = 0, len = all_behaviors.length; i < len; i++)
			{
				var btype = all_behaviors[i];
				var binst = new btype.behavior.Instance(btype, inst);
				binst.recycled = false;
				binst.properties = initial_inst[4][i].slice(0);
				binst.onCreate();
				cr.seal(binst);
				inst.behavior_insts.push(binst);
				btype.behavior.my_instances.add(inst);
			}
		}
		initial_props = initial_inst[5];
		if (inst.recycled)
		{
			for (i = 0, len = initial_props.length; i < len; i++)
				inst.properties[i] = initial_props[i];
		}
		else
			inst.properties = initial_props.slice(0);
		this.createRow.push(inst);
		if (layer)
		{
;
			layer.instances.push(inst);
			if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
				type.any_instance_parallaxed = true;
		}
		this.objectcount++;
		if (type.is_contained)
		{
			inst.is_contained = true;
			if (inst.recycled)
				inst.siblings.length = 0;
			else
				inst.siblings = [];			// note: should not include self in siblings
			if (!is_startup_instance && !skip_siblings)	// layout links initial instances
			{
				for (i = 0, len = type.container.length; i < len; i++)
				{
					if (type.container[i] === type)
						continue;
					if (!type.container[i].default_instance)
					{
						return null;
					}
					inst.siblings.push(this.createInstanceFromInit(type.container[i].default_instance, original_layer, false, is_world ? inst.x : sx, is_world ? inst.y : sy, true));
				}
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					inst.siblings[i].siblings.push(inst);
					for (j = 0; j < len; j++)
					{
						if (i !== j)
							inst.siblings[i].siblings.push(inst.siblings[j]);
					}
				}
			}
		}
		else
		{
			inst.is_contained = false;
			inst.siblings = null;
		}
		inst.onCreate();
		if (!inst.recycled)
			cr.seal(inst);
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].postCreate)
				inst.behavior_insts[i].postCreate();
		}
		return inst;
	};
	Runtime.prototype.getLayerByName = function (layer_name)
	{
		var i, len;
		for (i = 0, len = this.running_layout.layers.length; i < len; i++)
		{
			var layer = this.running_layout.layers[i];
			if (cr.equals_nocase(layer.name, layer_name))
				return layer;
		}
		return null;
	};
	Runtime.prototype.getLayerByNumber = function (index)
	{
		index = cr.floor(index);
		if (index < 0)
			index = 0;
		if (index >= this.running_layout.layers.length)
			index = this.running_layout.layers.length - 1;
		return this.running_layout.layers[index];
	};
	Runtime.prototype.getLayer = function (l)
	{
		if (cr.is_number(l))
			return this.getLayerByNumber(l);
		else
			return this.getLayerByName(l.toString());
	};
	Runtime.prototype.clearSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].getCurrentSol().select_all = true;
		}
	};
	Runtime.prototype.pushCleanSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCleanSol();
		}
	};
	Runtime.prototype.pushCopySol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].pushCopySol();
		}
	};
	Runtime.prototype.popSol = function (solModifiers)
	{
		var i, len;
		for (i = 0, len = solModifiers.length; i < len; i++)
		{
			solModifiers[i].popSol();
		}
	};
	Runtime.prototype.updateAllCells = function (type)
	{
		if (!type.any_cell_changed)
			return;		// all instances must already be up-to-date
		var i, len, instances = type.instances;
		for (i = 0, len = instances.length; i < len; ++i)
		{
			instances[i].update_collision_cell();
		}
		var createRow = this.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === type)
				createRow[i].update_collision_cell();
		}
		type.any_cell_changed = false;
	};
	Runtime.prototype.getCollisionCandidates = function (layer, rtype, bbox, candidates)
	{
		var i, len, t;
		var is_parallaxed = (layer ? (layer.parallaxX !== 1 || layer.parallaxY !== 1) : false);
		if (rtype.is_family)
		{
			for (i = 0, len = rtype.members.length; i < len; ++i)
			{
				t = rtype.members[i];
				if (is_parallaxed || t.any_instance_parallaxed)
				{
					cr.appendArray(candidates, t.instances);
				}
				else
				{
					this.updateAllCells(t);
					t.collision_grid.queryRange(bbox, candidates);
				}
			}
		}
		else
		{
			if (is_parallaxed || rtype.any_instance_parallaxed)
			{
				cr.appendArray(candidates, rtype.instances);
			}
			else
			{
				this.updateAllCells(rtype);
				rtype.collision_grid.queryRange(bbox, candidates);
			}
		}
	};
	Runtime.prototype.getTypesCollisionCandidates = function (layer, types, bbox, candidates)
	{
		var i, len;
		for (i = 0, len = types.length; i < len; ++i)
		{
			this.getCollisionCandidates(layer, types[i], bbox, candidates);
		}
	};
	Runtime.prototype.getSolidCollisionCandidates = function (layer, bbox, candidates)
	{
		var solid = this.getSolidBehavior();
		if (!solid)
			return null;
		this.getTypesCollisionCandidates(layer, solid.my_types, bbox, candidates);
	};
	Runtime.prototype.getJumpthruCollisionCandidates = function (layer, bbox, candidates)
	{
		var jumpthru = this.getJumpthruBehavior();
		if (!jumpthru)
			return null;
		this.getTypesCollisionCandidates(layer, jumpthru.my_types, bbox, candidates);
	};
	Runtime.prototype.testAndSelectCanvasPointOverlap = function (type, ptx, pty, inverted)
	{
		var sol = type.getCurrentSol();
		var i, j, inst, len;
		var lx, ly;
		if (sol.select_all)
		{
			if (!inverted)
			{
				sol.select_all = false;
				sol.instances.length = 0;   // clear contents
			}
			for (i = 0, len = type.instances.length; i < len; i++)
			{
				inst = type.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
						sol.instances.push(inst);
				}
			}
		}
		else
		{
			j = 0;
			for (i = 0, len = sol.instances.length; i < len; i++)
			{
				inst = sol.instances[i];
				inst.update_bbox();
				lx = inst.layer.canvasToLayer(ptx, pty, true);
				ly = inst.layer.canvasToLayer(ptx, pty, false);
				if (inst.contains_pt(lx, ly))
				{
					if (inverted)
						return false;
					else
					{
						sol.instances[j] = sol.instances[i];
						j++;
					}
				}
			}
			if (!inverted)
				sol.instances.length = j;
		}
		type.applySolToContainer();
		if (inverted)
			return true;		// did not find anything overlapping
		else
			return sol.hasObjects();
	};
	Runtime.prototype.testOverlap = function (a, b)
	{
		if (!a || !b || a === b || !a.collisionsEnabled || !b.collisionsEnabled)
			return false;
		a.update_bbox();
		b.update_bbox();
		var layera = a.layer;
		var layerb = b.layer;
		var different_layers = (layera !== layerb && (layera.parallaxX !== layerb.parallaxX || layerb.parallaxY !== layerb.parallaxY || layera.scale !== layerb.scale || layera.angle !== layerb.angle || layera.zoomRate !== layerb.zoomRate));
		var i, len, i2, i21, x, y, haspolya, haspolyb, polya, polyb;
		if (!different_layers)	// same layers: easy check
		{
			if (!a.bbox.intersects_rect(b.bbox))
				return false;
			if (!a.bquad.intersects_quad(b.bquad))
				return false;
			if (a.tilemap_exists && b.tilemap_exists)
				return false;
			if (a.tilemap_exists)
				return this.testTilemapOverlap(a, b);
			if (b.tilemap_exists)
				return this.testTilemapOverlap(b, a);
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolya && !haspolyb)
				return true;
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				polya = a.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
				polya = this.temp_poly;
			}
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				polyb = b.collision_poly;
			}
			else
			{
				this.temp_poly.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
				polyb = this.temp_poly;
			}
			return polya.intersects_poly(polyb, b.x - a.x, b.y - a.y);
		}
		else	// different layers: need to do full translated check
		{
			haspolya = (a.collision_poly && !a.collision_poly.is_empty());
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (haspolya)
			{
				a.collision_poly.cache_poly(a.width, a.height, a.angle);
				this.temp_poly.set_from_poly(a.collision_poly);
			}
			else
			{
				this.temp_poly.set_from_quad(a.bquad, a.x, a.y, a.width, a.height);
			}
			polya = this.temp_poly;
			if (haspolyb)
			{
				b.collision_poly.cache_poly(b.width, b.height, b.angle);
				this.temp_poly2.set_from_poly(b.collision_poly);
			}
			else
			{
				this.temp_poly2.set_from_quad(b.bquad, b.x, b.y, b.width, b.height);
			}
			polyb = this.temp_poly2;
			for (i = 0, len = polya.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polya.pts_cache[i2];
				y = polya.pts_cache[i21];
				polya.pts_cache[i2] = layera.layerToCanvas(x + a.x, y + a.y, true);
				polya.pts_cache[i21] = layera.layerToCanvas(x + a.x, y + a.y, false);
			}
			polya.update_bbox();
			for (i = 0, len = polyb.pts_count; i < len; i++)
			{
				i2 = i * 2;
				i21 = i2 + 1;
				x = polyb.pts_cache[i2];
				y = polyb.pts_cache[i21];
				polyb.pts_cache[i2] = layerb.layerToCanvas(x + b.x, y + b.y, true);
				polyb.pts_cache[i21] = layerb.layerToCanvas(x + b.x, y + b.y, false);
			}
			polyb.update_bbox();
			return polya.intersects_poly(polyb, 0, 0);
		}
	};
	var tmpQuad = new cr.quad();
	var tmpRect = new cr.rect(0, 0, 0, 0);
	var collrect_candidates = [];
	Runtime.prototype.testTilemapOverlap = function (tm, a)
	{
		var i, len, c, rc;
		var bbox = a.bbox;
		var tmx = tm.x;
		var tmy = tm.y;
		tm.getCollisionRectCandidates(bbox, collrect_candidates);
		var collrects = collrect_candidates;
		var haspolya = (a.collision_poly && !a.collision_poly.is_empty());
		for (i = 0, len = collrects.length; i < len; ++i)
		{
			c = collrects[i];
			rc = c.rc;
			if (bbox.intersects_rect_off(rc, tmx, tmy))
			{
				tmpQuad.set_from_rect(rc);
				tmpQuad.offset(tmx, tmy);
				if (tmpQuad.intersects_quad(a.bquad))
				{
					if (haspolya)
					{
						a.collision_poly.cache_poly(a.width, a.height, a.angle);
						if (c.poly)
						{
							if (c.poly.intersects_poly(a.collision_poly, a.x - (tmx + rc.left), a.y - (tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							this.temp_poly.set_from_quad(tmpQuad, 0, 0, rc.right - rc.left, rc.bottom - rc.top);
							if (this.temp_poly.intersects_poly(a.collision_poly, a.x, a.y))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
					}
					else
					{
						if (c.poly)
						{
							this.temp_poly.set_from_quad(a.bquad, 0, 0, a.width, a.height);
							if (c.poly.intersects_poly(this.temp_poly, -(tmx + rc.left), -(tmy + rc.top)))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
		}
		collrect_candidates.length = 0;
		return false;
	};
	Runtime.prototype.testRectOverlap = function (r, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		if (!b.bbox.intersects_rect(r))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(r, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (r.intersects_rect_off(tilerc, tmx, tmy))
				{
					if (c.poly)
					{
						this.temp_poly.set_from_rect(r, 0, 0);
						if (c.poly.intersects_poly(this.temp_poly, -(tmx + tilerc.left), -(tmy + tilerc.top)))
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
					else
					{
						collrect_candidates.length = 0;
						return true;
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			tmpQuad.set_from_rect(r);
			if (!b.bquad.intersects_quad(tmpQuad))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			tmpQuad.offset(-r.left, -r.top);
			this.temp_poly.set_from_quad(tmpQuad, 0, 0, 1, 1);
			return b.collision_poly.intersects_poly(this.temp_poly, r.left - b.x, r.top - b.y);
		}
	};
	Runtime.prototype.testSegmentOverlap = function (x1, y1, x2, y2, b)
	{
		if (!b || !b.collisionsEnabled)
			return false;
		b.update_bbox();
		var layerb = b.layer;
		var haspolyb, polyb;
		tmpRect.set(cr.min(x1, x2), cr.min(y1, y2), cr.max(x1, x2), cr.max(y1, y2));
		if (!b.bbox.intersects_rect(tmpRect))
			return false;
		if (b.tilemap_exists)
		{
			b.getCollisionRectCandidates(tmpRect, collrect_candidates);
			var collrects = collrect_candidates;
			var i, len, c, tilerc;
			var tmx = b.x;
			var tmy = b.y;
			for (i = 0, len = collrects.length; i < len; ++i)
			{
				c = collrects[i];
				tilerc = c.rc;
				if (tmpRect.intersects_rect_off(tilerc, tmx, tmy))
				{
					tmpQuad.set_from_rect(tilerc);
					tmpQuad.offset(tmx, tmy);
					if (tmpQuad.intersects_segment(x1, y1, x2, y2))
					{
						if (c.poly)
						{
							if (c.poly.intersects_segment(tmx + tilerc.left, tmy + tilerc.top, x1, y1, x2, y2))
							{
								collrect_candidates.length = 0;
								return true;
							}
						}
						else
						{
							collrect_candidates.length = 0;
							return true;
						}
					}
				}
			}
			collrect_candidates.length = 0;
			return false;
		}
		else
		{
			if (!b.bquad.intersects_segment(x1, y1, x2, y2))
				return false;
			haspolyb = (b.collision_poly && !b.collision_poly.is_empty());
			if (!haspolyb)
				return true;
			b.collision_poly.cache_poly(b.width, b.height, b.angle);
			return b.collision_poly.intersects_segment(b.x, b.y, x1, y1, x2, y2);
		}
	};
	Runtime.prototype.typeHasBehavior = function (t, b)
	{
		if (!b)
			return false;
		var i, len, j, lenj, f;
		for (i = 0, len = t.behaviors.length; i < len; i++)
		{
			if (t.behaviors[i].behavior instanceof b)
				return true;
		}
		if (!t.is_family)
		{
			for (i = 0, len = t.families.length; i < len; i++)
			{
				f = t.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (f.behaviors[j].behavior instanceof b)
						return true;
				}
			}
		}
		return false;
	};
	Runtime.prototype.typeHasNoSaveBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.NoSave);
	};
	Runtime.prototype.typeHasPersistBehavior = function (t)
	{
		return this.typeHasBehavior(t, cr.behaviors.Persist);
	};
	Runtime.prototype.getSolidBehavior = function ()
	{
		return this.solidBehavior;
	};
	Runtime.prototype.getJumpthruBehavior = function ()
	{
		return this.jumpthruBehavior;
	};
	var candidates = [];
	Runtime.prototype.testOverlapSolid = function (inst)
	{
		var i, len, s;
		inst.update_bbox();
		this.getSolidCollisionCandidates(inst.layer, inst.bbox, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testOverlap(inst, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	Runtime.prototype.testRectOverlapSolid = function (r)
	{
		var i, len, s;
		this.getSolidCollisionCandidates(null, r, candidates);
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			s = candidates[i];
			if (!s.extra.solidEnabled)
				continue;
			if (this.testRectOverlap(r, s))
			{
				candidates.length = 0;
				return s;
			}
		}
		candidates.length = 0;
		return null;
	};
	var jumpthru_array_ret = [];
	Runtime.prototype.testOverlapJumpThru = function (inst, all)
	{
		var ret = null;
		if (all)
		{
			ret = jumpthru_array_ret;
			ret.length = 0;
		}
		inst.update_bbox();
		this.getJumpthruCollisionCandidates(inst.layer, inst.bbox, candidates);
		var i, len, j;
		for (i = 0, len = candidates.length; i < len; ++i)
		{
			j = candidates[i];
			if (!j.extra.jumpthruEnabled)
				continue;
			if (this.testOverlap(inst, j))
			{
				if (all)
					ret.push(j);
				else
				{
					candidates.length = 0;
					return j;
				}
			}
		}
		candidates.length = 0;
		return ret;
	};
	Runtime.prototype.pushOutSolid = function (inst, xdir, ydir, dist, include_jumpthrus, specific_jumpthru)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		var last_overlapped = null, secondlast_overlapped = null;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (last_overlapped)
					secondlast_overlapped = last_overlapped;
				if (!last_overlapped)
				{
					if (include_jumpthrus)
					{
						if (specific_jumpthru)
							last_overlapped = (this.testOverlap(inst, specific_jumpthru) ? specific_jumpthru : null);
						else
							last_overlapped = this.testOverlapJumpThru(inst);
						if (last_overlapped)
							secondlast_overlapped = last_overlapped;
					}
					if (!last_overlapped)
					{
						if (secondlast_overlapped)
							this.pushInFractional(inst, xdir, ydir, secondlast_overlapped, 16);
						return true;
					}
				}
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushOut = function (inst, xdir, ydir, dist, otherinst)
	{
		var push_dist = dist || 50;
		var oldx = inst.x
		var oldy = inst.y;
		var i;
		for (i = 0; i < push_dist; i++)
		{
			inst.x = (oldx + (xdir * i));
			inst.y = (oldy + (ydir * i));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, otherinst))
				return true;
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.pushInFractional = function (inst, xdir, ydir, obj, limit)
	{
		var divisor = 2;
		var frac;
		var forward = false;
		var overlapping = false;
		var bestx = inst.x;
		var besty = inst.y;
		while (divisor <= limit)
		{
			frac = 1 / divisor;
			divisor *= 2;
			inst.x += xdir * frac * (forward ? 1 : -1);
			inst.y += ydir * frac * (forward ? 1 : -1);
			inst.set_bbox_changed();
			if (this.testOverlap(inst, obj))
			{
				forward = true;
				overlapping = true;
			}
			else
			{
				forward = false;
				overlapping = false;
				bestx = inst.x;
				besty = inst.y;
			}
		}
		if (overlapping)
		{
			inst.x = bestx;
			inst.y = besty;
			inst.set_bbox_changed();
		}
	};
	Runtime.prototype.pushOutSolidNearest = function (inst, max_dist_)
	{
		var max_dist = (cr.is_undefined(max_dist_) ? 100 : max_dist_);
		var dist = 0;
		var oldx = inst.x
		var oldy = inst.y;
		var dir = 0;
		var dx = 0, dy = 0;
		var last_overlapped = this.testOverlapSolid(inst);
		if (!last_overlapped)
			return true;		// already clear of solids
		while (dist <= max_dist)
		{
			switch (dir) {
			case 0:		dx = 0; dy = -1; dist++; break;
			case 1:		dx = 1; dy = -1; break;
			case 2:		dx = 1; dy = 0; break;
			case 3:		dx = 1; dy = 1; break;
			case 4:		dx = 0; dy = 1; break;
			case 5:		dx = -1; dy = 1; break;
			case 6:		dx = -1; dy = 0; break;
			case 7:		dx = -1; dy = -1; break;
			}
			dir = (dir + 1) % 8;
			inst.x = cr.floor(oldx + (dx * dist));
			inst.y = cr.floor(oldy + (dy * dist));
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, last_overlapped))
			{
				last_overlapped = this.testOverlapSolid(inst);
				if (!last_overlapped)
					return true;
			}
		}
		inst.x = oldx;
		inst.y = oldy;
		inst.set_bbox_changed();
		return false;
	};
	Runtime.prototype.registerCollision = function (a, b)
	{
		if (!a.collisionsEnabled || !b.collisionsEnabled)
			return;
		this.registered_collisions.push([a, b]);
	};
	Runtime.prototype.checkRegisteredCollision = function (a, b)
	{
		var i, len, x;
		for (i = 0, len = this.registered_collisions.length; i < len; i++)
		{
			x = this.registered_collisions[i];
			if ((x[0] == a && x[1] == b) || (x[0] == b && x[1] == a))
				return true;
		}
		return false;
	};
	Runtime.prototype.calculateSolidBounceAngle = function(inst, startx, starty, obj)
	{
		var objx = inst.x;
		var objy = inst.y;
		var radius = cr.max(10, cr.distanceTo(startx, starty, objx, objy));
		var startangle = cr.angleTo(startx, starty, objx, objy);
		var firstsolid = obj || this.testOverlapSolid(inst);
		if (!firstsolid)
			return cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		var i, curangle, anticlockwise_free_angle, clockwise_free_angle;
		var increment = cr.to_radians(5);	// 5 degree increments
		for (i = 1; i < 36; i++)
		{
			curangle = startangle - i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					anticlockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			anticlockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		var cursolid = firstsolid;
		for (i = 1; i < 36; i++)
		{
			curangle = startangle + i * increment;
			inst.x = startx + Math.cos(curangle) * radius;
			inst.y = starty + Math.sin(curangle) * radius;
			inst.set_bbox_changed();
			if (!this.testOverlap(inst, cursolid))
			{
				cursolid = obj ? null : this.testOverlapSolid(inst);
				if (!cursolid)
				{
					clockwise_free_angle = curangle;
					break;
				}
			}
		}
		if (i === 36)
			clockwise_free_angle = cr.clamp_angle(startangle + cr.PI);
		inst.x = objx;
		inst.y = objy;
		inst.set_bbox_changed();
		if (clockwise_free_angle === anticlockwise_free_angle)
			return clockwise_free_angle;
		var half_diff = cr.angleDiff(clockwise_free_angle, anticlockwise_free_angle) / 2;
		var normal;
		if (cr.angleClockwise(clockwise_free_angle, anticlockwise_free_angle))
		{
			normal = cr.clamp_angle(anticlockwise_free_angle + half_diff + cr.PI);
		}
		else
		{
			normal = cr.clamp_angle(clockwise_free_angle + half_diff);
		}
;
		var vx = Math.cos(startangle);
		var vy = Math.sin(startangle);
		var nx = Math.cos(normal);
		var ny = Math.sin(normal);
		var v_dot_n = vx * nx + vy * ny;
		var rx = vx - 2 * v_dot_n * nx;
		var ry = vy - 2 * v_dot_n * ny;
		return cr.angleTo(0, 0, rx, ry);
	};
	var triggerSheetIndex = -1;
	Runtime.prototype.trigger = function (method, inst, value /* for fast triggers */)
	{
;
		if (!this.running_layout)
			return false;
		var sheet = this.running_layout.event_sheet;
		if (!sheet)
			return false;     // no event sheet active; nothing to trigger
		var ret = false;
		var r, i, len;
		triggerSheetIndex++;
		var deep_includes = sheet.deep_includes;
		for (i = 0, len = deep_includes.length; i < len; ++i)
		{
			r = this.triggerOnSheet(method, inst, deep_includes[i], value);
			ret = ret || r;
		}
		r = this.triggerOnSheet(method, inst, sheet, value);
		ret = ret || r;
		triggerSheetIndex--;
		return ret;
    };
    Runtime.prototype.triggerOnSheet = function (method, inst, sheet, value)
    {
        var ret = false;
		var i, leni, r, families;
		if (!inst)
		{
			r = this.triggerOnSheetForTypeName(method, inst, "system", sheet, value);
			ret = ret || r;
		}
		else
		{
			r = this.triggerOnSheetForTypeName(method, inst, inst.type.name, sheet, value);
			ret = ret || r;
			families = inst.type.families;
			for (i = 0, leni = families.length; i < leni; ++i)
			{
				r = this.triggerOnSheetForTypeName(method, inst, families[i].name, sheet, value);
				ret = ret || r;
			}
		}
		return ret;             // true if anything got triggered
	};
	Runtime.prototype.triggerOnSheetForTypeName = function (method, inst, type_name, sheet, value)
	{
		var i, leni;
		var ret = false, ret2 = false;
		var trig, index;
		var fasttrigger = (typeof value !== "undefined");
		var triggers = (fasttrigger ? sheet.fasttriggers : sheet.triggers);
		var obj_entry = triggers[type_name];
		if (!obj_entry)
			return ret;
		var triggers_list = null;
		for (i = 0, leni = obj_entry.length; i < leni; ++i)
		{
			if (obj_entry[i].method == method)
			{
				triggers_list = obj_entry[i].evs;
				break;
			}
		}
		if (!triggers_list)
			return ret;
		var triggers_to_fire;
		if (fasttrigger)
		{
			triggers_to_fire = triggers_list[value];
		}
		else
		{
			triggers_to_fire = triggers_list;
		}
		if (!triggers_to_fire)
			return null;
		for (i = 0, leni = triggers_to_fire.length; i < leni; i++)
		{
			trig = triggers_to_fire[i][0];
			index = triggers_to_fire[i][1];
			ret2 = this.executeSingleTrigger(inst, type_name, trig, index);
			ret = ret || ret2;
		}
		return ret;
	};
	Runtime.prototype.executeSingleTrigger = function (inst, type_name, trig, index)
	{
		var i, leni;
		var ret = false;
		this.trigger_depth++;
		var current_event = this.getCurrentEventStack().current_event;
		if (current_event)
			this.pushCleanSol(current_event.solModifiersIncludingParents);
		var isrecursive = (this.trigger_depth > 1);		// calling trigger from inside another trigger
		this.pushCleanSol(trig.solModifiersIncludingParents);
		if (isrecursive)
			this.pushLocalVarStack();
		var event_stack = this.pushEventStack(trig);
		event_stack.current_event = trig;
		if (inst)
		{
			var sol = this.types[type_name].getCurrentSol();
			sol.select_all = false;
			sol.instances.length = 1;
			sol.instances[0] = inst;
			this.types[type_name].applySolToContainer();
		}
		var ok_to_run = true;
		if (trig.parent)
		{
			var temp_parents_arr = event_stack.temp_parents_arr;
			var cur_parent = trig.parent;
			while (cur_parent)
			{
				temp_parents_arr.push(cur_parent);
				cur_parent = cur_parent.parent;
			}
			temp_parents_arr.reverse();
			for (i = 0, leni = temp_parents_arr.length; i < leni; i++)
			{
				if (!temp_parents_arr[i].run_pretrigger())   // parent event failed
				{
					ok_to_run = false;
					break;
				}
			}
		}
		if (ok_to_run)
		{
			this.execcount++;
			if (trig.orblock)
				trig.run_orblocktrigger(index);
			else
				trig.run();
			ret = ret || event_stack.last_event_true;
		}
		this.popEventStack();
		if (isrecursive)
			this.popLocalVarStack();
		this.popSol(trig.solModifiersIncludingParents);
		if (current_event)
			this.popSol(current_event.solModifiersIncludingParents);
		if (this.isInOnDestroy === 0 && triggerSheetIndex === 0 && !this.isRunningEvents && (!this.deathRow.isEmpty() || this.createRow.length))
		{
			this.ClearDeathRow();
		}
		this.trigger_depth--;
		return ret;
	};
	Runtime.prototype.getCurrentCondition = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.conditions[evinfo.cndindex];
	};
	Runtime.prototype.getCurrentAction = function ()
	{
		var evinfo = this.getCurrentEventStack();
		return evinfo.current_event.actions[evinfo.actindex];
	};
	Runtime.prototype.pushLocalVarStack = function ()
	{
		this.localvar_stack_index++;
		if (this.localvar_stack_index >= this.localvar_stack.length)
			this.localvar_stack.push([]);
	};
	Runtime.prototype.popLocalVarStack = function ()
	{
;
		this.localvar_stack_index--;
	};
	Runtime.prototype.getCurrentLocalVarStack = function ()
	{
		return this.localvar_stack[this.localvar_stack_index];
	};
	Runtime.prototype.pushEventStack = function (cur_event)
	{
		this.event_stack_index++;
		if (this.event_stack_index >= this.event_stack.length)
			this.event_stack.push(new cr.eventStackFrame());
		var ret = this.getCurrentEventStack();
		ret.reset(cur_event);
		return ret;
	};
	Runtime.prototype.popEventStack = function ()
	{
;
		this.event_stack_index--;
	};
	Runtime.prototype.getCurrentEventStack = function ()
	{
		return this.event_stack[this.event_stack_index];
	};
	Runtime.prototype.pushLoopStack = function (name_)
	{
		this.loop_stack_index++;
		if (this.loop_stack_index >= this.loop_stack.length)
		{
			this.loop_stack.push(cr.seal({ name: name_, index: 0, stopped: false }));
		}
		var ret = this.getCurrentLoop();
		ret.name = name_;
		ret.index = 0;
		ret.stopped = false;
		return ret;
	};
	Runtime.prototype.popLoopStack = function ()
	{
;
		this.loop_stack_index--;
	};
	Runtime.prototype.getCurrentLoop = function ()
	{
		return this.loop_stack[this.loop_stack_index];
	};
	Runtime.prototype.getEventVariableByName = function (name, scope)
	{
		var i, leni, j, lenj, sheet, e;
		while (scope)
		{
			for (i = 0, leni = scope.subevents.length; i < leni; i++)
			{
				e = scope.subevents[i];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
			scope = scope.parent;
		}
		for (i = 0, leni = this.eventsheets_by_index.length; i < leni; i++)
		{
			sheet = this.eventsheets_by_index[i];
			for (j = 0, lenj = sheet.events.length; j < lenj; j++)
			{
				e = sheet.events[j];
				if (e instanceof cr.eventvariable && cr.equals_nocase(name, e.name))
					return e;
			}
		}
		return null;
	};
	Runtime.prototype.getLayoutBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			if (this.layouts_by_index[i].sid === sid_)
				return this.layouts_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getObjectTypeBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			if (this.types_by_index[i].sid === sid_)
				return this.types_by_index[i];
		}
		return null;
	};
	Runtime.prototype.getGroupBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			if (this.allGroups[i].sid === sid_)
				return this.allGroups[i];
		}
		return null;
	};
	function makeSaveDb(e)
	{
		var db = e.target.result;
		db.createObjectStore("saves", { keyPath: "slot" });
	};
	function IndexedDB_WriteSlot(slot_, data_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"], "readwrite");
			var objectStore = transaction.objectStore("saves");
			var putReq = objectStore.put({"slot": slot_, "data": data_ });
			putReq.onsuccess = oncomplete_;
		};
	};
	function IndexedDB_ReadSlot(slot_, oncomplete_, onerror_)
	{
		var request = indexedDB.open("_C2SaveStates");
		request.onupgradeneeded = makeSaveDb;
		request.onerror = onerror_;
		request.onsuccess = function (e)
		{
			var db = e.target.result;
			db.onerror = onerror_;
			var transaction = db.transaction(["saves"]);
			var objectStore = transaction.objectStore("saves");
			var readReq = objectStore.get(slot_);
			readReq.onsuccess = function (e)
			{
				if (readReq.result)
					oncomplete_(readReq.result["data"]);
				else
					oncomplete_(null);
			};
		};
	};
	Runtime.prototype.signalContinuousPreview = function ()
	{
		this.signalledContinuousPreview = true;
	};
	function doContinuousPreviewReload()
	{
		cr.logexport("Reloading for continuous preview");
		if (!!window["c2cocoonjs"])
		{
			CocoonJS["App"]["reload"]();
		}
		else
		{
			if (window.location.search.indexOf("continuous") > -1)
				window.location.reload(true);
			else
				window.location = window.location + "?continuous";
		}
	};
	Runtime.prototype.handleSaveLoad = function ()
	{
		var self = this;
		var savingToSlot = this.saveToSlot;
		var savingJson = this.lastSaveJson;
		var loadingFromSlot = this.loadFromSlot;
		var continuous = false;
		if (this.signalledContinuousPreview)
		{
			continuous = true;
			savingToSlot = "__c2_continuouspreview";
			this.signalledContinuousPreview = false;
		}
		if (savingToSlot.length)
		{
			this.ClearDeathRow();
			savingJson = this.saveToJSONString();
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_WriteSlot(savingToSlot, savingJson, function ()
				{
					cr.logexport("Saved state to IndexedDB storage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}, function (e)
				{
					try {
						localStorage.setItem("__c2save_" + savingToSlot, savingJson);
						cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
						self.lastSaveJson = savingJson;
						self.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
						self.lastSaveJson = "";
						if (continuous)
							doContinuousPreviewReload();
					}
					catch (f)
					{
						cr.logexport("Failed to save game state: " + e + "; " + f);
					}
				});
			}
			else
			{
				try {
					localStorage.setItem("__c2save_" + savingToSlot, savingJson);
					cr.logexport("Saved state to WebStorage (" + savingJson.length + " bytes)");
					self.lastSaveJson = savingJson;
					this.trigger(cr.system_object.prototype.cnds.OnSaveComplete, null);
					self.lastSaveJson = "";
					if (continuous)
						doContinuousPreviewReload();
				}
				catch (e)
				{
					cr.logexport("Error saving to WebStorage: " + e);
				}
			}
			this.saveToSlot = "";
			this.loadFromSlot = "";
			this.loadFromJson = "";
		}
		if (loadingFromSlot.length)
		{
			if (window.indexedDB && !this.isCocoonJs)
			{
				IndexedDB_ReadSlot(loadingFromSlot, function (result_)
				{
					if (result_)
					{
						self.loadFromJson = result_;
						cr.logexport("Loaded state from IndexedDB storage (" + self.loadFromJson.length + " bytes)");
					}
					else
					{
						self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
						cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					}
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				}, function (e)
				{
					self.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
					cr.logexport("Loaded state from WebStorage (" + self.loadFromJson.length + " bytes)");
					self.suspendDrawing = false;
					if (!self.loadFromJson.length)
						self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
				});
			}
			else
			{
				this.loadFromJson = localStorage.getItem("__c2save_" + loadingFromSlot) || "";
				cr.logexport("Loaded state from WebStorage (" + this.loadFromJson.length + " bytes)");
				this.suspendDrawing = false;
				if (!self.loadFromJson.length)
					self.trigger(cr.system_object.prototype.cnds.OnLoadFailed, null);
			}
			this.loadFromSlot = "";
			this.saveToSlot = "";
		}
		if (this.loadFromJson.length)
		{
			this.ClearDeathRow();
			this.loadFromJSONString(this.loadFromJson);
			this.lastSaveJson = this.loadFromJson;
			this.trigger(cr.system_object.prototype.cnds.OnLoadComplete, null);
			this.lastSaveJson = "";
			this.loadFromJson = "";
		}
	};
	function CopyExtraObject(extra)
	{
		var p, ret = {};
		for (p in extra)
		{
			if (extra.hasOwnProperty(p))
			{
				if (extra[p] instanceof cr.ObjectSet)
					continue;
				if (extra[p] && typeof extra[p].c2userdata !== "undefined")
					continue;
				ret[p] = extra[p];
			}
		}
		return ret;
	};
	Runtime.prototype.saveToJSONString = function()
	{
		var i, len, j, lenj, type, layout, typeobj, g, c, a, v, p;
		var o = {
			"c2save":				true,
			"version":				1,
			"rt": {
				"time":				this.kahanTime.sum,
				"timescale":		this.timescale,
				"tickcount":		this.tickcount,
				"execcount":		this.execcount,
				"next_uid":			this.next_uid,
				"running_layout":	this.running_layout.sid,
				"start_time_offset": (Date.now() - this.start_time)
			},
			"types": {},
			"layouts": {},
			"events": {
				"groups": {},
				"cnds": {},
				"acts": {},
				"vars": {}
			}
		};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family || this.typeHasNoSaveBehavior(type))
				continue;
			typeobj = {
				"instances": []
			};
			if (cr.hasAnyOwnProperty(type.extra))
				typeobj["ex"] = CopyExtraObject(type.extra);
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				typeobj["instances"].push(this.saveInstanceToJSON(type.instances[j]));
			}
			o["types"][type.sid.toString()] = typeobj;
		}
		for (i = 0, len = this.layouts_by_index.length; i < len; i++)
		{
			layout = this.layouts_by_index[i];
			o["layouts"][layout.sid.toString()] = layout.saveToJSON();
		}
		var ogroups = o["events"]["groups"];
		for (i = 0, len = this.allGroups.length; i < len; i++)
		{
			g = this.allGroups[i];
			ogroups[g.sid.toString()] = this.groups_by_name[g.group_name].group_active;
		}
		var ocnds = o["events"]["cnds"];
		for (p in this.cndsBySid)
		{
			if (this.cndsBySid.hasOwnProperty(p))
			{
				c = this.cndsBySid[p];
				if (cr.hasAnyOwnProperty(c.extra))
					ocnds[p] = { "ex": CopyExtraObject(c.extra) };
			}
		}
		var oacts = o["events"]["acts"];
		for (p in this.actsBySid)
		{
			if (this.actsBySid.hasOwnProperty(p))
			{
				a = this.actsBySid[p];
				if (cr.hasAnyOwnProperty(a.extra))
					oacts[p] = { "ex": a.extra };
			}
		}
		var ovars = o["events"]["vars"];
		for (p in this.varsBySid)
		{
			if (this.varsBySid.hasOwnProperty(p))
			{
				v = this.varsBySid[p];
				if (!v.is_constant && (!v.parent || v.is_static))
					ovars[p] = v.data;
			}
		}
		o["system"] = this.system.saveToJSON();
		return JSON.stringify(o);
	};
	Runtime.prototype.refreshUidMap = function ()
	{
		var i, len, type, j, lenj, inst;
		this.objectsByUid = {};
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				this.objectsByUid[inst.uid.toString()] = inst;
			}
		}
	};
	Runtime.prototype.loadFromJSONString = function (str)
	{
		var o = JSON.parse(str);
		if (!o["c2save"])
			return;		// probably not a c2 save state
		if (o["version"] > 1)
			return;		// from future version of c2; assume not compatible
		var rt = o["rt"];
		this.kahanTime.reset();
		this.kahanTime.sum = rt["time"];
		this.timescale = rt["timescale"];
		this.tickcount = rt["tickcount"];
		this.start_time = Date.now() - rt["start_time_offset"];
		var layout_sid = rt["running_layout"];
		if (layout_sid !== this.running_layout.sid)
		{
			var changeToLayout = this.getLayoutBySid(layout_sid);
			if (changeToLayout)
				this.doChangeLayout(changeToLayout);
			else
				return;		// layout that was saved on has gone missing (deleted?)
		}
		this.isLoadingState = true;
		var i, len, j, lenj, k, lenk, p, type, existing_insts, load_insts, inst, binst, layout, layer, g, iid, t;
		var otypes = o["types"];
		for (p in otypes)
		{
			if (otypes.hasOwnProperty(p))
			{
				type = this.getObjectTypeBySid(parseInt(p, 10));
				if (!type || type.is_family || this.typeHasNoSaveBehavior(type))
					continue;
				if (otypes[p]["ex"])
					type.extra = otypes[p]["ex"];
				else
					cr.wipe(type.extra);
				existing_insts = type.instances;
				load_insts = otypes[p]["instances"];
				for (i = 0, len = cr.min(existing_insts.length, load_insts.length); i < len; i++)
				{
					this.loadInstanceFromJSON(existing_insts[i], load_insts[i]);
				}
				for (i = load_insts.length, len = existing_insts.length; i < len; i++)
					this.DestroyInstance(existing_insts[i]);
				for (i = existing_insts.length, len = load_insts.length; i < len; i++)
				{
					layer = null;
					if (type.plugin.is_world)
					{
						layer = this.running_layout.getLayerBySid(load_insts[i]["w"]["l"]);
						if (!layer)
							continue;
					}
					inst = this.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
					this.loadInstanceFromJSON(inst, load_insts[i]);
				}
				type.stale_iids = true;
			}
		}
		this.ClearDeathRow();
		this.refreshUidMap();
		var olayouts = o["layouts"];
		for (p in olayouts)
		{
			if (olayouts.hasOwnProperty(p))
			{
				layout = this.getLayoutBySid(parseInt(p, 10));
				if (!layout)
					continue;		// must've gone missing
				layout.loadFromJSON(olayouts[p]);
			}
		}
		var ogroups = o["events"]["groups"];
		for (p in ogroups)
		{
			if (ogroups.hasOwnProperty(p))
			{
				g = this.getGroupBySid(parseInt(p, 10));
				if (g && this.groups_by_name[g.group_name])
					this.groups_by_name[g.group_name].group_active = ogroups[p];
			}
		}
		var ocnds = o["events"]["cnds"];
		for (p in ocnds)
		{
			if (ocnds.hasOwnProperty(p) && this.cndsBySid.hasOwnProperty(p))
			{
				this.cndsBySid[p].extra = ocnds[p]["ex"];
			}
		}
		var oacts = o["events"]["acts"];
		for (p in oacts)
		{
			if (oacts.hasOwnProperty(p) && this.actsBySid.hasOwnProperty(p))
			{
				this.actsBySid[p].extra = oacts[p]["ex"];
			}
		}
		var ovars = o["events"]["vars"];
		for (p in ovars)
		{
			if (ovars.hasOwnProperty(p) && this.varsBySid.hasOwnProperty(p))
			{
				this.varsBySid[p].data = ovars[p];
			}
		}
		this.next_uid = rt["next_uid"];
		this.isLoadingState = false;
		this.system.loadFromJSON(o["system"]);
		for (i = 0, len = this.types_by_index.length; i < len; i++)
		{
			type = this.types_by_index[i];
			if (type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
			{
				inst = type.instances[j];
				if (type.is_contained)
				{
					iid = inst.get_iid();
					inst.siblings.length = 0;
					for (k = 0, lenk = type.container.length; k < lenk; k++)
					{
						t = type.container[k];
						if (type === t)
							continue;
;
						inst.siblings.push(t.instances[iid]);
					}
				}
				if (inst.afterLoad)
					inst.afterLoad();
				if (inst.behavior_insts)
				{
					for (k = 0, lenk = inst.behavior_insts.length; k < lenk; k++)
					{
						binst = inst.behavior_insts[k];
						if (binst.afterLoad)
							binst.afterLoad();
					}
				}
			}
		}
		this.redraw = true;
	};
	Runtime.prototype.saveInstanceToJSON = function(inst, state_only)
	{
		var i, len, world, behinst, et;
		var type = inst.type;
		var plugin = type.plugin;
		var o = {};
		if (state_only)
			o["c2"] = true;		// mark as known json data from Construct 2
		else
			o["uid"] = inst.uid;
		if (cr.hasAnyOwnProperty(inst.extra))
			o["ex"] = CopyExtraObject(inst.extra);
		if (inst.instance_vars && inst.instance_vars.length)
		{
			o["ivs"] = {};
			for (i = 0, len = inst.instance_vars.length; i < len; i++)
			{
				o["ivs"][inst.type.instvar_sids[i].toString()] = inst.instance_vars[i];
			}
		}
		if (plugin.is_world)
		{
			world = {
				"x": inst.x,
				"y": inst.y,
				"w": inst.width,
				"h": inst.height,
				"l": inst.layer.sid,
				"zi": inst.get_zindex()
			};
			if (inst.angle !== 0)
				world["a"] = inst.angle;
			if (inst.opacity !== 1)
				world["o"] = inst.opacity;
			if (inst.hotspotX !== 0.5)
				world["hX"] = inst.hotspotX;
			if (inst.hotspotY !== 0.5)
				world["hY"] = inst.hotspotY;
			if (inst.blend_mode !== 0)
				world["bm"] = inst.blend_mode;
			if (!inst.visible)
				world["v"] = inst.visible;
			if (!inst.collisionsEnabled)
				world["ce"] = inst.collisionsEnabled;
			if (inst.my_timescale !== -1)
				world["mts"] = inst.my_timescale;
			if (type.effect_types.length)
			{
				world["fx"] = [];
				for (i = 0, len = type.effect_types.length; i < len; i++)
				{
					et = type.effect_types[i];
					world["fx"].push({"name": et.name,
									  "active": inst.active_effect_flags[et.index],
									  "params": inst.effect_params[et.index] });
				}
			}
			o["w"] = world;
		}
		if (inst.behavior_insts && inst.behavior_insts.length)
		{
			o["behs"] = {};
			for (i = 0, len = inst.behavior_insts.length; i < len; i++)
			{
				behinst = inst.behavior_insts[i];
				if (behinst.saveToJSON)
					o["behs"][behinst.type.sid.toString()] = behinst.saveToJSON();
			}
		}
		if (inst.saveToJSON)
			o["data"] = inst.saveToJSON();
		return o;
	};
	Runtime.prototype.getInstanceVarIndexBySid = function (type, sid_)
	{
		var i, len;
		for (i = 0, len = type.instvar_sids.length; i < len; i++)
		{
			if (type.instvar_sids[i] === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.getBehaviorIndexBySid = function (inst, sid_)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i].type.sid === sid_)
				return i;
		}
		return -1;
	};
	Runtime.prototype.loadInstanceFromJSON = function(inst, o, state_only)
	{
		var p, i, len, iv, oivs, world, fxindex, obehs, behindex;
		var oldlayer;
		var type = inst.type;
		var plugin = type.plugin;
		if (state_only)
		{
			if (!o["c2"])
				return;
		}
		else
			inst.uid = o["uid"];
		if (o["ex"])
			inst.extra = o["ex"];
		else
			cr.wipe(inst.extra);
		oivs = o["ivs"];
		if (oivs)
		{
			for (p in oivs)
			{
				if (oivs.hasOwnProperty(p))
				{
					iv = this.getInstanceVarIndexBySid(type, parseInt(p, 10));
					if (iv < 0 || iv >= inst.instance_vars.length)
						continue;		// must've gone missing
					inst.instance_vars[iv] = oivs[p];
				}
			}
		}
		if (plugin.is_world)
		{
			world = o["w"];
			if (inst.layer.sid !== world["l"])
			{
				oldlayer = inst.layer;
				inst.layer = this.running_layout.getLayerBySid(world["l"]);
				if (inst.layer)
				{
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
					cr.arrayFindRemove(oldlayer.instances, inst);
					oldlayer.zindices_stale = true;
				}
				else
				{
					inst.layer = oldlayer;
					this.DestroyInstance(inst);
				}
			}
			inst.x = world["x"];
			inst.y = world["y"];
			inst.width = world["w"];
			inst.height = world["h"];
			inst.zindex = world["zi"];
			inst.angle = world.hasOwnProperty("a") ? world["a"] : 0;
			inst.opacity = world.hasOwnProperty("o") ? world["o"] : 1;
			inst.hotspotX = world.hasOwnProperty("hX") ? world["hX"] : 0.5;
			inst.hotspotY = world.hasOwnProperty("hY") ? world["hY"] : 0.5;
			inst.visible = world.hasOwnProperty("v") ? world["v"] : true;
			inst.collisionsEnabled = world.hasOwnProperty("ce") ? world["ce"] : true;
			inst.my_timescale = world.hasOwnProperty("mts") ? world["mts"] : -1;
			inst.blend_mode = world.hasOwnProperty("bm") ? world["bm"] : 0;;
			inst.compositeOp = cr.effectToCompositeOp(inst.blend_mode);
			if (this.gl)
				cr.setGLBlend(inst, inst.blend_mode, this.gl);
			inst.set_bbox_changed();
			if (world.hasOwnProperty("fx"))
			{
				for (i = 0, len = world["fx"].length; i < len; i++)
				{
					fxindex = type.getEffectIndexByName(world["fx"][i]["name"]);
					if (fxindex < 0)
						continue;		// must've gone missing
					inst.active_effect_flags[fxindex] = world["fx"][i]["active"];
					inst.effect_params[fxindex] = world["fx"][i]["params"];
				}
			}
			inst.updateActiveEffects();
		}
		obehs = o["behs"];
		if (obehs)
		{
			for (p in obehs)
			{
				if (obehs.hasOwnProperty(p))
				{
					behindex = this.getBehaviorIndexBySid(inst, parseInt(p, 10));
					if (behindex < 0)
						continue;		// must've gone missing
					inst.behavior_insts[behindex].loadFromJSON(obehs[p]);
				}
			}
		}
		if (o["data"])
			inst.loadFromJSON(o["data"]);
	};
	cr.runtime = Runtime;
	cr.createRuntime = function (canvasid)
	{
		return new Runtime(document.getElementById(canvasid));
	};
	cr.createDCRuntime = function (w, h)
	{
		return new Runtime({ "dc": true, "width": w, "height": h });
	};
	window["cr_createRuntime"] = cr.createRuntime;
	window["cr_createDCRuntime"] = cr.createDCRuntime;
	window["createCocoonJSRuntime"] = function ()
	{
		window["c2cocoonjs"] = true;
		var canvas = document.createElement("screencanvas") || document.createElement("canvas");
		canvas.screencanvas = true;
		document.body.appendChild(canvas);
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window.addEventListener("orientationchange", function () {
			window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		});
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
	window["createEjectaRuntime"] = function ()
	{
		var canvas = document.getElementById("canvas");
		var rt = new Runtime(canvas);
		window["c2runtime"] = rt;
		window["c2runtime"]["setSize"](window.innerWidth, window.innerHeight);
		return rt;
	};
}());
window["cr_getC2Runtime"] = function()
{
	var canvas = document.getElementById("c2canvas");
	if (canvas)
		return canvas["c2runtime"];
	else if (window["c2runtime"])
		return window["c2runtime"];
	else
		return null;
}
window["cr_sizeCanvas"] = function(w, h)
{
	if (w === 0 || h === 0)
		return;
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSize"](w, h);
}
window["cr_setSuspended"] = function(s)
{
	var runtime = window["cr_getC2Runtime"]();
	if (runtime)
		runtime["setSuspended"](s);
}
;
(function()
{
	function Layout(runtime, m)
	{
		this.runtime = runtime;
		this.event_sheet = null;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		this.scale = 1.0;
		this.angle = 0;
		this.first_visit = true;
		this.name = m[0];
		this.width = m[1];
		this.height = m[2];
		this.unbounded_scrolling = m[3];
		this.sheetname = m[4];
		this.sid = m[5];
		var lm = m[6];
		var i, len;
		this.layers = [];
		this.initial_types = [];
		for (i = 0, len = lm.length; i < len; i++)
		{
			var layer = new cr.layer(this, lm[i]);
			layer.number = i;
			cr.seal(layer);
			this.layers.push(layer);
		}
		var im = m[7];
		this.initial_nonworld = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
				type.default_instance = inst;
			this.initial_nonworld.push(inst);
			if (this.initial_types.indexOf(type) === -1)
				this.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[8].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[8][i][0],
				name: m[8][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[8][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
		this.persist_data = {};
	};
	Layout.prototype.saveObjectToPersist = function (inst)
	{
		var sidStr = inst.type.sid.toString();
		if (!this.persist_data.hasOwnProperty(sidStr))
			this.persist_data[sidStr] = [];
		var type_persist = this.persist_data[sidStr];
		type_persist.push(this.runtime.saveInstanceToJSON(inst));
	};
	Layout.prototype.hasOpaqueBottomLayer = function ()
	{
		var layer = this.layers[0];
		return !layer.transparent && layer.opacity === 1.0 && !layer.forceOwnTexture && layer.visible;
	};
	Layout.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layout.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	var created_instances = [];
	Layout.prototype.startRunning = function ()
	{
		if (this.sheetname)
		{
			this.event_sheet = this.runtime.eventsheets[this.sheetname];
;
			this.event_sheet.updateDeepIncludes();
		}
		this.runtime.running_layout = this;
		this.scrollX = (this.runtime.original_width / 2);
		this.scrollY = (this.runtime.original_height / 2);
		var i, k, len, lenk, type, type_instances, inst, iid, t, s, p, q, type_data, layer;
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.is_family)
				continue;		// instances are only transferred for their real type
			type_instances = type.instances;
			for (k = 0, lenk = type_instances.length; k < lenk; k++)
			{
				inst = type_instances[k];
				if (inst.layer)
				{
					var num = inst.layer.number;
					if (num >= this.layers.length)
						num = this.layers.length - 1;
					inst.layer = this.layers[num];
					inst.layer.instances.push(inst);
					inst.layer.zindices_stale = true;
				}
			}
		}
		var layer;
		created_instances.length = 0;
		this.boundScrolling();
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			layer.createInitialInstances();		// fills created_instances
			layer.disableAngle = true;
			var px = layer.canvasToLayer(0, 0, true, true);
			var py = layer.canvasToLayer(0, 0, false, true);
			layer.disableAngle = false;
			if (this.runtime.pixel_rounding)
			{
				px = (px + 0.5) | 0;
				py = (py + 0.5) | 0;
			}
			layer.rotateViewport(px, py, null);
		}
		var uids_changed = false;
		if (!this.first_visit)
		{
			for (p in this.persist_data)
			{
				if (this.persist_data.hasOwnProperty(p))
				{
					type = this.runtime.getObjectTypeBySid(parseInt(p, 10));
					if (!type || type.is_family || !this.runtime.typeHasPersistBehavior(type))
						continue;
					type_data = this.persist_data[p];
					for (i = 0, len = type_data.length; i < len; i++)
					{
						layer = null;
						if (type.plugin.is_world)
						{
							layer = this.getLayerBySid(type_data[i]["w"]["l"]);
							if (!layer)
								continue;
						}
						inst = this.runtime.createInstanceFromInit(type.default_instance, layer, false, 0, 0, true);
						this.runtime.loadInstanceFromJSON(inst, type_data[i]);
						uids_changed = true;
						created_instances.push(inst);
					}
					type_data.length = 0;
				}
			}
			for (i = 0, len = this.layers.length; i < len; i++)
			{
				this.layers[i].instances.sort(sortInstanceByZIndex);
				this.layers[i].zindices_stale = true;		// in case of duplicates/holes
			}
		}
		if (uids_changed)
		{
			this.runtime.ClearDeathRow();
			this.runtime.refreshUidMap();
		}
		for (i = 0; i < created_instances.length; i++)
		{
			inst = created_instances[i];
			if (!inst.type.is_contained)
				continue;
			iid = inst.get_iid();
			for (k = 0, lenk = inst.type.container.length; k < lenk; k++)
			{
				t = inst.type.container[k];
				if (inst.type === t)
					continue;
				if (t.instances.length > iid)
					inst.siblings.push(t.instances[iid]);
				else
				{
					if (!t.default_instance)
					{
					}
					else
					{
						s = this.runtime.createInstanceFromInit(t.default_instance, inst.layer, true, inst.x, inst.y, true);
						this.runtime.ClearDeathRow();
						t.updateIIDs();
						inst.siblings.push(s);
						created_instances.push(s);		// come back around and link up its own instances too
					}
				}
			}
		}
		for (i = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			inst = this.runtime.createInstanceFromInit(this.initial_nonworld[i], null, true);
;
		}
		this.runtime.changelayout = null;
		this.runtime.ClearDeathRow();
		if (this.runtime.ctx && !this.runtime.isDomFree)
		{
			for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
			{
				t = this.runtime.types_by_index[i];
				if (t.is_family || !t.instances.length || !t.preloadCanvas2D)
					continue;
				t.preloadCanvas2D(this.runtime.ctx);
			}
		}
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout start: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		for (i = 0, len = created_instances.length; i < len; i++)
		{
			inst = created_instances[i];
			this.runtime.trigger(Object.getPrototypeOf(inst.type.plugin).cnds.OnCreated, inst);
		}
		created_instances.length = 0;
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutStart, null);
		this.first_visit = false;
	};
	Layout.prototype.createGlobalNonWorlds = function ()
	{
		var i, k, len, initial_inst, inst, type;
		for (i = 0, k = 0, len = this.initial_nonworld.length; i < len; i++)
		{
			initial_inst = this.initial_nonworld[i];
			type = this.runtime.types_by_index[initial_inst[1]];
			if (type.global)
				inst = this.runtime.createInstanceFromInit(initial_inst, null, true);
			else
			{
				this.initial_nonworld[k] = initial_inst;
				k++;
			}
		}
		this.initial_nonworld.length = k;
	};
	Layout.prototype.stopRunning = function ()
	{
;
		/*
		if (this.runtime.glwrap)
		{
			console.log("Estimated VRAM at layout end: " + this.runtime.glwrap.textureCount() + " textures, approx. " + Math.round(this.runtime.glwrap.estimateVRAM() / 1024) + " kb");
		}
		*/
		this.runtime.trigger(cr.system_object.prototype.cnds.OnLayoutEnd, null);
		this.runtime.system.waits.length = 0;
		var i, leni, j, lenj;
		var layer_instances, inst, type;
		for (i = 0, leni = this.layers.length; i < leni; i++)
		{
			layer_instances = this.layers[i].instances;
			for (j = 0, lenj = layer_instances.length; j < lenj; j++)
			{
				inst = layer_instances[j];
				if (!inst.type.global)
				{
					if (this.runtime.typeHasPersistBehavior(inst.type))
						this.saveObjectToPersist(inst);
					this.runtime.DestroyInstance(inst);
				}
			}
			this.runtime.ClearDeathRow();
			layer_instances.length = 0;
			this.layers[i].zindices_stale = true;
		}
		for (i = 0, leni = this.runtime.types_by_index.length; i < leni; i++)
		{
			type = this.runtime.types_by_index[i];
			if (type.global || type.plugin.is_world || type.plugin.singleglobal || type.is_family)
				continue;
			for (j = 0, lenj = type.instances.length; j < lenj; j++)
				this.runtime.DestroyInstance(type.instances[j]);
			this.runtime.ClearDeathRow();
		}
	};
	Layout.prototype.draw = function (ctx)
	{
		var layout_canvas;
		var layout_ctx = ctx;
		var ctx_changed = false;
		var render_offscreen = !this.runtime.fullscreenScalingQuality;
		if (render_offscreen)
		{
			if (!this.runtime.layout_canvas)
			{
				this.runtime.layout_canvas = document.createElement("canvas");
				layout_canvas = this.runtime.layout_canvas;
				layout_canvas.width = this.runtime.draw_width;
				layout_canvas.height = this.runtime.draw_height;
				this.runtime.layout_ctx = layout_canvas.getContext("2d");
				ctx_changed = true;
			}
			layout_canvas = this.runtime.layout_canvas;
			layout_ctx = this.runtime.layout_ctx;
			if (layout_canvas.width !== this.runtime.draw_width)
			{
				layout_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layout_canvas.height !== this.runtime.draw_height)
			{
				layout_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layout_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layout_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
		}
		layout_ctx.globalAlpha = 1;
		layout_ctx.globalCompositeOperation = "source-over";
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			layout_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		var i, len, l;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.visible && l.opacity > 0 && l.blend_mode !== 11)
				l.draw(layout_ctx);
		}
		if (render_offscreen)
		{
			ctx.drawImage(layout_canvas, 0, 0, this.runtime.width, this.runtime.height);
		}
	};
	Layout.prototype.drawGL = function (glw)
	{
		var render_to_texture = (this.active_effect_types.length > 0 ||
								 this.runtime.uses_background_blending ||
								 !this.runtime.fullscreenScalingQuality);
		if (render_to_texture)
		{
			if (!this.runtime.layout_tex)
			{
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layout_tex.c2width !== this.runtime.draw_width || this.runtime.layout_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layout_tex);
			if (!this.runtime.fullscreenScalingQuality)
			{
				glw.setSize(this.runtime.draw_width, this.runtime.draw_height);
			}
		}
		else
		{
			if (this.runtime.layout_tex)
			{
				glw.setRenderingToTexture(null);
				glw.deleteTexture(this.runtime.layout_tex);
				this.runtime.layout_tex = null;
			}
		}
		if (this.runtime.alphaBackground && !this.hasOpaqueBottomLayer())
			glw.clear(0, 0, 0, 0);
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].visible && this.layers[i].opacity > 0)
				this.layers[i].drawGL(glw);
		}
		if (render_to_texture)
		{
			if (this.active_effect_types.length === 0 ||
				(this.active_effect_types.length === 1 && this.runtime.fullscreenScalingQuality))
			{
				if (this.active_effect_types.length === 1)
				{
					var etindex = this.active_effect_types[0].index;
					glw.switchProgram(this.active_effect_types[0].shaderindex);
					glw.setProgramParameters(null,								// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.scale,						// layerScale
											 this.angle,						// layerAngle
											 0.0, 0.0,							// viewOrigin
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(this.active_effect_types[0].shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
				}
				glw.setRenderingToTexture(null);				// to backbuffer
				glw.setOpacity(1);
				glw.setTexture(this.runtime.layout_tex);
				glw.setAlphaBlend();
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.width / 2;
				var halfh = this.runtime.height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.renderEffectChain(glw, null, null, null);
			}
		}
	};
	Layout.prototype.getRenderTarget = function()
	{
		return (this.active_effect_types.length > 0 ||
				this.runtime.uses_background_blending ||
				!this.runtime.fullscreenScalingQuality) ? this.runtime.layout_tex : null;
	};
	Layout.prototype.getMinLayerScale = function ()
	{
		var m = this.layers[0].getScale();
		var i, len, l;
		for (i = 1, len = this.layers.length; i < len; i++)
		{
			l = this.layers[i];
			if (l.parallaxX === 0 && l.parallaxY === 0)
				continue;
			if (l.getScale() < m)
				m = l.getScale();
		}
		return m;
	};
	Layout.prototype.scrollToX = function (x)
	{
		if (!this.unbounded_scrolling)
		{
			var widthBoundary = (this.runtime.draw_width * (1 / this.getMinLayerScale()) / 2);
			if (x > this.width - widthBoundary)
				x = this.width - widthBoundary;
			if (x < widthBoundary)
				x = widthBoundary;
		}
		if (this.scrollX !== x)
		{
			this.scrollX = x;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.scrollToY = function (y)
	{
		if (!this.unbounded_scrolling)
		{
			var heightBoundary = (this.runtime.draw_height * (1 / this.getMinLayerScale()) / 2);
			if (y > this.height - heightBoundary)
				y = this.height - heightBoundary;
			if (y < heightBoundary)
				y = heightBoundary;
		}
		if (this.scrollY !== y)
		{
			this.scrollY = y;
			this.runtime.redraw = true;
		}
	};
	Layout.prototype.boundScrolling = function ()
	{
		this.scrollToX(this.scrollX);
		this.scrollToY(this.scrollY);
	};
	Layout.prototype.renderEffectChain = function (glw, layer, inst, rendertarget)
	{
		var active_effect_types = inst ?
							inst.active_effect_types :
							layer ?
								layer.active_effect_types :
								this.active_effect_types;
		var layerScale = 1, layerAngle = 0, viewOriginLeft = 0, viewOriginTop = 0;
		if (inst)
		{
			layerScale = inst.layer.getScale();
			layerAngle = inst.layer.getAngle();
			viewOriginLeft = inst.layer.viewLeft;
			viewOriginTop = inst.layer.viewTop;
		}
		else if (layer)
		{
			layerScale = layer.getScale();
			layerAngle = layer.getAngle();
			viewOriginLeft = layer.viewLeft;
			viewOriginTop = layer.viewTop;
		}
		var fx_tex = this.runtime.fx_tex;
		var i, len, last, temp, fx_index = 0, other_fx_index = 1;
		var y, h;
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var halfw = windowWidth / 2;
		var halfh = windowHeight / 2;
		var rcTex = layer ? layer.rcTex : this.rcTex;
		var rcTex2 = layer ? layer.rcTex2 : this.rcTex2;
		var screenleft = 0, clearleft = 0;
		var screentop = 0, cleartop = 0;
		var screenright = windowWidth, clearright = windowWidth;
		var screenbottom = windowHeight, clearbottom = windowHeight;
		var boxExtendHorizontal = 0;
		var boxExtendVertical = 0;
		var inst_layer_angle = inst ? inst.layer.getAngle() : 0;
		if (inst)
		{
			for (i = 0, len = active_effect_types.length; i < len; i++)
			{
				boxExtendHorizontal += glw.getProgramBoxExtendHorizontal(active_effect_types[i].shaderindex);
				boxExtendVertical += glw.getProgramBoxExtendVertical(active_effect_types[i].shaderindex);
			}
			var bbox = inst.bbox;
			screenleft = layer.layerToCanvas(bbox.left, bbox.top, true, true);
			screentop = layer.layerToCanvas(bbox.left, bbox.top, false, true);
			screenright = layer.layerToCanvas(bbox.right, bbox.bottom, true, true);
			screenbottom = layer.layerToCanvas(bbox.right, bbox.bottom, false, true);
			if (inst_layer_angle !== 0)
			{
				var screentrx = layer.layerToCanvas(bbox.right, bbox.top, true, true);
				var screentry = layer.layerToCanvas(bbox.right, bbox.top, false, true);
				var screenblx = layer.layerToCanvas(bbox.left, bbox.bottom, true, true);
				var screenbly = layer.layerToCanvas(bbox.left, bbox.bottom, false, true);
				temp = Math.min(screenleft, screenright, screentrx, screenblx);
				screenright = Math.max(screenleft, screenright, screentrx, screenblx);
				screenleft = temp;
				temp = Math.min(screentop, screenbottom, screentry, screenbly);
				screenbottom = Math.max(screentop, screenbottom, screentry, screenbly);
				screentop = temp;
			}
			screenleft -= boxExtendHorizontal;
			screentop -= boxExtendVertical;
			screenright += boxExtendHorizontal;
			screenbottom += boxExtendVertical;
			rcTex2.left = screenleft / windowWidth;
			rcTex2.top = 1 - screentop / windowHeight;
			rcTex2.right = screenright / windowWidth;
			rcTex2.bottom = 1 - screenbottom / windowHeight;
			clearleft = screenleft = cr.floor(screenleft);
			cleartop = screentop = cr.floor(screentop);
			clearright = screenright = cr.ceil(screenright);
			clearbottom = screenbottom = cr.ceil(screenbottom);
			clearleft -= boxExtendHorizontal;
			cleartop -= boxExtendVertical;
			clearright += boxExtendHorizontal;
			clearbottom += boxExtendVertical;
			if (screenleft < 0)					screenleft = 0;
			if (screentop < 0)					screentop = 0;
			if (screenright > windowWidth)		screenright = windowWidth;
			if (screenbottom > windowHeight)	screenbottom = windowHeight;
			if (clearleft < 0)					clearleft = 0;
			if (cleartop < 0)					cleartop = 0;
			if (clearright > windowWidth)		clearright = windowWidth;
			if (clearbottom > windowHeight)		clearbottom = windowHeight;
			rcTex.left = screenleft / windowWidth;
			rcTex.top = 1 - screentop / windowHeight;
			rcTex.right = screenright / windowWidth;
			rcTex.bottom = 1 - screenbottom / windowHeight;
		}
		else
		{
			rcTex.left = rcTex2.left = 0;
			rcTex.top = rcTex2.top = 0;
			rcTex.right = rcTex2.right = 1;
			rcTex.bottom = rcTex2.bottom = 1;
		}
		var pre_draw = (inst && (((inst.angle || inst_layer_angle) && glw.programUsesDest(active_effect_types[0].shaderindex)) || boxExtendHorizontal !== 0 || boxExtendVertical !== 0 || inst.opacity !== 1 || inst.type.plugin.must_predraw)) || (layer && !inst && layer.opacity !== 1);
		glw.setAlphaBlend();
		if (pre_draw)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(0);
			glw.setRenderingToTexture(fx_tex[fx_index]);
			h = clearbottom - cleartop;
			y = (windowHeight - cleartop) - h;
			glw.clearRect(clearleft, y, clearright - clearleft, h);
			if (inst)
			{
				inst.drawGL(glw);
			}
			else
			{
				glw.setTexture(this.runtime.layer_tex);
				glw.setOpacity(layer.opacity);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			}
			rcTex2.left = rcTex2.top = 0;
			rcTex2.right = rcTex2.bottom = 1;
			if (inst)
			{
				temp = rcTex.top;
				rcTex.top = rcTex.bottom;
				rcTex.bottom = temp;
			}
			fx_index = 1;
			other_fx_index = 0;
		}
		glw.setOpacity(1);
		var last = active_effect_types.length - 1;
		var post_draw = glw.programUsesCrossSampling(active_effect_types[last].shaderindex) ||
						(!layer && !inst && !this.runtime.fullscreenScalingQuality);
		var etindex = 0;
		for (i = 0, len = active_effect_types.length; i < len; i++)
		{
			if (!fx_tex[fx_index])
			{
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			if (fx_tex[fx_index].c2width !== windowWidth || fx_tex[fx_index].c2height !== windowHeight)
			{
				glw.deleteTexture(fx_tex[fx_index]);
				fx_tex[fx_index] = glw.createEmptyTexture(windowWidth, windowHeight, this.runtime.linearSampling);
			}
			glw.switchProgram(active_effect_types[i].shaderindex);
			etindex = active_effect_types[i].index;
			if (glw.programIsAnimated(active_effect_types[i].shaderindex))
				this.runtime.redraw = true;
			if (i == 0 && !pre_draw)
			{
				glw.setRenderingToTexture(fx_tex[fx_index]);
				h = clearbottom - cleartop;
				y = (windowHeight - cleartop) - h;
				glw.clearRect(clearleft, y, clearright - clearleft, h);
				if (inst)
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / inst.width,				// pixelWidth
											 1.0 / inst.height,				// pixelHeight
											 rcTex2.left, rcTex2.top,		// destStart
											 rcTex2.right, rcTex2.bottom,	// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 inst.effect_params[etindex]);	// fx params
					inst.drawGL(glw);
				}
				else
				{
					glw.setProgramParameters(rendertarget,					// backTex
											 1.0 / windowWidth,				// pixelWidth
											 1.0 / windowHeight,			// pixelHeight
											 0.0, 0.0,						// destStart
											 1.0, 1.0,						// destEnd
											 layerScale,
											 layerAngle,
											 viewOriginLeft, viewOriginTop,
											 layer ?						// fx params
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
					glw.setTexture(layer ? this.runtime.layer_tex : this.runtime.layout_tex);
					glw.resetModelView();
					glw.translate(-halfw, -halfh);
					glw.updateModelView();
					glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				}
				rcTex2.left = rcTex2.top = 0;
				rcTex2.right = rcTex2.bottom = 1;
				if (inst && !post_draw)
				{
					temp = screenbottom;
					screenbottom = screentop;
					screentop = temp;
				}
			}
			else
			{
				glw.setProgramParameters(rendertarget,						// backTex
										 1.0 / windowWidth,					// pixelWidth
										 1.0 / windowHeight,				// pixelHeight
										 rcTex2.left, rcTex2.top,			// destStart
										 rcTex2.right, rcTex2.bottom,		// destEnd
										 layerScale,
										 layerAngle,
										 viewOriginLeft, viewOriginTop,
										 inst ?								// fx params
											inst.effect_params[etindex] :
											layer ?
												layer.effect_params[etindex] :
												this.effect_params[etindex]);
				glw.setTexture(null);
				if (i === last && !post_draw)
				{
					if (inst)
						glw.setBlend(inst.srcBlend, inst.destBlend);
					else if (layer)
						glw.setBlend(layer.srcBlend, layer.destBlend);
					glw.setRenderingToTexture(rendertarget);
				}
				else
				{
					glw.setRenderingToTexture(fx_tex[fx_index]);
					h = clearbottom - cleartop;
					y = (windowHeight - cleartop) - h;
					glw.clearRect(clearleft, y, clearright - clearleft, h);
				}
				glw.setTexture(fx_tex[other_fx_index]);
				glw.resetModelView();
				glw.translate(-halfw, -halfh);
				glw.updateModelView();
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
				if (i === last && !post_draw)
					glw.setTexture(null);
			}
			fx_index = (fx_index === 0 ? 1 : 0);
			other_fx_index = (fx_index === 0 ? 1 : 0);		// will be opposite to fx_index since it was just assigned
		}
		if (post_draw)
		{
			glw.switchProgram(0);
			if (inst)
				glw.setBlend(inst.srcBlend, inst.destBlend);
			else if (layer)
				glw.setBlend(layer.srcBlend, layer.destBlend);
			else
			{
				if (!this.runtime.fullscreenScalingQuality)
				{
					glw.setSize(this.runtime.width, this.runtime.height);
					halfw = this.runtime.width / 2;
					halfh = this.runtime.height / 2;
					screenleft = 0;
					screentop = 0;
					screenright = this.runtime.width;
					screenbottom = this.runtime.height;
				}
			}
			glw.setRenderingToTexture(rendertarget);
			glw.setTexture(fx_tex[other_fx_index]);
			glw.resetModelView();
			glw.translate(-halfw, -halfh);
			glw.updateModelView();
			if (inst && active_effect_types.length === 1 && !pre_draw)
				glw.quadTex(screenleft, screentop, screenright, screentop, screenright, screenbottom, screenleft, screenbottom, rcTex);
			else
				glw.quadTex(screenleft, screenbottom, screenright, screenbottom, screenright, screentop, screenleft, screentop, rcTex);
			glw.setTexture(null);
		}
	};
	Layout.prototype.getLayerBySid = function (sid_)
	{
		var i, len;
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			if (this.layers[i].sid === sid_)
				return this.layers[i];
		}
		return null;
	};
	Layout.prototype.saveToJSON = function ()
	{
		var i, len, layer, et;
		var o = {
			"sx": this.scrollX,
			"sy": this.scrollY,
			"s": this.scale,
			"a": this.angle,
			"w": this.width,
			"h": this.height,
			"fv": this.first_visit,			// added r127
			"persist": this.persist_data,
			"fx": [],
			"layers": {}
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		for (i = 0, len = this.layers.length; i < len; i++)
		{
			layer = this.layers[i];
			o["layers"][layer.sid.toString()] = layer.saveToJSON();
		}
		return o;
	};
	Layout.prototype.loadFromJSON = function (o)
	{
		var i, len, fx, p, layer;
		this.scrollX = o["sx"];
		this.scrollY = o["sy"];
		this.scale = o["s"];
		this.angle = o["a"];
		this.width = o["w"];
		this.height = o["h"];
		this.persist_data = o["persist"];
		if (typeof o["fv"] !== "undefined")
			this.first_visit = o["fv"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		var olayers = o["layers"];
		for (p in olayers)
		{
			if (olayers.hasOwnProperty(p))
			{
				layer = this.getLayerBySid(parseInt(p, 10));
				if (!layer)
					continue;		// must've gone missing
				layer.loadFromJSON(olayers[p]);
			}
		}
	};
	cr.layout = Layout;
	function Layer(layout, m)
	{
		this.layout = layout;
		this.runtime = layout.runtime;
		this.instances = [];        // running instances
		this.scale = 1.0;
		this.angle = 0;
		this.disableAngle = false;
		this.tmprect = new cr.rect(0, 0, 0, 0);
		this.tmpquad = new cr.quad();
		this.viewLeft = 0;
		this.viewRight = 0;
		this.viewTop = 0;
		this.viewBottom = 0;
		this.zindices_stale = false;
		this.name = m[0];
		this.index = m[1];
		this.sid = m[2];
		this.visible = m[3];		// initially visible
		this.background_color = m[4];
		this.transparent = m[5];
		this.parallaxX = m[6];
		this.parallaxY = m[7];
		this.opacity = m[8];
		this.forceOwnTexture = m[9];
		this.zoomRate = m[10];
		this.blend_mode = m[11];
		this.effect_fallback = m[12];
		this.compositeOp = "source-over";
		this.srcBlend = 0;
		this.destBlend = 0;
		this.render_offscreen = false;
		var im = m[13];
		var i, len;
		this.initial_instances = [];
		for (i = 0, len = im.length; i < len; i++)
		{
			var inst = im[i];
			var type = this.runtime.types_by_index[inst[1]];
;
			if (!type.default_instance)
			{
				type.default_instance = inst;
				type.default_layerindex = this.index;
			}
			this.initial_instances.push(inst);
			if (this.layout.initial_types.indexOf(type) === -1)
				this.layout.initial_types.push(type);
		}
		this.effect_types = [];
		this.active_effect_types = [];
		this.effect_params = [];
		for (i = 0, len = m[14].length; i < len; i++)
		{
			this.effect_types.push({
				id: m[14][i][0],
				name: m[14][i][1],
				shaderindex: -1,
				active: true,
				index: i
			});
			this.effect_params.push(m[14][i][2].slice(0));
		}
		this.updateActiveEffects();
		this.rcTex = new cr.rect(0, 0, 1, 1);
		this.rcTex2 = new cr.rect(0, 0, 1, 1);
	};
	Layer.prototype.updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.active)
				this.active_effect_types.push(et);
		}
	};
	Layer.prototype.getEffectByName = function (name_)
	{
		var i, len, et;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			if (et.name === name_)
				return et;
		}
		return null;
	};
	Layer.prototype.createInitialInstances = function ()
	{
		var i, k, len, inst, initial_inst, type, keep, hasPersistBehavior;
		for (i = 0, k = 0, len = this.initial_instances.length; i < len; i++)
		{
			initial_inst = this.initial_instances[i];
			type = this.runtime.types_by_index[initial_inst[1]];
;
			hasPersistBehavior = this.runtime.typeHasPersistBehavior(type);
			keep = true;
			if (!hasPersistBehavior || this.layout.first_visit)
			{
				inst = this.runtime.createInstanceFromInit(initial_inst, this, true);
;
				created_instances.push(inst);
				if (inst.type.global)
					keep = false;
			}
			if (keep)
			{
				this.initial_instances[k] = this.initial_instances[i];
				k++;
			}
		}
		this.initial_instances.length = k;
		this.runtime.ClearDeathRow();		// flushes creation row so IIDs will be correct
		if (!this.runtime.glwrap && this.effect_types.length)	// no WebGL renderer and shaders used
			this.blend_mode = this.effect_fallback;				// use fallback blend mode
		this.compositeOp = cr.effectToCompositeOp(this.blend_mode);
		if (this.runtime.gl)
			cr.setGLBlend(this, this.blend_mode, this.runtime.gl);
	};
	Layer.prototype.updateZIndices = function ()
	{
		if (!this.zindices_stale)
			return;
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
;
;
			this.instances[i].zindex = i;
		}
		this.zindices_stale = false;
	};
	Layer.prototype.getScale = function (include_aspect)
	{
		return this.getNormalScale() * (this.runtime.fullscreenScalingQuality || include_aspect ? this.runtime.aspect_scale : 1);
	};
	Layer.prototype.getNormalScale = function ()
	{
		return ((this.scale * this.layout.scale) - 1) * this.zoomRate + 1;
	};
	Layer.prototype.getAngle = function ()
	{
		if (this.disableAngle)
			return 0;
		return cr.clamp_angle(this.layout.angle + this.angle);
	};
	Layer.prototype.draw = function (ctx)
	{
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.blend_mode !== 0);
		var layer_canvas = this.runtime.canvas;
		var layer_ctx = ctx;
		var ctx_changed = false;
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_canvas)
			{
				this.runtime.layer_canvas = document.createElement("canvas");
;
				layer_canvas = this.runtime.layer_canvas;
				layer_canvas.width = this.runtime.draw_width;
				layer_canvas.height = this.runtime.draw_height;
				this.runtime.layer_ctx = layer_canvas.getContext("2d");
;
				ctx_changed = true;
			}
			layer_canvas = this.runtime.layer_canvas;
			layer_ctx = this.runtime.layer_ctx;
			if (layer_canvas.width !== this.runtime.draw_width)
			{
				layer_canvas.width = this.runtime.draw_width;
				ctx_changed = true;
			}
			if (layer_canvas.height !== this.runtime.draw_height)
			{
				layer_canvas.height = this.runtime.draw_height;
				ctx_changed = true;
			}
			if (ctx_changed)
			{
				layer_ctx["webkitImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["mozImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["msImageSmoothingEnabled"] = this.runtime.linearSampling;
				layer_ctx["imageSmoothingEnabled"] = this.runtime.linearSampling;
			}
			if (this.transparent)
				layer_ctx.clearRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.globalAlpha = 1;
		layer_ctx.globalCompositeOperation = "source-over";
		if (!this.transparent)
		{
			layer_ctx.fillStyle = "rgb(" + this.background_color[0] + "," + this.background_color[1] + "," + this.background_color[2] + ")";
			layer_ctx.fillRect(0, 0, this.runtime.draw_width, this.runtime.draw_height);
		}
		layer_ctx.save();
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, layer_ctx);
		var myscale = this.getScale();
		layer_ctx.scale(myscale, myscale);
		layer_ctx.translate(-px, -py);
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			layer_ctx.globalCompositeOperation = inst.compositeOp;
			inst.draw(layer_ctx);
		}
		layer_ctx.restore();
		if (this.render_offscreen)
		{
			ctx.globalCompositeOperation = this.compositeOp;
			ctx.globalAlpha = this.opacity;
			ctx.drawImage(layer_canvas, 0, 0);
		}
	};
	Layer.prototype.rotateViewport = function (px, py, ctx)
	{
		var myscale = this.getScale();
		this.viewLeft = px;
		this.viewTop = py;
		this.viewRight = px + (this.runtime.draw_width * (1 / myscale));
		this.viewBottom = py + (this.runtime.draw_height * (1 / myscale));
		var myAngle = this.getAngle();
		if (myAngle !== 0)
		{
			if (ctx)
			{
				ctx.translate(this.runtime.draw_width / 2, this.runtime.draw_height / 2);
				ctx.rotate(-myAngle);
				ctx.translate(this.runtime.draw_width / -2, this.runtime.draw_height / -2);
			}
			this.tmprect.set(this.viewLeft, this.viewTop, this.viewRight, this.viewBottom);
			this.tmprect.offset((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
			this.tmpquad.set_from_rotated_rect(this.tmprect, myAngle);
			this.tmpquad.bounding_box(this.tmprect);
			this.tmprect.offset((this.viewLeft + this.viewRight) / 2, (this.viewTop + this.viewBottom) / 2);
			this.viewLeft = this.tmprect.left;
			this.viewTop = this.tmprect.top;
			this.viewRight = this.tmprect.right;
			this.viewBottom = this.tmprect.bottom;
		}
	}
	Layer.prototype.drawGL = function (glw)
	{
		var windowWidth = this.runtime.draw_width;
		var windowHeight = this.runtime.draw_height;
		var shaderindex = 0;
		var etindex = 0;
		this.render_offscreen = (this.forceOwnTexture || this.opacity !== 1.0 || this.active_effect_types.length > 0 || this.blend_mode !== 0);
		if (this.render_offscreen)
		{
			if (!this.runtime.layer_tex)
			{
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			if (this.runtime.layer_tex.c2width !== this.runtime.draw_width || this.runtime.layer_tex.c2height !== this.runtime.draw_height)
			{
				glw.deleteTexture(this.runtime.layer_tex);
				this.runtime.layer_tex = glw.createEmptyTexture(this.runtime.draw_width, this.runtime.draw_height, this.runtime.linearSampling);
			}
			glw.setRenderingToTexture(this.runtime.layer_tex);
			if (this.transparent)
				glw.clear(0, 0, 0, 0);
		}
		if (!this.transparent)
		{
			glw.clear(this.background_color[0] / 255, this.background_color[1] / 255, this.background_color[2] / 255, 1);
		}
		this.disableAngle = true;
		var px = this.canvasToLayer(0, 0, true, true);
		var py = this.canvasToLayer(0, 0, false, true);
		this.disableAngle = false;
		if (this.runtime.pixel_rounding)
		{
			px = (px + 0.5) | 0;
			py = (py + 0.5) | 0;
		}
		this.rotateViewport(px, py, null);
		var myscale = this.getScale();
		glw.resetModelView();
		glw.scale(myscale, myscale);
		glw.rotateZ(-this.getAngle());
		glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
		glw.updateModelView();
		var i, len, inst, bbox;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			if (!inst.visible || inst.width === 0 || inst.height === 0)
				continue;
			inst.update_bbox();
			bbox = inst.bbox;
			if (bbox.right < this.viewLeft || bbox.bottom < this.viewTop || bbox.left > this.viewRight || bbox.top > this.viewBottom)
				continue;
			if (inst.uses_shaders)
			{
				shaderindex = inst.active_effect_types[0].shaderindex;
				etindex = inst.active_effect_types[0].index;
				if (inst.active_effect_types.length === 1 && !glw.programUsesCrossSampling(shaderindex) &&
					!glw.programExtendsBox(shaderindex) && ((!inst.angle && !inst.layer.getAngle()) || !glw.programUsesDest(shaderindex)) &&
					inst.opacity === 1 && !inst.type.plugin.must_predraw)
				{
					glw.switchProgram(shaderindex);
					glw.setBlend(inst.srcBlend, inst.destBlend);
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
					var destStartX = 0, destStartY = 0, destEndX = 0, destEndY = 0;
					if (glw.programUsesDest(shaderindex))
					{
						var bbox = inst.bbox;
						var screenleft = this.layerToCanvas(bbox.left, bbox.top, true, true);
						var screentop = this.layerToCanvas(bbox.left, bbox.top, false, true);
						var screenright = this.layerToCanvas(bbox.right, bbox.bottom, true, true);
						var screenbottom = this.layerToCanvas(bbox.right, bbox.bottom, false, true);
						destStartX = screenleft / windowWidth;
						destStartY = 1 - screentop / windowHeight;
						destEndX = screenright / windowWidth;
						destEndY = 1 - screenbottom / windowHeight;
					}
					glw.setProgramParameters(this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget(), // backTex
											 1.0 / inst.width,			// pixelWidth
											 1.0 / inst.height,			// pixelHeight
											 destStartX, destStartY,
											 destEndX, destEndY,
											 this.getScale(),
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 inst.effect_params[etindex]);
					inst.drawGL(glw);
				}
				else
				{
					this.layout.renderEffectChain(glw, this, inst, this.render_offscreen ? this.runtime.layer_tex : this.layout.getRenderTarget());
					glw.resetModelView();
					glw.scale(myscale, myscale);
					glw.rotateZ(-this.getAngle());
					glw.translate((this.viewLeft + this.viewRight) / -2, (this.viewTop + this.viewBottom) / -2);
					glw.updateModelView();
				}
			}
			else
			{
				glw.switchProgram(0);		// un-set any previously set shader
				glw.setBlend(inst.srcBlend, inst.destBlend);
				inst.drawGL(glw);
			}
		}
		if (this.render_offscreen)
		{
			shaderindex = this.active_effect_types.length ? this.active_effect_types[0].shaderindex : 0;
			etindex = this.active_effect_types.length ? this.active_effect_types[0].index : 0;
			if (this.active_effect_types.length === 0 || (this.active_effect_types.length === 1 &&
				!glw.programUsesCrossSampling(shaderindex) && this.opacity === 1))
			{
				if (this.active_effect_types.length === 1)
				{
					glw.switchProgram(shaderindex);
					glw.setProgramParameters(this.layout.getRenderTarget(),		// backTex
											 1.0 / this.runtime.draw_width,		// pixelWidth
											 1.0 / this.runtime.draw_height,	// pixelHeight
											 0.0, 0.0,							// destStart
											 1.0, 1.0,							// destEnd
											 this.getScale(),					// layerScale
											 this.getAngle(),
											 this.viewLeft, this.viewTop,
											 this.effect_params[etindex]);		// fx parameters
					if (glw.programIsAnimated(shaderindex))
						this.runtime.redraw = true;
				}
				else
					glw.switchProgram(0);
				glw.setRenderingToTexture(this.layout.getRenderTarget());
				glw.setOpacity(this.opacity);
				glw.setTexture(this.runtime.layer_tex);
				glw.setBlend(this.srcBlend, this.destBlend);
				glw.resetModelView();
				glw.updateModelView();
				var halfw = this.runtime.draw_width / 2;
				var halfh = this.runtime.draw_height / 2;
				glw.quad(-halfw, halfh, halfw, halfh, halfw, -halfh, -halfw, -halfh);
				glw.setTexture(null);
			}
			else
			{
				this.layout.renderEffectChain(glw, this, null, this.layout.getRenderTarget());
			}
		}
	};
	Layer.prototype.canvasToLayer = function (ptx, pty, getx, using_draw_area)
	{
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			ptx *= multiplier;
			pty *= multiplier;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x += ptx * invScale;
		y += pty * invScale;
		var a = this.getAngle();
		if (a !== 0)
		{
			x -= this.layout.scrollX;
			y -= this.layout.scrollY;
			var cosa = Math.cos(a);
			var sina = Math.sin(a);
			var x_temp = (x * cosa) - (y * sina);
			y = (y * cosa) + (x * sina);
			x = x_temp;
			x += this.layout.scrollX;
			y += this.layout.scrollY;
		}
		return getx ? x : y;
	};
	Layer.prototype.layerToCanvas = function (ptx, pty, getx, using_draw_area)
	{
		var a = this.getAngle();
		if (a !== 0)
		{
			ptx -= this.layout.scrollX;
			pty -= this.layout.scrollY;
			var cosa = Math.cos(-a);
			var sina = Math.sin(-a);
			var x_temp = (ptx * cosa) - (pty * sina);
			pty = (pty * cosa) + (ptx * sina);
			ptx = x_temp;
			ptx += this.layout.scrollX;
			pty += this.layout.scrollY;
		}
		var ox = this.runtime.parallax_x_origin;
		var oy = this.runtime.parallax_y_origin;
		var x = ((this.layout.scrollX - ox) * this.parallaxX) + ox;
		var y = ((this.layout.scrollY - oy) * this.parallaxY) + oy;
		var invScale = 1 / this.getScale(!using_draw_area);
		if (using_draw_area)
		{
			x -= (this.runtime.draw_width * invScale) / 2;
			y -= (this.runtime.draw_height * invScale) / 2;
		}
		else
		{
			x -= (this.runtime.width * invScale) / 2;
			y -= (this.runtime.height * invScale) / 2;
		}
		x = (ptx - x) / invScale;
		y = (pty - y) / invScale;
		var multiplier = this.runtime.devicePixelRatio;
		if (this.runtime.isRetina)
		{
			x /= multiplier;
			y /= multiplier;
		}
		return getx ? x : y;
	};
	Layer.prototype.rotatePt = function (x_, y_, getx)
	{
		if (this.getAngle() === 0)
			return getx ? x_ : y_;
		var nx = this.layerToCanvas(x_, y_, true);
		var ny = this.layerToCanvas(x_, y_, false);
		this.disableAngle = true;
		var px = this.canvasToLayer(nx, ny, true);
		var py = this.canvasToLayer(nx, ny, true);
		this.disableAngle = false;
		return getx ? px : py;
	};
	Layer.prototype.saveToJSON = function ()
	{
		var i, len, et;
		var o = {
			"s": this.scale,
			"a": this.angle,
			"vl": this.viewLeft,
			"vt": this.viewTop,
			"vr": this.viewRight,
			"vb": this.viewBottom,
			"v": this.visible,
			"bc": this.background_color,
			"t": this.transparent,
			"px": this.parallaxX,
			"py": this.parallaxY,
			"o": this.opacity,
			"zr": this.zoomRate,
			"fx": [],
			"instances": []
		};
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			et = this.effect_types[i];
			o["fx"].push({"name": et.name, "active": et.active, "params": this.effect_params[et.index] });
		}
		return o;
	};
	function sortInstanceByZIndex(a, b)
	{
		return a.zindex - b.zindex;
	};
	Layer.prototype.loadFromJSON = function (o)
	{
		var i, len, p, inst, fx;
		this.scale = o["s"];
		this.angle = o["a"];
		this.viewLeft = o["vl"];
		this.viewTop = o["vt"];
		this.viewRight = o["vr"];
		this.viewBottom = o["vb"];
		this.visible = o["v"];
		this.background_color = o["bc"];
		this.transparent = o["t"];
		this.parallaxX = o["px"];
		this.parallaxY = o["py"];
		this.opacity = o["o"];
		this.zoomRate = o["zr"];
		var ofx = o["fx"];
		for (i = 0, len = ofx.length; i < len; i++)
		{
			fx = this.getEffectByName(ofx[i]["name"]);
			if (!fx)
				continue;		// must've gone missing
			fx.active = ofx[i]["active"];
			this.effect_params[fx.index] = ofx[i]["params"];
		}
		this.updateActiveEffects();
		this.instances.sort(sortInstanceByZIndex);
		this.zindices_stale = true;
	};
	cr.layer = Layer;
}());
;
(function()
{
	var allUniqueSolModifiers = [];
	function testSolsMatch(arr1, arr2)
	{
		var i, len = arr1.length;
		switch (len) {
		case 0:
			return true;
		case 1:
			return arr1[0] === arr2[0];
		case 2:
			return arr1[0] === arr2[0] && arr1[1] === arr2[1];
		default:
			for (i = 0; i < len; i++)
			{
				if (arr1[i] !== arr2[i])
					return false;
			}
			return true;
		}
	};
	function solArraySorter(t1, t2)
	{
		return t1.index - t2.index;
	};
	function findMatchingSolModifier(arr)
	{
		var i, len, u, temp, subarr;
		if (arr.length === 2)
		{
			if (arr[0].index > arr[1].index)
			{
				temp = arr[0];
				arr[0] = arr[1];
				arr[1] = temp;
			}
		}
		else if (arr.length > 2)
			arr.sort(solArraySorter);		// so testSolsMatch compares in same order
		if (arr.length >= allUniqueSolModifiers.length)
			allUniqueSolModifiers.length = arr.length + 1;
		if (!allUniqueSolModifiers[arr.length])
			allUniqueSolModifiers[arr.length] = [];
		subarr = allUniqueSolModifiers[arr.length];
		for (i = 0, len = subarr.length; i < len; i++)
		{
			u = subarr[i];
			if (testSolsMatch(arr, u))
				return u;
		}
		subarr.push(arr);
		return arr;
	};
	function EventSheet(runtime, m)
	{
		this.runtime = runtime;
		this.triggers = {};
		this.fasttriggers = {};
        this.hasRun = false;
        this.includes = new cr.ObjectSet(); 	// all event sheets included by this sheet, at first-level indirection only
		this.deep_includes = [];				// all includes from this sheet recursively, in trigger order
		this.already_included_sheets = [];		// used while building deep_includes
		this.name = m[0];
		var em = m[1];		// events model
		this.events = [];       // triggers won't make it to this array
		var i, len;
		for (i = 0, len = em.length; i < len; i++)
			this.init_event(em[i], null, this.events);
	};
    EventSheet.prototype.toString = function ()
    {
        return this.name;
    };
	EventSheet.prototype.init_event = function (m, parent, nontriggers)
	{
		switch (m[0]) {
		case 0:	// event block
		{
			var block = new cr.eventblock(this, parent, m);
			cr.seal(block);
			if (block.orblock)
			{
				nontriggers.push(block);
				var i, len;
				for (i = 0, len = block.conditions.length; i < len; i++)
				{
					if (block.conditions[i].trigger)
						this.init_trigger(block, i);
				}
			}
			else
			{
				if (block.is_trigger())
					this.init_trigger(block, 0);
				else
					nontriggers.push(block);
			}
			break;
		}
		case 1: // variable
		{
			var v = new cr.eventvariable(this, parent, m);
			cr.seal(v);
			nontriggers.push(v);
			break;
		}
        case 2:	// include
        {
            var inc = new cr.eventinclude(this, parent, m);
			cr.seal(inc);
            nontriggers.push(inc);
			break;
        }
		default:
;
		}
	};
	EventSheet.prototype.postInit = function ()
	{
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			this.events[i].postInit(i < len - 1 && this.events[i + 1].is_else_block);
		}
	};
	EventSheet.prototype.updateDeepIncludes = function ()
	{
		this.deep_includes.length = 0;
		this.already_included_sheets.length = 0;
		this.addDeepIncludes(this);
		this.already_included_sheets.length = 0;
	};
	EventSheet.prototype.addDeepIncludes = function (root_sheet)
	{
		var i, len, inc, sheet;
		var deep_includes = root_sheet.deep_includes;
		var already_included_sheets = root_sheet.already_included_sheets;
		var arr = this.includes.valuesRef();
		for (i = 0, len = arr.length; i < len; ++i)
		{
			inc = arr[i];
			sheet = inc.include_sheet;
			if (!inc.isActive() || root_sheet === sheet || already_included_sheets.indexOf(sheet) > -1)
				continue;
			already_included_sheets.push(sheet);
			sheet.addDeepIncludes(root_sheet);
			deep_includes.push(sheet);
		}
	};
	EventSheet.prototype.run = function (from_include)
	{
		if (!this.runtime.resuming_breakpoint)
		{
			this.hasRun = true;
			if (!from_include)
				this.runtime.isRunningEvents = true;
		}
		var i, len;
		for (i = 0, len = this.events.length; i < len; i++)
		{
			var ev = this.events[i];
			ev.run();
				this.runtime.clearSol(ev.solModifiers);
				if (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length)
					this.runtime.ClearDeathRow();
		}
			if (!from_include)
				this.runtime.isRunningEvents = false;
	};
	function isPerformanceSensitiveTrigger(method)
	{
		if (cr.plugins_.Sprite && method === cr.plugins_.Sprite.prototype.cnds.OnFrameChanged)
		{
			return true;
		}
		return false;
	};
	EventSheet.prototype.init_trigger = function (trig, index)
	{
		if (!trig.orblock)
			this.runtime.triggers_to_postinit.push(trig);	// needs to be postInit'd later
		var i, len;
		var cnd = trig.conditions[index];
		var type_name;
		if (cnd.type)
			type_name = cnd.type.name;
		else
			type_name = "system";
		var fasttrigger = cnd.fasttrigger;
		var triggers = (fasttrigger ? this.fasttriggers : this.triggers);
		if (!triggers[type_name])
			triggers[type_name] = [];
		var obj_entry = triggers[type_name];
		var method = cnd.func;
		if (fasttrigger)
		{
			if (!cnd.parameters.length)				// no parameters
				return;
			var firstparam = cnd.parameters[0];
			if (firstparam.type !== 1 ||			// not a string param
				firstparam.expression.type !== 2)	// not a string literal node
			{
				return;
			}
			var fastevs;
			var firstvalue = firstparam.expression.value.toLowerCase();
			var i, len;
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					fastevs = obj_entry[i].evs;
					if (!fastevs[firstvalue])
						fastevs[firstvalue] = [[trig, index]];
					else
						fastevs[firstvalue].push([trig, index]);
					return;
				}
			}
			fastevs = {};
			fastevs[firstvalue] = [[trig, index]];
			obj_entry.push({ method: method, evs: fastevs });
		}
		else
		{
			for (i = 0, len = obj_entry.length; i < len; i++)
			{
				if (obj_entry[i].method == method)
				{
					obj_entry[i].evs.push([trig, index]);
					return;
				}
			}
			if (isPerformanceSensitiveTrigger(method))
				obj_entry.unshift({ method: method, evs: [[trig, index]]});
			else
				obj_entry.push({ method: method, evs: [[trig, index]]});
		}
	};
	cr.eventsheet = EventSheet;
	function Selection(type)
	{
		this.type = type;
		this.instances = [];        // subset of picked instances
		this.else_instances = [];	// subset of unpicked instances
		this.select_all = true;
	};
	Selection.prototype.hasObjects = function ()
	{
		if (this.select_all)
			return this.type.instances.length;
		else
			return this.instances.length;
	};
	Selection.prototype.getObjects = function ()
	{
		if (this.select_all)
			return this.type.instances;
		else
			return this.instances;
	};
	/*
	Selection.prototype.ensure_picked = function (inst, skip_siblings)
	{
		var i, len;
		var orblock = inst.runtime.getCurrentEventStack().current_event.orblock;
		if (this.select_all)
		{
			this.select_all = false;
			if (orblock)
			{
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				cr.arrayFindRemove(this.else_instances, inst);
			}
			this.instances.length = 1;
			this.instances[0] = inst;
		}
		else
		{
			if (orblock)
			{
				i = this.else_instances.indexOf(inst);
				if (i !== -1)
				{
					this.instances.push(this.else_instances[i]);
					this.else_instances.splice(i, 1);
				}
			}
			else
			{
				if (this.instances.indexOf(inst) === -1)
					this.instances.push(inst);
			}
		}
		if (!skip_siblings)
		{
		}
	};
	*/
	Selection.prototype.pick_one = function (inst)
	{
		if (!inst)
			return;
		if (inst.runtime.getCurrentEventStack().current_event.orblock)
		{
			if (this.select_all)
			{
				this.instances.length = 0;
				cr.shallowAssignArray(this.else_instances, inst.type.instances);
				this.select_all = false;
			}
			var i = this.else_instances.indexOf(inst);
			if (i !== -1)
			{
				this.instances.push(this.else_instances[i]);
				this.else_instances.splice(i, 1);
			}
		}
		else
		{
			this.select_all = false;
			this.instances.length = 1;
			this.instances[0] = inst;
		}
	};
	cr.selection = Selection;
	function EventBlock(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.solModifiersIncludingParents = [];
		this.solWriterAfterCnds = false;	// block does not change SOL after running its conditions
		this.group = false;					// is group of events
		this.initially_activated = false;	// if a group, is active on startup
		this.toplevelevent = false;			// is an event block parented only by a top-level group
		this.toplevelgroup = false;			// is parented only by other groups or is top-level (i.e. not in a subevent)
		this.has_else_block = false;		// is followed by else
;
		this.conditions = [];
		this.actions = [];
		this.subevents = [];
		this.group_name = "";
		this.group = false;
		this.initially_activated = false;
		this.group_active = false;
		this.contained_includes = null;
        if (m[1])
        {
			this.group_name = m[1][1].toLowerCase();
			this.group = true;
			this.initially_activated = !!m[1][0];
			this.contained_includes = [];
			this.group_active = this.initially_activated;
			this.runtime.allGroups.push(this);
            this.runtime.groups_by_name[this.group_name] = this;
        }
		this.orblock = m[2];
		this.sid = m[4];
		if (!this.group)
			this.runtime.blocksBySid[this.sid.toString()] = this;
		var i, len;
		var cm = m[5];
		for (i = 0, len = cm.length; i < len; i++)
		{
			var cnd = new cr.condition(this, cm[i]);
			cnd.index = i;
			cr.seal(cnd);
			this.conditions.push(cnd);
			/*
			if (cnd.is_logical())
				this.is_logical = true;
			if (cnd.type && !cnd.type.plugin.singleglobal && this.cndReferences.indexOf(cnd.type) === -1)
				this.cndReferences.push(cnd.type);
			*/
			this.addSolModifier(cnd.type);
		}
		var am = m[6];
		for (i = 0, len = am.length; i < len; i++)
		{
			var act = new cr.action(this, am[i]);
			act.index = i;
			cr.seal(act);
			this.actions.push(act);
		}
		if (m.length === 8)
		{
			var em = m[7];
			for (i = 0, len = em.length; i < len; i++)
				this.sheet.init_event(em[i], this, this.subevents);
		}
		this.is_else_block = false;
		if (this.conditions.length)
		{
			this.is_else_block = (this.conditions[0].type == null && this.conditions[0].func == cr.system_object.prototype.cnds.Else);
		}
	};
	window["_c2hh_"] = "760BFF12FB41F04D25CEC370B2CBB07BAC7B9FD9";
	EventBlock.prototype.postInit = function (hasElse/*, prevBlock_*/)
	{
		var i, len;
		var p = this.parent;
		if (this.group)
		{
			this.toplevelgroup = true;
			while (p)
			{
				if (!p.group)
				{
					this.toplevelgroup = false;
					break;
				}
				p = p.parent;
			}
		}
		this.toplevelevent = !this.is_trigger() && (!this.parent || (this.parent.group && this.parent.toplevelgroup));
		this.has_else_block = !!hasElse;
		this.solModifiersIncludingParents = this.solModifiers.slice(0);
		p = this.parent;
		while (p)
		{
			for (i = 0, len = p.solModifiers.length; i < len; i++)
				this.addParentSolModifier(p.solModifiers[i]);
			p = p.parent;
		}
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		this.solModifiersIncludingParents = findMatchingSolModifier(this.solModifiersIncludingParents);
		var i, len/*, s*/;
		for (i = 0, len = this.conditions.length; i < len; i++)
			this.conditions[i].postInit();
		for (i = 0, len = this.actions.length; i < len; i++)
			this.actions[i].postInit();
		for (i = 0, len = this.subevents.length; i < len; i++)
		{
			this.subevents[i].postInit(i < len - 1 && this.subevents[i + 1].is_else_block);
		}
		/*
		if (this.is_else_block && this.prev_block)
		{
			for (i = 0, len = this.prev_block.solModifiers.length; i < len; i++)
			{
				s = this.prev_block.solModifiers[i];
				if (this.solModifiers.indexOf(s) === -1)
					this.solModifiers.push(s);
			}
		}
		*/
	};
	EventBlock.prototype.setGroupActive = function (a)
	{
		if (this.group_active === !!a)
			return;		// same state
		this.group_active = !!a;
		var i, len;
		for (i = 0, len = this.contained_includes.length; i < len; ++i)
		{
			this.contained_includes[i].updateActive();
		}
		if (len > 0 && this.runtime.running_layout.event_sheet)
			this.runtime.running_layout.event_sheet.updateDeepIncludes();
	};
	function addSolModifierToList(type, arr)
	{
		var i, len, t;
		if (!type)
			return;
		if (arr.indexOf(type) === -1)
			arr.push(type);
		if (type.is_contained)
		{
			for (i = 0, len = type.container.length; i < len; i++)
			{
				t = type.container[i];
				if (type === t)
					continue;		// already handled
				if (arr.indexOf(t) === -1)
					arr.push(t);
			}
		}
	};
	EventBlock.prototype.addSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiers);
	};
	EventBlock.prototype.addParentSolModifier = function (type)
	{
		addSolModifierToList(type, this.solModifiersIncludingParents);
	};
	EventBlock.prototype.setSolWriterAfterCnds = function ()
	{
		this.solWriterAfterCnds = true;
		if (this.parent)
			this.parent.setSolWriterAfterCnds();
	};
	EventBlock.prototype.is_trigger = function ()
	{
		if (!this.conditions.length)    // no conditions
			return false;
		else
			return this.conditions[0].trigger;
	};
	EventBlock.prototype.run = function ()
	{
		var i, len, any_true = false, cnd_result;
		var runtime = this.runtime;
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var conditions = this.conditions;
			if (!this.is_else_block)
				evinfo.else_branch_ran = false;
		if (this.orblock)
		{
			if (conditions.length === 0)
				any_true = true;		// be sure to run if empty block
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (conditions[evinfo.cndindex].trigger)		// skip triggers when running OR block
					continue;
				cnd_result = conditions[evinfo.cndindex].run();
				if (cnd_result)			// make sure all conditions run and run if any were true
					any_true = true;
			}
			evinfo.last_event_true = any_true;
			if (any_true)
				this.run_actions_and_subevents();
		}
		else
		{
				evinfo.cndindex = 0
			for (len = conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				cnd_result = conditions[evinfo.cndindex].run();
				if (!cnd_result)    // condition failed
				{
					evinfo.last_event_true = false;
					if (this.toplevelevent && (!runtime.deathRow.isEmpty() || runtime.createRow.length))
						runtime.ClearDeathRow();
					return;		// bail out now
				}
			}
			evinfo.last_event_true = true;
			this.run_actions_and_subevents();
		}
		this.end_run(evinfo);
	};
	EventBlock.prototype.end_run = function (evinfo)
	{
		if (evinfo.last_event_true && this.has_else_block)
			evinfo.else_branch_ran = true;
		if (this.toplevelevent && (!this.runtime.deathRow.isEmpty() || this.runtime.createRow.length))
			this.runtime.ClearDeathRow();
	};
	EventBlock.prototype.run_orblocktrigger = function (index)
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		if (this.conditions[index].run())
		{
			this.run_actions_and_subevents();
			this.runtime.getCurrentEventStack().last_event_true = true;
		}
	};
	EventBlock.prototype.run_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (evinfo.actindex = 0, len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.resume_actions_and_subevents = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		var len;
		for (len = this.actions.length; evinfo.actindex < len; evinfo.actindex++)
		{
			if (this.actions[evinfo.actindex].run())
				return;
		}
		this.run_subevents();
	};
	EventBlock.prototype.run_subevents = function ()
	{
		if (!this.subevents.length)
			return;
		var i, len, subev, pushpop/*, skipped_pop = false, pop_modifiers = null*/;
		var last = this.subevents.length - 1;
			this.runtime.pushEventStack(this);
		if (this.solWriterAfterCnds)
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				subev = this.subevents[i];
					pushpop = (!this.toplevelgroup || (!this.group && i < last));
					if (pushpop)
						this.runtime.pushCopySol(subev.solModifiers);
				subev.run();
					if (pushpop)
						this.runtime.popSol(subev.solModifiers);
					else
						this.runtime.clearSol(subev.solModifiers);
			}
		}
		else
		{
			for (i = 0, len = this.subevents.length; i < len; i++)
			{
				this.subevents[i].run();
			}
		}
			this.runtime.popEventStack();
	};
	EventBlock.prototype.run_pretrigger = function ()
	{
		var evinfo = this.runtime.getCurrentEventStack();
		evinfo.current_event = this;
		var any_true = false;
		var i, len;
		for (evinfo.cndindex = 0, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
		{
;
			if (this.conditions[evinfo.cndindex].run())
				any_true = true;
			else if (!this.orblock)			// condition failed (let OR blocks run all conditions anyway)
				return false;               // bail out
		}
		return this.orblock ? any_true : true;
	};
	EventBlock.prototype.retrigger = function ()
	{
		this.runtime.execcount++;
		var prevcndindex = this.runtime.getCurrentEventStack().cndindex;
		var len;
		var evinfo = this.runtime.pushEventStack(this);
		if (!this.orblock)
		{
			for (evinfo.cndindex = prevcndindex + 1, len = this.conditions.length; evinfo.cndindex < len; evinfo.cndindex++)
			{
				if (!this.conditions[evinfo.cndindex].run())    // condition failed
				{
					this.runtime.popEventStack();               // moving up level of recursion
					return false;                               // bail out
				}
			}
		}
		this.run_actions_and_subevents();
		this.runtime.popEventStack();
		return true;		// ran an iteration
	};
	EventBlock.prototype.isFirstConditionOfType = function (cnd)
	{
		var cndindex = cnd.index;
		if (cndindex === 0)
			return true;
		--cndindex;
		for ( ; cndindex >= 0; --cndindex)
		{
			if (this.conditions[cndindex].type === cnd.type)
				return false;
		}
		return true;
	};
	cr.eventblock = EventBlock;
	function Condition(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		this.trigger = (m[3] > 0);
		this.fasttrigger = (m[3] === 2);
		this.looping = m[4];
		this.inverted = m[5];
		this.isstatic = m[6];
		this.sid = m[7];
		this.runtime.cndsBySid[this.sid.toString()] = this;
		if (m[0] === -1)		// system object
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			if (this.isstatic)
				this.run = this.run_static;
			else
				this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
			if (this.block.parent)
				this.block.parent.setSolWriterAfterCnds();
		}
		if (this.fasttrigger)
			this.run = this.run_true;
		if (m.length === 10)
		{
			var i, len;
			var em = m[9];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Condition.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	/*
	Condition.prototype.is_logical = function ()
	{
		return !this.type || this.type.plugin.singleglobal;
	};
	*/
	Condition.prototype.run_true = function ()
	{
		return true;
	};
	Condition.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return cr.xor(this.func.apply(this.runtime.system, this.results), this.inverted);
	};
	Condition.prototype.run_static = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		var ret = this.func.apply(this.behaviortype ? this.behaviortype : this.type, this.results);
		this.type.applySolToContainer();
		return ret;
	};
	Condition.prototype.run_object = function ()
	{
		var i, j, k, leni, lenj, p, ret, met, inst, s, sol2;
		var type = this.type;
		var sol = type.getCurrentSol();
		var is_orblock = this.block.orblock && !this.trigger;		// triggers in OR blocks need to work normally
		var offset = 0;
		var is_contained = type.is_contained;
		var is_family = type.is_family;
		var family_index = type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var inverted = this.inverted;
		var func = this.func;
		var arr, container;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		if (sol.select_all) {
			sol.instances.length = 0;       // clear contents
			sol.else_instances.length = 0;
			arr = type.instances;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				met = cr.xor(ret, inverted);
				if (met)
					sol.instances.push(inst);
				else if (is_orblock)					// in OR blocks, keep the instances not meeting the condition for subsequent testing
					sol.else_instances.push(inst);
			}
			if (type.finish)
				type.finish(true);
			sol.select_all = false;
			type.applySolToContainer();
			return sol.hasObjects();
		}
		else {
			k = 0;
			var using_else_instances = (is_orblock && !this.block.isFirstConditionOfType(this));
			arr = (using_else_instances ? sol.else_instances : sol.instances);
			var any_true = false;
			for (i = 0, leni = arr.length; i < leni; ++i)
			{
				inst = arr[i];
;
				if (params_vary)
				{
					for (j = 0, lenj = parameters.length; j < lenj; ++j)
					{
						p = parameters[j];
						if (p.variesPerInstance)
							results[j] = p.get(i);        // default SOL index is current object
					}
				}
				if (is_beh)
				{
					offset = 0;
					if (is_family)
					{
						offset = inst.type.family_beh_map[family_index];
					}
					ret = func.apply(inst.behavior_insts[beh_index + offset], results);
				}
				else
					ret = func.apply(inst, results);
				if (cr.xor(ret, inverted))
				{
					any_true = true;
					if (using_else_instances)
					{
						sol.instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances.push(s);
							}
						}
					}
					else
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().instances[k] = s;
							}
						}
						k++;
					}
				}
				else
				{
					if (using_else_instances)
					{
						arr[k] = inst;
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances[k] = s;
							}
						}
						k++;
					}
					else if (is_orblock)
					{
						sol.else_instances.push(inst);
						if (is_contained)
						{
							for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
							{
								s = inst.siblings[j];
								s.type.getCurrentSol().else_instances.push(s);
							}
						}
					}
				}
			}
			arr.length = k;
			if (is_contained)
			{
				container = type.container;
				for (i = 0, leni = container.length; i < leni; i++)
				{
					sol2 = container[i].getCurrentSol();
					if (using_else_instances)
						sol2.else_instances.length = k;
					else
						sol2.instances.length = k;
				}
			}
			var pick_in_finish = any_true;		// don't pick in finish() if we're only doing the logic test below
			if (using_else_instances && !any_true)
			{
				for (i = 0, leni = sol.instances.length; i < leni; i++)
				{
					inst = sol.instances[i];
					if (params_vary)
					{
						for (j = 0, lenj = parameters.length; j < lenj; j++)
						{
							p = parameters[j];
							if (p.variesPerInstance)
								results[j] = p.get(i);
						}
					}
					if (is_beh)
						ret = func.apply(inst.behavior_insts[beh_index], results);
					else
						ret = func.apply(inst, results);
					if (cr.xor(ret, inverted))
					{
						any_true = true;
						break;		// got our flag, don't need to test any more
					}
				}
			}
			if (type.finish)
				type.finish(pick_in_finish || is_orblock);
			return is_orblock ? any_true : sol.hasObjects();
		}
	};
	cr.condition = Condition;
	function Action(block, m)
	{
		this.block = block;
		this.sheet = block.sheet;
		this.runtime = block.runtime;
		this.parameters = [];
		this.results = [];
		this.extra = {};		// for plugins to stow away some custom info
		this.index = -1;
		this.anyParamVariesPerInstance = false;
		this.func = m[1];
;
		if (m[0] === -1)	// system
		{
			this.type = null;
			this.run = this.run_system;
			this.behaviortype = null;
			this.beh_index = -1;
		}
		else
		{
			this.type = this.runtime.types_by_index[m[0]];
;
			this.run = this.run_object;
			if (m[2])
			{
				this.behaviortype = this.type.getBehaviorByName(m[2]);
;
				this.beh_index = this.type.getBehaviorIndexByName(m[2]);
;
			}
			else
			{
				this.behaviortype = null;
				this.beh_index = -1;
			}
		}
		this.sid = m[3];
		this.runtime.actsBySid[this.sid.toString()] = this;
		if (m.length === 6)
		{
			var i, len;
			var em = m[5];
			for (i = 0, len = em.length; i < len; i++)
			{
				var param = new cr.parameter(this, em[i]);
				cr.seal(param);
				this.parameters.push(param);
			}
			this.results.length = em.length;
		}
	};
	Action.prototype.postInit = function ()
	{
		var i, len, p;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			p = this.parameters[i];
			p.postInit();
			if (p.variesPerInstance)
				this.anyParamVariesPerInstance = true;
		}
	};
	Action.prototype.run_system = function ()
	{
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
			this.results[i] = this.parameters[i].get();
		return this.func.apply(this.runtime.system, this.results);
	};
	Action.prototype.run_object = function ()
	{
		var instances = this.type.getCurrentSol().getObjects();
		var is_family = this.type.is_family;
		var family_index = this.type.family_index;
		var beh_index = this.beh_index;
		var is_beh = (beh_index > -1);
		var params_vary = this.anyParamVariesPerInstance;
		var parameters = this.parameters;
		var results = this.results;
		var func = this.func;
		var i, j, leni, lenj, p, inst, offset;
		if (params_vary)
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
			{
				p = parameters[j];
				if (!p.variesPerInstance)
					results[j] = p.get(0);
			}
		}
		else
		{
			for (j = 0, lenj = parameters.length; j < lenj; ++j)
				results[j] = parameters[j].get(0);
		}
		for (i = 0, leni = instances.length; i < leni; ++i)
		{
			inst = instances[i];
			if (params_vary)
			{
				for (j = 0, lenj = parameters.length; j < lenj; ++j)
				{
					p = parameters[j];
					if (p.variesPerInstance)
						results[j] = p.get(i);    // pass i to use as default SOL index
				}
			}
			if (is_beh)
			{
				offset = 0;
				if (is_family)
				{
					offset = inst.type.family_beh_map[family_index];
				}
				func.apply(inst.behavior_insts[beh_index + offset], results);
			}
			else
				func.apply(inst, results);
		}
		return false;
	};
	cr.action = Action;
	var tempValues = [];
	var tempValuesPtr = -1;
	function Parameter(owner, m)
	{
		this.owner = owner;
		this.block = owner.block;
		this.sheet = owner.sheet;
		this.runtime = owner.runtime;
		this.type = m[0];
		this.expression = null;
		this.solindex = 0;
		this.get = null;
		this.combosel = 0;
		this.layout = null;
		this.key = 0;
		this.object = null;
		this.index = 0;
		this.varname = null;
		this.eventvar = null;
		this.fileinfo = null;
		this.subparams = null;
		this.variadicret = null;
		this.subparams = null;
		this.variadicret = null;
		this.variesPerInstance = false;
		var i, len, param;
		switch (m[0])
		{
			case 0:		// number
			case 7:		// any
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp;
				break;
			case 1:		// string
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_exp_str;
				break;
			case 5:		// layer
				this.expression = new cr.expNode(this, m[1]);
				this.solindex = 0;
				this.get = this.get_layer;
				break;
			case 3:		// combo
			case 8:		// cmp
				this.combosel = m[1];
				this.get = this.get_combosel;
				break;
			case 6:		// layout
				this.layout = this.runtime.layouts[m[1]];
;
				this.get = this.get_layout;
				break;
			case 9:		// keyb
				this.key = m[1];
				this.get = this.get_key;
				break;
			case 4:		// object
				this.object = this.runtime.types_by_index[m[1]];
;
				this.get = this.get_object;
				this.block.addSolModifier(this.object);
				if (this.owner instanceof cr.action)
					this.block.setSolWriterAfterCnds();
				else if (this.block.parent)
					this.block.parent.setSolWriterAfterCnds();
				break;
			case 10:	// instvar
				this.index = m[1];
				if (owner.type.is_family)
				{
					this.get = this.get_familyvar;
					this.variesPerInstance = true;
				}
				else
					this.get = this.get_instvar;
				break;
			case 11:	// eventvar
				this.varname = m[1];
				this.eventvar = null;
				this.get = this.get_eventvar;
				break;
			case 2:		// audiofile	["name", ismusic]
			case 12:	// fileinfo		"name"
				this.fileinfo = m[1];
				this.get = this.get_audiofile;
				break;
			case 13:	// variadic
				this.get = this.get_variadic;
				this.subparams = [];
				this.variadicret = [];
				for (i = 1, len = m.length; i < len; i++)
				{
					param = new cr.parameter(this.owner, m[i]);
					cr.seal(param);
					this.subparams.push(param);
					this.variadicret.push(0);
				}
				break;
			default:
;
		}
	};
	Parameter.prototype.postInit = function ()
	{
		var i, len;
		if (this.type === 11)		// eventvar
		{
			this.eventvar = this.runtime.getEventVariableByName(this.varname, this.block.parent);
;
		}
		else if (this.type === 13)	// variadic, postInit all sub-params
		{
			for (i = 0, len = this.subparams.length; i < len; i++)
				this.subparams[i].postInit();
		}
		if (this.expression)
			this.expression.postInit();
	};
	Parameter.prototype.maybeVaryForType = function (t)
	{
		if (this.variesPerInstance)
			return;				// already varies per instance, no need to check again
		if (!t)
			return;				// never vary for system type
		if (!t.plugin.singleglobal)
		{
			this.variesPerInstance = true;
			return;
		}
	};
	Parameter.prototype.setVaries = function ()
	{
		this.variesPerInstance = true;
	};
	Parameter.prototype.pushTempValue = function ()
	{
		tempValuesPtr++;
		if (tempValues.length === tempValuesPtr)
			tempValues.push(new cr.expvalue());
		return tempValues[tempValuesPtr];
	};
	Parameter.prototype.popTempValue = function ()
	{
		tempValuesPtr--;
	};
	Parameter.prototype.get_exp = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		return temp.data;      			// return actual JS value, not expvalue
	};
	Parameter.prototype.get_exp_str = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (cr.is_string(temp.data))
			return temp.data;
		else
			return "";
	};
	Parameter.prototype.get_object = function ()
	{
		return this.object;
	};
	Parameter.prototype.get_combosel = function ()
	{
		return this.combosel;
	};
	Parameter.prototype.get_layer = function (solindex)
	{
		this.solindex = solindex || 0;   // default SOL index to use
		var temp = this.pushTempValue();
		this.expression.get(temp);
		this.popTempValue();
		if (temp.is_number())
			return this.runtime.getLayerByNumber(temp.data);
		else
			return this.runtime.getLayerByName(temp.data);
	}
	Parameter.prototype.get_layout = function ()
	{
		return this.layout;
	};
	Parameter.prototype.get_key = function ()
	{
		return this.key;
	};
	Parameter.prototype.get_instvar = function ()
	{
		return this.index;
	};
	Parameter.prototype.get_familyvar = function (solindex_)
	{
		var solindex = solindex_ || 0;
		var familytype = this.owner.type;
		var realtype = null;
		var sol = familytype.getCurrentSol();
		var objs = sol.getObjects();
		if (objs.length)
			realtype = objs[solindex % objs.length].type;
		else if (sol.else_instances.length)
			realtype = sol.else_instances[solindex % sol.else_instances.length].type;
		else if (familytype.instances.length)
			realtype = familytype.instances[solindex % familytype.instances.length].type;
		else
			return 0;
		return this.index + realtype.family_var_map[familytype.family_index];
	};
	Parameter.prototype.get_eventvar = function ()
	{
		return this.eventvar;
	};
	Parameter.prototype.get_audiofile = function ()
	{
		return this.fileinfo;
	};
	Parameter.prototype.get_variadic = function ()
	{
		var i, len;
		for (i = 0, len = this.subparams.length; i < len; i++)
		{
			this.variadicret[i] = this.subparams[i].get();
		}
		return this.variadicret;
	};
	cr.parameter = Parameter;
	function EventVariable(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.name = m[1];
		this.vartype = m[2];
		this.initial = m[3];
		this.is_static = !!m[4];
		this.is_constant = !!m[5];
		this.sid = m[6];
		this.runtime.varsBySid[this.sid.toString()] = this;
		this.data = this.initial;	// note: also stored in event stack frame for local nonstatic nonconst vars
		if (this.parent)			// local var
		{
			if (this.is_static || this.is_constant)
				this.localIndex = -1;
			else
				this.localIndex = this.runtime.stackLocalCount++;
			this.runtime.all_local_vars.push(this);
		}
		else						// global var
		{
			this.localIndex = -1;
			this.runtime.all_global_vars.push(this);
		}
	};
	EventVariable.prototype.postInit = function ()
	{
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
	};
	EventVariable.prototype.setValue = function (x)
	{
;
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs)
			this.data = x;
		else	// local nonstatic variable: use event stack to keep value at this level of recursion
		{
			if (this.localIndex >= lvs.length)
				lvs.length = this.localIndex + 1;
			lvs[this.localIndex] = x;
		}
	};
	EventVariable.prototype.getValue = function ()
	{
		var lvs = this.runtime.getCurrentLocalVarStack();
		if (!this.parent || this.is_static || !lvs || this.is_constant)
			return this.data;
		else	// local nonstatic variable
		{
			if (this.localIndex >= lvs.length)
			{
;
				return this.initial;
			}
			if (typeof lvs[this.localIndex] === "undefined")
			{
;
				return this.initial;
			}
			return lvs[this.localIndex];
		}
	};
	EventVariable.prototype.run = function ()
	{
			if (this.parent && !this.is_static && !this.is_constant)
				this.setValue(this.initial);
	};
	cr.eventvariable = EventVariable;
	function EventInclude(sheet, parent, m)
	{
		this.sheet = sheet;
		this.parent = parent;
		this.runtime = sheet.runtime;
		this.solModifiers = [];
		this.include_sheet = null;		// determined in postInit
		this.include_sheet_name = m[1];
		this.active = true;
	};
	EventInclude.prototype.toString = function ()
	{
		return "include:" + this.include_sheet.toString();
	};
	EventInclude.prototype.postInit = function ()
	{
        this.include_sheet = this.runtime.eventsheets[this.include_sheet_name];
;
;
        this.sheet.includes.add(this);
		this.solModifiers = findMatchingSolModifier(this.solModifiers);
		var p = this.parent;
		while (p)
		{
			if (p.group)
				p.contained_includes.push(this);
			p = p.parent;
		}
		this.updateActive();
	};
	EventInclude.prototype.run = function ()
	{
			if (this.parent)
				this.runtime.pushCleanSol(this.runtime.types_by_index);
        if (!this.include_sheet.hasRun)
            this.include_sheet.run(true);			// from include
			if (this.parent)
				this.runtime.popSol(this.runtime.types_by_index);
	};
	EventInclude.prototype.updateActive = function ()
	{
		var p = this.parent;
		while (p)
		{
			if (p.group && !p.group_active)
			{
				this.active = false;
				return;
			}
			p = p.parent;
		}
		this.active = true;
	};
	EventInclude.prototype.isActive = function ()
	{
		return this.active;
	};
	cr.eventinclude = EventInclude;
	function EventStackFrame()
	{
		this.temp_parents_arr = [];
		this.reset(null);
		cr.seal(this);
	};
	EventStackFrame.prototype.reset = function (cur_event)
	{
		this.current_event = cur_event;
		this.cndindex = 0;
		this.actindex = 0;
		this.temp_parents_arr.length = 0;
		this.last_event_true = false;
		this.else_branch_ran = false;
		this.any_true_state = false;
	};
	EventStackFrame.prototype.isModifierAfterCnds = function ()
	{
		if (this.current_event.solWriterAfterCnds)
			return true;
		if (this.cndindex < this.current_event.conditions.length - 1)
			return !!this.current_event.solModifiers.length;
		return false;
	};
	cr.eventStackFrame = EventStackFrame;
}());
(function()
{
	function ExpNode(owner_, m)
	{
		this.owner = owner_;
		this.runtime = owner_.runtime;
		this.type = m[0];
;
		this.get = [this.eval_int,
					this.eval_float,
					this.eval_string,
					this.eval_unaryminus,
					this.eval_add,
					this.eval_subtract,
					this.eval_multiply,
					this.eval_divide,
					this.eval_mod,
					this.eval_power,
					this.eval_and,
					this.eval_or,
					this.eval_equal,
					this.eval_notequal,
					this.eval_less,
					this.eval_lessequal,
					this.eval_greater,
					this.eval_greaterequal,
					this.eval_conditional,
					this.eval_system_exp,
					this.eval_object_behavior_exp,
					this.eval_instvar_exp,
					this.eval_object_behavior_exp,
					this.eval_eventvar_exp][this.type];
		var paramsModel = null;
		this.value = null;
		this.first = null;
		this.second = null;
		this.third = null;
		this.func = null;
		this.results = null;
		this.parameters = null;
		this.object_type = null;
		this.beh_index = -1;
		this.instance_expr = null;
		this.varindex = -1;
		this.behavior_type = null;
		this.varname = null;
		this.eventvar = null;
		this.return_string = false;
		switch (this.type) {
		case 0:		// int
		case 1:		// float
		case 2:		// string
			this.value = m[1];
			break;
		case 3:		// unaryminus
			this.first = new cr.expNode(owner_, m[1]);
			break;
		case 18:	// conditional
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
			this.third = new cr.expNode(owner_, m[3]);
			break;
		case 19:	// system_exp
			this.func = m[1];
;
			if (this.func === cr.system_object.prototype.exps.random
			 || this.func === cr.system_object.prototype.exps.choose)
			{
				this.owner.setVaries();
			}
			this.results = [];
			this.parameters = [];
			if (m.length === 3)
			{
				paramsModel = m[2];
				this.results.length = paramsModel.length + 1;	// must also fit 'ret'
			}
			else
				this.results.length = 1;      // to fit 'ret'
			break;
		case 20:	// object_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.beh_index = -1;
			this.func = m[2];
			this.return_string = m[3];
			if (cr.plugins_.Function && this.func === cr.plugins_.Function.prototype.exps.Call)
			{
				this.owner.setVaries();
			}
			if (m[4])
				this.instance_expr = new cr.expNode(owner_, m[4]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 6)
			{
				paramsModel = m[5];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 21:		// instvar_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.return_string = m[2];
			if (m[3])
				this.instance_expr = new cr.expNode(owner_, m[3]);
			else
				this.instance_expr = null;
			this.varindex = m[4];
			break;
		case 22:		// behavior_exp
			this.object_type = this.runtime.types_by_index[m[1]];
;
			this.behavior_type = this.object_type.getBehaviorByName(m[2]);
;
			this.beh_index = this.object_type.getBehaviorIndexByName(m[2]);
			this.func = m[3];
			this.return_string = m[4];
			if (m[5])
				this.instance_expr = new cr.expNode(owner_, m[5]);
			else
				this.instance_expr = null;
			this.results = [];
			this.parameters = [];
			if (m.length === 7)
			{
				paramsModel = m[6];
				this.results.length = paramsModel.length + 1;
			}
			else
				this.results.length = 1;	// to fit 'ret'
			break;
		case 23:		// eventvar_exp
			this.varname = m[1];
			this.eventvar = null;	// assigned in postInit
			break;
		}
		this.owner.maybeVaryForType(this.object_type);
		if (this.type >= 4 && this.type <= 17)
		{
			this.first = new cr.expNode(owner_, m[1]);
			this.second = new cr.expNode(owner_, m[2]);
		}
		if (paramsModel)
		{
			var i, len;
			for (i = 0, len = paramsModel.length; i < len; i++)
				this.parameters.push(new cr.expNode(owner_, paramsModel[i]));
		}
		cr.seal(this);
	};
	ExpNode.prototype.postInit = function ()
	{
		if (this.type === 23)	// eventvar_exp
		{
			this.eventvar = this.owner.runtime.getEventVariableByName(this.varname, this.owner.block.parent);
;
		}
		if (this.first)
			this.first.postInit();
		if (this.second)
			this.second.postInit();
		if (this.third)
			this.third.postInit();
		if (this.instance_expr)
			this.instance_expr.postInit();
		if (this.parameters)
		{
			var i, len;
			for (i = 0, len = this.parameters.length; i < len; i++)
				this.parameters[i].postInit();
		}
	};
	ExpNode.prototype.eval_system_exp = function (ret)
	{
		this.results[0] = ret;
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++)
		{
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		this.owner.popTempValue();
		this.func.apply(this.runtime.system, this.results);
	};
	ExpNode.prototype.eval_object_behavior_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		this.results[0] = ret;
		ret.object_class = this.object_type;		// so expression can access family type if need be
		var temp = this.owner.pushTempValue();
		var i, len;
		for (i = 0, len = this.parameters.length; i < len; i++) {
			this.parameters[i].get(temp);
			this.results[i + 1] = temp.data;   // passing actual javascript value as argument instead of expvalue
		}
		var index = this.owner.solindex;
		if (this.instance_expr) {
			this.instance_expr.get(temp);
			if (temp.is_number()) {
				index = temp.data;
				instances = this.object_type.instances;    // pick from all instances, not SOL
			}
		}
		this.owner.popTempValue();
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var returned_val;
		var inst = instances[index];
		if (this.beh_index > -1)
		{
			var offset = 0;
			if (this.object_type.is_family)
			{
				offset = inst.type.family_beh_map[this.object_type.family_index];
			}
			returned_val = this.func.apply(inst.behavior_insts[this.beh_index + offset], this.results);
		}
		else
			returned_val = this.func.apply(inst, this.results);
;
	};
	ExpNode.prototype.eval_instvar_exp = function (ret)
	{
		var sol = this.object_type.getCurrentSol();
		var instances = sol.getObjects();
		if (!instances.length)
		{
			if (sol.else_instances.length)
				instances = sol.else_instances;
			else
			{
				if (this.return_string)
					ret.set_string("");
				else
					ret.set_int(0);
				return;
			}
		}
		var index = this.owner.solindex;
		if (this.instance_expr)
		{
			var temp = this.owner.pushTempValue();
			this.instance_expr.get(temp);
			if (temp.is_number())
			{
				index = temp.data;
				var type_instances = this.object_type.instances;
				index %= type_instances.length;     // wraparound
				if (index < 0)                      // offset
					index += type_instances.length;
				var to_ret = type_instances[index].instance_vars[this.varindex];
				if (cr.is_string(to_ret))
					ret.set_string(to_ret);
				else
					ret.set_float(to_ret);
				this.owner.popTempValue();
				return;         // done
			}
			this.owner.popTempValue();
		}
		index %= instances.length;      // wraparound
		if (index < 0)
			index += instances.length;
		var inst = instances[index];
		var offset = 0;
		if (this.object_type.is_family)
		{
			offset = inst.type.family_var_map[this.object_type.family_index];
		}
		var to_ret = inst.instance_vars[this.varindex + offset];
		if (cr.is_string(to_ret))
			ret.set_string(to_ret);
		else
			ret.set_float(to_ret);
	};
	ExpNode.prototype.eval_int = function (ret)
	{
		ret.type = cr.exptype.Integer;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_float = function (ret)
	{
		ret.type = cr.exptype.Float;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_string = function (ret)
	{
		ret.type = cr.exptype.String;
		ret.data = this.value;
	};
	ExpNode.prototype.eval_unaryminus = function (ret)
	{
		this.first.get(ret);                // retrieve operand
		if (ret.is_number())
			ret.data = -ret.data;
	};
	ExpNode.prototype.eval_add = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data += temp.data;          // both operands numbers: add
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_subtract = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data -= temp.data;          // both operands numbers: subtract
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_multiply = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data *= temp.data;          // both operands numbers: multiply
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_divide = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data /= temp.data;          // both operands numbers: divide
			ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_mod = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data %= temp.data;          // both operands numbers: modulo
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_power = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			ret.data = Math.pow(ret.data, temp.data);   // both operands numbers: raise to power
			if (temp.is_float())
				ret.make_float();
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_and = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number())
		{
			if (temp.is_string())
			{
				ret.set_string(ret.data.toString() + temp.data);
			}
			else
			{
				if (ret.data && temp.data)
					ret.set_int(1);
				else
					ret.set_int(0);
			}
		}
		else if (ret.is_string())
		{
			if (temp.is_string())
				ret.data += temp.data;
			else
			{
				ret.data += (Math.round(temp.data * 1e10) / 1e10).toString();
			}
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_or = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		if (ret.is_number() && temp.is_number())
		{
			if (ret.data || temp.data)
				ret.set_int(1);
			else
				ret.set_int(0);
		}
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_conditional = function (ret)
	{
		this.first.get(ret);                // condition operand
		if (ret.data)                       // is true
			this.second.get(ret);           // evaluate second operand to ret
		else
			this.third.get(ret);            // evaluate third operand to ret
	};
	ExpNode.prototype.eval_equal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data === temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_notequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data !== temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_less = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data < temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_lessequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data <= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greater = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data > temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_greaterequal = function (ret)
	{
		this.first.get(ret);                // left operand
		var temp = this.owner.pushTempValue();
		this.second.get(temp);			// right operand
		ret.set_int(ret.data >= temp.data ? 1 : 0);
		this.owner.popTempValue();
	};
	ExpNode.prototype.eval_eventvar_exp = function (ret)
	{
		var val = this.eventvar.getValue();
		if (cr.is_number(val))
			ret.set_float(val);
		else
			ret.set_string(val);
	};
	cr.expNode = ExpNode;
	function ExpValue(type, data)
	{
		this.type = type || cr.exptype.Integer;
		this.data = data || 0;
		this.object_class = null;
;
;
;
		if (this.type == cr.exptype.Integer)
			this.data = Math.floor(this.data);
		cr.seal(this);
	};
	ExpValue.prototype.is_int = function ()
	{
		return this.type === cr.exptype.Integer;
	};
	ExpValue.prototype.is_float = function ()
	{
		return this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_number = function ()
	{
		return this.type === cr.exptype.Integer || this.type === cr.exptype.Float;
	};
	ExpValue.prototype.is_string = function ()
	{
		return this.type === cr.exptype.String;
	};
	ExpValue.prototype.make_int = function ()
	{
		if (!this.is_int())
		{
			if (this.is_float())
				this.data = Math.floor(this.data);      // truncate float
			else if (this.is_string())
				this.data = parseInt(this.data, 10);
			this.type = cr.exptype.Integer;
		}
	};
	ExpValue.prototype.make_float = function ()
	{
		if (!this.is_float())
		{
			if (this.is_string())
				this.data = parseFloat(this.data);
			this.type = cr.exptype.Float;
		}
	};
	ExpValue.prototype.make_string = function ()
	{
		if (!this.is_string())
		{
			this.data = this.data.toString();
			this.type = cr.exptype.String;
		}
	};
	ExpValue.prototype.set_int = function (val)
	{
;
		this.type = cr.exptype.Integer;
		this.data = Math.floor(val);
	};
	ExpValue.prototype.set_float = function (val)
	{
;
		this.type = cr.exptype.Float;
		this.data = val;
	};
	ExpValue.prototype.set_string = function (val)
	{
;
		this.type = cr.exptype.String;
		this.data = val;
	};
	ExpValue.prototype.set_any = function (val)
	{
		if (cr.is_number(val))
		{
			this.type = cr.exptype.Float;
			this.data = val;
		}
		else if (cr.is_string(val))
		{
			this.type = cr.exptype.String;
			this.data = val.toString();
		}
		else
		{
			this.type = cr.exptype.Integer;
			this.data = 0;
		}
	};
	cr.expvalue = ExpValue;
	cr.exptype = {
		Integer: 0,     // emulated; no native integer support in javascript
		Float: 1,
		String: 2
	};
}());
;
cr.system_object = function (runtime)
{
    this.runtime = runtime;
	this.waits = [];
};
cr.system_object.prototype.saveToJSON = function ()
{
	var o = {};
	var i, len, j, lenj, p, w, t, sobj;
	o["waits"] = [];
	var owaits = o["waits"];
	var waitobj;
	for (i = 0, len = this.waits.length; i < len; i++)
	{
		w = this.waits[i];
		waitobj = {
			"t": w.time,
			"ev": w.ev.sid,
			"sm": [],
			"sols": {}
		};
		if (w.ev.actions[w.actindex])
			waitobj["act"] = w.ev.actions[w.actindex].sid;
		for (j = 0, lenj = w.solModifiers.length; j < lenj; j++)
			waitobj["sm"].push(w.solModifiers[j].sid);
		for (p in w.sols)
		{
			if (w.sols.hasOwnProperty(p))
			{
				t = this.runtime.types_by_index[parseInt(p, 10)];
;
				sobj = {
					"sa": w.sols[p].sa,
					"insts": []
				};
				for (j = 0, lenj = w.sols[p].insts.length; j < lenj; j++)
					sobj["insts"].push(w.sols[p].insts[j].uid);
				waitobj["sols"][t.sid.toString()] = sobj;
			}
		}
		owaits.push(waitobj);
	}
	return o;
};
cr.system_object.prototype.loadFromJSON = function (o)
{
	var owaits = o["waits"];
	var i, len, j, lenj, p, w, addWait, e, aindex, t, savedsol, nusol, inst;
	this.waits.length = 0;
	for (i = 0, len = owaits.length; i < len; i++)
	{
		w = owaits[i];
		e = this.runtime.blocksBySid[w["ev"].toString()];
		if (!e)
			continue;	// event must've gone missing
		aindex = -1;
		for (j = 0, lenj = e.actions.length; j < lenj; j++)
		{
			if (e.actions[j].sid === w["act"])
			{
				aindex = j;
				break;
			}
		}
		if (aindex === -1)
			continue;	// action must've gone missing
		addWait = {};
		addWait.sols = {};
		addWait.solModifiers = [];
		addWait.deleteme = false;
		addWait.time = w["t"];
		addWait.ev = e;
		addWait.actindex = aindex;
		for (j = 0, lenj = w["sm"].length; j < lenj; j++)
		{
			t = this.runtime.getObjectTypeBySid(w["sm"][j]);
			if (t)
				addWait.solModifiers.push(t);
		}
		for (p in w["sols"])
		{
			if (w["sols"].hasOwnProperty(p))
			{
				t = this.runtime.getObjectTypeBySid(parseInt(p, 10));
				if (!t)
					continue;		// type must've been deleted
				savedsol = w["sols"][p];
				nusol = {
					sa: savedsol["sa"],
					insts: []
				};
				for (j = 0, lenj = savedsol["insts"].length; j < lenj; j++)
				{
					inst = this.runtime.getObjectByUID(savedsol["insts"][j]);
					if (inst)
						nusol.insts.push(inst);
				}
				addWait.sols[t.index.toString()] = nusol;
			}
		}
		this.waits.push(addWait);
	}
};
(function ()
{
	var sysProto = cr.system_object.prototype;
	function SysCnds() {};
    SysCnds.prototype.EveryTick = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutStart = function()
    {
        return true;
    };
    SysCnds.prototype.OnLayoutEnd = function()
    {
        return true;
    };
    SysCnds.prototype.Compare = function(x, cmp, y)
    {
        return cr.do_cmp(x, cmp, y);
    };
    SysCnds.prototype.CompareTime = function (cmp, t)
    {
        var elapsed = this.runtime.kahanTime.sum;
        if (cmp === 0)
        {
            var cnd = this.runtime.getCurrentCondition();
            if (!cnd.extra.CompareTime_executed)
            {
                if (elapsed >= t)
                {
                    cnd.extra.CompareTime_executed = true;
                    return true;
                }
            }
            return false;
        }
        return cr.do_cmp(elapsed, cmp, t);
    };
    SysCnds.prototype.LayerVisible = function (layer)
    {
        if (!layer)
            return false;
        else
            return layer.visible;
    };
	SysCnds.prototype.LayerCmpOpacity = function (layer, cmp, opacity_)
	{
		if (!layer)
			return false;
		return cr.do_cmp(layer.opacity * 100, cmp, opacity_);
	};
    SysCnds.prototype.Repeat = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; i < count && !current_loop.stopped; i++)
			{
				current_loop.index = i;
				current_event.retrigger();
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	SysCnds.prototype.While = function (count)
    {
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i;
		if (solModifierAfterCnds)
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				current_loop.index = i;
				if (!current_event.retrigger())		// one of the other conditions returned false
					current_loop.stopped = true;	// break
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			for (i = 0; !current_loop.stopped; i++)
			{
				current_loop.index = i;
				if (!current_event.retrigger())
					current_loop.stopped = true;
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
    SysCnds.prototype.For = function (name, start, end)
    {
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack(name);
        var i;
		if (end < start)
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i >= end && !current_loop.stopped; --i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
		else
		{
			if (solModifierAfterCnds)
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					this.runtime.pushCopySol(current_event.solModifiers);
					current_loop.index = i;
					current_event.retrigger();
					this.runtime.popSol(current_event.solModifiers);
				}
			}
			else
			{
				for (i = start; i <= end && !current_loop.stopped; ++i)  // inclusive to end
				{
					current_loop.index = i;
					current_event.retrigger();
				}
			}
		}
        this.runtime.popLoopStack();
		return false;
    };
	var foreach_instancestack = [];
	var foreach_instanceptr = -1;
    SysCnds.prototype.ForEach = function (obj)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
        var i, len, j, lenj, inst, s, sol2;
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	function foreach_sortinstances(a, b)
	{
		var va = a.extra.c2_foreachordered_val;
		var vb = b.extra.c2_foreachordered_val;
		if (cr.is_number(va) && cr.is_number(vb))
			return va - vb;
		else
		{
			va = "" + va;
			vb = "" + vb;
			if (va < vb)
				return -1;
			else if (va > vb)
				return 1;
			else
				return 0;
		}
	};
	SysCnds.prototype.ForEachOrdered = function (obj, exp, order)
    {
        var sol = obj.getCurrentSol();
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var instances = foreach_instancestack[foreach_instanceptr];
		cr.shallowAssignArray(instances, sol.getObjects());
        var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var current_condition = this.runtime.getCurrentCondition();
		var solModifierAfterCnds = current_frame.isModifierAfterCnds();
        var current_loop = this.runtime.pushLoopStack();
		var i, len, j, lenj, inst, s, sol2;
		for (i = 0, len = instances.length; i < len; i++)
		{
			instances[i].extra.c2_foreachordered_val = current_condition.parameters[1].get(i);
		}
		instances.sort(foreach_sortinstances);
		if (order === 1)
			instances.reverse();
		var is_contained = obj.is_contained;
		if (solModifierAfterCnds)
		{
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				this.runtime.pushCopySol(current_event.solModifiers);
				inst = instances[i];
				sol = obj.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
				this.runtime.popSol(current_event.solModifiers);
			}
		}
		else
		{
			sol.select_all = false;
			sol.instances.length = 1;
			for (i = 0, len = instances.length; i < len && !current_loop.stopped; i++)
			{
				inst = instances[i];
				sol.instances[0] = inst;
				if (is_contained)
				{
					for (j = 0, lenj = inst.siblings.length; j < lenj; j++)
					{
						s = inst.siblings[j];
						sol2 = s.type.getCurrentSol();
						sol2.select_all = false;
						sol2.instances.length = 1;
						sol2.instances[0] = s;
					}
				}
				current_loop.index = i;
				current_event.retrigger();
			}
		}
		instances.length = 0;
        this.runtime.popLoopStack();
		foreach_instanceptr--;
		return false;
    };
	SysCnds.prototype.PickByComparison = function (obj_, exp_, cmp_, val_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			val_ = current_condition.parameters[3].get(i);
			if (cr.do_cmp(exp_, cmp_, val_))
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
	SysCnds.prototype.PickByEvaluate = function (obj_, exp_)
	{
		var i, len, k, inst;
		if (!obj_)
			return;
		foreach_instanceptr++;
		if (foreach_instancestack.length === foreach_instanceptr)
			foreach_instancestack.push([]);
		var tmp_instances = foreach_instancestack[foreach_instanceptr];
		var sol = obj_.getCurrentSol();
		cr.shallowAssignArray(tmp_instances, sol.getObjects());
		if (sol.select_all)
			sol.else_instances.length = 0;
		var current_condition = this.runtime.getCurrentCondition();
		for (i = 0, k = 0, len = tmp_instances.length; i < len; i++)
		{
			inst = tmp_instances[i];
			tmp_instances[k] = inst;
			exp_ = current_condition.parameters[1].get(i);
			if (exp_)
			{
				k++;
			}
			else
			{
				sol.else_instances.push(inst);
			}
		}
		tmp_instances.length = k;
		sol.select_all = false;
		cr.shallowAssignArray(sol.instances, tmp_instances);
		tmp_instances.length = 0;
		foreach_instanceptr--;
		obj_.applySolToContainer();
		return !!sol.instances.length;
	};
    SysCnds.prototype.TriggerOnce = function ()
    {
        var cndextra = this.runtime.getCurrentCondition().extra;
		if (typeof cndextra.TriggerOnce_lastTick === "undefined")
			cndextra.TriggerOnce_lastTick = -1;
        var last_tick = cndextra.TriggerOnce_lastTick;
        var cur_tick = this.runtime.tickcount;
        cndextra.TriggerOnce_lastTick = cur_tick;
        return this.runtime.layout_first_tick || last_tick !== cur_tick - 1;
    };
    SysCnds.prototype.Every = function (seconds)
    {
        var cnd = this.runtime.getCurrentCondition();
        var last_time = cnd.extra.Every_lastTime || 0;
        var cur_time = this.runtime.kahanTime.sum;
		if (typeof cnd.extra.Every_seconds === "undefined")
			cnd.extra.Every_seconds = seconds;
		var this_seconds = cnd.extra.Every_seconds;
        if (cur_time >= last_time + this_seconds)
        {
            cnd.extra.Every_lastTime = last_time + this_seconds;
			if (cur_time >= cnd.extra.Every_lastTime + 0.04)
			{
				cnd.extra.Every_lastTime = cur_time;
			}
			cnd.extra.Every_seconds = seconds;
            return true;
        }
		else if (cur_time < last_time - 0.1)
		{
			cnd.extra.Every_lastTime = cur_time;
		}
		return false;
    };
    SysCnds.prototype.PickNth = function (obj, index)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		index = cr.floor(index);
        if (index < 0 || index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.PickRandom = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
		var index = cr.floor(Math.random() * instances.length);
        if (index >= instances.length)
            return false;
		var inst = instances[index];
        sol.pick_one(inst);
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.CompareVar = function (v, cmp, val)
    {
        return cr.do_cmp(v.getValue(), cmp, val);
    };
    SysCnds.prototype.IsGroupActive = function (group)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
        return g && g.group_active;
    };
	SysCnds.prototype.IsPreview = function ()
	{
		return typeof cr_is_preview !== "undefined";
	};
	SysCnds.prototype.PickAll = function (obj)
    {
        if (!obj)
            return false;
		if (!obj.instances.length)
			return false;
        var sol = obj.getCurrentSol();
        sol.select_all = true;
		obj.applySolToContainer();
        return true;
    };
	SysCnds.prototype.IsMobile = function ()
	{
		return this.runtime.isMobile;
	};
	SysCnds.prototype.CompareBetween = function (x, a, b)
	{
		return x >= a && x <= b;
	};
	SysCnds.prototype.Else = function ()
	{
		var current_frame = this.runtime.getCurrentEventStack();
		if (current_frame.else_branch_ran)
			return false;		// another event in this else-if chain has run
		else
			return !current_frame.last_event_true;
		/*
		var current_frame = this.runtime.getCurrentEventStack();
        var current_event = current_frame.current_event;
		var prev_event = current_event.prev_block;
		if (!prev_event)
			return false;
		if (prev_event.is_logical)
			return !this.runtime.last_event_true;
		var i, len, j, lenj, s, sol, temp, inst, any_picked = false;
		for (i = 0, len = prev_event.cndReferences.length; i < len; i++)
		{
			s = prev_event.cndReferences[i];
			sol = s.getCurrentSol();
			if (sol.select_all || sol.instances.length === s.instances.length)
			{
				sol.select_all = false;
				sol.instances.length = 0;
			}
			else
			{
				if (sol.instances.length === 1 && sol.else_instances.length === 0 && s.instances.length >= 2)
				{
					inst = sol.instances[0];
					sol.instances.length = 0;
					for (j = 0, lenj = s.instances.length; j < lenj; j++)
					{
						if (s.instances[j] != inst)
							sol.instances.push(s.instances[j]);
					}
					any_picked = true;
				}
				else
				{
					temp = sol.instances;
					sol.instances = sol.else_instances;
					sol.else_instances = temp;
					any_picked = true;
				}
			}
		}
		return any_picked;
		*/
	};
	SysCnds.prototype.OnLoadFinished = function ()
	{
		return true;
	};
	SysCnds.prototype.OnCanvasSnapshot = function ()
	{
		return true;
	};
	SysCnds.prototype.EffectsSupported = function ()
	{
		return !!this.runtime.glwrap;
	};
	SysCnds.prototype.OnSaveComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadComplete = function ()
	{
		return true;
	};
	SysCnds.prototype.OnLoadFailed = function ()
	{
		return true;
	};
	SysCnds.prototype.ObjectUIDExists = function (u)
	{
		return !!this.runtime.getObjectByUID(u);
	};
	SysCnds.prototype.IsOnPlatform = function (p)
	{
		var rt = this.runtime;
		switch (p) {
		case 0:		// HTML5 website
			return !rt.isDomFree && !rt.isNodeWebkit && !rt.isPhoneGap && !rt.isCrosswalk && !rt.isWinJS && !rt.isWindowsPhone8 && !rt.isBlackberry10 && !rt.isAmazonWebApp;
		case 1:		// iOS
			return rt.isiOS;
		case 2:		// Android
			return rt.isAndroid;
		case 3:		// Windows 8
			return rt.isWindows8App;
		case 4:		// Windows Phone 8
			return rt.isWindowsPhone8;
		case 5:		// Blackberry 10
			return rt.isBlackberry10;
		case 6:		// Tizen
			return rt.isTizen;
		case 7:		// CocoonJS
			return rt.isCocoonJs;
		case 8:		// PhoneGap
			return rt.isPhoneGap;
		case 9:	// Scirra Arcade
			return rt.isArcade;
		case 10:	// node-webkit
			return rt.isNodeWebkit;
		case 11:	// crosswalk
			return rt.isCrosswalk;
		case 12:	// amazon webapp
			return rt.isAmazonWebApp;
		default:	// should not be possible
			return false;
		}
	};
	var cacheRegex = null;
	var lastRegex = "";
	var lastFlags = "";
	function getRegex(regex_, flags_)
	{
		if (!cacheRegex || regex_ !== lastRegex || flags_ !== lastFlags)
		{
			cacheRegex = new RegExp(regex_, flags_);
			lastRegex = regex_;
			lastFlags = flags_;
		}
		cacheRegex.lastIndex = 0;		// reset
		return cacheRegex;
	};
	SysCnds.prototype.RegexTest = function (str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		return regex.test(str_);
	};
	var tmp_arr = [];
	SysCnds.prototype.PickOverlappingPoint = function (obj_, x_, y_)
	{
		if (!obj_)
            return false;
        var sol = obj_.getCurrentSol();
        var instances = sol.getObjects();
		var current_event = this.runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		var cnd = this.runtime.getCurrentCondition();
		var i, len, inst, pick;
		if (sol.select_all)
		{
			cr.shallowAssignArray(tmp_arr, instances);
			sol.else_instances.length = 0;
			sol.select_all = false;
			sol.instances.length = 0;
		}
		else
		{
			if (orblock)
			{
				cr.shallowAssignArray(tmp_arr, sol.else_instances);
				sol.else_instances.length = 0;
			}
			else
			{
				cr.shallowAssignArray(tmp_arr, instances);
				sol.instances.length = 0;
			}
		}
		for (i = 0, len = tmp_arr.length; i < len; ++i)
		{
			inst = tmp_arr[i];
			inst.update_bbox();
			pick = cr.xor(inst.contains_pt(x_, y_), cnd.inverted);
			if (pick)
				sol.instances.push(inst);
			else
				sol.else_instances.push(inst);
		}
		obj_.applySolToContainer();
		return cr.xor(!!sol.instances.length, cnd.inverted);
	};
	sysProto.cnds = new SysCnds();
    function SysActs() {};
    SysActs.prototype.GoToLayout = function(to)
    {
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
        this.runtime.changelayout = to;
    };
    SysActs.prototype.CreateObject = function (obj, layer, x, y)
    {
        if (!layer || !obj)
            return;
        var inst = this.runtime.createInstance(obj, layer, x, y);
		if (!inst)
			return;
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
        var sol = obj.getCurrentSol();
        sol.select_all = false;
		sol.instances.length = 1;
		sol.instances[0] = inst;
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				sol = s.type.getCurrentSol();
				sol.select_all = false;
				sol.instances.length = 1;
				sol.instances[0] = s;
			}
		}
    };
    SysActs.prototype.SetLayerVisible = function (layer, visible_)
    {
        if (!layer)
            return;
		if (layer.visible !== visible_)
		{
			layer.visible = visible_;
			this.runtime.redraw = true;
		}
    };
	SysActs.prototype.SetLayerOpacity = function (layer, opacity_)
	{
		if (!layer)
			return;
		opacity_ = cr.clamp(opacity_ / 100, 0, 1);
		if (layer.opacity !== opacity_)
		{
			layer.opacity = opacity_;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayerScaleRate = function (layer, sr)
	{
		if (!layer)
			return;
		if (layer.zoomRate !== sr)
		{
			layer.zoomRate = sr;
			this.runtime.redraw = true;
		}
	};
	SysActs.prototype.SetLayoutScale = function (s)
	{
		if (!this.runtime.running_layout)
			return;
		if (this.runtime.running_layout.scale !== s)
		{
			this.runtime.running_layout.scale = s;
			this.runtime.running_layout.boundScrolling();
			this.runtime.redraw = true;
		}
	};
    SysActs.prototype.ScrollX = function(x)
    {
        this.runtime.running_layout.scrollToX(x);
    };
    SysActs.prototype.ScrollY = function(y)
    {
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.Scroll = function(x, y)
    {
        this.runtime.running_layout.scrollToX(x);
        this.runtime.running_layout.scrollToY(y);
    };
    SysActs.prototype.ScrollToObject = function(obj)
    {
        var inst = obj.getFirstPicked();
        if (inst)
        {
            this.runtime.running_layout.scrollToX(inst.x);
            this.runtime.running_layout.scrollToY(inst.y);
        }
    };
	SysActs.prototype.SetVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(x);
			else
				v.setValue(parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(x.toString());
	};
	SysActs.prototype.AddVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() + x);
			else
				v.setValue(v.getValue() + parseFloat(x));
		}
		else if (v.vartype === 1)
			v.setValue(v.getValue() + x.toString());
	};
	SysActs.prototype.SubVar = function(v, x)
	{
;
		if (v.vartype === 0)
		{
			if (cr.is_number(x))
				v.setValue(v.getValue() - x);
			else
				v.setValue(v.getValue() - parseFloat(x));
		}
	};
    SysActs.prototype.SetGroupActive = function (group, active)
    {
		var g = this.runtime.groups_by_name[group.toLowerCase()];
		if (!g)
			return;
		switch (active) {
		case 0:
			g.setGroupActive(false);
			break;
		case 1:
			g.setGroupActive(true);
			break;
		case 2:
			g.setGroupActive(!g.group_active);
			break;
		}
    };
    SysActs.prototype.SetTimescale = function (ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        this.runtime.timescale = ts;
    };
    SysActs.prototype.SetObjectTimescale = function (obj, ts_)
    {
        var ts = ts_;
        if (ts < 0)
            ts = 0;
        if (!obj)
            return;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = ts;
        }
    };
    SysActs.prototype.RestoreObjectTimescale = function (obj)
    {
        if (!obj)
            return false;
        var sol = obj.getCurrentSol();
        var instances = sol.getObjects();
        var i, len;
        for (i = 0, len = instances.length; i < len; i++)
        {
            instances[i].my_timescale = -1.0;
        }
    };
	var waitobjrecycle = [];
	function allocWaitObject()
	{
		var w;
		if (waitobjrecycle.length)
			w = waitobjrecycle.pop();
		else
		{
			w = {};
			w.sols = {};
			w.solModifiers = [];
		}
		w.deleteme = false;
		return w;
	};
	function freeWaitObject(w)
	{
		cr.wipe(w.sols);
		w.solModifiers.length = 0;
		waitobjrecycle.push(w);
	};
	var solstateobjects = [];
	function allocSolStateObject()
	{
		var s;
		if (solstateobjects.length)
			s = solstateobjects.pop();
		else
		{
			s = {};
			s.insts = [];
		}
		s.sa = false;
		return s;
	};
	function freeSolStateObject(s)
	{
		s.insts.length = 0;
		solstateobjects.push(s);
	};
	SysActs.prototype.Wait = function (seconds)
	{
		if (seconds < 0)
			return;
		var i, len, s, t, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		var waitobj = allocWaitObject();
		waitobj.time = this.runtime.kahanTime.sum + seconds;
		waitobj.ev = evinfo.current_event;
		waitobj.actindex = evinfo.actindex + 1;	// pointing at next action
		for (i = 0, len = this.runtime.types_by_index.length; i < len; i++)
		{
			t = this.runtime.types_by_index[i];
			s = t.getCurrentSol();
			if (s.select_all && evinfo.current_event.solModifiers.indexOf(t) === -1)
				continue;
			waitobj.solModifiers.push(t);
			ss = allocSolStateObject();
			ss.sa = s.select_all;
			cr.shallowAssignArray(ss.insts, s.instances);
			waitobj.sols[i.toString()] = ss;
		}
		this.waits.push(waitobj);
		return true;
	};
	SysActs.prototype.SetLayerScale = function (layer, scale)
    {
        if (!layer)
            return;
		if (layer.scale === scale)
			return;
        layer.scale = scale;
        this.runtime.redraw = true;
    };
	SysActs.prototype.ResetGlobals = function ()
	{
		var i, len, g;
		for (i = 0, len = this.runtime.all_global_vars.length; i < len; i++)
		{
			g = this.runtime.all_global_vars[i];
			g.data = g.initial;
		}
	};
	SysActs.prototype.SetLayoutAngle = function (a)
	{
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (this.runtime.running_layout)
		{
			if (this.runtime.running_layout.angle !== a)
			{
				this.runtime.running_layout.angle = a;
				this.runtime.redraw = true;
			}
		}
	};
	SysActs.prototype.SetLayerAngle = function (layer, a)
    {
        if (!layer)
            return;
		a = cr.to_radians(a);
		a = cr.clamp_angle(a);
		if (layer.angle === a)
			return;
        layer.angle = a;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerParallax = function (layer, px, py)
    {
        if (!layer)
            return;
		if (layer.parallaxX === px / 100 && layer.parallaxY === py / 100)
			return;
        layer.parallaxX = px / 100;
		layer.parallaxY = py / 100;
		if (layer.parallaxX !== 1 || layer.parallaxY !== 1)
		{
			var i, len, instances = layer.instances;
			for (i = 0, len = instances.length; i < len; ++i)
			{
				instances[i].type.any_instance_parallaxed = true;
			}
		}
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerBackground = function (layer, c)
    {
        if (!layer)
            return;
		var r = cr.GetRValue(c);
		var g = cr.GetGValue(c);
		var b = cr.GetBValue(c);
		if (layer.background_color[0] === r && layer.background_color[1] === g && layer.background_color[2] === b)
			return;
        layer.background_color[0] = r;
		layer.background_color[1] = g;
		layer.background_color[2] = b;
        this.runtime.redraw = true;
    };
	SysActs.prototype.SetLayerTransparent = function (layer, t)
    {
        if (!layer)
            return;
		if (!!t === !!layer.transparent)
			return;
		layer.transparent = !!t;
        this.runtime.redraw = true;
    };
	SysActs.prototype.StopLoop = function ()
	{
		if (this.runtime.loop_stack_index < 0)
			return;		// no loop currently running
		this.runtime.getCurrentLoop().stopped = true;
	};
	SysActs.prototype.GoToLayoutByName = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot change layout while loading on loader layout
		if (this.runtime.changelayout)
			return;		// already changing to different layout
;
		var l;
		for (l in this.runtime.layouts)
		{
			if (this.runtime.layouts.hasOwnProperty(l) && cr.equals_nocase(l, layoutname))
			{
				this.runtime.changelayout = this.runtime.layouts[l];
				return;
			}
		}
	};
	SysActs.prototype.RestartLayout = function (layoutname)
	{
		if (this.runtime.isloading)
			return;		// cannot restart loader layouts
		if (this.runtime.changelayout)
			return;		// already changing to a different layout
;
		if (!this.runtime.running_layout)
			return;
		this.runtime.changelayout = this.runtime.running_layout;
		var i, len, g;
		for (i = 0, len = this.runtime.allGroups.length; i < len; i++)
		{
			g = this.runtime.allGroups[i];
			g.setGroupActive(g.initially_activated);
		}
	};
	SysActs.prototype.SnapshotCanvas = function (format_, quality_)
	{
		this.runtime.snapshotCanvas = [format_ === 0 ? "image/png" : "image/jpeg", quality_ / 100];
		this.runtime.redraw = true;		// force redraw so snapshot is always taken
	};
	SysActs.prototype.SetCanvasSize = function (w, h)
	{
		if (w <= 0 || h <= 0)
			return;
		var mode = this.runtime.fullscreen_mode;
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
		if (isfullscreen && this.runtime.fullscreen_scaling > 0)
			mode = this.runtime.fullscreen_scaling;
		if (mode === 0)
		{
			this.runtime["setSize"](w, h, true);
		}
		else
		{
			this.runtime.original_width = w;
			this.runtime.original_height = h;
			this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
		}
	};
	SysActs.prototype.SetLayoutEffectEnabled = function (enable_, effectname_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		this.runtime.running_layout.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectEnabled = function (layer, enable_, effectname_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var enable = (enable_ === 1);
		if (et.active == enable)
			return;		// no change
		et.active = enable;
		layer.updateActiveEffects();
		this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayoutEffectParam = function (effectname_, index_, value_)
	{
		if (!this.runtime.running_layout || !this.runtime.glwrap)
			return;
		var et = this.runtime.running_layout.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = this.runtime.running_layout.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SetLayerEffectParam = function (layer, effectname_, index_, value_)
	{
		if (!layer || !this.runtime.glwrap)
			return;
		var et = layer.getEffectByName(effectname_);
		if (!et)
			return;		// effect name not found
		var params = layer.effect_params[et.index];
		index_ = Math.floor(index_);
		if (index_ < 0 || index_ >= params.length)
			return;		// effect index out of bounds
		if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
			value_ /= 100.0;
		if (params[index_] === value_)
			return;		// no change
		params[index_] = value_;
		if (et.active)
			this.runtime.redraw = true;
	};
	SysActs.prototype.SaveState = function (slot_)
	{
		this.runtime.saveToSlot = slot_;
	};
	SysActs.prototype.LoadState = function (slot_)
	{
		this.runtime.loadFromSlot = slot_;
	};
	SysActs.prototype.LoadStateJSON = function (jsonstr_)
	{
		this.runtime.loadFromJson = jsonstr_;
	};
	SysActs.prototype.SetHalfFramerateMode = function (set_)
	{
		this.runtime.halfFramerateMode = (set_ !== 0);
	};
	SysActs.prototype.SetFullscreenQuality = function (q)
	{
		var isfullscreen = (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"] || this.isNodeFullscreen);
		if (!isfullscreen && this.runtime.fullscreen_mode === 0)
			return;
		this.runtime.wantFullscreenScalingQuality = (q !== 0);
		this.runtime["setSize"](this.runtime.lastWindowWidth, this.runtime.lastWindowHeight, true);
	};
	sysProto.acts = new SysActs();
    function SysExps() {};
    SysExps.prototype["int"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_int(parseInt(x, 10));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_int(x);
    };
    SysExps.prototype["float"] = function(ret, x)
    {
        if (cr.is_string(x))
        {
            ret.set_float(parseFloat(x));
            if (isNaN(ret.data))
                ret.data = 0;
        }
        else
            ret.set_float(x);
    };
    SysExps.prototype.str = function(ret, x)
    {
        if (cr.is_string(x))
            ret.set_string(x);
        else
            ret.set_string(x.toString());
    };
    SysExps.prototype.len = function(ret, x)
    {
        ret.set_int(x.length || 0);
    };
    SysExps.prototype.random = function (ret, a, b)
    {
        if (b === undefined)
        {
            ret.set_float(Math.random() * a);
        }
        else
        {
            ret.set_float(Math.random() * (b - a) + a);
        }
    };
    SysExps.prototype.sqrt = function(ret, x)
    {
        ret.set_float(Math.sqrt(x));
    };
    SysExps.prototype.abs = function(ret, x)
    {
        ret.set_float(Math.abs(x));
    };
    SysExps.prototype.round = function(ret, x)
    {
        ret.set_int(Math.round(x));
    };
    SysExps.prototype.floor = function(ret, x)
    {
        ret.set_int(Math.floor(x));
    };
    SysExps.prototype.ceil = function(ret, x)
    {
        ret.set_int(Math.ceil(x));
    };
    SysExps.prototype.sin = function(ret, x)
    {
        ret.set_float(Math.sin(cr.to_radians(x)));
    };
    SysExps.prototype.cos = function(ret, x)
    {
        ret.set_float(Math.cos(cr.to_radians(x)));
    };
    SysExps.prototype.tan = function(ret, x)
    {
        ret.set_float(Math.tan(cr.to_radians(x)));
    };
    SysExps.prototype.asin = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.asin(x)));
    };
    SysExps.prototype.acos = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.acos(x)));
    };
    SysExps.prototype.atan = function(ret, x)
    {
        ret.set_float(cr.to_degrees(Math.atan(x)));
    };
    SysExps.prototype.exp = function(ret, x)
    {
        ret.set_float(Math.exp(x));
    };
    SysExps.prototype.ln = function(ret, x)
    {
        ret.set_float(Math.log(x));
    };
    SysExps.prototype.log10 = function(ret, x)
    {
        ret.set_float(Math.log(x) / Math.LN10);
    };
    SysExps.prototype.max = function(ret)
    {
		var max_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (max_ < arguments[i])
				max_ = arguments[i];
		}
		ret.set_float(max_);
    };
    SysExps.prototype.min = function(ret)
    {
        var min_ = arguments[1];
		var i, len;
		for (i = 2, len = arguments.length; i < len; i++)
		{
			if (min_ > arguments[i])
				min_ = arguments[i];
		}
		ret.set_float(min_);
    };
    SysExps.prototype.dt = function(ret)
    {
        ret.set_float(this.runtime.dt);
    };
    SysExps.prototype.timescale = function(ret)
    {
        ret.set_float(this.runtime.timescale);
    };
    SysExps.prototype.wallclocktime = function(ret)
    {
        ret.set_float((Date.now() - this.runtime.start_time) / 1000.0);
    };
    SysExps.prototype.time = function(ret)
    {
        ret.set_float(this.runtime.kahanTime.sum);
    };
    SysExps.prototype.tickcount = function(ret)
    {
        ret.set_int(this.runtime.tickcount);
    };
    SysExps.prototype.objectcount = function(ret)
    {
        ret.set_int(this.runtime.objectcount);
    };
    SysExps.prototype.fps = function(ret)
    {
        ret.set_int(this.runtime.fps);
    };
    SysExps.prototype.loopindex = function(ret, name_)
    {
		var loop, i, len;
        if (!this.runtime.loop_stack.length)
        {
            ret.set_int(0);
            return;
        }
        if (name_)
        {
            for (i = 0, len = this.runtime.loop_stack.length; i < len; i++)
            {
                loop = this.runtime.loop_stack[i];
                if (loop.name === name_)
                {
                    ret.set_int(loop.index);
                    return;
                }
            }
            ret.set_int(0);
        }
        else
        {
			loop = this.runtime.getCurrentLoop();
			ret.set_int(loop ? loop.index : -1);
        }
    };
    SysExps.prototype.distance = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.distanceTo(x1, y1, x2, y2));
    };
    SysExps.prototype.angle = function(ret, x1, y1, x2, y2)
    {
        ret.set_float(cr.to_degrees(cr.angleTo(x1, y1, x2, y2)));
    };
    SysExps.prototype.scrollx = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollX);
    };
    SysExps.prototype.scrolly = function(ret)
    {
        ret.set_float(this.runtime.running_layout.scrollY);
    };
    SysExps.prototype.newline = function(ret)
    {
        ret.set_string("\n");
    };
    SysExps.prototype.lerp = function(ret, a, b, x)
    {
        ret.set_float(cr.lerp(a, b, x));
    };
    SysExps.prototype.windowwidth = function(ret)
    {
        ret.set_int(this.runtime.width);
    };
    SysExps.prototype.windowheight = function(ret)
    {
        ret.set_int(this.runtime.height);
    };
	SysExps.prototype.uppercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toUpperCase() : "");
	};
	SysExps.prototype.lowercase = function(ret, str)
	{
		ret.set_string(cr.is_string(str) ? str.toLowerCase() : "");
	};
	SysExps.prototype.clamp = function(ret, x, l, u)
	{
		if (x < l)
			ret.set_float(l);
		else if (x > u)
			ret.set_float(u);
		else
			ret.set_float(x);
	};
	SysExps.prototype.layerscale = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.scale);
	};
	SysExps.prototype.layeropacity = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.opacity * 100);
	};
	SysExps.prototype.layerscalerate = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.zoomRate);
	};
	SysExps.prototype.layerparallaxx = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxX * 100);
	};
	SysExps.prototype.layerparallaxy = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(layer.parallaxY * 100);
	};
	SysExps.prototype.layoutscale = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_float(this.runtime.running_layout.scale);
		else
			ret.set_float(0);
	};
	SysExps.prototype.layoutangle = function (ret)
	{
		ret.set_float(cr.to_degrees(this.runtime.running_layout.angle));
	};
	SysExps.prototype.layerangle = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		if (!layer)
			ret.set_float(0);
		else
			ret.set_float(cr.to_degrees(layer.angle));
	};
	SysExps.prototype.layoutwidth = function (ret)
	{
		ret.set_int(this.runtime.running_layout.width);
	};
	SysExps.prototype.layoutheight = function (ret)
	{
		ret.set_int(this.runtime.running_layout.height);
	};
	SysExps.prototype.find = function (ret, text, searchstr)
	{
		if (cr.is_string(text) && cr.is_string(searchstr))
			ret.set_int(text.search(new RegExp(cr.regexp_escape(searchstr), "i")));
		else
			ret.set_int(-1);
	};
	SysExps.prototype.left = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(0, n) : "");
	};
	SysExps.prototype.right = function (ret, text, n)
	{
		ret.set_string(cr.is_string(text) ? text.substr(text.length - n) : "");
	};
	SysExps.prototype.mid = function (ret, text, index_, length_)
	{
		ret.set_string(cr.is_string(text) ? text.substr(index_, length_) : "");
	};
	SysExps.prototype.tokenat = function (ret, text, index_, sep)
	{
		if (cr.is_string(text) && cr.is_string(sep))
		{
			var arr = text.split(sep);
			var i = cr.floor(index_);
			if (i < 0 || i >= arr.length)
				ret.set_string("");
			else
				ret.set_string(arr[i]);
		}
		else
			ret.set_string("");
	};
	SysExps.prototype.tokencount = function (ret, text, sep)
	{
		if (cr.is_string(text) && text.length)
			ret.set_int(text.split(sep).length);
		else
			ret.set_int(0);
	};
	SysExps.prototype.replace = function (ret, text, find_, replace_)
	{
		if (cr.is_string(text) && cr.is_string(find_) && cr.is_string(replace_))
			ret.set_string(text.replace(new RegExp(cr.regexp_escape(find_), "gi"), replace_));
		else
			ret.set_string(cr.is_string(text) ? text : "");
	};
	SysExps.prototype.trim = function (ret, text)
	{
		ret.set_string(cr.is_string(text) ? text.trim() : "");
	};
	SysExps.prototype.pi = function (ret)
	{
		ret.set_float(cr.PI);
	};
	SysExps.prototype.layoutname = function (ret)
	{
		if (this.runtime.running_layout)
			ret.set_string(this.runtime.running_layout.name);
		else
			ret.set_string("");
	};
	SysExps.prototype.renderer = function (ret)
	{
		ret.set_string(this.runtime.gl ? "webgl" : "canvas2d");
	};
	SysExps.prototype.anglediff = function (ret, a, b)
	{
		ret.set_float(cr.to_degrees(cr.angleDiff(cr.to_radians(a), cr.to_radians(b))));
	};
	SysExps.prototype.choose = function (ret)
	{
		var index = cr.floor(Math.random() * (arguments.length - 1));
		ret.set_any(arguments[index + 1]);
	};
	SysExps.prototype.rgb = function (ret, r, g, b)
	{
		ret.set_int(cr.RGB(r, g, b));
	};
	SysExps.prototype.projectversion = function (ret)
	{
		ret.set_string(this.runtime.versionstr);
	};
	SysExps.prototype.anglelerp = function (ret, a, b, x)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		var diff = cr.angleDiff(a, b);
		if (cr.angleClockwise(b, a))
		{
			ret.set_float(cr.to_clamped_degrees(a + diff * x));
		}
		else
		{
			ret.set_float(cr.to_clamped_degrees(a - diff * x));
		}
	};
	SysExps.prototype.anglerotate = function (ret, a, b, c)
	{
		a = cr.to_radians(a);
		b = cr.to_radians(b);
		c = cr.to_radians(c);
		ret.set_float(cr.to_clamped_degrees(cr.angleRotate(a, b, c)));
	};
	SysExps.prototype.zeropad = function (ret, n, d)
	{
		var s = (n < 0 ? "-" : "");
		if (n < 0) n = -n;
		var zeroes = d - n.toString().length;
		for (var i = 0; i < zeroes; i++)
			s += "0";
		ret.set_string(s + n.toString());
	};
	SysExps.prototype.cpuutilisation = function (ret)
	{
		ret.set_float(this.runtime.cpuutilisation / 1000);
	};
	SysExps.prototype.viewportleft = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewLeft : 0);
	};
	SysExps.prototype.viewporttop = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewTop : 0);
	};
	SysExps.prototype.viewportright = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewRight : 0);
	};
	SysExps.prototype.viewportbottom = function (ret, layerparam)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.viewBottom : 0);
	};
	SysExps.prototype.loadingprogress = function (ret)
	{
		ret.set_float(this.runtime.loadingprogress);
	};
	SysExps.prototype.unlerp = function(ret, a, b, y)
    {
        ret.set_float(cr.unlerp(a, b, y));
    };
	SysExps.prototype.canvassnapshot = function (ret)
	{
		ret.set_string(this.runtime.snapshotData);
	};
	SysExps.prototype.urlencode = function (ret, s)
	{
		ret.set_string(encodeURIComponent(s));
	};
	SysExps.prototype.urldecode = function (ret, s)
	{
		ret.set_string(decodeURIComponent(s));
	};
	SysExps.prototype.canvastolayerx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, true) : 0);
	};
	SysExps.prototype.canvastolayery = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.canvasToLayer(x, y, false) : 0);
	};
	SysExps.prototype.layertocanvasx = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, true) : 0);
	};
	SysExps.prototype.layertocanvasy = function (ret, layerparam, x, y)
	{
		var layer = this.runtime.getLayer(layerparam);
		ret.set_float(layer ? layer.layerToCanvas(x, y, false) : 0);
	};
	SysExps.prototype.savestatejson = function (ret)
	{
		ret.set_string(this.runtime.lastSaveJson);
	};
	SysExps.prototype.imagememoryusage = function (ret)
	{
		if (this.runtime.glwrap)
			ret.set_float(Math.round(100 * this.runtime.glwrap.estimateVRAM() / (1024 * 1024)) / 100);
		else
			ret.set_float(0);
	};
	SysExps.prototype.regexsearch = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_int(str_ ? str_.search(regex) : -1);
	};
	SysExps.prototype.regexreplace = function (ret, str_, regex_, flags_, replace_)
	{
		var regex = getRegex(regex_, flags_);
		ret.set_string(str_ ? str_.replace(regex, replace_) : "");
	};
	var regexMatches = [];
	var lastMatchesStr = "";
	var lastMatchesRegex = "";
	var lastMatchesFlags = "";
	function updateRegexMatches(str_, regex_, flags_)
	{
		if (str_ === lastMatchesStr && regex_ === lastMatchesRegex && flags_ === lastMatchesFlags)
			return;
		var regex = getRegex(regex_, flags_);
		regexMatches = str_.match(regex);
		lastMatchesStr = str_;
		lastMatchesRegex = regex_;
		lastMatchesFlags = flags_;
	};
	SysExps.prototype.regexmatchcount = function (ret, str_, regex_, flags_)
	{
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		ret.set_int(regexMatches ? regexMatches.length : 0);
	};
	SysExps.prototype.regexmatchat = function (ret, str_, regex_, flags_, index_)
	{
		index_ = Math.floor(index_);
		var regex = getRegex(regex_, flags_);
		updateRegexMatches(str_, regex_, flags_);
		if (!regexMatches || index_ < 0 || index_ >= regexMatches.length)
			ret.set_string("");
		else
			ret.set_string(regexMatches[index_]);
	};
	SysExps.prototype.infinity = function (ret)
	{
		ret.set_float(Infinity);
	};
	SysExps.prototype.setbit = function (ret, n, b, v)
	{
		n = n | 0;
		b = b | 0;
		v = (v !== 0 ? 1 : 0);
		ret.set_int((n & ~(1 << b)) | (v << b));
	};
	SysExps.prototype.togglebit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int(n ^ (1 << b));
	};
	SysExps.prototype.getbit = function (ret, n, b)
	{
		n = n | 0;
		b = b | 0;
		ret.set_int((n & (1 << b)) ? 1 : 0);
	};
	sysProto.exps = new SysExps();
	sysProto.runWaits = function ()
	{
		var i, j, len, w, k, s, ss;
		var evinfo = this.runtime.getCurrentEventStack();
		for (i = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			if (w.time > this.runtime.kahanTime.sum)
				continue;
			evinfo.current_event = w.ev;
			evinfo.actindex = w.actindex;
			evinfo.cndindex = 0;
			for (k in w.sols)
			{
				if (w.sols.hasOwnProperty(k))
				{
					s = this.runtime.types_by_index[parseInt(k, 10)].getCurrentSol();
					ss = w.sols[k];
					s.select_all = ss.sa;
					cr.shallowAssignArray(s.instances, ss.insts);
					freeSolStateObject(ss);
				}
			}
			w.ev.resume_actions_and_subevents();
			this.runtime.clearSol(w.solModifiers);
			w.deleteme = true;
		}
		for (i = 0, j = 0, len = this.waits.length; i < len; i++)
		{
			w = this.waits[i];
			this.waits[j] = w;
			if (w.deleteme)
				freeWaitObject(w);
			else
				j++;
		}
		this.waits.length = j;
	};
}());
;
(function () {
	cr.add_common_aces = function (m)
	{
		var pluginProto = m[0].prototype;
		var singleglobal_ = m[1];
		var position_aces = m[3];
		var size_aces = m[4];
		var angle_aces = m[5];
		var appearance_aces = m[6];
		var zorder_aces = m[7];
		var effects_aces = m[8];
		if (!pluginProto.cnds)
			pluginProto.cnds = {};
		if (!pluginProto.acts)
			pluginProto.acts = {};
		if (!pluginProto.exps)
			pluginProto.exps = {};
		var cnds = pluginProto.cnds;
		var acts = pluginProto.acts;
		var exps = pluginProto.exps;
		if (position_aces)
		{
			cnds.CompareX = function (cmp, x)
			{
				return cr.do_cmp(this.x, cmp, x);
			};
			cnds.CompareY = function (cmp, y)
			{
				return cr.do_cmp(this.y, cmp, y);
			};
			cnds.IsOnScreen = function ()
			{
				var layer = this.layer;
				this.update_bbox();
				var bbox = this.bbox;
				return !(bbox.right < layer.viewLeft || bbox.bottom < layer.viewTop || bbox.left > layer.viewRight || bbox.top > layer.viewBottom);
			};
			cnds.IsOutsideLayout = function ()
			{
				this.update_bbox();
				var bbox = this.bbox;
				var layout = this.runtime.running_layout;
				return (bbox.right < 0 || bbox.bottom < 0 || bbox.left > layout.width || bbox.top > layout.height);
			};
			cnds.PickDistance = function (which, x, y)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var dist = cr.distanceTo(inst.x, inst.y, x, y);
				var i, len, d;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					d = cr.distanceTo(inst.x, inst.y, x, y);
					if ((which === 0 && d < dist) || (which === 1 && d > dist))
					{
						dist = d;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.SetX = function (x)
			{
				if (this.x !== x)
				{
					this.x = x;
					this.set_bbox_changed();
				}
			};
			acts.SetY = function (y)
			{
				if (this.y !== y)
				{
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPos = function (x, y)
			{
				if (this.x !== x || this.y !== y)
				{
					this.x = x;
					this.y = y;
					this.set_bbox_changed();
				}
			};
			acts.SetPosToObject = function (obj, imgpt)
			{
				var inst = obj.getPairedInstance(this);
				if (!inst)
					return;
				var newx, newy;
				if (inst.getImagePoint)
				{
					newx = inst.getImagePoint(imgpt, true);
					newy = inst.getImagePoint(imgpt, false);
				}
				else
				{
					newx = inst.x;
					newy = inst.y;
				}
				if (this.x !== newx || this.y !== newy)
				{
					this.x = newx;
					this.y = newy;
					this.set_bbox_changed();
				}
			};
			acts.MoveForward = function (dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(this.angle) * dist;
					this.y += Math.sin(this.angle) * dist;
					this.set_bbox_changed();
				}
			};
			acts.MoveAtAngle = function (a, dist)
			{
				if (dist !== 0)
				{
					this.x += Math.cos(cr.to_radians(a)) * dist;
					this.y += Math.sin(cr.to_radians(a)) * dist;
					this.set_bbox_changed();
				}
			};
			exps.X = function (ret)
			{
				ret.set_float(this.x);
			};
			exps.Y = function (ret)
			{
				ret.set_float(this.y);
			};
			exps.dt = function (ret)
			{
				ret.set_float(this.runtime.getDt(this));
			};
		}
		if (size_aces)
		{
			cnds.CompareWidth = function (cmp, w)
			{
				return cr.do_cmp(this.width, cmp, w);
			};
			cnds.CompareHeight = function (cmp, h)
			{
				return cr.do_cmp(this.height, cmp, h);
			};
			acts.SetWidth = function (w)
			{
				if (this.width !== w)
				{
					this.width = w;
					this.set_bbox_changed();
				}
			};
			acts.SetHeight = function (h)
			{
				if (this.height !== h)
				{
					this.height = h;
					this.set_bbox_changed();
				}
			};
			acts.SetSize = function (w, h)
			{
				if (this.width !== w || this.height !== h)
				{
					this.width = w;
					this.height = h;
					this.set_bbox_changed();
				}
			};
			exps.Width = function (ret)
			{
				ret.set_float(this.width);
			};
			exps.Height = function (ret)
			{
				ret.set_float(this.height);
			};
			exps.BBoxLeft = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.left);
			};
			exps.BBoxTop = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.top);
			};
			exps.BBoxRight = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.right);
			};
			exps.BBoxBottom = function (ret)
			{
				this.update_bbox();
				ret.set_float(this.bbox.bottom);
			};
		}
		if (angle_aces)
		{
			cnds.AngleWithin = function (within, a)
			{
				return cr.angleDiff(this.angle, cr.to_radians(a)) <= cr.to_radians(within);
			};
			cnds.IsClockwiseFrom = function (a)
			{
				return cr.angleClockwise(this.angle, cr.to_radians(a));
			};
			cnds.IsBetweenAngles = function (a, b)
			{
				var lower = cr.to_clamped_radians(a);
				var upper = cr.to_clamped_radians(b);
				var angle = cr.clamp_angle(this.angle);
				var obtuse = (!cr.angleClockwise(upper, lower));
				if (obtuse)
					return !(!cr.angleClockwise(angle, lower) && cr.angleClockwise(angle, upper));
				else
					return cr.angleClockwise(angle, lower) && !cr.angleClockwise(angle, upper);
			};
			acts.SetAngle = function (a)
			{
				var newangle = cr.to_radians(cr.clamp_angle_degrees(a));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateClockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle += cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateCounterclockwise = function (a)
			{
				if (a !== 0 && !isNaN(a))
				{
					this.angle -= cr.to_radians(a);
					this.angle = cr.clamp_angle(this.angle);
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardAngle = function (amt, target)
			{
				var newangle = cr.angleRotate(this.angle, cr.to_radians(target), cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.RotateTowardPosition = function (amt, x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var target = Math.atan2(dy, dx);
				var newangle = cr.angleRotate(this.angle, target, cr.to_radians(amt));
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			acts.SetTowardPosition = function (x, y)
			{
				var dx = x - this.x;
				var dy = y - this.y;
				var newangle = Math.atan2(dy, dx);
				if (isNaN(newangle))
					return;
				if (this.angle !== newangle)
				{
					this.angle = newangle;
					this.set_bbox_changed();
				}
			};
			exps.Angle = function (ret)
			{
				ret.set_float(cr.to_clamped_degrees(this.angle));
			};
		}
		if (!singleglobal_)
		{
			cnds.CompareInstanceVar = function (iv, cmp, val)
			{
				return cr.do_cmp(this.instance_vars[iv], cmp, val);
			};
			cnds.IsBoolInstanceVarSet = function (iv)
			{
				return this.instance_vars[iv];
			};
			cnds.PickInstVarHiLow = function (which, iv)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var val = inst.instance_vars[iv];
				var i, len, v;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					v = inst.instance_vars[iv];
					if ((which === 0 && v < val) || (which === 1 && v > val))
					{
						val = v;
						pickme = inst;
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			cnds.PickByUID = function (u)
			{
				var i, len, j, inst, families, instances, sol;
				var cnd = this.runtime.getCurrentCondition();
				if (cnd.inverted)
				{
					sol = this.getCurrentSol();
					if (sol.select_all)
					{
						sol.select_all = false;
						sol.instances.length = 0;
						sol.else_instances.length = 0;
						instances = this.instances;
						for (i = 0, len = instances.length; i < len; i++)
						{
							inst = instances[i];
							if (inst.uid === u)
								sol.else_instances.push(inst);
							else
								sol.instances.push(inst);
						}
						this.applySolToContainer();
						return !!sol.instances.length;
					}
					else
					{
						for (i = 0, j = 0, len = sol.instances.length; i < len; i++)
						{
							inst = sol.instances[i];
							sol.instances[j] = inst;
							if (inst.uid === u)
							{
								sol.else_instances.push(inst);
							}
							else
								j++;
						}
						sol.instances.length = j;
						this.applySolToContainer();
						return !!sol.instances.length;
					}
				}
				else
				{
					inst = this.runtime.getObjectByUID(u);
					if (!inst)
						return false;
					sol = this.getCurrentSol();
					if (!sol.select_all && sol.instances.indexOf(inst) === -1)
						return false;		// not picked
					if (this.is_family)
					{
						families = inst.type.families;
						for (i = 0, len = families.length; i < len; i++)
						{
							if (families[i] === this)
							{
								sol.pick_one(inst);
								this.applySolToContainer();
								return true;
							}
						}
					}
					else if (inst.type === this)
					{
						sol.pick_one(inst);
						this.applySolToContainer();
						return true;
					}
					return false;
				}
			};
			cnds.OnCreated = function ()
			{
				return true;
			};
			cnds.OnDestroyed = function ()
			{
				return true;
			};
			acts.SetInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] = val;
					else
						myinstvars[iv] = val.toString();
				}
				else
;
			};
			acts.AddInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += parseFloat(val);
				}
				else if (cr.is_string(myinstvars[iv]))
				{
					if (cr.is_string(val))
						myinstvars[iv] += val;
					else
						myinstvars[iv] += val.toString();
				}
				else
;
			};
			acts.SubInstanceVar = function (iv, val)
			{
				var myinstvars = this.instance_vars;
				if (cr.is_number(myinstvars[iv]))
				{
					if (cr.is_number(val))
						myinstvars[iv] -= val;
					else
						myinstvars[iv] -= parseFloat(val);
				}
				else
;
			};
			acts.SetBoolInstanceVar = function (iv, val)
			{
				this.instance_vars[iv] = val ? 1 : 0;
			};
			acts.ToggleBoolInstanceVar = function (iv)
			{
				this.instance_vars[iv] = 1 - this.instance_vars[iv];
			};
			acts.Destroy = function ()
			{
				this.runtime.DestroyInstance(this);
			};
			if (!acts.LoadFromJsonString)
			{
				acts.LoadFromJsonString = function (str_)
				{
					var o, i, len, binst;
					try {
						o = JSON.parse(str_);
					}
					catch (e) {
						return;
					}
					this.runtime.loadInstanceFromJSON(this, o, true);
					if (this.afterLoad)
						this.afterLoad();
					if (this.behavior_insts)
					{
						for (i = 0, len = this.behavior_insts.length; i < len; ++i)
						{
							binst = this.behavior_insts[i];
							if (binst.afterLoad)
								binst.afterLoad();
						}
					}
				};
			}
			exps.Count = function (ret)
			{
				var count = ret.object_class.instances.length;
				var i, len, inst;
				for (i = 0, len = this.runtime.createRow.length; i < len; i++)
				{
					inst = this.runtime.createRow[i];
					if (ret.object_class.is_family)
					{
						if (inst.type.families.indexOf(ret.object_class) >= 0)
							count++;
					}
					else
					{
						if (inst.type === ret.object_class)
							count++;
					}
				}
				ret.set_int(count);
			};
			exps.PickedCount = function (ret)
			{
				ret.set_int(ret.object_class.getCurrentSol().getObjects().length);
			};
			exps.UID = function (ret)
			{
				ret.set_int(this.uid);
			};
			exps.IID = function (ret)
			{
				ret.set_int(this.get_iid());
			};
			if (!exps.AsJSON)
			{
				exps.AsJSON = function (ret)
				{
					ret.set_string(JSON.stringify(this.runtime.saveInstanceToJSON(this, true)));
				};
			}
		}
		if (appearance_aces)
		{
			cnds.IsVisible = function ()
			{
				return this.visible;
			};
			acts.SetVisible = function (v)
			{
				if (!v !== !this.visible)
				{
					this.visible = v;
					this.runtime.redraw = true;
				}
			};
			cnds.CompareOpacity = function (cmp, x)
			{
				return cr.do_cmp(cr.round6dp(this.opacity * 100), cmp, x);
			};
			acts.SetOpacity = function (x)
			{
				var new_opacity = x / 100.0;
				if (new_opacity < 0)
					new_opacity = 0;
				else if (new_opacity > 1)
					new_opacity = 1;
				if (new_opacity !== this.opacity)
				{
					this.opacity = new_opacity;
					this.runtime.redraw = true;
				}
			};
			exps.Opacity = function (ret)
			{
				ret.set_float(cr.round6dp(this.opacity * 100.0));
			};
		}
		if (zorder_aces)
		{
			cnds.IsOnLayer = function (layer_)
			{
				if (!layer_)
					return false;
				return this.layer === layer_;
			};
			cnds.PickTopBottom = function (which_)
			{
				var sol = this.getCurrentSol();
				var instances = sol.getObjects();
				if (!instances.length)
					return false;
				var inst = instances[0];
				var pickme = inst;
				var i, len;
				for (i = 1, len = instances.length; i < len; i++)
				{
					inst = instances[i];
					if (which_ === 0)
					{
						if (inst.layer.index > pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() > pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
					else
					{
						if (inst.layer.index < pickme.layer.index || (inst.layer.index === pickme.layer.index && inst.get_zindex() < pickme.get_zindex()))
						{
							pickme = inst;
						}
					}
				}
				sol.pick_one(pickme);
				return true;
			};
			acts.MoveToTop = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === this.layer.instances.length - 1)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.push(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToBottom = function ()
			{
				var zindex = this.get_zindex();
				if (zindex === 0)
					return;
				cr.arrayRemove(this.layer.instances, zindex);
				this.layer.instances.unshift(this);
				this.runtime.redraw = true;
				this.layer.zindices_stale = true;
			};
			acts.MoveToLayer = function (layerMove)
			{
				if (!layerMove || layerMove == this.layer)
					return;
				cr.arrayRemove(this.layer.instances, this.get_zindex());
				this.layer.zindices_stale = true;
				this.layer = layerMove;
				this.zindex = layerMove.instances.length;
				layerMove.instances.push(this);
				this.runtime.redraw = true;
			};
			acts.ZMoveToObject = function (where_, obj_)
			{
				var isafter = (where_ === 0);
				if (!obj_)
					return;
				var other = obj_.getFirstPicked(this);
				if (!other || other.uid === this.uid)
					return;
				if (this.layer.index !== other.layer.index)
				{
					cr.arrayRemove(this.layer.instances, this.get_zindex());
					this.layer.zindices_stale = true;
					this.layer = other.layer;
					this.zindex = other.layer.instances.length;
					other.layer.instances.push(this);
				}
				var myZ = this.get_zindex();
				var insertZ = other.get_zindex();
				cr.arrayRemove(this.layer.instances, myZ);
				if (myZ < insertZ)
					insertZ--;
				if (isafter)
					insertZ++;
				if (insertZ === this.layer.instances.length)
					this.layer.instances.push(this);
				else
					this.layer.instances.splice(insertZ, 0, this);
				this.layer.zindices_stale = true;
				this.runtime.redraw = true;
			};
			exps.LayerNumber = function (ret)
			{
				ret.set_int(this.layer.number);
			};
			exps.LayerName = function (ret)
			{
				ret.set_string(this.layer.name);
			};
			exps.ZIndex = function (ret)
			{
				ret.set_int(this.get_zindex());
			};
		}
		if (effects_aces)
		{
			acts.SetEffectEnabled = function (enable_, effectname_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var enable = (enable_ === 1);
				if (this.active_effect_flags[i] === enable)
					return;		// no change
				this.active_effect_flags[i] = enable;
				this.updateActiveEffects();
				this.runtime.redraw = true;
			};
			acts.SetEffectParam = function (effectname_, index_, value_)
			{
				if (!this.runtime.glwrap)
					return;
				var i = this.type.getEffectIndexByName(effectname_);
				if (i < 0)
					return;		// effect name not found
				var et = this.type.effect_types[i];
				var params = this.effect_params[i];
				index_ = Math.floor(index_);
				if (index_ < 0 || index_ >= params.length)
					return;		// effect index out of bounds
				if (this.runtime.glwrap.getProgramParameterType(et.shaderindex, index_) === 1)
					value_ /= 100.0;
				if (params[index_] === value_)
					return;		// no change
				params[index_] = value_;
				if (et.active)
					this.runtime.redraw = true;
			};
		}
	};
	cr.set_bbox_changed = function ()
	{
		this.bbox_changed = true;      		// will recreate next time box requested
		this.cell_changed = true;
		this.type.any_cell_changed = true;	// avoid unnecessary updateAllBBox() calls
		this.runtime.redraw = true;     	// assume runtime needs to redraw
		var i, len, callbacks = this.bbox_changed_callbacks;
		for (i = 0, len = callbacks.length; i < len; ++i)
		{
			callbacks[i](this);
		}
	};
	cr.add_bbox_changed_callback = function (f)
	{
		if (f)
		{
			this.bbox_changed_callbacks.push(f);
		}
	};
	cr.update_bbox = function ()
	{
		if (!this.bbox_changed)
			return;                 // bounding box not changed
		var bbox = this.bbox;
		var bquad = this.bquad;
		bbox.set(this.x, this.y, this.x + this.width, this.y + this.height);
		bbox.offset(-this.hotspotX * this.width, -this.hotspotY * this.height);
		if (!this.angle)
		{
			bquad.set_from_rect(bbox);    // make bounding quad from box
		}
		else
		{
			bbox.offset(-this.x, -this.y);       			// translate to origin
			bquad.set_from_rotated_rect(bbox, this.angle);	// rotate around origin
			bquad.offset(this.x, this.y);      				// translate back to original position
			bquad.bounding_box(bbox);
		}
		bbox.normalize();
		this.bbox_changed = false;  // bounding box up to date
	};
	var tmprc = new cr.rect(0, 0, 0, 0);
	cr.update_collision_cell = function ()
	{
		if (!this.cell_changed || !this.collisionsEnabled)
			return;
		this.update_bbox();
		var mygrid = this.type.collision_grid;
		var collcells = this.collcells;
		var bbox = this.bbox;
		tmprc.set(mygrid.XToCell(bbox.left), mygrid.YToCell(bbox.top), mygrid.XToCell(bbox.right), mygrid.YToCell(bbox.bottom));
		if (collcells.equals(tmprc))
			return;
		if (collcells.right < collcells.left)
			mygrid.update(this, null, tmprc);		// first insertion with invalid rect: don't provide old range
		else
			mygrid.update(this, collcells, tmprc);
		collcells.copy(tmprc);
		this.cell_changed = false;
	};
	cr.inst_contains_pt = function (x, y)
	{
		if (!this.bbox.contains_pt(x, y))
			return false;
		if (!this.bquad.contains_pt(x, y))
			return false;
		if (this.collision_poly && !this.collision_poly.is_empty())
		{
			this.collision_poly.cache_poly(this.width, this.height, this.angle);
			return this.collision_poly.contains_pt(x - this.x, y - this.y);
		}
		else
			return true;
	};
	cr.inst_get_iid = function ()
	{
		this.type.updateIIDs();
		return this.iid;
	};
	cr.inst_get_zindex = function ()
	{
		this.layer.updateZIndices();
		return this.zindex;
	};
	cr.inst_updateActiveEffects = function ()
	{
		this.active_effect_types.length = 0;
		var i, len, et, inst;
		for (i = 0, len = this.active_effect_flags.length; i < len; i++)
		{
			if (this.active_effect_flags[i])
				this.active_effect_types.push(this.type.effect_types[i]);
		}
		this.uses_shaders = !!this.active_effect_types.length;
	};
	cr.inst_toString = function ()
	{
		return "Inst" + this.puid;
	};
	cr.type_getFirstPicked = function (frominst)
	{
		if (frominst && frominst.is_contained && frominst.type != this)
		{
			var i, len, s;
			for (i = 0, len = frominst.siblings.length; i < len; i++)
			{
				s = frominst.siblings[i];
				if (s.type == this)
					return s;
			}
		}
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[0];
		else
			return null;
	};
	cr.type_getPairedInstance = function (inst)
	{
		var instances = this.getCurrentSol().getObjects();
		if (instances.length)
			return instances[inst.get_iid() % instances.length];
		else
			return null;
	};
	cr.type_updateIIDs = function ()
	{
		if (!this.stale_iids || this.is_family)
			return;		// up to date or is family - don't want family to overwrite IIDs
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].iid = i;
		var next_iid = i;
		var createRow = this.runtime.createRow;
		for (i = 0, len = createRow.length; i < len; ++i)
		{
			if (createRow[i].type === this)
				createRow[i].iid = next_iid++;
		}
		this.stale_iids = false;
	};
	cr.type_getInstanceByIID = function (i)
	{
		if (i < this.instances.length)
			return this.instances[i];
		i -= this.instances.length;
		var createRow = this.runtime.createRow;
		var j, lenj;
		for (j = 0, lenj = createRow.length; j < lenj; ++j)
		{
			if (createRow[j].type === this)
			{
				if (i === 0)
					return createRow[j];
				--i;
			}
		}
;
		return null;
	};
	cr.type_getCurrentSol = function ()
	{
		return this.solstack[this.cur_sol];
	};
	cr.type_pushCleanSol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		else
			this.solstack[this.cur_sol].select_all = true;  // else clear next SOL
	};
	cr.type_pushCopySol = function ()
	{
		this.cur_sol++;
		if (this.cur_sol === this.solstack.length)
			this.solstack.push(new cr.selection(this));
		var clonesol = this.solstack[this.cur_sol];
		var prevsol = this.solstack[this.cur_sol - 1];
		if (prevsol.select_all)
			clonesol.select_all = true;
		else
		{
			clonesol.select_all = false;
			cr.shallowAssignArray(clonesol.instances, prevsol.instances);
			cr.shallowAssignArray(clonesol.else_instances, prevsol.else_instances);
		}
	};
	cr.type_popSol = function ()
	{
;
		this.cur_sol--;
	};
	cr.type_getBehaviorByName = function (behname)
	{
		var i, len, j, lenj, f, index = 0;
		if (!this.is_family)
		{
			for (i = 0, len = this.families.length; i < len; i++)
			{
				f = this.families[i];
				for (j = 0, lenj = f.behaviors.length; j < lenj; j++)
				{
					if (behname === f.behaviors[j].name)
					{
						this.extra.lastBehIndex = index;
						return f.behaviors[j];
					}
					index++;
				}
			}
		}
		for (i = 0, len = this.behaviors.length; i < len; i++) {
			if (behname === this.behaviors[i].name)
			{
				this.extra.lastBehIndex = index;
				return this.behaviors[i];
			}
			index++;
		}
		return null;
	};
	cr.type_getBehaviorIndexByName = function (behname)
	{
		var b = this.getBehaviorByName(behname);
		if (b)
			return this.extra.lastBehIndex;
		else
			return -1;
	};
	cr.type_getEffectIndexByName = function (name_)
	{
		var i, len;
		for (i = 0, len = this.effect_types.length; i < len; i++)
		{
			if (this.effect_types[i].name === name_)
				return i;
		}
		return -1;
	};
	cr.type_applySolToContainer = function ()
	{
		if (!this.is_contained || this.is_family)
			return;
		var i, len, j, lenj, t, sol, sol2;
		this.updateIIDs();
		sol = this.getCurrentSol();
		var select_all = sol.select_all;
		var es = this.runtime.getCurrentEventStack();
		var orblock = es && es.current_event && es.current_event.orblock;
		for (i = 0, len = this.container.length; i < len; i++)
		{
			t = this.container[i];
			if (t === this)
				continue;
			t.updateIIDs();
			sol2 = t.getCurrentSol();
			sol2.select_all = select_all;
			if (!select_all)
			{
				sol2.instances.length = sol.instances.length;
				for (j = 0, lenj = sol.instances.length; j < lenj; j++)
					sol2.instances[j] = t.getInstanceByIID(sol.instances[j].iid);
				if (orblock)
				{
					sol2.else_instances.length = sol.else_instances.length;
					for (j = 0, lenj = sol.else_instances.length; j < lenj; j++)
						sol2.else_instances[j] = t.getInstanceByIID(sol.else_instances[j].iid);
				}
			}
		}
	};
	cr.type_toString = function ()
	{
		return "Type" + this.sid;
	};
	cr.do_cmp = function (x, cmp, y)
	{
		if (typeof x === "undefined" || typeof y === "undefined")
			return false;
		switch (cmp)
		{
			case 0:     // equal
				return x === y;
			case 1:     // not equal
				return x !== y;
			case 2:     // less
				return x < y;
			case 3:     // less/equal
				return x <= y;
			case 4:     // greater
				return x > y;
			case 5:     // greater/equal
				return x >= y;
			default:
;
				return false;
		}
	};
})();
cr.shaders = {};
;
;
cr.plugins_.Browser = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Browser.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		window.addEventListener("resize", function () {
			self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnResize, self);
		});
		if (typeof navigator.onLine !== "undefined")
		{
			window.addEventListener("online", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOnline, self);
			});
			window.addEventListener("offline", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnOffline, self);
			});
		}
		if (typeof window.applicationCache !== "undefined")
		{
			window.applicationCache.addEventListener('updateready', function() {
				self.runtime.loadingprogress = 1;
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			window.applicationCache.addEventListener('progress', function(e) {
				self.runtime.loadingprogress = e["loaded"] / e["total"];
			});
		}
		if (!this.runtime.isDirectCanvas)
		{
			document.addEventListener("appMobi.device.update.available", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnUpdateReady, self);
			});
			document.addEventListener("backbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			});
			document.addEventListener("menubutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
			});
			document.addEventListener("searchbutton", function() {
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnSearchButton, self);
			});
			document.addEventListener("tizenhwkey", function (e) {
				var ret;
				switch (e["keyName"]) {
				case "back":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
					if (!ret)
					{
						if (window["tizen"])
							window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
					}
					break;
				case "menu":
					ret = self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnMenuButton, self);
					if (!ret)
						e.preventDefault();
					break;
				}
			});
		}
		if (this.runtime.isWindowsPhone81)
		{
			WinJS["Application"]["onbackclick"] = function (e)
			{
				return !!self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnBackButton, self);
			};
		}
		this.runtime.addSuspendCallback(function(s) {
			if (s)
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageHidden, self);
			}
			else
			{
				self.runtime.trigger(cr.plugins_.Browser.prototype.cnds.OnPageVisible, self);
			}
		});
		this.is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	};
	function Cnds() {};
	Cnds.prototype.CookiesEnabled = function()
	{
		return navigator ? navigator.cookieEnabled : false;
	};
	Cnds.prototype.IsOnline = function()
	{
		return navigator ? navigator.onLine : false;
	};
	Cnds.prototype.HasJava = function()
	{
		return navigator ? navigator.javaEnabled() : false;
	};
	Cnds.prototype.OnOnline = function()
	{
		return true;
	};
	Cnds.prototype.OnOffline = function()
	{
		return true;
	};
	Cnds.prototype.IsDownloadingUpdate = function ()
	{
		if (typeof window["applicationCache"] === "undefined")
			return false;
		else
			return window["applicationCache"]["status"] === window["applicationCache"]["DOWNLOADING"];
	};
	Cnds.prototype.OnUpdateReady = function ()
	{
		return true;
	};
	Cnds.prototype.PageVisible = function ()
	{
		return !this.runtime.isSuspended;
	};
	Cnds.prototype.OnPageVisible = function ()
	{
		return true;
	};
	Cnds.prototype.OnPageHidden = function ()
	{
		return true;
	};
	Cnds.prototype.OnResize = function ()
	{
		return true;
	};
	Cnds.prototype.IsFullscreen = function ()
	{
		return !!(document["mozFullScreen"] || document["webkitIsFullScreen"] || document["fullScreen"] || this.runtime.isNodeFullscreen);
	};
	Cnds.prototype.OnBackButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnMenuButton = function ()
	{
		return true;
	};
	Cnds.prototype.OnSearchButton = function ()
	{
		return true;
	};
	Cnds.prototype.IsMetered = function ()
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			return false;
		return connection["metered"];
	};
	Cnds.prototype.IsCharging = function ()
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			return true;
		return battery["charging"];
	};
	Cnds.prototype.IsPortraitLandscape = function (p)
	{
		var current = (window.innerWidth <= window.innerHeight ? 0 : 1);
		return current === p;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Alert = function (msg)
	{
		if (!this.runtime.isDomFree)
			alert(msg.toString());
	};
	Acts.prototype.Close = function ()
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["forceToFinish"]();
		else if (window["tizen"])
			window["tizen"]["application"]["getCurrentApplication"]()["exit"]();
		else if (navigator["app"] && navigator["app"]["exitApp"])
			navigator["app"]["exitApp"]();
		else if (navigator["device"] && navigator["device"]["exitApp"])
			navigator["device"]["exitApp"]();
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.close();
	};
	Acts.prototype.Focus = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["focus"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.focus();
	};
	Acts.prototype.Blur = function ()
	{
		if (this.runtime.isNodeWebkit)
		{
			var win = window["nwgui"]["Window"]["get"]();
			win["blur"]();
		}
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.blur();
	};
	Acts.prototype.GoBack = function ()
	{
		if (navigator["app"] && navigator["app"]["backHistory"])
			navigator["app"]["backHistory"]();
		else if (!this.is_arcade && !this.runtime.isDomFree && window.back)
			window.back();
	};
	Acts.prototype.GoForward = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.forward)
			window.forward();
	};
	Acts.prototype.GoHome = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree && window.home)
			window.home();
	};
	Acts.prototype.GoToURL = function (url)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.location = url;
	};
	Acts.prototype.GoToURLWindow = function (url, tag)
	{
		if (this.runtime.isCocoonJs)
			CocoonJS["App"]["openURL"](url);
		else if (this.runtime.isEjecta)
			ejecta["openURL"](url);
		else if (this.runtime.isWinJS)
			Windows["System"]["Launcher"]["launchUriAsync"](new Windows["Foundation"]["Uri"](url));
		else if (navigator["app"] && navigator["app"]["loadUrl"])
			navigator["app"]["loadUrl"](url, { "openExternal": true });
		else if (!this.is_arcade && !this.runtime.isDomFree)
			window.open(url, tag);
	};
	Acts.prototype.Reload = function ()
	{
		if (!this.is_arcade && !this.runtime.isDomFree)
			window.location.reload();
	};
	var firstRequestFullscreen = true;
	var crruntime = null;
	function onFullscreenError()
	{
		if (typeof jQuery !== "undefined")
		{
			crruntime["setSize"](jQuery(window).width(), jQuery(window).height());
		}
	};
	Acts.prototype.RequestFullScreen = function (stretchmode)
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Requesting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (stretchmode >= 2)
			stretchmode += 1;
		if (stretchmode === 6)
			stretchmode = 2;
		if (this.runtime.isNodeWebkit)
		{
			if (!this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["enterFullscreen"]();
				this.runtime.isNodeFullscreen = true;
				this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			}
		}
		else
		{
			if (document["mozFullScreen"] || document["webkitIsFullScreen"] || !!document["msFullscreenElement"] || document["fullScreen"])
			{
				return;
			}
			this.runtime.fullscreen_scaling = (stretchmode >= 2 ? stretchmode : 0);
			var elem = this.runtime.canvasdiv || this.runtime.canvas;
			if (firstRequestFullscreen)
			{
				firstRequestFullscreen = false;
				crruntime = this.runtime;
				elem.addEventListener("mozfullscreenerror", onFullscreenError);
				elem.addEventListener("webkitfullscreenerror", onFullscreenError);
				elem.addEventListener("msfullscreenerror", onFullscreenError);
				elem.addEventListener("fullscreenerror", onFullscreenError);
			}
			if (!cr.is_undefined(elem["requestFullscreen"]))
				elem["requestFullscreen"]();
			else if (!cr.is_undefined(elem["webkitRequestFullScreen"]))
			{
				if (typeof Element !== "undefined" && typeof Element["ALLOW_KEYBOARD_INPUT"] !== "undefined")
					elem["webkitRequestFullScreen"](Element["ALLOW_KEYBOARD_INPUT"]);
				else
					elem["webkitRequestFullScreen"]();
			}
			else if (!cr.is_undefined(elem["mozRequestFullScreen"]))
				elem["mozRequestFullScreen"]();
			else if (!cr.is_undefined(elem["msRequestFullscreen"]))
				elem["msRequestFullscreen"]();
		}
	};
	Acts.prototype.CancelFullScreen = function ()
	{
		if (this.runtime.isDomFree)
		{
			cr.logexport("[Construct 2] Exiting fullscreen is not supported on this platform - the request has been ignored");
			return;
		}
		if (this.runtime.isNodeWebkit)
		{
			if (this.runtime.isNodeFullscreen)
			{
				window["nwgui"]["Window"]["get"]()["leaveFullscreen"]();
				this.runtime.isNodeFullscreen = false;
			}
		}
		else
		{
			if (!cr.is_undefined(document["exitFullscreen"]))
				document["exitFullscreen"]();
			else if (!cr.is_undefined(document["webkitCancelFullScreen"]))
				document["webkitCancelFullScreen"]();
			else if (!cr.is_undefined(document["mozCancelFullScreen"]))
				document["mozCancelFullScreen"]();
			else if (!cr.is_undefined(document["msExitFullscreen"]))
				document["msExitFullscreen"]();
		}
	};
	Acts.prototype.Vibrate = function (pattern_)
	{
		try {
			var arr = pattern_.split(",");
			var i, len;
			for (i = 0, len = arr.length; i < len; i++)
			{
				arr[i] = parseInt(arr[i], 10);
			}
			if (navigator["vibrate"])
				navigator["vibrate"](arr);
			else if (navigator["mozVibrate"])
				navigator["mozVibrate"](arr);
			else if (navigator["webkitVibrate"])
				navigator["webkitVibrate"](arr);
			else if (navigator["msVibrate"])
				navigator["msVibrate"](arr);
		}
		catch (e) {}
	};
	Acts.prototype.InvokeDownload = function (url_, filename_)
	{
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(url_);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = url_;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.InvokeDownloadString = function (str_, mimetype_, filename_)
	{
		var datauri = "data:" + mimetype_ + "," + encodeURIComponent(str_);
		var a = document.createElement("a");
		if (typeof a["download"] === "undefined")
		{
			window.open(datauri);
		}
		else
		{
			var body = document.getElementsByTagName("body")[0];
			a.textContent = filename_;
			a.href = datauri;
			a["download"] = filename_;
			body.appendChild(a);
			var clickEvent = document.createEvent("MouseEvent");
			clickEvent.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null);
			a.dispatchEvent(clickEvent);
			body.removeChild(a);
		}
	};
	Acts.prototype.ConsoleLog = function (type_, msg_)
	{
		if (typeof console === "undefined")
			return;
		if (type_ === 0 && console.log)
			console.log(msg_.toString());
		if (type_ === 1 && console.warn)
			console.warn(msg_.toString());
		if (type_ === 2 && console.error)
			console.error(msg_.toString());
	};
	Acts.prototype.ConsoleGroup = function (name_)
	{
		if (console && console.group)
			console.group(name_);
	};
	Acts.prototype.ConsoleGroupEnd = function ()
	{
		if (console && console.groupEnd)
			console.groupEnd();
	};
	Acts.prototype.ExecJs = function (js_)
	{
		if (eval)
			eval(js_);
	};
	var orientations = [
		"portrait",
		"landscape",
		"portrait-primary",
		"portrait-secondary",
		"landscape-primary",
		"landscape-secondary"
	];
	Acts.prototype.LockOrientation = function (o)
	{
		o = Math.floor(o);
		if (o < 0 || o >= orientations.length)
			return;
		this.runtime.autoLockOrientation = false;
		var orientation = orientations[o];
		if (screen["lockOrientation"])
			screen["lockOrientation"](orientation);
		else if (screen["webkitLockOrientation"])
			screen["webkitLockOrientation"](orientation);
		else if (screen["mozLockOrientation"])
			screen["mozLockOrientation"](orientation);
		else if (screen["msLockOrientation"])
			screen["msLockOrientation"](orientation);
	};
	Acts.prototype.UnlockOrientation = function ()
	{
		this.runtime.autoLockOrientation = false;
		if (screen["unlockOrientation"])
			screen["unlockOrientation"]();
		else if (screen["webkitUnlockOrientation"])
			screen["webkitUnlockOrientation"]();
		else if (screen["mozUnlockOrientation"])
			screen["mozUnlockOrientation"]();
		else if (screen["msUnlockOrientation"])
			screen["msUnlockOrientation"]();
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.URL = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.toString());
	};
	Exps.prototype.Protocol = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.protocol);
	};
	Exps.prototype.Domain = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hostname);
	};
	Exps.prototype.PathName = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.pathname);
	};
	Exps.prototype.Hash = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.hash);
	};
	Exps.prototype.Referrer = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.referrer);
	};
	Exps.prototype.Title = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : document.title);
	};
	Exps.prototype.Name = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appName);
	};
	Exps.prototype.Version = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.appVersion);
	};
	Exps.prototype.Language = function (ret)
	{
		if (navigator && navigator.language)
			ret.set_string(navigator.language);
		else
			ret.set_string("");
	};
	Exps.prototype.Platform = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.platform);
	};
	Exps.prototype.Product = function (ret)
	{
		if (navigator && navigator.product)
			ret.set_string(navigator.product);
		else
			ret.set_string("");
	};
	Exps.prototype.Vendor = function (ret)
	{
		if (navigator && navigator.vendor)
			ret.set_string(navigator.vendor);
		else
			ret.set_string("");
	};
	Exps.prototype.UserAgent = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : navigator.userAgent);
	};
	Exps.prototype.QueryString = function (ret)
	{
		ret.set_string(this.runtime.isDomFree ? "" : window.location.search);
	};
	Exps.prototype.QueryParam = function (ret, paramname)
	{
		if (this.runtime.isDomFree)
		{
			ret.set_string("");
			return;
		}
		var match = RegExp('[?&]' + paramname + '=([^&]*)').exec(window.location.search);
		if (match)
			ret.set_string(decodeURIComponent(match[1].replace(/\+/g, ' ')));
		else
			ret.set_string("");
	};
	Exps.prototype.Bandwidth = function (ret)
	{
		var connection = navigator["connection"] || navigator["mozConnection"] || navigator["webkitConnection"];
		if (!connection)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(connection["bandwidth"]);
	};
	Exps.prototype.BatteryLevel = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(1);
		else
			ret.set_float(battery["level"]);
	};
	Exps.prototype.BatteryTimeLeft = function (ret)
	{
		var battery = navigator["battery"] || navigator["mozBattery"] || navigator["webkitBattery"];
		if (!battery)
			ret.set_float(Number.POSITIVE_INFINITY);
		else
			ret.set_float(battery["dischargingTime"]);
	};
	Exps.prototype.ExecJS = function (ret, js_)
	{
		if (!eval)
		{
			ret.set_any(0);
			return;
		}
		var result = eval(js_);
		if (typeof result === "number")
			ret.set_any(result);
		else if (typeof result === "string")
			ret.set_any(result);
		else if (typeof result === "boolean")
			ret.set_any(result ? 1 : 0);
		else
			ret.set_any(0);
	};
	Exps.prototype.ScreenWidth = function (ret)
	{
		ret.set_int(screen.width);
	};
	Exps.prototype.ScreenHeight = function (ret)
	{
		ret.set_int(screen.height);
	};
	Exps.prototype.DevicePixelRatio = function (ret)
	{
		ret.set_float(this.runtime.devicePixelRatio);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.CJSAds = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var input_text = "";
	var products_list = [];
	var requested_score = 0;
	var bannerPosition = 0;
	var preloadingBanner = false;
	var bannerReady = false;
	var preloadingFullscreen = false;
	var fullscreenReady = false;
	var pluginProto = cr.plugins_.CJSAds.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.isShowingBanner = false;
		this.isShowingFullscreen = false;
		this.triggerProduct = "";
		this.socialService = null;
		this.socialServiceAvailable = false;
		this.storeServiceAvailable = (this.runtime.isCocoonJs && typeof CocoonJS["Store"]["nativeExtensionObjectAvailable"] !== "undefined");
		this.storeManaged = (this.properties[0] !== 1);
		this.storeSandboxed = (this.properties[1] !== 0);
		this.onConsumePurchaseFailedTransactionId = "";
		this.onConsumePurchaseCompleted = "";
		var self = this;
		if (this.runtime.isCocoonJs)
		{
			CocoonJS["App"]["onTextDialogFinished"].addEventListener(function(text) {
				input_text = text;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardOK, self);
			});
			CocoonJS["App"]["onTextDialogCancelled"].addEventListener(function() {
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnKeyboardCancelled, self);
			});
			CocoonJS["Ad"]["onBannerShown"].addEventListener(function ()
			{
				self.isShowingBanner = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnBannerShown, self);
			});
			CocoonJS["Ad"]["onBannerReady"].addEventListener(function ()
			{
				bannerReady = true;
				if (!preloadingBanner)
				{
					CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
					CocoonJS["Ad"]["showBanner"]();
				}
			});
			CocoonJS["Ad"]["onFullScreenShown"].addEventListener(function ()
			{
				self.isShowingFullscreen = true;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenShown, self);
			});
			CocoonJS["Ad"]["onFullScreenHidden"].addEventListener(function ()
			{
				self.isShowingFullscreen = false;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnFullscreenHidden, self);
			});
			CocoonJS["Ad"]["onFullScreenReady"].addEventListener(function ()
			{
				fullscreenReady = true;
				if (!preloadFullScreen)
					CocoonJS["Ad"]["showFullScreen"]();
			});
			if (this.storeServiceAvailable)
			{
				CocoonJS["Store"]["onProductPurchaseCompleted"].addEventListener(function (purchase)
				{
					self.triggerProduct = purchase["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete, self);
					CocoonJS["Store"]["addPurchase"](purchase);
					CocoonJS["Store"]["consumePurchase"](purchase["transactionId"], purchase["productId"]);
					CocoonJS["Store"]["finishPurchase"](purchase["transactionId"]);
				});
				CocoonJS["Store"]["onConsumePurchaseFailed"].addEventListener(function(transactionId, errorMessage)
				{
					this.onConsumePurchaseFailedTransactionId = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseFailed, self);
				});
				CocoonJS["Store"]["onConsumePurchaseCompleted"].addEventListener(function(transactionId)
				{
					this.onConsumePurchaseCompleted = transactionId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onConsumePurchaseCompleted, self);
				});
				CocoonJS["Store"]["onProductPurchaseFailed"].addEventListener(function (productId, errorMsg)
				{
					self.triggerProduct = productId;
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail, self);
				});
				CocoonJS["Store"]["onProductPurchaseStarted"].addEventListener(function (productinfo)
				{
					self.triggerProduct = productinfo["productId"];
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnPurchaseStart, self);
				});
				CocoonJS["Store"]["onProductsFetchStarted"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchStarted, self);
				});
				CocoonJS["Store"]["onProductsFetchFailed"].addEventListener(function ()
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchFailed, self);
				});
				CocoonJS["Store"]["onProductsFetchCompleted"].addEventListener(function (products)
				{
					self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.onProductsFetchCompleted, self);
				});
				CocoonJS["Store"]["requestInitialization"]({
					"managed": this.storeManaged,
					"sandbox": this.storeSandboxed
				});
				CocoonJS["Store"]["start"]();
			}
			this.socialService = CocoonJS["SocialGaming"]["GameCenter"];
			this.socialServiceAvailable = !!this.socialService["nativeExtensionObjectAvailable"];
			this.socialService["onRequestLoginSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginSuccess, self);
			});
			this.socialService["onRequestLoginFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLoginFail, self);
			});
			this.socialService["onLogout"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLogout, self);
			});
			this.socialService["onRequestUserScoreSucceed"].addEventListener(function (userInfo) {
				requested_score = userInfo["score"] || 0;
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreReceived, self);
			});
			this.socialService["onRequestUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreUnavailable, self);
			});
			this.socialService["onSubmitUserScoreSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitSuccess, self);
			});
			this.socialService["onSubmitUserScoreFailed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCScoreSubmitFail, self);
			});
			this.socialService["onLeaderboardViewSucceed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardOpen, self);
			});
			this.socialService["onLeaderboardViewClosed"].addEventListener(function () {
				self.runtime.trigger(cr.plugins_.CJSAds.prototype.cnds.OnGCLeaderboardClose, self);
			});
		}
	};
	function Cnds() {};
	Cnds.prototype.IsShowingBanner = function ()
	{
		return this.isShowingBanner;
	};
	Cnds.prototype.IsCocoonJS = function ()
	{
		return this.runtime.isCocoonJs;
	};
	Cnds.prototype.OnBannerShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenShown = function ()
	{
		return true;
	};
	Cnds.prototype.OnFullscreenHidden = function ()
	{
		return true;
	};
	Cnds.prototype.IsShowingFullscreen = function ()
	{
		return this.isShowingFullscreen;
	};
	Cnds.prototype.IsStoreAvailable = function ()
	{
		if (this.runtime.isCocoonJs)
			return this.storeServiceAvailable && CocoonJS["Store"]["canPurchase"]();
		else
			return false;
	};
	Cnds.prototype.OnPurchaseStart = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseComplete = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.OnPurchaseFail = function (productid)
	{
		return this.triggerProduct === productid;
	};
	Cnds.prototype.onProductsFetchStarted = function(){
		return true;
	}
	Cnds.prototype.onConsumePurchaseFailed = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchCompleted = function(){
		return true;
	}
	Cnds.prototype.onProductsFetchFailed = function(){
		return true;
	}
	Cnds.prototype.IsProductPurchased = function (productid)
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["isProductPurchased"](productid);
		else
			return false;
	};
	Cnds.prototype.OnKeyboardCancelled = function ()
	{
		return true;
	};
	Cnds.prototype.OnKeyboardOK = function ()
	{
		return true;
	};
	Cnds.prototype.IsGCAvailable = function ()
	{
		return this.socialServiceAvailable;
	};
	Cnds.prototype.IsGCLoggedIn = function ()
	{
		if (!this.socialServiceAvailable)
			return false;
		return this.socialService["isLoggedIn"]();
	};
	Cnds.prototype.OnGCLoginSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLoginFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLogout = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreReceived = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreUnavailable = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCScoreSubmitFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardOpen = function ()
	{
		return true;
	};
	Cnds.prototype.OnGCLeaderboardClose = function ()
	{
		return true;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.ShowBanner = function (layout_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		bannerPosition = (layout_ === 0 ? CocoonJS["Ad"]["BannerLayout"]["TOP_CENTER"] : CocoonJS["Ad"]["BannerLayout"]["BOTTOM_CENTER"]);
		preloadingBanner = false;
		if (bannerReady)
		{
			CocoonJS["Ad"]["setBannerLayout"](bannerPosition);
			CocoonJS["Ad"]["showBanner"]();
		}
		else
		{
			CocoonJS["Ad"]["preloadBanner"]();
		}
	};
	Acts.prototype.ShowFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = false;
		if (fullscreenReady)
			CocoonJS["Ad"]["showFullScreen"]();
		else
			CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.HideBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["hideBanner"]();
		this.isShowingBanner = false;
	};
	Acts.prototype.PreloadBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingBanner = true;
		CocoonJS["Ad"]["preloadBanner"]();
	};
	Acts.prototype.PreloadFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		preloadingFullscreen = true;
		CocoonJS["Ad"]["preloadFullScreen"]();
	};
	Acts.prototype.RefreshBanner = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshBanner"]();
	};
	Acts.prototype.RefreshFullscreen = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Ad"]["refreshFullScreen"]();
	};
	Acts.prototype.Purchase = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProduct"](productid);
	};
	Acts.prototype.fetchProductsFromStore = function (products)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["fetchProductsFromStore"](products.split(","));
	};
	Acts.prototype.restorePurchases = function ()
	{
		if (this.runtime.isCocoonJs)
			return CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PurchasePreview = function (productid)
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["purchaseProductModalWithPreview"](productid);
	};
	Acts.prototype.RestorePurchases = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		CocoonJS["Store"]["restorePurchases"]();
	};
	Acts.prototype.PromptKeyboard = function (title_, message_, initial_, type_, canceltext_, oktext_)
	{
		if (!this.runtime.isCocoonJs)
			return;
		var typestr = ["text", "num", "phone", "email", "url"][type_];
		CocoonJS["App"]["showTextDialog"](title_, message_, initial_, typestr, canceltext_, oktext_);
	};
	Acts.prototype.UpdateProductsList = function ()
	{
		if (!this.runtime.isCocoonJs)
			return;
		if (!CocoonJS["Store"]["canPurchase"]())
			return;
		products_list = CocoonJS["Store"]["getProducts"]();
	};
	Acts.prototype.GCLogin = function ()
	{
		if (!this.socialServiceAvailable || this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogin"]();
	};
	Acts.prototype.GCLogout = function ()
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestLogout"]();
	};
	Acts.prototype.GCSubmitScore = function (score_, leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["submitUserScore"](score_, leaderboard_);
	};
	Acts.prototype.GCRequestScore = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["requestUserScore"](leaderboard_);
	};
	Acts.prototype.GCOpenLeaderboard = function (leaderboard_)
	{
		if (!this.socialServiceAvailable || !this.socialService["isLoggedIn"]())
			return;
		this.socialService["showLeaderboardView"](leaderboard_);
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.InputText = function (ret)
	{
		ret.set_string(input_text);
	};
	Exps.prototype.ProductCount = function (ret)
	{
		ret.set_int(products_list.length);
	};
	Exps.prototype.ProductDescription = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["description"]);
	};
	Exps.prototype.ProductLocalizedPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["localizedPrice"]);
	};
	Exps.prototype.ProductPrice = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["price"]);
	};
	Exps.prototype.ProductAlias = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productAlias"]);
	};
	Exps.prototype.ProductID = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["productId"]);
	};
	Exps.prototype.ProductTitle = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= products_list.length)
		{
			ret.set_string("");
			return;
		}
		ret.set_string(products_list[index]["title"]);
	};
	Exps.prototype.GameCenterScore = function (ret)
	{
		ret.set_float(requested_score);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Mouse = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Mouse.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.buttonMap = new Array(4);		// mouse down states
		this.mouseXcanvas = 0;				// mouse position relative to canvas
		this.mouseYcanvas = 0;
		this.triggerButton = 0;
		this.triggerType = 0;
		this.triggerDir = 0;
		this.handled = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		var self = this;
		if (!this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
			jQuery(document).dblclick(
				function(info) {
					self.onDoubleClick(info);
				}
			);
			var wheelevent = function(info) {
								self.onWheel(info);
							};
			document.addEventListener("mousewheel", wheelevent, false);
			document.addEventListener("DOMMouseScroll", wheelevent, false);
		}
	};
	var dummyoffset = {left: 0, top: 0};
	instanceProto.onMouseMove = function(info)
	{
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		this.mouseXcanvas = info.pageX - offset.left;
		this.mouseYcanvas = info.pageY - offset.top;
	};
	instanceProto.mouseInGame = function ()
	{
		if (this.runtime.fullscreen_mode > 0)
			return true;
		return this.mouseXcanvas >= 0 && this.mouseYcanvas >= 0
		    && this.mouseXcanvas < this.runtime.width && this.mouseYcanvas < this.runtime.height;
	};
	instanceProto.onMouseDown = function(info)
	{
		if (!this.mouseInGame())
			return;
		if (this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.buttonMap[info.which] = true;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnAnyClick, this);
		this.triggerButton = info.which - 1;	// 1-based
		this.triggerType = 0;					// single click
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick, this);
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onMouseUp = function(info)
	{
		if (!this.buttonMap[info.which])
			return;
		if (this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		this.buttonMap[info.which] = false;
		this.runtime.isInUserInputEvent = true;
		this.triggerButton = info.which - 1;	// 1-based
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnRelease, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onDoubleClick = function(info)
	{
		if (!this.mouseInGame())
			return;
		info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		this.triggerButton = info.which - 1;	// 1-based
		this.triggerType = 1;					// double click
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnClick, this);
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnObjectClicked, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onWheel = function (info)
	{
		var delta = info.wheelDelta ? info.wheelDelta : info.detail ? -info.detail : 0;
		this.triggerDir = (delta < 0 ? 0 : 1);
		this.handled = false;
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Mouse.prototype.cnds.OnWheel, this);
		this.runtime.isInUserInputEvent = false;
		if (this.handled)
			info.preventDefault();
	};
	function Cnds() {};
	Cnds.prototype.OnClick = function (button, type)
	{
		return button === this.triggerButton && type === this.triggerType;
	};
	Cnds.prototype.OnAnyClick = function ()
	{
		return true;
	};
	Cnds.prototype.IsButtonDown = function (button)
	{
		return this.buttonMap[button + 1];	// jQuery uses 1-based buttons for some reason
	};
	Cnds.prototype.OnRelease = function (button)
	{
		return button === this.triggerButton;
	};
	Cnds.prototype.IsOverObject = function (obj)
	{
		var cnd = this.runtime.getCurrentCondition();
		var mx = this.mouseXcanvas;
		var my = this.mouseYcanvas;
		return cr.xor(this.runtime.testAndSelectCanvasPointOverlap(obj, mx, my, cnd.inverted), cnd.inverted);
	};
	Cnds.prototype.OnObjectClicked = function (button, type, obj)
	{
		if (button !== this.triggerButton || type !== this.triggerType)
			return false;	// wrong click type
		return this.runtime.testAndSelectCanvasPointOverlap(obj, this.mouseXcanvas, this.mouseYcanvas, false);
	};
	Cnds.prototype.OnWheel = function (dir)
	{
		this.handled = true;
		return dir === this.triggerDir;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetCursor = function (c)
	{
		var cursor_style = ["auto", "pointer", "text", "crosshair", "move", "help", "wait", "none"][c];
		if (this.runtime.canvas && this.runtime.canvas.style)
			this.runtime.canvas.style.cursor = cursor_style;
	};
	Acts.prototype.SetCursorSprite = function (obj)
	{
		if (this.runtime.isDomFree || this.runtime.isMobile || !obj)
			return;
		var inst = obj.getFirstPicked();
		if (!inst || !inst.curFrame)
			return;
		var frame = inst.curFrame;
		var datauri = frame.getDataUri();
		var cursor_style = "url(" + datauri + ") " + Math.round(frame.hotspotX * frame.width) + " " + Math.round(frame.hotspotY * frame.height) + ", auto";
		jQuery(this.runtime.canvas).css("cursor", cursor_style);
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.X = function (ret, layerparam)
	{
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.mouseXcanvas, this.mouseYcanvas, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		ret.set_float(this.mouseXcanvas);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		ret.set_float(this.mouseYcanvas);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Sprite = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Sprite.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	function frame_getDataUri()
	{
		if (this.datauri.length === 0)
		{
			var tmpcanvas = document.createElement("canvas");
			tmpcanvas.width = this.width;
			tmpcanvas.height = this.height;
			var tmpctx = tmpcanvas.getContext("2d");
			if (this.spritesheeted)
			{
				tmpctx.drawImage(this.texture_img, this.offx, this.offy, this.width, this.height,
										 0, 0, this.width, this.height);
			}
			else
			{
				tmpctx.drawImage(this.texture_img, 0, 0, this.width, this.height);
			}
			this.datauri = tmpcanvas.toDataURL("image/png");
		}
		return this.datauri;
	};
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		var i, leni, j, lenj;
		var anim, frame, animobj, frameobj, wt, uv;
		this.all_frames = [];
		this.has_loaded_textures = false;
		for (i = 0, leni = this.animations.length; i < leni; i++)
		{
			anim = this.animations[i];
			animobj = {};
			animobj.name = anim[0];
			animobj.speed = anim[1];
			animobj.loop = anim[2];
			animobj.repeatcount = anim[3];
			animobj.repeatto = anim[4];
			animobj.pingpong = anim[5];
			animobj.sid = anim[6];
			animobj.frames = [];
			for (j = 0, lenj = anim[7].length; j < lenj; j++)
			{
				frame = anim[7][j];
				frameobj = {};
				frameobj.texture_file = frame[0];
				frameobj.texture_filesize = frame[1];
				frameobj.offx = frame[2];
				frameobj.offy = frame[3];
				frameobj.width = frame[4];
				frameobj.height = frame[5];
				frameobj.duration = frame[6];
				frameobj.hotspotX = frame[7];
				frameobj.hotspotY = frame[8];
				frameobj.image_points = frame[9];
				frameobj.poly_pts = frame[10];
				frameobj.pixelformat = frame[11];
				frameobj.spritesheeted = (frameobj.width !== 0);
				frameobj.datauri = "";		// generated on demand and cached
				frameobj.getDataUri = frame_getDataUri;
				uv = {};
				uv.left = 0;
				uv.top = 0;
				uv.right = 1;
				uv.bottom = 1;
				frameobj.sheetTex = uv;
				frameobj.webGL_texture = null;
				wt = this.runtime.findWaitingTexture(frame[0]);
				if (wt)
				{
					frameobj.texture_img = wt;
				}
				else
				{
					frameobj.texture_img = new Image();
					frameobj.texture_img["idtkLoadDisposed"] = true;
					frameobj.texture_img.src = frame[0];
					frameobj.texture_img.cr_src = frame[0];
					frameobj.texture_img.cr_filesize = frame[1];
					frameobj.texture_img.c2webGL_texture = null;
					this.runtime.waitForImageLoad(frameobj.texture_img);
				}
				cr.seal(frameobj);
				animobj.frames.push(frameobj);
				this.all_frames.push(frameobj);
			}
			cr.seal(animobj);
			this.animations[i] = animobj;		// swap array data for object
		}
	};
	typeProto.updateAllCurrentTexture = function ()
	{
		var i, len, inst;
		for (i = 0, len = this.instances.length; i < len; i++)
		{
			inst = this.instances[i];
			inst.curWebGLTexture = inst.curFrame.webGL_texture;
		}
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.texture_img.c2webGL_texture = null;
			frame.webGL_texture = null;
		}
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.updateAllCurrentTexture();
	};
	typeProto.loadTextures = function ()
	{
		if (this.is_family || this.has_loaded_textures || !this.runtime.glwrap)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			frame.webGL_texture = this.runtime.glwrap.loadTexture(frame.texture_img, false, this.runtime.linearSampling, frame.pixelformat);
		}
		this.has_loaded_textures = true;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.has_loaded_textures)
			return;
		var i, len, frame;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frame = this.all_frames[i];
			this.runtime.glwrap.deleteTexture(frame.webGL_texture);
			frame.webGL_texture = null;
		}
		this.has_loaded_textures = false;
	};
	var already_drawn_images = [];
	typeProto.preloadCanvas2D = function (ctx)
	{
		var i, len, frameimg;
		already_drawn_images.length = 0;
		for (i = 0, len = this.all_frames.length; i < len; ++i)
		{
			frameimg = this.all_frames[i].texture_img;
			if (already_drawn_images.indexOf(frameimg) !== -1)
					continue;
			ctx.drawImage(frameimg, 0, 0);
			already_drawn_images.push(frameimg);
		}
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		var poly_pts = this.type.animations[0].frames[0].poly_pts;
		if (this.recycled)
			this.collision_poly.set_pts(poly_pts);
		else
			this.collision_poly = new cr.CollisionPoly(poly_pts);
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);	// 0=visible, 1=invisible
		this.isTicking = false;
		this.inAnimTrigger = false;
		this.collisionsEnabled = (this.properties[3] !== 0);
		if (!(this.type.animations.length === 1 && this.type.animations[0].frames.length === 1) && this.type.animations[0].speed !== 0)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		this.cur_animation = this.getAnimationByName(this.properties[1]) || this.type.animations[0];
		this.cur_frame = this.properties[2];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		var curanimframe = this.cur_animation.frames[this.cur_frame];
		this.collision_poly.set_pts(curanimframe.poly_pts);
		this.hotspotX = curanimframe.hotspotX;
		this.hotspotY = curanimframe.hotspotY;
		this.cur_anim_speed = this.cur_animation.speed;
		if (this.recycled)
			this.animTimer.reset();
		else
			this.animTimer = new cr.KahanAdder();
		this.frameStart = this.getNowTime();
		this.animPlaying = true;
		this.animRepeats = 0;
		this.animForwards = true;
		this.animTriggerName = "";
		this.changeAnimName = "";
		this.changeAnimFrom = 0;
		this.changeAnimFrame = -1;
		this.type.loadTextures();
		var i, leni, j, lenj;
		var anim, frame, uv, maintex;
		for (i = 0, leni = this.type.animations.length; i < leni; i++)
		{
			anim = this.type.animations[i];
			for (j = 0, lenj = anim.frames.length; j < lenj; j++)
			{
				frame = anim.frames[j];
				if (frame.width === 0)
				{
					frame.width = frame.texture_img.width;
					frame.height = frame.texture_img.height;
				}
				if (frame.spritesheeted)
				{
					maintex = frame.texture_img;
					uv = frame.sheetTex;
					uv.left = frame.offx / maintex.width;
					uv.top = frame.offy / maintex.height;
					uv.right = (frame.offx + frame.width) / maintex.width;
					uv.bottom = (frame.offy + frame.height) / maintex.height;
					if (frame.offx === 0 && frame.offy === 0 && frame.width === maintex.width && frame.height === maintex.height)
					{
						frame.spritesheeted = false;
					}
				}
			}
		}
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
	};
	instanceProto.saveToJSON = function ()
	{
		var o = {
			"a": this.cur_animation.sid,
			"f": this.cur_frame,
			"cas": this.cur_anim_speed,
			"fs": this.frameStart,
			"ar": this.animRepeats,
			"at": this.animTimer.sum
		};
		if (!this.animPlaying)
			o["ap"] = this.animPlaying;
		if (!this.animForwards)
			o["af"] = this.animForwards;
		return o;
	};
	instanceProto.loadFromJSON = function (o)
	{
		var anim = this.getAnimationBySid(o["a"]);
		if (anim)
			this.cur_animation = anim;
		this.cur_frame = o["f"];
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		this.cur_anim_speed = o["cas"];
		this.frameStart = o["fs"];
		this.animRepeats = o["ar"];
		this.animTimer.reset();
		this.animTimer.sum = o["at"];
		this.animPlaying = o.hasOwnProperty("ap") ? o["ap"] : true;
		this.animForwards = o.hasOwnProperty("af") ? o["af"] : true;
		this.curFrame = this.cur_animation.frames[this.cur_frame];
		this.curWebGLTexture = this.curFrame.webGL_texture;
		this.collision_poly.set_pts(this.curFrame.poly_pts);
		this.hotspotX = this.curFrame.hotspotX;
		this.hotspotY = this.curFrame.hotspotY;
	};
	instanceProto.animationFinish = function (reverse)
	{
		this.cur_frame = reverse ? 0 : this.cur_animation.frames.length - 1;
		this.animPlaying = false;
		this.animTriggerName = this.cur_animation.name;
		this.inAnimTrigger = true;
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnyAnimFinished, this);
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnAnimFinished, this);
		this.inAnimTrigger = false;
		this.animRepeats = 0;
	};
	instanceProto.getNowTime = function()
	{
		return this.animTimer.sum;
	};
	instanceProto.tick = function()
	{
		this.animTimer.add(this.runtime.getDt(this));
		if (this.changeAnimName.length)
			this.doChangeAnim();
		if (this.changeAnimFrame >= 0)
			this.doChangeAnimFrame();
		var now = this.getNowTime();
		var cur_animation = this.cur_animation;
		var prev_frame = cur_animation.frames[this.cur_frame];
		var next_frame;
		var cur_frame_time = prev_frame.duration / this.cur_anim_speed;
		if (this.animPlaying && now >= this.frameStart + cur_frame_time)
		{
			if (this.animForwards)
			{
				this.cur_frame++;
			}
			else
			{
				this.cur_frame--;
			}
			this.frameStart += cur_frame_time;
			if (this.cur_frame >= cur_animation.frames.length)
			{
				if (cur_animation.pingpong)
				{
					this.animForwards = false;
					this.cur_frame = cur_animation.frames.length - 2;
				}
				else if (cur_animation.loop)
				{
					this.cur_frame = cur_animation.repeatto;
				}
				else
				{
					this.animRepeats++;
					if (this.animRepeats >= cur_animation.repeatcount)
					{
						this.animationFinish(false);
					}
					else
					{
						this.cur_frame = cur_animation.repeatto;
					}
				}
			}
			if (this.cur_frame < 0)
			{
				if (cur_animation.pingpong)
				{
					this.cur_frame = 1;
					this.animForwards = true;
					if (!cur_animation.loop)
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
					}
				}
				else
				{
					if (cur_animation.loop)
					{
						this.cur_frame = cur_animation.repeatto;
					}
					else
					{
						this.animRepeats++;
						if (this.animRepeats >= cur_animation.repeatcount)
						{
							this.animationFinish(true);
						}
						else
						{
							this.cur_frame = cur_animation.repeatto;
						}
					}
				}
			}
			if (this.cur_frame < 0)
				this.cur_frame = 0;
			else if (this.cur_frame >= cur_animation.frames.length)
				this.cur_frame = cur_animation.frames.length - 1;
			if (now > this.frameStart + (cur_animation.frames[this.cur_frame].duration / this.cur_anim_speed))
			{
				this.frameStart = now;
			}
			next_frame = cur_animation.frames[this.cur_frame];
			this.OnFrameChanged(prev_frame, next_frame);
			this.runtime.redraw = true;
		}
	};
	instanceProto.getAnimationByName = function (name_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (cr.equals_nocase(a.name, name_))
				return a;
		}
		return null;
	};
	instanceProto.getAnimationBySid = function (sid_)
	{
		var i, len, a;
		for (i = 0, len = this.type.animations.length; i < len; i++)
		{
			a = this.type.animations[i];
			if (a.sid === sid_)
				return a;
		}
		return null;
	};
	instanceProto.doChangeAnim = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var anim = this.getAnimationByName(this.changeAnimName);
		this.changeAnimName = "";
		if (!anim)
			return;
		if (cr.equals_nocase(anim.name, this.cur_animation.name) && this.animPlaying)
			return;
		this.cur_animation = anim;
		this.cur_anim_speed = anim.speed;
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (this.changeAnimFrom === 1)
			this.cur_frame = 0;
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		this.animForwards = true;
		this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
		this.runtime.redraw = true;
	};
	instanceProto.doChangeAnimFrame = function ()
	{
		var prev_frame = this.cur_animation.frames[this.cur_frame];
		var prev_frame_number = this.cur_frame;
		this.cur_frame = cr.floor(this.changeAnimFrame);
		if (this.cur_frame < 0)
			this.cur_frame = 0;
		if (this.cur_frame >= this.cur_animation.frames.length)
			this.cur_frame = this.cur_animation.frames.length - 1;
		if (prev_frame_number !== this.cur_frame)
		{
			this.OnFrameChanged(prev_frame, this.cur_animation.frames[this.cur_frame]);
			this.frameStart = this.getNowTime();
			this.runtime.redraw = true;
		}
		this.changeAnimFrame = -1;
	};
	instanceProto.OnFrameChanged = function (prev_frame, next_frame)
	{
		var oldw = prev_frame.width;
		var oldh = prev_frame.height;
		var neww = next_frame.width;
		var newh = next_frame.height;
		if (oldw != neww)
			this.width *= (neww / oldw);
		if (oldh != newh)
			this.height *= (newh / oldh);
		this.hotspotX = next_frame.hotspotX;
		this.hotspotY = next_frame.hotspotY;
		this.collision_poly.set_pts(next_frame.poly_pts);
		this.set_bbox_changed();
		this.curFrame = next_frame;
		this.curWebGLTexture = next_frame.webGL_texture;
		var i, len, b;
		for (i = 0, len = this.behavior_insts.length; i < len; i++)
		{
			b = this.behavior_insts[i];
			if (b.onSpriteFrameChanged)
				b.onSpriteFrameChanged(prev_frame, next_frame);
		}
		this.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnFrameChanged, this);
	};
	instanceProto.draw = function(ctx)
	{
		ctx.globalAlpha = this.opacity;
		var cur_frame = this.curFrame;
		var spritesheeted = cur_frame.spritesheeted;
		var cur_image = cur_frame.texture_img;
		var myx = this.x;
		var myy = this.y;
		var w = this.width;
		var h = this.height;
		if (this.angle === 0 && w >= 0 && h >= 0)
		{
			myx -= this.hotspotX * w;
			myy -= this.hotspotY * h;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 myx, myy, w, h);
			}
			else
			{
				ctx.drawImage(cur_image, myx, myy, w, h);
			}
		}
		else
		{
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			var widthfactor = w > 0 ? 1 : -1;
			var heightfactor = h > 0 ? 1 : -1;
			ctx.translate(myx, myy);
			if (widthfactor !== 1 || heightfactor !== 1)
				ctx.scale(widthfactor, heightfactor);
			ctx.rotate(this.angle * widthfactor * heightfactor);
			var drawx = 0 - (this.hotspotX * cr.abs(w))
			var drawy = 0 - (this.hotspotY * cr.abs(h));
			if (spritesheeted)
			{
				ctx.drawImage(cur_image, cur_frame.offx, cur_frame.offy, cur_frame.width, cur_frame.height,
										 drawx, drawy, cr.abs(w), cr.abs(h));
			}
			else
			{
				ctx.drawImage(cur_image, drawx, drawy, cr.abs(w), cr.abs(h));
			}
			ctx.restore();
		}
		/*
		ctx.strokeStyle = "#f00";
		ctx.lineWidth = 3;
		ctx.beginPath();
		this.collision_poly.cache_poly(this.width, this.height, this.angle);
		var i, len, ax, ay, bx, by;
		for (i = 0, len = this.collision_poly.pts_count; i < len; i++)
		{
			ax = this.collision_poly.pts_cache[i*2] + this.x;
			ay = this.collision_poly.pts_cache[i*2+1] + this.y;
			bx = this.collision_poly.pts_cache[((i+1)%len)*2] + this.x;
			by = this.collision_poly.pts_cache[((i+1)%len)*2+1] + this.y;
			ctx.moveTo(ax, ay);
			ctx.lineTo(bx, by);
		}
		ctx.stroke();
		ctx.closePath();
		*/
		/*
		if (this.behavior_insts.length >= 1 && this.behavior_insts[0].draw)
		{
			this.behavior_insts[0].draw(ctx);
		}
		*/
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.curWebGLTexture);
		glw.setOpacity(this.opacity);
		var cur_frame = this.curFrame;
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = ((this.x + 0.5) | 0) - this.x;
			var oy = ((this.y + 0.5) | 0) - this.y;
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy, cur_frame.sheetTex);
			else
				glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
		{
			if (cur_frame.spritesheeted)
				glw.quadTex(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly, cur_frame.sheetTex);
			else
				glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
		}
	};
	instanceProto.getImagePointIndexByName = function(name_)
	{
		var cur_frame = this.curFrame;
		var i, len;
		for (i = 0, len = cur_frame.image_points.length; i < len; i++)
		{
			if (cr.equals_nocase(name_, cur_frame.image_points[i][0]))
				return i;
		}
		return -1;
	};
	instanceProto.getImagePoint = function(imgpt, getX)
	{
		var cur_frame = this.curFrame;
		var image_points = cur_frame.image_points;
		var index;
		if (cr.is_string(imgpt))
			index = this.getImagePointIndexByName(imgpt);
		else
			index = imgpt - 1;	// 0 is origin
		index = cr.floor(index);
		if (index < 0 || index >= image_points.length)
			return getX ? this.x : this.y;	// return origin
		var x = (image_points[index][1] - cur_frame.hotspotX) * this.width;
		var y = image_points[index][2];
		y = (y - cur_frame.hotspotY) * this.height;
		var cosa = Math.cos(this.angle);
		var sina = Math.sin(this.angle);
		var x_temp = (x * cosa) - (y * sina);
		y = (y * cosa) + (x * sina);
		x = x_temp;
		x += this.x;
		y += this.y;
		return getX ? x : y;
	};
	function Cnds() {};
	var arrCache = [];
	function allocArr()
	{
		if (arrCache.length)
			return arrCache.pop();
		else
			return [0, 0, 0];
	};
	function freeArr(a)
	{
		a[0] = 0;
		a[1] = 0;
		a[2] = 0;
		arrCache.push(a);
	};
	function makeCollKey(a, b)
	{
		if (a < b)
			return "" + a + "," + b;
		else
			return "" + b + "," + a;
	};
	function collmemory_add(collmemory, a, b, tickcount)
	{
		var a_uid = a.uid;
		var b_uid = b.uid;
		var key = makeCollKey(a_uid, b_uid);
		if (collmemory.hasOwnProperty(key))
		{
			collmemory[key][2] = tickcount;
			return;
		}
		var arr = allocArr();
		arr[0] = a_uid;
		arr[1] = b_uid;
		arr[2] = tickcount;
		collmemory[key] = arr;
	};
	function collmemory_remove(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			freeArr(collmemory[key]);
			delete collmemory[key];
		}
	};
	function collmemory_removeInstance(collmemory, inst)
	{
		var uid = inst.uid;
		var p, entry;
		for (p in collmemory)
		{
			if (collmemory.hasOwnProperty(p))
			{
				entry = collmemory[p];
				if (entry[0] === uid || entry[1] === uid)
				{
					freeArr(collmemory[p]);
					delete collmemory[p];
				}
			}
		}
	};
	var last_coll_tickcount = -2;
	function collmemory_has(collmemory, a, b)
	{
		var key = makeCollKey(a.uid, b.uid);
		if (collmemory.hasOwnProperty(key))
		{
			last_coll_tickcount = collmemory[key][2];
			return true;
		}
		else
		{
			last_coll_tickcount = -2;
			return false;
		}
	};
	var candidates1 = [];
	Cnds.prototype.OnCollision = function (rtype)
	{
		if (!rtype)
			return false;
		var runtime = this.runtime;
		var cnd = runtime.getCurrentCondition();
		var ltype = cnd.type;
		if (!cnd.extra.collmemory)
		{
			cnd.extra.collmemory = {};
			runtime.addDestroyCallback((function (collmemory) {
				return function(inst) {
					collmemory_removeInstance(collmemory, inst);
				};
			})(cnd.extra.collmemory));
		}
		var collmemory = cnd.extra.collmemory;
		var lsol = ltype.getCurrentSol();
		var rsol = rtype.getCurrentSol();
		var linstances = lsol.getObjects();
		var rinstances;
		var l, linst, r, rinst;
		var curlsol, currsol;
		var tickcount = this.runtime.tickcount;
		var lasttickcount = tickcount - 1;
		var exists, run;
		var current_event = runtime.getCurrentEventStack().current_event;
		var orblock = current_event.orblock;
		for (l = 0; l < linstances.length; l++)
		{
			linst = linstances[l];
			if (rsol.select_all)
			{
				linst.update_bbox();
				this.runtime.getCollisionCandidates(linst.layer, rtype, linst.bbox, candidates1);
				rinstances = candidates1;
			}
			else
				rinstances = rsol.getObjects();
			for (r = 0; r < rinstances.length; r++)
			{
				rinst = rinstances[r];
				if (runtime.testOverlap(linst, rinst) || runtime.checkRegisteredCollision(linst, rinst))
				{
					exists = collmemory_has(collmemory, linst, rinst);
					run = (!exists || (last_coll_tickcount < lasttickcount));
					collmemory_add(collmemory, linst, rinst, tickcount);
					if (run)
					{
						runtime.pushCopySol(current_event.solModifiers);
						curlsol = ltype.getCurrentSol();
						currsol = rtype.getCurrentSol();
						curlsol.select_all = false;
						currsol.select_all = false;
						if (ltype === rtype)
						{
							curlsol.instances.length = 2;	// just use lsol, is same reference as rsol
							curlsol.instances[0] = linst;
							curlsol.instances[1] = rinst;
							ltype.applySolToContainer();
						}
						else
						{
							curlsol.instances.length = 1;
							currsol.instances.length = 1;
							curlsol.instances[0] = linst;
							currsol.instances[0] = rinst;
							ltype.applySolToContainer();
							rtype.applySolToContainer();
						}
						current_event.retrigger();
						runtime.popSol(current_event.solModifiers);
					}
				}
				else
				{
					collmemory_remove(collmemory, linst, rinst);
				}
			}
			candidates1.length = 0;
		}
		return false;
	};
	var rpicktype = null;
	var rtopick = new cr.ObjectSet();
	var needscollisionfinish = false;
	var candidates2 = [];
	function DoOverlapCondition(rtype, offx, offy)
	{
		if (!rtype)
			return false;
		var do_offset = (offx !== 0 || offy !== 0);
		var oldx, oldy, ret = false, r, lenr, rinst;
		var cnd = this.runtime.getCurrentCondition();
		var ltype = cnd.type;
		var inverted = cnd.inverted;
		var rsol = rtype.getCurrentSol();
		var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
		var rinstances;
		if (rsol.select_all)
		{
			this.update_bbox();
			this.runtime.getCollisionCandidates(this.layer, rtype, this.bbox, candidates2);
			rinstances = candidates2;
		}
		else if (orblock)
			rinstances = rsol.else_instances;
		else
			rinstances = rsol.instances;
		rpicktype = rtype;
		needscollisionfinish = (ltype !== rtype && !inverted);
		if (do_offset)
		{
			oldx = this.x;
			oldy = this.y;
			this.x += offx;
			this.y += offy;
			this.set_bbox_changed();
		}
		for (r = 0, lenr = rinstances.length; r < lenr; r++)
		{
			rinst = rinstances[r];
			if (this.runtime.testOverlap(this, rinst))
			{
				ret = true;
				if (inverted)
					break;
				if (ltype !== rtype)
					rtopick.add(rinst);
			}
		}
		if (do_offset)
		{
			this.x = oldx;
			this.y = oldy;
			this.set_bbox_changed();
		}
		candidates2.length = 0;
		return ret;
	};
	typeProto.finish = function (do_pick)
	{
		if (!needscollisionfinish)
			return;
		if (do_pick)
		{
			var orblock = this.runtime.getCurrentEventStack().current_event.orblock;
			var sol = rpicktype.getCurrentSol();
			var topick = rtopick.valuesRef();
			var i, len, inst;
			if (sol.select_all)
			{
				sol.select_all = false;
				sol.instances.length = topick.length;
				for (i = 0, len = topick.length; i < len; i++)
				{
					sol.instances[i] = topick[i];
				}
				if (orblock)
				{
					sol.else_instances.length = 0;
					for (i = 0, len = rpicktype.instances.length; i < len; i++)
					{
						inst = rpicktype.instances[i];
						if (!rtopick.contains(inst))
							sol.else_instances.push(inst);
					}
				}
			}
			else
			{
				if (orblock)
				{
					var initsize = sol.instances.length;
					sol.instances.length = initsize + topick.length;
					for (i = 0, len = topick.length; i < len; i++)
					{
						sol.instances[initsize + i] = topick[i];
						cr.arrayFindRemove(sol.else_instances, topick[i]);
					}
				}
				else
				{
					cr.shallowAssignArray(sol.instances, topick);
				}
			}
			rpicktype.applySolToContainer();
		}
		rtopick.clear();
		needscollisionfinish = false;
	};
	Cnds.prototype.IsOverlapping = function (rtype)
	{
		return DoOverlapCondition.call(this, rtype, 0, 0);
	};
	Cnds.prototype.IsOverlappingOffset = function (rtype, offx, offy)
	{
		return DoOverlapCondition.call(this, rtype, offx, offy);
	};
	Cnds.prototype.IsAnimPlaying = function (animname)
	{
		if (this.changeAnimName.length)
			return cr.equals_nocase(this.changeAnimName, animname);
		else
			return cr.equals_nocase(this.cur_animation.name, animname);
	};
	Cnds.prototype.CompareFrame = function (cmp, framenum)
	{
		return cr.do_cmp(this.cur_frame, cmp, framenum);
	};
	Cnds.prototype.CompareAnimSpeed = function (cmp, x)
	{
		var s = (this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
		return cr.do_cmp(s, cmp, x);
	};
	Cnds.prototype.OnAnimFinished = function (animname)
	{
		return cr.equals_nocase(this.animTriggerName, animname);
	};
	Cnds.prototype.OnAnyAnimFinished = function ()
	{
		return true;
	};
	Cnds.prototype.OnFrameChanged = function ()
	{
		return true;
	};
	Cnds.prototype.IsMirrored = function ()
	{
		return this.width < 0;
	};
	Cnds.prototype.IsFlipped = function ()
	{
		return this.height < 0;
	};
	Cnds.prototype.OnURLLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsCollisionEnabled = function ()
	{
		return this.collisionsEnabled;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.Spawn = function (obj, layer, imgpt)
	{
		if (!obj || !layer)
			return;
		var inst = this.runtime.createInstance(obj, layer, this.getImagePoint(imgpt, true), this.getImagePoint(imgpt, false));
		if (!inst)
			return;
		if (typeof inst.angle !== "undefined")
		{
			inst.angle = this.angle;
			inst.set_bbox_changed();
		}
		this.runtime.isInOnDestroy++;
		var i, len, s;
		this.runtime.trigger(Object.getPrototypeOf(obj.plugin).cnds.OnCreated, inst);
		if (inst.is_contained)
		{
			for (i = 0, len = inst.siblings.length; i < len; i++)
			{
				s = inst.siblings[i];
				this.runtime.trigger(Object.getPrototypeOf(s.type.plugin).cnds.OnCreated, s);
			}
		}
		this.runtime.isInOnDestroy--;
		var cur_act = this.runtime.getCurrentAction();
		var reset_sol = false;
		if (cr.is_undefined(cur_act.extra.Spawn_LastExec) || cur_act.extra.Spawn_LastExec < this.runtime.execcount)
		{
			reset_sol = true;
			cur_act.extra.Spawn_LastExec = this.runtime.execcount;
		}
		var sol;
		if (obj != this.type)
		{
			sol = obj.getCurrentSol();
			sol.select_all = false;
			if (reset_sol)
			{
				sol.instances.length = 1;
				sol.instances[0] = inst;
			}
			else
				sol.instances.push(inst);
			if (inst.is_contained)
			{
				for (i = 0, len = inst.siblings.length; i < len; i++)
				{
					s = inst.siblings[i];
					sol = s.type.getCurrentSol();
					sol.select_all = false;
					if (reset_sol)
					{
						sol.instances.length = 1;
						sol.instances[0] = s;
					}
					else
						sol.instances.push(s);
				}
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.StopAnim = function ()
	{
		this.animPlaying = false;
	};
	Acts.prototype.StartAnim = function (from)
	{
		this.animPlaying = true;
		this.frameStart = this.getNowTime();
		if (from === 1 && this.cur_frame !== 0)
		{
			this.changeAnimFrame = 0;
			if (!this.inAnimTrigger)
				this.doChangeAnimFrame();
		}
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetAnim = function (animname, from)
	{
		this.changeAnimName = animname;
		this.changeAnimFrom = from;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnim();
	};
	Acts.prototype.SetAnimFrame = function (framenumber)
	{
		this.changeAnimFrame = framenumber;
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
		if (!this.inAnimTrigger)
			this.doChangeAnimFrame();
	};
	Acts.prototype.SetAnimSpeed = function (s)
	{
		this.cur_anim_speed = cr.abs(s);
		this.animForwards = (s >= 0);
		if (!this.isTicking)
		{
			this.runtime.tickMe(this);
			this.isTicking = true;
		}
	};
	Acts.prototype.SetMirrored = function (m)
	{
		var neww = cr.abs(this.width) * (m === 0 ? -1 : 1);
		if (this.width === neww)
			return;
		this.width = neww;
		this.set_bbox_changed();
	};
	Acts.prototype.SetFlipped = function (f)
	{
		var newh = cr.abs(this.height) * (f === 0 ? -1 : 1);
		if (this.height === newh)
			return;
		this.height = newh;
		this.set_bbox_changed();
	};
	Acts.prototype.SetScale = function (s)
	{
		var cur_frame = this.curFrame;
		var mirror_factor = (this.width < 0 ? -1 : 1);
		var flip_factor = (this.height < 0 ? -1 : 1);
		var new_width = cur_frame.width * s * mirror_factor;
		var new_height = cur_frame.height * s * flip_factor;
		if (this.width !== new_width || this.height !== new_height)
		{
			this.width = new_width;
			this.height = new_height;
			this.set_bbox_changed();
		}
	};
	Acts.prototype.LoadURL = function (url_, resize_)
	{
		var img = new Image();
		var self = this;
		var curFrame_ = this.curFrame;
		img.onload = function ()
		{
			if (curFrame_.texture_img.src === img.src)
			{
				if (self.runtime.glwrap && self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.runtime.redraw = true;
				self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
				return;
			}
			curFrame_.texture_img = img;
			curFrame_.offx = 0;
			curFrame_.offy = 0;
			curFrame_.width = img.width;
			curFrame_.height = img.height;
			curFrame_.spritesheeted = false;
			curFrame_.datauri = "";
			if (self.runtime.glwrap)
			{
				if (curFrame_.webGL_texture)
					self.runtime.glwrap.deleteTexture(curFrame_.webGL_texture);
				curFrame_.webGL_texture = self.runtime.glwrap.loadTexture(img, false, self.runtime.linearSampling);
				if (self.curFrame === curFrame_)
					self.curWebGLTexture = curFrame_.webGL_texture;
				self.type.updateAllCurrentTexture();
			}
			if (resize_ === 0)		// resize to image size
			{
				self.width = img.width;
				self.height = img.height;
				self.set_bbox_changed();
			}
			self.runtime.redraw = true;
			self.runtime.trigger(cr.plugins_.Sprite.prototype.cnds.OnURLLoaded, self);
		};
		if (url_.substr(0, 5) !== "data:")
			img.crossOrigin = 'anonymous';
		img.src = url_;
	};
	Acts.prototype.SetCollisions = function (set_)
	{
		if (this.collisionsEnabled === (set_ !== 0))
			return;		// no change
		this.collisionsEnabled = (set_ !== 0);
		if (this.collisionsEnabled)
			this.set_bbox_changed();		// needs to be added back to cells
		else
		{
			if (this.collcells.right >= this.collcells.left)
				this.type.collision_grid.update(this, this.collcells, null);
			this.collcells.set(0, 0, -1, -1);
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.AnimationFrame = function (ret)
	{
		ret.set_int(this.cur_frame);
	};
	Exps.prototype.AnimationFrameCount = function (ret)
	{
		ret.set_int(this.cur_animation.frames.length);
	};
	Exps.prototype.AnimationName = function (ret)
	{
		ret.set_string(this.cur_animation.name);
	};
	Exps.prototype.AnimationSpeed = function (ret)
	{
		ret.set_float(this.animForwards ? this.cur_anim_speed : -this.cur_anim_speed);
	};
	Exps.prototype.ImagePointX = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, true));
	};
	Exps.prototype.ImagePointY = function (ret, imgpt)
	{
		ret.set_float(this.getImagePoint(imgpt, false));
	};
	Exps.prototype.ImagePointCount = function (ret)
	{
		ret.set_int(this.curFrame.image_points.length);
	};
	Exps.prototype.ImageWidth = function (ret)
	{
		ret.set_float(this.curFrame.width);
	};
	Exps.prototype.ImageHeight = function (ret)
	{
		ret.set_float(this.curFrame.height);
	};
	pluginProto.exps = new Exps();
}());
var SpriteFont = {};
;
;
cr.plugins_.SpriteFont = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.SpriteFont.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
    };
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		this.FontStrip = new Image();
		this.FontStrip.src = this.texture_file;
		this.FontStrip.cr_filesize = this.texture_filesize;
		this.runtime.wait_for_textures.push(this.FontStrip);
        this.webGL_texture = null;
		this.buffer = document.createElement('canvas');
		this.bufctx = this.buffer.getContext('2d');
		this.gl_rect = new cr.rect(0,0,1,1);
		this.gl_quad = new cr.quad();
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onCreate = function()
	{
		this.bCanvas = document.createElement('canvas'); // one buffer canvas per instance
		this.bctx = this.bCanvas.getContext('2d');
		this.compositeOp = cr.effectToCompositeOp(this.properties[14]);
		cr.setGLBlend(this, this.properties[14], this.runtime.gl);
        this.charSet = this.properties[2];
        this.text = this.properties[3];
        this.wrapMethod = this.properties[4]; // 0 = None, 1 = Break, 2 = By word
        this.scale = this.properties[5]; // text scale / size modifier (float)
        if (this.scale <= 0) {this.scale = 1.0;}; // don't allow zero or negative, revert to default size
        this.autoResize = this.properties[6]; // 0 = No resize, 1 = Limit length, 2 = Limit lines, 3 = Fixed size
		this.maxLength = this.properties[7] // max characters in a line
        this.maxLines = this.properties[8] // max lines
        this.hAlign = this.properties[9]; // text horizontal alignment: 0 - left, 1 - center, 3 - right
        this.vAlign = this.properties[10]; // text vertical alignment: 0 - top, 1 - middle, 2 - bottom
        this.tile = {};
        this.tile.w = this.properties[0]; // original width, don't change!
        this.tile.h = this.properties[1]; //original height, don't change!
        this.tile.sw = Math.round(this.properties[0] * this.properties[5]); // scaled tile width
        this.tile.sh = Math.round(this.properties[1] * this.properties[5]); // scaled tile height
        this.tile.hs = this.properties[12]; // horizontal spacing between characters; negative for tighter letters, positive for sparser letters
        this.tile.vs = this.properties[13]; // vertical spacing between lines; negative for tighter lines, positive for sparser lines
        this.resetGridSize(); // adjust the maxLength and maxLines
		this.charMap = [];  // charcode-indexed sparse array with internal coordinate sets for individual characters
        this.prepareCharMap(); // populate the charMap
        this.textGrid = []; // 2D array (grid) to contain prepared text; should be updated on each on text change, size change and wrapping method change
		this.gridChanged = true; // just declaring the variable, prepareText() toggles it by itself
		this.prepareText(); // set this to true whenever text properties are changed.
		this.webGL_texture = null;
		this.forcePointSampling = (this.properties[11] === 1) ? true : false;
        this.debug = false; //debugging mode, toggle true to draw red outlines
	};
    instanceProto.draw = function(ctx)
    {
		if(this.gridChanged) // if the text grid has changed somehow, re-render the text in buffer canvas
			this.drawBuffer(this.bctx);
		ctx.save();
        if(this.opacity !== 1.0) ctx.globalAlpha = this.opacity; // opacity
        if(this.debug)
        {
            ctx.strokeStyle = "#f00";
		    ctx.lineWidth = 1;
		}
		ctx.translate(this.x,this.y);
		ctx.rotate(this.angle);
		if(this.debug) ctx.strokeRect(0,0,this.width,this.height);
		ctx.drawImage(this.bctx.canvas, 0, 0, this.bctx.canvas.width*this.scale, this.bctx.canvas.height*this.scale);
		ctx.restore();
    }
    instanceProto.drawGL = function(glw)
    {
		if(this.gridChanged)
			this.drawBuffer(this.bctx);
		glw.setTexture(this.webGL_texture);
        glw.setOpacity(this.opacity);
		this.type.gl_rect.set(0,0,(this.bctx.canvas.width-1)*this.scale,(this.bctx.canvas.height-1)*this.scale); // remember this uses coordinates, so width/height minus one
		this.type.gl_quad.set_from_rotated_rect(this.type.gl_rect,this.angle);
		this.type.gl_quad.offset(this.x,this.y);
		glw.quad(this.type.gl_quad.tlx, this.type.gl_quad.tly, this.type.gl_quad.trx, this.type.gl_quad.try_, this.type.gl_quad.brx, this.type.gl_quad.bry, this.type.gl_quad.blx, this.type.gl_quad.bly);
    }
	instanceProto.resetGridSize = function()
	{
		this.maxLength = (this.autoResize === 1 || this.autoResize === 3) ? this.maxLength : Math.floor((this.width - this.tile.hs)/((this.tile.w + this.tile.hs)*this.scale)); // max characters in a line
        this.maxLines = (this.autoResize === 2 || this.autoResize === 3) ? this.maxLines : Math.floor((this.height - this.tile.vs)/((this.tile.h + this.tile.vs)*this.scale)); // max lines
		if(this.maxLength < 1) this.maxLength = 1;
		if(this.maxLines < 1) this.maxLines = 1;
	}
	instanceProto.drawBuffer = function(ctx)
	{
		var key = 0;
		var letter = {};
		ctx.canvas.width = this.maxLength*this.tile.w + (this.maxLength-1)*this.tile.hs;
		ctx.canvas.height = this.maxLines*this.tile.h + (this.maxLines-1)*this.tile.vs;
		ctx.clearRect(0,0,ctx.canvas.width,ctx.canvas.height);
		for(var y = 0; y < this.textGrid.length; y++)
		{
			for(var x = 0; x < this.textGrid[y].length; x++)
			{
				key = this.textGrid[y].charCodeAt(x);
				if(key != 32 && this.charMap[key])
				{
					letter = this.charMap[key];
					ctx.drawImage(this.type.FontStrip, letter.x*this.tile.w, letter.y*this.tile.h, this.tile.w, this.tile.h, x*(this.tile.w+this.tile.hs), y*(this.tile.h+this.tile.vs), this.tile.w, this.tile.h);
				}
			}
		}
		if (this.runtime.gl)
		{
			if(this.webGL_texture)
				this.runtime.glwrap.deleteTexture(this.webGL_texture); // got to delete the old texture first, hopefully avoiding the memory leak!
			this.webGL_texture = this.runtime.glwrap.loadTexture(ctx.canvas, false, this.forcePointSampling ? false : this.runtime.linearSampling); // is this efficient?
		}
		this.gridChanged = false; // done
	}
    instanceProto.prepareCharMap = function()
    {
        var dx = this.tile.w; // horizontal step (pixels)
        var dy = this.tile.h; // vertical step (pixels)
        var n = this.charSet.length; // number of tiles
        var mapWidth = Math.floor(this.type.FontStrip.width/dx); // grid width
        for(var i = 0; i < n; i++)
        {
            var tileX = i%mapWidth;
            var tileY = Math.floor(i/mapWidth);
            this.charMap[this.charSet.charCodeAt(i)] = {};
            this.charMap[this.charSet.charCodeAt(i)].x = tileX;
            this.charMap[this.charSet.charCodeAt(i)].y = tileY;
        }
    }
    instanceProto.prepareText = function()
    {
		this.resetGridSize();
        var lengthLimited = this.autoResize == 1 || this.autoResize == 3; // is the line length limited?
        var linesLimited = this.autoResize == 2 || this.autoResize == 3; // is the line count limited?
        var lines = this.text.split("\n");
        var processed = false;
        var index = 0;
        while(!processed)
        {
            var currentLine = lines[index];
            var excess = "";
            if(this.wrapMethod === 1 && currentLine.length > this.maxLength) // break the line
            {
                excess = currentLine.slice(this.maxLength);
                lines[index] = currentLine.slice(0,this.maxLength);
                lines.splice(index+1,0,excess);
            }
            else if (this.wrapMethod === 2 && currentLine.length > this.maxLength) //wrap by word
            {
                var lastSpace = currentLine.lastIndexOf(" ", this.maxLength);
                var lastTab = currentLine.lastIndexOf("\t", this.maxLength);
                var wsIndex = lastSpace>lastTab ? lastSpace : lastTab; // index of the last whitespace in string
				if (wsIndex > this.maxLength - Math.round(this.maxLength/3)) // bigger words should just be broken
                {
                    excess = currentLine.slice(wsIndex+1); // slice from the last whitespace
					lines[index] = currentLine.slice(0,wsIndex);
                }
                else
                {
                    excess = currentLine.slice(this.maxLength); // break the string normally
                    lines[index] = currentLine.slice(0,this.maxLength);
                };
                lines.splice(index+1,0,excess);
            }
            else {lines[index] = currentLine.slice(0,this.maxLength)}; // no text wrapping, disregard all text after the limit
			if(index+1 == lines.length || (lines.length >= this.maxLines))
			{
				lines.splice(this.maxLines); // remove the unnecessary lines
				processed = true; // no new lines were inserted this iteration, so we're done!
			}
			index++; // with the current line sorted out, we move to next line
        }
		for(var i=0;i<lines.length;i++)
		{
			lines[i].replace(/^\s*|\s*$/,""); // trim spaces
			if(this.vAlign > 0)
			{
				if(this.vAlign === 1) // middle
				{
					var start = lines.length;
					while(lines.length < Math.floor((this.maxLines+start)/2))
						lines.unshift("");
				}
				else if(this.vAlign === 2) // bottom
				{
					while(lines.length < this.maxLines)
						lines.unshift("");
				}
			}
			if(this.hAlign > 0) // time to align text!
			{
				if(this.hAlign === 1) // center
				{
					var start = lines[i].length;
					while(lines[i].length < Math.floor((this.maxLength+start)/2))
						lines[i] = " "+lines[i];
				}
				else if(this.hAlign === 2) // right
				{
					while(lines[i].length < this.maxLength)
						lines[i] = " "+lines[i];
				}
			}
		}
        if(this.autoResize != 0) // only resize if autoResizing is set
        {
            var newWidth = 0;
            var newHeight = 0;
            var longestLine = 0;
            for (var i = 0; i<lines.length; i++) { if(lines[i].length > lines[longestLine].length) longestLine = i};
            newWidth = lengthLimited ? (this.maxLength*this.tile.sw + (this.maxLength-1)*this.tile.hs) : (lines[longestLine].length*this.tile.sw + (lines[longestLine].length-1)*this.tile.hs);
            newHeight = linesLimited ? (this.maxLines*this.tile.sh + (this.maxLines-1)*this.tile.vs) : (lines.length*this.tile.sh + (lines.length-1)*this.tile.vs);
            if (newWidth != this.width || newHeight != this.height) //only if the width or height are actually different
            {
                this.width = newWidth;
                this.height = newHeight;
                this.set_bbox_changed();
            }
        }
        this.textGrid = lines;
		this.gridChanged = true;
        this.runtime.redraw = true;
    }
	pluginProto.cnds = {};
	var cnds = pluginProto.cnds;
	pluginProto.acts = {};
	var acts = pluginProto.acts;
	acts.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
    acts.setText = function(param)
	{
		if (typeof param === "number")
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set) // no point in setting redrawing the identical text
		{
			this.text = text_to_set;
			this.prepareText();
		}
	};
	acts.appendText = function(param)
	{
		if (typeof param === "number")
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.prepareText();
		}
	};
	acts.setWordWrap = function(param)
	{
	    if(param === 0 || param === 1 || param === 2)
	    {
            if(param != this.wrapMethod)
            {
                this.wrapMethod = param;
                this.prepareText();
            }
        }
	}
    acts.SetSize = function(newWidth,newHeight)  // size of bounding box in pixels
    {
        if( newWidth >= 0 && newHeight >= 0 ) // no negatives allowed
        {
            if ((newWidth != this.width) || (newHeight != this.height))
            {
                this.width = newWidth;
                this.height = newHeight;
                this.set_bbox_changed();
                this.prepareText();
            }
        }
    }
    acts.SetWidth = function(newWidth) // width of bounding box in pixels
    {
        if(newWidth >= 0 && this.width != newWidth)
        {
            this.width = newWidth;
            this.set_bbox_changed();
            this.prepareText();
        }
    }
    acts.SetHeight = function(newHeight) // height of bounding box in pixels
    {
        if(newHeight >= 0 && this.height != newHeight)
        {
            this.height = newHeight;
            this.set_bbox_changed();
            this.prepareText();
        }
    }
    acts.setScale = function(scale)
    {
        if(scale > 0 && this.scale != scale)
        {
            this.scale = scale;
            this.tile.sw = Math.round(this.tile.w*this.scale);
            this.tile.sh = Math.round(this.tile.h*this.scale);
            this.prepareText();
        }
    }
    acts.setResizeMode = function(method, width, height)
    {
        if(method != this.autoResize || width != this.maxLength || height != this.maxLines)
        {
            this.autoResize = method;
            this.maxLength = width;
            this.maxLines = height;
            this.prepareText();
        }
    }
    acts.setTextParams = function(text, textWrap, resizeMode, lengthLimit, lineCount, scale)
    {
        this.text = text;
        this.wrapMethod = textWrap;
        this.autoResize = resizeMode;
        this.maxLength = lengthLimit;
        this.maxLines = lineCount;
        this.scale = (scale > 0) ? scale : 1.0; // default value, number must be greater than 0
        this.tile.sw = Math.round(this.tile.w*this.scale);
        this.tile.sh = Math.round(this.tile.h*this.scale);
        this.prepareText();
    }
    acts.setTextAlign = function(hAlign, vAlign)
    {
        if(hAlign !== this.hAlign || vAlign !== this.vAlign)
        {
            this.hAlign = hAlign;
            this.vAlign = vAlign;
			this.prepareText();
        }
    }
    acts.toggleDebug = function()
    {
        this.debug = this.debug ? false : true;
        this.runtime.redraw = true;
    }
    acts.setHorizontalSpacing = function(hs)
    {
        if(this.tile.hs != hs)
        {
            this.tile.hs = hs;
			this.prepareText();
        }
    }
    acts.setVerticalSpacing = function(vs)
    {
        if(this.tile.vs != vs)
        {
            this.tile.vs = vs;
			this.prepareText();
        }
    }
	pluginProto.exps = {};
	var exps = pluginProto.exps;
    exps.text = function(ret){ret.set_string(this.text)}
    exps.charWidth = function(ret){ret.set_int(this.tile.w)}
    exps.charHeight = function(ret){ret.set_int(this.tile.h)}
    exps.wrapMethod = function(ret)
    {
        switch(this.wrapMethod)
        {
            case 0:
                ret.set_string("None");
                break;
            case 1:
                ret.set_string("Break");
                break;
            case 2:
                ret.set_string("By word");
                break;
            default:
                ret.set_string("Error");
        }
    }
    exps.scale = function(ret)
    {
        ret.set_float(this.scale);
    }
    exps.getResizeMode = function(ret)
    {
        switch(this.autoresize)
        {
            case 1:
                ret.set_string("Limit length");
                break;
            case 2:
                ret.set_string("Limit lines");
                break;
            case 3:
                ret.set_string("Fixed size");
                break;
            default:
                ret.set_string("No resize");
                break;
        }
    }
    exps.getResizeWidth = function(ret){ret.set_int(this.maxLength)}
    exps.getResizeHeight = function(ret){ret.set_int(this.maxLines)}
    exps.getHorizontalAlign = function(ret){ret.set_string(this.hAlign != 0 ? (this.hAlign == 1 ? "Center" : "Right") : "Left")}
    exps.getVerticalAlign = function(ret){ret.set_string(this.vAlign != 0 ? (this.vAlign == 1 ? "Middle" : "Bottom") : "Top")}
    exps.getHorizontalSpacing = function(ret){ret.set_float(this.tile.hs)}
    exps.getVerticalSpacing = function(ret){ret.set_float(this.tile.vs)}
    cnds.compareText = function(text_to_compare, case_sensitive) // DEPRECATED
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return this.text.toLowerCase() == text_to_compare.toLowerCase();
	};
	cnds.containsText = function(text_to_find, case_sensitive) // DEPRECATED
	{
	    if (text_to_find) //not empty
	    {
            return (this.text.search(new RegExp(cr.regexp_escape(text_to_find.toString()), case_sensitive ? "" : "i")) == -1) ? false : true;
        }
        else return false;
    }
}());
/* global cr,log,assert2 */
/* jshint globalstrict: true */
/* jshint strict: true */
;
;
cr.plugins_.Spritefont2 = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Spritefont2.prototype;
	pluginProto.onCreate = function ()
	{
	};
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		if (this.is_family)
			return;
		this.texture_img = new Image();
		this.texture_img["idtkLoadDisposed"] = true;
		this.texture_img.src = this.texture_file;
		this.runtime.waitForImageLoad(this.texture_img);
		this.webGL_texture = null;
	};
	typeProto.onLostWebGLContext = function ()
	{
		if (this.is_family)
			return;
		this.webGL_texture = null;
	};
	typeProto.onRestoreWebGLContext = function ()
	{
		if (this.is_family || !this.instances.length)
			return;
		if (!this.webGL_texture)
		{
			this.webGL_texture = this.runtime.glwrap.loadTexture(this.texture_img, false, this.runtime.linearSampling, this.texture_pixelformat);
		}
		var i, len;
		for (i = 0, len = this.instances.length; i < len; i++)
			this.instances[i].webGL_texture = this.webGL_texture;
	};
	typeProto.unloadTextures = function ()
	{
		if (this.is_family || this.instances.length || !this.webGL_texture)
			return;
		this.runtime.glwrap.deleteTexture(this.webGL_texture);
		this.webGL_texture = null;
	};
	typeProto.preloadCanvas2D = function (ctx)
	{
		ctx.drawImage(this.texture_img, 0, 0);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	instanceProto.onDestroy = function()
	{
		freeAllLines (this.lines);
		freeAllClip  (this.clipList);
		freeAllClipUV(this.clipUV);
		cr.wipe(this.characterWidthList);
	};
	instanceProto.onCreate = function()
	{
		this.texture_img      = this.type.texture_img;
		this.characterWidth   = this.properties[0];
		this.characterHeight  = this.properties[1];
		this.characterSet     = this.properties[2];
		this.text             = this.properties[3];
		this.characterScale   = this.properties[4];
		this.visible          = (this.properties[5] === 0);	// 0=visible, 1=invisible
		this.halign           = this.properties[6]/2.0;			// 0=left, 1=center, 2=right
		this.valign           = this.properties[7]/2.0;			// 0=top, 1=center, 2=bottom
		this.wrapbyword       = (this.properties[9] === 0);	// 0=word, 1=character
		this.characterSpacing = this.properties[10];
		this.lineHeight       = this.properties[11];
		this.textWidth  = 0;
		this.textHeight = 0;
		if (this.recycled)
		{
			this.lines.length = 0;
			cr.wipe(this.clipList);
			cr.wipe(this.clipUV);
			cr.wipe(this.characterWidthList);
		}
		else
		{
			this.lines = [];
			this.clipList = {};
			this.clipUV = {};
			this.characterWidthList = {};
		}
		this.text_changed = true;
		this.lastwrapwidth = this.width;
		if (this.runtime.glwrap)
		{
			if (!this.type.webGL_texture)
			{
				this.type.webGL_texture = this.runtime.glwrap.loadTexture(this.type.texture_img, false, this.runtime.linearSampling, this.type.texture_pixelformat);
			}
			this.webGL_texture = this.type.webGL_texture;
		}
		this.SplitSheet();
	};
	instanceProto.saveToJSON = function ()
	{
		var save = {
			"t": this.text,
			"csc": this.characterScale,
			"csp": this.characterSpacing,
			"lh": this.lineHeight,
			"tw": this.textWidth,
			"th": this.textHeight,
			"lrt": this.last_render_tick,
			"cw": {}
		};
		for (var ch in this.characterWidthList)
			save["cw"][ch] = this.characterWidthList[ch];
		return save;
	};
	instanceProto.loadFromJSON = function (o)
	{
		this.text = o["t"];
		this.characterScale = o["csc"];
		this.characterSpacing = o["csp"];
		this.lineHeight = o["lh"];
		this.textWidth = o["tw"];
		this.textHeight = o["th"];
		this.last_render_tick = o["lrt"];
		for(var ch in o["cw"])
			this.characterWidthList[ch] = o["cw"][ch];
		this.text_changed = true;
		this.lastwrapwidth = this.width;
	};
	function trimRight(text)
	{
		return text.replace(/\s\s*$/, '');
	}
	var MAX_CACHE_SIZE = 1000;
	function alloc(cache,Constructor)
	{
		if (cache.length)
			return cache.pop();
		else
			return new Constructor();
	}
	function free(cache,data)
	{
		if (cache.length < MAX_CACHE_SIZE)
		{
			cache.push(data);
		}
	}
	function freeAll(cache,dataList,isArray)
	{
		if (isArray) {
			var i, len;
			for (i = 0, len = dataList.length; i < len; i++)
			{
				free(cache,dataList[i]);
			}
			dataList.length = 0;
		} else {
			var prop;
			for(prop in dataList) {
				if(Object.prototype.hasOwnProperty.call(dataList,prop)) {
					free(cache,dataList[prop]);
					delete dataList[prop];
				}
			}
		}
	}
	function addLine(inst,lineIndex,cur_line) {
		var lines = inst.lines;
		var line;
		cur_line = trimRight(cur_line);
		if (lineIndex >= lines.length)
			lines.push(allocLine());
		line = lines[lineIndex];
		line.text = cur_line;
		line.width = inst.measureWidth(cur_line);
		inst.textWidth = cr.max(inst.textWidth,line.width);
	}
	var linesCache = [];
	function allocLine()       { return alloc(linesCache,Object); }
	function freeLine(l)       { free(linesCache,l); }
	function freeAllLines(arr) { freeAll(linesCache,arr,true); }
	function addClip(obj,property,x,y,w,h) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipCache,Object);
		}
		obj[property].x = x;
		obj[property].y = y;
		obj[property].w = w;
		obj[property].h = h;
	}
	var clipCache = [];
	function allocClip()      { return alloc(clipCache,Object); }
	function freeAllClip(obj) { freeAll(clipCache,obj,false);}
	function addClipUV(obj,property,left,top,right,bottom) {
		if (obj[property] === undefined) {
			obj[property] = alloc(clipUVCache,cr.rect);
		}
		obj[property].left   = left;
		obj[property].top    = top;
		obj[property].right  = right;
		obj[property].bottom = bottom;
	}
	var clipUVCache = [];
	function allocClipUV()      { return alloc(clipUVCache,cr.rect);}
	function freeAllClipUV(obj) { freeAll(clipUVCache,obj,false);}
	instanceProto.SplitSheet = function() {
		var texture      = this.texture_img;
		var texWidth     = texture.width;
		var texHeight    = texture.height;
		var charWidth    = this.characterWidth;
		var charHeight   = this.characterHeight;
		var charU        = charWidth /texWidth;
		var charV        = charHeight/texHeight;
		var charSet      = this.characterSet ;
		var cols = Math.floor(texWidth/charWidth);
		var rows = Math.floor(texHeight/charHeight);
		for ( var c = 0; c < charSet.length; c++) {
			if  (c >= cols * rows) break;
			var x = c%cols;
			var y = Math.floor(c/cols);
			var letter = charSet.charAt(c);
			if (this.runtime.glwrap) {
				addClipUV(
					this.clipUV, letter,
					x * charU ,
					y * charV ,
					(x+1) * charU ,
					(y+1) * charV
				);
			} else {
				addClip(
					this.clipList, letter,
					x * charWidth,
					y * charHeight,
					charWidth,
					charHeight
				);
			}
		}
	};
	/*
     *	Word-Wrapping
     */
	var wordsCache = [];
	pluginProto.TokeniseWords = function (text)
	{
		wordsCache.length = 0;
		var cur_word = "";
		var ch;
		var i = 0;
		while (i < text.length)
		{
			ch = text.charAt(i);
			if (ch === "\n")
			{
				if (cur_word.length)
				{
					wordsCache.push(cur_word);
					cur_word = "";
				}
				wordsCache.push("\n");
				++i;
			}
			else if (ch === " " || ch === "\t" || ch === "-")
			{
				do {
					cur_word += text.charAt(i);
					i++;
				}
				while (i < text.length && (text.charAt(i) === " " || text.charAt(i) === "\t"));
				wordsCache.push(cur_word);
				cur_word = "";
			}
			else if (i < text.length)
			{
				cur_word += ch;
				i++;
			}
		}
		if (cur_word.length)
			wordsCache.push(cur_word);
	};
	pluginProto.WordWrap = function (inst)
	{
		var text = inst.text;
		var lines = inst.lines;
		if (!text || !text.length)
		{
			freeAllLines(lines);
			return;
		}
		var width = inst.width;
		if (width <= 2.0)
		{
			freeAllLines(lines);
			return;
		}
		var charWidth = inst.characterWidth;
		var charScale = inst.characterScale;
		var charSpacing = inst.characterSpacing;
		if ( (text.length * (charWidth * charScale + charSpacing) - charSpacing) <= width && text.indexOf("\n") === -1)
		{
			var all_width = inst.measureWidth(text);
			if (all_width <= width)
			{
				freeAllLines(lines);
				lines.push(allocLine());
				lines[0].text = text;
				lines[0].width = all_width;
				inst.textWidth  = all_width;
				inst.textHeight = inst.characterHeight * charScale + inst.lineHeight;
				return;
			}
		}
		var wrapbyword = inst.wrapbyword;
		this.WrapText(inst);
		inst.textHeight = lines.length * (inst.characterHeight * charScale + inst.lineHeight);
	};
	pluginProto.WrapText = function (inst)
	{
		var wrapbyword = inst.wrapbyword;
		var text       = inst.text;
		var lines      = inst.lines;
		var width      = inst.width;
		var wordArray;
		if (wrapbyword) {
			this.TokeniseWords(text);	// writes to wordsCache
			wordArray = wordsCache;
		} else {
			wordArray = text;
		}
		var cur_line = "";
		var prev_line;
		var line_width;
		var i;
		var lineIndex = 0;
		var line;
		var ignore_newline = false;
		for (i = 0; i < wordArray.length; i++)
		{
			if (wordArray[i] === "\n")
			{
				if (ignore_newline === true) {
					ignore_newline = false;
				} else {
					addLine(inst,lineIndex,cur_line);
					lineIndex++;
				}
				cur_line = "";
				continue;
			}
			ignore_newline = false;
			prev_line = cur_line;
			cur_line += wordArray[i];
			line_width = inst.measureWidth(trimRight(cur_line));
			if (line_width > width)
			{
				if (prev_line === "") {
					addLine(inst,lineIndex,cur_line);
					cur_line = "";
					ignore_newline = true;
				} else {
					addLine(inst,lineIndex,prev_line);
					cur_line = wordArray[i];
				}
				lineIndex++;
				if (!wrapbyword && cur_line === " ")
					cur_line = "";
			}
		}
		if (trimRight(cur_line).length)
		{
			addLine(inst,lineIndex,cur_line);
			lineIndex++;
		}
		for (i = lineIndex; i < lines.length; i++)
			freeLine(lines[i]);
		lines.length = lineIndex;
	};
	instanceProto.measureWidth = function(text) {
		var spacing = this.characterSpacing;
		var len     = text.length;
		var width   = 0;
		for (var i = 0; i < len; i++) {
			width += this.getCharacterWidth(text.charAt(i)) * this.characterScale + spacing;
		}
		width -= (width > 0) ? spacing : 0;
		return width;
	};
	/***/
	instanceProto.getCharacterWidth = function(character) {
		var widthList = this.characterWidthList;
		if (widthList[character] !== undefined) {
			return widthList[character];
		} else {
			return this.characterWidth;
		}
	};
	instanceProto.rebuildText = function() {
		if (this.text_changed || this.width !== this.lastwrapwidth) {
			this.textWidth = 0;
			this.textHeight = 0;
			this.type.plugin.WordWrap(this);
			this.text_changed = false;
			this.lastwrapwidth = this.width;
		}
	};
	var EPSILON = 0.00001;
	instanceProto.draw = function(ctx, glmode)
	{
		var texture = this.texture_img;
		if (this.text !== "" && texture != null) {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			ctx.globalAlpha = this.opacity;
			var myx = this.x;
			var myy = this.y;
			if (this.runtime.pixel_rounding)
			{
				myx = (myx + 0.5) | 0;
				myy = (myy + 0.5) | 0;
			}
			ctx.save();
			ctx.translate(myx, myy);
			ctx.rotate(this.angle);
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = -(this.hotspotX * this.width);
			var offy = -(this.hotspotY * this.height);
			offy += valign;
			var drawX ;
			var drawY = offy;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line = lines[i].text;
				var len  = lines[i].width;
				halign = ha * cr.max(0,this.width - len);
				drawX = offx + halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clip = this.clipList[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale > this.width + EPSILON ) {
						break;
					}
					if (clip !== undefined) {
						roundX = drawX;
						roundY = drawY;
						if (this.angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						ctx.drawImage( this.texture_img,
									 clip.x, clip.y, clip.w, clip.h,
									 roundX,roundY,clip.w*scale,clip.h*scale);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
			ctx.restore();
		}
	};
	var dQuad = new cr.quad();
	function rotateQuad(quad,cosa,sina) {
		var x_temp;
		x_temp   = (quad.tlx * cosa) - (quad.tly * sina);
		quad.tly = (quad.tly * cosa) + (quad.tlx * sina);
		quad.tlx = x_temp;
		x_temp    = (quad.trx * cosa) - (quad.try_ * sina);
		quad.try_ = (quad.try_ * cosa) + (quad.trx * sina);
		quad.trx  = x_temp;
		x_temp   = (quad.blx * cosa) - (quad.bly * sina);
		quad.bly = (quad.bly * cosa) + (quad.blx * sina);
		quad.blx = x_temp;
		x_temp    = (quad.brx * cosa) - (quad.bry * sina);
		quad.bry = (quad.bry * cosa) + (quad.brx * sina);
		quad.brx  = x_temp;
	}
	instanceProto.drawGL = function(glw)
	{
		glw.setTexture(this.webGL_texture);
		glw.setOpacity(this.opacity);
		if (this.text !== "") {
			this.rebuildText();
			if (this.height < this.characterHeight*this.characterScale + this.lineHeight) {
				return;
			}
			this.update_bbox();
			var q = this.bquad;
			var ox = 0;
			var oy = 0;
			if (this.runtime.pixel_rounding)
			{
				ox = ((this.x + 0.5) | 0) - this.x;
				oy = ((this.y + 0.5) | 0) - this.y;
			}
			var angle      = this.angle;
			var ha         = this.halign;
			var va         = this.valign;
			var scale      = this.characterScale;
			var charHeight = this.characterHeight * scale;   // to precalculate in onCreate or on change
			var lineHeight = this.lineHeight;
			var charSpace  = this.characterSpacing;
			var lines = this.lines;
			var textHeight = this.textHeight;
			var cosa,sina;
			if (angle !== 0)
			{
				cosa = Math.cos(angle);
				sina = Math.sin(angle);
			}
			var halign;
			var valign = va * cr.max(0,(this.height - textHeight));
			var offx = q.tlx + ox;
			var offy = q.tly + oy;
			var drawX ;
			var drawY = valign;
			var roundX, roundY;
			for(var i = 0; i < lines.length; i++) {
				var line       = lines[i].text;
				var lineWidth  = lines[i].width;
				halign = ha * cr.max(0,this.width - lineWidth);
				drawX = halign;
				drawY += lineHeight;
				for(var j = 0; j < line.length; j++) {
					var letter = line.charAt(j);
					var clipUV = this.clipUV[letter];
					if ( drawX + this.getCharacterWidth(letter) * scale  > this.width + EPSILON) {
						break;
					}
					if (clipUV !== undefined) {
						var clipWidth  = this.characterWidth*scale;
						var clipHeight = this.characterHeight*scale;
						roundX = drawX;
						roundY = drawY;
						if (angle === 0)
						{
							roundX = Math.round(roundX);
							roundY = Math.round(roundY);
						}
						dQuad.tlx  = roundX;
						dQuad.tly  = roundY;
						dQuad.trx  = roundX + clipWidth;
						dQuad.try_ = roundY ;
						dQuad.blx  = roundX;
						dQuad.bly  = roundY + clipHeight;
						dQuad.brx  = roundX + clipWidth;
						dQuad.bry  = roundY + clipHeight;
						if(angle !== 0)
						{
							rotateQuad(dQuad,cosa,sina);
						}
						dQuad.offset(offx,offy);
						glw.quadTex(
							dQuad.tlx, dQuad.tly,
							dQuad.trx, dQuad.try_,
							dQuad.brx, dQuad.bry,
							dQuad.blx, dQuad.bly,
							clipUV
						);
					}
					drawX  += this.getCharacterWidth(letter) * scale + charSpace;
				}
				drawY += charHeight;
				if ( drawY + charHeight + lineHeight > this.height) {
					break;
				}
			}
		}
	};
	function Cnds() {}
	Cnds.prototype.CompareText = function(text_to_compare, case_sensitive)
	{
		if (case_sensitive)
			return this.text == text_to_compare;
		else
			return cr.equals_nocase(this.text, text_to_compare);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {}
	Acts.prototype.SetText = function(param)
	{
		if (cr.is_number(param) && param < 1e9)
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_set = param.toString();
		if (this.text !== text_to_set)
		{
			this.text = text_to_set;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.AppendText = function(param)
	{
		if (cr.is_number(param))
			param = Math.round(param * 1e10) / 1e10;	// round to nearest ten billionth - hides floating point errors
		var text_to_append = param.toString();
		if (text_to_append)	// not empty
		{
			this.text += text_to_append;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetScale = function(param)
	{
		if (param !== this.characterScale) {
			this.characterScale = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterSpacing = function(param)
	{
		if (param !== this.CharacterSpacing) {
			this.characterSpacing = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetLineHeight = function(param)
	{
		if (param !== this.lineHeight) {
			this.lineHeight = param;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	instanceProto.SetCharWidth = function(character,width) {
		var w = parseInt(width,10);
		if (this.characterWidthList[character] !== w) {
			this.characterWidthList[character] = w;
			this.text_changed = true;
			this.runtime.redraw = true;
		}
	};
	Acts.prototype.SetCharacterWidth = function(characterSet,width)
	{
		if (characterSet !== "") {
			for(var c = 0; c < characterSet.length; c++) {
				this.SetCharWidth(characterSet.charAt(c),width);
			}
		}
	};
	Acts.prototype.SetEffect = function (effect)
	{
		this.compositeOp = cr.effectToCompositeOp(effect);
		cr.setGLBlend(this, effect, this.runtime.gl);
		this.runtime.redraw = true;
	};
	Acts.prototype.SetHAlign = function (a)
	{
		this.halign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	Acts.prototype.SetVAlign = function (a)
	{
		this.valign = a / 2.0;
		this.text_changed = true;
		this.runtime.redraw = true;
	};
	pluginProto.acts = new Acts();
	function Exps() {}
	Exps.prototype.CharacterWidth = function(ret,character)
	{
		ret.set_int(this.getCharacterWidth(character));
	};
	Exps.prototype.CharacterHeight = function(ret)
	{
		ret.set_int(this.characterHeight);
	};
	Exps.prototype.CharacterScale = function(ret)
	{
		ret.set_float(this.characterScale);
	};
	Exps.prototype.CharacterSpacing = function(ret)
	{
		ret.set_int(this.characterSpacing);
	};
	Exps.prototype.LineHeight = function(ret)
	{
		ret.set_int(this.lineHeight);
	};
	Exps.prototype.Text = function(ret)
	{
		ret.set_string(this.text);
	};
	Exps.prototype.TextWidth = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textWidth);
	};
	Exps.prototype.TextHeight = function (ret)
	{
		this.rebuildText();
		ret.set_float(this.textHeight);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.Touch = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.Touch.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
		this.touches = [];
		this.mouseDown = false;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var dummyoffset = {left: 0, top: 0};
	instanceProto.findTouch = function (id)
	{
		var i, len;
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			if (this.touches[i]["id"] === id)
				return i;
		}
		return -1;
	};
	var appmobi_accx = 0;
	var appmobi_accy = 0;
	var appmobi_accz = 0;
	function AppMobiGetAcceleration(evt)
	{
		appmobi_accx = evt.x;
		appmobi_accy = evt.y;
		appmobi_accz = evt.z;
	};
	var pg_accx = 0;
	var pg_accy = 0;
	var pg_accz = 0;
	function PhoneGapGetAcceleration(evt)
	{
		pg_accx = evt.x;
		pg_accy = evt.y;
		pg_accz = evt.z;
	};
	var theInstance = null;
	instanceProto.onCreate = function()
	{
		theInstance = this;
		this.isWindows8 = !!(typeof window["c2isWindows8"] !== "undefined" && window["c2isWindows8"]);
		this.orient_alpha = 0;
		this.orient_beta = 0;
		this.orient_gamma = 0;
		this.acc_g_x = 0;
		this.acc_g_y = 0;
		this.acc_g_z = 0;
		this.acc_x = 0;
		this.acc_y = 0;
		this.acc_z = 0;
		this.curTouchX = 0;
		this.curTouchY = 0;
		this.trigger_index = 0;
		this.trigger_id = 0;
		this.useMouseInput = (this.properties[0] !== 0);
		var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
		var elem2 = document;
		if (this.runtime.isDirectCanvas)
			elem2 = elem = window["Canvas"];
		else if (this.runtime.isCocoonJs)
			elem2 = elem = window;
		var self = this;
		if (window.navigator["pointerEnabled"])
		{
			elem.addEventListener("pointerdown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("pointermove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("pointerup",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("pointercancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				this.runtime.canvas.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("gesturehold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else if (window.navigator["msPointerEnabled"])
		{
			elem.addEventListener("MSPointerDown",
				function(info) {
					self.onPointerStart(info);
				},
				false
			);
			elem.addEventListener("MSPointerMove",
				function(info) {
					self.onPointerMove(info);
				},
				false
			);
			elem2.addEventListener("MSPointerUp",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			elem2.addEventListener("MSPointerCancel",
				function(info) {
					self.onPointerEnd(info);
				},
				false
			);
			if (this.runtime.canvas)
			{
				this.runtime.canvas.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
				document.addEventListener("MSGestureHold", function(e) {
					e.preventDefault();
				}, false);
			}
		}
		else
		{
			elem.addEventListener("touchstart",
				function(info) {
					self.onTouchStart(info);
				},
				false
			);
			elem.addEventListener("touchmove",
				function(info) {
					self.onTouchMove(info);
				},
				false
			);
			elem2.addEventListener("touchend",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
			elem2.addEventListener("touchcancel",
				function(info) {
					self.onTouchEnd(info);
				},
				false
			);
		}
		if (this.isWindows8)
		{
			var win8accelerometerFn = function(e) {
					var reading = e["reading"];
					self.acc_x = reading["accelerationX"];
					self.acc_y = reading["accelerationY"];
					self.acc_z = reading["accelerationZ"];
				};
			var win8inclinometerFn = function(e) {
					var reading = e["reading"];
					self.orient_alpha = reading["yawDegrees"];
					self.orient_beta = reading["pitchDegrees"];
					self.orient_gamma = reading["rollDegrees"];
				};
			var accelerometer = Windows["Devices"]["Sensors"]["Accelerometer"]["getDefault"]();
            if (accelerometer)
			{
                accelerometer["reportInterval"] = Math.max(accelerometer["minimumReportInterval"], 16);
				accelerometer.addEventListener("readingchanged", win8accelerometerFn);
            }
			var inclinometer = Windows["Devices"]["Sensors"]["Inclinometer"]["getDefault"]();
			if (inclinometer)
			{
				inclinometer["reportInterval"] = Math.max(inclinometer["minimumReportInterval"], 16);
				inclinometer.addEventListener("readingchanged", win8inclinometerFn);
			}
			document.addEventListener("visibilitychange", function(e) {
				if (document["hidden"] || document["msHidden"])
				{
					if (accelerometer)
						accelerometer.removeEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.removeEventListener("readingchanged", win8inclinometerFn);
				}
				else
				{
					if (accelerometer)
						accelerometer.addEventListener("readingchanged", win8accelerometerFn);
					if (inclinometer)
						inclinometer.addEventListener("readingchanged", win8inclinometerFn);
				}
			}, false);
		}
		else
		{
			window.addEventListener("deviceorientation", function (eventData) {
				self.orient_alpha = eventData["alpha"] || 0;
				self.orient_beta = eventData["beta"] || 0;
				self.orient_gamma = eventData["gamma"] || 0;
			}, false);
			window.addEventListener("devicemotion", function (eventData) {
				if (eventData["accelerationIncludingGravity"])
				{
					self.acc_g_x = eventData["accelerationIncludingGravity"]["x"] || 0;
					self.acc_g_y = eventData["accelerationIncludingGravity"]["y"] || 0;
					self.acc_g_z = eventData["accelerationIncludingGravity"]["z"] || 0;
				}
				if (eventData["acceleration"])
				{
					self.acc_x = eventData["acceleration"]["x"] || 0;
					self.acc_y = eventData["acceleration"]["y"] || 0;
					self.acc_z = eventData["acceleration"]["z"] || 0;
				}
			}, false);
		}
		if (this.useMouseInput && !this.runtime.isDomFree)
		{
			jQuery(document).mousemove(
				function(info) {
					self.onMouseMove(info);
				}
			);
			jQuery(document).mousedown(
				function(info) {
					self.onMouseDown(info);
				}
			);
			jQuery(document).mouseup(
				function(info) {
					self.onMouseUp(info);
				}
			);
		}
		if (this.runtime.isAppMobi && !this.runtime.isDirectCanvas)
		{
			AppMobi["accelerometer"]["watchAcceleration"](AppMobiGetAcceleration, { "frequency": 40, "adjustForRotation": true });
		}
		if (this.runtime.isPhoneGap && navigator["accelerometer"] && navigator["accelerometer"]["watchAcceleration"])
		{
			navigator["accelerometer"]["watchAcceleration"](PhoneGapGetAcceleration, null, { "frequency": 40 });
		}
		this.runtime.tick2Me(this);
	};
	instanceProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		var nowtime = cr.performance_now();
		if (i >= 0)
		{
			var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
			var t = this.touches[i];
			if (nowtime - t.time < 2)
				return;
			t.lasttime = t.time;
			t.lastx = t.x;
			t.lasty = t.y;
			t.time = nowtime;
			t.x = info.pageX - offset.left;
			t.y = info.pageY - offset.top;
		}
	};
	instanceProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var touchx = info.pageX - offset.left;
		var touchy = info.pageY - offset.top;
		var nowtime = cr.performance_now();
		this.trigger_index = this.touches.length;
		this.trigger_id = info["pointerId"];
		this.touches.push({ time: nowtime,
							x: touchx,
							y: touchy,
							lasttime: nowtime,
							lastx: touchx,
							lasty: touchy,
							"id": info["pointerId"],
							startindex: this.trigger_index
						});
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
		this.curTouchX = touchx;
		this.curTouchY = touchy;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"] || info["pointerType"] === "mouse")
			return;
		if (info.preventDefault)
			info.preventDefault();
		var i = this.findTouch(info["pointerId"]);
		this.trigger_index = (i >= 0 ? this.touches[i].startindex : -1);
		this.trigger_id = (i >= 0 ? this.touches[i]["id"] : -1);
		this.runtime.isInUserInputEvent = true;
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
		this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
		this.runtime.isInUserInputEvent = false;
		if (i >= 0)
		{
			this.touches.splice(i, 1);
		}
	};
	instanceProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var nowtime = cr.performance_now();
		var i, len, t, u;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			var j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
				u = this.touches[j];
				if (nowtime - u.time < 2)
					continue;
				u.lasttime = u.time;
				u.lastx = u.x;
				u.lasty = u.y;
				u.time = nowtime;
				u.x = t.pageX - offset.left;
				u.y = t.pageY - offset.top;
			}
		}
	};
	instanceProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var nowtime = cr.performance_now();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j !== -1)
				continue;
			var touchx = t.pageX - offset.left;
			var touchy = t.pageY - offset.top;
			this.trigger_index = this.touches.length;
			this.trigger_id = t["identifier"];
			this.touches.push({ time: nowtime,
								x: touchx,
								y: touchy,
								lasttime: nowtime,
								lastx: touchx,
								lasty: touchy,
								"id": t["identifier"],
								startindex: this.trigger_index
							});
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchStart, this);
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchStart, this);
			this.curTouchX = touchx;
			this.curTouchY = touchy;
			this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchObject, this);
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		this.runtime.isInUserInputEvent = true;
		var i, len, t, j;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			j = this.findTouch(t["identifier"]);
			if (j >= 0)
			{
				this.trigger_index = this.touches[j].startindex;
				this.trigger_id = this.touches[j]["id"];
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnNthTouchEnd, this);
				this.runtime.trigger(cr.plugins_.Touch.prototype.cnds.OnTouchEnd, this);
				this.touches.splice(j, 1);
			}
		}
		this.runtime.isInUserInputEvent = false;
	};
	instanceProto.getAlpha = function ()
	{
		if (this.runtime.isAppMobi && this.orient_alpha === 0 && appmobi_accz !== 0)
			return appmobi_accz * 90;
		else if (this.runtime.isPhoneGap  && this.orient_alpha === 0 && pg_accz !== 0)
			return pg_accz * 90;
		else
			return this.orient_alpha;
	};
	instanceProto.getBeta = function ()
	{
		if (this.runtime.isAppMobi && this.orient_beta === 0 && appmobi_accy !== 0)
			return appmobi_accy * -90;
		else if (this.runtime.isPhoneGap  && this.orient_beta === 0 && pg_accy !== 0)
			return pg_accy * -90;
		else
			return this.orient_beta;
	};
	instanceProto.getGamma = function ()
	{
		if (this.runtime.isAppMobi && this.orient_gamma === 0 && appmobi_accx !== 0)
			return appmobi_accx * 90;
		else if (this.runtime.isPhoneGap  && this.orient_gamma === 0 && pg_accx !== 0)
			return pg_accx * 90;
		else
			return this.orient_gamma;
	};
	var noop_func = function(){};
	instanceProto.onMouseDown = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchStart(fakeinfo);
		this.mouseDown = true;
	};
	instanceProto.onMouseMove = function(info)
	{
		if (!this.mouseDown)
			return;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchMove(fakeinfo);
	};
	instanceProto.onMouseUp = function(info)
	{
		if (info.preventDefault && this.runtime.had_a_click && !this.runtime.isMobile)
			info.preventDefault();
		this.runtime.had_a_click = true;
		var t = { pageX: info.pageX, pageY: info.pageY, "identifier": 0 };
		var fakeinfo = { changedTouches: [t] };
		this.onTouchEnd(fakeinfo);
		this.mouseDown = false;
	};
	instanceProto.tick2 = function()
	{
		var i, len, t;
		var nowtime = cr.performance_now();
		for (i = 0, len = this.touches.length; i < len; i++)
		{
			t = this.touches[i];
			if (t.time <= nowtime - 50)
				t.lasttime = nowtime;
		}
	};
	function Cnds() {};
	Cnds.prototype.OnTouchStart = function ()
	{
		return true;
	};
	Cnds.prototype.OnTouchEnd = function ()
	{
		return true;
	};
	Cnds.prototype.IsInTouch = function ()
	{
		return this.touches.length;
	};
	Cnds.prototype.OnTouchObject = function (type)
	{
		if (!type)
			return false;
		return this.runtime.testAndSelectCanvasPointOverlap(type, this.curTouchX, this.curTouchY, false);
	};
	Cnds.prototype.IsTouchingObject = function (type)
	{
		if (!type)
			return false;
		var sol = type.getCurrentSol();
		var instances = sol.getObjects();
		var px, py;
		var touching = [];
		var i, leni, j, lenj;
		for (i = 0, leni = instances.length; i < leni; i++)
		{
			var inst = instances[i];
			inst.update_bbox();
			for (j = 0, lenj = this.touches.length; j < lenj; j++)
			{
				var touch = this.touches[j];
				px = inst.layer.canvasToLayer(touch.x, touch.y, true);
				py = inst.layer.canvasToLayer(touch.x, touch.y, false);
				if (inst.contains_pt(px, py))
				{
					touching.push(inst);
					break;
				}
			}
		}
		if (touching.length)
		{
			sol.select_all = false;
			sol.instances = touching;
			type.applySolToContainer();
			return true;
		}
		else
			return false;
	};
	Cnds.prototype.CompareTouchSpeed = function (index, cmp, s)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
			return false;
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		var speed = 0;
		if (timediff > 0)
			speed = dist / timediff;
		return cr.do_cmp(speed, cmp, s);
	};
	Cnds.prototype.OrientationSupported = function ()
	{
		return typeof window["DeviceOrientationEvent"] !== "undefined";
	};
	Cnds.prototype.MotionSupported = function ()
	{
		return typeof window["DeviceMotionEvent"] !== "undefined";
	};
	Cnds.prototype.CompareOrientation = function (orientation_, cmp_, angle_)
	{
		var v = 0;
		if (orientation_ === 0)
			v = this.getAlpha();
		else if (orientation_ === 1)
			v = this.getBeta();
		else
			v = this.getGamma();
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.CompareAcceleration = function (acceleration_, cmp_, angle_)
	{
		var v = 0;
		if (acceleration_ === 0)
			v = this.acc_g_x;
		else if (acceleration_ === 1)
			v = this.acc_g_y;
		else if (acceleration_ === 2)
			v = this.acc_g_z;
		else if (acceleration_ === 3)
			v = this.acc_x;
		else if (acceleration_ === 4)
			v = this.acc_y;
		else if (acceleration_ === 5)
			v = this.acc_z;
		return cr.do_cmp(v, cmp_, angle_);
	};
	Cnds.prototype.OnNthTouchStart = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.OnNthTouchEnd = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return touch_ === this.trigger_index;
	};
	Cnds.prototype.HasNthTouch = function (touch_)
	{
		touch_ = Math.floor(touch_);
		return this.touches.length >= touch_ + 1;
	};
	pluginProto.cnds = new Cnds();
	function Exps() {};
	Exps.prototype.TouchCount = function (ret)
	{
		ret.set_int(this.touches.length);
	};
	Exps.prototype.X = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxX = layer.parallaxX;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxX = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxX = oldParallaxX;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, true));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.XAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.XForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxX, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxX = layer.parallaxX;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxX = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxX = oldParallaxX;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, true));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.Y = function (ret, layerparam)
	{
		if (this.touches.length)
		{
			var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
			if (cr.is_undefined(layerparam))
			{
				layer = this.runtime.getLayerByNumber(0);
				oldScale = layer.scale;
				oldZoomRate = layer.zoomRate;
				oldParallaxY = layer.parallaxY;
				oldAngle = layer.angle;
				layer.scale = this.runtime.running_layout.scale;
				layer.zoomRate = 1.0;
				layer.parallaxY = 1.0;
				layer.angle = this.runtime.running_layout.angle;
				ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				layer.scale = oldScale;
				layer.zoomRate = oldZoomRate;
				layer.parallaxY = oldParallaxY;
				layer.angle = oldAngle;
			}
			else
			{
				if (cr.is_number(layerparam))
					layer = this.runtime.getLayerByNumber(layerparam);
				else
					layer = this.runtime.getLayerByName(layerparam);
				if (layer)
					ret.set_float(layer.canvasToLayer(this.touches[0].x, this.touches[0].y, false));
				else
					ret.set_float(0);
			}
		}
		else
			ret.set_float(0);
	};
	Exps.prototype.YAt = function (ret, index, layerparam)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(this.touches[index].x, this.touches[index].y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.YForID = function (ret, id, layerparam)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var layer, oldScale, oldZoomRate, oldParallaxY, oldAngle;
		if (cr.is_undefined(layerparam))
		{
			layer = this.runtime.getLayerByNumber(0);
			oldScale = layer.scale;
			oldZoomRate = layer.zoomRate;
			oldParallaxY = layer.parallaxY;
			oldAngle = layer.angle;
			layer.scale = this.runtime.running_layout.scale;
			layer.zoomRate = 1.0;
			layer.parallaxY = 1.0;
			layer.angle = this.runtime.running_layout.angle;
			ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			layer.scale = oldScale;
			layer.zoomRate = oldZoomRate;
			layer.parallaxY = oldParallaxY;
			layer.angle = oldAngle;
		}
		else
		{
			if (cr.is_number(layerparam))
				layer = this.runtime.getLayerByNumber(layerparam);
			else
				layer = this.runtime.getLayerByName(layerparam);
			if (layer)
				ret.set_float(layer.canvasToLayer(touch.x, touch.y, false));
			else
				ret.set_float(0);
		}
	};
	Exps.prototype.AbsoluteX = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].x);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteXAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].x);
	};
	Exps.prototype.AbsoluteXForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.x);
	};
	Exps.prototype.AbsoluteY = function (ret)
	{
		if (this.touches.length)
			ret.set_float(this.touches[0].y);
		else
			ret.set_float(0);
	};
	Exps.prototype.AbsoluteYAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		ret.set_float(this.touches[index].y);
	};
	Exps.prototype.AbsoluteYForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(touch.y);
	};
	Exps.prototype.SpeedAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		var dist = cr.distanceTo(t.x, t.y, t.lastx, t.lasty);
		var timediff = (t.time - t.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.SpeedForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		var dist = cr.distanceTo(touch.x, touch.y, touch.lastx, touch.lasty);
		var timediff = (touch.time - touch.lasttime) / 1000;
		if (timediff === 0)
			ret.set_float(0);
		else
			ret.set_float(dist / timediff);
	};
	Exps.prototype.AngleAt = function (ret, index)
	{
		index = Math.floor(index);
		if (index < 0 || index >= this.touches.length)
		{
			ret.set_float(0);
			return;
		}
		var t = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(t.lastx, t.lasty, t.x, t.y)));
	};
	Exps.prototype.AngleForID = function (ret, id)
	{
		var index = this.findTouch(id);
		if (index < 0)
		{
			ret.set_float(0);
			return;
		}
		var touch = this.touches[index];
		ret.set_float(cr.to_degrees(cr.angleTo(touch.lastx, touch.lasty, touch.x, touch.y)));
	};
	Exps.prototype.Alpha = function (ret)
	{
		ret.set_float(this.getAlpha());
	};
	Exps.prototype.Beta = function (ret)
	{
		ret.set_float(this.getBeta());
	};
	Exps.prototype.Gamma = function (ret)
	{
		ret.set_float(this.getGamma());
	};
	Exps.prototype.AccelerationXWithG = function (ret)
	{
		ret.set_float(this.acc_g_x);
	};
	Exps.prototype.AccelerationYWithG = function (ret)
	{
		ret.set_float(this.acc_g_y);
	};
	Exps.prototype.AccelerationZWithG = function (ret)
	{
		ret.set_float(this.acc_g_z);
	};
	Exps.prototype.AccelerationX = function (ret)
	{
		ret.set_float(this.acc_x);
	};
	Exps.prototype.AccelerationY = function (ret)
	{
		ret.set_float(this.acc_y);
	};
	Exps.prototype.AccelerationZ = function (ret)
	{
		ret.set_float(this.acc_z);
	};
	Exps.prototype.TouchIndex = function (ret)
	{
		ret.set_int(this.trigger_index);
	};
	Exps.prototype.TouchID = function (ret)
	{
		ret.set_float(this.trigger_id);
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.plugins_.WebStorage = function(runtime)
{
	this.runtime = runtime;
};
(function()
{
	var pluginProto = cr.plugins_.WebStorage.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var prefix = "";
	var is_arcade = (typeof window["is_scirra_arcade"] !== "undefined");
	if (is_arcade)
		prefix = "arcade" + window["scirra_arcade_id"];
	var logged_sessionnotsupported = false;
	function LogSessionNotSupported()
	{
		if (logged_sessionnotsupported)
			return;
		cr.logexport("[Construct 2] Webstorage plugin: session storage is not supported on this platform. Try using local storage or global variables instead.");
		logged_sessionnotsupported = true;
	};
	instanceProto.onCreate = function()
	{
	};
	function Cnds() {};
	Cnds.prototype.LocalStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.SessionStorageEnabled = function()
	{
		return true;
	};
	Cnds.prototype.LocalStorageExists = function(key)
	{
		return localStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.SessionStorageExists = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return false;
		}
		return sessionStorage.getItem(prefix + key) != null;
	};
	Cnds.prototype.OnQuotaExceeded = function ()
	{
		return true;
	};
	Cnds.prototype.CompareKeyText = function (key, text_to_compare, case_sensitive)
	{
		var value = localStorage.getItem(prefix + key) || "";
		if (case_sensitive)
			return value == text_to_compare;
		else
			return cr.equals_nocase(value, text_to_compare);
	};
	Cnds.prototype.CompareKeyNumber = function (key, cmp, x)
	{
		var value = localStorage.getItem(prefix + key) || "";
		return cr.do_cmp(parseFloat(value), cmp, x);
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.StoreLocal = function(key, data)
	{
		try {
			localStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.StoreSession = function(key,data)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		try {
			sessionStorage.setItem(prefix + key, data);
		}
		catch (e)
		{
			this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
		}
	};
	Acts.prototype.RemoveLocal = function(key)
	{
		localStorage.removeItem(prefix + key);
	};
	Acts.prototype.RemoveSession = function(key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		sessionStorage.removeItem(prefix + key);
	};
	Acts.prototype.ClearLocal = function()
	{
		if (!is_arcade)
			localStorage.clear();
	};
	Acts.prototype.ClearSession = function()
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			return;
		}
		if (!is_arcade)
			sessionStorage.clear();
	};
	Acts.prototype.JSONLoad = function (json_, mode_)
	{
		var d;
		try {
			d = JSON.parse(json_);
		}
		catch(e) { return; }
		if (!d["c2dictionary"])			// presumably not a c2dictionary object
			return;
		var o = d["data"];
		if (mode_ === 0 && !is_arcade)	// 'set' mode: must clear webstorage first
			localStorage.clear();
		var p;
		for (p in o)
		{
			if (o.hasOwnProperty(p))
			{
				try {
					localStorage.setItem(prefix + p, o[p]);
				}
				catch (e)
				{
					this.runtime.trigger(cr.plugins_.WebStorage.prototype.cnds.OnQuotaExceeded, this);
					return;
				}
			}
		}
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.LocalValue = function(ret,key)
	{
		ret.set_string(localStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.SessionValue = function(ret,key)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		ret.set_string(sessionStorage.getItem(prefix + key) || "");
	};
	Exps.prototype.LocalCount = function(ret)
	{
		ret.set_int(is_arcade ? 0 : localStorage.length);
	};
	Exps.prototype.SessionCount = function(ret)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_int(0);
			return;
		}
		ret.set_int(is_arcade ? 0 : sessionStorage.length);
	};
	Exps.prototype.LocalAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.getItem(localStorage.key(n)) || "");
	};
	Exps.prototype.SessionAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.getItem(sessionStorage.key(n)) || "");
	};
	Exps.prototype.LocalKeyAt = function(ret,n)
	{
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(localStorage.key(n) || "");
	};
	Exps.prototype.SessionKeyAt = function(ret,n)
	{
		if (this.runtime.isCocoonJs || !sessionStorage)
		{
			LogSessionNotSupported();
			ret.set_string("");
			return;
		}
		if (is_arcade)
			ret.set_string("");
		else
			ret.set_string(sessionStorage.key(n) || "");
	};
	Exps.prototype.AsJSON = function (ret)
	{
		var o = {}, i, len, k;
		for (i = 0, len = localStorage.length; i < len; i++)
		{
			k = localStorage.key(i);
			if (is_arcade)
			{
				if (k.substr(0, prefix.length) === prefix)
				{
					o[k.substr(prefix.length)] = localStorage.getItem(k);
				}
			}
			else
				o[k] = localStorage.getItem(k);
		}
		ret.set_string(JSON.stringify({
			"c2dictionary": true,
			"data": o
		}));
	};
	pluginProto.exps = new Exps();
}());
/**
 * flood fill algorithm
 * image_data is an array with pixel information as provided in canvas_context.data
 * (x, y) is starting point and color is the color used to replace old color
 */
function flood_fill(image_data, canvas_width, canvas_height, x, y, _color) {
	if (x<0 || x>canvas_width){		return;}
	if (y<0 || y>canvas_height){	return;}
	var color = $('<div></div>').css('background-color', _color).css('background-color');
    if(color == "transparent")
        color="rgb(0,0,0)";
    color=color.slice(4,-1).split(",");
    var components = 4; //rgba
    var  fillColorR = color[0];
    var  fillColorG = color[1];
    var  fillColorB = color[2];
    var pixel_pos = (y*canvas_width + x) * components;
    var startR = image_data[pixel_pos];
    var startG = image_data[pixel_pos + 1];
    var startB = image_data[pixel_pos + 2];
    if(fillColorR==startR && fillColorG==startG && fillColorB==startB)
        return;  //prevent inf loop.
    function matchStartColor(pixel_pos) {
      return startR == image_data[pixel_pos] &&
             startG == image_data[pixel_pos+1] &&
             startB == image_data[pixel_pos+2];
    }
    function colorPixel(pixel_pos) {
      image_data[pixel_pos] = fillColorR;
      image_data[pixel_pos+1] = fillColorG;
      image_data[pixel_pos+2] = fillColorB;
      image_data[pixel_pos+3] = 255;
    }
    function trace(dir) {
        if(matchStartColor(pixel_pos + dir*components)) {
          if(!sides[dir]) {
            pixelStack.push([x + dir, y]);
            sides[dir]= true;
          }
        }
        else if(sides[dir]) {
          sides[dir]= false;
        }
    }
    var pixelStack = [[x, y]];
    while(pixelStack.length)
    {
      var newPos, x, y, pixel_pos, reachLeft, reachRight;
      newPos = pixelStack.pop();
      x = newPos[0];
      y = newPos[1];
      pixel_pos = (y*canvas_width + x) * components;
      while(y-- >= 0 && matchStartColor(pixel_pos))
      {
        pixel_pos -= canvas_width * components;
      }
      pixel_pos += canvas_width * components;
      ++y;
      var sides = [];
      sides[-1] = false;
      sides[1] = false;
      while(y++ < canvas_height-1 && matchStartColor(pixel_pos)) {
        colorPixel(pixel_pos);
        if(x > 0) {
            trace(-1);
        }
        if(x < canvas_width-1) {
            trace(1);
        }
        pixel_pos += canvas_width * components;
      }
    }
}
;
;
cr.plugins_.c2canvas = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.c2canvas.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
		this.texture_img = new Image();
		this.texture_img.src = this.texture_file;
		this.texture_img.cr_filesize = this.texture_filesize;
		this.runtime.wait_for_textures.push(this.texture_img);
	};
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	var fxNames = [ "lighter",
					"xor",
					"copy",
					"destination-over",
					"source-in",
					"destination-in",
					"source-out",
					"destination-out",
					"source-atop",
					"destination-atop"];
	instanceProto.effectToCompositeOp = function(effect)
	{
		if (effect <= 0 || effect >= 11)
			return "source-over";
		return fxNames[effect - 1];	// not including "none" so offset by 1
	};
	instanceProto.updateBlend = function(effect)
	{
		var gl = this.runtime.gl;
		if (!gl)
			return;
		this.srcBlend = gl.ONE;
		this.destBlend = gl.ONE_MINUS_SRC_ALPHA;
		switch (effect) {
		case 1:		// lighter (additive)
			this.srcBlend = gl.ONE;
			this.destBlend = gl.ONE;
			break;
		case 2:		// xor
			break;	// todo
		case 3:		// copy
			this.srcBlend = gl.ONE;
			this.destBlend = gl.ZERO;
			break;
		case 4:		// destination-over
			this.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this.destBlend = gl.ONE;
			break;
		case 5:		// source-in
			this.srcBlend = gl.DST_ALPHA;
			this.destBlend = gl.ZERO;
			break;
		case 6:		// destination-in
			this.srcBlend = gl.ZERO;
			this.destBlend = gl.SRC_ALPHA;
			break;
		case 7:		// source-out
			this.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this.destBlend = gl.ZERO;
			break;
		case 8:		// destination-out
			this.srcBlend = gl.ZERO;
			this.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 9:		// source-atop
			this.srcBlend = gl.DST_ALPHA;
			this.destBlend = gl.ONE_MINUS_SRC_ALPHA;
			break;
		case 10:	// destination-atop
			this.srcBlend = gl.ONE_MINUS_DST_ALPHA;
			this.destBlend = gl.SRC_ALPHA;
			break;
		}
	};
	instanceProto.onCreate = function()
	{
		this.visible = (this.properties[0] === 0);							// 0=visible, 1=invisible
		this.compositeOp = this.effectToCompositeOp(this.properties[1]);
		this.updateBlend(this.properties[1]);
		this.canvas = document.createElement('canvas');
		this.canvas.width=this.width;
		this.canvas.height=this.height;
		this.ctx = this.canvas.getContext('2d');
		this.ctx.drawImage(this.type.texture_img,0,0,this.width,this.height);
		this.tCanvas = document.createElement('canvas');
		this.tCtx = this.tCanvas.getContext('2d');
        this.update_tex = true;
		this.rcTex = new cr.rect(0, 0, 0, 0);
	};
	instanceProto.onDestroy = function ()
	{
	};
	instanceProto.saveToJSON = function ()
	{
		return {
            "canvas_w":this.canvas.width,
            "canvas_h":this.canvas.height,
            "image":this.ctx.getImageData(0,0,this.canvas.width,this.canvas.height).data
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
        var canvasWidth = this.canvas.width = o["canvas_w"];
        var canvasHeight = this.canvas.height = o["canvas_h"];
        var data = this.ctx.getImageData(0,0,this.canvas.width,this.canvas.height).data;
        for (var y = 0; y < canvasHeight; ++y) {
            for (var x = 0; x < canvasWidth; ++x) {
                var index = (y * canvasWidth + x)*4;
                for (var c = 0; c < 4; ++c)
                data[index+c] = o["image"][index+c];
            }
        }
	};
	instanceProto.draw_instances = function (instances, ctx)
    {
        for(var x in instances)
        {
            if(instances[x].visible==false && this.runtime.testOverlap(this, instances[x])== false)
                continue;
            ctx.save();
            ctx.scale(this.canvas.width/this.width, this.canvas.height/this.height);
            ctx.rotate(-this.angle);
            ctx.translate(-this.bquad.tlx, -this.bquad.tly);
            ctx.globalCompositeOperation = instances[x].compositeOp;//rojo
            if (instances[x].type.pattern !== undefined && instances[x].type.texture_img !== undefined) {
                instances[x].pattern = ctx.createPattern(instances[x].type.texture_img, "repeat");
            }
            instances[x].draw(ctx);
            ctx.restore();
        }
    };
	instanceProto.draw = function(ctx)
	{
		ctx.save();
		ctx.globalAlpha = this.opacity;
		ctx.globalCompositeOperation = this.compositeOp;
		var myx = this.x;
		var myy = this.y;
		if (this.runtime.pixel_rounding)
		{
			myx = Math.round(myx);
			myy = Math.round(myy);
		}
		ctx.translate(myx, myy);
		ctx.rotate(this.angle);
		ctx.drawImage(this.canvas,
						  0 - (this.hotspotX * this.width),
						  0 - (this.hotspotY * this.height),
						  this.width,
						  this.height);
		ctx.restore();
	};
	instanceProto.drawGL = function(glw)
	{
		glw.setBlend(this.srcBlend, this.destBlend);
        if (this.update_tex)
        {
            if (this.tex)
                glw.deleteTexture(this.tex);
            this.tex=glw.loadTexture(this.canvas, false, this.runtime.linearSampling);
            this.update_tex = false;
        }
		glw.setTexture(this.tex);
		glw.setOpacity(this.opacity);
		var q = this.bquad;
		if (this.runtime.pixel_rounding)
		{
			var ox = Math.round(this.x) - this.x;
			var oy = Math.round(this.y) - this.y;
			glw.quad(q.tlx + ox, q.tly + oy, q.trx + ox, q.try_ + oy, q.brx + ox, q.bry + oy, q.blx + ox, q.bly + oy);
		}
		else
			glw.quad(q.tlx, q.tly, q.trx, q.try_, q.brx, q.bry, q.blx, q.bly);
	};
	pluginProto.cnds = {};
	var cnds = pluginProto.cnds;
	pluginProto.acts = {};
	var acts = pluginProto.acts;
	acts.SetEffect = function (effect)
	{
		this.compositeOp = this.effectToCompositeOp(effect);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.DrawPoint = function (x,y, color)
	{
		var ctx=this.ctx;
		ctx.fillStyle = color;
		ctx.fillRect(x,y,1,1);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.ResizeCanvas = function (width, height)
	{
		this.canvas.width=width;
		this.canvas.height=height;
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.PasteObject = function (object)
	{
		var ctx=this.ctx;
		this.update_bbox();
		var sol = object.getCurrentSol();
		var instances;
		if (sol.select_all)
			instances = sol.type.instances;
		else
			instances = sol.instances;
		this.draw_instances(instances, ctx);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.PasteLayer = function (layer)
	{
		if (!layer || !layer.visible)
			return false;
		var ctx=this.ctx;
		this.update_bbox();
		this.tCanvas.width=this.canvas.width;
		this.tCanvas.height=this.canvas.height;
 		var t=this.tCtx;
		t.clearRect(0,0,this.tCanvas.width, this.tCanvas.height);
		this.draw_instances(layer.instances, t);
		ctx.drawImage(this.tCanvas,0,0,this.width,this.height);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.DrawBox = function (x, y, width, height, color)
	{
		this.ctx.fillStyle = color;
		this.ctx.fillRect(x,y,width,height);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.DrawLine = function (x1, y1, x2, y2, color, line_width)
	{
		var ctx = this.ctx;
		ctx.strokeStyle = color;
		ctx.lineWidth = line_width;
		ctx.beginPath();
		ctx.moveTo(x1,y1);
		ctx.lineTo(x2, y2);
		ctx.stroke();
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.ClearCanvas = function ()
	{
		this.ctx.clearRect(0,0,this.canvas.width, this.canvas.height);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.FillColor = function (color)
	{
		this.ctx.fillStyle = color;
		this.ctx.fillRect(0,0,this.canvas.width, this.canvas.height);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.fillGradient = function (gradient_style, color1, color2)
	{
		var ctx = this.ctx;
		var w =this.canvas.width;
		var h=this.canvas.height;
		var gradient;
		switch(gradient_style)
		{
		case 0: //horizontal
			gradient = ctx.createLinearGradient(0,0,w,0);
			break;
		case 1: //vertical
			gradient = ctx.createLinearGradient(0,0,0,h);
			break;
		case 2: //diagonal_down_right
			gradient = ctx.createLinearGradient(0,0,w,h);
			break;
		case 3: //diagonal_down_left
			gradient = ctx.createLinearGradient(w,0,0,h);
			break;
		case 4: //radial
			gradient = ctx.createRadialGradient(w/2,h/2,0,w/2,h/2, Math.sqrt(w*w+h*h)/2);
			break;
		}
        try{
            gradient.addColorStop(0, color1);
        }catch(e){
            gradient.addColorStop(0, "black");
        }
        try{
            gradient.addColorStop(1, color2);
        }catch(e){
            gradient.addColorStop(1, "black");
        }
		this.ctx.fillStyle = gradient;
		this.ctx.fillRect(0, 0, w, h);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.beginPath = function ()
	{
		this.ctx.beginPath();
	};
	acts.drawPath = function (color, line_width)
	{
		var ctx = this.ctx;
		ctx.strokeStyle = color;
		ctx.lineWidth = line_width;
		ctx.stroke();
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.setLineSettings = function (line_cap, line_joint)
	{
		var ctx = this.ctx;
		ctx.lineCap = ["butt","round","square"][line_cap];
		ctx.lineJoin = ["round","bevel","milet"][line_joint];
	};
	acts.fillPath = function (color)
	{
		this.ctx.fillStyle = color;
		this.ctx.fill();
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.moveTo = function (x, y)
	{
		this.ctx.moveTo(x, y);
	};
	acts.lineTo = function (x, y)
	{
		this.ctx.lineTo(x, y);
	};
	acts.arc = function (x, y, radius, start_angle, end_angle, arc_direction)
	{
		this.ctx.arc(x, y, radius, cr.to_radians(start_angle), cr.to_radians(end_angle), arc_direction==1);
	};
	acts.drawCircle = function (x, y, radius, color, line_width)
	{
		var ctx = this.ctx;
		ctx.strokeStyle = color;
		ctx.lineWidth = line_width;
		ctx.beginPath();
		ctx.arc(x, y, radius, 0, cr.to_radians(360), true);
		ctx.stroke();
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	acts.bezierCurveTo = function (cp1x, cp1y, cp2x, cp2y, x, y)
	{
		this.ctx.bezierCurveTo(cp1x, cp1y, cp2x, cp2y, x, y);
	};
	acts.quadraticCurveTo = function (cpx, cpy, x, y)
	{
		this.ctx.quadraticCurveTo(cpx, cpy, x, y);
	};
	acts.rectPath = function (x, y, width, height)
	{
		this.ctx.rect(x,y,width,height);
	};
	acts.FloodFill= function (x,y,color)
	{
		var ctx = this.ctx;
		var I = ctx.getImageData(0, 0, this.canvas.width, this.canvas.height);
		flood_fill(I.data, this.canvas.width, this.canvas.height, x, y, color);
		ctx.putImageData(I,0,0);
		this.runtime.redraw = true;
        this.update_tex = true;
	};
	pluginProto.exps = {};
	var exps = pluginProto.exps;
	exps.rgbaAt = function (ret, x, y)
	{
		var imageData= this.ctx.getImageData(x,y,1,1);
		var data= imageData.data;
		ret.set_string("rgba(" + data[0] + "," + data[1] + "," + data[2] + "," + data[3]/255 + ")");
	};
    exps.redAt = function (ret, x, y)
	{
		var imageData= this.ctx.getImageData(x,y,1,1);
		var data= imageData.data;
		ret.set_int(data[0]);
	};
    exps.greenAt = function (ret, x, y)
	{
		var imageData= this.ctx.getImageData(x,y,1,1);
		var data= imageData.data;
		ret.set_int(data[1]);
	};
    exps.blueAt = function (ret, x, y)
	{
		var imageData= this.ctx.getImageData(x,y,1,1);
		var data= imageData.data;
		ret.set_int(data[2]);
	};
    exps.alphaAt = function (ret, x, y)
	{
		var imageData= this.ctx.getImageData(x,y,1,1);
		var data= imageData.data;
		ret.set_int(data[3]*100/255);
	};
	exps.imageUrl = function (ret)
	{
		ret.set_string(this.canvas.toDataURL());
	};
    exps.AsJSON = function(ret)
    {
        ret.set_string( JSON.stringify({
			"c2array": true,
			"size": [1, 1, this.canvas.width * this.canvas.height * 4],
			"data": [[this.ctx.getImageData(0, 0, this.canvas.width, this.canvas.height).data]]
		}));
    };
}());
;
;
cr.plugins_.googleplay = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var pluginProto = cr.plugins_.googleplay.prototype;
	pluginProto.Type = function(plugin)
	{
		this.plugin = plugin;
		this.runtime = plugin.runtime;
	};
	var typeProto = pluginProto.Type.prototype;
	typeProto.onCreate = function()
	{
	};
	var applicationId = "";
	var clientId = "";
	var isLoaded = false;
	var fireLoadedFirstTick = false;
	var isSignedIn = false;
	var lastError = "";
	var theInst = null;
	var my_playerid = "";
	var my_displayname = "";
	var my_avatarurl = "";
	var my_givenname = "";
	var my_familyname = "";
	var hiscores_total = 0;
	var hiscores_mybest = 0;
	var hiscores_myformattedbest = "";
	var hiscores_mybesttag = "";
	var hiscores_myrank = 0;
	var hiscores_myformattedrank = "";
	var hiscores_page = null;
	var achievements_page = null;
	var achievements_by_id = {};
	var achievement_trigger_id = "";
	pluginProto.Instance = function(type)
	{
		this.type = type;
		this.runtime = type.runtime;
	};
	var instanceProto = pluginProto.Instance.prototype;
	function addMetaTag(name, content)
	{
		var meta = document.createElement("meta");
		meta["name"] = name;
		meta["content"] = content;
		document.head.appendChild(meta);
	};
	function addScriptTag(src)
	{
		var s = document.createElement("script");
		s["type"] = "text/javascript";
		s["async"] = true;
		s["src"] = src;
		document.head.appendChild(s);
	};
	window["googlePlayLoadCallback"] = function ()
	{
		isLoaded = true;
		if (theInst.runtime.running_layout)
		{
			theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnLoaded, theInst);
		}
		else
		{
			fireLoadedFirstTick = true;
		}
	};
	window["googlePlaySigninCallback"] = function (auth)
	{
		if (auth["status"] && auth["status"]["signed_in"])
		{
			isSignedIn = true;
			theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnSignedIn, theInst);
		}
		else if (auth["error"] === "user_signed_out")
		{
			isSignedIn = false;
			lastError = "user_signed_out";
			theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnSignedOut, theInst);
		}
		else if (auth["error"] === "immediate_failed")
		{
			isSignedIn = false;
			lastError = "immediate_failed";
			theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAutoSignInFailed, theInst);
		}
		else
		{
			isSignedIn = false;
			lastError = auth["error"].toString();
			theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
		}
	};
	instanceProto.onCreate = function()
	{
		applicationId = this.properties[0];
		clientId = this.properties[1];
		if (this.runtime.isDomFree)
			return;		// cannot add meta tags in dom-free wrappers
		theInst = this;
		addMetaTag("google-signin-clientid", clientId);
		addMetaTag("google-signin-cookiepolicy", "single_host_origin");
		addMetaTag("google-signin-callback", "googlePlaySigninCallback");
		addMetaTag("google-signin-scope", "https://www.googleapis.com/auth/games");
		addScriptTag("https://apis.google.com/js/client.js?onload=googlePlayLoadCallback");
		this.runtime.tickMe(this);
	};
	instanceProto.onDestroy = function ()
	{
	};
	instanceProto.saveToJSON = function ()
	{
		return {
		};
	};
	instanceProto.loadFromJSON = function (o)
	{
	};
	instanceProto.onLayoutChange = function ()
	{
		if (isLoaded)
			this.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnLoaded, this);
		if (isSignedIn)
			this.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnSignedIn, this);
	};
	instanceProto.tick = function ()
	{
		if (fireLoadedFirstTick)
		{
			fireLoadedFirstTick = false;
			this.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnLoaded, this);
		}
	};
	function Cnds() {};
	Cnds.prototype.OnLoaded = function ()
	{
		return true;
	};
	Cnds.prototype.IsLoaded = function ()
	{
		return isLoaded;
	};
	Cnds.prototype.OnSignedIn = function ()
	{
		return true;
	};
	Cnds.prototype.OnSignedOut = function ()
	{
		return true;
	};
	Cnds.prototype.IsSignedIn = function ()
	{
		return isSignedIn;
	};
	Cnds.prototype.OnError = function ()
	{
		return true;
	};
	Cnds.prototype.OnPlayerDetails = function ()
	{
		return true;
	};
	Cnds.prototype.OnAutoSignInFailed = function ()
	{
		return true;
	};
	Cnds.prototype.OnScoreSubmitSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnScoreSubmitFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnHiScoreRequestSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnHiScoreRequestFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnAchievementsRequestSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnAchievementsRequestFail = function ()
	{
		return true;
	};
	Cnds.prototype.CompareAchievementState = function (i, s)
	{
		var a = getAchievementAt(i);
		if (!a)
			return false;
		var str = a["achievementState"];
		if (s === 0)
			return str === "HIDDEN";
		if (s === 1)
			return str === "REVEALED";
		if (s === 2)
			return str === "UNLOCKED";
		return false;
	};
	Cnds.prototype.OnAchievementsMetadataSuccess = function ()
	{
		return true;
	};
	Cnds.prototype.OnAchievementsMetadataFail = function ()
	{
		return true;
	};
	Cnds.prototype.OnAchievementRevealed = function (id)
	{
		return achievement_trigger_id === id;
	};
	Cnds.prototype.OnAchievementUnlocked = function (id)
	{
		return achievement_trigger_id === id;
	};
	pluginProto.cnds = new Cnds();
	function Acts() {};
	function getErrorString(err)
	{
		if (typeof err === "string")
			return err;
		else if (typeof err["message"] === "string")
			return err["message"]
		else
			return "unknown";
	};
	Acts.prototype.RequestPlayerDetails = function ()
	{
		if (!isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/players/me",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				my_playerid = response["playerId"] || "";
				my_displayname = response["displayName"] || "";
				my_avatarurl = response["avatarImageUrl"] || "";
				if (response["name"])
				{
					my_givenname = response["name"]["givenName"] || "";
					my_familyname = response["name"]["familyName"] || "";
				}
				else
				{
					my_givenname = "";
					my_familyname = "";
				}
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnPlayerDetails, theInst);
			}
		});
	};
	Acts.prototype.SignIn = function ()
	{
		if (!isLoaded || isSignedIn)
			return;
		gapi["auth"]["signIn"]({
			"callback": window["googlePlaySigninCallback"]
		});
	};
	Acts.prototype.SignOut = function ()
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["auth"]["signOut"]();
	};
	Acts.prototype.SubmitScore = function (leaderboardId, score, tag)
	{
		if (!isLoaded || !isSignedIn)
			return;
		var params = {
			"leaderboardId": leaderboardId,
			"score": score
		};
		if (tag)
			params["scoreTag"] = tag;
		gapi["client"]["request"]({
			"path": "/games/v1/leaderboards/" + leaderboardId + "/scores",
			"params": params,
			"method": "post",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnScoreSubmitFail, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnScoreSubmitFail, theInst);
					return;
				}
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnScoreSubmitSuccess, theInst);
			}
		});
	};
	Acts.prototype.RequestHiScores = function (leaderboardId, collection, timespan, maxresults, type)
	{
		if (!isLoaded || !isSignedIn)
			return;
		var collectionstr = (collection === 0 ? "PUBLIC" : "SOCIAL");
		var timespanstr = "ALL_TIME";
		if (timespan === 1)
			timespanstr = "WEEKLY";
		else if (timespan === 2)
			timespanstr = "DAILY";
		var params = {
			"leaderboardId": leaderboardId,
			"collection": collectionstr,
			"timeSpan": timespanstr,
			"maxResults": maxresults
		};
		var typestr = "scores";
		if (type === 1)
			typestr = "window";
		gapi["client"]["request"]({
			"path": "/games/v1/leaderboards/" + leaderboardId + "/" + typestr + "/" + collectionstr,
			"params": params,
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnHiScoreRequestFail, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnHiScoreRequestFail, theInst);
					return;
				}
				hiscores_total = parseInt(response["numScores"], 10) || 0;
				if (response["playerScore"])
				{
					hiscores_mybest = parseInt(response["playerScore"]["scoreValue"], 10) || 0;
					hiscores_myformattedbest = response["playerScore"]["formattedScore"] || "";
					hiscores_mybesttag = response["playerScore"]["scoreTag"] || "";
					hiscores_myrank = parseInt(response["playerScore"]["scoreRank"], 10) || 0;
					hiscores_myformattedrank = response["playerScore"]["formattedScoreRank"] || "";
				}
				else
				{
					hiscores_mybest = 0;
					hiscores_myformattedbest = "";
					hiscores_mybesttag = "";
					hiscores_myrank = 0;
					hiscores_myformattedrank = "";
				}
				hiscores_page = response["items"];
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnHiScoreRequestSuccess, theInst);
			}
		});
	};
	Acts.prototype.RequestAchievements = function (which)
	{
		if (!isLoaded || !isSignedIn)
			return;
		var whichstr = "ALL";
		if (which === 1)
			whichstr = "HIDDEN";
		else if (which === 2)
			whichstr = "REVEALED";
		else if (which === 3)
			whichstr = "UNLOCKED";
		gapi["client"]["request"]({
			"path": "/games/v1/players/me/achievements",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsRequestFail, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsRequestFail, theInst);
					return;
				}
				achievements_page = response["items"];
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsRequestSuccess, theInst);
			}
		});
	};
	Acts.prototype.RequestAchievementMetadata = function ()
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/achievements",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsMetadataFail, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsMetadataFail, theInst);
					return;
				}
				achievements_by_id = {};
				var i, len, a, items = response["items"];
				for (i = 0, len = items.length; i < len; ++i)
				{
					a = items[i];
					achievements_by_id[a["id"]] = {
						name: a["name"],
						description: a["description"],
						type: a["achievementType"],
						totalSteps: a["totalSteps"],
						revealedUrl: a["revealedIconUrl"],
						unlockedUrl: a["unlockedIconUrl"]
					};
				}
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementsMetadataSuccess, theInst);
			}
		});
	};
	Acts.prototype.RevealAchievement = function (id)
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/achievements/" + id + "/reveal",
			"method": "post",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				achievement_trigger_id = id;
				theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementRevealed, theInst);
			}
		});
	};
	Acts.prototype.UnlockAchievement = function (id)
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/achievements/" + id + "/unlock",
			"method": "post",
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["newlyUnlocked"])
				{
					achievement_trigger_id = id;
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementUnlocked, theInst);
				}
			}
		});
	};
	Acts.prototype.IncrementAchievement = function (id, steps)
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/achievements/" + id + "/increment",
			"method": "post",
			"params": {
				"stepsToIncrement": steps
			},
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["newlyUnlocked"])
				{
					achievement_trigger_id = id;
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementUnlocked, theInst);
				}
			}
		});
	};
	Acts.prototype.SetStepsAchievement = function (id, steps)
	{
		if (!isLoaded || !isSignedIn)
			return;
		gapi["client"]["request"]({
			"path": "/games/v1/achievements/" + id + "/setStepsAtLeast",
			"method": "post",
			"params": {
				"steps": steps
			},
			"callback": function (response)
			{
				if (!response)
				{
					lastError = "no_response";
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["error"])
				{
					lastError = getErrorString(response["error"]);
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnError, theInst);
					return;
				}
				if (response["newlyUnlocked"])
				{
					achievement_trigger_id = id;
					theInst.runtime.trigger(cr.plugins_.googleplay.prototype.cnds.OnAchievementUnlocked, theInst);
				}
			}
		});
	};
	pluginProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.ErrorMessage = function (ret)
	{
		ret.set_string(lastError);
	};
	Exps.prototype.MyID = function (ret)
	{
		ret.set_string(my_playerid);
	};
	Exps.prototype.MyDisplayName = function (ret)
	{
		ret.set_string(my_displayname);
	};
	Exps.prototype.MyAvatarUrl = function (ret)
	{
		ret.set_string(my_avatarurl);
	};
	Exps.prototype.MyGivenName = function (ret)
	{
		ret.set_string(my_givenname);
	};
	Exps.prototype.MyFamilyName = function (ret)
	{
		ret.set_string(my_familyname);
	};
	Exps.prototype.HiScoreTotalCount = function (ret)
	{
		ret.set_int(hiscores_total);
	};
	Exps.prototype.HiScoreMyBest = function (ret)
	{
		ret.set_int(hiscores_mybest);
	};
	Exps.prototype.HiScoreMyBestTag = function (ret)
	{
		ret.set_string(hiscores_mybesttag);
	};
	Exps.prototype.HiScoreMyFormattedBest = function (ret)
	{
		ret.set_string(hiscores_myformattedbest);
	};
	Exps.prototype.HiScoreMyBestRank = function (ret)
	{
		ret.set_int(hiscores_myrank);
	};
	Exps.prototype.HiScoreMyBestFormattedRank = function (ret)
	{
		ret.set_string(hiscores_myformattedrank);
	};
	Exps.prototype.HiScoreCount = function (ret)
	{
		ret.set_int(hiscores_page ? (hiscores_page.length || 0) : 0);
	};
	function getScoreAt(i)
	{
		if (!hiscores_page)
			return null;
		i = Math.floor(i);
		if (i < 0 || i >= hiscores_page.length)
			return null;
		return hiscores_page[i];
	};
	Exps.prototype.HiScoreNameAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_string((s && s["player"]) ? (s["player"]["displayName"] || "") : "");
	};
	Exps.prototype.HiScoreRankAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_int(s ? (parseInt(s["scoreRank"], 10) || 0) : 0);
	};
	Exps.prototype.HiScoreAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_int(s ? (parseInt(s["scoreValue"], 10) || 0) : 0);
	};
	Exps.prototype.HiScoreTagAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_string((s && s["scoreTag"]) ? (s["scoreTag"] || "") : "");
	};
	Exps.prototype.HiScoreFormattedAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_string((s && s["formattedScore"]) ? (s["formattedScore"] || "") : "");
	};
	Exps.prototype.HiScoreFormattedRankAt = function (ret, i)
	{
		var s = getScoreAt(i);
		ret.set_string((s && s["formattedScoreRank"]) ? (s["formattedScoreRank"] || "") : "");
	};
	function getAchievementAt(i)
	{
		if (!achievements_page)
			return null;
		i = Math.floor(i);
		if (i < 0 || i >= achievements_page.length)
			return null;
		return achievements_page[i];
	};
	function getAchievementMetadataAt(i)
	{
		var a = getAchievementAt(i);
		if (!a)
			return null;
		var id = a["id"];
		if (!achievements_by_id.hasOwnProperty(id))
			return null;
		return achievements_by_id[id];
	};
	Exps.prototype.AchievementsCount = function (ret)
	{
		ret.set_int(achievements_page ? (achievements_page.length || 0) : 0);
	};
	Exps.prototype.AchievementIDAt = function (ret, i)
	{
		var a = getAchievementAt(i);
		ret.set_string(a ? (a["id"] || "") : "");
	};
	Exps.prototype.AchievementStepsAt = function (ret, i)
	{
		var a = getAchievementAt(i);
		ret.set_int(a ? (a["currentSteps"] || 0) : 0);
	};
	Exps.prototype.AchievementNameAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_string(a ? (a.name || "") : "");
	};
	Exps.prototype.AchievementDescriptionAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_string(a ? (a.description || "") : "");
	};
	Exps.prototype.AchievementTypeAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_string(a ? (a.type || "").toLowerCase() : "");
	};
	Exps.prototype.AchievementTotalStepsAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_int(a ? (a.totalSteps || 0) : 0);
	};
	Exps.prototype.AchievementRevealedIconURLAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_string(a ? (a.revealedUrl || "") : "");
	};
	Exps.prototype.AchievementUnlockedIconURLAt = function (ret, i)
	{
		var a = getAchievementMetadataAt(i);
		ret.set_string(a ? (a.unlockedUrl || "") : "");
	};
	pluginProto.exps = new Exps();
}());
;
;
cr.behaviors.Rex_MoveTo = function(runtime)
{
	this.runtime = runtime;
};
(function ()
{
	var behaviorProto = cr.behaviors.Rex_MoveTo.prototype;
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
        this.enabled = (this.properties[0] == 1);
        this.move = {"max":this.properties[1],
                     "acc":this.properties[2],
                     "dec":this.properties[3]};
        this.target = {"x":0 , "y":0, "a":0};
        this.is_moving = false;
        this.current_speed = 0;
        this.remain_distance = 0;
        this.is_hit_target = false;
        this._pre_pos = {"x":0,"y":0};
        this._moving_angle_info = {"x":0,"y":0,"a":(-1)};
        this._last_tick = null;
        this.is_my_call = false;
	};
	behinstProto.tick = function ()
	{
        if (this.is_hit_target)
        {
		    if ((this.inst.x == this.target["x"]) && (this.inst.y == this.target["y"]))
			{
                this.is_my_call = true;
                this.runtime.trigger(cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget, this.inst);
                this.is_my_call = false;
	        }
            this.is_hit_target = false;
        }
        if ( (!this.enabled) || (!this.is_moving) )
        {
            return;
        }
		var dt = this.runtime.getDt(this.inst);
        if (dt==0)   // can not move if dt == 0
            return;
        if ((this._pre_pos["x"] != this.inst.x) || (this._pre_pos["y"] != this.inst.y))
		    this._reset_current_pos();    // reset this.remain_distance
        var is_slow_down = false;
        if (this.move["dec"] != 0)
        {
            var _speed = this.current_speed;
            var _distance = (_speed*_speed)/(2*this.move["dec"]); // (v*v)/(2*a)
            is_slow_down = (_distance >= this.remain_distance);
        }
        var acc = (is_slow_down)? (-this.move["dec"]):this.move["acc"];
        if (acc != 0)
        {
            this.SetCurrentSpeed( this.current_speed + (acc * dt) );
        }
        var distance = this.current_speed * dt;
        this.remain_distance -= distance;
        if ( (this.remain_distance <= 0) || (this.current_speed <= 0) )
        {
            this.is_moving = false;
            this.inst.x = this.target["x"];
            this.inst.y = this.target["y"];
            this.SetCurrentSpeed(0);
            this.moving_angle_get();
            this.is_hit_target = true;
        }
        else
        {
            var angle = this.target["a"];
            this.inst.x += (distance * Math.cos(angle));
            this.inst.y += (distance * Math.sin(angle));
        }
		this.inst.set_bbox_changed();
		this._pre_pos["x"] = this.inst.x;
		this._pre_pos["y"] = this.inst.y;
	};
	behinstProto.tick2 = function ()
	{
        this._moving_angle_info["x"] = this.inst.x;
		this._moving_angle_info["y"] = this.inst.y;
    };
	behinstProto.SetCurrentSpeed = function(speed)
	{
        if (speed != null)
        {
            this.current_speed = (speed > this.move["max"])?
                                 this.move["max"]: speed;
        }
        else if (this.move["acc"]==0)
        {
            this.current_speed = this.move["max"];
        }
	};
	behinstProto._reset_current_pos = function ()
	{
        var dx = this.target["x"] - this.inst.x;
        var dy = this.target["y"] - this.inst.y;
        this.target["a"] = Math.atan2(dy, dx);
        this.remain_distance = Math.sqrt( (dx*dx) + (dy*dy) );
		this._pre_pos["x"] = this.inst.x;
		this._pre_pos["y"] = this.inst.y;
	};
	behinstProto.SetTargetPos = function (_x, _y)
	{
        this.is_moving = true;
		this.target["x"] = _x;
        this.target["y"] = _y;
        this._reset_current_pos();
        this.SetCurrentSpeed(null);
		this._moving_angle_info["x"] = this.inst.x;
		this._moving_angle_info["y"] = this.inst.y;
	};
	behinstProto.is_tick_changed = function ()
	{
	    var cur_tick = this.runtime.tickcount;
		var tick_changed = (this._last_tick != cur_tick);
        this._last_tick = cur_tick;
		return tick_changed;
	};
 	behinstProto.moving_angle_get = function (ret)
	{
        if (this.is_tick_changed())
        {
            var dx = this.inst.x - this._moving_angle_info["x"];
            var dy = this.inst.y - this._moving_angle_info["y"];
            if ((dx!=0) || (dy!=0))
                this._moving_angle_info["a"] = cr.to_clamped_degrees(Math.atan2(dy,dx));
        }
		return this._moving_angle_info["a"];
	};
	behinstProto.saveToJSON = function ()
	{
		return { "en": this.enabled,
		         "v": this.move,
                 "t": this.target,
                 "is_m": this.is_moving,
                 "c_spd" : this.current_speed,
                 "rd" : this.remain_distance,
                 "is_ht" : this.is_hit_target,
                 "pp": this._pre_pos,
                 "ma": this._moving_angle_info,
                 "lt": this._last_tick,
               };
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.enabled = o["en"];
		this.move = o["v"];
		this.target = o["t"];
		this.is_moving = o["is_m"];
		this.current_speed = o["c_spd"];
		this.remain_distance = o["rd"];
		this.is_hit_target = o["is_ht"];
        this._pre_pos = o["pp"];
        this._moving_angle_info = o["ma"];
        this._last_tick = o["lt"];
	};
	function Cnds() {};
	behaviorProto.cnds = new Cnds();
	Cnds.prototype.OnHitTarget = function ()
	{
		return (this.is_my_call);
	};
	Cnds.prototype.CompareSpeed = function (cmp, s)
	{
		return cr.do_cmp(this.current_speed, cmp, s);
	};
    Cnds.prototype.OnMoving = function ()  // deprecated
	{
		return false;
	};
	Cnds.prototype.IsMoving = function ()
	{
		return (this.enabled && this.is_moving);
	};
	Cnds.prototype.CompareMovingAngle = function (cmp, s)
	{
        var angle = this.moving_angle_get();
        if (angle != (-1))
		    return cr.do_cmp(this.moving_angle_get(), cmp, s);
        else
            return false;
	};
	function Acts() {};
	behaviorProto.acts = new Acts();
	Acts.prototype.SetEnabled = function (en)
	{
		this.enabled = (en === 1);
	};
	Acts.prototype.SetMaxSpeed = function (s)
	{
		this.move["max"] = s;
        this.SetCurrentSpeed(null);
	};
	Acts.prototype.SetAcceleration = function (a)
	{
		this.move["acc"] = a;
        this.SetCurrentSpeed(null);
	};
	Acts.prototype.SetDeceleration = function (a)
	{
		this.move["dec"] = a;
	};
	Acts.prototype.SetTargetPos = function (_x, _y)
	{
        this.SetTargetPos(_x, _y)
	};
	Acts.prototype.SetCurrentSpeed = function (s)
	{
        this.SetCurrentSpeed(s);
	};
 	Acts.prototype.SetTargetPosOnObject = function (objtype)
	{
		if (!objtype)
			return;
		var inst = objtype.getFirstPicked();
        if (inst != null)
            this.SetTargetPos(inst.x, inst.y);
	};
 	Acts.prototype.SetTargetPosByDeltaXY = function (dx, dy)
	{
        this.SetTargetPos(this.inst.x + dx, this.inst.y + dy);
	};
 	Acts.prototype.SetTargetPosByDistanceAngle = function (distance, angle)
	{
        var a = cr.to_clamped_radians(angle);
        var dx = distance*Math.cos(a);
        var dy = distance*Math.sin(a);
        this.SetTargetPos(this.inst.x + dx, this.inst.y + dy);
	};
 	Acts.prototype.Stop = function ()
	{
        this.is_moving = false;
	};
	function Exps() {};
	behaviorProto.exps = new Exps();
	Exps.prototype.Activated = function (ret)
	{
		ret.set_int((this.enabled)? 1:0);
	};
	Exps.prototype.Speed = function (ret)
	{
		ret.set_float(this.current_speed);
	};
	Exps.prototype.MaxSpeed = function (ret)
	{
		ret.set_float(this.move["max"]);
	};
	Exps.prototype.Acc = function (ret)
	{
		ret.set_float(this.move["acc"]);
	};
 	Exps.prototype.Dec = function (ret)
	{
		ret.set_float(this.move["dec"]);
	};
	Exps.prototype.TargetX = function (ret)
	{
		ret.set_float(this.target["x"]);
	};
 	Exps.prototype.TargetY = function (ret)
	{
		ret.set_float(this.target["y"]);
	};
 	Exps.prototype.MovingAngle = function (ret)
	{
		ret.set_float(this.moving_angle_get());
	};
}());
;
;
cr.behaviors.SpriteButton = function(runtime)
{
	this.runtime = runtime;
	var self = this;
	if (!this.runtime.isDomFree)
	{
		jQuery(document).mousemove(
			function(info)
			{
				self.onMouseMove(info);
			});
		jQuery(document).mousedown(
			function(info)
			{
				self.onMouseDown(info);
			});
		jQuery(document).mouseup(
			function(info)
			{
				self.onMouseUp(info);
			});
	}
	var elem = (this.runtime.fullscreen_mode > 0) ? document : this.runtime.canvas;
	if (this.runtime.isDirectCanvas)
		elem = window["Canvas"];
	else if (this.runtime.isCocoonJs)
		elem = window;
	elem.addEventListener("touchstart",
		function(info)
		{
			self.onTouchStart(info);
		},
		false);
	elem.addEventListener("touchmove",
		function(info)
		{
			self.onTouchMove(info);
		},
		false);
	elem.addEventListener("touchend",
		function(info)
		{
			self.onTouchEnd(info);
		},
		false);
	elem.addEventListener("touchcancel",
		function(info)
		{
			self.onTouchEnd(info);
		},
		false);
	if (window.navigator["msPointerEnabled"])
	{
		elem.addEventListener("MSPointerDown",
			function(info)
			{
				self.onPointerStart(info);
			},
			false);
		elem.addEventListener("MSPointerMove",
			function(info)
			{
				self.onPointerMove(info);
			},
			false);
		elem.addEventListener("MSPointerUp",
			function(info)
			{
				self.onPointerEnd(info);
			},
			false);
		elem.addEventListener("MSPointerCancel",
			function(info)
			{
				self.onPointerEnd(info);
			},
			false);
	}
};
(function ()
{
	var behaviorProto = cr.behaviors.SpriteButton.prototype;
	var dummyoffset = {left: 0, top: 0};
	behaviorProto.Type = function(behavior, objtype)
	{
		this.behavior = behavior;
		this.objtype = objtype;
		this.runtime = behavior.runtime;
		this.leftButtonDown = false;
		this.middleButtonDown = false;
		this.rightButtonDown = false;
	};
	var behtypeProto = behaviorProto.Type.prototype;
	behtypeProto.onCreate = function()
	{
	};
	behaviorProto.onMouseDown = function (info)
	{
		switch (info.which)
		{
			case 1:
				this.leftButtonDown = true;
				break;
			case 2:
				this.middleButtonDown = true;
				break;
			case 3:
				this.rightButtonDown = true;
				break;
		}
		this.onInputDown(null, info.pageX, info.pageY);
	};
	behaviorProto.onMouseMove = function (info)
	{
		this.onInputMove(null, info.pageX, info.pageY);
	};
	behaviorProto.onMouseUp = function (info)
	{
		switch (info.which)
		{
			case 1:
				this.leftButtonDown = false;
				break;
			case 2:
				this.middleButtonDown = false;
				break;
			case 3:
				this.rightButtonDown = false;
				break;
		}
		this.onInputUp(null, info.pageX, info.pageY, true);
	};
	behaviorProto.onTouchStart = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputDown(id ? id.toString() : null, t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchMove = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputMove(id ? id.toString() : null, t.pageX, t.pageY);
		}
	};
	behaviorProto.onTouchEnd = function (info)
	{
		if (info.preventDefault)
			info.preventDefault();
		var i, len, t, id;
		for (i = 0, len = info.changedTouches.length; i < len; i++)
		{
			t = info.changedTouches[i];
			id = t.identifier;
			this.onInputUp(id ? id.toString() : null, t.pageX, t.pageY, false);
		}
	};
	behaviorProto.onPointerStart = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"])
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputDown(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerMove = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"])
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputMove(info["pointerId"].toString(), info.pageX, info.pageY);
	};
	behaviorProto.onPointerEnd = function (info)
	{
		if (info["pointerType"] === info["MSPOINTER_TYPE_MOUSE"])
			return;
		if (info.preventDefault)
			info.preventDefault();
		this.onInputUp(info["pointerId"].toString(), info.pageX, info.pageY, true);
	};
	function GetSpriteButtonBehavior(inst)
	{
		var i, len;
		for (i = 0, len = inst.behavior_insts.length; i < len; i++)
		{
			if (inst.behavior_insts[i] instanceof behaviorProto.Instance)
				return inst.behavior_insts[i];
		}
		return null;
	};
	behaviorProto.onInputDown = function (src, pageX, pageY)
	{
		var arr = this.my_instances.valuesRef();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var i, len, b, inst, topmost = null;
		var lx, ly;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			var b = GetSpriteButtonBehavior(inst);
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			if (inst.contains_pt(lx, ly) && !b.touchSource)
			{
				b.touchSource = src;
				b.buttonState = "click";
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame.apply(inst, [b.clickFrame]);
			}
		}
	};
	behaviorProto.onInputMove = function (src, pageX, pageY)
	{
		var arr = this.my_instances.valuesRef();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var i, len, b, inst, topmost = null;
		var lx, ly;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			var b = GetSpriteButtonBehavior(inst);
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			b.status = "[" + src + "]" + "(" + lx + ", " + ly + ")";
			if (inst.contains_pt(lx, ly))
			{
				if (src != null &&(b.touchSource == null || src == b.touchSource))
				{
					b.touchSource = src;
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame.apply(inst, [b.clickFrame])
				}
				else if (src == null)
				{
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame.apply(inst, this.leftButtonDown? [b.clickFrame] : [b.hoverFrame])
				}
			}
			else
			{
				if (src == null || src == b.touchSource)
				{
					b.touchSource = null;
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame.apply(inst, [b.normalFrame])
				}
			}
		}
	};
	behaviorProto.onInputUp = function (src, pageX, pageY, hover)
	{
		var arr = this.my_instances.valuesRef();
		var offset = this.runtime.isDomFree ? dummyoffset : jQuery(this.runtime.canvas).offset();
		var x = pageX - offset.left;
		var y = pageY - offset.top;
		var i, len, b, inst;
		var lx, ly;
		for (i = 0, len = arr.length; i < len; i++)
		{
			inst = arr[i];
			b = GetSpriteButtonBehavior(inst);
			lx = inst.layer.canvasToLayer(x, y, true);
			ly = inst.layer.canvasToLayer(x, y, false);
			inst.update_bbox();
			if (inst.contains_pt(lx, ly) && (src == null || src == b.touchSource))
			{
				b.touchSource = null;
				cr.plugins_.Sprite.prototype.acts.SetAnimFrame.apply(inst, hover? [b.hoverFrame] : [b.normalFrame]);
				b.runtime.trigger(cr.behaviors.SpriteButton.prototype.cnds.OnClick, inst);
			}
		}
	};
	behaviorProto.Instance = function(type, inst)
	{
		this.type = type;
		this.behavior = type.behavior;
		this.inst = inst;				// associated object instance to modify
		this.runtime = type.runtime;
		this.touchSource = null;
		this.status = "";
	};
	var behinstProto = behaviorProto.Instance.prototype;
	behinstProto.onCreate = function()
	{
		this.normalFrame = this.properties[0];
		this.hoverFrame = this.properties[1];
		this.clickFrame = this.properties[2];
	};
	behinstProto.saveToJSON = function ()
	{
		return{
			"normalFrame": this.normalFrame,
			"hoverFrame": this.hoverFrame,
			"clickFrame": this.clickFrame
		};
	};
	behinstProto.loadFromJSON = function (o)
	{
		this.normalFrame = o["normalFrame"];
		this.hoverFrame = o["hoverFrame"];
		this.clickFrame = o["clickFrame"];
	};
	behinstProto.tick = function ()
	{
		var dt = this.runtime.getDt(this.inst);
		if (dt === 0)
			return;
	};
	function Cnds() {};
	Cnds.prototype.OnClick = function ()
	{
		return true;
	};
	behaviorProto.cnds = new Cnds();
	function Acts() {};
	Acts.prototype.SetNormalFrame = function (value)
	{
		this.normalFrame = value;
	};
	Acts.prototype.SetHoverFrame = function (value)
	{
		this.hoverFrame = value;
	};
	Acts.prototype.SetClickFrame = function (value)
	{
		this.clickFrame = value;
	};
	behaviorProto.acts = new Acts();
	function Exps() {};
	Exps.prototype.NormalFrame = function (ret)
	{
		ret.set_int(this.normalFrame);
	};
	Exps.prototype.HoverFrame = function (ret)
	{
		ret.set_int(this.hoverFrame);
	};
	Exps.prototype.ClickFrame = function (ret)
	{
		ret.set_int(this.clickFrame);
	};
	Exps.prototype.Status = function(ret)
	{
		ret.set_string(this.status);
	};
	behaviorProto.exps = new Exps();
}());
cr.getProjectModel = function() { return [
	null,
	"Layout 1",
	[
	[
		cr.plugins_.c2canvas,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		false,
		false
	]
,	[
		cr.plugins_.Browser,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.CJSAds,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.googleplay,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Mouse,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.Sprite,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		false
	]
,	[
		cr.plugins_.SpriteFont,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		false,
		false
	]
,	[
		cr.plugins_.Spritefont2,
		false,
		true,
		true,
		true,
		true,
		true,
		true,
		true,
		true
	]
,	[
		cr.plugins_.Touch,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
,	[
		cr.plugins_.WebStorage,
		true,
		false,
		false,
		false,
		false,
		false,
		false,
		false,
		false
	]
	],
	[
	[
		"t0",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2297993684647927,
			[
				["buttonupgrade1-sheet0.png", 14426, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade1-sheet0.png", 14426, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1983979921039069
		]
		],
		false,
		false,
		3575284989600479,
		[],
		null
	]
,	[
		"t1",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8993916822178352,
			[
				["buttonupgrade2-sheet0.png", 16123, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade2-sheet0.png", 16123, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			5423575179469021
		]
		],
		false,
		false,
		1891506526680377,
		[],
		null
	]
,	[
		"t2",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4382907532571328,
			[
				["buttonupgrade3-sheet0.png", 15180, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade3-sheet0.png", 15180, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			5914700258747705
		]
		],
		false,
		false,
		1308453213301661,
		[],
		null
	]
,	[
		"t3",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5761411870921612,
			[
				["buttonupgrade4-sheet0.png", 12936, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade4-sheet0.png", 12936, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			5493072336096083
		]
		],
		false,
		false,
		5365222785625817,
		[],
		null
	]
,	[
		"t4",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9164178312923548,
			[
				["buttonupgrade5-sheet0.png", 11512, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade5-sheet0.png", 11512, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			489307781191613
		]
		],
		false,
		false,
		2837234566236385,
		[],
		null
	]
,	[
		"t5",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2729186157605031,
			[
				["buttonupgrade6-sheet0.png", 13084, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade6-sheet0.png", 13084, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			6324897789756921
		]
		],
		false,
		false,
		6612290953269841,
		[],
		null
	]
,	[
		"t6",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6297379124567179,
			[
				["buttonupgrade7-sheet0.png", 10697, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade7-sheet0.png", 10697, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			962926212079631
		]
		],
		false,
		false,
		3660541445000083,
		[],
		null
	]
,	[
		"t7",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6274611464874591,
			[
				["buttonupgrade8-sheet0.png", 13781, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade8-sheet0.png", 13781, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			6380269114395358
		]
		],
		false,
		false,
		3881953574545833,
		[],
		null
	]
,	[
		"t8",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4542832868781456,
			[
				["buttonupgrade9-sheet0.png", 17271, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade9-sheet0.png", 17271, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			2684255360759908
		]
		],
		false,
		false,
		4409017403319753,
		[],
		null
	]
,	[
		"t9",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4819929933774362,
			[
				["buttonupgrade10-sheet0.png", 15786, 0, 0, 202, 52, 1, 0.5, 0.5,[],[],0],
				["buttonupgrade10-sheet0.png", 15786, 0, 52, 202, 52, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1945782929958197
		]
		],
		false,
		false,
		4963849702611247,
		[],
		null
	]
,	[
		"t10",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5462995714634328,
			[
				["imagebuttonclicker-sheet0.png", 399883, 0, 0, 960, 640, 1, 0.5, 0.5,[],[],0],
				["imagebuttonclicker-sheet1.png", 399883, 0, 0, 960, 640, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1642574605087902
		]
		],
		true,
		false,
		7385400599238132,
		[],
		null
	]
,	[
		"t11",
		cr.plugins_.WebStorage,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		8838810526635987,
		[],
		null
		,[]
	]
,	[
		"t12",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9242201183981715,
			[
				["sprite-sheet0.png", 15211, 0, 0, 410, 300, 1, 0.5, 0.5,[],[-0.1243900060653687,0.0133330225944519,0,-0.3499999940395355,0.1487799882888794,-0.02000001072883606,0.1487799882888794,0,0.3585370182991028,0.3066669702529907,0,0.2666670083999634,-0.3731710016727448,0.3266670107841492,-0.1146340072154999,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9944244242295172,
		[],
		null
	]
,	[
		"t13",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9911070750627417,
			[
				["sprite3-sheet0.png", 225039, 0, 0, 556, 335, 1, 0.5, 0.5014925599098206,[],[-0.4910071790218353,-0.4865671694278717,0,-0.5014925599098206,0.4910069704055786,-0.4865671694278717,0.4910069704055786,0.4835824370384216,0,0.4985074400901794,-0.4910071790218353,0.4835824370384216],0]
			]
			]
		],
		[
		],
		false,
		false,
		9669319582972657,
		[],
		null
	]
,	[
		"t14",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1576689823909458,
			[
				["sprite4-sheet0.png", 6289, 0, 0, 100, 50, 1, 0.5, 0.5,[],[-0.3700000047683716,-0.2400000095367432,0,-0.3799999952316284,0.3700000047683716,-0.2400000095367432,0.4200000166893005,0,0.4200000166893005,0.3399999737739563,-0.4200000166893005,0.3399999737739563,-0.4699999988079071,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		4333698310031097,
		[],
		null
	]
,	[
		"t15",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5574025337224509,
			[
				["sprite5-sheet0.png", 5099, 0, 0, 75, 50, 1, 0.5066666603088379, 0.5,[],[-0.3466666638851166,-0.2599999904632568,-0.01333364844322205,-0.2599999904632568,0.3866663575172424,-0.3400000035762787,0.3733333349227905,0,0.4266663193702698,0.3999999761581421,-0.01333364844322205,0.1600000262260437,-0.3999996781349182,0.3399999737739563,-0.4533333480358124,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		4625361060583693,
		[],
		null
	]
,	[
		"t16",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8192052124759274,
			[
				["imgupgradestext1-sheet0.png", 13387, 0, 0, 200, 50, 1, 0.5, 0.5,[],[-0.4300000071525574,-0.2199999988079071,0,-0.2800000011920929,0.425000011920929,-0.199999988079071,0.4200000166893005,0,0.4399999976158142,0.2599999904632568,0,0.3600000143051148,-0.449999988079071,0.300000011920929,-0.4600000083446503,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		91292089464787,
		[],
		null
	]
,	[
		"t17",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2549298912320914,
			[
				["imgupgradestext1-sheet0.png", 13387, 0, 0, 200, 50, 1, 0.5, 0.5,[],[-0.4300000071525574,-0.2199999988079071,0,-0.2800000011920929,0.425000011920929,-0.199999988079071,0.4200000166893005,0,0.4399999976158142,0.2599999904632568,0,0.3600000143051148,-0.449999988079071,0.300000011920929,-0.4600000083446503,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9798807166885292,
		[],
		null
	]
,	[
		"t18",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9028535027805168,
			[
				["imgupgradesbg1-sheet0.png", 876, 0, 0, 380, 515, 1, 0.5, 0.5009709000587463,[],[-0.4894737005233765,-0.4932039082050324,0.4894739985466003,-0.4932039082050324,0.4894739985466003,0.4912620782852173,-0.4894737005233765,0.4912620782852173],0]
			]
			]
		],
		[
		],
		false,
		false,
		1301253054836934,
		[],
		null
	]
,	[
		"t19",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5002475523550063,
			[
				["imgupgradesbg1-sheet0.png", 876, 0, 0, 380, 515, 1, 0.5, 0.5009709000587463,[],[-0.4894737005233765,-0.4932039082050324,0.4894739985466003,-0.4932039082050324,0.4894739985466003,0.4912620782852173,-0.4894737005233765,0.4912620782852173],0]
			]
			]
		],
		[
		],
		false,
		false,
		9062215867383934,
		[],
		null
	]
,	[
		"t20",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8054835924368519,
			[
				["sprite10-sheet0.png", 18102, 0, 0, 410, 300, 1, 0.5, 0.5,[],[-0.1585370004177094,-0.03333300352096558,0,-0.4166666865348816,0.2268289923667908,-0.1266669929027557,0.199999988079071,0,0.3999999761581421,0.363332986831665,0,0.3966670036315918,-0.4073171019554138,0.3733329772949219,-0.1829270124435425,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		4390456228013993,
		[],
		null
	]
,	[
		"t21",
		cr.plugins_.Touch,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		6862841605664013,
		[],
		null
		,[1]
	]
,	[
		"t22",
		cr.plugins_.CJSAds,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		9615045399620265,
		[],
		null
		,[0,0]
	]
,	[
		"t23",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		4556972741399455,
		[],
		null
	]
,	[
		"t24",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		4725280098328721,
		[],
		null
	]
,	[
		"t25",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		7091257654540526,
		[],
		null
	]
,	[
		"t26",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		2062607986903261,
		[],
		null
	]
,	[
		"t27",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		4938694247898088,
		[],
		null
	]
,	[
		"t28",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		8441322630932615,
		[],
		null
	]
,	[
		"t29",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		302103210654084,
		[],
		null
	]
,	[
		"t30",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		9445570764717708,
		[],
		null
	]
,	[
		"t31",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		6855191872846089,
		[],
		null
	]
,	[
		"t32",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		221609631485389,
		[],
		null
	]
,	[
		"t33",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		3156423820592106,
		[],
		null
	]
,	[
		"t34",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		772320229705146,
		[],
		null
	]
,	[
		"t35",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		2739490086725489,
		[],
		null
	]
,	[
		"t36",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		8515270598599253,
		[],
		null
	]
,	[
		"t37",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		5549985272135538,
		[],
		null
	]
,	[
		"t38",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		5763927811286919,
		[],
		null
	]
,	[
		"t39",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		1367308602948182,
		[],
		null
	]
,	[
		"t40",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		1011011036870457,
		[],
		null
	]
,	[
		"t41",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		4084253046421554,
		[],
		null
	]
,	[
		"t42",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		5602971825466198,
		[],
		null
	]
,	[
		"t43",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfupgradelvl1.png", 4422, 0],
		null,
		[
		],
		false,
		false,
		3400330213154174,
		[],
		null
	]
,	[
		"t44",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		8458875637362596,
		[],
		null
	]
,	[
		"t45",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2771285498763839,
			[
				["sprite2-sheet0.png", 2533, 0, 0, 200, 200, 1, 0.5, 0.5,[],[-0.4749999940395355,-0.4749999940395355,0,-0.5,0.4750000238418579,-0.4749999940395355,0.5,0,0.300000011920929,0.300000011920929,0,0.4549999833106995,-0.3349999785423279,0.3349999785423279,-0.5,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		7670494839140705,
		[],
		null
	]
,	[
		"t46",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1447469009760016,
			[
				["menuachievments-sheet0.png", 12268, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4642859697341919,-0.4749999940395355,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0],
				["menuachievments-sheet1.png", 14308, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4642859697341919,-0.4749999940395355,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			922717319499007
		]
		],
		false,
		false,
		171772917977608,
		[],
		null
	]
,	[
		"t47",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			292817811647772,
			[
				["menufacebook-sheet0.png", 12121, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4642859697341919,-0.4749999940395355,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7563767414599919
		]
		],
		false,
		false,
		1710868314794524,
		[],
		null
	]
,	[
		"t48",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7169871381069474,
			[
				["menutwitter-sheet0.png", 12174, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4761899709701538,-0.4833332896232605,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			4200477801660901
		]
		],
		false,
		false,
		4327336819805154,
		[],
		null
	]
,	[
		"t49",
		cr.plugins_.Sprite,
		false,
		[2277843299078101],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3363006390967676,
			[
				["menucart-sheet0.png", 12125, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4642859697341919,-0.4749999940395355,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7061593764858125
		]
		],
		false,
		false,
		4439487617003398,
		[],
		null
	]
,	[
		"t50",
		cr.plugins_.Browser,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		2161152184951437,
		[],
		null
		,[]
	]
,	[
		"t51",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6482674775171743,
			[
				["sprite17-sheet0.png", 168, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],3]
			]
			]
		],
		[
		],
		false,
		false,
		4713152649928819,
		[],
		null
	]
,	[
		"t52",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2509747076430833,
			[
				["imgachievements-sheet0.png", 192291, 0, 0, 556, 335, 1, 0.5, 0.5014925599098206,[],[-0.4910071790218353,-0.4865671694278717,0,-0.5014925599098206,0.4910069704055786,-0.4865671694278717,0.4910069704055786,0.4835824370384216,0,0.4985074400901794,-0.4910071790218353,0.4835824370384216],0]
			]
			]
		],
		[
		],
		false,
		false,
		4374300904926491,
		[],
		null
	]
,	[
		"t53",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1855436129389047,
			[
				["imgpurse-sheet0.png", 30351, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgpurse-sheet1.png", 19188, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			5698295462237411
		]
		],
		false,
		false,
		9041597462717269,
		[],
		null
	]
,	[
		"t54",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8857518968623904,
			[
				["imgshoes-sheet0.png", 31465, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgshoes-sheet1.png", 20128, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			394295055870507
		]
		],
		false,
		false,
		6262112493933551,
		[],
		null
	]
,	[
		"t55",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			767715583994745,
			[
				["imgmakeup-sheet0.png", 29505, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgmakeup-sheet1.png", 18601, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			3827548588869732
		]
		],
		false,
		false,
		1185646220615447,
		[],
		null
	]
,	[
		"t56",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2443768274646861,
			[
				["imgperfume-sheet0.png", 27002, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgperfume-sheet1.png", 16701, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			4492026291318825
		]
		],
		false,
		false,
		7776944363585326,
		[],
		null
	]
,	[
		"t57",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1018980519258711,
			[
				["imgdress-sheet0.png", 28199, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgdress-sheet1.png", 17714, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			6581174829900119
		]
		],
		false,
		false,
		1776898868598504,
		[],
		null
	]
,	[
		"t58",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6759547006037526,
			[
				["sprite17-sheet0.png", 168, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],3]
			]
			]
		],
		[
		],
		false,
		false,
		2670643005894003,
		[],
		null
	]
,	[
		"t59",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7728331734296147,
			[
				["imgsunglasses-sheet0.png", 27768, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgsunglasses-sheet1.png", 17723, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			16522212698063
		]
		],
		false,
		false,
		5017237744423295,
		[],
		null
	]
,	[
		"t60",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			87159214708773,
			[
				["imgphone-sheet0.png", 25486, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgphone-sheet1.png", 16116, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			8435488530968996
		]
		],
		false,
		false,
		3383579818100673,
		[],
		null
	]
,	[
		"t61",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6402684724946132,
			[
				["imglingerie-sheet0.png", 31759, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imglingerie-sheet1.png", 20376, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7647014801592083
		]
		],
		false,
		false,
		9475698427318915,
		[],
		null
	]
,	[
		"t62",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4295764844471801,
			[
				["imgrunwayshow-sheet0.png", 30219, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgrunwayshow-sheet1.png", 19263, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7609470899597336
		]
		],
		false,
		false,
		3308048382742169,
		[],
		null
	]
,	[
		"t63",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3321684802430732,
			[
				["imgagencies-sheet0.png", 29858, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0],
				["imgagencies-sheet1.png", 18733, 0, 0, 128, 128, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			9568787219239282
		]
		],
		false,
		false,
		7466975570906631,
		[],
		null
	]
,	[
		"t64",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sfachievements.png", 47245, 0],
		null,
		[
		],
		false,
		false,
		9320556668125361,
		[],
		null
	]
,	[
		"t65",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5041498410812827,
			[
				["imgclose-sheet0.png", 660, 0, 0, 150, 50, 1, 0.5, 0.5,[],[-0.386667013168335,-0.1599999964237213,0,-0.1800000071525574,0.3133329749107361,0.06000000238418579,0.300000011920929,0,0.3066669702529907,-0.08000001311302185,0,0.1800000071525574,-0.386667013168335,0.1600000262260437,-0.4066666960716248,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			49281450448573
		]
		],
		false,
		false,
		663788240179667,
		[],
		null
	]
,	[
		"t66",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7111372434193908,
			[
				["imgachievepurse-sheet0.png", 105175, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			916266259853141
		]
		],
		false,
		false,
		3285928805651266,
		[],
		null
	]
,	[
		"t67",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			901961510674947,
			[
				["imgachievment-sheet0.png", 27461, 0, 0, 500, 100, 1, 0.5, 0.5,[],[-0.4399999976158142,-0.199999988079071,0,-0.2800000011920929,0.4559999704360962,-0.2800000011920929,0.4679999947547913,0,0.4480000138282776,0.2400000095367432,0,0.2599999904632568,-0.4480000138282776,0.2400000095367432,-0.4539999961853027,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		929759474341394,
		[],
		null
	]
,	[
		"t68",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6135780839808745,
			[
				["imgcompleted-sheet0.png", 25230, 0, 0, 500, 100, 1, 0.5, 0.5,[],[-0.3980000019073486,0.009999990463256836,0,-0.2599999904632568,0.3980000019073486,0.009999990463256836,0.3980000019073486,-0.009999990463256836,0,0.2699999809265137,-0.3980000019073486,-0.009999990463256836],0]
			]
			]
		],
		[
		],
		false,
		false,
		3347214832001675,
		[],
		null
	]
,	[
		"t69",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4389440229843193,
			[
				["sprite11-sheet0.png", 21723, 0, 0, 600, 450, 1, 0.5, 0.5,[],[-0.471666693687439,-0.4622221887111664,0,-0.5,0.4716669917106628,-0.4622221887111664,0.5,0,0.4716669917106628,0.4622219800949097,0,0.5,-0.4766666889190674,0.4688889980316162,-0.5,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		2119675835381839,
		[],
		null
	]
,	[
		"t70",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			493454527383406,
			[
				["imgachieveshoes-sheet0.png", 110368, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			4670441057096574
		]
		],
		false,
		false,
		8721707417230186,
		[],
		null
	]
,	[
		"t71",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2693385105185263,
			[
				["imgachievemakeup-sheet0.png", 101271, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			3522508766807011
		]
		],
		false,
		false,
		4875246820077329,
		[],
		null
	]
,	[
		"t72",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9326358435954969,
			[
				["imgachieveperfume-sheet0.png", 95830, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			4037205376666813
		]
		],
		false,
		false,
		2488685472663541,
		[],
		null
	]
,	[
		"t73",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5352295424595514,
			[
				["imgachievedress-sheet0.png", 104093, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			8392562286282181
		]
		],
		false,
		false,
		2507499304794809,
		[],
		null
	]
,	[
		"t74",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1508831526592839,
			[
				["imgachievesunglass-sheet0.png", 98322, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			409352212989757
		]
		],
		false,
		false,
		5896684416593957,
		[],
		null
	]
,	[
		"t75",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8233950789191711,
			[
				["imgachievephone-sheet0.png", 91018, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			4459391795424312
		]
		],
		false,
		false,
		3537905320561563,
		[],
		null
	]
,	[
		"t76",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2803907120184775,
			[
				["imgachievelingerie-sheet0.png", 115186, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			2864575205818793
		]
		],
		false,
		false,
		3333113709270609,
		[],
		null
	]
,	[
		"t77",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1873586355651178,
			[
				["imgachieverunwayshow-sheet0.png", 109013, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			1130095678476154
		]
		],
		false,
		false,
		1815541207952058,
		[],
		null
	]
,	[
		"t78",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1402280071493186,
			[
				["imgachieveagencies-sheet0.png", 97786, 0, 0, 256, 256, 1, 0.5, 0.5,[],[-0.4570311903953552,-0.4570311903953552,0,-0.5,0.4570310115814209,-0.4570311903953552,0.5,0,0.4570310115814209,0.4570310115814209,0,0.5,-0.4570311903953552,0.4570310115814209,-0.5,0],0]
			]
			]
		],
		[
		[
			"MoveTo",
			cr.behaviors.Rex_MoveTo,
			3139721618152765
		]
		],
		false,
		false,
		8893007932407963,
		[],
		null
	]
,	[
		"t79",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2454353152431553,
			[
				["imgplusfame-sheet0.png", 2531, 0, 96, 102, 32, 1, 0.5, 0.5,[],[-0.3899999856948853,-0.1333329975605011,0,-0.06666699051856995,0.4300000071525574,-0.2666670083999634,0.4200000166893005,0,0.4300000071525574,0.2666670083999634,0,0.300000011920929,-0.4000000059604645,0.1666669845581055,-0.4300000071525574,0],0],
				["imgplusfame-sheet1.png", 1403, 0, 0, 102, 32, 1, 0.5, 0.5,[],[],0],
				["imgplusfame-sheet1.png", 1403, 0, 32, 102, 32, 1, 0.5, 0.5,[],[],0],
				["imgplusfame-sheet1.png", 1403, 0, 64, 102, 32, 1, 0.5, 0.5,[],[],0],
				["imgplusfame-sheet0.png", 2531, 0, 0, 112, 32, 1, 0.5, 0.5,[],[],0],
				["imgplusfame-sheet0.png", 2531, 0, 32, 112, 32, 1, 0.5, 0.5,[],[],0],
				["imgplusfame-sheet0.png", 2531, 0, 64, 112, 32, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		3737629177938487,
		[],
		null
	]
,	[
		"t80",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7882354357448396,
			[
				["imgpurchasefame-sheet0.png", 612368, 0, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[-0.4577007293701172,-0.4264706075191498,-0.002169638872146606,-0.4632352888584137,0.4490233659744263,-0.4154412150382996,0.4859004020690918,0,0.4490233659744263,0.4154409766197205,-0.002169638872146606,0.4816179871559143,-0.4577007293701172,0.4264709949493408,-0.4793926179409027,0],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 0, 1644, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 463, 1644, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 926, 1644, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet0.png", 612368, 1389, 1644, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 926, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 1389, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 926, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 1389, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 926, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 1389, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 926, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 1389, 822, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 926, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 1389, 1096, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 0, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgpurchasefame-sheet1.png", 500721, 463, 1370, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			4965775009001974
		]
		],
		false,
		false,
		6836231041238935,
		[],
		null
	]
,	[
		"t81",
		cr.plugins_.c2canvas,
		false,
		[],
		0,
		0,
		["canvas2.png", 168, 3],
		null,
		[
		],
		false,
		false,
		3517056737968189,
		[],
		null
	]
,	[
		"t82",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2926948308039755,
			[
				["imgcheaperlines-sheet0.png", 249407, 0, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[-0.4533623158931732,-0.4191175997257233,-0.002169638872146606,-0.4632352888584137,0.4533623456954956,-0.4227941036224365,0.4945773482322693,0,0.4533623456954956,0.422793984413147,-0.002169638872146606,0.4816179871559143,-0.4533623158931732,0.4191179871559143,-0.4707158207893372,0],0],
				["imgcheaperlines-sheet0.png", 249407, 463, 0, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgcheaperlines-sheet0.png", 249407, 0, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgcheaperlines-sheet0.png", 249407, 463, 274, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0],
				["imgcheaperlines-sheet0.png", 249407, 0, 548, 463, 274, 1, 0.5010846257209778, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			9054165287877277
		]
		],
		false,
		false,
		3734392587497936,
		[],
		null
	]
,	[
		"t83",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2115942973379323,
			[
				["imgclicks-sheet0.png", 529112, 0, 0, 468, 274, 1, 0.5, 0.5,[],[-0.452789694070816,-0.4191175997257233,0,-0.4632352888584137,0.448498010635376,-0.4117647111415863,0.484978973865509,0,0.4506440162658691,0.4154409766197205,0,0.4816179871559143,-0.452789694070816,0.4191179871559143,-0.4699571132659912,0],0],
				["imgclicks-sheet0.png", 529112, 468, 0, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 936, 0, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 1404, 0, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 0, 274, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 468, 274, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 936, 274, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 1404, 274, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 0, 548, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 468, 548, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 936, 548, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 1404, 548, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 0, 822, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 468, 822, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 936, 822, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 1404, 822, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 0, 1096, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 468, 1096, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 936, 1096, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 1404, 1096, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 0, 1370, 468, 274, 1, 0.5, 0.5,[],[],0],
				["imgclicks-sheet0.png", 529112, 468, 1370, 468, 274, 1, 0.5, 0.5,[],[],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			8564592773709304
		]
		],
		false,
		false,
		3796546587876308,
		[],
		null
	]
,	[
		"t84",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9592929084220552,
			[
				["imgdoublefame-sheet0.png", 67128, 0, 0, 466, 272, 1, 0.5, 0.5,[],[-0.452789694070816,-0.4191175997257233,0,-0.4632352888584137,0.448498010635376,-0.4117647111415863,0.484978973865509,0,0.4506440162658691,0.4154409766197205,0,0.4816179871559143,-0.452789694070816,0.4191179871559143,-0.4699571132659912,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			3307091895418859
		]
		],
		false,
		false,
		5156183777487404,
		[],
		null
	]
,	[
		"t85",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			7900024343904951,
			[
				["imgfame7-sheet0.png", 66312, 0, 0, 466, 272, 1, 0.5, 0.5,[],[-0.452789694070816,-0.4191175997257233,0,-0.4632352888584137,0.448498010635376,-0.4117647111415863,0.484978973865509,0,0.4506440162658691,0.4154409766197205,0,0.4816179871559143,-0.452789694070816,0.4191179871559143,-0.4699571132659912,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			5720618859676386
		]
		],
		false,
		false,
		6403963017277601,
		[],
		null
	]
,	[
		"t86",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6070517003228711,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7630948169808948
		]
		],
		false,
		false,
		7997052696993569,
		[],
		null
	]
,	[
		"t87",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5379325541762146,
			[
				["sprite31-sheet0.png", 1739, 0, 0, 245, 50, 1, 0.5020408034324646, 0.5,[],[-0.4571428000926971,-0.2800000011920929,-0.004081815481185913,-0.2400000095367432,0.4530612230300903,-0.2800000011920929,0.4857141971588135,0,0.4530612230300903,0.2799999713897705,-0.4571428000926971,0.2799999713897705,-0.4938775300979614,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5812249611827646,
		[],
		null
	]
,	[
		"t88",
		cr.plugins_.SpriteFont,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		3252308582364772,
		[],
		null
	]
,	[
		"t89",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		9190977585661408,
		[],
		null
	]
,	[
		"t90",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4340387883924683,
			[
				["sprite17-sheet0.png", 168, 0, 0, 250, 250, 1, 0.5, 0.5,[],[],3]
			]
			]
		],
		[
		],
		false,
		false,
		3480740147824956,
		[],
		null
	]
,	[
		"t91",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4923542713707897,
			[
				["sprite34-sheet0.png", 191371, 0, 0, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 44, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 88, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 132, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 176, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 220, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 264, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 308, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 352, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 396, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 440, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 484, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 528, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 572, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 616, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 660, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 704, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 748, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 792, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 836, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 880, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 924, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet0.png", 191371, 0, 968, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 0, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 44, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 88, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 132, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 176, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 220, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 264, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 308, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 352, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 396, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 440, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 484, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 528, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 572, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 616, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 660, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 704, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 748, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 792, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 836, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 880, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 924, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet1.png", 204393, 0, 968, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 0, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 44, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 88, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 132, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 176, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 220, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0],
				["sprite34-sheet2.png", 72150, 0, 264, 529, 44, 1, 0.5009487867355347, 0.5,[],[],0]
			]
			]
		],
		[
		],
		false,
		false,
		7004153949050537,
		[],
		null
	]
,	[
		"t92",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			550392821012177,
			[
				["sprite32-sheet0.png", 926, 0, 0, 600, 42, 1, 0.5016666650772095, 0.5,[],[-0.001666665077209473,0.04761898517608643,0.006666362285614014,0,0.4450003504753113,-0.2619050145149231,-0.001666665077209473,0.1904760003089905,0.00166630744934082,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		6420213618406941,
		[],
		null
	]
,	[
		"t93",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		6331203173856571,
		[],
		null
	]
,	[
		"t94",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		8322256926893864,
		[],
		null
	]
,	[
		"t95",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6156444277666496,
			[
				["sprite35-sheet0.png", 3785, 0, 0, 400, 100, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1480692495809908
		]
		],
		false,
		false,
		1726758858863506,
		[],
		null
	]
,	[
		"t96",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5710477884893075,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9632503633496403,
		[],
		null
	]
,	[
		"t97",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		1682981637993706,
		[],
		null
	]
,	[
		"t98",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8473605323723327,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		5723903325496075,
		[],
		null
	]
,	[
		"t99",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			3732984437217947,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		4061261770061814,
		[],
		null
	]
,	[
		"t100",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			466492627704445,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		727966925914114,
		[],
		null
	]
,	[
		"t101",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4002998051359927,
			[
				["sprite30-sheet0.png", 19081, 0, 0, 245, 256, 1, 0.5020408034324646, 0.5,[],[-0.3306118249893189,-0.3359369933605194,-0.004081815481185913,-0.5,0.3632652163505554,-0.3710939884185791,0.4938771724700928,0,0.3020411729812622,0.3125,-0.004081815481185913,0.4570310115814209,-0.3428568243980408,0.3476560115814209,-0.497959166765213,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		7870002740495568,
		[],
		null
	]
,	[
		"t102",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		7108117610976419,
		[],
		null
	]
,	[
		"t103",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		5824136361838333,
		[],
		null
	]
,	[
		"t104",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		8117469743234844,
		[],
		null
	]
,	[
		"t105",
		cr.plugins_.Spritefont2,
		false,
		[],
		0,
		0,
		["sffame.png", 4546, 0],
		null,
		[
		],
		false,
		false,
		8037027113061049,
		[],
		null
	]
,	[
		"t106",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8215197828909506,
			[
				["imgminibar-sheet0.png", 220, 0, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 22, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 44, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 66, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 88, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 0, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 22, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 44, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 66, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet0.png", 220, 88, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 0, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 22, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 44, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 66, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 88, 0, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 0, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 22, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 44, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 66, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet1.png", 220, 88, 62, 22, 62, 1, 0.5, 0.5,[],[],0],
				["imgminibar-sheet2.png", 104, 0, 0, 20, 60, 1, 0.5, 0.5,[],[],1]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			9979513094468995
		]
		],
		false,
		false,
		744822050767187,
		[],
		null
	]
,	[
		"t107",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2374845320037758,
			[
				["sprite24-sheet0.png", 12350, 0, 0, 84, 120, 1, 0.5, 0.5,[],[-0.357142984867096,-0.4000000059604645,0,-0.5,0.4642859697341919,-0.4749999940395355,0.4761899709701538,0,0.4285709857940674,0.449999988079071,0,0.3416669964790344,-0.357142984867096,0.3999999761581421],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			8184226212576111
		]
		],
		false,
		false,
		3391428724074988,
		[],
		null
	]
,	[
		"t108",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			2668465608040508,
			[
				["imgpowercoinstext-sheet0.png", 34997, 0, 0, 900, 100, 1, 0.5, 0.5,[],[-0.4522221982479096,-0.06999999284744263,0,0.1200000047683716,0.4433329701423645,0.009999990463256836,0.4433329701423645,-0.009999990463256836,0,0.1399999856948853,-0.4522221982479096,0.06999999284744263],0]
			]
			]
		],
		[
		],
		false,
		false,
		8791110021867009,
		[],
		null
	]
,	[
		"t109",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			152792210395598,
			[
				["imgtutorial2-sheet0.png", 3412, 0, 0, 300, 100, 1, 0.5, 0.5,[],[-0.4166666865348816,-0.25,0,-0.5,0.5,-0.5,0.5,0.5,0,0.5,-0.4200000166893005,0.2599999904632568,-0.5,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		374368363933411,
		[],
		null
	]
,	[
		"t110",
		cr.plugins_.Mouse,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		5844591900383711,
		[],
		null
		,[]
	]
,	[
		"t111",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9229468677060786,
			[
				["imgbuy100coins-sheet0.png", 32104, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1343587764265044
		]
		],
		false,
		false,
		9102304043444413,
		[],
		null
	]
,	[
		"t112",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8874465067437897,
			[
				["imgbuy250coins-sheet0.png", 32937, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1130332046227253
		]
		],
		false,
		false,
		1486635317231193,
		[],
		null
	]
,	[
		"t113",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6597491077689044,
			[
				["imgbuy1000coins-sheet0.png", 34683, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			7704475903546642
		]
		],
		false,
		false,
		1617322989084623,
		[],
		null
	]
,	[
		"t114",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			6898304055414929,
			[
				["imgbuy3000coins-sheet0.png", 33858, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			9455215217329099
		]
		],
		false,
		false,
		8392012323143053,
		[],
		null
	]
,	[
		"t115",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5489002623423587,
			[
				["imgbuy10000coins-sheet0.png", 32975, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			280284388656278
		]
		],
		false,
		false,
		2594480655048843,
		[],
		null
	]
,	[
		"t116",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			464008355577381,
			[
				["imgbuy100000coins-sheet0.png", 30064, 0, 0, 128, 128, 1, 0.5, 0.5,[],[-0.453125,-0.453125,0,-0.5,0.453125,-0.453125,0.5,0,0.453125,0.453125,0,0.5,-0.453125,0.453125,-0.5,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			1537910083607654
		]
		],
		false,
		false,
		5017273979204039,
		[],
		null
	]
,	[
		"t117",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			1125452649702433,
			[
				["imggetpremium-sheet0.png", 35474, 0, 0, 269, 156, 1, 0.5018587112426758, 0.5,[],[-0.4758363962173462,-0.4551281929016113,-0.00371772050857544,-0.4935897290706635,0.4721192717552185,-0.4551281929016113,0.4981412887573242,0,0.4609662890434265,0.4358969926834106,-0.00371772050857544,0.4615380167961121,-0.464684009552002,0.4358969926834106,-0.5018587112426758,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			2982557501125882
		]
		],
		false,
		false,
		5124011756019664,
		[],
		null
	]
,	[
		"t118",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8068312921074549,
			[
				["imgcoinshopbg-sheet0.png", 195022, 0, 0, 556, 335, 1, 0.5, 0.5014925599098206,[],[-0.4910071790218353,-0.4865671694278717,0,-0.5014925599098206,0.4910069704055786,-0.4865671694278717,0.4910069704055786,0.4835824370384216,0,0.4985074400901794,-0.4910071790218353,0.4835824370384216],0]
			]
			]
		],
		[
		],
		false,
		false,
		6669993167822228,
		[],
		null
	]
,	[
		"t119",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			38408500463582,
			[
				["imgclose-sheet0.png", 660, 0, 0, 150, 50, 1, 0.5, 0.5,[],[-0.386667013168335,-0.1599999964237213,0,-0.1800000071525574,0.3133329749107361,0.06000000238418579,0.300000011920929,0,0.3066669702529907,-0.08000001311302185,0,0.1800000071525574,-0.386667013168335,0.1600000262260437,-0.4066666960716248,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			2883064504012046
		]
		],
		false,
		false,
		5424892197345325,
		[],
		null
	]
,	[
		"t120",
		cr.plugins_.googleplay,
		false,
		[],
		0,
		0,
		null,
		null,
		[
		],
		false,
		false,
		6175500720005755,
		[],
		null
		,["768626718299","768626718299.apps.googleusercontent.com"]
	]
,	[
		"t121",
		cr.plugins_.Sprite,
		false,
		[],
		1,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			4721401904132195,
			[
				["sprite6-sheet0.png", 10860, 0, 0, 112, 84, 1, 0.5, 0.5,[],[-0.3035709857940674,-0.2380949854850769,0,-0.4285714030265808,0.4464290142059326,-0.4285714030265808,0.5,0,0.4285709857940674,0.4047619700431824,0,0.4047619700431824,-0.3214290142059326,0.2619050145149231,-0.2232140004634857,0],0]
			]
			]
		],
		[
		[
			"SpriteButton",
			cr.behaviors.SpriteButton,
			865377861028282
		]
		],
		false,
		false,
		8983505244348382,
		[],
		null
	]
,	[
		"t122",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9665497295328407,
			[
				["imgpurchasefailed-sheet0.png", 1633, 0, 0, 300, 100, 1, 0.5, 0.5,[],[-0.4900000095367432,-0.4699999988079071,0,-0.5,0.4900000095367432,-0.4699999988079071,0.4900000095367432,0.4700000286102295,0,0.5,-0.4900000095367432,0.4700000286102295],0]
			]
			]
		],
		[
		],
		false,
		false,
		2321836142644275,
		[],
		null
	]
,	[
		"t123",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8963597183247565,
			[
				["imgpurchasesuccessful-sheet0.png", 2216, 0, 0, 300, 100, 1, 0.5, 0.5,[],[-0.4900000095367432,-0.4699999988079071,0,-0.5,0.4900000095367432,-0.4699999988079071,0.4900000095367432,0.4700000286102295,0,0.5,-0.4900000095367432,0.4700000286102295],0]
			]
			]
		],
		[
		],
		false,
		false,
		751942584775564,
		[],
		null
	]
,	[
		"t124",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			285298843419407,
			[
				["imgpurchaseprice1-sheet0.png", 2846, 0, 0, 120, 30, 1, 0.5, 0.5,[],[0,0.1333330273628235,0.3083329796791077,0,0,0.300000011920929,-0.2750000059604645,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		7512115202372293,
		[],
		null
	]
,	[
		"t125",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8665483750980393,
			[
				["imgpurchaseprice2-sheet0.png", 2657, 0, 0, 120, 30, 1, 0.5, 0.5,[],[0,0.1333330273628235,0.3083329796791077,0,0,0.300000011920929,-0.2750000059604645,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		7261030078117567,
		[],
		null
	]
,	[
		"t126",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			207591150326203,
			[
				["imgpurchaseprice5-sheet0.png", 2813, 0, 0, 120, 30, 1, 0.5, 0.5,[],[0,0.1333330273628235,0.3083329796791077,0,0,0.300000011920929,-0.2750000059604645,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		6463266061323815,
		[],
		null
	]
,	[
		"t127",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			5687051115203717,
			[
				["imgpurchaseprice10-sheet0.png", 2381, 0, 0, 120, 30, 1, 0.5, 0.5,[],[0,0.1333330273628235,0.3083329796791077,0,0,0.300000011920929,-0.2750000059604645,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		655658094175583,
		[],
		null
	]
,	[
		"t128",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			9811567308639497,
			[
				["imgpurchaseprice20-sheet0.png", 3376, 0, 0, 120, 30, 1, 0.5, 0.5,[],[-0.3333330154418945,0.1666669845581055,0,-0.2666670083999634,0.375,0,0.3833330273628235,0,0.3833330273628235,0.03333300352096558,0,0.300000011920929,-0.3666670024394989,-0.03333300352096558,-0.3416669964790344,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		9694088207086718,
		[],
		null
	]
,	[
		"t129",
		cr.plugins_.Sprite,
		false,
		[],
		0,
		0,
		null,
		[
			[
			"Default",
			5,
			false,
			1,
			0,
			false,
			8389797395358082,
			[
				["imgpurchaseprice100-sheet0.png", 3113, 0, 0, 120, 30, 1, 0.5, 0.5,[],[-0.3333330154418945,0.1666669845581055,0,-0.2666670083999634,0.375,0,0.3833330273628235,0,0.3833330273628235,0.03333300352096558,0,0.300000011920929,-0.3666670024394989,-0.03333300352096558,-0.3416669964790344,0],0]
			]
			]
		],
		[
		],
		false,
		false,
		2865188397376036,
		[],
		null
	]
	],
	[
	],
	[
	[
		"Layout 1",
		960,
		640,
		false,
		"Event sheet 1",
		8873350371196689,
		[
		[
			"Background",
			0,
			8722530541249526,
			true,
			[255, 255, 255],
			false,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[480, 320, 0, 960, 640, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				10,
				47,
				[
				],
				[
				[
					0,
					1,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[819, 266, 0, 217, 302, 0, 0, 1, 0.5, 0.5009709000587463, 0, 0, []],
				19,
				6,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 266, 0, 217, 302, 0, 0, 1, 0.5, 0.5009709000587463, 0, 0, []],
				18,
				5,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 145, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				0,
				37,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 205, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				1,
				38,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 265, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				2,
				39,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 325, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				3,
				40,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[155, 385, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				4,
				41,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[820, 145, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				5,
				42,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[820, 205, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				6,
				43,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[820, 265, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				7,
				44,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[820, 325, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				8,
				45,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[820, 385, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				9,
				46,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[91.77604675292969, 513.59228515625, 0, 184.4018096923828, 134.9281616210938, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				20,
				7,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[817, 90, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				17,
				4,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[395.3500061035156, 471.1749877929688, 0, 100, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				14,
				1,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[643, 471, 0, 75, 50, 0, 0, 1, 0.5066666603088379, 0.5, 0, 0, []],
				15,
				2,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[152, 90, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				16,
				3,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[244, 492, 0, 293, 23, 0, 0, 1, 0, 0, 0, 0, []],
				23,
				10,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"0",
					0.4,
					0,
					1,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[3, 138, 0, 42, 22, 0, 0, 1, 0, 0, 0, 0, []],
				24,
				11,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[3, 198, 0, 42, 22, 0, 0, 1, 0, 0, 0, 0, []],
				25,
				12,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[3, 258, 0, 42, 22, 0, 0, 1, 0, 0, 0, 0, []],
				26,
				13,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[3, 318, 0, 42, 22, 0, 0, 1, 0, 0, 0, 0, []],
				27,
				14,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[3, 378, 0, 42, 22, 0, 0, 1, 0, 0, 0, 0, []],
				28,
				15,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[662, 138, 0, 48, 22, 0, 0, 1, 0, 0, 0, 0, []],
				29,
				16,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[662, 198, 0, 48, 22, 0, 0, 1, 0, 0, 0, 0, []],
				30,
				17,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[662, 258, 0, 48, 22, 0, 0, 1, 0, 0, 0, 0, []],
				31,
				24,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[662, 318, 0, 48, 22, 0, 0, 1, 0, 0, 0, 0, []],
				32,
				26,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[662, 378, 0, 48, 22, 0, 0, 1, 0, 0, 0, 0, []],
				33,
				27,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[60, 151, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				34,
				28,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"15",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[60, 211, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				35,
				29,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"100",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[60, 271, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				36,
				36,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"500",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[60, 331, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				37,
				61,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"3000",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[60, 391, 0, 194, 22, 0, 0, 1, 0, 0, 0, 0, []],
				38,
				62,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"10000",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[724, 151, 0, 194, 22, 0, 0, 1, 0, 0, 0, 0, []],
				39,
				63,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"40000",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[724, 211, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				40,
				64,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"200000",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[724, 271, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				41,
				65,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"1666666",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[724, 331, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				42,
				66,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"123456789",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[724, 391, 0, 195, 22, 0, 0, 1, 0, 0, 0, 0, []],
				43,
				67,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"3999999999",
					0.4,
					0,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[490, 492, 0, 293, 20, 0, 0, 1, 0, 0, 0, 0, []],
				44,
				68,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"0",
					0.4,
					0,
					1,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[399.9671325683594, 188.9671325683594, 0, 116.7277069091797, 116.7277069091797, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				45,
				18,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[365.4508361816406, 178.7454681396484, 0, 182.901611328125, 60.96720504760742, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				109,
				84,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"OnTopOfBackground",
			1,
			44827404238309,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[1157, 581, 0, 300, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				122,
				115,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1356, 475, 0, 300, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				123,
				116,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"Menu Ribbons",
			2,
			5287888947844153,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[346, 76, 0, 84, 120, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				46,
				19,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[424, 76, 0, 84, 120, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				47,
				20,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[502, 76, 0, 84, 120, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				48,
				21,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[580, 76, 0, 84, 120, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				49,
				22,
				[
					[0]
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[658, 76, 0, 84, 120, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				107,
				82,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[868, -34, 0, 100, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				79,
				78,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"ACHIEVEMENTS",
			3,
			7915448383363197,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-301, 514, 0, 556, 335, 0, 0, 1, 0.5, 0.5014925599098206, 0, 0, []],
				52,
				30,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-506, 475, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				53,
				31,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-406, 475, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				54,
				32,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-306, 475, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				55,
				33,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-206, 475, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				56,
				48,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-106, 475, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				57,
				49,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-506, 580, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				59,
				50,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-406, 580, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				60,
				51,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-306, 580, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				61,
				52,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-206, 580, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				62,
				53,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-106, 580, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				63,
				54,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-580, 594, 0, 533.60009765625, 58.00048828125, 0, 0, 1, 0, 0, 0, 0, []],
				64,
				55,
				[
				],
				[
				],
				[
					79,
					90,
					"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789.,;:?!-_~#\"'&()[]|`\\/@°+=*$£€<>",
					"PRESS AN ACHIEVEMENT TO  VIEW DETAILS",
					0.25,
					1,
					1,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-179, 702, 0, 150, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				65,
				56,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-97, -182, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				66,
				57,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[114, -34, 0, 500, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				67,
				58,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[609, -38, 0, 500, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				68,
				59,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[27, -185, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				70,
				69,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[130, -188, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				71,
				70,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[240, -192, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				72,
				71,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[354, -194, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				73,
				72,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[533, -196, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				74,
				73,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[647, -195, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				75,
				74,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[830, -195, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				76,
				75,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[954, -196, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				77,
				76,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1063, -196, 0, 256, 256, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				78,
				77,
				[
				],
				[
				[
					1,
					400,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
,		[
			"PowerCoin",
			4,
			351104658518801,
			true,
			[255, 255, 255],
			true,
			1,
			1,
			1,
			false,
			1,
			0,
			0,
			[
			[
				[-2, 861, 0, 960, 640, 0, 0, 1, 0, 0, 0, 0, []],
				81,
				80,
				[
				],
				[
				],
				[
					0,
					0,
					0
				]
			]
,			[
				[1090, 73, 0, 230, 136, 0, 0, 1, 0.5010846257209778, 0.5, 0, 0, []],
				80,
				90,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1090, 180, 0, 230, 136, 0, 0, 1, 0.5010846257209778, 0.5, 0, 0, []],
				82,
				91,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1090, 261, 0, 230, 136, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				83,
				92,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1090, 361, 0, 230, 136, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				84,
				93,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1090, 449, 0, 230, 136, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				85,
				94,
				[
				],
				[
				[
					0,
					0,
					0
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[410, 705, 0, 527, 42, 0, 0, 1, 0.5009487867355347, 0.5, 0, 0, []],
				91,
				97,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[386, 684, 0, 600, 42, 0, 0, 1, 0.5016666650772095, 0.5, 0, 0, []],
				92,
				96,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[66, 748, 0, 421, 24, 0, 0, 1, 0, 0, 0, 0, []],
				93,
				98,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"0",
					0.4,
					1,
					2,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[510, 748, 0, 393, 30, 0, 0, 1, 0, 0, 0, 0, []],
				94,
				99,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"0",
					0.4,
					1,
					0,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[-9, 707, 0, 200, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				95,
				100,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-54, 181, 0, 21.02732658386231, 21.97140884399414, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				96,
				95,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[-37, 217, 0, 21.02700042724609, 21.97100067138672, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				98,
				102,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-39, 245, 0, 21.02700042724609, 21.97100067138672, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				99,
				103,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-40, 274, 0, 21.02700042724609, 21.97100067138672, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				100,
				104,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-39, 298, 0, 21.02700042724609, 21.97100067138672, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				101,
				105,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[-43, 172, 0, 93, 30, 0, 0, 1, 0, 0, 0, 0, []],
				97,
				101,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"200",
					0.4,
					1,
					0,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[-72, 199, 0, 93, 30, 0, 0, 1, 0, 0, 0, 0, []],
				102,
				106,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"200",
					0.4,
					1,
					0,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[-74, 235, 0, 93, 30, 0, 0, 1, 0, 0, 0, 0, []],
				103,
				107,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"1",
					0.4,
					1,
					0,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[-72, 266, 0, 93, 30, 0, 0, 1, 0, 0, 0, 0, []],
				104,
				108,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"1",
					0.4,
					1,
					0,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[-72, 292, 0, 93, 30, 0, 0, 1, 0, 0, 0, 0, []],
				105,
				109,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"5",
					0.4,
					1,
					0,
					0,
					0,
					0,
					1,
					0
				]
			]
,			[
				[936, 485, 0, 10, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				106,
				110,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[905, 485, 0, 40, 42, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				86,
				86,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[744, 476, 0, 138, 21, 0, 0, 1, 0, 0, 0, 0, []],
				89,
				81,
				[
				],
				[
				],
				[
					33,
					43,
					"0123456789.",
					"0",
					0.4,
					0,
					2,
					0,
					0,
					0,
					0,
					0
				]
			]
,			[
				[1379, -20, 0, 900, 100, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				108,
				83,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[901, 455, 0, 103.7795715332031, 21.17950439453125, 0, 0, 1, 0.5020408034324646, 0.5, 0, 0, []],
				87,
				87,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[1122, 809, 0, 556, 335, 0, 0, 1, 0.5, 0.5014925599098206, 0, 0, []],
				118,
				112,
				[
				],
				[
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
,			[
				[976, 874, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				124,
				117,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1055, 872, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				125,
				118,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1134, 871, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				126,
				119,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1213, 869, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				127,
				120,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1296, 870, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				128,
				121,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1091, 910, 0, 120, 30, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				129,
				122,
				[
				],
				[
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[952, 689, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				111,
				23,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1018, 689, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				112,
				34,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1085, 689, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				113,
				35,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1158, 688, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				114,
				60,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1233, 687, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				115,
				88,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[953, 779, 0, 90, 90, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				116,
				89,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1105.345458984375, 788.1427001953125, 0, 195.5762329101563, 112.692626953125, 0, 0, 1, 0.5018587112426758, 0.5, 0, 0, []],
				117,
				111,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					1,
					"Default",
					0,
					1
				]
			]
,			[
				[1221, 941, 0, 150, 50, 0, 0, 1, 0.5, 0.5, 0, 0, []],
				119,
				113,
				[
				],
				[
				[
					0,
					1,
					2
				]
				],
				[
					0,
					"Default",
					0,
					1
				]
			]
			],
			[			]
		]
		],
		[
		],
		[]
	]
	],
	[
	[
		"Event sheet 1",
		[
		[
			1,
			"TotalFame",
			0,
			0,
false,false,5640556131027101,false
		]
,		[
			1,
			"Fame",
			0,
			0,
false,false,8436211588480816,false
		]
,		[
			1,
			"TotalFPS",
			0,
			0,
false,false,587191795358437,false
		]
,		[
			1,
			"Upgrade1FPS",
			0,
			0.1,
false,false,2136836152492701,false
		]
,		[
			1,
			"Upgrade2FPS",
			0,
			0.5,
false,false,3686707893982044,false
		]
,		[
			1,
			"Upgrade3FPS",
			0,
			4,
false,false,6351036135763554,false
		]
,		[
			1,
			"Upgrade4FPS",
			0,
			10,
false,false,8216872930634275,false
		]
,		[
			1,
			"Upgrade5FPS",
			0,
			40,
false,false,344390137239877,false
		]
,		[
			1,
			"Upgrade6FPS",
			0,
			100,
false,false,2738991586644715,false
		]
,		[
			1,
			"Upgrade7FPS",
			0,
			400,
false,false,7491751262578394,false
		]
,		[
			1,
			"Upgrade8FPS",
			0,
			6666,
false,false,9284706563942287,false
		]
,		[
			1,
			"Upgrade9FPS",
			0,
			98765,
false,false,9282102283832112,false
		]
,		[
			1,
			"Upgrade10FPS",
			0,
			999999,
false,false,6556639058224668,false
		]
,		[
			1,
			"Upgrade1Lvl",
			0,
			0,
false,false,519955534977548,false
		]
,		[
			1,
			"Upgrade2Lvl",
			0,
			0,
false,false,1493616856120605,false
		]
,		[
			1,
			"Upgrade3Lvl",
			0,
			0,
false,false,7534632669537816,false
		]
,		[
			1,
			"Upgrade4Lvl",
			0,
			0,
false,false,5926049883054862,false
		]
,		[
			1,
			"Upgrade5Lvl",
			0,
			0,
false,false,8096643777546758,false
		]
,		[
			1,
			"Upgrade6Lvl",
			0,
			0,
false,false,3165981538154874,false
		]
,		[
			1,
			"Upgrade7Lvl",
			0,
			0,
false,false,6069329398107502,false
		]
,		[
			1,
			"Upgrade8Lvl",
			0,
			0,
false,false,1305819386437699,false
		]
,		[
			1,
			"Upgrade9Lvl",
			0,
			0,
false,false,8504714146900992,false
		]
,		[
			1,
			"Upgrade10Lvl",
			0,
			0,
false,false,7741791144987512,false
		]
,		[
			1,
			"Upgrade1Cost",
			0,
			15,
false,false,5921179445963624,false
		]
,		[
			1,
			"Upgrade1Discounted",
			0,
			15,
false,false,8916079082496507,false
		]
,		[
			1,
			"Upgrade2Cost",
			0,
			100,
false,false,5930034282567298,false
		]
,		[
			1,
			"Upgrade2Discounted",
			0,
			100,
false,false,9973664880950568,false
		]
,		[
			1,
			"Upgrade3Cost",
			0,
			500,
false,false,5132594818682201,false
		]
,		[
			1,
			"Upgrade3Discounted",
			0,
			500,
false,false,1563172023566704,false
		]
,		[
			1,
			"Upgrade4Cost",
			0,
			3000,
false,false,1042134692565201,false
		]
,		[
			1,
			"Upgrade4Discounted",
			0,
			3000,
false,false,3183024546657464,false
		]
,		[
			1,
			"Upgrade5Cost",
			0,
			10000,
false,false,236807449971326,false
		]
,		[
			1,
			"Upgrade5Discounted",
			0,
			10000,
false,false,7751104433208041,false
		]
,		[
			1,
			"Upgrade6Cost",
			0,
			40000,
false,false,9580555577288551,false
		]
,		[
			1,
			"Upgrade6Discounted",
			0,
			40000,
false,false,3071858236491595,false
		]
,		[
			1,
			"Upgrade7Cost",
			0,
			200000,
false,false,9361229165172901,false
		]
,		[
			1,
			"Upgrade7Discounted",
			0,
			200000,
false,false,1270119860051181,false
		]
,		[
			1,
			"Upgrade8Cost",
			0,
			1666666,
false,false,5001013238758242,false
		]
,		[
			1,
			"Upgrade8Discounted",
			0,
			1666666,
false,false,6233538574912043,false
		]
,		[
			1,
			"Upgrade9Cost",
			0,
			123456789,
false,false,3425890942060194,false
		]
,		[
			1,
			"Upgrade9Discounted",
			0,
			123456789,
false,false,4899795578925273,false
		]
,		[
			1,
			"Upgrade10Cost",
			0,
			3999999999,
false,false,1801648205184471,false
		]
,		[
			1,
			"Upgrade10Discounted",
			0,
			3999999999,
false,false,7960783160461474,false
		]
,		[
			1,
			"CountPurse",
			0,
			0,
false,false,7410415874929579,false
		]
,		[
			1,
			"CountShoes",
			0,
			0,
false,false,5836110270791076,false
		]
,		[
			1,
			"CountMakeup",
			0,
			0,
false,false,1763992607777342,false
		]
,		[
			1,
			"CountPerfume",
			0,
			0,
false,false,2202314000087753,false
		]
,		[
			1,
			"CountDress",
			0,
			0,
false,false,8675144003725786,false
		]
,		[
			1,
			"CountSunglass",
			0,
			0,
false,false,2064612129953783,false
		]
,		[
			1,
			"CountPhone",
			0,
			0,
false,false,6959010439558684,false
		]
,		[
			1,
			"CountLingerie",
			0,
			0,
false,false,7883500978111888,false
		]
,		[
			1,
			"CountRunwayShows",
			0,
			0,
false,false,1444946334165058,false
		]
,		[
			1,
			"CountAgencies",
			0,
			0,
false,false,3686487208120878,false
		]
,		[
			1,
			"AchievementsVisible",
			0,
			0,
false,false,5121468780953149,false
		]
,		[
			1,
			"TotalLines",
			0,
			0,
false,false,8057557420569578,false
		]
,		[
			1,
			"AchievementPurseCompleted",
			0,
			0,
false,false,5610494326363661,false
		]
,		[
			1,
			"AchievementShoesCompleted",
			0,
			0,
false,false,3907799770390954,false
		]
,		[
			1,
			"AchievementMakeupCompleted",
			0,
			0,
false,false,3406439390975686,false
		]
,		[
			1,
			"AchievementPerfumeCompleted",
			0,
			0,
false,false,5672184195192001,false
		]
,		[
			1,
			"AchievementDressCompleted",
			0,
			0,
false,false,4369966443051924,false
		]
,		[
			1,
			"AchievementSunglassCompleted",
			0,
			0,
false,false,7684128029240684,false
		]
,		[
			1,
			"AchievementPhoneCompleted",
			0,
			0,
false,false,7090835734270094,false
		]
,		[
			1,
			"AchievementLingerieCompleted",
			0,
			0,
false,false,6191037169603164,false
		]
,		[
			1,
			"AchievementRunwayShowsCompleted",
			0,
			0,
false,false,4938381144312707,false
		]
,		[
			1,
			"AchievementAgenciesCompleted",
			0,
			0,
false,false,9326819727389733,false
		]
,		[
			1,
			"AchievementLight",
			0,
			0,
false,false,1652254278593811,false
		]
,		[
			1,
			"AchievementLightWhite",
			0,
			1,
false,false,1028829983559889,false
		]
,		[
			1,
			"AchievementLightGold",
			0,
			0,
false,false,1010428519203919,false
		]
,		[
			1,
			"PowerCoins",
			0,
			0,
false,false,4323060848044995,false
		]
,		[
			1,
			"FamePercent",
			0,
			0,
false,false,195616876015539,false
		]
,		[
			1,
			"FamePercentCount",
			0,
			0,
false,false,7851964873675482,false
		]
,		[
			1,
			"FamePercentCost",
			0,
			200,
false,false,4296947319747772,false
		]
,		[
			1,
			"LinesDiscount",
			0,
			0,
false,false,6903578682254065,false
		]
,		[
			1,
			"LinesDiscountCost",
			0,
			200,
false,false,3119924263163957,false
		]
,		[
			1,
			"LinesDiscountCount",
			0,
			0,
false,false,9473773211527525,false
		]
,		[
			1,
			"Clicks",
			0,
			1,
false,false,3740236568153864,false
		]
,		[
			1,
			"ClicksCost",
			0,
			1,
false,false,501142352532533,false
		]
,		[
			1,
			"ClicksCount",
			0,
			0,
false,false,3879974354874659,false
		]
,		[
			1,
			"FameBarPercent",
			0,
			0,
false,false,419146145560903,false
		]
,		[
			1,
			"FameBarNeeded",
			0,
			10000,
false,false,5412010334256325,false
		]
,		[
			1,
			"FameBarBalance",
			0,
			0,
false,false,3763096135417708,false
		]
,		[
			1,
			"Fame77on",
			0,
			0,
false,false,3737036468160984,false
		]
,		[
			1,
			"Fame77Cost",
			0,
			5,
false,false,3277121224508092,false
		]
,		[
			1,
			"DoubleFameCost",
			0,
			1,
false,false,197405247520531,false
		]
,		[
			1,
			"Fame77Timer",
			0,
			0,
false,false,3306480344034189,false
		]
,		[
			1,
			"FullAdCount",
			0,
			0,
false,false,3302474861309359,false
		]
,		[
			1,
			"CartVisible",
			0,
			0,
false,false,8091893214023531,false
		]
,		[
			1,
			"PowerCoinsTotal",
			0,
			0,
false,false,8266338649948162,false
		]
,		[
			1,
			"PowerCoinsDifference",
			0,
			0,
false,false,142070362659774,false
		]
,		[
			1,
			"PowerCoinsPurchased",
			0,
			0,
false,false,45784531977798,false
		]
,		[
			0,
			null,
			false,
			null,
			508497328010881,
			[
			[
				10,
				cr.behaviors.SpriteButton.prototype.cnds.OnClick,
				"SpriteButton",
				1,
				false,
				false,
				false,
				6005779579001851,
				false
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7782501878294065,
				false
				,[
				[
					11,
					"Fame"
				]
,				[
					7,
					[
						4,
						[
							23,
							"Fame"
						]
						,[
							23,
							"Clicks"
						]
					]
				]
				]
			]
,			[
				23,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				3730989231722663,
				false
				,[
				[
					7,
					[
						10,
						[
							2,
							""
						]
						,[
							19,
							cr.system_object.prototype.exps.round
							,[
[
								23,
								"Fame"
							]
							]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.AddVar,
				null,
				1629889549422004,
				false
				,[
				[
					11,
					"TotalFame"
				]
,				[
					7,
					[
						23,
						"Clicks"
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.CreateObject,
				null,
				586268723904135,
				false
				,[
				[
					4,
					79
				]
,				[
					5,
					[
						0,
						1
					]
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps.random
						,[
[
							0,
							380
						]
,[
							0,
							600
						]
						]
					]
				]
,				[
					0,
					[
						19,
						cr.system_object.prototype.exps.random
						,[
[
							0,
							134
						]
,[
							0,
							342
						]
						]
					]
				]
				]
			]
,			[
				79,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5573291775739488,
				false
				,[
				[
					3,
					1
				]
				]
			]
			]
			,[
			[
				0,
				null,
				false,
				null,
				9689274856583913,
				[
				[
					-1,
					cr.system_object.prototype.cnds.ForEach,
					null,
					0,
					true,
					false,
					false,
					6662057439937551,
					false
					,[
					[
						4,
						79
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					6251721000225126,
					false
				]
				],
				[
				[
					79,
					cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
					null,
					6384499025050949,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					3443563243594805,
					false
					,[
					[
						0,
						[
							23,
							"ClicksCount"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6647571549462926,
					false
					,[
					[
						0,
						[
							1,
							0.5
						]
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7259336865564747,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					79,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					6591169288920129,
					false
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Tutorial"],
			false,
			null,
			8440091759401712,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8440091759401712,
				false
				,[
				[
					1,
					[
						2,
						"Tutorial"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2007468440352701,
				[
				[
					11,
					cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
					null,
					0,
					false,
					false,
					false,
					4353684996579753,
					false
					,[
					[
						1,
						[
							2,
							"TutorialDone"
						]
					]
					]
				]
				],
				[
				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4788260404355989,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					2498370326095885,
					false
				]
,				[
					109,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4827149057318251,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2365923045863499,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareTime,
					null,
					0,
					false,
					false,
					false,
					7979334408261311,
					false
					,[
					[
						8,
						5
					]
,					[
						0,
						[
							1,
							120
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3438770749827046,
					false
					,[
					[
						1,
						[
							2,
							"TutorialDone"
						]
					]
,					[
						7,
						[
							2,
							"Yes"
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3426617417386485,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					109,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2344338755893333,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2270772709018495,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6342914266225339,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							15
						]
					]
					]
				]
				],
				[
				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5054732919222733,
					false
					,[
					[
						1,
						[
							2,
							"TutorialDone"
						]
					]
,					[
						7,
						[
							2,
							"Yes"
						]
					]
					]
				]
,				[
					45,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6767707699422619,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					45,
					cr.plugins_.Sprite.prototype.acts.Destroy,
					null,
					9038200509448225,
					false
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4764592266637307,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7398449208541026,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							15
						]
					]
					]
				]
				],
				[
				[
					109,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6517517996375063,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8648792010574141,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7771023972677057,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					109,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5796315232887068,
					false
					,[
					[
						3,
						0
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade1"],
			false,
			null,
			5162222932756408,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5162222932756408,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade1"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					0,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade1Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					2113952545012263,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade1Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8611765274774872,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					142081151521734,
					false
					,[
					[
						11,
						"Upgrade1Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade1Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8664055940415682,
					false
					,[
					[
						11,
						"Upgrade1Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade1Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					8143305943029935,
					false
					,[
					[
						11,
						"Upgrade1Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade1Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5741764330199803,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade1FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade1FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2960935323331139,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1178467783277571,
					false
					,[
					[
						11,
						"Upgrade1Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4100884246442059,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade1Lvl"
							]
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9497250190451964,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade1Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5835856646732458,
					false
					,[
					[
						11,
						"CountPurse"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3660669051492394,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade2"],
			false,
			null,
			3707703419493607,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3707703419493607,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					1,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade2Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					6675978133041802,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade2Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4345888564653879,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5419345078603885,
					false
					,[
					[
						11,
						"Upgrade2Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade2Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					395136388006398,
					false
					,[
					[
						11,
						"Upgrade2Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade2Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					2149916514237188,
					false
					,[
					[
						11,
						"Upgrade2Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade2Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1687074252413481,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade2FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade2FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6626118244232414,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9439563993311399,
					false
					,[
					[
						11,
						"Upgrade2Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6917285570537096,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade2Lvl"
							]
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7642588790356818,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade2Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3455813150544763,
					false
					,[
					[
						11,
						"CountShoes"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					7382189916747004,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade3"],
			false,
			null,
			4535165930274562,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4535165930274562,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					2,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade3Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					3126166837661268,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade3Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8738822711485456,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1613507164373176,
					false
					,[
					[
						11,
						"Upgrade3Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade3Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3207736444722607,
					false
					,[
					[
						11,
						"Upgrade3Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade3Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					6577129591880209,
					false
					,[
					[
						11,
						"Upgrade3Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade3Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2856269674735231,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade3FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade3FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4056057964251101,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1176492624513873,
					false
					,[
					[
						11,
						"Upgrade3Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3163686962238269,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade3Lvl"
							]
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					8250777022866088,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade3Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4024071657879283,
					false
					,[
					[
						11,
						"CountMakeup"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9810726801755501,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade4"],
			false,
			null,
			1506828436228702,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1506828436228702,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade4"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					3,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade4Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					1289856156472221,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade4Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3200191793671332,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2961402402891002,
					false
					,[
					[
						11,
						"Upgrade4Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade4Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6308062017132352,
					false
					,[
					[
						11,
						"Upgrade4Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade4Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					9959867466869378,
					false
					,[
					[
						11,
						"Upgrade4Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade4Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4191353264018725,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade4FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade4FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4782111589370906,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4026432568467492,
					false
					,[
					[
						11,
						"Upgrade4Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1259521703137786,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade4Lvl"
							]
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5436164250924463,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade4Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8610843880608899,
					false
					,[
					[
						11,
						"CountPerfume"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3665565202723843,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade5"],
			false,
			null,
			1018488287924514,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1018488287924514,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					4,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade5Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					7664028887315001,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade5Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4982252689232755,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4377321621780299,
					false
					,[
					[
						11,
						"Upgrade5Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade5Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4286949516967986,
					false
					,[
					[
						11,
						"Upgrade5Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade5Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					5980098295103162,
					false
					,[
					[
						11,
						"Upgrade5Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade5Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9728831103993147,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade5FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade5FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1375234773511852,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6670399818136671,
					false
					,[
					[
						11,
						"Upgrade5Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2094828873235048,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade5Lvl"
							]
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					724651680107967,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade5Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4366710496445883,
					false
					,[
					[
						11,
						"CountDress"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3182254358790809,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade6"],
			false,
			null,
			1544281037095737,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1544281037095737,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					5,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade6Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					9503501346295213,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade6Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9658556826632459,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5252689874338009,
					false
					,[
					[
						11,
						"Upgrade6Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade6Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1420566429661678,
					false
					,[
					[
						11,
						"Upgrade6Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade6Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					6668457719293176,
					false
					,[
					[
						11,
						"Upgrade6Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade6Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9907776596419718,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade6FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade6FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2799811513718574,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1382713246897572,
					false
					,[
					[
						11,
						"Upgrade6Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					414285763031615,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade6Lvl"
							]
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7236658895856471,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade6Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1810260111099896,
					false
					,[
					[
						11,
						"CountSunglass"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2457393202142103,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade7"],
			false,
			null,
			5921303962252703,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5921303962252703,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade7"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					6,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade7Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					3974903839714773,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade7Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9658403660638098,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5451220642996826,
					false
					,[
					[
						11,
						"Upgrade7Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade7Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3214034126756893,
					false
					,[
					[
						11,
						"Upgrade7Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade7Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					1434589984532545,
					false
					,[
					[
						11,
						"Upgrade7Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade7Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9246645310747016,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade7FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade7FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3094469094330665,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5130661256944473,
					false
					,[
					[
						11,
						"Upgrade7Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7871583419362827,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade7Lvl"
							]
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9891256737809187,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade7Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					905746456366764,
					false
					,[
					[
						11,
						"CountPhone"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3040140316808814,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade8"],
			false,
			null,
			4984473983355305,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4984473983355305,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade8"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					7,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade8Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					7646590586394132,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade8Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					265173646865468,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					1730126937370649,
					false
					,[
					[
						11,
						"Upgrade8Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade8Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					1682254815699157,
					false
					,[
					[
						11,
						"Upgrade8Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade8Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					1788845299637268,
					false
					,[
					[
						11,
						"Upgrade8Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade8Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2722960704408555,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade8FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade8FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4886844861951859,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3495526749610977,
					false
					,[
					[
						11,
						"Upgrade8Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3467381749250492,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade8Lvl"
							]
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					9134664377534399,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade8Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8782512124297969,
					false
					,[
					[
						11,
						"CountLingerie"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3679260457285542,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade9"],
			false,
			null,
			4934585261422189,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4934585261422189,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade9"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					8,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade9Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					2941879524059891,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade9Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6304114434392083,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6991192233884296,
					false
					,[
					[
						11,
						"Upgrade9Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade9Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3611080696960961,
					false
					,[
					[
						11,
						"Upgrade9Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade9Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					768033069165682,
					false
					,[
					[
						11,
						"Upgrade9Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade9Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5473876670961323,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade9FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade9FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5690153697786533,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8643527319288812,
					false
					,[
					[
						11,
						"Upgrade9Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					3205312339369267,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade9Lvl"
							]
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					1839898684515044,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade9Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6025073638426113,
					false
					,[
					[
						11,
						"CountRunwayShows"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8482860609280957,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Upgrade10"],
			false,
			null,
			6418041787545407,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6418041787545407,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade10"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				423807729747224,
				[
				[
					9,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					408538574356539,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9876007100086464,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade10Discounted"
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					1852126295099581,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							23,
							"Upgrade10Discounted"
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4563447092655999,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2170568538159319,
					false
					,[
					[
						11,
						"Upgrade10Cost"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade10Cost"
							]
							,[
								1,
								0.15
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3824136105145508,
					false
					,[
					[
						11,
						"Upgrade10Discounted"
					]
,					[
						7,
						[
							23,
							"Upgrade10Cost"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SubVar,
					null,
					1404344604110134,
					false
					,[
					[
						11,
						"Upgrade10Discounted"
					]
,					[
						7,
						[
							6,
							[
								23,
								"Upgrade10Cost"
							]
							,[
								23,
								"LinesDiscount"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					2976265988926899,
					false
					,[
					[
						11,
						"TotalFPS"
					]
,					[
						7,
						[
							4,
							[
								23,
								"Upgrade10FPS"
							]
							,[
								6,
								[
									23,
									"Upgrade10FPS"
								]
								,[
									23,
									"FamePercent"
								]
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					4590171389306006,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"TotalFPS"
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3500683371636262,
					false
					,[
					[
						11,
						"Upgrade10Lvl"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2784322167726347,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								23,
								"Upgrade10Lvl"
							]
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					5762326418824672,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									23,
									"Upgrade10Discounted"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					499516134394736,
					false
					,[
					[
						11,
						"CountAgencies"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9369917352101923,
					false
					,[
					[
						11,
						"TotalLines"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled1"],
			false,
			null,
			8927550109206178,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8927550109206178,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled1"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade1Discounted"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled1"],
			false,
			null,
			7127244535735832,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7127244535735832,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled1"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade1Discounted"
						]
					]
					]
				]
				],
				[
				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled2"],
			false,
			null,
			9820403484976937,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9820403484976937,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade2Discounted"
						]
					]
					]
				]
				],
				[
				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled2"],
			false,
			null,
			2763443275568737,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2763443275568737,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled2"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade2Discounted"
						]
					]
					]
				]
				],
				[
				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled3"],
			false,
			null,
			7878736015646698,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7878736015646698,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade3Discounted"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled3"],
			false,
			null,
			6906080229151263,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6906080229151263,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled3"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade3Discounted"
						]
					]
					]
				]
				],
				[
				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled4"],
			false,
			null,
			9113734056405747,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9113734056405747,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled4"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade4Discounted"
						]
					]
					]
				]
				],
				[
				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled4"],
			false,
			null,
			5699313490305413,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5699313490305413,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled4"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade4Discounted"
						]
					]
					]
				]
				],
				[
				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled5"],
			false,
			null,
			2360031268668011,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2360031268668011,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade5Discounted"
						]
					]
					]
				]
				],
				[
				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled5"],
			false,
			null,
			6452064922667869,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6452064922667869,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled5"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade5Discounted"
						]
					]
					]
				]
				],
				[
				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled6"],
			false,
			null,
			6767604226826355,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6767604226826355,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade6Discounted"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled6"],
			false,
			null,
			6607537509394545,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6607537509394545,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled6"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade6Discounted"
						]
					]
					]
				]
				],
				[
				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled7"],
			false,
			null,
			6589347306918028,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6589347306918028,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled7"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade7Discounted"
						]
					]
					]
				]
				],
				[
				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled7"],
			false,
			null,
			670667435029584,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				670667435029584,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled7"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade7Discounted"
						]
					]
					]
				]
				],
				[
				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled8"],
			false,
			null,
			3281194924054864,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				3281194924054864,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled8"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade8Discounted"
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled8"],
			false,
			null,
			2651410224271142,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2651410224271142,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled8"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade8Discounted"
						]
					]
					]
				]
				],
				[
				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled9"],
			false,
			null,
			2796306866860216,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2796306866860216,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled9"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade9Discounted"
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled9"],
			false,
			null,
			8672428103581305,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8672428103581305,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled9"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade9Discounted"
						]
					]
					]
				]
				],
				[
				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeEnabled10"],
			false,
			null,
			5187978279431704,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5187978279431704,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeEnabled10"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				6829430767605727,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9157762520637102,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							23,
							"Upgrade10Discounted"
						]
					]
					]
				]
				],
				[
				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					4182812339468644,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "UpgradeDisabled10"],
			false,
			null,
			7001784521567274,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7001784521567274,
				false
				,[
				[
					1,
					[
						2,
						"UpgradeDisabled10"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				8693253054005207,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5136146781424897,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							23,
							"Upgrade10Discounted"
						]
					]
					]
				]
				],
				[
				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					8533442802173146,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Cash Per Minute"],
			false,
			null,
			7649475886155461,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				7649475886155461,
				false
				,[
				[
					1,
					[
						2,
						"Cash Per Minute"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9936690226250257,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					8392193237850792,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1044797762405196,
					false
					,[
					[
						11,
						"Fame77on"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8098100718085381,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							7,
							[
								23,
								"TotalFPS"
							]
							,[
								0,
								10
							]
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6049691116698745,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					146048503602449,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						7,
						[
							7,
							[
								23,
								"TotalFPS"
							]
							,[
								0,
								10
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					2450850346133817,
					false
					,[
					[
						7,
						[
							23,
							"TotalFPS"
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Cash Per Minute 77"],
			false,
			null,
			9507138440414617,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9507138440414617,
				false
				,[
				[
					1,
					[
						2,
						"Cash Per Minute 77"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9936690226250257,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					8392193237850792,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1044797762405196,
					false
					,[
					[
						11,
						"Fame77on"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1521954691660891,
					false
					,[
					[
						11,
						"Fame77Timer"
					]
,					[
						8,
						3
					]
,					[
						7,
						[
							0,
							70
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8098100718085381,
					false
					,[
					[
						11,
						"Fame"
					]
,					[
						7,
						[
							7,
							[
								6,
								[
									23,
									"TotalFPS"
								]
								,[
									0,
									7
								]
							]
							,[
								0,
								10
							]
						]
					]
					]
				]
,				[
					23,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					6049691116698745,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									23,
									"Fame"
								]
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					146048503602449,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						7,
						[
							7,
							[
								6,
								[
									23,
									"TotalFPS"
								]
								,[
									0,
									7
								]
							]
							,[
								0,
								10
							]
						]
					]
					]
				]
,				[
					44,
					cr.plugins_.Spritefont2.prototype.acts.SetText,
					null,
					7925829289665945,
					false
					,[
					[
						7,
						[
							10,
							[
								2,
								""
							]
							,[
								6,
								[
									23,
									"TotalFPS"
								]
								,[
									0,
									7
								]
							]
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4718794034951948,
					false
					,[
					[
						11,
						"Fame77Timer"
					]
,					[
						7,
						[
							1,
							0.1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4380287586352414,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					4157095629574678,
					false
					,[
					[
						11,
						"Fame77Timer"
					]
,					[
						8,
						4
					]
,					[
						7,
						[
							0,
							70
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4376880819004565,
					false
					,[
					[
						11,
						"Fame77Timer"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3058722770003356,
					false
					,[
					[
						11,
						"Fame77on"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Stop button animations at start"],
			false,
			null,
			6383905570643,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6383905570643,
				false
				,[
				[
					1,
					[
						2,
						"Stop button animations at start"
					]
				]
				]
			]
			],
			[
			]
		]
,		[
			0,
			null,
			false,
			null,
			8190949620820412,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				3072082320008373,
				false
			]
			],
			[
			[
				79,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				2926075037248248,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				0,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				3299115943861391,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				1,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				4317973918104812,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				2,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				3066413429736153,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				3,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				8067910946658588,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				4,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				1819927506279463,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				5,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				3892434514928896,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				6,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				5300828417934501,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				7,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				1385063396942394,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				8,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				7192835395678181,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				9,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				9791608525389988,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				10,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				5239342164057505,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				53,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				3560857849466171,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				54,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				7303079592021225,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				55,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				4944666460409473,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				56,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				9466779352507162,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				57,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				4875939576733317,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				59,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				1080783344823995,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				60,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				6067100279360954,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				61,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				9733513875372278,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				62,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				463467352198131,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				63,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				933905991990483,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				46,
				cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
				null,
				6167128367887379,
				false
				,[
				[
					0,
					[
						0,
						0
					]
				]
				]
			]
,			[
				81,
				cr.plugins_.c2canvas.prototype.acts.FillColor,
				null,
				9321970512543093,
				false
				,[
				[
					1,
					[
						2,
						"black"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Saving"],
			false,
			null,
			5138706309336854,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				5138706309336854,
				false
				,[
				[
					1,
					[
						2,
						"Saving"
					]
				]
				]
			]
			],
			[
			]
		]
,		[
			0,
			null,
			false,
			null,
			9318872511371848,
			[
			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				7306203879769752,
				false
				,[
				[
					0,
					[
						1,
						10
					]
				]
				]
			]
			],
			[
			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				8215494262009542,
				false
				,[
				[
					1,
					[
						2,
						"TotalFame"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"TotalFame"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5463751336705127,
				false
				,[
				[
					1,
					[
						2,
						"Fame"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Fame"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9069407555953411,
				false
				,[
				[
					1,
					[
						2,
						"TotalFPS"
					]
				]
,				[
					7,
					[
						23,
						"TotalFPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4848234656262976,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade1FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade1FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4716792705611345,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade2FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade2FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				8547786650489906,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade3FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade3FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7906970194763908,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade4FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade4FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7712963381121831,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade5FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade5FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1365006377740917,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade6FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade6FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				812067195174371,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade7FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade7FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5553094824219251,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade8FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade8FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				3402306487001915,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade9FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade9FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5389427268964028,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade10FPS"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade10FPS"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				2271120925061392,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade1Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade1Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				6664041972421933,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade2Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade2Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				416216839119389,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade3Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade3Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				6338593489615543,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade4Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade4Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4952535953445582,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade5Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade5Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				3257704550183537,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade6Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade6Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4113071586399936,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade7Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade7Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				220809208118749,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade8Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade8Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5840530755011508,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade9Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade9Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				415599300004533,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade10Lvl"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade10Lvl"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7078316161590853,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade1Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade1Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7662798374026875,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade2Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade2Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9220266305016017,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade3Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade3Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				774263518276506,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade4Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade4Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				936796818853617,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade5Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade5Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4470703647512694,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade6Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade6Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				785027594207567,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade7Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade7Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1764611723306951,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade8Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade8Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				2472740222547676,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade9Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade9Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5087460075041601,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade10Cost"
					]
				]
,				[
					7,
					[
						19,
						cr.system_object.prototype.exps.round
						,[
[
							23,
							"Upgrade10Cost"
						]
						]
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7676348271347402,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade1Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade1Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4316091483938321,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade2Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade2Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5025374766004509,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade3Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade3Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1936649357388947,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade4Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade4Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9397216196235706,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade5Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade5Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				2823366102838673,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade6Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade6Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7425719182333616,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade7Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade7Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5397401735027733,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade8Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade8Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5028388622244292,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade9Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade9Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				403288370836467,
				false
				,[
				[
					1,
					[
						2,
						"Upgrade10Discounted"
					]
				]
,				[
					7,
					[
						23,
						"Upgrade10Discounted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				8947741799752982,
				false
				,[
				[
					1,
					[
						2,
						"CountPurse"
					]
				]
,				[
					7,
					[
						23,
						"CountPurse"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1918559467310673,
				false
				,[
				[
					1,
					[
						2,
						"CountShoes"
					]
				]
,				[
					7,
					[
						23,
						"CountShoes"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9047973548649422,
				false
				,[
				[
					1,
					[
						2,
						"CountMakeup"
					]
				]
,				[
					7,
					[
						23,
						"CountMakeup"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				703610834892501,
				false
				,[
				[
					1,
					[
						2,
						"CountPurfume"
					]
				]
,				[
					7,
					[
						23,
						"CountPerfume"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				891697629247076,
				false
				,[
				[
					1,
					[
						2,
						"CountDress"
					]
				]
,				[
					7,
					[
						23,
						"CountDress"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4201719984265112,
				false
				,[
				[
					1,
					[
						2,
						"CountSunglass"
					]
				]
,				[
					7,
					[
						23,
						"CountSunglass"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1322598806776878,
				false
				,[
				[
					1,
					[
						2,
						"CountPhone"
					]
				]
,				[
					7,
					[
						23,
						"CountPhone"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9581784616402625,
				false
				,[
				[
					1,
					[
						2,
						"CountLingerie"
					]
				]
,				[
					7,
					[
						23,
						"CountLingerie"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5101598249104989,
				false
				,[
				[
					1,
					[
						2,
						"CountRunwayShows"
					]
				]
,				[
					7,
					[
						23,
						"CountRunwayShows"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7902137203296856,
				false
				,[
				[
					1,
					[
						2,
						"CountAgencies"
					]
				]
,				[
					7,
					[
						23,
						"CountAgencies"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5455464138304565,
				false
				,[
				[
					1,
					[
						2,
						"TotalLines"
					]
				]
,				[
					7,
					[
						23,
						"TotalLines"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				3943749883048373,
				false
				,[
				[
					1,
					[
						2,
						"AchievementPurseCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementPurseCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				3403656146617867,
				false
				,[
				[
					1,
					[
						2,
						"AchievementShoesCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementShoesCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				99131604698751,
				false
				,[
				[
					1,
					[
						2,
						"AchievementMakeupCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementMakeupCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5423563685604726,
				false
				,[
				[
					1,
					[
						2,
						"AchievementPerfumeCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementPerfumeCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5881369496161757,
				false
				,[
				[
					1,
					[
						2,
						"AchievementDressCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementDressCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				6797166745611247,
				false
				,[
				[
					1,
					[
						2,
						"AchievementSunglassCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementSunglassCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7709342782343444,
				false
				,[
				[
					1,
					[
						2,
						"AchievementPhoneCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementPhoneCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				2238572054504017,
				false
				,[
				[
					1,
					[
						2,
						"AchievementLingerieCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementLingerieCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				230835326008637,
				false
				,[
				[
					1,
					[
						2,
						"AchievementRunwayShowsCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementRunwayShowsCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1434071797885743,
				false
				,[
				[
					1,
					[
						2,
						"AchievementAgenciesCompleted"
					]
				]
,				[
					7,
					[
						23,
						"AchievementAgenciesCompleted"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				518442958938239,
				false
				,[
				[
					1,
					[
						2,
						"AchievementLight"
					]
				]
,				[
					7,
					[
						23,
						"AchievementLight"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5697235281451005,
				false
				,[
				[
					1,
					[
						2,
						"AchievementLightWhite"
					]
				]
,				[
					7,
					[
						23,
						"AchievementLightWhite"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				8425435763642855,
				false
				,[
				[
					1,
					[
						2,
						"AchievementLightGold"
					]
				]
,				[
					7,
					[
						23,
						"AchievementLightGold"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				220498262751422,
				false
				,[
				[
					1,
					[
						2,
						"PowerCoins"
					]
				]
,				[
					7,
					[
						23,
						"PowerCoins"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				6748933001363275,
				false
				,[
				[
					1,
					[
						2,
						"FamePercent"
					]
				]
,				[
					7,
					[
						23,
						"FamePercent"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1224299516684963,
				false
				,[
				[
					1,
					[
						2,
						"FamePercentCount"
					]
				]
,				[
					7,
					[
						23,
						"FamePercentCount"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7239371154878662,
				false
				,[
				[
					1,
					[
						2,
						"FamePercentCost"
					]
				]
,				[
					7,
					[
						23,
						"FamePercentCost"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				4365615385818892,
				false
				,[
				[
					1,
					[
						2,
						"LinesDiscount"
					]
				]
,				[
					7,
					[
						23,
						"LinesDiscount"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5320765746474673,
				false
				,[
				[
					1,
					[
						2,
						"LinesDiscountCost"
					]
				]
,				[
					7,
					[
						23,
						"LinesDiscountCost"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9247380749572654,
				false
				,[
				[
					1,
					[
						2,
						"LinesDiscountCount"
					]
				]
,				[
					7,
					[
						23,
						"LinesDiscountCount"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				6191418916506263,
				false
				,[
				[
					1,
					[
						2,
						"Clicks"
					]
				]
,				[
					7,
					[
						23,
						"Clicks"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				9570839932010815,
				false
				,[
				[
					1,
					[
						2,
						"ClicksCost"
					]
				]
,				[
					7,
					[
						23,
						"ClicksCost"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				5293603869446567,
				false
				,[
				[
					1,
					[
						2,
						"ClicksCount"
					]
				]
,				[
					7,
					[
						23,
						"ClicksCount"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7119494857212811,
				false
				,[
				[
					1,
					[
						2,
						"FameBarPercent"
					]
				]
,				[
					7,
					[
						23,
						"FameBarPercent"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				215982076817415,
				false
				,[
				[
					1,
					[
						2,
						"FameBarNeeded"
					]
				]
,				[
					7,
					[
						23,
						"FameBarNeeded"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				7703053153297761,
				false
				,[
				[
					1,
					[
						2,
						"FameBarBalance"
					]
				]
,				[
					7,
					[
						23,
						"FameBarBalance"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				1074630469203709,
				false
				,[
				[
					1,
					[
						2,
						"Fame77Cost"
					]
				]
,				[
					7,
					[
						23,
						"Fame77Cost"
					]
				]
				]
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.acts.StoreLocal,
				null,
				682894769604433,
				false
				,[
				[
					1,
					[
						2,
						"DoubleFameCost"
					]
				]
,				[
					7,
					[
						23,
						"DoubleFameCost"
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Loading"],
			false,
			null,
			9634741826862255,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				9634741826862255,
				false
				,[
				[
					1,
					[
						2,
						"Loading"
					]
				]
				]
			]
			],
			[
			]
		]
,		[
			0,
			null,
			false,
			null,
			7368905533890387,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				8122888143457828,
				false
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
				null,
				0,
				false,
				false,
				false,
				5254137459841027,
				false
				,[
				[
					1,
					[
						2,
						"Fame"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9486623364537756,
				false
				,[
				[
					11,
					"TotalFame"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"TotalFame"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3901886685424479,
				false
				,[
				[
					11,
					"Fame"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Fame"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8038303716112523,
				false
				,[
				[
					11,
					"TotalFPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"TotalFPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4407996710574699,
				false
				,[
				[
					11,
					"Upgrade1FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7072264980747418,
				false
				,[
				[
					11,
					"Upgrade2FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6061473898374589,
				false
				,[
				[
					11,
					"Upgrade3FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3472561531189122,
				false
				,[
				[
					11,
					"Upgrade4FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3174852510258114,
				false
				,[
				[
					11,
					"Upgrade5FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				401457872237873,
				false
				,[
				[
					11,
					"Upgrade6FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5445797150873855,
				false
				,[
				[
					11,
					"Upgrade7FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9633891793660429,
				false
				,[
				[
					11,
					"Upgrade8FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2945876674845016,
				false
				,[
				[
					11,
					"Upgrade9FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6722408173557869,
				false
				,[
				[
					11,
					"Upgrade10FPS"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10FPS"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6995369236461974,
				false
				,[
				[
					11,
					"Upgrade1Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4753818373170032,
				false
				,[
				[
					11,
					"Upgrade2Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3667671424760594,
				false
				,[
				[
					11,
					"Upgrade3Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2655329993471029,
				false
				,[
				[
					11,
					"Upgrade4Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3025210643851178,
				false
				,[
				[
					11,
					"Upgrade5Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8854131954387371,
				false
				,[
				[
					11,
					"Upgrade6Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1803084587935407,
				false
				,[
				[
					11,
					"Upgrade7Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6192411811940058,
				false
				,[
				[
					11,
					"Upgrade8Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7449718679460072,
				false
				,[
				[
					11,
					"Upgrade9Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2212075766894815,
				false
				,[
				[
					11,
					"Upgrade10Lvl"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7061881138426326,
				false
				,[
				[
					11,
					"Upgrade1Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9092136036056226,
				false
				,[
				[
					11,
					"Upgrade2Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5401911488869729,
				false
				,[
				[
					11,
					"Upgrade3Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7111563289375536,
				false
				,[
				[
					11,
					"Upgrade4Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7321481503619134,
				false
				,[
				[
					11,
					"Upgrade5Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8324550209420973,
				false
				,[
				[
					11,
					"Upgrade6Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1715857826179675,
				false
				,[
				[
					11,
					"Upgrade7Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2308343438285667,
				false
				,[
				[
					11,
					"Upgrade8Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3941786274312709,
				false
				,[
				[
					11,
					"Upgrade9Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6483032085730278,
				false
				,[
				[
					11,
					"Upgrade10Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5752728093750335,
				false
				,[
				[
					11,
					"Upgrade1Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				389399551517238,
				false
				,[
				[
					11,
					"Upgrade2Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6650162198094275,
				false
				,[
				[
					11,
					"Upgrade3Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1132066322671441,
				false
				,[
				[
					11,
					"Upgrade4Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4376096147930713,
				false
				,[
				[
					11,
					"Upgrade5Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				871197357035845,
				false
				,[
				[
					11,
					"Upgrade6Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				12339858365739,
				false
				,[
				[
					11,
					"Upgrade7Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				250385971300811,
				false
				,[
				[
					11,
					"Upgrade8Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				998544950262753,
				false
				,[
				[
					11,
					"Upgrade9Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9Discounted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4889523635394882,
				false
				,[
				[
					11,
					"Upgrade10Discounted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10Discounted"
						]
						]
					]
				]
				]
			]
,			[
				23,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8908930772109088,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Fame"
						]
						]
					]
				]
				]
			]
,			[
				44,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				492328233935786,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"TotalFPS"
						]
						]
					]
				]
				]
			]
,			[
				34,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				2411486747680566,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1Cost"
						]
						]
					]
				]
				]
			]
,			[
				35,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7406711511742582,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2Cost"
						]
						]
					]
				]
				]
			]
,			[
				36,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				1729769634585622,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3Cost"
						]
						]
					]
				]
				]
			]
,			[
				37,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				6308029184124217,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4Cost"
						]
						]
					]
				]
				]
			]
,			[
				38,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				5364567897020761,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5Cost"
						]
						]
					]
				]
				]
			]
,			[
				39,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7456059648564732,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6Cost"
						]
						]
					]
				]
				]
			]
,			[
				40,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8578973540174066,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7Cost"
						]
						]
					]
				]
				]
			]
,			[
				41,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				350095109320583,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8Cost"
						]
						]
					]
				]
				]
			]
,			[
				42,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				4385843658345197,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9Cost"
						]
						]
					]
				]
				]
			]
,			[
				43,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7727904659031347,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10Cost"
						]
						]
					]
				]
				]
			]
,			[
				24,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8634525083523449,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade1Lvl"
						]
						]
					]
				]
				]
			]
,			[
				25,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				3409923715452307,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade2Lvl"
						]
						]
					]
				]
				]
			]
,			[
				26,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				7648185660403778,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade3Lvl"
						]
						]
					]
				]
				]
			]
,			[
				27,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				569839039802037,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade4Lvl"
						]
						]
					]
				]
				]
			]
,			[
				28,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				9775268298774071,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade5Lvl"
						]
						]
					]
				]
				]
			]
,			[
				29,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				9031939232077379,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade6Lvl"
						]
						]
					]
				]
				]
			]
,			[
				30,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				6524980060833724,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade7Lvl"
						]
						]
					]
				]
				]
			]
,			[
				31,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				4075495639917949,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade8Lvl"
						]
						]
					]
				]
				]
			]
,			[
				32,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8012219374092097,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade9Lvl"
						]
						]
					]
				]
				]
			]
,			[
				33,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				5383250841906613,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Upgrade10Lvl"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7910113790898119,
				false
				,[
				[
					11,
					"CountPurse"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountPurse"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9604051268776384,
				false
				,[
				[
					11,
					"CountShoes"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountShoes"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				600246830136315,
				false
				,[
				[
					11,
					"CountMakeup"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountMakeup"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3477672827651766,
				false
				,[
				[
					11,
					"CountPerfume"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountPurfume"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7754288804924142,
				false
				,[
				[
					11,
					"CountDress"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountDress"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2309694398571818,
				false
				,[
				[
					11,
					"CountSunglass"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountSunglass"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2892309756960024,
				false
				,[
				[
					11,
					"CountPhone"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountPhone"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3296540398648491,
				false
				,[
				[
					11,
					"CountLingerie"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountLingerie"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				877826552142136,
				false
				,[
				[
					11,
					"CountRunwayShows"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountRunwayShows"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6606149577209635,
				false
				,[
				[
					11,
					"CountAgencies"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"CountAgencies"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6522240376418228,
				false
				,[
				[
					11,
					"TotalLines"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"TotalLines"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9971052729096945,
				false
				,[
				[
					11,
					"AchievementPurseCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementPurseCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1369147970564857,
				false
				,[
				[
					11,
					"AchievementShoesCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementShoesCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1020140357879241,
				false
				,[
				[
					11,
					"AchievementMakeupCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementMakeupCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6464301113517555,
				false
				,[
				[
					11,
					"AchievementPerfumeCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementPurfumeCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7179198129923428,
				false
				,[
				[
					11,
					"AchievementDressCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementDressCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9804067273256354,
				false
				,[
				[
					11,
					"AchievementSunglassCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementSunglassCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8086715847466518,
				false
				,[
				[
					11,
					"AchievementPhoneCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementPhoneCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2681701960691148,
				false
				,[
				[
					11,
					"AchievementLingerieCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementLingerieCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				2733838611095882,
				false
				,[
				[
					11,
					"AchievementRunwayShowsCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementRunwayShowsCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9012142450598789,
				false
				,[
				[
					11,
					"AchievementAgenciesCompleted"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementAgenciesCompleted"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4453869493239724,
				false
				,[
				[
					11,
					"AchievementLight"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementLight"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6767278775287496,
				false
				,[
				[
					11,
					"AchievementLightWhite"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementLightWhite"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8413754022252097,
				false
				,[
				[
					11,
					"AchievementLightGold"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"AchievementLightGold"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6827738477531001,
				false
				,[
				[
					11,
					"FamePercent"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FamePercent"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				4534750035651859,
				false
				,[
				[
					11,
					"FamePercentCount"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FamePercentCount"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1367435089167212,
				false
				,[
				[
					11,
					"FamePercentCost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FamePercentCost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				8499473442912666,
				false
				,[
				[
					11,
					"LinesDiscount"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"LinesDiscount"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5492985564007457,
				false
				,[
				[
					11,
					"LinesDiscountCost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"LinesDiscountCost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9845898022346122,
				false
				,[
				[
					11,
					"LinesDiscountCount"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"LinesDiscountCount"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9839298280060228,
				false
				,[
				[
					11,
					"Clicks"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Clicks"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				5600066834153771,
				false
				,[
				[
					11,
					"ClicksCost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"ClicksCost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7622893361408623,
				false
				,[
				[
					11,
					"ClicksCount"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"ClicksCount"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				7735421392962729,
				false
				,[
				[
					11,
					"FameBarPercent"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FameBarPercent"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1442028872365671,
				false
				,[
				[
					11,
					"FameBarNeeded"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FameBarNeeded"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				261161008145959,
				false
				,[
				[
					11,
					"FameBarBalance"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"FameBarBalance"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				872762433960128,
				false
				,[
				[
					11,
					"PowerCoins"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"PowerCoins"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				3395089612804311,
				false
				,[
				[
					11,
					"Fame77Cost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"Fame77Cost"
						]
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				9062149137012965,
				false
				,[
				[
					11,
					"DoubleFameCost"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"DoubleFameCost"
						]
						]
					]
				]
				]
			]
,			[
				89,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				5103749347556348,
				false
				,[
				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"PowerCoins"
						]
						]
					]
				]
				]
			]
,			[
				97,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				2311534366400818,
				false
				,[
				[
					7,
					[
						23,
						"FamePercentCost"
					]
				]
				]
			]
,			[
				102,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				306935576107813,
				false
				,[
				[
					7,
					[
						23,
						"LinesDiscountCost"
					]
				]
				]
			]
,			[
				103,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				8027588046058565,
				false
				,[
				[
					7,
					[
						23,
						"ClicksCost"
					]
				]
				]
			]
,			[
				104,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				9221091233408646,
				false
				,[
				[
					7,
					[
						23,
						"DoubleFameCost"
					]
				]
				]
			]
,			[
				105,
				cr.plugins_.Spritefont2.prototype.acts.SetText,
				null,
				997666489723698,
				false
				,[
				[
					7,
					[
						23,
						"Fame77Cost"
					]
				]
				]
			]
,			[
				83,
				cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
				"SpriteButton",
				4988265984352744,
				false
				,[
				[
					0,
					[
						23,
						"ClicksCount"
					]
				]
				]
			]
,			[
				83,
				cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
				"SpriteButton",
				9905169700749116,
				false
				,[
				[
					0,
					[
						23,
						"ClicksCount"
					]
				]
				]
			]
,			[
				83,
				cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
				"SpriteButton",
				5134662795534442,
				false
				,[
				[
					0,
					[
						23,
						"ClicksCount"
					]
				]
				]
			]
,			[
				80,
				cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
				"SpriteButton",
				2166117711906229,
				false
				,[
				[
					0,
					[
						23,
						"FamePercentCount"
					]
				]
				]
			]
,			[
				80,
				cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
				"SpriteButton",
				8609325153892006,
				false
				,[
				[
					0,
					[
						23,
						"FamePercentCount"
					]
				]
				]
			]
,			[
				80,
				cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
				"SpriteButton",
				6372132296128027,
				false
				,[
				[
					0,
					[
						23,
						"FamePercentCount"
					]
				]
				]
			]
,			[
				82,
				cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
				"SpriteButton",
				3955797081886216,
				false
				,[
				[
					0,
					[
						23,
						"LinesDiscountCount"
					]
				]
				]
			]
,			[
				82,
				cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
				"SpriteButton",
				6730325552659564,
				false
				,[
				[
					0,
					[
						23,
						"LinesDiscountCount"
					]
				]
				]
			]
,			[
				82,
				cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
				"SpriteButton",
				7045151997409312,
				false
				,[
				[
					0,
					[
						23,
						"LinesDiscountCount"
					]
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9499330943548063,
			[
			[
				-1,
				cr.system_object.prototype.cnds.OnLayoutStart,
				null,
				1,
				false,
				false,
				false,
				3667935425071651,
				false
			]
,			[
				11,
				cr.plugins_.WebStorage.prototype.cnds.LocalStorageExists,
				null,
				0,
				false,
				false,
				false,
				4067401824984998,
				false
				,[
				[
					1,
					[
						2,
						"PowerCoinsPurchased"
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				6563442851377764,
				false
				,[
				[
					11,
					"PowerCoinsPurchased"
				]
,				[
					7,
					[
						20,
						11,
						cr.plugins_.WebStorage.prototype.exps.LocalValue,
						true,
						null
						,[
[
							2,
							"PowerCoinsPurchased"
						]
						]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Play Store"],
			false,
			null,
			2557622002169914,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2557622002169914,
				false
				,[
				[
					1,
					[
						2,
						"Play Store"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7669757243760384,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					9704019892705337,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.fetchProductsFromStore,
					null,
					816820641147316,
					false
					,[
					[
						1,
						[
							2,
							"1dollarcoin,2dollarcoin,5dollarcoin,10dollarcoin,20dollarcoin,100dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6318786250847218,
				[
				[
					111,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					3712771172386582,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					7801849307951859,
					false
					,[
					[
						1,
						[
							2,
							"1dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1360742671415065,
				[
				[
					112,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					2818673160130825,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					8248964852640167,
					false
					,[
					[
						1,
						[
							2,
							"2dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5456158710538297,
				[
				[
					113,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					4030682893766366,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					7792989312392859,
					false
					,[
					[
						1,
						[
							2,
							"5dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1822960068832983,
				[
				[
					114,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					7863365425009527,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					3964731079678414,
					false
					,[
					[
						1,
						[
							2,
							"10dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9336128460379979,
				[
				[
					115,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					2136203604451373,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					4752687331959593,
					false
					,[
					[
						1,
						[
							2,
							"20dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1490211203972368,
				[
				[
					116,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					2584116563885282,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PurchasePreview,
					null,
					1524634001201403,
					false
					,[
					[
						1,
						[
							2,
							"100dollarcoin"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9557635641317399,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					4389868665201492,
					false
					,[
					[
						1,
						[
							2,
							"1dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4963730210103588,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1094178730625591,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					6504641507177701,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5997627354334138,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1076108924095877,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8947443864803805,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					8174532360814151,
					false
					,[
					[
						1,
						[
							2,
							"1dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5831612055056454,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4042087314657423,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6745032394393354,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							100
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					8774820633313872,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4630163691847257,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					104575191848095,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5369696206848483,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6339815226322017,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					3551871948150301,
					false
					,[
					[
						1,
						[
							2,
							"2dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1883196655179667,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					90913819101548,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9062855773589789,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6377460652955621,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6209054931986687,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2334827694280486,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					1212759297490055,
					false
					,[
					[
						1,
						[
							2,
							"2dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8363727713403839,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3203406413115897,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					8064036664790349,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							250
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					3065035936296412,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5595293396392746,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					529448789402561,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1078117739263098,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6602817465296668,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					215832487894952,
					false
					,[
					[
						1,
						[
							2,
							"5dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2885167425847107,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1472530723626508,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7700207370629855,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1910345106883442,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4115335066146778,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5661592359081123,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					273476772384219,
					false
					,[
					[
						1,
						[
							2,
							"5dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8266101270326899,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1599796454322529,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					7329185074205065,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							1000
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7935063672933649,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4473771661675906,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9665199324498716,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9415464767644196,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				349636903449588,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					8304867367732877,
					false
					,[
					[
						1,
						[
							2,
							"10dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7343922329182237,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7876182598990055,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3214010524881892,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7222173528283549,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1271165433585584,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				3803444480590427,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					7025637768611359,
					false
					,[
					[
						1,
						[
							2,
							"10dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8697204588268927,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5638017161277252,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					3171577567935475,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							3000
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					2398231335100061,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9732582274639481,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4645334857681841,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1229032046059588,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1897279760006751,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					2366000420657453,
					false
					,[
					[
						1,
						[
							2,
							"20dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7793287484594514,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1418592554305639,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					1742516750943991,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5530864935675594,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8653515879936141,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7517157399223122,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					9516876851701935,
					false
					,[
					[
						1,
						[
							2,
							"20dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2521061362921804,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6264204687628089,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4629187871015608,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							10000
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					7083916295582013,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					2456228940564795,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					169524778915863,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1825482921735635,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1465480930564037,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseFail,
					null,
					1,
					false,
					false,
					false,
					6072111116577261,
					false
					,[
					[
						1,
						[
							2,
							"100dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5488310885104234,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9119094373962956,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3846282245909705,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5621527141071078,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5926710916721538,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9805175403150066,
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.cnds.OnPurchaseComplete,
					null,
					1,
					false,
					false,
					false,
					853788582509082,
					false
					,[
					[
						1,
						[
							2,
							"100dollarcoin"
						]
					]
					]
				]
				],
				[
				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3573147427050239,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9808274739695442,
					false
					,[
					[
						0,
						[
							0,
							480
						]
					]
,					[
						0,
						[
							0,
							320
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					9330954991676438,
					false
					,[
					[
						11,
						"PowerCoinsPurchased"
					]
,					[
						7,
						[
							0,
							100000
						]
					]
					]
				]
,				[
					11,
					cr.plugins_.WebStorage.prototype.acts.StoreLocal,
					null,
					5820405772207696,
					false
					,[
					[
						1,
						[
							2,
							"PowerCoinsPurchased"
						]
					]
,					[
						7,
						[
							23,
							"PowerCoinsPurchased"
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8486156088035975,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					123,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4540450393497127,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					122,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					759358189533919,
					false
					,[
					[
						0,
						[
							0,
							1157
						]
					]
,					[
						0,
						[
							0,
							581
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Menu Ribbons"],
			false,
			null,
			2323770451598929,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2323770451598929,
				false
				,[
				[
					1,
					[
						2,
						"Menu Ribbons"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				7571752880562619,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					8513642731546292,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5795466719461224,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6151708326969406,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							1000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					1083775211135318,
					false
					,[
					[
						1,
						[
							2,
							"https://www.facebook.com/ArgieApps"
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4753585386889543,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					4051209401347238,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					7966528953082871,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1768321620743376,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							10000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					8499450566599334,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://24.media.tumblr.com/45f574337ad363d1eb549c10573f304a/tumblr_n5eabjSSg11tbysc0o1_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8841085610836733,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					5078461360301981,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6732834019064647,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							10000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2133057225397696,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							100000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					8969169385575516,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://24.media.tumblr.com/2e965135bb659922996b6a2c1bb9a69e/tumblr_n5eabjSSg11tbysc0o2_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2006796993299628,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					4173173814091586,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					4008496192307031,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							100000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6466129133709006,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							1000000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					3762535586973684,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://31.media.tumblr.com/45de0b53517ca3bca80ebbe8decebc86/tumblr_n5eabjSSg11tbysc0o3_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				1434004602913031,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					8806647925395167,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					506203887318034,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1000000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6057487690512471,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							1000000000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					840862061117512,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://24.media.tumblr.com/fa45c8ca59d7c80d3a8eafcdd21c2b59/tumblr_n5eabjSSg11tbysc0o4_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8948492349792106,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					3938285333344591,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9326080219551414,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1000000000
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					8030322511203019,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						2
					]
,					[
						7,
						[
							0,
							1000000000000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					9891424383058386,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://24.media.tumblr.com/b5edf55d1ebbb5c1d0d5dc21f3049309/tumblr_n5eabjSSg11tbysc0o5_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2382025998764324,
				[
				[
					47,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					3184807112902833,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					3174441042872779,
					false
					,[
					[
						11,
						"TotalFame"
					]
,					[
						8,
						5
					]
,					[
						7,
						[
							0,
							1000000000000
						]
					]
					]
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					454871338671951,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://www.facebook.com/dialog/feed?app_id=548656455255173&display=popup&caption=Play it on Facebook or your Android Phone&link=https://apps.facebook.com/popularlady&redirect_uri=https://facebook.com&name=Popular Lady Fashion Model&picture=https://24.media.tumblr.com/0495e25803600be315177512efafac02/tumblr_n5eabjSSg11tbysc0o6_1280.png&description=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on Popular Lady. You should join soon. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second, soon you wont be able to catch up."
							]
						]
					]
,					[
						1,
						[
							2,
							"ShareOnFacebook"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8304335949109442,
				[
				[
					48,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					3922927076537935,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					2412620772658751,
					false
					,[
					[
						1,
						[
							10,
							[
								10,
								[
									10,
									[
										10,
										[
											2,
											"https://twitter.com/intent/tweet?text=Famous! I have "
										]
										,[
											19,
											cr.system_object.prototype.exps.floor
											,[
[
												23,
												"TotalFame"
											]
											]
										]
									]
									,[
										2,
										" FAME on %23PopularLadyGame You should join. I am making "
									]
								]
								,[
									23,
									"TotalFPS"
								]
							]
							,[
								2,
								" Fame Per Second. Play @ Facebook&lang=en&url=http://goo.gl/tID3ii"
							]
						]
					]
,					[
						1,
						[
							2,
							"Twitter"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				7731334254702185,
				[
				[
					46,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					3186768062502002,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					775173082151716,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					284094027325477,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3547060185042621,
					false
					,[
					[
						11,
						"AchievementLight"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7637559865185863,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7568023730563364,
					false
					,[
					[
						0,
						[
							0,
							512
						]
					]
,					[
						0,
						[
							0,
							263
						]
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4661111601695671,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2839419606932214,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							441
						]
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetVisible,
					null,
					1260800132802065,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1108062022672407,
					false
					,[
					[
						0,
						[
							0,
							244
						]
					]
,					[
						0,
						[
							0,
							366
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2506101149797266,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7241831604740681,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2113203526798986,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					699001514004602,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4182978135947601,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1413086004426253,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4440615407462213,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3279267323762155,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6198141852295093,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8833460905139804,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1626993052827242,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5066632400727172,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8095277454386302,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2091180766972738,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4917187173350511,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					6342566709663167,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5545198525880626,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3526443004543362,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9405509405266896,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7362348645950627,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5542192926531313,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3658191278649791,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9395019798142895,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5638238756578987,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9431222902417984,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					185673320267105,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8430820012003848,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8279443065530283,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8699084654600764,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9669072128565137,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6095216626078167,
					false
					,[
					[
						0,
						[
							0,
							1211
						]
					]
,					[
						0,
						[
							0,
							712
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5005666150847196,
					false
					,[
					[
						0,
						[
							0,
							1211
						]
					]
,					[
						0,
						[
							0,
							712
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8920143860503402,
					false
					,[
					[
						0,
						[
							0,
							1124
						]
					]
,					[
						0,
						[
							0,
							721
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1433441204687563,
					false
					,[
					[
						0,
						[
							0,
							1124
						]
					]
,					[
						0,
						[
							0,
							721
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3029545404972514,
					false
					,[
					[
						0,
						[
							0,
							311
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5503719740356469,
					false
					,[
					[
						0,
						[
							0,
							411
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1323261067094913,
					false
					,[
					[
						0,
						[
							0,
							511
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3851498566129751,
					false
					,[
					[
						0,
						[
							0,
							611
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3209327422796751,
					false
					,[
					[
						0,
						[
							0,
							711
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					191158965121585,
					false
					,[
					[
						0,
						[
							0,
							311
						]
					]
,					[
						0,
						[
							0,
							315
						]
					]
					]
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5494758419866268,
					false
					,[
					[
						0,
						[
							0,
							411
						]
					]
,					[
						0,
						[
							0,
							315
						]
					]
					]
				]
,				[
					61,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9618729440104441,
					false
					,[
					[
						0,
						[
							0,
							511
						]
					]
,					[
						0,
						[
							0,
							315
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4836703279377898,
					false
					,[
					[
						0,
						[
							0,
							611
						]
					]
,					[
						0,
						[
							0,
							315
						]
					]
					]
				]
,				[
					63,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6252063081095415,
					false
					,[
					[
						0,
						[
							0,
							711
						]
					]
,					[
						0,
						[
							0,
							315
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3941759321869548,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3554306177964247,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4369264153247412,
				[
				[
					46,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					5328931897645281,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					590764818407093,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					8491039684933384,
					false
					,[
					[
						11,
						"AchievementLight"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8704110463690066,
					false
					,[
					[
						0,
						[
							0,
							-301
						]
					]
,					[
						0,
						[
							0,
							514
						]
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5177958784297201,
					false
					,[
					[
						0,
						[
							0,
							-179
						]
					]
,					[
						0,
						[
							0,
							702
						]
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1991801213700152,
					false
					,[
					[
						0,
						[
							0,
							-580
						]
					]
,					[
						0,
						[
							0,
							594
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1384180676793679,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7221531330921395,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					287062910635719,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6793104484915259,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9050822947707805,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3608388150666854,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2929084106576549,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					61,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4213589307449641,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					685673549769742,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					63,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9421672736632503,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9188858318331854,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2597814605136193,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3167309611561216,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					834613253851191,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6994120949327434,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5334248052543211,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7842709735449533,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3742763271766822,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1177888813211652,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					61,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2534309288430505,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9357964860089361,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					63,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1195271755898995,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetVisible,
					null,
					9222997749554159,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3089684017027845,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4042213218904864,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4625589739792887,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2324123552808736,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4606875558096631,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8692196340372459,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6775375795513594,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6770923153264761,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6593208473431835,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3259897069986566,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5746582447082646,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7744498487332586,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4252319828002763,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					676363708974137,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5425195856831948,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8472511146320725,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1629688127328558,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4754758272837042,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7816819294583167,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					509469288209981,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					811264907072275,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3719739678738283,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5753282843216876,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5514565061421344,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					437978321144868,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7249306772649434,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3350909204980304,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2153195083751551,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2576880164755955,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3379588446920245,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8777743389862158,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5981906424269928,
					false
					,[
					[
						0,
						[
							0,
							819
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4369783050605957,
					false
					,[
					[
						0,
						[
							0,
							152
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5906935796505509,
					false
					,[
					[
						0,
						[
							0,
							817
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8668239561061378,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9078674979458191,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					5470662455086588,
					false
					,[
					[
						11,
						"FullAdCount"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				832476042050453,
				[
				[
					49,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					2891099245077476,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					1689699219438575,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5454111285777748,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
				],
				[
				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3960370548780189,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6829849321992048,
					false
					,[
					[
						0,
						[
							0,
							512
						]
					]
,					[
						0,
						[
							0,
							263
						]
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					583899055162819,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					465633115303375,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							441
						]
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6293998364412761,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					462370011690514,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					384786254279729,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3521106347689359,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6300964077432853,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9166887999786505,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8913035124817913,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5957145057347746,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9779494823368467,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8279976646668047,
					false
					,[
					[
						0,
						[
							0,
							1089
						]
					]
,					[
						0,
						[
							0,
							695
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					6008880242671836,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9988155913332616,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3336548441401327,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8526476499340023,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8329446287119574,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2869693874340632,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					375436543413771,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4387631152126532,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8331650308026007,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9771146490933457,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4302772936409051,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					6789946269104928,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9783256379615559,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7767988805175149,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4140137054579822,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5180449836636006,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3356872346478225,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9592453085437868,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7169127970403582,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					903968478322819,
					false
					,[
					[
						0,
						[
							0,
							730
						]
					]
,					[
						0,
						[
							0,
							657
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7126159684018044,
					false
					,[
					[
						0,
						[
							0,
							1211
						]
					]
,					[
						0,
						[
							0,
							712
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5789012926285532,
					false
					,[
					[
						0,
						[
							0,
							1211
						]
					]
,					[
						0,
						[
							0,
							712
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					278692357600967,
					false
					,[
					[
						0,
						[
							0,
							1124
						]
					]
,					[
						0,
						[
							0,
							721
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5527280442878362,
					false
					,[
					[
						0,
						[
							0,
							1124
						]
					]
,					[
						0,
						[
							0,
							721
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6590433233163006,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3625152036237675,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6897340342845793,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6767799591348204,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5245628132621081,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3860181903997749,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2125380952754457,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5744067869075871,
					false
					,[
					[
						0,
						[
							0,
							311
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1200668825911896,
					false
					,[
					[
						0,
						[
							0,
							411
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					599002595682064,
					false
					,[
					[
						0,
						[
							0,
							511
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6301163848870715,
					false
					,[
					[
						0,
						[
							0,
							611
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9191906125218583,
					false
					,[
					[
						0,
						[
							0,
							711
						]
					]
,					[
						0,
						[
							0,
							210
						]
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1388829043971802,
					false
					,[
					[
						0,
						[
							0,
							311
						]
					]
,					[
						0,
						[
							0,
							340
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1353678120473431,
					false
					,[
					[
						0,
						[
							0,
							670
						]
					]
,					[
						0,
						[
							0,
							355
						]
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6974511180228158,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8314820352136637,
					false
					,[
					[
						0,
						[
							0,
							310
						]
					]
,					[
						0,
						[
							0,
							270
						]
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9680243347747602,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8678875478828945,
					false
					,[
					[
						0,
						[
							0,
							410
						]
					]
,					[
						0,
						[
							0,
							270
						]
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4919734773566821,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9971959057960061,
					false
					,[
					[
						0,
						[
							0,
							510
						]
					]
,					[
						0,
						[
							0,
							270
						]
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1650396045659053,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4075534170639664,
					false
					,[
					[
						0,
						[
							0,
							610
						]
					]
,					[
						0,
						[
							0,
							270
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2004245792466794,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					105358803753575,
					false
					,[
					[
						0,
						[
							0,
							710
						]
					]
,					[
						0,
						[
							0,
							270
						]
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2995286664567869,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7226058128937536,
					false
					,[
					[
						0,
						[
							0,
							310
						]
					]
,					[
						0,
						[
							0,
							400
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					3444494508766798,
					false
					,[
					[
						0,
						[
							1,
							0.2
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					369078813558364,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				4582233834468238,
				[
				[
					49,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					6264730830946668,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2472474267770667,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6718110566777971,
					false
					,[
					[
						0,
						[
							0,
							1122
						]
					]
,					[
						0,
						[
							0,
							809
						]
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8943271715341567,
					false
					,[
					[
						0,
						[
							0,
							-179
						]
					]
,					[
						0,
						[
							0,
							702
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5629290679587518,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2502862647041997,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7886475800194258,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5576156337765087,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2226699175176014,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2606063875885034,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4721292415824096,
					false
					,[
					[
						0,
						[
							0,
							1126
						]
					]
,					[
						0,
						[
							0,
							800
						]
					]
					]
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1675056035265884,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6240163716543238,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9282917340281419,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					316384366619784,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7962743916564929,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					4534500324144881,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1044044504294544,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1832054791362038,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					328275750130469,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5471598049249181,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5978552861647718,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3139663429299275,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9893642755517137,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1560630696492143,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6126943215242021,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8199516980076651,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7808498470273239,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9799451304709595,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6516753957252998,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8610359766413732,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					3489166270725534,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					76065230347105,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3530388826011865,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9474776690383237,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3528295472514693,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					925799070173166,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9741496674650771,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4683364060570455,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9525880459211384,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8494758222613979,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7879201872070763,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4180917602799413,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9465313295536401,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5178269520175152,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					871118688543306,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2928230943064888,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2294078079286622,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8903044530436096,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2466602694713283,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9511122931503195,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4841588493083893,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3189406020639219,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5014969772713519,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2275513642041181,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7681767037889083,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7188854894304032,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8800743273565553,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4661817753795872,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4395725691571661,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3058782626435036,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9407417598293216,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4031154759693316,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5875278092482327,
					false
					,[
					[
						0,
						[
							0,
							819
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9431874817436722,
					false
					,[
					[
						0,
						[
							0,
							152
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2349656882346914,
					false
					,[
					[
						0,
						[
							0,
							817
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5996406132795289,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9102919202005929,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6870703349980973,
					false
					,[
					[
						11,
						"FullAdCount"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2472870374612089,
				[
				[
					119,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					4949560793793113,
					false
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					2223264624289276,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1102814511287299,
					false
					,[
					[
						0,
						[
							0,
							1122
						]
					]
,					[
						0,
						[
							0,
							809
						]
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1577550983262621,
					false
					,[
					[
						0,
						[
							0,
							-179
						]
					]
,					[
						0,
						[
							0,
							702
						]
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4620594934807184,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3081942780885324,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7525688622196639,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2681604423247051,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1610856921750065,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1268197138205721,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3053862153977757,
					false
					,[
					[
						0,
						[
							0,
							1126
						]
					]
,					[
						0,
						[
							0,
							800
						]
					]
					]
				]
,				[
					118,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2098774895913816,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					119,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					928105536567686,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					111,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1206479779239461,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					112,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7368759744204904,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					113,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7608790062716662,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					114,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6367720199133467,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					115,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8466731547973028,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					116,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6279477746321453,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5010330721173968,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					124,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					22066696117923,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					786336057055177,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					125,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9152225488472639,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					5050456020909054,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					126,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6599930962122626,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					7951157418894056,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					127,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2868643814408231,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8834179364778039,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					128,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5572315244770119,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8983975563107371,
					false
					,[
					[
						3,
						1
					]
					]
				]
,				[
					129,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8753960933232649,
					false
					,[
					[
						0,
						[
							0,
							976
						]
					]
,					[
						0,
						[
							0,
							874
						]
					]
					]
				]
,				[
					117,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2391938679693375,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1208085257227249,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7145470778743621,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9368321379791228,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2945796255097552,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6375652141437103,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2488970124552413,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3441156468101147,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1528869587872316,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2360383572554045,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6763747759407536,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4035256025883077,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5745379699542535,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9467440106597906,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4769330546261362,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9565245714660558,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8272031864563558,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9789002341727354,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					6170964949831105,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					216447455261951,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1040526694462217,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2688818375451615,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9594447881147501,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5128831190142526,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2493547580487976,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4676202319204463,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9269120454772255,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3057026081738654,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2797375118787415,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1827930626889536,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1920418064760725,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3921596125701791,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5474288042784779,
					false
					,[
					[
						0,
						[
							0,
							819
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2857333096435252,
					false
					,[
					[
						0,
						[
							0,
							152
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1984620725494278,
					false
					,[
					[
						0,
						[
							0,
							817
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					8756995653588559,
					false
					,[
					[
						0,
						[
							1,
							0.1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					9852490091040542,
					false
					,[
					[
						11,
						"CartVisible"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					4541109345333328,
					false
					,[
					[
						11,
						"FullAdCount"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Achievements"],
			false,
			null,
			1736531541010749,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				1736531541010749,
				false
				,[
				[
					1,
					[
						2,
						"Achievements"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				9890563261399369,
				[
				[
					65,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					7476343879929489,
					false
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					7673377630030148,
					false
				]
				],
				[
				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3268541739011156,
					false
					,[
					[
						0,
						[
							0,
							-301
						]
					]
,					[
						0,
						[
							0,
							514
						]
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5312708447511561,
					false
					,[
					[
						0,
						[
							0,
							-179
						]
					]
,					[
						0,
						[
							0,
							702
						]
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5061742746841155,
					false
					,[
					[
						0,
						[
							0,
							-580
						]
					]
,					[
						0,
						[
							0,
							594
						]
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7522603464220118,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					179294682021736,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6463919561232251,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6222924516478744,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6494036207060747,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7313452092417557,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5697265269571754,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					61,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2556042369039474,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					62,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6115593111740354,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					63,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9566516312907398,
					false
					,[
					[
						0,
						[
							0,
							-506
						]
					]
,					[
						0,
						[
							0,
							475
						]
					]
					]
				]
,				[
					52,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					869726130032939,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					65,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					332766305286,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					64,
					cr.plugins_.Spritefont2.prototype.acts.SetVisible,
					null,
					1130623050828851,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					53,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2228533517521597,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					54,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1470022941190539,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					55,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					6970820668282475,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					56,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					619136628230247,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					57,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2511327203516333,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					59,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					9963291196365982,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					60,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8356559331063044,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					61,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					8553207126382306,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					62,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					1224695194720612,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					63,
					cr.plugins_.Sprite.prototype.acts.SetVisible,
					null,
					2504788099360202,
					false
					,[
					[
						3,
						0
					]
					]
				]
,				[
					0,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7093138076397833,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					1,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					2122981794661638,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					2,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					259066575893445,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					3,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					4269810006006688,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					4,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					9055223497160836,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					5,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					7606155265160787,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							145
						]
					]
					]
				]
,				[
					6,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					3415705935505719,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							205
						]
					]
					]
				]
,				[
					7,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8686559147829732,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							265
						]
					]
					]
				]
,				[
					8,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					5093166149106203,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							325
						]
					]
					]
				]
,				[
					9,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					1310437900434022,
					false
					,[
					[
						0,
						[
							0,
							820
						]
					]
,					[
						0,
						[
							0,
							385
						]
					]
					]
				]
,				[
					24,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3208890642218498,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					25,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4920622744640996,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					26,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2063870081186321,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					27,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					691305592014637,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					28,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4947053716640216,
					false
					,[
					[
						0,
						[
							0,
							3
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					29,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					8644556902538316,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							138
						]
					]
					]
				]
,				[
					30,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4200528108100468,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							198
						]
					]
					]
				]
,				[
					31,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					4397151601841798,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							258
						]
					]
					]
				]
,				[
					32,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5130112302905641,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							318
						]
					]
					]
				]
,				[
					33,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					659270576922927,
					false
					,[
					[
						0,
						[
							0,
							662
						]
					]
,					[
						0,
						[
							0,
							378
						]
					]
					]
				]
,				[
					34,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3492878000916695,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					35,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					2362966016956692,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					36,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9624711537667112,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					37,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					1511799310179559,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					38,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					5999903692430987,
					false
					,[
					[
						0,
						[
							0,
							60
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					39,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					6537452342149967,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							151
						]
					]
					]
				]
,				[
					40,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7377107844996663,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							211
						]
					]
					]
				]
,				[
					41,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					7883108974513301,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							271
						]
					]
					]
				]
,				[
					42,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					3171630944543426,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							331
						]
					]
					]
				]
,				[
					43,
					cr.plugins_.Spritefont2.prototype.acts.SetPos,
					null,
					9125370453018434,
					false
					,[
					[
						0,
						[
							0,
							724
						]
					]
,					[
						0,
						[
							0,
							391
						]
					]
					]
				]
,				[
					18,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6759401205244074,
					false
					,[
					[
						0,
						[
							0,
							155
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					19,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8874584732322057,
					false
					,[
					[
						0,
						[
							0,
							819
						]
					]
,					[
						0,
						[
							0,
							266
						]
					]
					]
				]
,				[
					16,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					8822148489109915,
					false
					,[
					[
						0,
						[
							0,
							152
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					17,
					cr.plugins_.Sprite.prototype.acts.SetPos,
					null,
					6092437377295278,
					false
					,[
					[
						0,
						[
							0,
							817
						]
					]
,					[
						0,
						[
							0,
							90
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					3474942533802377,
					false
					,[
					[
						11,
						"AchievementsVisible"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.AddVar,
					null,
					6535013288379489,
					false
					,[
					[
						11,
						"FullAdCount"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Not Achieved"],
				false,
				null,
				9291558011245706,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					9291558011245706,
					false
					,[
					[
						1,
						[
							2,
							"Not Achieved"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					9520754415281171,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7080910410070913,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4821238996190178,
						false
						,[
						[
							11,
							"CountPurse"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						53,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7899145164518477,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						53,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9162924113604866,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						53,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						1316279762812762,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5612834583166677,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						2233618087218735,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8541547897309262,
						false
						,[
						[
							11,
							"CountShoes"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						54,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7427843658969719,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5112075720233462,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						54,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						6057954120093288,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5986940813968398,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						5230730064914264,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9501331066262532,
						false
						,[
						[
							11,
							"CountMakeup"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						55,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8704277826413284,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						55,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5950453976025187,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						55,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						4437008767619239,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					693847210957076,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						4876609151913247,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9992491439499657,
						false
						,[
						[
							11,
							"CountPerfume"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6176273795275269,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7340253518736549,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						56,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						6845804973344432,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6568449652895297,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7526657552806393,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9041664212653021,
						false
						,[
						[
							11,
							"CountDress"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						57,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3467722139773443,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						57,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8402890262058713,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						57,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						2177520346580994,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1561053320819668,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3784033708212525,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4937294660624254,
						false
						,[
						[
							11,
							"CountSunglass"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						59,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3470902939914994,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						59,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						634098206670599,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						59,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						3644749687350117,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8571790781279455,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8156053363056763,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7330144404461412,
						false
						,[
						[
							11,
							"CountPhone"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						60,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5590753523736436,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						60,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4304482899134938,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						60,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						4538947823090561,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					330636814950869,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						4745690344775225,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5514252691078911,
						false
						,[
						[
							11,
							"CountLingerie"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						61,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7701353163530141,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						61,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1314506994527485,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						61,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						3439466534033581,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6054669219161653,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3174768430923456,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2406852557657029,
						false
						,[
						[
							11,
							"CountRunwayShows"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7181059605869327,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						62,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2362088028231896,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						62,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						6948215778710948,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8523019198120761,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						6497683635330023,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1564938223557486,
						false
						,[
						[
							11,
							"CountAgencies"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						63,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2842567346376821,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						63,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2057843778231858,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
,					[
						63,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						8426878261533707,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Achieved"],
				false,
				null,
				7484636366617227,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7484636366617227,
					false
					,[
					[
						1,
						[
							2,
							"Achieved"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					2769520685822618,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						9255067895790489,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						212197573568679,
						false
						,[
						[
							11,
							"CountPurse"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						53,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5828772313472203,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						53,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						555673261748127,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						53,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						3370488861124491,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6084493827929255,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8966295646300134,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3165965176214928,
						false
						,[
						[
							11,
							"CountShoes"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						54,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1003437595952081,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						54,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1407731584805721,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						54,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						9975535773624461,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5714717021111437,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						7980428378283255,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9214102397889583,
						false
						,[
						[
							11,
							"CountMakeup"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						55,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						695291639831502,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						55,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6124890310831047,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						55,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						3178191437675564,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7179787948069652,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						1561295919550473,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						809901715528947,
						false
						,[
						[
							11,
							"CountPerfume"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3846408682977845,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						56,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9950779792696833,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						56,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						9740052660114283,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8564968525755452,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						4541956781689696,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2188838691497034,
						false
						,[
						[
							11,
							"CountDress"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						57,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5069021948607017,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						57,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7609001547392432,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						57,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						9016431460948661,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3742648859827216,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						2435276411218209,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						282365197939138,
						false
						,[
						[
							11,
							"CountSunglass"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						59,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1741753023729291,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						59,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2203109353693471,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						59,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						1188693496464973,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9949100481359809,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						3152302575973478,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8241164207271754,
						false
						,[
						[
							11,
							"CountPhone"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						60,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8055464965637839,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						60,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2903927322011934,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						60,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						4196264212813419,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9415351630962854,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						6460418397294572,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5827116836772997,
						false
						,[
						[
							11,
							"CountLingerie"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						61,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3227441542451566,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						61,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3625177056330386,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						61,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						33383636849088,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8621842232012407,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						2551448840583572,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						43023489142648,
						false
						,[
						[
							11,
							"CountRunwayShows"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						62,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3493585094150996,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						62,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7992335695607147,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						62,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						9339274217408029,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7046520542629295,
					[
					[
						52,
						cr.plugins_.Sprite.prototype.cnds.IsVisible,
						null,
						0,
						false,
						false,
						false,
						8631690543249812,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8073515475267778,
						false
						,[
						[
							11,
							"CountAgencies"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						63,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7482097298423558,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						63,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4171618974040079,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						63,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						1836534659118499,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					[true, "Achievement Details Text"],
					false,
					null,
					615357665657117,
					[
					[
						-1,
						cr.system_object.prototype.cnds.IsGroupActive,
						null,
						0,
						false,
						false,
						false,
						615357665657117,
						false
						,[
						[
							1,
							[
								2,
								"Achievement Details Text"
							]
						]
						]
					]
					],
					[
					]
					,[
					[
						0,
						null,
						false,
						null,
						4126772329062167,
						[
						[
							-1,
							cr.system_object.prototype.cnds.CompareVar,
							null,
							0,
							false,
							false,
							false,
							6167518649463559,
							false
							,[
							[
								11,
								"AchievementsVisible"
							]
,							[
								8,
								0
							]
,							[
								7,
								[
									0,
									0
								]
							]
							]
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							3791536667395828,
							false
							,[
							[
								7,
								[
									2,
									"PRESS AN ACHIEVEMENT TO  VIEW DETAILS"
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7802152984639553,
						[
						[
							53,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							7590510275641587,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							4999338528905817,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Purse lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7694950887868764,
						[
						[
							54,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							5844303533031629,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							8884488280819987,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Shoe lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						2902163880018826,
						[
						[
							55,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							1852879083874928,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							3678289334357478,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Makeup lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						8209320089977367,
						[
						[
							56,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							2292294476098324,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							1593333626306911,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Purfume lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7026879352898496,
						[
						[
							57,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							3545182311132421,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							8902960468484286,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Dress lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						569884284683314,
						[
						[
							59,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							8091680838599634,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							3137247224588848,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Sunglass lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5676877579703281,
						[
						[
							60,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							2828626691121754,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							4214891313767674,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Phone lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						1581722440798028,
						[
						[
							61,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							2761847213162731,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							4376821497716853,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Linegerie lines to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						7732844166649443,
						[
						[
							62,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							8601978593963819,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							8488600052785807,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Runway Shows to get this achievement."
								]
							]
							]
						]
						]
					]
,					[
						0,
						null,
						false,
						null,
						5026950000519624,
						[
						[
							63,
							cr.behaviors.SpriteButton.prototype.cnds.OnClick,
							"SpriteButton",
							1,
							false,
							false,
							false,
							7592486417900258,
							false
						]
						],
						[
						[
							64,
							cr.plugins_.Spritefont2.prototype.acts.SetText,
							null,
							720623819995908,
							false
							,[
							[
								7,
								[
									2,
									"Get 10 Modeling Agencies to get this achievement."
								]
							]
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "GooglePLay Achievements"],
			false,
			null,
			4751006768989521,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4751006768989521,
				false
				,[
				[
					1,
					[
						2,
						"GooglePLay Achievements"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Acheivement Submit"],
				false,
				null,
				6512845862426575,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					6512845862426575,
					false
					,[
					[
						1,
						[
							2,
							"Acheivement Submit"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					3259090482031345,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7539062746906216,
						false
						,[
						[
							11,
							"CountPurse"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4907017068641066,
						false
						,[
						[
							11,
							"AchievementPurseCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3820733728114887,
						false
						,[
						[
							11,
							"AchievementPurseCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9031349438189159,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5337977691313095,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2812160003082049,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1251777289589953,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1733756203253798,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						66,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3134512866056899,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						66,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						1481220122517969,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						66,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						7523780862451212,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						66,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						6057391843798053,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						66,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						922506234688519,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4415833929080002,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2353553093858209,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5310702269746947,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						66,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						4427710149897046,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						66,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						6210023327857465,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1549642894668529,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8144983281445241,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9500309610561537,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2732688336942794,
						false
						,[
						[
							11,
							"CountShoes"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9804710343168865,
						false
						,[
						[
							11,
							"AchievementShoesCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2654776634048894,
						false
						,[
						[
							11,
							"AchievementShoesCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9700385137689132,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1429607284869845,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9920726886403799,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4848671807499396,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6189467219727799,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						70,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8942611839973398,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						70,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						5441580299497327,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						70,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						653463876802375,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						70,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						9867239261859392,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						70,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						9916080312696027,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6024750312911599,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1885474478461546,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6311023226559106,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						70,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						7798497044595225,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						70,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						2219629973455837,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						745533182444773,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1744328057644267,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3760389057719453,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						345652237631141,
						false
						,[
						[
							11,
							"CountMakeup"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7024412703731313,
						false
						,[
						[
							11,
							"AchievementMakeupCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						217760546489903,
						false
						,[
						[
							11,
							"AchievementMakeupCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2867383602624424,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						611171823850403,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2761529659847351,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2413429233817941,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						370533324450611,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						71,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1330536445434224,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						71,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						5094759469912576,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						71,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						9841743786736198,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						71,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						272838878177677,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						71,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						5236937461955798,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1907932077260979,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2142240480555907,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4169432556698377,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						71,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						8337289014206644,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						71,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						804298744634798,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8120663263532003,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7065837098310524,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7252792961058457,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2073558368937914,
						false
						,[
						[
							11,
							"CountPerfume"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2332674666202836,
						false
						,[
						[
							11,
							"AchievementPerfumeCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8678023926956976,
						false
						,[
						[
							11,
							"AchievementPerfumeCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						5799656673263832,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9321487673726901,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3417112104806331,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6812387906795581,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4986578942361959,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8386515474563926,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						1360553024875623,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						7304524708950783,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						1640695215100941,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						72,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						6388007250983255,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9832014861601074,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						577026498201643,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1450791236383968,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						72,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						2524647930717101,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						72,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						7739030840290857,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7794828845160523,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						398175628658406,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3324725992763975,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6359528258793576,
						false
						,[
						[
							11,
							"CountDress"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6066574673533189,
						false
						,[
						[
							11,
							"AchievementDressCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7343588857837359,
						false
						,[
						[
							11,
							"AchievementDressCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2407513612244325,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3781747234932354,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7498177880186089,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4466983628557647,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7923749572303347,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						782206934823832,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						2003504029270263,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						4746183061334258,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						2520966521198716,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						73,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						509082431388406,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7812930413107854,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5839603731481326,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6707026078703929,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						73,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						4813481815071769,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						73,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						806772877909254,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						372484737432917,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						122775102521424,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9747449700832139,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4864491480296494,
						false
						,[
						[
							11,
							"CountSunglass"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7662406500109403,
						false
						,[
						[
							11,
							"AchievementSunglassCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2932102675340079,
						false
						,[
						[
							11,
							"AchievementSunglassCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						6626910730589014,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5702597083348812,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7950865283191984,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9427081382890212,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9750970301470885,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						606862175174895,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						6906614951298953,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						394503756873187,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8560519493782385,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						74,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						1285161791601371,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						7648863505992816,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7298646556165703,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2881091120941746,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						74,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						2465038345541372,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						74,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						5273292672219564,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3899301497147951,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8763981955539939,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8534582610269621,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4908928203327293,
						false
						,[
						[
							11,
							"CountPhone"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8903184018385347,
						false
						,[
						[
							11,
							"AchievementPhoneCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6640095792257991,
						false
						,[
						[
							11,
							"AchievementPhoneCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						8466214322068754,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8856289813456429,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2891996573687825,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9262751347431273,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1379258973378792,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						75,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3068160083330564,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						75,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						9932756722000952,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						75,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						1933554834265294,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						75,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						8229735693315333,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						75,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						1424091439527087,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						1508802609485152,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4865914635751731,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8050965415955985,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						75,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						2501512280838904,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						75,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						1898196004989561,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8940981195481555,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9976684033603381,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8910674521038267,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6064127313541229,
						false
						,[
						[
							11,
							"CountLingerie"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1280796107984202,
						false
						,[
						[
							11,
							"AchievementLingerieCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9434976370614807,
						false
						,[
						[
							11,
							"AchievementLingerieCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2820447787649878,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4255128206183488,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4235937435130291,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6867015637728572,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4363476716385216,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5361930613332231,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						3559386814807837,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						7175072000259673,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						458138513749008,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						76,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						9439748056689957,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						4044856908400484,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1194250005343707,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5518789483703566,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						76,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						2936195763795107,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						76,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						6474166193179633,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7868888362440409,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						166218282479993,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8941772366341713,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4734098225789969,
						false
						,[
						[
							11,
							"CountRunwayShows"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5749506320890958,
						false
						,[
						[
							11,
							"AchievementRunwayShowsCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						134368696250444,
						false
						,[
						[
							11,
							"AchievementRunwayShowsCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						9352235322952372,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9282947485688157,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4521327034898345,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4638331649261337,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7569466033129389,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						77,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1237439204629731,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						77,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						2288539047401094,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						1150755241123587,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						2864920901116136,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						77,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						7120554900224586,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						3715554702780007,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2484102683538033,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1209953983611177,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						77,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						3047480389614099,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						77,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						1232343066836311,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4759041796634353,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						5802493709909002,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7404320525399674,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6723786396748673,
						false
						,[
						[
							11,
							"CountAgencies"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5362223834612108,
						false
						,[
						[
							11,
							"AchievementAgenciesCompleted"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4632251152560592,
						false
						,[
						[
							11,
							"AchievementAgenciesCompleted"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						2538548721722668,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5766664646281907,
						false
						,[
						[
							0,
							[
								0,
								478
							]
						]
,						[
							0,
							[
								0,
								175
							]
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5958904278762661,
						false
						,[
						[
							0,
							[
								0,
								482
							]
						]
,						[
							0,
							[
								0,
								523
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3966167478362244,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1756821176658953,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						269553247923788,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetHeight,
						null,
						8718043474194378,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetWidth,
						null,
						3312010231170581,
						false
						,[
						[
							0,
							[
								0,
								256
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetX,
						null,
						616794039095428,
						false
						,[
						[
							0,
							[
								0,
								500
							]
						]
						]
					]
,					[
						78,
						cr.plugins_.Sprite.prototype.acts.SetY,
						null,
						3155408514584724,
						false
						,[
						[
							0,
							[
								0,
								350
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						3565822102161234,
						false
						,[
						[
							0,
							[
								1,
								2
							]
						]
						]
					]
,					[
						67,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6823671200140557,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						68,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1925392180907922,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						78,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
						"MoveTo",
						1408395292736883,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						78,
						cr.behaviors.Rex_MoveTo.prototype.acts.SetTargetPos,
						"MoveTo",
						3575604851333566,
						false
						,[
						[
							0,
							[
								4,
								[
									20,
									46,
									cr.plugins_.Sprite.prototype.exps.X,
									false,
									null
								]
								,[
									0,
									6
								]
							]
						]
,						[
							0,
							[
								20,
								46,
								cr.plugins_.Sprite.prototype.exps.Y,
								false,
								null
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						669892970180223,
						false
						,[
						[
							11,
							"AchievementLight"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.Wait,
						null,
						3332853861033348,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Achievement Effects"],
			false,
			null,
			4562416607412671,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4562416607412671,
				false
				,[
				[
					1,
					[
						2,
						"Achievement Effects"
					]
				]
				]
			]
			],
			[
			]
		]
,		[
			0,
			null,
			false,
			null,
			2858251228624233,
			[
			[
				66,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				5116654398037828,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				4988461426577926,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				989864717334813,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				66,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				3114651922671266,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							66,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				66,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				6276548004327268,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							66,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				3373074857455156,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				66,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				1773017724246129,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4393083989400558,
			[
			[
				66,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				2130541077817794,
				false
			]
			],
			[
			[
				66,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				9270756680484389,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				66,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				9551587737715366,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1967325264444988,
			[
			[
				70,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				9198544776439201,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				5866931503048365,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				1229832222721284,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				8730008174446391,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				9880187538161701,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							70,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				6087016501766104,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				6979003133124181,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7836084062338045,
			[
			[
				70,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				5090041744161774,
				false
			]
			],
			[
			[
				70,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				4126352780758083,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				70,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				3008970183778753,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6343998639707407,
			[
			[
				71,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4957188198413625,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				3877064822208255,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				3991731072487672,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				879029810058807,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							71,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				9516910687658162,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							71,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				2554093105577951,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				7597935654458018,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6521476728076004,
			[
			[
				71,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				674993889187722,
				false
			]
			],
			[
			[
				71,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				2307283537392376,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				71,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				6319580297496712,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			4396633535571257,
			[
			[
				72,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4052766105255623,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				6917866414887786,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				4510885260033061,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				6117214217839442,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							72,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				5378615964990418,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							72,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				5030652245685627,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				8922074510756024,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7488346398374391,
			[
			[
				72,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				1465296183429134,
				false
			]
			],
			[
			[
				72,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				7036912308235814,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				72,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				5752453055454738,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5087144463158084,
			[
			[
				73,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4722128890371993,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				6261977242064368,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				9601377692847966,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				5538380349255531,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							73,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				2267635321901858,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							73,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				7081895115580031,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				3135131424208439,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2642854134191803,
			[
			[
				73,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				4031390563029656,
				false
			]
			],
			[
			[
				73,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				6303848444952374,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				73,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				7388376168707338,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8641360607769591,
			[
			[
				74,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				3064241381300027,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				9749239730182332,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				747568317437317,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				8480276702429681,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							74,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				6789699930881434,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							74,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				7329012651887626,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				74,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				8416925124954561,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			498308741944787,
			[
			[
				74,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				6360040779285087,
				false
			]
			],
			[
			[
				74,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5017818923072947,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				74,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				6300085584831569,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			7534309516502625,
			[
			[
				75,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				327434021961285,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				1923454188608412,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				5729850902193916,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				75,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				4444035928547632,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							75,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				75,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				9243164667603359,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							75,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				4675480488202989,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				75,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				4284815847424439,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			8872926572416734,
			[
			[
				75,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				3123057938181898,
				false
			]
			],
			[
			[
				75,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				1153034309991314,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				75,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				3021851539098652,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5744591235352023,
			[
			[
				76,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				4790284752980574,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				3224831712200677,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				2388772945220033,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				76,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				687853373210209,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							76,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				76,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				9094745646347893,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							76,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				3803539725545299,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				76,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				721162231606781,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			1528713083071904,
			[
			[
				76,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				7515067333708943,
				false
			]
			],
			[
			[
				76,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				4720109815165178,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				76,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				8348517263421012,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			5160033310499868,
			[
			[
				77,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				5298031511468461,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				6670755913192668,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				2859142126816173,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				77,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				9407363840130858,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							77,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				77,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				5443750272313379,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							77,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				1229660760431991,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				77,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				1897007920300707,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9091538312840162,
			[
			[
				77,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				3386580596808202,
				false
			]
			],
			[
			[
				77,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				7744969594409361,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				77,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				8145388668427358,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			9232103635686635,
			[
			[
				78,
				cr.plugins_.Sprite.prototype.cnds.IsVisible,
				null,
				0,
				false,
				false,
				false,
				703083868320267,
				false
			]
,			[
				-1,
				cr.system_object.prototype.cnds.Every,
				null,
				0,
				false,
				false,
				false,
				8392283169978565,
				false
				,[
				[
					0,
					[
						1,
						0.015
					]
				]
				]
			]
			],
			[
			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				2500823593606297,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetHeight,
				null,
				7092804935029473,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							78,
							cr.plugins_.Sprite.prototype.exps.Height,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetWidth,
				null,
				4465330947225383,
				false
				,[
				[
					0,
					[
						5,
						[
							20,
							78,
							cr.plugins_.Sprite.prototype.exps.Width,
							false,
							null
						]
						,[
							0,
							5
						]
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				953603025469125,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				5410467838029076,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			2593387987753779,
			[
			[
				78,
				cr.behaviors.Rex_MoveTo.prototype.cnds.OnHitTarget,
				"MoveTo",
				1,
				false,
				false,
				false,
				7271381100999605,
				false
			]
			],
			[
			[
				78,
				cr.plugins_.Sprite.prototype.acts.SetVisible,
				null,
				1417789671319351,
				false
				,[
				[
					3,
					0
				]
				]
			]
,			[
				78,
				cr.behaviors.Rex_MoveTo.prototype.acts.SetEnabled,
				"MoveTo",
				2701287153105974,
				false
				,[
				[
					3,
					0
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Achievement Light"],
			false,
			null,
			8905736040108588,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				8905736040108588,
				false
				,[
				[
					1,
					[
						2,
						"Achievement Light"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				1650382118362618,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					5289579533608785,
					false
					,[
					[
						11,
						"AchievementLight"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					893296409902934,
					false
					,[
					[
						11,
						"AchievementLightGold"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					46,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9746789522108562,
					false
					,[
					[
						0,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					9385859030133112,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					680300891527367,
					false
					,[
					[
						11,
						"AchievementLightGold"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					4333099391716969,
					false
					,[
					[
						11,
						"AchievementLightWhite"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				5990438976581295,
				[
				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					6384240089545672,
					false
					,[
					[
						11,
						"AchievementLight"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.cnds.CompareVar,
					null,
					0,
					false,
					false,
					false,
					9050203792937582,
					false
					,[
					[
						11,
						"AchievementLightWhite"
					]
,					[
						8,
						0
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				],
				[
				[
					46,
					cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
					null,
					9522561002372686,
					false
					,[
					[
						0,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					7236021029952385,
					false
					,[
					[
						0,
						[
							1,
							1
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					7725239016028135,
					false
					,[
					[
						11,
						"AchievementLightWhite"
					]
,					[
						7,
						[
							0,
							0
						]
					]
					]
				]
,				[
					-1,
					cr.system_object.prototype.acts.SetVar,
					null,
					6470759110805291,
					false
					,[
					[
						11,
						"AchievementLightGold"
					]
,					[
						7,
						[
							0,
							1
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Testing"],
				false,
				null,
				8598885473790278,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					8598885473790278,
					false
					,[
					[
						1,
						[
							2,
							"Testing"
						]
					]
					]
				]
				],
				[
				]
			]
			]
		]
,		[
			0,
			[true, "PowerCoin Events"],
			false,
			null,
			6948519467378827,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				6948519467378827,
				false
				,[
				[
					1,
					[
						2,
						"PowerCoin Events"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Progress Bar"],
				false,
				null,
				2483432962312577,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2483432962312577,
					false
					,[
					[
						1,
						[
							2,
							"Progress Bar"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6087457289813827,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						3301496929838361,
						false
						,[
						[
							0,
							[
								1,
								1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4282547214755127,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.floor
								,[
[
									6,
									[
										7,
										[
											5,
											[
												23,
												"TotalFame"
											]
											,[
												23,
												"FameBarBalance"
											]
										]
										,[
											23,
											"FameBarNeeded"
										]
									]
									,[
										0,
										100
									]
								]
								]
							]
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						4186057821495583,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									19,
									cr.system_object.prototype.exps.round
									,[
[
										5,
										[
											23,
											"TotalFame"
										]
										,[
											23,
											"FameBarBalance"
										]
									]
									]
								]
							]
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8964793916884803,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									23,
									"FameBarNeeded"
								]
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3117797070082533,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9000131472706589,
						false
						,[
						[
							11,
							"TotalFame"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								4,
								[
									23,
									"FameBarNeeded"
								]
								,[
									23,
									"FameBarBalance"
								]
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6071401831219224,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6203033443980022,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									4,
									[
										23,
										"PowerCoins"
									]
									,[
										23,
										"PowerCoinsPurchased"
									]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						240568101235613,
						false
						,[
						[
							11,
							"FameBarBalance"
						]
,						[
							7,
							[
								23,
								"FameBarNeeded"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8157386052898092,
						false
						,[
						[
							11,
							"FameBarNeeded"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.round
								,[
[
									6,
									[
										23,
										"FameBarNeeded"
									]
									,[
										1,
										0.3
									]
								]
								]
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Progress Bar Percent"],
				false,
				null,
				7061972750596516,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					7061972750596516,
					false
					,[
					[
						1,
						[
							2,
							"Progress Bar Percent"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8718282095733102,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						693791270125256,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9243171831441363,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3147428359446724,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7138643539504852,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								2
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8961305860063154,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								3
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						678306505647965,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9401109234028024,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7201826985842046,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								4
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6622177654015718,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7414498652499306,
						false
						,[
						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4732309887607505,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2283705252035978,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5979289597398053,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								7
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7079912949004923,
						false
						,[
						[
							0,
							[
								0,
								3
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4585151122426192,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1964577699720177,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								8
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1480393926340196,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								9
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5208314534929529,
						false
						,[
						[
							0,
							[
								0,
								4
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					625621475906852,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6053409008283239,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2217541290698419,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								11
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5780682701898676,
						false
						,[
						[
							0,
							[
								0,
								5
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2725082151160567,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7884266536268915,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								12
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3308147705486793,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								13
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6308345483884969,
						false
						,[
						[
							0,
							[
								0,
								6
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4259127476346621,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7324545717712509,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								14
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2573351010615384,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								15
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8735503042940456,
						false
						,[
						[
							0,
							[
								0,
								7
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3478336097484508,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5964049074036764,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5473082927060494,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								17
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6871622744058942,
						false
						,[
						[
							0,
							[
								0,
								8
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1003973216500302,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6569328052161015,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								18
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3598664562178623,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								19
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5590627711927509,
						false
						,[
						[
							0,
							[
								0,
								9
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9883108287144164,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3462287902082685,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5930257024473817,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								21
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6190619706909894,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2673540663711191,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2036933603192428,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								22
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1649568789461602,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								23
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2844566758401201,
						false
						,[
						[
							0,
							[
								0,
								11
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8467844592314821,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2967484834369959,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								24
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2623258179744408,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								25
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4390677895481507,
						false
						,[
						[
							0,
							[
								0,
								12
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8499788904821659,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2464943979379016,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								26
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						870876739671386,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								27
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3134327685789652,
						false
						,[
						[
							0,
							[
								0,
								13
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1399807885842529,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5935714233074336,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								28
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4118335838242898,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								29
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8305032197862282,
						false
						,[
						[
							0,
							[
								0,
								14
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6024176085075684,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8255392291787938,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								30
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7536573777658383,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								31
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3272966050331576,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5938199495323666,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4000759632011645,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								32
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1786959278156367,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								33
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2607781672890685,
						false
						,[
						[
							0,
							[
								0,
								16
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1394956353032874,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						17623567834447,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								34
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						752331198322569,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								35
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						35977458145155,
						false
						,[
						[
							0,
							[
								0,
								17
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8627772058876684,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2602614714182568,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								36
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9909653396285847,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								37
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6312187234937197,
						false
						,[
						[
							0,
							[
								0,
								18
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2051367686424023,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8713867638568594,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								38
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						840102686186935,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								39
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8506596962802811,
						false
						,[
						[
							0,
							[
								0,
								19
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8951551011155773,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8147753878629755,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								40
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8601341785658078,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								41
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						192701641806959,
						false
						,[
						[
							0,
							[
								0,
								20
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6477706251241747,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7754784848444859,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								42
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7998673548259318,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								43
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5291023356620313,
						false
						,[
						[
							0,
							[
								0,
								21
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2026203991434701,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5763625683133444,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								44
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7395381005326232,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								45
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6052677785191162,
						false
						,[
						[
							0,
							[
								0,
								22
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4996740540232109,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6965107504896229,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								46
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5813675918342567,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								47
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8700554724374558,
						false
						,[
						[
							0,
							[
								0,
								23
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9294112442049824,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3045092559937848,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								48
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						208966007682708,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								49
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9907565457978277,
						false
						,[
						[
							0,
							[
								0,
								24
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6687937646278166,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5045343913452054,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								50
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6824672550564769,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								51
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3123660955082087,
						false
						,[
						[
							0,
							[
								0,
								25
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8047487608263591,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4141922034287354,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								52
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2267627991847693,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								53
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9947378622175298,
						false
						,[
						[
							0,
							[
								0,
								26
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					520364798578407,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						61148583933699,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								54
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4163570576222306,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								55
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7537687664779167,
						false
						,[
						[
							0,
							[
								0,
								27
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					436567005997966,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8239384154661191,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								56
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6382233250535634,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								57
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5586050166121214,
						false
						,[
						[
							0,
							[
								0,
								28
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8316732354720633,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4216658427402719,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								58
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8902130447326539,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								59
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7237392948200578,
						false
						,[
						[
							0,
							[
								0,
								29
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2244480296607586,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8543596003046187,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								60
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5060651541717186,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								61
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3873493976853945,
						false
						,[
						[
							0,
							[
								0,
								30
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8789436565099449,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6192463118988081,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								62
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7680930189254598,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								63
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7836057045029952,
						false
						,[
						[
							0,
							[
								0,
								31
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					215710821112232,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9328630231076651,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								64
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3103193821491284,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								65
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						916060023382946,
						false
						,[
						[
							0,
							[
								0,
								32
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7781473492875724,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2839483968315607,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								66
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7005744630447404,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								67
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						660422864620464,
						false
						,[
						[
							0,
							[
								0,
								33
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5441541281869887,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6152971032849722,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								68
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						132707174432126,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								69
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						392865247901084,
						false
						,[
						[
							0,
							[
								0,
								34
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2048351440560453,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6028909878490271,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								70
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6304065808835794,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								71
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1160059909484831,
						false
						,[
						[
							0,
							[
								0,
								35
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8969621375543491,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						559632973139132,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								72
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1175139662171848,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								73
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6682802891338346,
						false
						,[
						[
							0,
							[
								0,
								36
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7913838952222535,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7034085199550393,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								74
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1953669378416374,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								75
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9757028258053164,
						false
						,[
						[
							0,
							[
								0,
								37
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9896051054053556,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6313215574577107,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								76
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1610010478735683,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								77
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9656544250733725,
						false
						,[
						[
							0,
							[
								0,
								38
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2556986746501292,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1907057570994166,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								78
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8338361987406709,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								79
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2000101726060413,
						false
						,[
						[
							0,
							[
								0,
								39
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8480885573113451,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8260574849728014,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								80
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						266316887397264,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								81
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9454959770209942,
						false
						,[
						[
							0,
							[
								0,
								40
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1887878898795894,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8736186175663796,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								82
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8980658772698091,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								83
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6184674554408841,
						false
						,[
						[
							0,
							[
								0,
								41
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7703974418196315,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						523759570193249,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								84
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3842376829933707,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								85
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1448251758831945,
						false
						,[
						[
							0,
							[
								0,
								42
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2034606863073368,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3837196417002788,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								86
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4238243905095254,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								87
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6793543571139123,
						false
						,[
						[
							0,
							[
								0,
								43
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6074935446291168,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3330725778274165,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								88
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2363164308850238,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								89
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1632797422973244,
						false
						,[
						[
							0,
							[
								0,
								44
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4208313803693548,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						737808799799014,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								90
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5295470747382528,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								91
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5160640624486094,
						false
						,[
						[
							0,
							[
								0,
								45
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7719087138914728,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5977917200144161,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								92
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2744598989518102,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								93
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5331106960163156,
						false
						,[
						[
							0,
							[
								0,
								46
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5075827779470503,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8380085861149651,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								94
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8398532176309747,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								95
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						362005254645125,
						false
						,[
						[
							0,
							[
								0,
								47
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2338532619085225,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6957394015029595,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								96
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9050892730349366,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								97
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2991016886429987,
						false
						,[
						[
							0,
							[
								0,
								48
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7846347609241104,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7934415611479407,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								97
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1195945473814163,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								97
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5876129188891737,
						false
						,[
						[
							0,
							[
								0,
								49
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2568608024797708,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						338837463404215,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								98
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5558754126393489,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								98
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1893419258822824,
						false
						,[
						[
							0,
							[
								0,
								50
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4035693212877866,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2077205057054757,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								99
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						449469039324802,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								99
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4684823905949626,
						false
						,[
						[
							0,
							[
								0,
								51
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8703611354014511,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2165741382633267,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
					],
					[
					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						1906457597191356,
						false
						,[
						[
							0,
							[
								0,
								52
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Mini Bar Percent"],
				false,
				null,
				1349630668281336,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					1349630668281336,
					false
					,[
					[
						1,
						[
							2,
							"Mini Bar Percent"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8718282095733102,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						693791270125256,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9243171831441363,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9401109234028024,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7201826985842046,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6622177654015718,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								5
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7414498652499306,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4732309887607505,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2283705252035978,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5979289597398053,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								10
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						7079912949004923,
						false
						,[
						[
							0,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					625621475906852,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6053409008283239,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								11
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2217541290698419,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								15
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5780682701898676,
						false
						,[
						[
							0,
							[
								0,
								2
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4259127476346621,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7324545717712509,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								16
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2573351010615384,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								20
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8735503042940456,
						false
						,[
						[
							0,
							[
								0,
								3
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					3478336097484508,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5964049074036764,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								21
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5473082927060494,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								25
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6871622744058942,
						false
						,[
						[
							0,
							[
								0,
								4
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1003973216500302,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6569328052161015,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								26
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3598664562178623,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								30
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5590627711927509,
						false
						,[
						[
							0,
							[
								0,
								5
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9883108287144164,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3462287902082685,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								31
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5930257024473817,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								35
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6190619706909894,
						false
						,[
						[
							0,
							[
								0,
								6
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2673540663711191,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2036933603192428,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								36
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1649568789461602,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								40
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2844566758401201,
						false
						,[
						[
							0,
							[
								0,
								7
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8467844592314821,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2967484834369959,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								41
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2623258179744408,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								45
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						4390677895481507,
						false
						,[
						[
							0,
							[
								0,
								8
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8499788904821659,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2464943979379016,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								46
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						870876739671386,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								50
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3134327685789652,
						false
						,[
						[
							0,
							[
								0,
								9
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1399807885842529,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5935714233074336,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								51
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4118335838242898,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								55
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8305032197862282,
						false
						,[
						[
							0,
							[
								0,
								10
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6024176085075684,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8255392291787938,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								56
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7536573777658383,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								60
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						3272966050331576,
						false
						,[
						[
							0,
							[
								0,
								11
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5938199495323666,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4000759632011645,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								61
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1786959278156367,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								65
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						2607781672890685,
						false
						,[
						[
							0,
							[
								0,
								12
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1394956353032874,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						17623567834447,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								66
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						752331198322569,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								70
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						35977458145155,
						false
						,[
						[
							0,
							[
								0,
								13
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8627772058876684,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2602614714182568,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								71
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9909653396285847,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								75
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6312187234937197,
						false
						,[
						[
							0,
							[
								0,
								14
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2051367686424023,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8713867638568594,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								76
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						840102686186935,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								80
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8506596962802811,
						false
						,[
						[
							0,
							[
								0,
								15
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8951551011155773,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8147753878629755,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								81
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8601341785658078,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								85
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						192701641806959,
						false
						,[
						[
							0,
							[
								0,
								16
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6477706251241747,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7754784848444859,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								86
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7998673548259318,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								90
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						5291023356620313,
						false
						,[
						[
							0,
							[
								0,
								17
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					2026203991434701,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5763625683133444,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								91
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7395381005326232,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								95
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						6052677785191162,
						false
						,[
						[
							0,
							[
								0,
								18
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4996740540232109,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6965107504896229,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								96
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5813675918342567,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							3
						]
,						[
							7,
							[
								0,
								99
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						8700554724374558,
						false
						,[
						[
							0,
							[
								0,
								19
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9294112442049824,
					[
					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3045092559937848,
						false
						,[
						[
							11,
							"FameBarPercent"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								0,
								100
							]
						]
						]
					]
					],
					[
					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimFrame,
						null,
						9907565457978277,
						false
						,[
						[
							0,
							[
								0,
								20
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Launch PowerCoin Screen"],
				false,
				null,
				6971000415590959,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					6971000415590959,
					false
					,[
					[
						1,
						[
							2,
							"Launch PowerCoin Screen"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					1708815542383406,
					[
					[
						-1,
						cr.system_object.prototype.cnds.OnLayoutStart,
						null,
						1,
						false,
						false,
						false,
						9658982654865547,
						false
					]
					],
					[
					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						80576640465897,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						8038012845565668,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						2930218808966606,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						7318715824453641,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						7234546044156881,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						6847587895254476,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						106,
						cr.plugins_.Sprite.prototype.acts.SetAnimSpeed,
						null,
						4329230857962053,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					8017944594991227,
					[
					[
						86,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						9208276106469592,
						false
					]
					],
					[
					[
						81,
						cr.plugins_.c2canvas.prototype.acts.SetPos,
						null,
						88606620856797,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.c2canvas.prototype.acts.SetVisible,
						null,
						858076296703877,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8473406294521117,
						false
						,[
						[
							0,
							[
								0,
								245
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4041606169129919,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9473774758180486,
						false
						,[
						[
							0,
							[
								1,
								479.325
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8574850117168958,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7760911530801141,
						false
						,[
						[
							0,
							[
								1,
								714.925
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2536277639624437,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1995087114216747,
						false
						,[
						[
							0,
							[
								0,
								245
							]
						]
,						[
							0,
							[
								0,
								352
							]
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6094446975136696,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9635969348721254,
						false
						,[
						[
							0,
							[
								0,
								474
							]
						]
,						[
							0,
							[
								0,
								352
							]
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1233043894595052,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3948762801772459,
						false
						,[
						[
							0,
							[
								0,
								479
							]
						]
,						[
							0,
							[
								0,
								484
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3041074021295399,
						false
						,[
						[
							0,
							[
								0,
								481
							]
						]
,						[
							0,
							[
								0,
								443
							]
						]
						]
					]
,					[
						95,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5417765072290866,
						false
						,[
						[
							0,
							[
								0,
								117
							]
						]
,						[
							0,
							[
								0,
								546
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1965262970002382,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6021882070527141,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						95,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6450580912596989,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						1313082246461669,
						false
						,[
						[
							0,
							[
								0,
								48
							]
						]
,						[
							0,
							[
								0,
								440
							]
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						4656854067451629,
						false
						,[
						[
							0,
							[
								0,
								492
							]
						]
,						[
							0,
							[
								0,
								440
							]
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						8449828276159927,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						4591323031516505,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						96,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						441497680493367,
						false
						,[
						[
							0,
							[
								0,
								156
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						96,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7203307417322488,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						98,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9931686628230414,
						false
						,[
						[
							0,
							[
								0,
								390
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						98,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5104688181310655,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7054096448352866,
						false
						,[
						[
							0,
							[
								0,
								626
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6640414427513356,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1272533059846253,
						false
						,[
						[
							0,
							[
								0,
								156
							]
						]
,						[
							0,
							[
								0,
								306
							]
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6797273185815584,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						101,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						622670274583749,
						false
						,[
						[
							0,
							[
								0,
								390
							]
						]
,						[
							0,
							[
								0,
								306
							]
						]
						]
					]
,					[
						101,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4717020385574738,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						2502087453685839,
						false
						,[
						[
							0,
							[
								0,
								167
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						9689693165327292,
						false
						,[
						[
							0,
							[
								0,
								401
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						6765862666131032,
						false
						,[
						[
							0,
							[
								0,
								637
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						8737097171612901,
						false
						,[
						[
							0,
							[
								0,
								167
							]
						]
,						[
							0,
							[
								0,
								297
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						9017951223800496,
						false
						,[
						[
							0,
							[
								0,
								401
							]
						]
,						[
							0,
							[
								0,
								297
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						7688707916815314,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						3893274787000941,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						1884523046385395,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						6313783182179375,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						1921498505044872,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5072137094047635,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3585680550323872,
						false
						,[
						[
							0,
							[
								0,
								480
							]
						]
,						[
							0,
							[
								0,
								95
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1258394639172775,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						975401344609375,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8497342020853119,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						3,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						25389664701714,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						338658443238499,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2814888870910695,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						6,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						315063181181099,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1606281330757385,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						905546891255872,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						9,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2961882856902536,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6566754021755129,
						false
						,[
						[
							11,
							"FullAdCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6581951016143009,
					[
					[
						106,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						8955611325197343,
						false
					]
					],
					[
					[
						81,
						cr.plugins_.c2canvas.prototype.acts.SetPos,
						null,
						1776968953131316,
						false
						,[
						[
							0,
							[
								0,
								0
							]
						]
,						[
							0,
							[
								0,
								0
							]
						]
						]
					]
,					[
						81,
						cr.plugins_.c2canvas.prototype.acts.SetVisible,
						null,
						5419055680852498,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8859318174960976,
						false
						,[
						[
							0,
							[
								0,
								245
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						784193930990231,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5218524386397563,
						false
						,[
						[
							0,
							[
								1,
								479.325
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						5532491948605766,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1241974437408008,
						false
						,[
						[
							0,
							[
								1,
								714.925
							]
						]
,						[
							0,
							[
								0,
								204
							]
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2152926544840591,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3954723506769999,
						false
						,[
						[
							0,
							[
								0,
								245
							]
						]
,						[
							0,
							[
								0,
								352
							]
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8628810774200317,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4057049235950464,
						false
						,[
						[
							0,
							[
								0,
								474
							]
						]
,						[
							0,
							[
								0,
								352
							]
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3847236337189232,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						3490359515345772,
						false
						,[
						[
							0,
							[
								0,
								479
							]
						]
,						[
							0,
							[
								0,
								484
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8501201058857362,
						false
						,[
						[
							0,
							[
								0,
								481
							]
						]
,						[
							0,
							[
								0,
								443
							]
						]
						]
					]
,					[
						95,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6932350324204262,
						false
						,[
						[
							0,
							[
								0,
								117
							]
						]
,						[
							0,
							[
								0,
								546
							]
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						320390140464368,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						3156332036612671,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						95,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2640701154324771,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						604976317097161,
						false
						,[
						[
							0,
							[
								0,
								48
							]
						]
,						[
							0,
							[
								0,
								440
							]
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						6830607507445334,
						false
						,[
						[
							0,
							[
								0,
								492
							]
						]
,						[
							0,
							[
								0,
								440
							]
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						9183281830262562,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						6522269893658392,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						96,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2128481394609562,
						false
						,[
						[
							0,
							[
								0,
								156
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						96,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4306241667275124,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						98,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						668596796589569,
						false
						,[
						[
							0,
							[
								0,
								390
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						98,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2881171305413708,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9161004170101834,
						false
						,[
						[
							0,
							[
								0,
								626
							]
						]
,						[
							0,
							[
								0,
								158
							]
						]
						]
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7843241856716516,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						9697876957857326,
						false
						,[
						[
							0,
							[
								0,
								156
							]
						]
,						[
							0,
							[
								0,
								306
							]
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2160906405598574,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						101,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8782099365314843,
						false
						,[
						[
							0,
							[
								0,
								390
							]
						]
,						[
							0,
							[
								0,
								306
							]
						]
						]
					]
,					[
						101,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7808499580893051,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						3046006499323812,
						false
						,[
						[
							0,
							[
								0,
								167
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						9147473687557217,
						false
						,[
						[
							0,
							[
								0,
								401
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						25420856927811,
						false
						,[
						[
							0,
							[
								0,
								637
							]
						]
,						[
							0,
							[
								0,
								149
							]
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						8406785830413172,
						false
						,[
						[
							0,
							[
								0,
								167
							]
						]
,						[
							0,
							[
								0,
								297
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetPos,
						null,
						1034300395262243,
						false
						,[
						[
							0,
							[
								0,
								401
							]
						]
,						[
							0,
							[
								0,
								297
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						917375266142409,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						4361524459460022,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						7284301780709569,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						524145013217474,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						9999318860516927,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4886029994863596,
						false
						,[
						[
							3,
							1
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5577012334857382,
						false
						,[
						[
							0,
							[
								0,
								480
							]
						]
,						[
							0,
							[
								0,
								95
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5452959313020019,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1975740341423106,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4909683892877086,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						3,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6100921105129877,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8413119177280913,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7334844634096439,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						6,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1907126770712552,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2696166601760008,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1939706256642423,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						9,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4920283922006727,
						false
						,[
						[
							0,
							[
								0,
								1089
							]
						]
,						[
							0,
							[
								0,
								695
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8460557490341824,
						false
						,[
						[
							11,
							"FullAdCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Purhcases"],
			false,
			null,
			942342531339243,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				942342531339243,
				false
				,[
				[
					1,
					[
						2,
						"Purhcases"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				[true, "Exit"],
				false,
				null,
				3065675365094349,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3065675365094349,
					false
					,[
					[
						1,
						[
							2,
							"Exit"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5483304524064908,
					[
					[
						95,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						8435933667060872,
						false
					]
					],
					[
					[
						81,
						cr.plugins_.c2canvas.prototype.acts.SetVisible,
						null,
						9420984629075281,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						9826016544875986,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						7277645738860294,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1725880387916046,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4874181781372066,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2298816027714706,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						92,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8927806323700271,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						91,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						2431047417334392,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						95,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1330537532982568,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						93,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						7794138293641722,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						94,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						2113396153694023,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						96,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						4442436254504134,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						98,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						210859029384653,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						99,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1517888909102972,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						100,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						6294063746136964,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						101,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						1758317558412475,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						5016330118035539,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						9534306277678384,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						7431705240187605,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						324731399986259,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetVisible,
						null,
						9959789182701046,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						80,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6420589845739185,
						false
						,[
						[
							0,
							[
								0,
								1090
							]
						]
,						[
							0,
							[
								0,
								73
							]
						]
						]
					]
,					[
						82,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5627127465231228,
						false
						,[
						[
							0,
							[
								0,
								1090
							]
						]
,						[
							0,
							[
								0,
								180
							]
						]
						]
					]
,					[
						83,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8688526393946907,
						false
						,[
						[
							0,
							[
								0,
								1090
							]
						]
,						[
							0,
							[
								0,
								261
							]
						]
						]
					]
,					[
						84,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2482671916756125,
						false
						,[
						[
							0,
							[
								0,
								1090
							]
						]
,						[
							0,
							[
								0,
								361
							]
						]
						]
					]
,					[
						85,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6114895764722046,
						false
						,[
						[
							0,
							[
								0,
								1090
							]
						]
,						[
							0,
							[
								0,
								449
							]
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetVisible,
						null,
						8241639657383294,
						false
						,[
						[
							3,
							0
						]
						]
					]
,					[
						108,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4360167134446319,
						false
						,[
						[
							0,
							[
								0,
								1379
							]
						]
,						[
							0,
							[
								0,
								-20
							]
						]
						]
					]
,					[
						0,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						8824335217703804,
						false
						,[
						[
							0,
							[
								0,
								155
							]
						]
,						[
							0,
							[
								0,
								145
							]
						]
						]
					]
,					[
						1,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1339677382373646,
						false
						,[
						[
							0,
							[
								0,
								155
							]
						]
,						[
							0,
							[
								0,
								205
							]
						]
						]
					]
,					[
						2,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5823672220923463,
						false
						,[
						[
							0,
							[
								0,
								155
							]
						]
,						[
							0,
							[
								0,
								265
							]
						]
						]
					]
,					[
						3,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1588650339423617,
						false
						,[
						[
							0,
							[
								0,
								155
							]
						]
,						[
							0,
							[
								0,
								325
							]
						]
						]
					]
,					[
						4,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						1083860709495565,
						false
						,[
						[
							0,
							[
								0,
								155
							]
						]
,						[
							0,
							[
								0,
								385
							]
						]
						]
					]
,					[
						5,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						4435797509552517,
						false
						,[
						[
							0,
							[
								0,
								820
							]
						]
,						[
							0,
							[
								0,
								145
							]
						]
						]
					]
,					[
						6,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						5331386223506516,
						false
						,[
						[
							0,
							[
								0,
								820
							]
						]
,						[
							0,
							[
								0,
								205
							]
						]
						]
					]
,					[
						7,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						2153526848549294,
						false
						,[
						[
							0,
							[
								0,
								820
							]
						]
,						[
							0,
							[
								0,
								265
							]
						]
						]
					]
,					[
						8,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						7440997091279675,
						false
						,[
						[
							0,
							[
								0,
								820
							]
						]
,						[
							0,
							[
								0,
								325
							]
						]
						]
					]
,					[
						9,
						cr.plugins_.Sprite.prototype.acts.SetPos,
						null,
						6365304875328458,
						false
						,[
						[
							0,
							[
								0,
								820
							]
						]
,						[
							0,
							[
								0,
								385
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						7850075583517257,
						false
						,[
						[
							11,
							"FullAdCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1939432672802444,
					[
					[
						-1,
						cr.system_object.prototype.cnds.Every,
						null,
						0,
						false,
						false,
						false,
						3906116282711845,
						false
						,[
						[
							0,
							[
								1,
								0.1
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7846023246769094,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							7,
							[
								4,
								[
									23,
									"PowerCoins"
								]
								,[
									23,
									"PowerCoinsPurchased"
								]
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6254934648033869,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Purchase FPS X7"],
				false,
				null,
				3811141465420165,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					3811141465420165,
					false
					,[
					[
						1,
						[
							2,
							"Purchase FPS X7"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6506519454523938,
					[
					[
						85,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						825972643978345,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7359906828413143,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6356528639646009,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9510591579918625,
						false
						,[
						[
							11,
							"Fame77on"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						7810066500773263,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3387708696305719,
						false
						,[
						[
							11,
							"Fame77Cost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame77Cost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2776035310925083,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3046692815165107,
						false
						,[
						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7933908319896068,
					[
					[
						85,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						5745663497630306,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4071473452348849,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						297552162088092,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5741186855991453,
						false
						,[
						[
							11,
							"Fame77on"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						2646885789441482,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						7365214037490272,
						false
						,[
						[
							11,
							"Fame77Cost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame77Cost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8233030829668738,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8809885499335072,
						false
						,[
						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2132449450017123,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					932726186611585,
					[
					[
						85,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						6278941777848948,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3046588352101385,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2568797778088698,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9435691650424048,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8024996937933104,
						false
						,[
						[
							11,
							"Fame77on"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8625023565572325,
						false
						,[
						[
							11,
							"PowerCoinsDifference"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.abs
								,[
[
									5,
									[
										23,
										"PowerCoinsPurchased"
									]
									,[
										23,
										"Fame77Cost"
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						1981526117906483,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4278138669918538,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"PowerCoinsDifference"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2023067372024742,
						false
						,[
						[
							11,
							"Fame77Cost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame77Cost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8577336162328945,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						105,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3475187069876547,
						false
						,[
						[
							7,
							[
								23,
								"Fame77Cost"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						3551677219127621,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Double Fame"],
				false,
				null,
				8113003073696102,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					8113003073696102,
					false
					,[
					[
						1,
						[
							2,
							"Double Fame"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6506519454523938,
					[
					[
						84,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						825972643978345,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4214652404805653,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2226603782888797,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9510591579918625,
						false
						,[
						[
							11,
							"Fame"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9277332762655487,
						false
						,[
						[
							11,
							"TotalFame"
						]
,						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						23,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2307463266020736,
						false
						,[
						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						8725754440261667,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						621552564973557,
						false
						,[
						[
							11,
							"DoubleFameCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"DoubleFameCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						224193548971085,
						false
						,[
						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8027156189435982,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					4435512881005116,
					[
					[
						84,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						7247937046550357,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						2541770227820885,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						762562364506912,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3850221458459236,
						false
						,[
						[
							11,
							"Fame"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						4924075057054329,
						false
						,[
						[
							11,
							"TotalFame"
						]
,						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						23,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1095101176713206,
						false
						,[
						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4804002869190062,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9465688714830525,
						false
						,[
						[
							11,
							"DoubleFameCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"DoubleFameCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						5428212779375982,
						false
						,[
						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8243451167241832,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						730892341698364,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					7478640795765,
					[
					[
						84,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						1734165509280619,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7078189951000893,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1875752832184098,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6868624086074625,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1865884323831054,
						false
						,[
						[
							11,
							"Fame"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Fame"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3984467746326814,
						false
						,[
						[
							11,
							"TotalFame"
						]
,						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						23,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8196184383144881,
						false
						,[
						[
							7,
							[
								23,
								"Fame"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						777155908387659,
						false
						,[
						[
							11,
							"PowerCoinsDifference"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.abs
								,[
[
									5,
									[
										23,
										"PowerCoinsPurchased"
									]
									,[
										23,
										"DoubleFameCost"
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						2399087596201954,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						7368153904469193,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"PowerCoinsDifference"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4771601551934391,
						false
						,[
						[
							11,
							"DoubleFameCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"DoubleFameCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						104,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						7482177241907121,
						false
						,[
						[
							7,
							[
								23,
								"DoubleFameCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						5662527138658461,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						2894452297066989,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Purchase + Fame %"],
				false,
				null,
				5687131759450799,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					5687131759450799,
					false
					,[
					[
						1,
						[
							2,
							"Purchase + Fame %"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					8721074048378205,
					[
					[
						80,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						7811743057840923,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6265746576690598,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9494921607191127,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						2114702202118647,
						false
						,[
						[
							11,
							"FamePercent"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						723925958702847,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5688909308242116,
						false
						,[
						[
							11,
							"FamePercentCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"FamePercentCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						2591523298054124,
						false
						,[
						[
							11,
							"FamePercentCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						8135607500815502,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						1250378140653276,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						7276849134467063,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						9193080203596146,
						false
						,[
						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2705291426580247,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					6228470957728428,
					[
					[
						80,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						9000198845736765,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7519224596102321,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1291720852152397,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						2760366029337445,
						false
						,[
						[
							11,
							"FamePercent"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						8158089925625196,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9683461709493465,
						false
						,[
						[
							11,
							"FamePercentCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"FamePercentCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3748638139286691,
						false
						,[
						[
							11,
							"FamePercentCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						1423685940857453,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						8277182436345052,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						6168498712759056,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3002403187981163,
						false
						,[
						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3594565300541084,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						4080820481379515,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					1036693963051235,
					[
					[
						80,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						2485816725746147,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4223663598959352,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						370753757349727,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9943768715395425,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						9645839389500447,
						false
						,[
						[
							11,
							"FamePercent"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						9257195172764503,
						false
						,[
						[
							11,
							"PowerCoinsDifference"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.abs
								,[
[
									5,
									[
										23,
										"PowerCoinsPurchased"
									]
									,[
										23,
										"FamePercentCost"
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						1324425362315232,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						7827963024574248,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"PowerCoinsDifference"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1994089053682598,
						false
						,[
						[
							11,
							"FamePercentCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"FamePercentCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						1709827143543223,
						false
						,[
						[
							11,
							"FamePercentCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						7333917437048313,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						8058406730928251,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						80,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						2521607313108149,
						false
						,[
						[
							0,
							[
								23,
								"FamePercentCount"
							]
						]
						]
					]
,					[
						97,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6495474339445278,
						false
						,[
						[
							7,
							[
								23,
								"FamePercentCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1257473477600191,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5228859867359493,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Purchase Lines Discount"],
				false,
				null,
				505799223443244,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					505799223443244,
					false
					,[
					[
						1,
						[
							2,
							"Purchase Lines Discount"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					6317582619489046,
					[
					[
						82,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						2817042872193332,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1417193890953713,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9363239281693327,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						5165588618434577,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						7462830637512319,
						false
						,[
						[
							11,
							"LinesDiscount"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						780181899238407,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						2594749009945381,
						false
						,[
						[
							11,
							"LinesDiscountCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"LinesDiscountCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						8824610670406254,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						571125744173992,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						1815842788202486,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						8834214993464593,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						279932879133735,
						false
						,[
						[
							11,
							"Upgrade1Discounted"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Upgrade1Cost"
								]
								,[
									23,
									"LinesDiscount"
								]
							]
						]
						]
					]
,					[
						34,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3399834823004131,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									19,
									cr.system_object.prototype.exps.round
									,[
[
										23,
										"Upgrade1Discounted"
									]
									]
								]
							]
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						9404672225091225,
						false
						,[
						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						5736340758150618,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					9137419696464857,
					[
					[
						82,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						8607739936715815,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1041289416747032,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3568105128708486,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						7800693324643603,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						5786505180335236,
						false
						,[
						[
							11,
							"LinesDiscount"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						3118067927983944,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						6005322588198189,
						false
						,[
						[
							11,
							"LinesDiscountCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"LinesDiscountCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						1517299290306454,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						2837135354753715,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						8485408426138866,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						778869783524701,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4624796095439289,
						false
						,[
						[
							11,
							"Upgrade1Discounted"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Upgrade1Cost"
								]
								,[
									23,
									"LinesDiscount"
								]
							]
						]
						]
					]
,					[
						34,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						9874062555444351,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									19,
									cr.system_object.prototype.exps.round
									,[
[
										23,
										"Upgrade1Discounted"
									]
									]
								]
							]
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6042697423290858,
						false
						,[
						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2683894112176268,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						346248637148455,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					87706254293614,
					[
					[
						82,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						4840674980662139,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						6971570146106535,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3715680188501597,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						3852721443550779,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8805266626613727,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								0,
								6
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						3461658403814053,
						false
						,[
						[
							11,
							"LinesDiscount"
						]
,						[
							7,
							[
								1,
								0.1
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3789170108860908,
						false
						,[
						[
							11,
							"PowerCoinsDifference"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.abs
								,[
[
									5,
									[
										23,
										"PowerCoinsPurchased"
									]
									,[
										23,
										"LinesDiscountCost"
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						2694420229624276,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						5072790441303047,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"PowerCoinsDifference"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						8751199023440847,
						false
						,[
						[
							11,
							"LinesDiscountCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"LinesDiscountCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						7144213567392159,
						false
						,[
						[
							11,
							"LinesDiscountCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						3000658727395285,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						5458108604315767,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						82,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						1790464190302856,
						false
						,[
						[
							0,
							[
								23,
								"LinesDiscountCount"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						6405033813804825,
						false
						,[
						[
							11,
							"Upgrade1Discounted"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Upgrade1Cost"
								]
								,[
									23,
									"LinesDiscount"
								]
							]
						]
						]
					]
,					[
						34,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2908557713814682,
						false
						,[
						[
							7,
							[
								10,
								[
									2,
									""
								]
								,[
									19,
									cr.system_object.prototype.exps.round
									,[
[
										23,
										"Upgrade1Discounted"
									]
									]
								]
							]
						]
						]
					]
,					[
						102,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						1309862861701977,
						false
						,[
						[
							7,
							[
								23,
								"LinesDiscountCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						6668274015553904,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						5953949882319925,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
				]
			]
,			[
				0,
				[true, "Purchase Clicks"],
				false,
				null,
				2237587665917024,
				[
				[
					-1,
					cr.system_object.prototype.cnds.IsGroupActive,
					null,
					0,
					false,
					false,
					false,
					2237587665917024,
					false
					,[
					[
						1,
						[
							2,
							"Purchase Clicks"
						]
					]
					]
				]
				],
				[
				]
				,[
				[
					0,
					null,
					false,
					null,
					5150588826802445,
					[
					[
						83,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						8028875991465803,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						9800723853842923,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							0
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4655849415028675,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						5405433869348935,
						false
						,[
						[
							11,
							"Clicks"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Clicks"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						1803501487273319,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4970429380539258,
						false
						,[
						[
							11,
							"ClicksCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"ClicksCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						6039976828832733,
						false
						,[
						[
							11,
							"ClicksCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						9219317122502038,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						7626932662206322,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						1349708247254358,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2059597130713958,
						false
						,[
						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						2654232354460445,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					881594177443351,
					[
					[
						83,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						1553454775280195,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						1000071148955466,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						98922066415438,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3530177374465201,
						false
						,[
						[
							11,
							"Clicks"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Clicks"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						4431271693028075,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						1517008054260169,
						false
						,[
						[
							11,
							"ClicksCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"ClicksCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						1543285531567238,
						false
						,[
						[
							11,
							"ClicksCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						3266063001180948,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						9135710895738187,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						6573547257489985,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						420223506679054,
						false
						,[
						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						8637570372712233,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						8234935120028934,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
,				[
					0,
					null,
					false,
					null,
					5320352081705967,
					[
					[
						83,
						cr.behaviors.SpriteButton.prototype.cnds.OnClick,
						"SpriteButton",
						1,
						false,
						false,
						false,
						1497751958228234,
						false
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8511147646560324,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							4
						]
,						[
							7,
							[
								0,
								0
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						4234361306620127,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							8,
							2
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.cnds.CompareVar,
						null,
						0,
						false,
						false,
						false,
						8519798581966575,
						false
						,[
						[
							11,
							"PowerCoinsTotal"
						]
,						[
							8,
							5
						]
,						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
					],
					[
					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3939974058213747,
						false
						,[
						[
							11,
							"Clicks"
						]
,						[
							7,
							[
								6,
								[
									23,
									"Clicks"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						3751322695439746,
						false
						,[
						[
							11,
							"PowerCoinsDifference"
						]
,						[
							7,
							[
								19,
								cr.system_object.prototype.exps.abs
								,[
[
									5,
									[
										23,
										"PowerCoinsPurchased"
									]
									,[
										23,
										"ClicksCost"
									]
								]
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						8377101844880982,
						false
						,[
						[
							11,
							"PowerCoinsPurchased"
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SubVar,
						null,
						9374454152048521,
						false
						,[
						[
							11,
							"PowerCoins"
						]
,						[
							7,
							[
								23,
								"PowerCoinsDifference"
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.SetVar,
						null,
						4350907413738097,
						false
						,[
						[
							11,
							"ClicksCost"
						]
,						[
							7,
							[
								6,
								[
									23,
									"ClicksCost"
								]
								,[
									0,
									2
								]
							]
						]
						]
					]
,					[
						-1,
						cr.system_object.prototype.acts.AddVar,
						null,
						117840727856424,
						false
						,[
						[
							11,
							"ClicksCount"
						]
,						[
							7,
							[
								0,
								1
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetClickFrame,
						"SpriteButton",
						4824352982895243,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetHoverFrame,
						"SpriteButton",
						3486128835913385,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						83,
						cr.behaviors.SpriteButton.prototype.acts.SetNormalFrame,
						"SpriteButton",
						6632151687256032,
						false
						,[
						[
							0,
							[
								23,
								"ClicksCount"
							]
						]
						]
					]
,					[
						103,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3729436067013835,
						false
						,[
						[
							7,
							[
								23,
								"ClicksCost"
							]
						]
						]
					]
,					[
						89,
						cr.plugins_.Spritefont2.prototype.acts.SetText,
						null,
						3311019219699588,
						false
						,[
						[
							7,
							[
								23,
								"PowerCoinsTotal"
							]
						]
						]
					]
,					[
						11,
						cr.plugins_.WebStorage.prototype.acts.StoreLocal,
						null,
						6793463880807116,
						false
						,[
						[
							1,
							[
								2,
								"PowerCoinsPurchased"
							]
						]
,						[
							7,
							[
								23,
								"PowerCoinsPurchased"
							]
						]
						]
					]
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Free Events"],
			false,
			null,
			2698394232915329,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				2698394232915329,
				false
				,[
				[
					1,
					[
						2,
						"Free Events"
					]
				]
				]
			]
			],
			[
			]
			,[
			[
				0,
				null,
				false,
				null,
				2348842240636621,
				[
				[
					107,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					2747122112580937,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					5701361636512354,
					false
					,[
					[
						1,
						[
							2,
							"https://play.google.com/store/apps/details?id=com.PopularLady.Premium"
						]
					]
,					[
						1,
						[
							2,
							"PopularLadyPremium"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				9704876747197462,
				[
				[
					117,
					cr.behaviors.SpriteButton.prototype.cnds.OnClick,
					"SpriteButton",
					1,
					false,
					false,
					false,
					432578643392484,
					false
				]
				],
				[
				[
					50,
					cr.plugins_.Browser.prototype.acts.GoToURLWindow,
					null,
					8898077764176952,
					false
					,[
					[
						1,
						[
							2,
							"https://play.google.com/store/apps/details?id=com.PopularLady.Premium"
						]
					]
,					[
						1,
						[
							2,
							"PopularLadyPremium"
						]
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				2828442551956112,
				[
				[
					68,
					cr.plugins_.Sprite.prototype.cnds.IsVisible,
					null,
					0,
					false,
					false,
					false,
					8981624230541972,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.HideBanner,
					null,
					6903185237180032,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					5760218204282083,
					false
					,[
					[
						0,
						[
							1,
							3
						]
					]
					]
				]
,				[
					22,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					1533553154856025,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				6454130992872368,
				[
				[
					-1,
					cr.system_object.prototype.cnds.OnLayoutStart,
					null,
					1,
					false,
					false,
					false,
					5329929904894107,
					false
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PreloadBanner,
					null,
					6801040381225163,
					false
				]
,				[
					22,
					cr.plugins_.CJSAds.prototype.acts.ShowBanner,
					null,
					5737856560562025,
					false
					,[
					[
						3,
						1
					]
					]
				]
				]
			]
,			[
				0,
				null,
				false,
				null,
				8139501285692062,
				[
				[
					-1,
					cr.system_object.prototype.cnds.Every,
					null,
					0,
					false,
					false,
					false,
					542533614919324,
					false
					,[
					[
						0,
						[
							1,
							600
						]
					]
					]
				]
				],
				[
				[
					22,
					cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,
					null,
					4735939210396225,
					false
				]
,				[
					-1,
					cr.system_object.prototype.acts.Wait,
					null,
					4487548241301266,
					false
					,[
					[
						0,
						[
							1,
							2
						]
					]
					]
				]
,				[
					22,
					cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
					null,
					6493428551651927,
					false
				]
				]
			]
			]
		]
,		[
			0,
			null,
			false,
			null,
			6069573388543149,
			[
			[
				-1,
				cr.system_object.prototype.cnds.CompareVar,
				null,
				0,
				false,
				false,
				false,
				2733230388932961,
				false
				,[
				[
					11,
					"FullAdCount"
				]
,				[
					8,
					0
				]
,				[
					7,
					[
						0,
						3
					]
				]
				]
			]
			],
			[
			[
				22,
				cr.plugins_.CJSAds.prototype.acts.PreloadFullscreen,
				null,
				1668764210371866,
				false
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				1864671992154403,
				false
				,[
				[
					0,
					[
						1,
						2
					]
				]
				]
			]
,			[
				22,
				cr.plugins_.CJSAds.prototype.acts.ShowFullscreen,
				null,
				8540987064572815,
				false
			]
,			[
				-1,
				cr.system_object.prototype.acts.Wait,
				null,
				4166226050382353,
				false
				,[
				[
					0,
					[
						1,
						1
					]
				]
				]
			]
,			[
				-1,
				cr.system_object.prototype.acts.SetVar,
				null,
				1524601733549468,
				false
				,[
				[
					11,
					"FullAdCount"
				]
,				[
					7,
					[
						0,
						0
					]
				]
				]
			]
			]
		]
,		[
			0,
			[true, "Google Play Services"],
			false,
			null,
			4293190870972781,
			[
			[
				-1,
				cr.system_object.prototype.cnds.IsGroupActive,
				null,
				0,
				false,
				false,
				false,
				4293190870972781,
				false
				,[
				[
					1,
					[
						2,
						"Google Play Services"
					]
				]
				]
			]
			],
			[
			]
		]
		]
	]
	],
	"",
	true,
	960,
	640,
	2,
	true,
	true,
	true,
	"1.0.0.1",
	true,
	false,
	0,
	2,
	123,
	false,
	true,
	1,
	[
	]
];};

createCocoonJSRuntime();

})();
